(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 11.3' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       158,          7]
NotebookDataLength[    113032,       2955]
NotebookOptionsPosition[    101142,       2739]
NotebookOutlinePosition[    101495,       2755]
CellTagsIndexPosition[    101452,       2752]
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell[BoxData[
 RowBox[{"\[IndentingNewLine]", 
  RowBox[{"(*", " ", 
   RowBox[{
    RowBox[{
     RowBox[{"L_v", " ", "integral", " ", "for", " ", "v"}], "=", "1"}], ",", 
    " ", 
    RowBox[{
     RowBox[{"k", "^", "2"}], " ", "<", " ", "1"}]}], " ", "*)"}]}]], "Input",\

 CellChangeTimes->{{3.749239796371513*^9, 
  3.74923985779443*^9}},ExpressionUUID->"89f66477-fed4-49b8-aaa3-\
b709745f05a0"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Integrate", "[", 
  RowBox[{
   RowBox[{"k2", "*", 
    RowBox[{
     RowBox[{"Sqrt", "[", 
      RowBox[{"1", "-", 
       RowBox[{"k2", "*", "w"}]}], "]"}], "/", 
     RowBox[{"Sqrt", "[", 
      RowBox[{"k2", "*", "w"}], "]"}]}], "*", 
    RowBox[{
     RowBox[{"(", 
      RowBox[{"1", "-", "w"}], ")"}], "^", 
     RowBox[{"(", 
      RowBox[{"3", "/", "2"}], ")"}]}]}], ",", 
   RowBox[{"{", 
    RowBox[{"w", ",", "0", ",", "1"}], "}"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.749231584464138*^9, 3.7492316171403008`*^9}, {
  3.7492317315655613`*^9, 3.7492317565636387`*^9}},
 CellLabel->"In[19]:=",ExpressionUUID->"8fae422d-7ee1-4bd2-bd71-5bbfa1fccc9a"],

Cell[BoxData[
 RowBox[{"ConditionalExpression", "[", 
  RowBox[{
   FractionBox[
    RowBox[{
     RowBox[{"2", " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "2"}], "+", 
        RowBox[{"k2", " ", 
         RowBox[{"(", 
          RowBox[{"7", "+", 
           RowBox[{"3", " ", "k2"}]}], ")"}]}]}], ")"}], " ", 
      RowBox[{"EllipticE", "[", "k2", "]"}]}], "+", 
     RowBox[{"4", " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "1"}], "+", "k2"}], ")"}], " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "1"}], "+", 
        RowBox[{"3", " ", "k2"}]}], ")"}], " ", 
      RowBox[{"EllipticK", "[", "k2", "]"}]}]}], 
    RowBox[{"15", " ", 
     SuperscriptBox["k2", 
      RowBox[{"3", "/", "2"}]]}]], ",", 
   RowBox[{
    RowBox[{
     RowBox[{"Im", "[", "k2", "]"}], "\[NotEqual]", "0"}], "||", 
    RowBox[{
     RowBox[{"Re", "[", "k2", "]"}], "\[LessEqual]", "1"}]}]}], 
  "]"}]], "Output",
 CellChangeTimes->{3.7492316186382847`*^9, 3.749231758380712*^9},
 CellLabel->"Out[19]=",ExpressionUUID->"a9c8e0ba-ea1f-463f-bfdb-b62274b6cde6"]
}, Open  ]],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{
   RowBox[{
    RowBox[{"L_v", " ", "integral", " ", "for", " ", "v"}], "=", "0"}], ",", 
   " ", 
   RowBox[{
    RowBox[{"k", "^", "2"}], " ", "<", " ", "1"}]}], " ", "*)"}]], "Input",
 CellChangeTimes->{{3.749239815409361*^9, 3.7492398252196608`*^9}, {
  3.7492398604422607`*^9, 
  3.74923986173033*^9}},ExpressionUUID->"c457c7a1-f0de-47fc-a95e-\
8135e308841b"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Integrate", "[", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{"k2", "/", 
      RowBox[{"Sqrt", "[", 
       RowBox[{"1", "-", 
        RowBox[{"k2", "*", "w"}]}], "]"}]}], "/", 
     RowBox[{"Sqrt", "[", 
      RowBox[{"k2", "*", "w"}], "]"}]}], "*", 
    RowBox[{
     RowBox[{"(", 
      RowBox[{"1", "-", "w"}], ")"}], "^", 
     RowBox[{"(", 
      RowBox[{"3", "/", "2"}], ")"}]}]}], ",", 
   RowBox[{"{", 
    RowBox[{"w", ",", "0", ",", "1"}], "}"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.749231876922782*^9, 3.7492318775466213`*^9}},
 CellLabel->"In[20]:=",ExpressionUUID->"476d81a6-eaf8-4d26-96d8-68df3ade62be"],

Cell[BoxData[
 RowBox[{"ConditionalExpression", "[", 
  RowBox[{
   FractionBox[
    RowBox[{"2", " ", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{
        RowBox[{"(", 
         RowBox[{
          RowBox[{"-", "2"}], "+", 
          RowBox[{"4", " ", "k2"}]}], ")"}], " ", 
        RowBox[{"EllipticE", "[", "k2", "]"}]}], "+", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{
          RowBox[{"-", "1"}], "+", "k2"}], ")"}], " ", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"-", "2"}], "+", 
          RowBox[{"3", " ", "k2"}]}], ")"}], " ", 
        RowBox[{"EllipticK", "[", "k2", "]"}]}]}], ")"}]}], 
    RowBox[{"3", " ", 
     SuperscriptBox["k2", 
      RowBox[{"3", "/", "2"}]]}]], ",", 
   RowBox[{
    RowBox[{
     RowBox[{"Im", "[", "k2", "]"}], "\[NotEqual]", "0"}], "||", 
    RowBox[{
     RowBox[{"Re", "[", "k2", "]"}], "\[LessEqual]", "1"}]}]}], 
  "]"}]], "Output",
 CellChangeTimes->{3.749231878707794*^9},
 CellLabel->"Out[20]=",ExpressionUUID->"57c5b519-c12c-4291-a1b8-62bd612e6a14"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"D", "[", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{"Cos", "[", "phi", "]"}], "^", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"2", "*", "v"}], "-", "3"}], ")"}]}], "*", 
    RowBox[{"Sin", "[", "phi", "]"}]}], ",", "phi"}], "]"}]], "Input",
 CellChangeTimes->{{3.749234812104191*^9, 3.74923484355072*^9}, {
  3.749234961352573*^9, 3.749234965398448*^9}, {3.749235836837037*^9, 
  3.7492358424121943`*^9}, {3.749236836737547*^9, 3.7492368648034697`*^9}},
 CellLabel->"In[15]:=",ExpressionUUID->"17f12f75-6346-4717-bc7f-68f8c10adb2c"],

Cell[BoxData[
 RowBox[{
  SuperscriptBox[
   RowBox[{"Cos", "[", "phi", "]"}], 
   RowBox[{
    RowBox[{"-", "2"}], "+", 
    RowBox[{"2", " ", "v"}]}]], "-", 
  RowBox[{
   RowBox[{"(", 
    RowBox[{
     RowBox[{"-", "3"}], "+", 
     RowBox[{"2", " ", "v"}]}], ")"}], " ", 
   SuperscriptBox[
    RowBox[{"Cos", "[", "phi", "]"}], 
    RowBox[{
     RowBox[{"-", "4"}], "+", 
     RowBox[{"2", " ", "v"}]}]], " ", 
   SuperscriptBox[
    RowBox[{"Sin", "[", "phi", "]"}], "2"]}]}]], "Output",
 CellChangeTimes->{{3.749234822321971*^9, 3.74923484397053*^9}, 
   3.7492349657181587`*^9, {3.749235837798587*^9, 3.7492358427312527`*^9}, {
   3.749236837527236*^9, 3.7492368651348333`*^9}},
 CellLabel->"Out[15]=",ExpressionUUID->"be3532df-5afd-497b-9038-5201516e511d"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"1", "-", 
  RowBox[{
   RowBox[{"2", "/", "10"}], "*", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"2", "*", "v"}], "-", "2"}], ")"}], "*", 
      RowBox[{"(", 
       RowBox[{"k2", "-", "1"}], ")"}]}], "-", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"2", "*", "v"}], "-", "3"}], ")"}]}], ")"}]}]}]], "Input",
 CellChangeTimes->{{3.749237509942943*^9, 3.749237520408814*^9}},
 CellLabel->"In[16]:=",ExpressionUUID->"64294194-390a-44b8-91a3-da928d71d2e6"],

Cell[BoxData[
 RowBox[{"1", "+", 
  RowBox[{
   FractionBox["1", "5"], " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"-", "3"}], "+", 
     RowBox[{"2", " ", "v"}], "-", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "1"}], "+", "k2"}], ")"}], " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "2"}], "+", 
        RowBox[{"2", " ", "v"}]}], ")"}]}]}], ")"}]}]}]], "Output",
 CellChangeTimes->{3.749237521443265*^9},
 CellLabel->"Out[16]=",ExpressionUUID->"ae0918cc-ed3a-48a3-9c58-11f389ad5d09"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"FullSimplify", "[", "%", "]"}]], "Input",
 CellChangeTimes->{{3.7492375223413343`*^9, 3.749237523881085*^9}},
 CellLabel->"In[17]:=",ExpressionUUID->"d5d994e7-2898-45d9-a9fa-64297c581e6e"],

Cell[BoxData[
 RowBox[{
  RowBox[{"-", 
   FractionBox["2", "5"]}], " ", 
  RowBox[{"(", 
   RowBox[{
    RowBox[{"k2", " ", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"-", "1"}], "+", "v"}], ")"}]}], "-", 
    RowBox[{"2", " ", "v"}]}], ")"}]}]], "Output",
 CellChangeTimes->{3.749237524152821*^9},
 CellLabel->"Out[17]=",ExpressionUUID->"d6fda8b4-c3a6-4946-953a-d2b7799f3e7b"]
}, Open  ]],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{
   RowBox[{
    RowBox[{"L_v", " ", "integral", " ", "for", " ", "v"}], "=", "0"}], ",", 
   " ", 
   RowBox[{
    RowBox[{"k", "^", "2"}], " ", ">", " ", "1"}]}], " ", "*)"}]], "Input",
 CellChangeTimes->{{3.7492398536882257`*^9, 3.749239873154001*^9}},
 CellLabel->"In[18]:=",ExpressionUUID->"0c3aa25d-dad6-48fa-9757-8d22469cf186"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Integrate", "[", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{"1", "/", 
      RowBox[{"Sqrt", "[", "w", "]"}]}], "/", 
     RowBox[{"Sqrt", "[", 
      RowBox[{"1", "-", "w"}], "]"}]}], "*", 
    RowBox[{
     RowBox[{"(", 
      RowBox[{"1", "-", 
       RowBox[{"w", "/", "k2"}]}], ")"}], "^", 
     RowBox[{"(", 
      RowBox[{"3", "/", "2"}], ")"}]}]}], ",", 
   RowBox[{"{", 
    RowBox[{"w", ",", "0", ",", "1"}], "}"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.749239882903761*^9, 3.7492399129939413`*^9}},
 CellLabel->"In[19]:=",ExpressionUUID->"9be7d430-05e6-45df-b8a5-081efa414cf2"],

Cell[BoxData[
 RowBox[{"ConditionalExpression", "[", 
  RowBox[{
   FractionBox[
    RowBox[{
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "4"}], "+", 
        RowBox[{"8", " ", "k2"}]}], ")"}], " ", 
      RowBox[{"EllipticE", "[", 
       FractionBox["1", "k2"], "]"}]}], "-", 
     RowBox[{"2", " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "1"}], "+", "k2"}], ")"}], " ", 
      RowBox[{"EllipticK", "[", 
       FractionBox["1", "k2"], "]"}]}]}], 
    RowBox[{"3", " ", "k2"}]], ",", 
   RowBox[{
    RowBox[{
     RowBox[{"Im", "[", "k2", "]"}], "\[NotEqual]", "0"}], "||", 
    RowBox[{
     RowBox[{"Re", "[", "k2", "]"}], "\[GreaterEqual]", "1"}], "||", 
    RowBox[{
     RowBox[{"Re", "[", "k2", "]"}], "\[LessEqual]", "0"}]}]}], 
  "]"}]], "Output",
 CellChangeTimes->{3.7492399157201138`*^9},
 CellLabel->"Out[19]=",ExpressionUUID->"5d76c865-94d2-40ee-ac1d-99ea81b2f028"]
}, Open  ]],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{
   RowBox[{
    RowBox[{"L_v", " ", "integral", " ", "for", " ", "v"}], "=", "1"}], ",", 
   " ", 
   RowBox[{
    RowBox[{"k", "^", "2"}], " ", ">", " ", "1"}]}], " ", "*)"}]], "Input",
 CellChangeTimes->{{3.7492399833775187`*^9, 
  3.749239984576995*^9}},ExpressionUUID->"e493a91f-7832-42f3-b405-\
bbbb5b1ba8bc"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Integrate", "[", 
  RowBox[{
   RowBox[{
    RowBox[{"1", "/", 
     RowBox[{"Sqrt", "[", "w", "]"}]}], "*", 
    RowBox[{"Sqrt", "[", 
     RowBox[{"1", "-", "w"}], "]"}], "*", 
    RowBox[{
     RowBox[{"(", 
      RowBox[{"1", "-", 
       RowBox[{"w", "/", "k2"}]}], ")"}], "^", 
     RowBox[{"(", 
      RowBox[{"3", "/", "2"}], ")"}]}]}], ",", 
   RowBox[{"{", 
    RowBox[{"w", ",", "0", ",", "1"}], "}"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.7492399904895*^9, 3.74923999118464*^9}},
 CellLabel->"In[20]:=",ExpressionUUID->"e00f0fbf-d789-4552-8b0e-abd73a9d52e7"],

Cell[BoxData[
 RowBox[{"ConditionalExpression", "[", 
  RowBox[{
   FractionBox[
    RowBox[{"2", " ", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{
        RowBox[{"(", 
         RowBox[{
          RowBox[{"-", "2"}], "+", 
          RowBox[{"k2", " ", 
           RowBox[{"(", 
            RowBox[{"7", "+", 
             RowBox[{"3", " ", "k2"}]}], ")"}]}]}], ")"}], " ", 
        RowBox[{"EllipticE", "[", 
         FractionBox["1", "k2"], "]"}]}], "+", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{"1", "+", 
          RowBox[{
           RowBox[{"(", 
            RowBox[{"2", "-", 
             RowBox[{"3", " ", "k2"}]}], ")"}], " ", "k2"}]}], ")"}], " ", 
        RowBox[{"EllipticK", "[", 
         FractionBox["1", "k2"], "]"}]}]}], ")"}]}], 
    RowBox[{"15", " ", "k2"}]], ",", 
   RowBox[{
    RowBox[{
     RowBox[{"Im", "[", "k2", "]"}], "\[NotEqual]", "0"}], "||", 
    RowBox[{
     RowBox[{"Re", "[", "k2", "]"}], "\[GreaterEqual]", "1"}], "||", 
    RowBox[{
     RowBox[{"Re", "[", "k2", "]"}], "\[LessEqual]", "0"}]}]}], 
  "]"}]], "Output",
 CellChangeTimes->{3.749239998492201*^9},
 CellLabel->"Out[20]=",ExpressionUUID->"290e7390-5823-4425-9992-ba5caae955dc"]
}, Open  ]],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{
   RowBox[{
    RowBox[{"L_v", " ", "integral", " ", "for", " ", "v"}], "=", "2"}], ",", 
   " ", 
   RowBox[{
    RowBox[{"k", "^", "2"}], " ", ">", " ", "1"}]}], " ", "*)"}]], "Input",
 CellChangeTimes->{{3.7492408686075697`*^9, 
  3.749240868662712*^9}},ExpressionUUID->"f84d77c2-376e-4107-b5cc-\
d1f9042479e4"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"Integrate", "[", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"Sqrt", "[", 
       RowBox[{"1", "-", "w"}], "]"}], "/", 
      RowBox[{"Sqrt", "[", "w", "]"}]}], "*", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{"1", "-", 
        RowBox[{"w", "/", "k2"}]}], ")"}], "^", 
      RowBox[{"(", 
       RowBox[{"3", "/", "2"}], ")"}]}]}], ",", 
    RowBox[{"{", 
     RowBox[{"w", ",", "0", ",", "1"}], "}"}]}], "]"}], "-", 
  RowBox[{"Integrate", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"Sqrt", "[", 
      RowBox[{"1", "-", "w"}], "]"}], "*", 
     RowBox[{"Sqrt", "[", "w", "]"}], "*", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{"1", "-", 
        RowBox[{"w", "/", "k2"}]}], ")"}], "^", 
      RowBox[{"(", 
       RowBox[{"3", "/", "2"}], ")"}]}]}], ",", 
    RowBox[{"{", 
     RowBox[{"w", ",", "0", ",", "1"}], "}"}]}], "]"}]}]], "Input",
 CellChangeTimes->{{3.7492408803053513`*^9, 3.749240886174014*^9}, {
  3.749241109858162*^9, 3.7492411117907753`*^9}, {3.749241354345929*^9, 
  3.7492413627680492`*^9}},
 CellLabel->"In[23]:=",ExpressionUUID->"41a4af89-b525-4882-854c-177f48380763"],

Cell[BoxData[
 RowBox[{"ConditionalExpression", "[", 
  RowBox[{
   RowBox[{
    FractionBox[
     RowBox[{"2", " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{
         RowBox[{"(", 
          RowBox[{
           RowBox[{"-", "2"}], "+", 
           RowBox[{"k2", " ", 
            RowBox[{"(", 
             RowBox[{"7", "+", 
              RowBox[{"3", " ", "k2"}]}], ")"}]}]}], ")"}], " ", 
         RowBox[{"EllipticE", "[", 
          FractionBox["1", "k2"], "]"}]}], "+", 
        RowBox[{
         RowBox[{"(", 
          RowBox[{"1", "+", 
           RowBox[{
            RowBox[{"(", 
             RowBox[{"2", "-", 
              RowBox[{"3", " ", "k2"}]}], ")"}], " ", "k2"}]}], ")"}], " ", 
         RowBox[{"EllipticK", "[", 
          FractionBox["1", "k2"], "]"}]}]}], ")"}]}], 
     RowBox[{"15", " ", "k2"}]], "-", 
    FractionBox[
     RowBox[{
      RowBox[{"2", " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"-", "1"}], "+", 
         RowBox[{"2", " ", "k2"}]}], ")"}], " ", 
       RowBox[{"(", 
        RowBox[{"8", "+", 
         RowBox[{"3", " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"-", "1"}], "+", "k2"}], ")"}], " ", "k2"}]}], ")"}], " ", 
       RowBox[{"EllipticE", "[", 
        FractionBox["1", "k2"], "]"}]}], "-", 
      RowBox[{"4", " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"-", "1"}], "+", "k2"}], ")"}], " ", 
       RowBox[{"(", 
        RowBox[{"2", "+", 
         RowBox[{"3", " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"-", "1"}], "+", "k2"}], ")"}], " ", "k2"}]}], ")"}], " ", 
       RowBox[{"EllipticK", "[", 
        FractionBox["1", "k2"], "]"}]}]}], 
     RowBox[{"105", " ", "k2"}]]}], ",", 
   RowBox[{
    RowBox[{
     RowBox[{"Im", "[", "k2", "]"}], "\[NotEqual]", "0"}], "||", 
    RowBox[{
     RowBox[{"Re", "[", "k2", "]"}], "\[GreaterEqual]", "1"}], "||", 
    RowBox[{
     RowBox[{"Re", "[", "k2", "]"}], "\[LessEqual]", "0"}]}]}], 
  "]"}]], "Output",
 CellChangeTimes->{3.749241005387936*^9, 3.749241227853745*^9, 
  3.749241379901842*^9},
 CellLabel->"Out[23]=",ExpressionUUID->"5da7a688-de39-49e3-ac35-32041bb2630c"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"FullSimplify", "[", "%", "]"}]], "Input",
 CellChangeTimes->{{3.749241385982511*^9, 3.749241388362376*^9}},
 CellLabel->"In[24]:=",ExpressionUUID->"18ca87ca-c6bc-47bb-9b55-2c0add930d71"],

Cell[BoxData[
 RowBox[{"ConditionalExpression", "[", 
  RowBox[{
   FractionBox[
    RowBox[{
     RowBox[{
      RowBox[{"-", "4"}], " ", 
      RowBox[{"(", 
       RowBox[{"1", "+", "k2"}], ")"}], " ", 
      RowBox[{"(", 
       RowBox[{"1", "+", 
        RowBox[{
         RowBox[{"(", 
          RowBox[{
           RowBox[{"-", "6"}], "+", "k2"}], ")"}], " ", "k2"}]}], ")"}], " ", 
      
      RowBox[{"EllipticE", "[", 
       FractionBox["1", "k2"], "]"}]}], "+", 
     RowBox[{"2", " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "1"}], "+", "k2"}], ")"}], " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "1"}], "+", 
        RowBox[{"k2", " ", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"-", "9"}], "+", 
           RowBox[{"2", " ", "k2"}]}], ")"}]}]}], ")"}], " ", 
      RowBox[{"EllipticK", "[", 
       FractionBox["1", "k2"], "]"}]}]}], 
    RowBox[{"35", " ", "k2"}]], ",", 
   RowBox[{
    RowBox[{"k2", "\[NotEqual]", 
     RowBox[{"Re", "[", "k2", "]"}]}], "||", 
    RowBox[{
     RowBox[{"Re", "[", "k2", "]"}], "\[GreaterEqual]", "1"}], "||", 
    RowBox[{
     RowBox[{"Re", "[", "k2", "]"}], "\[LessEqual]", "0"}]}]}], 
  "]"}]], "Output",
 CellChangeTimes->{3.749241388847637*^9},
 CellLabel->"Out[24]=",ExpressionUUID->"9897d439-73d0-4422-98db-a64a05522a48"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"L2", " ", "=", " ", 
  FractionBox[
   RowBox[{
    RowBox[{
     RowBox[{"-", "4"}], " ", 
     RowBox[{"(", 
      RowBox[{"1", "+", "k2"}], ")"}], " ", 
     RowBox[{"(", 
      RowBox[{"1", "+", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{
          RowBox[{"-", "6"}], "+", "k2"}], ")"}], " ", "k2"}]}], ")"}], " ", 
     RowBox[{"EllipticE", "[", 
      FractionBox["1", "k2"], "]"}]}], "+", 
    RowBox[{"2", " ", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"-", "1"}], "+", "k2"}], ")"}], " ", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"-", "1"}], "+", 
       RowBox[{"k2", " ", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"-", "9"}], "+", 
          RowBox[{"2", " ", "k2"}]}], ")"}]}]}], ")"}], " ", 
     RowBox[{"EllipticK", "[", 
      FractionBox["1", "k2"], "]"}]}]}], 
   RowBox[{"35", " ", "k2"}]]}]], "Input",
 CellChangeTimes->{{3.749241489964055*^9, 3.749241499009158*^9}},
 CellLabel->"In[25]:=",ExpressionUUID->"e44c1d90-9de6-4b6f-bb15-948aeb4e249a"],

Cell[BoxData[
 FractionBox[
  RowBox[{
   RowBox[{
    RowBox[{"-", "4"}], " ", 
    RowBox[{"(", 
     RowBox[{"1", "+", "k2"}], ")"}], " ", 
    RowBox[{"(", 
     RowBox[{"1", "+", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{
         RowBox[{"-", "6"}], "+", "k2"}], ")"}], " ", "k2"}]}], ")"}], " ", 
    RowBox[{"EllipticE", "[", 
     FractionBox["1", "k2"], "]"}]}], "+", 
   RowBox[{"2", " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"-", "1"}], "+", "k2"}], ")"}], " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"-", "1"}], "+", 
      RowBox[{"k2", " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"-", "9"}], "+", 
         RowBox[{"2", " ", "k2"}]}], ")"}]}]}], ")"}], " ", 
    RowBox[{"EllipticK", "[", 
     FractionBox["1", "k2"], "]"}]}]}], 
  RowBox[{"35", " ", "k2"}]]], "Output",
 CellChangeTimes->{3.74924150082124*^9},
 CellLabel->"Out[25]=",ExpressionUUID->"04121c08-af75-4761-88b8-6984dc468e0c"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"L1", " ", "=", " ", 
  FractionBox[
   RowBox[{"2", " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{
       RowBox[{"(", 
        RowBox[{
         RowBox[{"-", "2"}], "+", 
         RowBox[{"k2", " ", 
          RowBox[{"(", 
           RowBox[{"7", "+", 
            RowBox[{"3", " ", "k2"}]}], ")"}]}]}], ")"}], " ", 
       RowBox[{"EllipticE", "[", 
        FractionBox["1", "k2"], "]"}]}], "+", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{"1", "+", 
         RowBox[{
          RowBox[{"(", 
           RowBox[{"2", "-", 
            RowBox[{"3", " ", "k2"}]}], ")"}], " ", "k2"}]}], ")"}], " ", 
       RowBox[{"EllipticK", "[", 
        FractionBox["1", "k2"], "]"}]}]}], ")"}]}], 
   RowBox[{"15", " ", "k2"}]]}]], "Input",
 CellChangeTimes->{{3.7492415025871277`*^9, 3.749241514159443*^9}},
 CellLabel->"In[26]:=",ExpressionUUID->"2cd1e7e8-255d-4890-aecf-98297a8aebe5"],

Cell[BoxData[
 FractionBox[
  RowBox[{"2", " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "2"}], "+", 
        RowBox[{"k2", " ", 
         RowBox[{"(", 
          RowBox[{"7", "+", 
           RowBox[{"3", " ", "k2"}]}], ")"}]}]}], ")"}], " ", 
      RowBox[{"EllipticE", "[", 
       FractionBox["1", "k2"], "]"}]}], "+", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{"1", "+", 
        RowBox[{
         RowBox[{"(", 
          RowBox[{"2", "-", 
           RowBox[{"3", " ", "k2"}]}], ")"}], " ", "k2"}]}], ")"}], " ", 
      RowBox[{"EllipticK", "[", 
       FractionBox["1", "k2"], "]"}]}]}], ")"}]}], 
  RowBox[{"15", " ", "k2"}]]], "Output",
 CellChangeTimes->{3.749241515162175*^9},
 CellLabel->"Out[26]=",ExpressionUUID->"bb29363c-fad5-46a0-a084-653aad7607ac"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"L0", " ", "=", " ", 
  FractionBox[
   RowBox[{
    RowBox[{
     RowBox[{"(", 
      RowBox[{
       RowBox[{"-", "4"}], "+", 
       RowBox[{"8", " ", "k2"}]}], ")"}], " ", 
     RowBox[{"EllipticE", "[", 
      FractionBox["1", "k2"], "]"}]}], "-", 
    RowBox[{"2", " ", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"-", "1"}], "+", "k2"}], ")"}], " ", 
     RowBox[{"EllipticK", "[", 
      FractionBox["1", "k2"], "]"}]}]}], 
   RowBox[{"3", " ", "k2"}]]}]], "Input",
 CellChangeTimes->{{3.749241527866837*^9, 3.749241531516951*^9}, 
   3.749241697361431*^9},
 CellLabel->"In[34]:=",ExpressionUUID->"2cf7a01f-f42c-4893-9523-d947212baf6c"],

Cell[BoxData[
 FractionBox[
  RowBox[{
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      RowBox[{"-", "4"}], "+", 
      RowBox[{"8", " ", "k2"}]}], ")"}], " ", 
    RowBox[{"EllipticE", "[", 
     FractionBox["1", "k2"], "]"}]}], "-", 
   RowBox[{"2", " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"-", "1"}], "+", "k2"}], ")"}], " ", 
    RowBox[{"EllipticK", "[", 
     FractionBox["1", "k2"], "]"}]}]}], 
  RowBox[{"3", " ", "k2"}]]], "Output",
 CellChangeTimes->{3.749241531973372*^9, 3.749241698126844*^9},
 CellLabel->"Out[34]=",ExpressionUUID->"97f0cb5e-986a-4f45-9daa-548ecd4d0632"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"L2", " ", "-", " ", 
  RowBox[{
   RowBox[{"1", "/", "7"}], "*", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{
      RowBox[{"-", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"2", "*", "k2"}], "-", "8"}], ")"}]}], "*", "L1"}], "+", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{"k2", "-", "1"}], ")"}], "*", "L0"}]}], ")"}]}]}]], "Input",
 CellChangeTimes->{{3.749241536574089*^9, 3.749241571532011*^9}, {
  3.749241607732052*^9, 3.749241612849484*^9}, {3.749242011774005*^9, 
  3.749242012179932*^9}, {3.7492421383276787`*^9, 3.749242206321302*^9}, {
  3.749242277408825*^9, 3.749242305373892*^9}, {3.749242359311489*^9, 
  3.7492423840536947`*^9}, {3.749242635337576*^9, 3.749242636271566*^9}},
 CellLabel->"In[50]:=",ExpressionUUID->"e180265f-5d56-42fd-8e1b-607a6aa515a3"],

Cell[BoxData[
 RowBox[{
  FractionBox[
   RowBox[{
    RowBox[{
     RowBox[{"-", "4"}], " ", 
     RowBox[{"(", 
      RowBox[{"1", "+", "k2"}], ")"}], " ", 
     RowBox[{"(", 
      RowBox[{"1", "+", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{
          RowBox[{"-", "6"}], "+", "k2"}], ")"}], " ", "k2"}]}], ")"}], " ", 
     RowBox[{"EllipticE", "[", 
      FractionBox["1", "k2"], "]"}]}], "+", 
    RowBox[{"2", " ", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"-", "1"}], "+", "k2"}], ")"}], " ", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"-", "1"}], "+", 
       RowBox[{"k2", " ", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"-", "9"}], "+", 
          RowBox[{"2", " ", "k2"}]}], ")"}]}]}], ")"}], " ", 
     RowBox[{"EllipticK", "[", 
      FractionBox["1", "k2"], "]"}]}]}], 
   RowBox[{"35", " ", "k2"}]], "+", 
  RowBox[{
   FractionBox["1", "7"], " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"-", 
      FractionBox[
       RowBox[{
        RowBox[{"(", 
         RowBox[{
          RowBox[{"-", "1"}], "+", "k2"}], ")"}], " ", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{
           RowBox[{"(", 
            RowBox[{
             RowBox[{"-", "4"}], "+", 
             RowBox[{"8", " ", "k2"}]}], ")"}], " ", 
           RowBox[{"EllipticE", "[", 
            FractionBox["1", "k2"], "]"}]}], "-", 
          RowBox[{"2", " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"-", "1"}], "+", "k2"}], ")"}], " ", 
           RowBox[{"EllipticK", "[", 
            FractionBox["1", "k2"], "]"}]}]}], ")"}]}], 
       RowBox[{"3", " ", "k2"}]]}], "-", 
     FractionBox[
      RowBox[{"2", " ", 
       RowBox[{"(", 
        RowBox[{"8", "-", 
         RowBox[{"2", " ", "k2"}]}], ")"}], " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{
          RowBox[{"(", 
           RowBox[{
            RowBox[{"-", "2"}], "+", 
            RowBox[{"k2", " ", 
             RowBox[{"(", 
              RowBox[{"7", "+", 
               RowBox[{"3", " ", "k2"}]}], ")"}]}]}], ")"}], " ", 
          RowBox[{"EllipticE", "[", 
           FractionBox["1", "k2"], "]"}]}], "+", 
         RowBox[{
          RowBox[{"(", 
           RowBox[{"1", "+", 
            RowBox[{
             RowBox[{"(", 
              RowBox[{"2", "-", 
               RowBox[{"3", " ", "k2"}]}], ")"}], " ", "k2"}]}], ")"}], " ", 
          RowBox[{"EllipticK", "[", 
           FractionBox["1", "k2"], "]"}]}]}], ")"}]}], 
      RowBox[{"15", " ", "k2"}]]}], ")"}]}]}]], "Output",
 CellChangeTimes->{
  3.7492422072477427`*^9, 3.74924230593451*^9, {3.749242361287364*^9, 
   3.7492423849122458`*^9}, 3.749242646087591*^9},
 CellLabel->"Out[50]=",ExpressionUUID->"b0561121-2f5f-4659-be96-3b35e5a283d3"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"FullSimplify", "[", "%", "]"}]], "Input",
 CellChangeTimes->{{3.749241700681415*^9, 3.749241703260653*^9}},
 CellLabel->"In[51]:=",ExpressionUUID->"6587fb02-7ba8-4d5c-b76e-93500aac365a"],

Cell[BoxData["0"], "Output",
 CellChangeTimes->{
  3.749241703643811*^9, 3.749242015518001*^9, 3.749242209155095*^9, 
   3.7492423084365377`*^9, {3.749242362998942*^9, 3.7492423872702417`*^9}, 
   3.749242647972151*^9},
 CellLabel->"Out[51]=",ExpressionUUID->"081de116-8af6-48b7-9a7f-b033d7523cfa"]
}, Open  ]],

Cell[BoxData["aqa"], "Input",
 CellChangeTimes->{{3.749242786289195*^9, 
  3.749242786350617*^9}},ExpressionUUID->"1f8beb3f-cc1f-45b7-bc68-\
f0f4dbdbb080"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"D", "[", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{"-", "2"}], "/", "10"}], "*", 
    RowBox[{
     RowBox[{"Sqrt", "[", 
      RowBox[{"k2", "-", "1", "+", 
       RowBox[{
        RowBox[{"Cos", "[", "phi", "]"}], "^", "2"}]}], "]"}], "^", "5"}]}], 
   ",", "phi"}], "]"}]], "Input",
 CellChangeTimes->{{3.749241818702758*^9, 3.7492418323768806`*^9}},
 CellLabel->"In[37]:=",ExpressionUUID->"50a32cea-5767-424d-b358-a063834ab98c"],

Cell[BoxData[
 RowBox[{
  RowBox[{"Cos", "[", "phi", "]"}], " ", 
  SuperscriptBox[
   RowBox[{"(", 
    RowBox[{
     RowBox[{"-", "1"}], "+", "k2", "+", 
     SuperscriptBox[
      RowBox[{"Cos", "[", "phi", "]"}], "2"]}], ")"}], 
   RowBox[{"3", "/", "2"}]], " ", 
  RowBox[{"Sin", "[", "phi", "]"}]}]], "Output",
 CellChangeTimes->{3.7492418335347357`*^9},
 CellLabel->"Out[37]=",ExpressionUUID->"ea1b08a2-a6d9-4493-b19b-853c4b63d697"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"1", "+", 
  RowBox[{
   RowBox[{"2", "/", "10"}], "*", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"2", "*", "v"}], "-", "2"}], ")"}]}]}]], "Input",
 CellChangeTimes->{{3.74924257486397*^9, 3.7492425790002613`*^9}},
 CellLabel->"In[48]:=",ExpressionUUID->"09bce8f5-9b4e-43f2-87e4-b384b0271711"],

Cell[BoxData[
 RowBox[{"1", "+", 
  RowBox[{
   FractionBox["1", "5"], " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"-", "2"}], "+", 
     RowBox[{"2", " ", "v"}]}], ")"}]}]}]], "Output",
 CellChangeTimes->{3.749242579382916*^9},
 CellLabel->"Out[48]=",ExpressionUUID->"2f8eb468-b564-4a11-84b2-955a51de427b"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"FullSimplify", "[", "%", "]"}]], "Input",
 CellChangeTimes->{{3.749242580029101*^9, 3.7492425824487047`*^9}},
 CellLabel->"In[49]:=",ExpressionUUID->"6f819485-a01e-443e-b317-94906175ac08"],

Cell[BoxData[
 RowBox[{
  FractionBox["1", "5"], " ", 
  RowBox[{"(", 
   RowBox[{"3", "+", 
    RowBox[{"2", " ", "v"}]}], ")"}]}]], "Output",
 CellChangeTimes->{3.749242582820628*^9},
 CellLabel->"Out[49]=",ExpressionUUID->"aaf4707c-4552-442b-801e-4093337c066c"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Integrate", "[", 
  RowBox[{
   RowBox[{
    RowBox[{"Cos", "[", "phi", "]"}], "^", 
    RowBox[{"(", 
     RowBox[{"2", "v"}], ")"}]}], ",", 
   RowBox[{"{", 
    RowBox[{"phi", ",", 
     RowBox[{
      RowBox[{"-", "Pi"}], "/", "2"}], ",", 
     RowBox[{"Pi", "/", "2"}]}], "}"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.749248377778352*^9, 3.749248390035429*^9}},
 CellLabel->"In[52]:=",ExpressionUUID->"d291dd0e-013d-430a-b22d-2bee2992c5ac"],

Cell[BoxData[
 RowBox[{"ConditionalExpression", "[", 
  RowBox[{
   FractionBox[
    RowBox[{
     SqrtBox["\[Pi]"], " ", 
     RowBox[{"Gamma", "[", 
      RowBox[{
       FractionBox["1", "2"], "+", "v"}], "]"}]}], 
    RowBox[{"Gamma", "[", 
     RowBox[{"1", "+", "v"}], "]"}]], ",", 
   RowBox[{
    RowBox[{"Re", "[", "v", "]"}], ">", 
    RowBox[{"-", 
     FractionBox["1", "2"]}]}]}], "]"}]], "Output",
 CellChangeTimes->{3.7492483943404627`*^9},
 CellLabel->"Out[52]=",ExpressionUUID->"a844cbf4-5ef7-4448-9c66-b3579beb6801"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Integrate", "[", 
  RowBox[{
   RowBox[{
    RowBox[{"Sin", "[", "phi", "]"}], "^", 
    RowBox[{"(", 
     RowBox[{"2", "v"}], ")"}]}], ",", 
   RowBox[{"{", 
    RowBox[{"phi", ",", 
     RowBox[{
      RowBox[{"-", "Pi"}], "/", "2"}], ",", 
     RowBox[{"Pi", "/", "2"}]}], "}"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.7492484380507727`*^9, 3.74924844733285*^9}},
 CellLabel->"In[53]:=",ExpressionUUID->"95dfbe70-528c-4bfa-987d-9061fe32bcf1"],

Cell[BoxData[
 FractionBox[
  RowBox[{
   RowBox[{"(", 
    RowBox[{"1", "+", 
     SuperscriptBox[
      RowBox[{"(", 
       RowBox[{"-", "1"}], ")"}], 
      RowBox[{"2", " ", "v"}]]}], ")"}], " ", 
   SqrtBox["\[Pi]"], " ", 
   RowBox[{"Gamma", "[", 
    RowBox[{
     FractionBox["1", "2"], "+", "v"}], "]"}]}], 
  RowBox[{"2", " ", 
   RowBox[{"Gamma", "[", 
    RowBox[{"1", "+", "v"}], "]"}]}]]], "Output",
 CellChangeTimes->{3.7492484488809547`*^9},
 CellLabel->"Out[53]=",ExpressionUUID->"8a61f81d-66e7-4347-8297-69908fe1a7e5"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Plot", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{
      RowBox[{"Cos", "[", "phi", "]"}], "^", "6"}], ",", 
     RowBox[{
      RowBox[{"Sin", "[", 
       RowBox[{"phi", "-", 
        RowBox[{"Pi", "/", "2"}]}], "]"}], "^", "6"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"phi", ",", 
     RowBox[{
      RowBox[{"-", "Pi"}], "/", "2"}], ",", 
     RowBox[{"Pi", "/", "2"}]}], "}"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.749249311626377*^9, 3.749249320772897*^9}, {
  3.749249389316907*^9, 3.749249459914151*^9}},
 CellLabel->"In[58]:=",ExpressionUUID->"bcf4fc25-d7d6-4310-820c-33302d8c6b99"],

Cell[BoxData[
 GraphicsBox[{{{}, {}, 
    TagBox[
     {RGBColor[0.368417, 0.506779, 0.709798], AbsoluteThickness[1.6], Opacity[
      1.], LineBox[CompressedData["
1:eJw1m3c819/7/62kqKw3RQpF2RQq43lZmRUJSSkyklHKKKtsQvYmZavM7Hns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       "]]},
     Annotation[#, "Charting`Private`Tag$198043#1"]& ], 
    TagBox[
     {RGBColor[0.880722, 0.611041, 0.142051], AbsoluteThickness[1.6], Opacity[
      1.], LineBox[CompressedData["
1:eJwtm3c41t//x62kNKwoUvhE2SOpcL9fVmZFQiJFWRmljDIzMpLs7MhWmdnz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       "]]},
     Annotation[#, "Charting`Private`Tag$198043#2"]& ]}, {}, {}},
  AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
  Axes->{True, True},
  AxesLabel->{None, None},
  AxesOrigin->{0, 0},
  DisplayFunction->Identity,
  Frame->{{False, False}, {False, False}},
  FrameLabel->{{None, None}, {None, None}},
  FrameTicks->{{Automatic, 
     Charting`ScaledFrameTicks[{Identity, Identity}]}, {Automatic, 
     Charting`ScaledFrameTicks[{Identity, Identity}]}},
  GridLines->{None, None},
  GridLinesStyle->Directive[
    GrayLevel[0.5, 0.4]],
  ImagePadding->All,
  Method->{
   "DefaultBoundaryStyle" -> Automatic, "DefaultMeshStyle" -> 
    AbsolutePointSize[6], "ScalingFunctions" -> None, 
    "CoordinatesToolOptions" -> {"DisplayFunction" -> ({
        (Identity[#]& )[
         Part[#, 1]], 
        (Identity[#]& )[
         Part[#, 2]]}& ), "CopiedValueFunction" -> ({
        (Identity[#]& )[
         Part[#, 1]], 
        (Identity[#]& )[
         Part[#, 2]]}& )}},
  PlotRange->
   NCache[{{Rational[-1, 2] Pi, Rational[1, 2] Pi}, {0., 
     0.9999998246097678}}, {{-1.5707963267948966`, 1.5707963267948966`}, {0., 
    0.9999998246097678}}],
  PlotRangeClipping->True,
  PlotRangePadding->{{
     Scaled[0.02], 
     Scaled[0.02]}, {
     Scaled[0.05], 
     Scaled[0.05]}},
  Ticks->{Automatic, Automatic}]], "Output",
 CellChangeTimes->{
  3.749249321890502*^9, {3.749249407836769*^9, 3.7492494608216352`*^9}},
 CellLabel->"Out[58]=",ExpressionUUID->"c7344a7e-52ea-4df7-a39f-91140a7fa190"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Series", "[", 
  RowBox[{
   RowBox[{
    RowBox[{"(", 
     RowBox[{"1", "-", 
      RowBox[{"y", "*", "w"}]}], ")"}], "^", 
    RowBox[{"(", 
     RowBox[{"3", "/", "2"}], ")"}]}], ",", 
   RowBox[{"{", 
    RowBox[{"y", ",", "0", ",", "4"}], "}"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.749431990388775*^9, 3.749432009704628*^9}},
 CellLabel->"In[2]:=",ExpressionUUID->"e1c3fc84-6063-4787-8f39-7be4a87ed8ed"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"1", "-", 
   FractionBox[
    RowBox[{"3", " ", "w", " ", "y"}], "2"], "+", 
   FractionBox[
    RowBox[{"3", " ", 
     SuperscriptBox["w", "2"], " ", 
     SuperscriptBox["y", "2"]}], "8"], "+", 
   FractionBox[
    RowBox[{
     SuperscriptBox["w", "3"], " ", 
     SuperscriptBox["y", "3"]}], "16"], "+", 
   FractionBox[
    RowBox[{"3", " ", 
     SuperscriptBox["w", "4"], " ", 
     SuperscriptBox["y", "4"]}], "128"], "+", 
   InterpretationBox[
    SuperscriptBox[
     RowBox[{"O", "[", "y", "]"}], "5"],
    SeriesData[$CellContext`y, 0, {}, 0, 5, 1],
    Editable->False]}],
  SeriesData[$CellContext`y, 0, {
   1, Rational[-3, 2] $CellContext`w, Rational[3, 8] $CellContext`w^2, 
    Rational[1, 16] $CellContext`w^3, Rational[3, 128] $CellContext`w^4}, 0, 
   5, 1],
  Editable->False]], "Output",
 CellChangeTimes->{3.7494320101725197`*^9},
 CellLabel->"Out[2]=",ExpressionUUID->"f9eb7796-409f-4b28-bc18-ebd424027f51"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Integrate", "[", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"(", 
       RowBox[{"1", "-", "w"}], ")"}], "^", 
      RowBox[{"(", 
       RowBox[{"v", "-", 
        RowBox[{"1", "/", "2"}]}], ")"}]}], "/", 
     RowBox[{"Sqrt", "[", "w", "]"}]}], "*", 
    RowBox[{"(", 
     RowBox[{"1", "-", 
      FractionBox[
       RowBox[{"3", " ", "w", " ", "y"}], "2"], "+", 
      FractionBox[
       RowBox[{"3", " ", 
        SuperscriptBox["w", "2"], " ", 
        SuperscriptBox["y", "2"]}], "8"], "+", 
      FractionBox[
       RowBox[{
        SuperscriptBox["w", "3"], " ", 
        SuperscriptBox["y", "3"]}], "16"], "+", 
      FractionBox[
       RowBox[{"3", " ", 
        SuperscriptBox["w", "4"], " ", 
        SuperscriptBox["y", "4"]}], "128"]}], ")"}]}], ",", 
   RowBox[{"{", 
    RowBox[{"w", ",", "0", ",", "1"}], "}"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.749432064019759*^9, 3.749432091953848*^9}},
 CellLabel->"In[3]:=",ExpressionUUID->"474e1945-44c9-487c-b7fe-f7bf5104c0c4"],

Cell[BoxData[
 RowBox[{"ConditionalExpression", "[", 
  RowBox[{
   RowBox[{
    FractionBox["1", 
     RowBox[{"2048", " ", 
      RowBox[{"Gamma", "[", 
       RowBox[{"5", "+", "v"}], "]"}]}]], 
    RowBox[{
     SqrtBox["\[Pi]"], " ", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"2048", " ", 
        RowBox[{"(", 
         RowBox[{"1", "+", "v"}], ")"}], " ", 
        RowBox[{"(", 
         RowBox[{"2", "+", "v"}], ")"}], " ", 
        RowBox[{"(", 
         RowBox[{"3", "+", "v"}], ")"}], " ", 
        RowBox[{"(", 
         RowBox[{"4", "+", "v"}], ")"}]}], "-", 
       RowBox[{"1536", " ", 
        RowBox[{"(", 
         RowBox[{"2", "+", "v"}], ")"}], " ", 
        RowBox[{"(", 
         RowBox[{"3", "+", "v"}], ")"}], " ", 
        RowBox[{"(", 
         RowBox[{"4", "+", "v"}], ")"}], " ", "y"}], "+", 
       RowBox[{"576", " ", 
        RowBox[{"(", 
         RowBox[{"3", "+", "v"}], ")"}], " ", 
        RowBox[{"(", 
         RowBox[{"4", "+", "v"}], ")"}], " ", 
        SuperscriptBox["y", "2"]}], "+", 
       RowBox[{"240", " ", 
        RowBox[{"(", 
         RowBox[{"4", "+", "v"}], ")"}], " ", 
        SuperscriptBox["y", "3"]}], "+", 
       RowBox[{"315", " ", 
        SuperscriptBox["y", "4"]}]}], ")"}], " ", 
     RowBox[{"Gamma", "[", 
      RowBox[{
       FractionBox["1", "2"], "+", "v"}], "]"}]}]}], ",", 
   RowBox[{
    RowBox[{"Re", "[", "v", "]"}], ">", 
    RowBox[{"-", 
     FractionBox["1", "2"]}]}]}], "]"}]], "Output",
 CellChangeTimes->{3.749432094676984*^9},
 CellLabel->"Out[3]=",ExpressionUUID->"ac9e3886-eadd-4b48-87ec-203dc6f772bb"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"FullSimplify", "[", "%", "]"}]], "Input",
 CellChangeTimes->{{3.7494321046368303`*^9, 3.7494321064324408`*^9}},
 CellLabel->"In[4]:=",ExpressionUUID->"df2b3f67-f47b-429c-8932-1448214e5407"],

Cell[BoxData[
 RowBox[{"ConditionalExpression", "[", 
  RowBox[{
   RowBox[{
    FractionBox["1", 
     RowBox[{"2048", " ", 
      RowBox[{"Gamma", "[", 
       RowBox[{"5", "+", "v"}], "]"}]}]], 
    RowBox[{
     SqrtBox["\[Pi]"], " ", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"2048", " ", 
        RowBox[{"(", 
         RowBox[{"1", "+", "v"}], ")"}], " ", 
        RowBox[{"(", 
         RowBox[{"2", "+", "v"}], ")"}], " ", 
        RowBox[{"(", 
         RowBox[{"3", "+", "v"}], ")"}], " ", 
        RowBox[{"(", 
         RowBox[{"4", "+", "v"}], ")"}]}], "-", 
       RowBox[{"1536", " ", 
        RowBox[{"(", 
         RowBox[{"2", "+", "v"}], ")"}], " ", 
        RowBox[{"(", 
         RowBox[{"3", "+", "v"}], ")"}], " ", 
        RowBox[{"(", 
         RowBox[{"4", "+", "v"}], ")"}], " ", "y"}], "+", 
       RowBox[{"576", " ", 
        RowBox[{"(", 
         RowBox[{"3", "+", "v"}], ")"}], " ", 
        RowBox[{"(", 
         RowBox[{"4", "+", "v"}], ")"}], " ", 
        SuperscriptBox["y", "2"]}], "+", 
       RowBox[{"240", " ", 
        RowBox[{"(", 
         RowBox[{"4", "+", "v"}], ")"}], " ", 
        SuperscriptBox["y", "3"]}], "+", 
       RowBox[{"315", " ", 
        SuperscriptBox["y", "4"]}]}], ")"}], " ", 
     RowBox[{"Gamma", "[", 
      RowBox[{
       FractionBox["1", "2"], "+", "v"}], "]"}]}]}], ",", 
   RowBox[{
    RowBox[{"Re", "[", "v", "]"}], ">", 
    RowBox[{"-", 
     FractionBox["1", "2"]}]}]}], "]"}]], "Output",
 CellChangeTimes->{3.749432106865272*^9},
 CellLabel->"Out[4]=",ExpressionUUID->"cb55398f-c596-4e15-bbf1-04f206c7410f"]
}, Open  ]],

Cell[BoxData[""], "Input",
 CellChangeTimes->{
  3.7494323556878023`*^9, {3.749432854203754*^9, 
   3.749432854811658*^9}},ExpressionUUID->"dff28f46-534c-438c-a37c-\
116ccfccc5e5"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{
   FractionBox["1", 
    RowBox[{"2048", " ", 
     RowBox[{"Gamma", "[", 
      RowBox[{"5", "+", "v"}], "]"}]}]], 
   SqrtBox["\[Pi]"], " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"2048", " ", 
      RowBox[{"(", 
       RowBox[{"1", "+", "v"}], ")"}], " ", 
      RowBox[{"(", 
       RowBox[{"2", "+", "v"}], ")"}], " ", 
      RowBox[{"(", 
       RowBox[{"3", "+", "v"}], ")"}], " ", 
      RowBox[{"(", 
       RowBox[{"4", "+", "v"}], ")"}]}], "-", 
     RowBox[{"1536", " ", 
      RowBox[{"(", 
       RowBox[{"2", "+", "v"}], ")"}], " ", 
      RowBox[{"(", 
       RowBox[{"3", "+", "v"}], ")"}], " ", 
      RowBox[{"(", 
       RowBox[{"4", "+", "v"}], ")"}], " ", "y"}], "+", 
     RowBox[{"576", " ", 
      RowBox[{"(", 
       RowBox[{"3", "+", "v"}], ")"}], " ", 
      RowBox[{"(", 
       RowBox[{"4", "+", "v"}], ")"}], " ", 
      SuperscriptBox["y", "2"]}], "+", 
     RowBox[{"240", " ", 
      RowBox[{"(", 
       RowBox[{"4", "+", "v"}], ")"}], " ", 
      SuperscriptBox["y", "3"]}], "+", 
     RowBox[{"315", " ", 
      SuperscriptBox["y", "4"]}]}], ")"}], " ", 
   RowBox[{"Gamma", "[", 
    RowBox[{
     FractionBox["1", "2"], "+", "v"}], "]"}]}], " ", "/.", " ", 
  RowBox[{"v", " ", "\[Rule]", " ", "0"}]}]], "Input",
 CellChangeTimes->{{3.7494328499566927`*^9, 3.749432852044326*^9}},
 CellLabel->"In[5]:=",ExpressionUUID->"7f27b2e2-d56b-453a-b729-9fca237be955"],

Cell[BoxData[
 FractionBox[
  RowBox[{"\[Pi]", " ", 
   RowBox[{"(", 
    RowBox[{"49152", "-", 
     RowBox[{"36864", " ", "y"}], "+", 
     RowBox[{"6912", " ", 
      SuperscriptBox["y", "2"]}], "+", 
     RowBox[{"960", " ", 
      SuperscriptBox["y", "3"]}], "+", 
     RowBox[{"315", " ", 
      SuperscriptBox["y", "4"]}]}], ")"}]}], "49152"]], "Output",
 CellChangeTimes->{3.7494328575870447`*^9},
 CellLabel->"Out[5]=",ExpressionUUID->"3e419626-f7db-4121-ad3b-e45f8d11d967"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"FullSimplify", "[", "%", "]"}]], "Input",
 CellChangeTimes->{{3.749432860264035*^9, 3.7494328639001703`*^9}},
 CellLabel->"In[6]:=",ExpressionUUID->"decf82ca-9996-4ff4-930f-dd5feb41daba"],

Cell[BoxData[
 RowBox[{"\[Pi]", " ", 
  RowBox[{"(", 
   RowBox[{"1", "-", 
    FractionBox[
     RowBox[{"3", " ", "y"}], "4"], "+", 
    FractionBox[
     RowBox[{
      SuperscriptBox["y", "2"], " ", 
      RowBox[{"(", 
       RowBox[{"2304", "+", 
        RowBox[{"5", " ", "y", " ", 
         RowBox[{"(", 
          RowBox[{"64", "+", 
           RowBox[{"21", " ", "y"}]}], ")"}]}]}], ")"}]}], "16384"]}], 
   ")"}]}]], "Output",
 CellChangeTimes->{3.749432864168311*^9},
 CellLabel->"Out[6]=",ExpressionUUID->"98e89b1a-f0af-4e32-9351-17daa9a90071"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{
   FractionBox["1", 
    RowBox[{"2048", " ", 
     RowBox[{"Gamma", "[", 
      RowBox[{"5", "+", "v"}], "]"}]}]], 
   SqrtBox["\[Pi]"], " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"2048", " ", 
      RowBox[{"(", 
       RowBox[{"1", "+", "v"}], ")"}], " ", 
      RowBox[{"(", 
       RowBox[{"2", "+", "v"}], ")"}], " ", 
      RowBox[{"(", 
       RowBox[{"3", "+", "v"}], ")"}], " ", 
      RowBox[{"(", 
       RowBox[{"4", "+", "v"}], ")"}]}], "-", 
     RowBox[{"1536", " ", 
      RowBox[{"(", 
       RowBox[{"2", "+", "v"}], ")"}], " ", 
      RowBox[{"(", 
       RowBox[{"3", "+", "v"}], ")"}], " ", 
      RowBox[{"(", 
       RowBox[{"4", "+", "v"}], ")"}], " ", "y"}], "+", 
     RowBox[{"576", " ", 
      RowBox[{"(", 
       RowBox[{"3", "+", "v"}], ")"}], " ", 
      RowBox[{"(", 
       RowBox[{"4", "+", "v"}], ")"}], " ", 
      SuperscriptBox["y", "2"]}], "+", 
     RowBox[{"240", " ", 
      RowBox[{"(", 
       RowBox[{"4", "+", "v"}], ")"}], " ", 
      SuperscriptBox["y", "3"]}], "+", 
     RowBox[{"315", " ", 
      SuperscriptBox["y", "4"]}]}], ")"}], " ", 
   RowBox[{"Gamma", "[", 
    RowBox[{
     FractionBox["1", "2"], "+", "v"}], "]"}]}], " ", "/.", " ", 
  RowBox[{"v", " ", "\[Rule]", " ", "1"}]}]], "Input",
 CellChangeTimes->{{3.749432877315757*^9, 3.7494328775073442`*^9}},
 CellLabel->"In[7]:=",ExpressionUUID->"a65563ac-91a5-4b8e-a868-f05d3ba98f33"],

Cell[BoxData[
 FractionBox[
  RowBox[{"\[Pi]", " ", 
   RowBox[{"(", 
    RowBox[{"245760", "-", 
     RowBox[{"92160", " ", "y"}], "+", 
     RowBox[{"11520", " ", 
      SuperscriptBox["y", "2"]}], "+", 
     RowBox[{"1200", " ", 
      SuperscriptBox["y", "3"]}], "+", 
     RowBox[{"315", " ", 
      SuperscriptBox["y", "4"]}]}], ")"}]}], "491520"]], "Output",
 CellChangeTimes->{3.749432877940206*^9},
 CellLabel->"Out[7]=",ExpressionUUID->"512331a8-5fc4-4693-beeb-884bb5c9b3b9"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"FullSimplify", "[", "%", "]"}]], "Input",
 CellChangeTimes->{{3.749432879007823*^9, 3.749432880899651*^9}},
 CellLabel->"In[8]:=",ExpressionUUID->"279291db-d396-4a3b-893b-efa251c95f3c"],

Cell[BoxData[
 RowBox[{
  FractionBox["\[Pi]", "2"], "+", 
  FractionBox[
   RowBox[{"\[Pi]", " ", "y", " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"-", "6144"}], "+", 
      RowBox[{"y", " ", 
       RowBox[{"(", 
        RowBox[{"768", "+", 
         RowBox[{"y", " ", 
          RowBox[{"(", 
           RowBox[{"80", "+", 
            RowBox[{"21", " ", "y"}]}], ")"}]}]}], ")"}]}]}], ")"}]}], 
   "32768"]}]], "Output",
 CellChangeTimes->{3.749432881199697*^9},
 CellLabel->"Out[8]=",ExpressionUUID->"d9fc9319-4d3f-4558-b591-262c8a449e4e"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{
   FractionBox["1", 
    RowBox[{"2048", " ", 
     RowBox[{"Gamma", "[", 
      RowBox[{"5", "+", "v"}], "]"}]}]], 
   SqrtBox["\[Pi]"], " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"2048", " ", 
      RowBox[{"(", 
       RowBox[{"1", "+", "v"}], ")"}], " ", 
      RowBox[{"(", 
       RowBox[{"2", "+", "v"}], ")"}], " ", 
      RowBox[{"(", 
       RowBox[{"3", "+", "v"}], ")"}], " ", 
      RowBox[{"(", 
       RowBox[{"4", "+", "v"}], ")"}]}], "-", 
     RowBox[{"1536", " ", 
      RowBox[{"(", 
       RowBox[{"2", "+", "v"}], ")"}], " ", 
      RowBox[{"(", 
       RowBox[{"3", "+", "v"}], ")"}], " ", 
      RowBox[{"(", 
       RowBox[{"4", "+", "v"}], ")"}], " ", "y"}], "+", 
     RowBox[{"576", " ", 
      RowBox[{"(", 
       RowBox[{"3", "+", "v"}], ")"}], " ", 
      RowBox[{"(", 
       RowBox[{"4", "+", "v"}], ")"}], " ", 
      SuperscriptBox["y", "2"]}], "+", 
     RowBox[{"240", " ", 
      RowBox[{"(", 
       RowBox[{"4", "+", "v"}], ")"}], " ", 
      SuperscriptBox["y", "3"]}], "+", 
     RowBox[{"315", " ", 
      SuperscriptBox["y", "4"]}]}], ")"}], " ", 
   RowBox[{"Gamma", "[", 
    RowBox[{
     FractionBox["1", "2"], "+", "v"}], "]"}]}], " ", "/.", " ", 
  RowBox[{"v", " ", "\[Rule]", " ", "2"}]}]], "Input",
 CellChangeTimes->{{3.7494328948394337`*^9, 3.749432894878525*^9}},
 CellLabel->"In[9]:=",ExpressionUUID->"0e93eddc-f1e9-449b-a998-904e2c57772c"],

Cell[BoxData[
 FractionBox[
  RowBox[{"\[Pi]", " ", 
   RowBox[{"(", 
    RowBox[{"737280", "-", 
     RowBox[{"184320", " ", "y"}], "+", 
     RowBox[{"17280", " ", 
      SuperscriptBox["y", "2"]}], "+", 
     RowBox[{"1440", " ", 
      SuperscriptBox["y", "3"]}], "+", 
     RowBox[{"315", " ", 
      SuperscriptBox["y", "4"]}]}], ")"}]}], "1966080"]], "Output",
 CellChangeTimes->{3.7494328952447433`*^9},
 CellLabel->"Out[9]=",ExpressionUUID->"c767cd8e-770c-412b-8e48-a2be931523ce"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"FullSimplify", "[", "%", "]"}]], "Input",
 CellChangeTimes->{{3.749432896506749*^9, 3.749432899535386*^9}},
 CellLabel->"In[10]:=",ExpressionUUID->"fda7f5a4-aea0-44ee-9d10-8eead7cfd601"],

Cell[BoxData[
 RowBox[{
  FractionBox[
   RowBox[{"3", " ", "\[Pi]"}], "8"], "+", 
  FractionBox[
   RowBox[{"3", " ", "\[Pi]", " ", "y", " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"-", "4096"}], "+", 
      RowBox[{"y", " ", 
       RowBox[{"(", 
        RowBox[{"384", "+", 
         RowBox[{"y", " ", 
          RowBox[{"(", 
           RowBox[{"32", "+", 
            RowBox[{"7", " ", "y"}]}], ")"}]}]}], ")"}]}]}], ")"}]}], 
   "131072"]}]], "Output",
 CellChangeTimes->{3.749432900008914*^9},
 CellLabel->"Out[10]=",ExpressionUUID->"930dce5c-0e9f-45b4-a6b0-159463f9b988"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"6144", "/", "32768"}]], "Input",
 CellChangeTimes->{{3.7494329836885777`*^9, 3.749432986042821*^9}},
 CellLabel->"In[11]:=",ExpressionUUID->"b2af9719-2355-442f-9655-dad337ce212e"],

Cell[BoxData[
 FractionBox["3", "16"]], "Output",
 CellChangeTimes->{3.749432986471589*^9},
 CellLabel->"Out[11]=",ExpressionUUID->"22e3a7a7-ce82-4404-93b2-9c791806516b"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"4096", "/", "131072"}]], "Input",
 CellChangeTimes->{{3.7494330319298897`*^9, 3.7494330341416073`*^9}},
 CellLabel->"In[12]:=",ExpressionUUID->"edfee580-4edc-46a6-8279-fda07ba5d4b2"],

Cell[BoxData[
 FractionBox["1", "32"]], "Output",
 CellChangeTimes->{3.749433034605102*^9},
 CellLabel->"Out[12]=",ExpressionUUID->"2609873e-006e-4179-9248-a6ce869276fe"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{
   FractionBox["1", 
    RowBox[{"2048", " ", 
     RowBox[{"Gamma", "[", 
      RowBox[{"5", "+", "v"}], "]"}]}]], 
   SqrtBox["\[Pi]"], " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"2048", " ", 
      RowBox[{"(", 
       RowBox[{"1", "+", "v"}], ")"}], " ", 
      RowBox[{"(", 
       RowBox[{"2", "+", "v"}], ")"}], " ", 
      RowBox[{"(", 
       RowBox[{"3", "+", "v"}], ")"}], " ", 
      RowBox[{"(", 
       RowBox[{"4", "+", "v"}], ")"}]}], "-", 
     RowBox[{"1536", " ", 
      RowBox[{"(", 
       RowBox[{"2", "+", "v"}], ")"}], " ", 
      RowBox[{"(", 
       RowBox[{"3", "+", "v"}], ")"}], " ", 
      RowBox[{"(", 
       RowBox[{"4", "+", "v"}], ")"}], " ", "y"}], "+", 
     RowBox[{"576", " ", 
      RowBox[{"(", 
       RowBox[{"3", "+", "v"}], ")"}], " ", 
      RowBox[{"(", 
       RowBox[{"4", "+", "v"}], ")"}], " ", 
      SuperscriptBox["y", "2"]}], "+", 
     RowBox[{"240", " ", 
      RowBox[{"(", 
       RowBox[{"4", "+", "v"}], ")"}], " ", 
      SuperscriptBox["y", "3"]}], "+", 
     RowBox[{"315", " ", 
      SuperscriptBox["y", "4"]}]}], ")"}], " ", 
   RowBox[{"Gamma", "[", 
    RowBox[{
     FractionBox["1", "2"], "+", "v"}], "]"}]}], " ", "/.", " ", 
  RowBox[{"v", " ", "\[Rule]", " ", "3"}]}]], "Input",
 CellChangeTimes->{{3.749433076369626*^9, 3.749433077096826*^9}},
 CellLabel->"In[13]:=",ExpressionUUID->"a07df9d2-0b54-461b-b433-73fdf8522f6c"],

Cell[BoxData[
 FractionBox[
  RowBox[{"\[Pi]", " ", 
   RowBox[{"(", 
    RowBox[{"1720320", "-", 
     RowBox[{"322560", " ", "y"}], "+", 
     RowBox[{"24192", " ", 
      SuperscriptBox["y", "2"]}], "+", 
     RowBox[{"1680", " ", 
      SuperscriptBox["y", "3"]}], "+", 
     RowBox[{"315", " ", 
      SuperscriptBox["y", "4"]}]}], ")"}]}], "5505024"]], "Output",
 CellChangeTimes->{3.74943307746096*^9},
 CellLabel->"Out[13]=",ExpressionUUID->"368cdc74-8262-4fe7-a8ee-e4272f54b4be"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"1720320", "/", "5505024"}]], "Input",
 CellChangeTimes->{{3.749433083745182*^9, 3.749433086449872*^9}},
 CellLabel->"In[14]:=",ExpressionUUID->"31e59bfc-aaef-4340-b33d-64ff82457e04"],

Cell[BoxData[
 FractionBox["5", "16"]], "Output",
 CellChangeTimes->{3.749433086907345*^9},
 CellLabel->"Out[14]=",ExpressionUUID->"f8e54489-95bd-4ba8-8bb4-b6f902372144"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"322560", "/", "5505024"}]], "Input",
 CellChangeTimes->{{3.749433105261606*^9, 3.7494331100302343`*^9}},
 CellLabel->"In[15]:=",ExpressionUUID->"2917ba9f-af22-4b76-8624-2e78e194bbd9"],

Cell[BoxData[
 FractionBox["15", "256"]], "Output",
 CellChangeTimes->{3.749433110454302*^9},
 CellLabel->"Out[15]=",ExpressionUUID->"df8f2685-85c7-4a03-8faa-e33584cde152"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{
   FractionBox["1", 
    RowBox[{"2048", " ", 
     RowBox[{"Gamma", "[", 
      RowBox[{"5", "+", "v"}], "]"}]}]], 
   SqrtBox["\[Pi]"], " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"2048", " ", 
      RowBox[{"(", 
       RowBox[{"1", "+", "v"}], ")"}], " ", 
      RowBox[{"(", 
       RowBox[{"2", "+", "v"}], ")"}], " ", 
      RowBox[{"(", 
       RowBox[{"3", "+", "v"}], ")"}], " ", 
      RowBox[{"(", 
       RowBox[{"4", "+", "v"}], ")"}]}], "-", 
     RowBox[{"1536", " ", 
      RowBox[{"(", 
       RowBox[{"2", "+", "v"}], ")"}], " ", 
      RowBox[{"(", 
       RowBox[{"3", "+", "v"}], ")"}], " ", 
      RowBox[{"(", 
       RowBox[{"4", "+", "v"}], ")"}], " ", "y"}]}], ")"}], 
   RowBox[{"Gamma", "[", 
    RowBox[{
     FractionBox["1", "2"], "+", "v"}], "]"}]}], " ", "/.", " ", 
  RowBox[{"v", " ", "\[Rule]", " ", "2"}]}]], "Input",
 CellChangeTimes->{{3.749433139361936*^9, 3.749433156367485*^9}},
 CellLabel->"In[18]:=",ExpressionUUID->"ac335b75-939b-412a-af03-6ef372cb3ca2"],

Cell[BoxData[
 FractionBox[
  RowBox[{"\[Pi]", " ", 
   RowBox[{"(", 
    RowBox[{"737280", "-", 
     RowBox[{"184320", " ", "y"}]}], ")"}]}], "1966080"]], "Output",
 CellChangeTimes->{{3.749433144486347*^9, 3.749433157021615*^9}},
 CellLabel->"Out[18]=",ExpressionUUID->"e0ebc112-5d6b-4a98-b603-1deed4143407"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"FullSimplify", "[", "%", "]"}]], "Input",
 CellChangeTimes->{{3.7494331453418427`*^9, 3.749433147089672*^9}},
 CellLabel->"In[19]:=",ExpressionUUID->"e1a993f4-c167-48cd-acb8-661a002cafdd"],

Cell[BoxData[
 RowBox[{
  RowBox[{"-", 
   FractionBox["3", "32"]}], " ", "\[Pi]", " ", 
  RowBox[{"(", 
   RowBox[{
    RowBox[{"-", "4"}], "+", "y"}], ")"}]}]], "Output",
 CellChangeTimes->{{3.749433147385689*^9, 3.749433158519435*^9}},
 CellLabel->"Out[19]=",ExpressionUUID->"fc651ea2-9742-4713-a66b-7de682478b81"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{
   FractionBox["1", 
    RowBox[{"2048", " ", 
     RowBox[{"Gamma", "[", 
      RowBox[{"5", "+", "v"}], "]"}]}]], 
   SqrtBox["\[Pi]"], " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"2048", " ", 
      RowBox[{"(", 
       RowBox[{"1", "+", "v"}], ")"}], " ", 
      RowBox[{"(", 
       RowBox[{"2", "+", "v"}], ")"}], " ", 
      RowBox[{"(", 
       RowBox[{"3", "+", "v"}], ")"}], " ", 
      RowBox[{"(", 
       RowBox[{"4", "+", "v"}], ")"}]}], "-", 
     RowBox[{"1536", " ", 
      RowBox[{"(", 
       RowBox[{"2", "+", "v"}], ")"}], " ", 
      RowBox[{"(", 
       RowBox[{"3", "+", "v"}], ")"}], " ", 
      RowBox[{"(", 
       RowBox[{"4", "+", "v"}], ")"}], " ", "y"}]}], ")"}], 
   RowBox[{"Gamma", "[", 
    RowBox[{
     FractionBox["1", "2"], "+", "v"}], "]"}]}], " ", "/.", " ", 
  RowBox[{"v", " ", "\[Rule]", " ", "4"}]}]], "Input",
 CellChangeTimes->{{3.749433254560885*^9, 3.749433254607903*^9}},
 CellLabel->"In[20]:=",ExpressionUUID->"2fd5d2df-aaca-4d68-8753-376ed21c9ede"],

Cell[BoxData[
 FractionBox[
  RowBox[{"\[Pi]", " ", 
   RowBox[{"(", 
    RowBox[{"3440640", "-", 
     RowBox[{"516096", " ", "y"}]}], ")"}]}], "12582912"]], "Output",
 CellChangeTimes->{3.749433254998336*^9},
 CellLabel->"Out[20]=",ExpressionUUID->"bb72c0bc-6fd4-4649-aca0-4675ebc98119"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"FullSimplify", "[", "%", "]"}]], "Input",
 CellChangeTimes->{{3.749433256268189*^9, 3.749433258280895*^9}},
 CellLabel->"In[21]:=",ExpressionUUID->"80df9df6-ada4-44a2-8f24-7d79aff24274"],

Cell[BoxData[
 RowBox[{
  RowBox[{"-", 
   FractionBox["7", "512"]}], " ", "\[Pi]", " ", 
  RowBox[{"(", 
   RowBox[{
    RowBox[{"-", "20"}], "+", 
    RowBox[{"3", " ", "y"}]}], ")"}]}]], "Output",
 CellChangeTimes->{3.749433258547977*^9},
 CellLabel->"Out[21]=",ExpressionUUID->"578e0742-5254-440f-9eaf-4c5f6b9768e5"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{
   FractionBox["1", 
    RowBox[{"2048", " ", 
     RowBox[{"Gamma", "[", 
      RowBox[{"5", "+", "v"}], "]"}]}]], 
   SqrtBox["\[Pi]"], " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"2048", " ", 
      RowBox[{"(", 
       RowBox[{"1", "+", "v"}], ")"}], " ", 
      RowBox[{"(", 
       RowBox[{"2", "+", "v"}], ")"}], " ", 
      RowBox[{"(", 
       RowBox[{"3", "+", "v"}], ")"}], " ", 
      RowBox[{"(", 
       RowBox[{"4", "+", "v"}], ")"}]}], "-", 
     RowBox[{"1536", " ", 
      RowBox[{"(", 
       RowBox[{"2", "+", "v"}], ")"}], " ", 
      RowBox[{"(", 
       RowBox[{"3", "+", "v"}], ")"}], " ", 
      RowBox[{"(", 
       RowBox[{"4", "+", "v"}], ")"}], " ", "y"}]}], ")"}], 
   RowBox[{"Gamma", "[", 
    RowBox[{
     FractionBox["1", "2"], "+", "v"}], "]"}]}], " ", "/.", " ", 
  RowBox[{"v", " ", "\[Rule]", " ", "0"}]}]], "Input",
 CellChangeTimes->{{3.749433322050948*^9, 3.749433322562146*^9}},
 CellLabel->"In[22]:=",ExpressionUUID->"5c0f6199-b634-4845-8397-db0d61920b54"],

Cell[BoxData[
 FractionBox[
  RowBox[{"\[Pi]", " ", 
   RowBox[{"(", 
    RowBox[{"49152", "-", 
     RowBox[{"36864", " ", "y"}]}], ")"}]}], "49152"]], "Output",
 CellChangeTimes->{3.749433322838602*^9},
 CellLabel->"Out[22]=",ExpressionUUID->"6b219443-37fc-45ab-ba86-cf39f548d4ab"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"FullSimplify", "[", "%", "]"}]], "Input",
 CellChangeTimes->{{3.749433324246544*^9, 3.7494333271627483`*^9}},
 CellLabel->"In[23]:=",ExpressionUUID->"9724d489-fb7e-4e87-a8d9-1dbfa88bb54c"],

Cell[BoxData[
 RowBox[{"\[Pi]", "-", 
  FractionBox[
   RowBox[{"3", " ", "\[Pi]", " ", "y"}], "4"]}]], "Output",
 CellChangeTimes->{3.749433327439476*^9},
 CellLabel->"Out[23]=",ExpressionUUID->"fffa31c7-b909-47b4-a75f-42f05f25f53d"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"3", "/", "20"}], "*", 
  RowBox[{"7", "/", "512"}]}]], "Input",
 CellChangeTimes->{{3.749433348138727*^9, 3.7494333508782988`*^9}},
 CellLabel->"In[24]:=",ExpressionUUID->"94f12be1-9a45-48af-8e93-8032b889bd65"],

Cell[BoxData[
 FractionBox["21", "10240"]], "Output",
 CellChangeTimes->{3.7494333512742863`*^9},
 CellLabel->"Out[24]=",ExpressionUUID->"18da4dd4-751d-4f3f-ba34-6670d552bfc5"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"10240", "/", "128"}]], "Input",
 CellChangeTimes->{{3.7494333531305637`*^9, 3.749433375653356*^9}},
 CellLabel->"In[25]:=",ExpressionUUID->"256988de-ad03-4882-96ca-9da2b30c31dd"],

Cell[BoxData["80"], "Output",
 CellChangeTimes->{3.7494333758732653`*^9},
 CellLabel->"Out[25]=",ExpressionUUID->"af3b491e-1022-43ca-bc62-3f8d2052c806"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Integrate", "[", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{"(", 
      RowBox[{"1", "-", 
       RowBox[{"k2", "*", "w"}]}], ")"}], "^", 
     RowBox[{"(", 
      RowBox[{"1", "/", "2"}], ")"}]}], "*", 
    RowBox[{"Sqrt", "[", "w", "]"}], "*", 
    RowBox[{
     RowBox[{"(", 
      RowBox[{"1", "-", "w"}], ")"}], "^", 
     RowBox[{"(", 
      RowBox[{"3", "/", "2"}], ")"}]}]}], ",", 
   RowBox[{"{", 
    RowBox[{"w", ",", "0", ",", 
     RowBox[{"1", "/", "k2"}]}], "}"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.749434189780816*^9, 3.7494342186014547`*^9}, {
  3.749434469294551*^9, 3.7494344826447077`*^9}, {3.749434646685508*^9, 
  3.749434647068465*^9}},
 CellLabel->"In[28]:=",ExpressionUUID->"29e1366d-f95e-4532-bd8f-c37821f6c111"],

Cell[BoxData[
 RowBox[{"ConditionalExpression", "[", 
  RowBox[{
   FractionBox[
    RowBox[{
     RowBox[{"2", " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "1"}], "+", 
        RowBox[{"2", " ", "k2"}]}], ")"}], " ", 
      RowBox[{"(", 
       RowBox[{"8", "+", 
        RowBox[{"3", " ", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"-", "1"}], "+", "k2"}], ")"}], " ", "k2"}]}], ")"}], " ", 
      
      RowBox[{"EllipticE", "[", 
       FractionBox["1", "k2"], "]"}]}], "-", 
     RowBox[{"4", " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "1"}], "+", "k2"}], ")"}], " ", 
      RowBox[{"(", 
       RowBox[{"2", "+", 
        RowBox[{"3", " ", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"-", "1"}], "+", "k2"}], ")"}], " ", "k2"}]}], ")"}], " ", 
      
      RowBox[{"EllipticK", "[", 
       FractionBox["1", "k2"], "]"}]}]}], 
    RowBox[{"105", " ", 
     SuperscriptBox["k2", 
      RowBox[{"5", "/", "2"}]]}]], ",", 
   RowBox[{
    RowBox[{
     RowBox[{"Re", "[", "k2", "]"}], ">", "1"}], "&&", 
    RowBox[{
     RowBox[{"Im", "[", "k2", "]"}], "\[Equal]", "0"}]}]}], "]"}]], "Output",
 CellChangeTimes->{3.749434221864192*^9, 3.7494344859854116`*^9, 
  3.749434656488907*^9},
 CellLabel->"Out[28]=",ExpressionUUID->"e54603d1-0868-4563-ad9e-e370c67a0985"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"FullSimplify", "[", "%", "]"}]], "Input",
 CellChangeTimes->{{3.749434660494649*^9, 3.749434662386445*^9}},
 CellLabel->"In[29]:=",ExpressionUUID->"0adff663-6f44-401a-b142-454ba424bd73"],

Cell[BoxData[
 RowBox[{"ConditionalExpression", "[", 
  RowBox[{
   FractionBox[
    RowBox[{
     RowBox[{"2", " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "1"}], "+", 
        RowBox[{"2", " ", "k2"}]}], ")"}], " ", 
      RowBox[{"(", 
       RowBox[{"8", "+", 
        RowBox[{"3", " ", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"-", "1"}], "+", "k2"}], ")"}], " ", "k2"}]}], ")"}], " ", 
      
      RowBox[{"EllipticE", "[", 
       FractionBox["1", "k2"], "]"}]}], "-", 
     RowBox[{"4", " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "1"}], "+", "k2"}], ")"}], " ", 
      RowBox[{"(", 
       RowBox[{"2", "+", 
        RowBox[{"3", " ", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"-", "1"}], "+", "k2"}], ")"}], " ", "k2"}]}], ")"}], " ", 
      
      RowBox[{"EllipticK", "[", 
       FractionBox["1", "k2"], "]"}]}]}], 
    RowBox[{"105", " ", 
     SuperscriptBox["k2", 
      RowBox[{"5", "/", "2"}]]}]], ",", 
   RowBox[{
    RowBox[{
     RowBox[{"Re", "[", "k2", "]"}], ">", "1"}], "&&", 
    RowBox[{
     RowBox[{"Im", "[", "k2", "]"}], "\[Equal]", "0"}]}]}], "]"}]], "Output",
 CellChangeTimes->{3.749434662971973*^9},
 CellLabel->"Out[29]=",ExpressionUUID->"fe8c171f-4d81-4eea-bf1d-2d4a3c732bf8"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"(", 
    RowBox[{"9", "-", 
     RowBox[{"1", "/", "k2"}]}], ")"}], "*", 
   RowBox[{"2", "/", "15"}], "*", 
   RowBox[{"(", 
    RowBox[{"4", "-", 
     RowBox[{"2", "*", "k2"}]}], ")"}]}], "+", 
  RowBox[{
   RowBox[{"(", 
    RowBox[{"k2", "-", "1"}], ")"}], "*", 
   RowBox[{"2", "/", "3"}], "*", 
   RowBox[{"(", 
    RowBox[{"3", "-", 
     RowBox[{"1", "/", "k2"}]}], ")"}]}]}]], "Input",
 CellChangeTimes->{{3.7494355346416807`*^9, 3.749435549804613*^9}},
 CellLabel->"In[30]:=",ExpressionUUID->"6f0a9d38-5817-4e5a-81aa-0a8ba8817025"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   FractionBox["2", "15"], " ", 
   RowBox[{"(", 
    RowBox[{"9", "-", 
     FractionBox["1", "k2"]}], ")"}], " ", 
   RowBox[{"(", 
    RowBox[{"4", "-", 
     RowBox[{"2", " ", "k2"}]}], ")"}]}], "+", 
  RowBox[{
   FractionBox["2", "3"], " ", 
   RowBox[{"(", 
    RowBox[{"3", "-", 
     FractionBox["1", "k2"]}], ")"}], " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"-", "1"}], "+", "k2"}], ")"}]}]}]], "Output",
 CellChangeTimes->{3.749435550159051*^9},
 CellLabel->"Out[30]=",ExpressionUUID->"85830b46-78f5-439e-b5e6-086d405e4d8b"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Expand", "[", "%", "]"}]], "Input",
 CellChangeTimes->{{3.749435550736917*^9, 3.7494355542926493`*^9}},
 CellLabel->"In[31]:=",ExpressionUUID->"b97ca2a1-e63d-458a-93b2-2138116615ff"],

Cell[BoxData[
 RowBox[{
  FractionBox["12", "5"], "+", 
  FractionBox["2", 
   RowBox[{"15", " ", "k2"}]], "-", 
  FractionBox[
   RowBox[{"2", " ", "k2"}], "5"]}]], "Output",
 CellChangeTimes->{3.749435554574888*^9},
 CellLabel->"Out[31]=",ExpressionUUID->"4d13416e-b0e6-4e38-a3e7-028b4e184ca1"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"FullSimplify", "[", "%", "]"}]], "Input",
 CellChangeTimes->{{3.7494355572401133`*^9, 3.749435559228056*^9}},
 CellLabel->"In[32]:=",ExpressionUUID->"aa464590-2427-4f08-86ce-d302bf7cb2d3"],

Cell[BoxData[
 RowBox[{
  FractionBox["2", "15"], " ", 
  RowBox[{"(", 
   RowBox[{"18", "+", 
    FractionBox["1", "k2"], "-", 
    RowBox[{"3", " ", "k2"}]}], ")"}]}]], "Output",
 CellChangeTimes->{3.7494355595100813`*^9},
 CellLabel->"Out[32]=",ExpressionUUID->"b4583ca5-5ebd-4cfb-ab0d-61e14f717efc"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"(", 
    RowBox[{"4", "-", 
     RowBox[{"2", "/", "k2"}]}], ")"}], "*", 
   RowBox[{"2", "/", "15"}], "*", 
   RowBox[{"(", 
    RowBox[{"6", "-", 
     RowBox[{"2", "/", "k2"}]}], ")"}]}], "+", 
  RowBox[{
   RowBox[{"(", 
    RowBox[{"k2", "-", "1"}], ")"}], "*", 
   RowBox[{"2", "/", "3"}], "*", 
   RowBox[{"(", 
    RowBox[{"3", "-", 
     RowBox[{"2", "/", "k2"}]}], ")"}]}]}]], "Input",
 CellChangeTimes->{{3.749435593334092*^9, 3.749435607200862*^9}},
 CellLabel->"In[33]:=",ExpressionUUID->"4cc6c191-6fda-404b-b314-688d42d24e47"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   FractionBox["2", "15"], " ", 
   RowBox[{"(", 
    RowBox[{"4", "-", 
     FractionBox["2", "k2"]}], ")"}], " ", 
   RowBox[{"(", 
    RowBox[{"6", "-", 
     FractionBox["2", "k2"]}], ")"}]}], "+", 
  RowBox[{
   FractionBox["2", "3"], " ", 
   RowBox[{"(", 
    RowBox[{"3", "-", 
     FractionBox["2", "k2"]}], ")"}], " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"-", "1"}], "+", "k2"}], ")"}]}]}]], "Output",
 CellChangeTimes->{3.749435607598333*^9},
 CellLabel->"Out[33]=",ExpressionUUID->"2604f9bf-f8b9-4218-a989-0c113434a47d"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"FullSimplify", "[", "%", "]"}]], "Input",
 CellChangeTimes->{{3.7494356084050827`*^9, 3.749435612576735*^9}},
 CellLabel->"In[34]:=",ExpressionUUID->"b8a8fef4-3e2a-408f-8246-3d58dcbca726"],

Cell[BoxData[
 RowBox[{
  FractionBox["2", "15"], " ", 
  RowBox[{"(", 
   RowBox[{
    RowBox[{"-", "1"}], "+", 
    FractionBox["4", 
     SuperscriptBox["k2", "2"]], "-", 
    FractionBox["10", "k2"], "+", 
    RowBox[{"15", " ", "k2"}]}], ")"}]}]], "Output",
 CellChangeTimes->{3.749435612859664*^9},
 CellLabel->"Out[34]=",ExpressionUUID->"93d34d55-4a99-47c0-844f-dd1c693f19f8"]
}, Open  ]]
},
WindowSize->{812, 436},
WindowMargins->{{-4, Automatic}, {Automatic, 1}},
FrontEndVersion->"11.3 for Mac OS X x86 (32-bit, 64-bit Kernel) (March 5, \
2018)",
StyleDefinitions->"Default.nb"
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[558, 20, 401, 12, 52, "Input",ExpressionUUID->"89f66477-fed4-49b8-aaa3-b709745f05a0"],
Cell[CellGroupData[{
Cell[984, 36, 687, 19, 30, "Input",ExpressionUUID->"8fae422d-7ee1-4bd2-bd71-5bbfa1fccc9a"],
Cell[1674, 57, 1092, 33, 112, "Output",ExpressionUUID->"a9c8e0ba-ea1f-463f-bfdb-b62274b6cde6"]
}, Open  ]],
Cell[2781, 93, 410, 11, 30, "Input",ExpressionUUID->"c457c7a1-f0de-47fc-a95e-8135e308841b"],
Cell[CellGroupData[{
Cell[3216, 108, 653, 19, 30, "Input",ExpressionUUID->"476d81a6-eaf8-4d26-96d8-68df3ade62be"],
Cell[3872, 129, 1036, 32, 83, "Output",ExpressionUUID->"57c5b519-c12c-4291-a1b8-62bd612e6a14"]
}, Open  ]],
Cell[CellGroupData[{
Cell[4945, 166, 570, 13, 30, "Input",ExpressionUUID->"17f12f75-6346-4717-bc7f-68f8c10adb2c"],
Cell[5518, 181, 767, 22, 34, "Output",ExpressionUUID->"be3532df-5afd-497b-9038-5201516e511d"]
}, Open  ]],
Cell[CellGroupData[{
Cell[6322, 208, 538, 16, 30, "Input",ExpressionUUID->"64294194-390a-44b8-91a3-da928d71d2e6"],
Cell[6863, 226, 536, 17, 51, "Output",ExpressionUUID->"ae0918cc-ed3a-48a3-9c58-11f389ad5d09"]
}, Open  ]],
Cell[CellGroupData[{
Cell[7436, 248, 212, 3, 30, "Input",ExpressionUUID->"d5d994e7-2898-45d9-a9fa-64297c581e6e"],
Cell[7651, 253, 385, 12, 51, "Output",ExpressionUUID->"d6fda8b4-c3a6-4946-953a-d2b7799f3e7b"]
}, Open  ]],
Cell[8051, 268, 379, 9, 30, "Input",ExpressionUUID->"0c3aa25d-dad6-48fa-9757-8d22469cf186"],
Cell[CellGroupData[{
Cell[8455, 281, 622, 18, 30, "Input",ExpressionUUID->"9be7d430-05e6-45df-b8a5-081efa414cf2"],
Cell[9080, 301, 927, 28, 87, "Output",ExpressionUUID->"5d76c865-94d2-40ee-ac1d-99ea81b2f028"]
}, Open  ]],
Cell[10022, 332, 360, 10, 30, "Input",ExpressionUUID->"e493a91f-7832-42f3-b405-bbbb5b1ba8bc"],
Cell[CellGroupData[{
Cell[10407, 346, 598, 17, 30, "Input",ExpressionUUID->"e00f0fbf-d789-4552-8b0e-abd73a9d52e7"],
Cell[11008, 365, 1200, 36, 87, "Output",ExpressionUUID->"290e7390-5823-4425-9992-ba5caae955dc"]
}, Open  ]],
Cell[12223, 404, 360, 10, 30, "Input",ExpressionUUID->"f84d77c2-376e-4107-b5cc-d1f9042479e4"],
Cell[CellGroupData[{
Cell[12608, 418, 1151, 34, 52, "Input",ExpressionUUID->"41a4af89-b525-4882-854c-177f48380763"],
Cell[13762, 454, 2181, 66, 135, "Output",ExpressionUUID->"5da7a688-de39-49e3-ac35-32041bb2630c"]
}, Open  ]],
Cell[CellGroupData[{
Cell[15980, 525, 210, 3, 30, "Input",ExpressionUUID->"18ca87ca-c6bc-47bb-9b55-2c0add930d71"],
Cell[16193, 530, 1337, 42, 117, "Output",ExpressionUUID->"9897d439-73d0-4422-98db-a64a05522a48"]
}, Open  ]],
Cell[CellGroupData[{
Cell[17567, 577, 1038, 32, 55, "Input",ExpressionUUID->"e44c1d90-9de6-4b6f-bb15-948aeb4e249a"],
Cell[18608, 611, 952, 31, 58, "Output",ExpressionUUID->"04121c08-af75-4761-88b8-6984dc468e0c"]
}, Open  ]],
Cell[CellGroupData[{
Cell[19597, 647, 916, 27, 55, "Input",ExpressionUUID->"2cd1e7e8-255d-4890-aecf-98297a8aebe5"],
Cell[20516, 676, 834, 26, 58, "Output",ExpressionUUID->"bb29363c-fad5-46a0-a084-653aad7607ac"]
}, Open  ]],
Cell[CellGroupData[{
Cell[21387, 707, 673, 20, 55, "Input",ExpressionUUID->"2cf7a01f-f42c-4893-9523-d947212baf6c"],
Cell[22063, 729, 597, 18, 58, "Output",ExpressionUUID->"97f0cb5e-986a-4f45-9daa-548ecd4d0632"]
}, Open  ]],
Cell[CellGroupData[{
Cell[22697, 752, 813, 19, 30, "Input",ExpressionUUID->"e180265f-5d56-42fd-8e1b-607a6aa515a3"],
Cell[23513, 773, 2775, 87, 167, "Output",ExpressionUUID->"b0561121-2f5f-4659-be96-3b35e5a283d3"]
}, Open  ]],
Cell[CellGroupData[{
Cell[26325, 865, 210, 3, 30, "Input",ExpressionUUID->"6587fb02-7ba8-4d5c-b76e-93500aac365a"],
Cell[26538, 870, 298, 5, 34, "Output",ExpressionUUID->"081de116-8af6-48b7-9a7f-b033d7523cfa"]
}, Open  ]],
Cell[26851, 878, 155, 3, 30, "Input",ExpressionUUID->"1f8beb3f-cc1f-45b7-bc68-f0f4dbdbb080"],
Cell[CellGroupData[{
Cell[27031, 885, 464, 13, 30, "Input",ExpressionUUID->"50a32cea-5767-424d-b358-a063834ab98c"],
Cell[27498, 900, 439, 12, 38, "Output",ExpressionUUID->"ea1b08a2-a6d9-4493-b19b-853c4b63d697"]
}, Open  ]],
Cell[CellGroupData[{
Cell[27974, 917, 318, 8, 30, "Input",ExpressionUUID->"09bce8f5-9b4e-43f2-87e4-b384b0271711"],
Cell[28295, 927, 312, 9, 51, "Output",ExpressionUUID->"2f8eb468-b564-4a11-84b2-955a51de427b"]
}, Open  ]],
Cell[CellGroupData[{
Cell[28644, 941, 212, 3, 30, "Input",ExpressionUUID->"6f819485-a01e-443e-b317-94906175ac08"],
Cell[28859, 946, 264, 7, 51, "Output",ExpressionUUID->"aaf4707c-4552-442b-801e-4093337c066c"]
}, Open  ]],
Cell[CellGroupData[{
Cell[29160, 958, 471, 13, 30, "Input",ExpressionUUID->"d291dd0e-013d-430a-b22d-2bee2992c5ac"],
Cell[29634, 973, 534, 16, 60, "Output",ExpressionUUID->"a844cbf4-5ef7-4448-9c66-b3579beb6801"]
}, Open  ]],
Cell[CellGroupData[{
Cell[30205, 994, 472, 13, 30, "Input",ExpressionUUID->"95dfbe70-528c-4bfa-987d-9061fe32bcf1"],
Cell[30680, 1009, 537, 17, 60, "Output",ExpressionUUID->"8a61f81d-66e7-4347-8297-69908fe1a7e5"]
}, Open  ]],
Cell[CellGroupData[{
Cell[31254, 1031, 642, 18, 30, "Input",ExpressionUUID->"bcf4fc25-d7d6-4310-820c-33302d8c6b99"],
Cell[31899, 1051, 36640, 621, 245, "Output",ExpressionUUID->"c7344a7e-52ea-4df7-a39f-91140a7fa190"]
}, Open  ]],
Cell[CellGroupData[{
Cell[68576, 1677, 438, 12, 30, "Input",ExpressionUUID->"e1c3fc84-6063-4787-8f39-7be4a87ed8ed"],
Cell[69017, 1691, 979, 28, 54, "Output",ExpressionUUID->"f9eb7796-409f-4b28-bc18-ebd424027f51"]
}, Open  ]],
Cell[CellGroupData[{
Cell[70033, 1724, 1042, 31, 53, "Input",ExpressionUUID->"474e1945-44c9-487c-b7fe-f7bf5104c0c4"],
Cell[71078, 1757, 1599, 48, 114, "Output",ExpressionUUID->"ac9e3886-eadd-4b48-87ec-203dc6f772bb"]
}, Open  ]],
Cell[CellGroupData[{
Cell[72714, 1810, 213, 3, 30, "Input",ExpressionUUID->"df2b3f67-f47b-429c-8932-1448214e5407"],
Cell[72930, 1815, 1599, 48, 114, "Output",ExpressionUUID->"cb55398f-c596-4e15-bbf1-04f206c7410f"]
}, Open  ]],
Cell[74544, 1866, 180, 4, 30, "Input",ExpressionUUID->"dff28f46-534c-438c-a37c-116ccfccc5e5"],
Cell[CellGroupData[{
Cell[74749, 1874, 1439, 43, 111, "Input",ExpressionUUID->"7f27b2e2-d56b-453a-b729-9fca237be955"],
Cell[76191, 1919, 483, 13, 56, "Output",ExpressionUUID->"3e419626-f7db-4121-ad3b-e45f8d11d967"]
}, Open  ]],
Cell[CellGroupData[{
Cell[76711, 1937, 211, 3, 30, "Input",ExpressionUUID->"decf82ca-9996-4ff4-930f-dd5feb41daba"],
Cell[76925, 1942, 557, 17, 57, "Output",ExpressionUUID->"98e89b1a-f0af-4e32-9351-17daa9a90071"]
}, Open  ]],
Cell[CellGroupData[{
Cell[77519, 1964, 1439, 43, 111, "Input",ExpressionUUID->"a65563ac-91a5-4b8e-a868-f05d3ba98f33"],
Cell[78961, 2009, 485, 13, 56, "Output",ExpressionUUID->"512331a8-5fc4-4693-beeb-884bb5c9b3b9"]
}, Open  ]],
Cell[CellGroupData[{
Cell[79483, 2027, 209, 3, 30, "Input",ExpressionUUID->"279291db-d396-4a3b-893b-efa251c95f3c"],
Cell[79695, 2032, 552, 17, 51, "Output",ExpressionUUID->"d9fc9319-4d3f-4558-b591-262c8a449e4e"]
}, Open  ]],
Cell[CellGroupData[{
Cell[80284, 2054, 1439, 43, 111, "Input",ExpressionUUID->"0e93eddc-f1e9-449b-a998-904e2c57772c"],
Cell[81726, 2099, 489, 13, 56, "Output",ExpressionUUID->"c767cd8e-770c-412b-8e48-a2be931523ce"]
}, Open  ]],
Cell[CellGroupData[{
Cell[82252, 2117, 210, 3, 30, "Input",ExpressionUUID->"fda7f5a4-aea0-44ee-9d10-8eead7cfd601"],
Cell[82465, 2122, 587, 18, 51, "Output",ExpressionUUID->"930dce5c-0e9f-45b4-a6b0-159463f9b988"]
}, Open  ]],
Cell[CellGroupData[{
Cell[83089, 2145, 203, 3, 30, "Input",ExpressionUUID->"b2af9719-2355-442f-9655-dad337ce212e"],
Cell[83295, 2150, 170, 3, 51, "Output",ExpressionUUID->"22e3a7a7-ce82-4404-93b2-9c791806516b"]
}, Open  ]],
Cell[CellGroupData[{
Cell[83502, 2158, 206, 3, 30, "Input",ExpressionUUID->"edfee580-4edc-46a6-8279-fda07ba5d4b2"],
Cell[83711, 2163, 170, 3, 51, "Output",ExpressionUUID->"2609873e-006e-4179-9248-a6ce869276fe"]
}, Open  ]],
Cell[CellGroupData[{
Cell[83918, 2171, 1438, 43, 111, "Input",ExpressionUUID->"a07df9d2-0b54-461b-b433-73fdf8522f6c"],
Cell[85359, 2216, 488, 13, 56, "Output",ExpressionUUID->"368cdc74-8262-4fe7-a8ee-e4272f54b4be"]
}, Open  ]],
Cell[CellGroupData[{
Cell[85884, 2234, 206, 3, 30, "Input",ExpressionUUID->"31e59bfc-aaef-4340-b33d-64ff82457e04"],
Cell[86093, 2239, 170, 3, 51, "Output",ExpressionUUID->"f8e54489-95bd-4ba8-8bb4-b6f902372144"]
}, Open  ]],
Cell[CellGroupData[{
Cell[86300, 2247, 207, 3, 30, "Input",ExpressionUUID->"2917ba9f-af22-4b76-8624-2e78e194bbd9"],
Cell[86510, 2252, 172, 3, 51, "Output",ExpressionUUID->"df8f2685-85c7-4a03-8faa-e33584cde152"]
}, Open  ]],
Cell[CellGroupData[{
Cell[86719, 2260, 1040, 31, 88, "Input",ExpressionUUID->"ac335b75-939b-412a-af03-6ef372cb3ca2"],
Cell[87762, 2293, 311, 7, 51, "Output",ExpressionUUID->"e0ebc112-5d6b-4a98-b603-1deed4143407"]
}, Open  ]],
Cell[CellGroupData[{
Cell[88110, 2305, 212, 3, 30, "Input",ExpressionUUID->"e1a993f4-c167-48cd-acb8-661a002cafdd"],
Cell[88325, 2310, 317, 8, 51, "Output",ExpressionUUID->"fc651ea2-9742-4713-a66b-7de682478b81"]
}, Open  ]],
Cell[CellGroupData[{
Cell[88679, 2323, 1040, 31, 88, "Input",ExpressionUUID->"2fd5d2df-aaca-4d68-8753-376ed21c9ede"],
Cell[89722, 2356, 289, 7, 51, "Output",ExpressionUUID->"bb72c0bc-6fd4-4649-aca0-4675ebc98119"]
}, Open  ]],
Cell[CellGroupData[{
Cell[90048, 2368, 210, 3, 30, "Input",ExpressionUUID->"80df9df6-ada4-44a2-8f24-7d79aff24274"],
Cell[90261, 2373, 320, 9, 51, "Output",ExpressionUUID->"578e0742-5254-440f-9eaf-4c5f6b9768e5"]
}, Open  ]],
Cell[CellGroupData[{
Cell[90618, 2387, 1040, 31, 88, "Input",ExpressionUUID->"5c0f6199-b634-4845-8397-db0d61920b54"],
Cell[91661, 2420, 283, 7, 51, "Output",ExpressionUUID->"6b219443-37fc-45ab-ba86-cf39f548d4ab"]
}, Open  ]],
Cell[CellGroupData[{
Cell[91981, 2432, 212, 3, 30, "Input",ExpressionUUID->"9724d489-fb7e-4e87-a8d9-1dbfa88bb54c"],
Cell[92196, 2437, 234, 5, 50, "Output",ExpressionUUID->"fffa31c7-b909-47b4-a75f-42f05f25f53d"]
}, Open  ]],
Cell[CellGroupData[{
Cell[92467, 2447, 245, 5, 30, "Input",ExpressionUUID->"94f12be1-9a45-48af-8e93-8032b889bd65"],
Cell[92715, 2454, 176, 3, 51, "Output",ExpressionUUID->"18da4dd4-751d-4f3f-ba34-6670d552bfc5"]
}, Open  ]],
Cell[CellGroupData[{
Cell[92928, 2462, 202, 3, 30, "Input",ExpressionUUID->"256988de-ad03-4882-96ca-9da2b30c31dd"],
Cell[93133, 2467, 152, 2, 34, "Output",ExpressionUUID->"af3b491e-1022-43ca-bc62-3f8d2052c806"]
}, Open  ]],
Cell[CellGroupData[{
Cell[93322, 2474, 776, 22, 30, "Input",ExpressionUUID->"29e1366d-f95e-4532-bd8f-c37821f6c111"],
Cell[94101, 2498, 1342, 42, 120, "Output",ExpressionUUID->"e54603d1-0868-4563-ad9e-e370c67a0985"]
}, Open  ]],
Cell[CellGroupData[{
Cell[95480, 2545, 210, 3, 30, "Input",ExpressionUUID->"0adff663-6f44-401a-b142-454ba424bd73"],
Cell[95693, 2550, 1293, 41, 120, "Output",ExpressionUUID->"fe8c171f-4d81-4eea-bf1d-2d4a3c732bf8"]
}, Open  ]],
Cell[CellGroupData[{
Cell[97023, 2596, 589, 18, 30, "Input",ExpressionUUID->"6f0a9d38-5817-4e5a-81aa-0a8ba8817025"],
Cell[97615, 2616, 577, 19, 51, "Output",ExpressionUUID->"85830b46-78f5-439e-b5e6-086d405e4d8b"]
}, Open  ]],
Cell[CellGroupData[{
Cell[98229, 2640, 206, 3, 30, "Input",ExpressionUUID->"b97ca2a1-e63d-458a-93b2-2138116615ff"],
Cell[98438, 2645, 296, 8, 52, "Output",ExpressionUUID->"4d13416e-b0e6-4e38-a3e7-028b4e184ca1"]
}, Open  ]],
Cell[CellGroupData[{
Cell[98771, 2658, 212, 3, 30, "Input",ExpressionUUID->"aa464590-2427-4f08-86ce-d302bf7cb2d3"],
Cell[98986, 2663, 303, 8, 51, "Output",ExpressionUUID->"b4583ca5-5ebd-4cfb-ab0d-61e14f717efc"]
}, Open  ]],
Cell[CellGroupData[{
Cell[99326, 2676, 587, 18, 30, "Input",ExpressionUUID->"4cc6c191-6fda-404b-b314-688d42d24e47"],
Cell[99916, 2696, 575, 19, 51, "Output",ExpressionUUID->"2604f9bf-f8b9-4218-a989-0c113434a47d"]
}, Open  ]],
Cell[CellGroupData[{
Cell[100528, 2720, 212, 3, 30, "Input",ExpressionUUID->"b8a8fef4-3e2a-408f-8246-3d58dcbca726"],
Cell[100743, 2725, 383, 11, 51, "Output",ExpressionUUID->"93d34d55-4a99-47c0-844f-dd1c693f19f8"]
}, Open  ]]
}
]
*)

