(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 11.3' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       158,          7]
NotebookDataLength[    345320,       8025]
NotebookOptionsPosition[    340293,       7927]
NotebookOutlinePosition[    340647,       7943]
CellTagsIndexPosition[    340604,       7940]
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{

Cell[CellGroupData[{
Cell[BoxData[
 RowBox[{"TrigExpand", "[", 
  RowBox[{"Sin", "[", 
   RowBox[{"2", "*", 
    RowBox[{"(", 
     RowBox[{"f", "+", "omega"}], ")"}]}], "]"}], "]"}]], "Input",
 CellChangeTimes->{{3.754071206956545*^9, 3.754071215760132*^9}},
 CellLabel->"In[5]:=",ExpressionUUID->"8ae2cdd8-4057-4693-a49d-3635cd58677f"],

Cell[BoxData[
 RowBox[{
  RowBox[{"2", " ", 
   RowBox[{"Cos", "[", "f", "]"}], " ", 
   SuperscriptBox[
    RowBox[{"Cos", "[", "omega", "]"}], "2"], " ", 
   RowBox[{"Sin", "[", "f", "]"}]}], "+", 
  RowBox[{"2", " ", 
   SuperscriptBox[
    RowBox[{"Cos", "[", "f", "]"}], "2"], " ", 
   RowBox[{"Cos", "[", "omega", "]"}], " ", 
   RowBox[{"Sin", "[", "omega", "]"}]}], "-", 
  RowBox[{"2", " ", 
   RowBox[{"Cos", "[", "omega", "]"}], " ", 
   SuperscriptBox[
    RowBox[{"Sin", "[", "f", "]"}], "2"], " ", 
   RowBox[{"Sin", "[", "omega", "]"}]}], "-", 
  RowBox[{"2", " ", 
   RowBox[{"Cos", "[", "f", "]"}], " ", 
   RowBox[{"Sin", "[", "f", "]"}], " ", 
   SuperscriptBox[
    RowBox[{"Sin", "[", "omega", "]"}], "2"]}]}]], "Output",
 CellChangeTimes->{3.754071216105063*^9},
 CellLabel->"Out[5]=",ExpressionUUID->"5bdeea1d-fcc4-40d1-b164-a9191765ff63"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"FullSimplify", "[", "%", "]"}]], "Input",
 CellChangeTimes->{{3.754071217444983*^9, 3.7540712219338837`*^9}},
 CellLabel->"In[6]:=",ExpressionUUID->"858cee10-8696-4b18-88a7-de60ffab86ae"],

Cell[BoxData[
 RowBox[{"Sin", "[", 
  RowBox[{"2", " ", 
   RowBox[{"(", 
    RowBox[{"f", "+", "omega"}], ")"}]}], "]"}]], "Output",
 CellChangeTimes->{3.754071222167074*^9},
 CellLabel->"Out[6]=",ExpressionUUID->"42356495-a8f5-4eb3-97b4-2b51217460c1"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"TrigExpand", "[", 
  RowBox[{
   RowBox[{"Sin", "[", 
    RowBox[{"f", "+", "omega"}], "]"}], "^", "2"}], "]"}]], "Input",
 CellChangeTimes->{{3.754071233692266*^9, 3.754071241045335*^9}},
 CellLabel->"In[7]:=",ExpressionUUID->"cb0e16bb-3800-4489-ad21-7fdfdeacb54e"],

Cell[BoxData[
 RowBox[{
  FractionBox["1", "2"], "-", 
  RowBox[{
   FractionBox["1", "2"], " ", 
   SuperscriptBox[
    RowBox[{"Cos", "[", "f", "]"}], "2"], " ", 
   SuperscriptBox[
    RowBox[{"Cos", "[", "omega", "]"}], "2"]}], "+", 
  RowBox[{
   FractionBox["1", "2"], " ", 
   SuperscriptBox[
    RowBox[{"Cos", "[", "omega", "]"}], "2"], " ", 
   SuperscriptBox[
    RowBox[{"Sin", "[", "f", "]"}], "2"]}], "+", 
  RowBox[{"2", " ", 
   RowBox[{"Cos", "[", "f", "]"}], " ", 
   RowBox[{"Cos", "[", "omega", "]"}], " ", 
   RowBox[{"Sin", "[", "f", "]"}], " ", 
   RowBox[{"Sin", "[", "omega", "]"}]}], "+", 
  RowBox[{
   FractionBox["1", "2"], " ", 
   SuperscriptBox[
    RowBox[{"Cos", "[", "f", "]"}], "2"], " ", 
   SuperscriptBox[
    RowBox[{"Sin", "[", "omega", "]"}], "2"]}], "-", 
  RowBox[{
   FractionBox["1", "2"], " ", 
   SuperscriptBox[
    RowBox[{"Sin", "[", "f", "]"}], "2"], " ", 
   SuperscriptBox[
    RowBox[{"Sin", "[", "omega", "]"}], "2"]}]}]], "Output",
 CellChangeTimes->{3.754071241436616*^9},
 CellLabel->"Out[7]=",ExpressionUUID->"c92ff2f3-1997-40bb-b85e-83380d3a55cc"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"TrigExpand", "[", 
  RowBox[{
   RowBox[{"ecc", "*", 
    RowBox[{"Sin", "[", "f", "]"}], 
    RowBox[{"(", 
     RowBox[{"1", "-", 
      RowBox[{
       RowBox[{"si", "^", "2"}], "*", 
       RowBox[{
        RowBox[{"Sin", "[", 
         RowBox[{"f", "+", "omega"}], "]"}], "^", "2"}]}]}], ")"}]}], "-", 
   RowBox[{
    RowBox[{"si", "^", "2"}], "*", 
    RowBox[{"Sin", "[", 
     RowBox[{"2", "*", 
      RowBox[{"(", 
       RowBox[{"f", "+", "omega"}], ")"}]}], "]"}], "*", 
    RowBox[{"(", 
     RowBox[{"1", "+", 
      RowBox[{"ecc", "*", 
       RowBox[{"Cos", "[", "f", "]"}]}]}], ")"}]}]}], "]"}]], "Input",
 CellChangeTimes->{{3.754071323185912*^9, 3.754071362042074*^9}},
 CellLabel->"In[8]:=",ExpressionUUID->"c96a54e4-94b9-44b2-a517-e5829bf4f4bd"],

Cell[BoxData[
 RowBox[{
  RowBox[{"ecc", " ", 
   RowBox[{"Sin", "[", "f", "]"}]}], "-", 
  RowBox[{
   FractionBox["1", "2"], " ", "ecc", " ", 
   SuperscriptBox["si", "2"], " ", 
   RowBox[{"Sin", "[", "f", "]"}]}], "-", 
  RowBox[{
   FractionBox["3", "4"], " ", "ecc", " ", 
   SuperscriptBox["si", "2"], " ", 
   SuperscriptBox[
    RowBox[{"Cos", "[", "omega", "]"}], "2"], " ", 
   RowBox[{"Sin", "[", "f", "]"}]}], "-", 
  RowBox[{"2", " ", 
   SuperscriptBox["si", "2"], " ", 
   RowBox[{"Cos", "[", "f", "]"}], " ", 
   SuperscriptBox[
    RowBox[{"Cos", "[", "omega", "]"}], "2"], " ", 
   RowBox[{"Sin", "[", "f", "]"}]}], "-", 
  RowBox[{
   FractionBox["3", "4"], " ", "ecc", " ", 
   SuperscriptBox["si", "2"], " ", 
   SuperscriptBox[
    RowBox[{"Cos", "[", "f", "]"}], "2"], " ", 
   SuperscriptBox[
    RowBox[{"Cos", "[", "omega", "]"}], "2"], " ", 
   RowBox[{"Sin", "[", "f", "]"}]}], "+", 
  RowBox[{
   FractionBox["1", "4"], " ", "ecc", " ", 
   SuperscriptBox["si", "2"], " ", 
   SuperscriptBox[
    RowBox[{"Cos", "[", "omega", "]"}], "2"], " ", 
   SuperscriptBox[
    RowBox[{"Sin", "[", "f", "]"}], "3"]}], "-", 
  RowBox[{
   FractionBox["3", "2"], " ", "ecc", " ", 
   SuperscriptBox["si", "2"], " ", 
   RowBox[{"Cos", "[", "f", "]"}], " ", 
   RowBox[{"Cos", "[", "omega", "]"}], " ", 
   RowBox[{"Sin", "[", "omega", "]"}]}], "-", 
  RowBox[{"2", " ", 
   SuperscriptBox["si", "2"], " ", 
   SuperscriptBox[
    RowBox[{"Cos", "[", "f", "]"}], "2"], " ", 
   RowBox[{"Cos", "[", "omega", "]"}], " ", 
   RowBox[{"Sin", "[", "omega", "]"}]}], "-", 
  RowBox[{
   FractionBox["1", "2"], " ", "ecc", " ", 
   SuperscriptBox["si", "2"], " ", 
   SuperscriptBox[
    RowBox[{"Cos", "[", "f", "]"}], "3"], " ", 
   RowBox[{"Cos", "[", "omega", "]"}], " ", 
   RowBox[{"Sin", "[", "omega", "]"}]}], "+", 
  RowBox[{"2", " ", 
   SuperscriptBox["si", "2"], " ", 
   RowBox[{"Cos", "[", "omega", "]"}], " ", 
   SuperscriptBox[
    RowBox[{"Sin", "[", "f", "]"}], "2"], " ", 
   RowBox[{"Sin", "[", "omega", "]"}]}], "+", 
  RowBox[{
   FractionBox["3", "2"], " ", "ecc", " ", 
   SuperscriptBox["si", "2"], " ", 
   RowBox[{"Cos", "[", "f", "]"}], " ", 
   RowBox[{"Cos", "[", "omega", "]"}], " ", 
   SuperscriptBox[
    RowBox[{"Sin", "[", "f", "]"}], "2"], " ", 
   RowBox[{"Sin", "[", "omega", "]"}]}], "+", 
  RowBox[{
   FractionBox["3", "4"], " ", "ecc", " ", 
   SuperscriptBox["si", "2"], " ", 
   RowBox[{"Sin", "[", "f", "]"}], " ", 
   SuperscriptBox[
    RowBox[{"Sin", "[", "omega", "]"}], "2"]}], "+", 
  RowBox[{"2", " ", 
   SuperscriptBox["si", "2"], " ", 
   RowBox[{"Cos", "[", "f", "]"}], " ", 
   RowBox[{"Sin", "[", "f", "]"}], " ", 
   SuperscriptBox[
    RowBox[{"Sin", "[", "omega", "]"}], "2"]}], "+", 
  RowBox[{
   FractionBox["3", "4"], " ", "ecc", " ", 
   SuperscriptBox["si", "2"], " ", 
   SuperscriptBox[
    RowBox[{"Cos", "[", "f", "]"}], "2"], " ", 
   RowBox[{"Sin", "[", "f", "]"}], " ", 
   SuperscriptBox[
    RowBox[{"Sin", "[", "omega", "]"}], "2"]}], "-", 
  RowBox[{
   FractionBox["1", "4"], " ", "ecc", " ", 
   SuperscriptBox["si", "2"], " ", 
   SuperscriptBox[
    RowBox[{"Sin", "[", "f", "]"}], "3"], " ", 
   SuperscriptBox[
    RowBox[{"Sin", "[", "omega", "]"}], "2"]}]}]], "Output",
 CellChangeTimes->{3.7540713631069736`*^9},
 CellLabel->"Out[8]=",ExpressionUUID->"732eafa2-a62b-416f-9606-b665f3fc0f64"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"FullSimplify", "[", "%", "]"}]], "Input",
 CellChangeTimes->{{3.754071365984779*^9, 3.754071367578382*^9}},
 CellLabel->"In[9]:=",ExpressionUUID->"6d625a42-2375-4558-bd2a-4b1760af137f"],

Cell[BoxData[
 RowBox[{
  FractionBox["1", "4"], " ", 
  RowBox[{"(", 
   RowBox[{
    RowBox[{
     RowBox[{"-", "2"}], " ", "ecc", " ", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"-", "2"}], "+", 
       SuperscriptBox["si", "2"]}], ")"}], " ", 
     RowBox[{"Sin", "[", "f", "]"}]}], "-", 
    RowBox[{
     SuperscriptBox["si", "2"], " ", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"4", " ", 
        RowBox[{"Sin", "[", 
         RowBox[{"2", " ", 
          RowBox[{"(", 
           RowBox[{"f", "+", "omega"}], ")"}]}], "]"}]}], "+", 
       RowBox[{"ecc", " ", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"3", " ", 
           RowBox[{"Sin", "[", 
            RowBox[{"f", "+", 
             RowBox[{"2", " ", "omega"}]}], "]"}]}], "+", 
          RowBox[{"Sin", "[", 
           RowBox[{
            RowBox[{"3", " ", "f"}], "+", 
            RowBox[{"2", " ", "omega"}]}], "]"}]}], ")"}]}]}], ")"}]}]}], 
   ")"}]}]], "Output",
 CellChangeTimes->{3.754071368234618*^9},
 CellLabel->"Out[9]=",ExpressionUUID->"26518906-3ac9-4fac-b262-f5e9549d2623"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Solve", "[", 
  RowBox[{
   RowBox[{
    RowBox[{"Out", "[", "9", "]"}], " ", "\[Equal]", "0"}], ",", "f"}], 
  "]"}]], "Input",
 CellChangeTimes->{{3.7540715916731*^9, 3.754071597944725*^9}},
 CellLabel->"In[10]:=",ExpressionUUID->"4e9cf2de-7959-4c16-8388-e143811a708b"],

Cell[BoxData[
 TemplateBox[{
  "Solve","ifun",
   "\"Inverse functions are being used by \
\\!\\(\\*RowBox[{\\\"Solve\\\"}]\\), so some solutions may not be found; use \
Reduce for complete solution information.\"",2,10,2,25571763906033481186,
   "Local"},
  "MessageTemplate"]], "Message", "MSG",
 CellChangeTimes->{3.754071600432156*^9},
 CellLabel->
  "During evaluation of \
In[10]:=",ExpressionUUID->"580cb522-d086-420c-b40c-5837b407bbd2"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Sin", "[", "f", "]"}], "*", 
   RowBox[{"Sin", "[", 
    RowBox[{"f", "+", "omega"}], "]"}]}], "+", 
  RowBox[{
   RowBox[{"Cos", "[", "f", "]"}], "*", 
   RowBox[{"Cos", "[", 
    RowBox[{"f", "+", "omega"}], "]"}]}]}]], "Input",
 CellChangeTimes->{{3.7540726437565823`*^9, 3.7540726480452433`*^9}, {
  3.754073000265273*^9, 3.754073012890504*^9}},
 CellLabel->"In[12]:=",ExpressionUUID->"ed1d97ab-8ff5-4b1e-b29e-b9a2f8e26759"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Cos", "[", "f", "]"}], " ", 
   RowBox[{"Cos", "[", 
    RowBox[{"f", "+", "omega"}], "]"}]}], "+", 
  RowBox[{
   RowBox[{"Sin", "[", "f", "]"}], " ", 
   RowBox[{"Sin", "[", 
    RowBox[{"f", "+", "omega"}], "]"}]}]}]], "Output",
 CellChangeTimes->{3.754073013214387*^9},
 CellLabel->"Out[12]=",ExpressionUUID->"89e506fa-160c-4379-8f7b-ca832aa6d63c"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"TrigReduce", "[", "%", "]"}]], "Input",
 CellChangeTimes->{{3.7540730137427483`*^9, 3.754073021585799*^9}},
 CellLabel->"In[13]:=",ExpressionUUID->"71520c40-265f-470c-97a5-7b592c512abe"],

Cell[BoxData[
 RowBox[{"Cos", "[", "omega", "]"}]], "Output",
 CellChangeTimes->{3.754073021849637*^9},
 CellLabel->"Out[13]=",ExpressionUUID->"a19302c7-5c04-4c50-ad0a-6371c24cdb8e"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"ecc", "*", 
   RowBox[{"Sin", "[", "f", "]"}]}], "-", 
  RowBox[{"ecc", "*", 
   RowBox[{"si", "^", "2"}], "*", 
   RowBox[{"Sin", "[", 
    RowBox[{"f", "+", "omega"}], "]"}], "*", 
   RowBox[{"Cos", "[", "omega", "]"}]}], "-", 
  RowBox[{
   RowBox[{"si", "^", "2"}], "*", 
   RowBox[{"Sin", "[", 
    RowBox[{"2", "*", 
     RowBox[{"(", 
      RowBox[{"f", "+", "omega"}], ")"}]}], "]"}]}]}]], "Input",
 CellChangeTimes->{{3.754073182249515*^9, 3.754073205530738*^9}},
 CellLabel->"In[14]:=",ExpressionUUID->"c26e6c5b-0f55-4498-8c87-6cc7a87df398"],

Cell[BoxData[
 RowBox[{
  RowBox[{"ecc", " ", 
   RowBox[{"Sin", "[", "f", "]"}]}], "-", 
  RowBox[{"ecc", " ", 
   SuperscriptBox["si", "2"], " ", 
   RowBox[{"Cos", "[", "omega", "]"}], " ", 
   RowBox[{"Sin", "[", 
    RowBox[{"f", "+", "omega"}], "]"}]}], "-", 
  RowBox[{
   SuperscriptBox["si", "2"], " ", 
   RowBox[{"Sin", "[", 
    RowBox[{"2", " ", 
     RowBox[{"(", 
      RowBox[{"f", "+", "omega"}], ")"}]}], "]"}]}]}]], "Output",
 CellChangeTimes->{3.754073210639209*^9},
 CellLabel->"Out[14]=",ExpressionUUID->"6918e325-c637-43c4-94f1-a6c4a7ba032a"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"TrigExpand", "[", "%", "]"}]], "Input",
 CellChangeTimes->{{3.754073211016713*^9, 3.7540732143943367`*^9}},
 CellLabel->"In[15]:=",ExpressionUUID->"7694460f-2875-4f33-96f6-65e734783c54"],

Cell[BoxData[
 RowBox[{
  RowBox[{"ecc", " ", 
   RowBox[{"Sin", "[", "f", "]"}]}], "-", 
  RowBox[{
   FractionBox["1", "2"], " ", "ecc", " ", 
   SuperscriptBox["si", "2"], " ", 
   RowBox[{"Sin", "[", "f", "]"}]}], "-", 
  RowBox[{
   FractionBox["1", "2"], " ", "ecc", " ", 
   SuperscriptBox["si", "2"], " ", 
   SuperscriptBox[
    RowBox[{"Cos", "[", "omega", "]"}], "2"], " ", 
   RowBox[{"Sin", "[", "f", "]"}]}], "-", 
  RowBox[{"2", " ", 
   SuperscriptBox["si", "2"], " ", 
   RowBox[{"Cos", "[", "f", "]"}], " ", 
   SuperscriptBox[
    RowBox[{"Cos", "[", "omega", "]"}], "2"], " ", 
   RowBox[{"Sin", "[", "f", "]"}]}], "-", 
  RowBox[{"ecc", " ", 
   SuperscriptBox["si", "2"], " ", 
   RowBox[{"Cos", "[", "f", "]"}], " ", 
   RowBox[{"Cos", "[", "omega", "]"}], " ", 
   RowBox[{"Sin", "[", "omega", "]"}]}], "-", 
  RowBox[{"2", " ", 
   SuperscriptBox["si", "2"], " ", 
   SuperscriptBox[
    RowBox[{"Cos", "[", "f", "]"}], "2"], " ", 
   RowBox[{"Cos", "[", "omega", "]"}], " ", 
   RowBox[{"Sin", "[", "omega", "]"}]}], "+", 
  RowBox[{"2", " ", 
   SuperscriptBox["si", "2"], " ", 
   RowBox[{"Cos", "[", "omega", "]"}], " ", 
   SuperscriptBox[
    RowBox[{"Sin", "[", "f", "]"}], "2"], " ", 
   RowBox[{"Sin", "[", "omega", "]"}]}], "+", 
  RowBox[{
   FractionBox["1", "2"], " ", "ecc", " ", 
   SuperscriptBox["si", "2"], " ", 
   RowBox[{"Sin", "[", "f", "]"}], " ", 
   SuperscriptBox[
    RowBox[{"Sin", "[", "omega", "]"}], "2"]}], "+", 
  RowBox[{"2", " ", 
   SuperscriptBox["si", "2"], " ", 
   RowBox[{"Cos", "[", "f", "]"}], " ", 
   RowBox[{"Sin", "[", "f", "]"}], " ", 
   SuperscriptBox[
    RowBox[{"Sin", "[", "omega", "]"}], "2"]}]}]], "Output",
 CellChangeTimes->{3.7540732146308537`*^9},
 CellLabel->"Out[15]=",ExpressionUUID->"6327c6f6-9284-40bc-95da-5d6fa0dbb5aa"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"FullSimplify", "[", "%", "]"}]], "Input",
 CellChangeTimes->{{3.7540732161521683`*^9, 3.75407321756386*^9}},
 CellLabel->"In[16]:=",ExpressionUUID->"2fd3094e-8af6-41cd-9196-944770fda4a6"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"-", 
    FractionBox["1", "2"]}], " ", "ecc", " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"-", "2"}], "+", 
     SuperscriptBox["si", "2"]}], ")"}], " ", 
   RowBox[{"Sin", "[", "f", "]"}]}], "-", 
  RowBox[{
   FractionBox["1", "2"], " ", 
   SuperscriptBox["si", "2"], " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"2", " ", 
      RowBox[{"Sin", "[", 
       RowBox[{"2", " ", 
        RowBox[{"(", 
         RowBox[{"f", "+", "omega"}], ")"}]}], "]"}]}], "+", 
     RowBox[{"ecc", " ", 
      RowBox[{"Sin", "[", 
       RowBox[{"f", "+", 
        RowBox[{"2", " ", "omega"}]}], "]"}]}]}], ")"}]}]}]], "Output",
 CellChangeTimes->{3.754073217987215*^9},
 CellLabel->"Out[16]=",ExpressionUUID->"fff26b0f-92ac-4a0a-8e24-9ad8447697db"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Factor", "[", 
  RowBox[{"Out", "[", "15", "]"}], "]"}]], "Input",
 CellChangeTimes->{{3.754073335011601*^9, 3.754073339549728*^9}},
 CellLabel->"In[19]:=",ExpressionUUID->"21c9fa8a-8eec-40f1-b6de-6c02a5d93351"],

Cell[BoxData[
 RowBox[{
  FractionBox["1", "2"], " ", 
  RowBox[{"(", 
   RowBox[{
    RowBox[{"2", " ", "ecc", " ", 
     RowBox[{"Sin", "[", "f", "]"}]}], "-", 
    RowBox[{"ecc", " ", 
     SuperscriptBox["si", "2"], " ", 
     RowBox[{"Sin", "[", "f", "]"}]}], "-", 
    RowBox[{"ecc", " ", 
     SuperscriptBox["si", "2"], " ", 
     SuperscriptBox[
      RowBox[{"Cos", "[", "omega", "]"}], "2"], " ", 
     RowBox[{"Sin", "[", "f", "]"}]}], "-", 
    RowBox[{"4", " ", 
     SuperscriptBox["si", "2"], " ", 
     RowBox[{"Cos", "[", "f", "]"}], " ", 
     SuperscriptBox[
      RowBox[{"Cos", "[", "omega", "]"}], "2"], " ", 
     RowBox[{"Sin", "[", "f", "]"}]}], "-", 
    RowBox[{"2", " ", "ecc", " ", 
     SuperscriptBox["si", "2"], " ", 
     RowBox[{"Cos", "[", "f", "]"}], " ", 
     RowBox[{"Cos", "[", "omega", "]"}], " ", 
     RowBox[{"Sin", "[", "omega", "]"}]}], "-", 
    RowBox[{"4", " ", 
     SuperscriptBox["si", "2"], " ", 
     SuperscriptBox[
      RowBox[{"Cos", "[", "f", "]"}], "2"], " ", 
     RowBox[{"Cos", "[", "omega", "]"}], " ", 
     RowBox[{"Sin", "[", "omega", "]"}]}], "+", 
    RowBox[{"4", " ", 
     SuperscriptBox["si", "2"], " ", 
     RowBox[{"Cos", "[", "omega", "]"}], " ", 
     SuperscriptBox[
      RowBox[{"Sin", "[", "f", "]"}], "2"], " ", 
     RowBox[{"Sin", "[", "omega", "]"}]}], "+", 
    RowBox[{"ecc", " ", 
     SuperscriptBox["si", "2"], " ", 
     RowBox[{"Sin", "[", "f", "]"}], " ", 
     SuperscriptBox[
      RowBox[{"Sin", "[", "omega", "]"}], "2"]}], "+", 
    RowBox[{"4", " ", 
     SuperscriptBox["si", "2"], " ", 
     RowBox[{"Cos", "[", "f", "]"}], " ", 
     RowBox[{"Sin", "[", "f", "]"}], " ", 
     SuperscriptBox[
      RowBox[{"Sin", "[", "omega", "]"}], "2"]}]}], ")"}]}]], "Output",
 CellChangeTimes->{3.754073339900133*^9},
 CellLabel->"Out[19]=",ExpressionUUID->"4d4e5d99-d443-4da1-ad3b-eb04d2a77c59"]
}, Open  ]],

Cell[BoxData[""], "Input",
 CellChangeTimes->{{3.754073428433646*^9, 
  3.754073430306705*^9}},ExpressionUUID->"5e381d28-09fb-4071-ad9c-\
b19f4a12e2c4"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Coefficient", "[", 
  RowBox[{
   RowBox[{
    RowBox[{"ecc", " ", 
     RowBox[{"Sin", "[", "f", "]"}]}], "-", 
    RowBox[{
     FractionBox["1", "2"], " ", "ecc", " ", 
     SuperscriptBox["si", "2"], " ", 
     RowBox[{"Sin", "[", "f", "]"}]}], "-", 
    RowBox[{
     FractionBox["1", "2"], " ", "ecc", " ", 
     SuperscriptBox["si", "2"], " ", 
     SuperscriptBox[
      RowBox[{"Cos", "[", "omega", "]"}], "2"], " ", 
     RowBox[{"Sin", "[", "f", "]"}]}], "-", 
    RowBox[{"2", " ", 
     SuperscriptBox["si", "2"], " ", 
     RowBox[{"Cos", "[", "f", "]"}], " ", 
     SuperscriptBox[
      RowBox[{"Cos", "[", "omega", "]"}], "2"], " ", 
     RowBox[{"Sin", "[", "f", "]"}]}], "-", 
    RowBox[{"ecc", " ", 
     SuperscriptBox["si", "2"], " ", 
     RowBox[{"Cos", "[", "f", "]"}], " ", 
     RowBox[{"Cos", "[", "omega", "]"}], " ", 
     RowBox[{"Sin", "[", "omega", "]"}]}], "-", 
    RowBox[{"2", " ", 
     SuperscriptBox["si", "2"], " ", 
     RowBox[{"(", 
      RowBox[{"1", "-", 
       RowBox[{
        RowBox[{"Sin", "[", "f", "]"}], "^", "2"}]}], ")"}], " ", 
     RowBox[{"Cos", "[", "omega", "]"}], " ", 
     RowBox[{"Sin", "[", "omega", "]"}]}], "+", 
    RowBox[{"2", " ", 
     SuperscriptBox["si", "2"], " ", 
     RowBox[{"Cos", "[", "omega", "]"}], " ", 
     SuperscriptBox[
      RowBox[{"Sin", "[", "f", "]"}], "2"], " ", 
     RowBox[{"Sin", "[", "omega", "]"}]}], "+", 
    RowBox[{
     FractionBox["1", "2"], " ", "ecc", " ", 
     SuperscriptBox["si", "2"], " ", 
     RowBox[{"Sin", "[", "f", "]"}], " ", 
     SuperscriptBox[
      RowBox[{"Sin", "[", "omega", "]"}], "2"]}], "+", 
    RowBox[{"2", " ", 
     SuperscriptBox["si", "2"], " ", 
     RowBox[{"Cos", "[", "f", "]"}], " ", 
     RowBox[{"Sin", "[", "f", "]"}], " ", 
     SuperscriptBox[
      RowBox[{"Sin", "[", "omega", "]"}], "2"]}]}], ",", 
   RowBox[{"Cos", "[", "f", "]"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.7540734518674088`*^9, 3.7540734786177187`*^9}},
 CellLabel->"In[20]:=",ExpressionUUID->"53638e90-c684-472c-a14e-4b9eee852044"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"-", "2"}], " ", 
   SuperscriptBox["si", "2"], " ", 
   SuperscriptBox[
    RowBox[{"Cos", "[", "omega", "]"}], "2"], " ", 
   RowBox[{"Sin", "[", "f", "]"}]}], "-", 
  RowBox[{"ecc", " ", 
   SuperscriptBox["si", "2"], " ", 
   RowBox[{"Cos", "[", "omega", "]"}], " ", 
   RowBox[{"Sin", "[", "omega", "]"}]}], "+", 
  RowBox[{"2", " ", 
   SuperscriptBox["si", "2"], " ", 
   RowBox[{"Sin", "[", "f", "]"}], " ", 
   SuperscriptBox[
    RowBox[{"Sin", "[", "omega", "]"}], "2"]}]}]], "Output",
 CellChangeTimes->{3.754073478925642*^9},
 CellLabel->"Out[20]=",ExpressionUUID->"18ec782a-9f5e-4296-a5a1-87fd74777e59"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"ecc", " ", 
   RowBox[{"Sin", "[", "f", "]"}]}], "-", 
  RowBox[{
   FractionBox["1", "2"], " ", "ecc", " ", 
   SuperscriptBox["si", "2"], " ", 
   RowBox[{"Sin", "[", "f", "]"}]}], "-", 
  RowBox[{
   FractionBox["1", "2"], " ", "ecc", " ", 
   SuperscriptBox["si", "2"], " ", 
   SuperscriptBox[
    RowBox[{"Cos", "[", "omega", "]"}], "2"], " ", 
   RowBox[{"Sin", "[", "f", "]"}]}], "-", 
  RowBox[{"2", " ", 
   SuperscriptBox["si", "2"], " ", 
   RowBox[{"Cos", "[", "f", "]"}], " ", 
   SuperscriptBox[
    RowBox[{"Cos", "[", "omega", "]"}], "2"], " ", 
   RowBox[{"Sin", "[", "f", "]"}]}], "-", 
  RowBox[{"ecc", " ", 
   SuperscriptBox["si", "2"], " ", 
   RowBox[{"Cos", "[", "f", "]"}], " ", 
   RowBox[{"Cos", "[", "omega", "]"}], " ", 
   RowBox[{"Sin", "[", "omega", "]"}]}], "-", 
  RowBox[{"2", " ", 
   SuperscriptBox["si", "2"], " ", 
   RowBox[{"(", 
    RowBox[{"1", "-", 
     RowBox[{
      RowBox[{"Sin", "[", "f", "]"}], "^", "2"}]}], ")"}], " ", 
   RowBox[{"Cos", "[", "omega", "]"}], " ", 
   RowBox[{"Sin", "[", "omega", "]"}]}], "+", 
  RowBox[{"2", " ", 
   SuperscriptBox["si", "2"], " ", 
   RowBox[{"Cos", "[", "omega", "]"}], " ", 
   SuperscriptBox[
    RowBox[{"Sin", "[", "f", "]"}], "2"], " ", 
   RowBox[{"Sin", "[", "omega", "]"}]}], "+", 
  RowBox[{
   FractionBox["1", "2"], " ", "ecc", " ", 
   SuperscriptBox["si", "2"], " ", 
   RowBox[{"Sin", "[", "f", "]"}], " ", 
   SuperscriptBox[
    RowBox[{"Sin", "[", "omega", "]"}], "2"]}], "+", 
  RowBox[{"2", " ", 
   SuperscriptBox["si", "2"], " ", 
   RowBox[{"Cos", "[", "f", "]"}], " ", 
   RowBox[{"Sin", "[", "f", "]"}], " ", 
   SuperscriptBox[
    RowBox[{"Sin", "[", "omega", "]"}], "2"]}]}]], "Input",
 CellLabel->"In[21]:=",ExpressionUUID->"8791fc7e-c9fe-4ed1-8034-763ad7e30d9a"],

Cell[BoxData[
 RowBox[{
  RowBox[{"ecc", " ", 
   RowBox[{"Sin", "[", "f", "]"}]}], "-", 
  RowBox[{
   FractionBox["1", "2"], " ", "ecc", " ", 
   SuperscriptBox["si", "2"], " ", 
   RowBox[{"Sin", "[", "f", "]"}]}], "-", 
  RowBox[{
   FractionBox["1", "2"], " ", "ecc", " ", 
   SuperscriptBox["si", "2"], " ", 
   SuperscriptBox[
    RowBox[{"Cos", "[", "omega", "]"}], "2"], " ", 
   RowBox[{"Sin", "[", "f", "]"}]}], "-", 
  RowBox[{"2", " ", 
   SuperscriptBox["si", "2"], " ", 
   RowBox[{"Cos", "[", "f", "]"}], " ", 
   SuperscriptBox[
    RowBox[{"Cos", "[", "omega", "]"}], "2"], " ", 
   RowBox[{"Sin", "[", "f", "]"}]}], "-", 
  RowBox[{"ecc", " ", 
   SuperscriptBox["si", "2"], " ", 
   RowBox[{"Cos", "[", "f", "]"}], " ", 
   RowBox[{"Cos", "[", "omega", "]"}], " ", 
   RowBox[{"Sin", "[", "omega", "]"}]}], "+", 
  RowBox[{"2", " ", 
   SuperscriptBox["si", "2"], " ", 
   RowBox[{"Cos", "[", "omega", "]"}], " ", 
   SuperscriptBox[
    RowBox[{"Sin", "[", "f", "]"}], "2"], " ", 
   RowBox[{"Sin", "[", "omega", "]"}]}], "-", 
  RowBox[{"2", " ", 
   SuperscriptBox["si", "2"], " ", 
   RowBox[{"Cos", "[", "omega", "]"}], " ", 
   RowBox[{"(", 
    RowBox[{"1", "-", 
     SuperscriptBox[
      RowBox[{"Sin", "[", "f", "]"}], "2"]}], ")"}], " ", 
   RowBox[{"Sin", "[", "omega", "]"}]}], "+", 
  RowBox[{
   FractionBox["1", "2"], " ", "ecc", " ", 
   SuperscriptBox["si", "2"], " ", 
   RowBox[{"Sin", "[", "f", "]"}], " ", 
   SuperscriptBox[
    RowBox[{"Sin", "[", "omega", "]"}], "2"]}], "+", 
  RowBox[{"2", " ", 
   SuperscriptBox["si", "2"], " ", 
   RowBox[{"Cos", "[", "f", "]"}], " ", 
   RowBox[{"Sin", "[", "f", "]"}], " ", 
   SuperscriptBox[
    RowBox[{"Sin", "[", "omega", "]"}], "2"]}]}]], "Output",
 CellChangeTimes->{3.754073660899396*^9},
 CellLabel->"Out[21]=",ExpressionUUID->"d9674857-d47a-42ad-9445-c6640e862706"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Simplify", "[", "%", "]"}]], "Input",
 CellChangeTimes->{{3.754073662562397*^9, 3.754073663980714*^9}},
 CellLabel->"In[22]:=",ExpressionUUID->"aa4bd010-9c62-41b2-bd82-d0ab5e8a46a1"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"-", 
    FractionBox["1", "2"]}], " ", "ecc", " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"-", "2"}], "+", 
     SuperscriptBox["si", "2"]}], ")"}], " ", 
   RowBox[{"Sin", "[", "f", "]"}]}], "-", 
  RowBox[{
   FractionBox["1", "2"], " ", 
   SuperscriptBox["si", "2"], " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"2", " ", 
      RowBox[{"Sin", "[", 
       RowBox[{"2", " ", 
        RowBox[{"(", 
         RowBox[{"f", "+", "omega"}], ")"}]}], "]"}]}], "+", 
     RowBox[{"ecc", " ", 
      RowBox[{"Sin", "[", 
       RowBox[{"f", "+", 
        RowBox[{"2", " ", "omega"}]}], "]"}]}]}], ")"}]}]}]], "Output",
 CellChangeTimes->{3.7540736643560266`*^9},
 CellLabel->"Out[22]=",ExpressionUUID->"a556cdf4-b028-4e44-8fc5-eeb44d4846a1"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"(", 
    RowBox[{
     RowBox[{"ecc", " ", 
      RowBox[{"Sin", "[", "f", "]"}]}], "-", 
     RowBox[{
      FractionBox["1", "2"], " ", "ecc", " ", 
      SuperscriptBox["si", "2"], " ", 
      RowBox[{"Sin", "[", "f", "]"}]}], "-", 
     RowBox[{
      FractionBox["1", "2"], " ", "ecc", " ", 
      SuperscriptBox["si", "2"], " ", 
      SuperscriptBox[
       RowBox[{"Cos", "[", "omega", "]"}], "2"], " ", 
      RowBox[{"Sin", "[", "f", "]"}]}], "-", 
     RowBox[{"2", " ", 
      SuperscriptBox["si", "2"], " ", 
      RowBox[{"(", 
       RowBox[{"1", "-", 
        RowBox[{
         RowBox[{"Sin", "[", "f", "]"}], "^", "2"}]}], ")"}], " ", 
      RowBox[{"Cos", "[", "omega", "]"}], " ", 
      RowBox[{"Sin", "[", "omega", "]"}]}], "+", 
     RowBox[{"2", " ", 
      SuperscriptBox["si", "2"], " ", 
      RowBox[{"Cos", "[", "omega", "]"}], " ", 
      SuperscriptBox[
       RowBox[{"Sin", "[", "f", "]"}], "2"], " ", 
      RowBox[{"Sin", "[", "omega", "]"}]}], "+", 
     RowBox[{
      FractionBox["1", "2"], " ", "ecc", " ", 
      SuperscriptBox["si", "2"], " ", 
      RowBox[{"Sin", "[", "f", "]"}], " ", 
      SuperscriptBox[
       RowBox[{"Sin", "[", "omega", "]"}], "2"]}]}], ")"}], "^", "2"}], "-", 
  RowBox[{
   RowBox[{"(", 
    RowBox[{"1", "-", 
     RowBox[{
      RowBox[{"Sin", "[", "f", "]"}], "^", "2"}]}], ")"}], "*", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      RowBox[{
       RowBox[{"-", "2"}], " ", 
       SuperscriptBox["si", "2"], " ", 
       SuperscriptBox[
        RowBox[{"Cos", "[", "omega", "]"}], "2"], " ", 
       RowBox[{"Sin", "[", "f", "]"}]}], "-", 
      RowBox[{"ecc", " ", 
       SuperscriptBox["si", "2"], " ", 
       RowBox[{"Cos", "[", "omega", "]"}], " ", 
       RowBox[{"Sin", "[", "omega", "]"}]}], "+", 
      RowBox[{"2", " ", 
       SuperscriptBox["si", "2"], " ", 
       RowBox[{"Sin", "[", "f", "]"}], " ", 
       SuperscriptBox[
        RowBox[{"Sin", "[", "omega", "]"}], "2"]}]}], ")"}], "^", 
    "2"}]}]}]], "Input",
 CellChangeTimes->{{3.754074130958151*^9, 3.7540741761205873`*^9}},
 CellLabel->"In[23]:=",ExpressionUUID->"a05cd943-204a-401d-a160-f84f69ed3f48"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"-", 
    RowBox[{"(", 
     RowBox[{"1", "-", 
      SuperscriptBox[
       RowBox[{"Sin", "[", "f", "]"}], "2"]}], ")"}]}], " ", 
   SuperscriptBox[
    RowBox[{"(", 
     RowBox[{
      RowBox[{
       RowBox[{"-", "2"}], " ", 
       SuperscriptBox["si", "2"], " ", 
       SuperscriptBox[
        RowBox[{"Cos", "[", "omega", "]"}], "2"], " ", 
       RowBox[{"Sin", "[", "f", "]"}]}], "-", 
      RowBox[{"ecc", " ", 
       SuperscriptBox["si", "2"], " ", 
       RowBox[{"Cos", "[", "omega", "]"}], " ", 
       RowBox[{"Sin", "[", "omega", "]"}]}], "+", 
      RowBox[{"2", " ", 
       SuperscriptBox["si", "2"], " ", 
       RowBox[{"Sin", "[", "f", "]"}], " ", 
       SuperscriptBox[
        RowBox[{"Sin", "[", "omega", "]"}], "2"]}]}], ")"}], "2"]}], "+", 
  SuperscriptBox[
   RowBox[{"(", 
    RowBox[{
     RowBox[{"ecc", " ", 
      RowBox[{"Sin", "[", "f", "]"}]}], "-", 
     RowBox[{
      FractionBox["1", "2"], " ", "ecc", " ", 
      SuperscriptBox["si", "2"], " ", 
      RowBox[{"Sin", "[", "f", "]"}]}], "-", 
     RowBox[{
      FractionBox["1", "2"], " ", "ecc", " ", 
      SuperscriptBox["si", "2"], " ", 
      SuperscriptBox[
       RowBox[{"Cos", "[", "omega", "]"}], "2"], " ", 
      RowBox[{"Sin", "[", "f", "]"}]}], "+", 
     RowBox[{"2", " ", 
      SuperscriptBox["si", "2"], " ", 
      RowBox[{"Cos", "[", "omega", "]"}], " ", 
      SuperscriptBox[
       RowBox[{"Sin", "[", "f", "]"}], "2"], " ", 
      RowBox[{"Sin", "[", "omega", "]"}]}], "-", 
     RowBox[{"2", " ", 
      SuperscriptBox["si", "2"], " ", 
      RowBox[{"Cos", "[", "omega", "]"}], " ", 
      RowBox[{"(", 
       RowBox[{"1", "-", 
        SuperscriptBox[
         RowBox[{"Sin", "[", "f", "]"}], "2"]}], ")"}], " ", 
      RowBox[{"Sin", "[", "omega", "]"}]}], "+", 
     RowBox[{
      FractionBox["1", "2"], " ", "ecc", " ", 
      SuperscriptBox["si", "2"], " ", 
      RowBox[{"Sin", "[", "f", "]"}], " ", 
      SuperscriptBox[
       RowBox[{"Sin", "[", "omega", "]"}], "2"]}]}], ")"}], "2"]}]], "Output",\

 CellChangeTimes->{3.754074181682267*^9},
 CellLabel->"Out[23]=",ExpressionUUID->"ff29c719-8f57-4c6d-b7ea-c51d8bb216e1"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"FullSimplify", "[", "%", "]"}]], "Input",
 CellChangeTimes->{{3.754074185616785*^9, 3.754074187411427*^9}},
 CellLabel->"In[24]:=",ExpressionUUID->"bc87635f-e0ee-4858-8281-dad81888b670"],

Cell[BoxData[
 RowBox[{
  FractionBox["1", "4"], " ", 
  RowBox[{"(", 
   RowBox[{
    RowBox[{
     RowBox[{"-", 
      SuperscriptBox["si", "4"]}], " ", 
     SuperscriptBox[
      RowBox[{"(", 
       RowBox[{
        RowBox[{"2", " ", 
         RowBox[{"Cos", "[", 
          RowBox[{"2", " ", "omega"}], "]"}], " ", 
         RowBox[{"Sin", "[", 
          RowBox[{"2", " ", "f"}], "]"}]}], "+", 
        RowBox[{"ecc", " ", 
         RowBox[{"Cos", "[", "f", "]"}], " ", 
         RowBox[{"Sin", "[", 
          RowBox[{"2", " ", "omega"}], "]"}]}]}], ")"}], "2"]}], "+", 
    SuperscriptBox[
     RowBox[{"(", 
      RowBox[{
       RowBox[{"ecc", " ", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"-", "2"}], "+", 
          SuperscriptBox["si", "2"], "+", 
          RowBox[{
           SuperscriptBox["si", "2"], " ", 
           RowBox[{"Cos", "[", 
            RowBox[{"2", " ", "omega"}], "]"}]}]}], ")"}], " ", 
        RowBox[{"Sin", "[", "f", "]"}]}], "+", 
       RowBox[{"2", " ", 
        SuperscriptBox["si", "2"], " ", 
        RowBox[{"Cos", "[", 
         RowBox[{"2", " ", "f"}], "]"}], " ", 
        RowBox[{"Sin", "[", 
         RowBox[{"2", " ", "omega"}], "]"}]}]}], ")"}], "2"]}], 
   ")"}]}]], "Output",
 CellChangeTimes->{3.7540741894550037`*^9},
 CellLabel->"Out[24]=",ExpressionUUID->"9a425acf-f08a-485b-93af-3dfb78b51431"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Series", "[", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{"-", 
      RowBox[{"(", 
       RowBox[{"1", "-", 
        SuperscriptBox[
         RowBox[{"Sin", "[", "f", "]"}], "2"]}], ")"}]}], " ", 
     SuperscriptBox[
      RowBox[{"(", 
       RowBox[{
        RowBox[{
         RowBox[{"-", "2"}], " ", 
         SuperscriptBox["si", "2"], " ", 
         SuperscriptBox[
          RowBox[{"Cos", "[", "omega", "]"}], "2"], " ", 
         RowBox[{"Sin", "[", "f", "]"}]}], "-", 
        RowBox[{"ecc", " ", 
         SuperscriptBox["si", "2"], " ", 
         RowBox[{"Cos", "[", "omega", "]"}], " ", 
         RowBox[{"Sin", "[", "omega", "]"}]}], "+", 
        RowBox[{"2", " ", 
         SuperscriptBox["si", "2"], " ", 
         RowBox[{"Sin", "[", "f", "]"}], " ", 
         SuperscriptBox[
          RowBox[{"Sin", "[", "omega", "]"}], "2"]}]}], ")"}], "2"]}], "+", 
    SuperscriptBox[
     RowBox[{"(", 
      RowBox[{
       RowBox[{"ecc", " ", 
        RowBox[{"Sin", "[", "f", "]"}]}], "-", 
       RowBox[{
        FractionBox["1", "2"], " ", "ecc", " ", 
        SuperscriptBox["si", "2"], " ", 
        RowBox[{"Sin", "[", "f", "]"}]}], "-", 
       RowBox[{
        FractionBox["1", "2"], " ", "ecc", " ", 
        SuperscriptBox["si", "2"], " ", 
        SuperscriptBox[
         RowBox[{"Cos", "[", "omega", "]"}], "2"], " ", 
        RowBox[{"Sin", "[", "f", "]"}]}], "+", 
       RowBox[{"2", " ", 
        SuperscriptBox["si", "2"], " ", 
        RowBox[{"Cos", "[", "omega", "]"}], " ", 
        SuperscriptBox[
         RowBox[{"Sin", "[", "f", "]"}], "2"], " ", 
        RowBox[{"Sin", "[", "omega", "]"}]}], "-", 
       RowBox[{"2", " ", 
        SuperscriptBox["si", "2"], " ", 
        RowBox[{"Cos", "[", "omega", "]"}], " ", 
        RowBox[{"(", 
         RowBox[{"1", "-", 
          SuperscriptBox[
           RowBox[{"Sin", "[", "f", "]"}], "2"]}], ")"}], " ", 
        RowBox[{"Sin", "[", "omega", "]"}]}], "+", 
       RowBox[{
        FractionBox["1", "2"], " ", "ecc", " ", 
        SuperscriptBox["si", "2"], " ", 
        RowBox[{"Sin", "[", "f", "]"}], " ", 
        SuperscriptBox[
         RowBox[{"Sin", "[", "omega", "]"}], "2"]}]}], ")"}], "2"]}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"Sin", "[", "f", "]"}], ",", "0", ",", "6"}], "}"}]}], 
  "]"}]], "Input",
 CellChangeTimes->{{3.754074251084672*^9, 3.754074276413941*^9}},
 CellLabel->"In[26]:=",ExpressionUUID->"f4f81b61-0b53-4ae5-ad01-9ce4cc901cb9"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
   RowBox[{"(", 
    RowBox[{
     RowBox[{"4", " ", 
      SuperscriptBox["si", "4"], " ", 
      SuperscriptBox[
       RowBox[{"Cos", "[", "omega", "]"}], "2"], " ", 
      SuperscriptBox[
       RowBox[{"Sin", "[", "omega", "]"}], "2"]}], "-", 
     RowBox[{
      SuperscriptBox["ecc", "2"], " ", 
      SuperscriptBox["si", "4"], " ", 
      SuperscriptBox[
       RowBox[{"Cos", "[", "omega", "]"}], "2"], " ", 
      SuperscriptBox[
       RowBox[{"Sin", "[", "omega", "]"}], "2"]}]}], ")"}], "+", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      RowBox[{
       RowBox[{"-", "4"}], " ", "ecc", " ", 
       SuperscriptBox["si", "2"], " ", 
       RowBox[{"Cos", "[", "omega", "]"}], " ", 
       RowBox[{"Sin", "[", "omega", "]"}]}], "+", 
      RowBox[{"2", " ", "ecc", " ", 
       SuperscriptBox["si", "4"], " ", 
       RowBox[{"Cos", "[", "omega", "]"}], " ", 
       RowBox[{"Sin", "[", "omega", "]"}]}], "-", 
      RowBox[{"2", " ", "ecc", " ", 
       SuperscriptBox["si", "4"], " ", 
       SuperscriptBox[
        RowBox[{"Cos", "[", "omega", "]"}], "3"], " ", 
       RowBox[{"Sin", "[", "omega", "]"}]}], "+", 
      RowBox[{"2", " ", "ecc", " ", 
       SuperscriptBox["si", "4"], " ", 
       RowBox[{"Cos", "[", "omega", "]"}], " ", 
       SuperscriptBox[
        RowBox[{"Sin", "[", "omega", "]"}], "3"]}]}], ")"}], " ", 
    RowBox[{"Sin", "[", "f", "]"}]}], "+", 
   RowBox[{
    FractionBox["1", "4"], " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"4", " ", 
       SuperscriptBox["ecc", "2"]}], "-", 
      RowBox[{"4", " ", 
       SuperscriptBox["ecc", "2"], " ", 
       SuperscriptBox["si", "2"]}], "+", 
      RowBox[{
       SuperscriptBox["ecc", "2"], " ", 
       SuperscriptBox["si", "4"]}], "-", 
      RowBox[{"4", " ", 
       SuperscriptBox["ecc", "2"], " ", 
       SuperscriptBox["si", "2"], " ", 
       SuperscriptBox[
        RowBox[{"Cos", "[", "omega", "]"}], "2"]}], "+", 
      RowBox[{"2", " ", 
       SuperscriptBox["ecc", "2"], " ", 
       SuperscriptBox["si", "4"], " ", 
       SuperscriptBox[
        RowBox[{"Cos", "[", "omega", "]"}], "2"]}], "-", 
      RowBox[{"16", " ", 
       SuperscriptBox["si", "4"], " ", 
       SuperscriptBox[
        RowBox[{"Cos", "[", "omega", "]"}], "4"]}], "+", 
      RowBox[{
       SuperscriptBox["ecc", "2"], " ", 
       SuperscriptBox["si", "4"], " ", 
       SuperscriptBox[
        RowBox[{"Cos", "[", "omega", "]"}], "4"]}], "+", 
      RowBox[{"4", " ", 
       SuperscriptBox["ecc", "2"], " ", 
       SuperscriptBox["si", "2"], " ", 
       SuperscriptBox[
        RowBox[{"Sin", "[", "omega", "]"}], "2"]}], "-", 
      RowBox[{"2", " ", 
       SuperscriptBox["ecc", "2"], " ", 
       SuperscriptBox["si", "4"], " ", 
       SuperscriptBox[
        RowBox[{"Sin", "[", "omega", "]"}], "2"]}], "-", 
      RowBox[{"32", " ", 
       SuperscriptBox["si", "4"], " ", 
       SuperscriptBox[
        RowBox[{"Cos", "[", "omega", "]"}], "2"], " ", 
       SuperscriptBox[
        RowBox[{"Sin", "[", "omega", "]"}], "2"]}], "+", 
      RowBox[{"2", " ", 
       SuperscriptBox["ecc", "2"], " ", 
       SuperscriptBox["si", "4"], " ", 
       SuperscriptBox[
        RowBox[{"Cos", "[", "omega", "]"}], "2"], " ", 
       SuperscriptBox[
        RowBox[{"Sin", "[", "omega", "]"}], "2"]}], "-", 
      RowBox[{"16", " ", 
       SuperscriptBox["si", "4"], " ", 
       SuperscriptBox[
        RowBox[{"Sin", "[", "omega", "]"}], "4"]}], "+", 
      RowBox[{
       SuperscriptBox["ecc", "2"], " ", 
       SuperscriptBox["si", "4"], " ", 
       SuperscriptBox[
        RowBox[{"Sin", "[", "omega", "]"}], "4"]}]}], ")"}], " ", 
    SuperscriptBox[
     RowBox[{"Sin", "[", "f", "]"}], "2"]}], "+", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      RowBox[{"8", " ", "ecc", " ", 
       SuperscriptBox["si", "2"], " ", 
       RowBox[{"Cos", "[", "omega", "]"}], " ", 
       RowBox[{"Sin", "[", "omega", "]"}]}], "-", 
      RowBox[{"4", " ", "ecc", " ", 
       SuperscriptBox["si", "4"], " ", 
       RowBox[{"Cos", "[", "omega", "]"}], " ", 
       RowBox[{"Sin", "[", "omega", "]"}]}]}], ")"}], " ", 
    SuperscriptBox[
     RowBox[{"Sin", "[", "f", "]"}], "3"]}], "+", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      RowBox[{"4", " ", 
       SuperscriptBox["si", "4"], " ", 
       SuperscriptBox[
        RowBox[{"Cos", "[", "omega", "]"}], "4"]}], "+", 
      RowBox[{"8", " ", 
       SuperscriptBox["si", "4"], " ", 
       SuperscriptBox[
        RowBox[{"Cos", "[", "omega", "]"}], "2"], " ", 
       SuperscriptBox[
        RowBox[{"Sin", "[", "omega", "]"}], "2"]}], "+", 
      RowBox[{"4", " ", 
       SuperscriptBox["si", "4"], " ", 
       SuperscriptBox[
        RowBox[{"Sin", "[", "omega", "]"}], "4"]}]}], ")"}], " ", 
    SuperscriptBox[
     RowBox[{"Sin", "[", "f", "]"}], "4"]}], "+", 
   InterpretationBox[
    SuperscriptBox[
     RowBox[{"O", "[", 
      RowBox[{"Sin", "[", "f", "]"}], "]"}], "7"],
    SeriesData[
     Sin[$CellContext`f], 0, {}, 0, 7, 1],
    Editable->False]}],
  SeriesData[
   Sin[$CellContext`f], 0, {
   4 $CellContext`si^4 Cos[$CellContext`omega]^2 
     Sin[$CellContext`omega]^2 - $CellContext`ecc^2 $CellContext`si^4 
    Cos[$CellContext`omega]^2 
    Sin[$CellContext`omega]^2, (-4) $CellContext`ecc $CellContext`si^2 
     Cos[$CellContext`omega] Sin[$CellContext`omega] + 
    2 $CellContext`ecc $CellContext`si^4 Cos[$CellContext`omega] 
     Sin[$CellContext`omega] - 2 $CellContext`ecc $CellContext`si^4 
    Cos[$CellContext`omega]^3 Sin[$CellContext`omega] + 
    2 $CellContext`ecc $CellContext`si^4 Cos[$CellContext`omega] 
     Sin[$CellContext`omega]^3, 
    Rational[1, 4] (4 $CellContext`ecc^2 - 
     4 $CellContext`ecc^2 $CellContext`si^2 + $CellContext`ecc^2 \
$CellContext`si^4 - 4 $CellContext`ecc^2 $CellContext`si^2 
     Cos[$CellContext`omega]^2 + 
     2 $CellContext`ecc^2 $CellContext`si^4 Cos[$CellContext`omega]^2 - 
     16 $CellContext`si^4 
     Cos[$CellContext`omega]^4 + $CellContext`ecc^2 $CellContext`si^4 
      Cos[$CellContext`omega]^4 + 
     4 $CellContext`ecc^2 $CellContext`si^2 Sin[$CellContext`omega]^2 - 
     2 $CellContext`ecc^2 $CellContext`si^4 Sin[$CellContext`omega]^2 - 
     32 $CellContext`si^4 Cos[$CellContext`omega]^2 Sin[$CellContext`omega]^2 + 
     2 $CellContext`ecc^2 $CellContext`si^4 Cos[$CellContext`omega]^2 
      Sin[$CellContext`omega]^2 - 16 $CellContext`si^4 
     Sin[$CellContext`omega]^4 + $CellContext`ecc^2 $CellContext`si^4 
      Sin[$CellContext`omega]^4), 
    8 $CellContext`ecc $CellContext`si^2 Cos[$CellContext`omega] 
     Sin[$CellContext`omega] - 4 $CellContext`ecc $CellContext`si^4 
    Cos[$CellContext`omega] Sin[$CellContext`omega], 
    4 $CellContext`si^4 Cos[$CellContext`omega]^4 + 
    8 $CellContext`si^4 Cos[$CellContext`omega]^2 Sin[$CellContext`omega]^2 + 
    4 $CellContext`si^4 Sin[$CellContext`omega]^4}, 0, 7, 1],
  Editable->False]], "Output",
 CellChangeTimes->{{3.754074260234334*^9, 3.754074277308549*^9}},
 CellLabel->"Out[26]=",ExpressionUUID->"04542604-12f3-434e-bdec-48a10954a488"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Solve", "[", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{"(", 
      RowBox[{
       RowBox[{"4", " ", 
        SuperscriptBox["si", "4"], " ", 
        SuperscriptBox[
         RowBox[{"Cos", "[", "omega", "]"}], "2"], " ", 
        SuperscriptBox[
         RowBox[{"Sin", "[", "omega", "]"}], "2"]}], "-", 
       RowBox[{
        SuperscriptBox["ecc", "2"], " ", 
        SuperscriptBox["si", "4"], " ", 
        SuperscriptBox[
         RowBox[{"Cos", "[", "omega", "]"}], "2"], " ", 
        SuperscriptBox[
         RowBox[{"Sin", "[", "omega", "]"}], "2"]}]}], ")"}], "+", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{
         RowBox[{"-", "4"}], " ", "ecc", " ", 
         SuperscriptBox["si", "2"], " ", 
         RowBox[{"Cos", "[", "omega", "]"}], " ", 
         RowBox[{"Sin", "[", "omega", "]"}]}], "+", 
        RowBox[{"2", " ", "ecc", " ", 
         SuperscriptBox["si", "4"], " ", 
         RowBox[{"Cos", "[", "omega", "]"}], " ", 
         RowBox[{"Sin", "[", "omega", "]"}]}], "-", 
        RowBox[{"2", " ", "ecc", " ", 
         SuperscriptBox["si", "4"], " ", 
         SuperscriptBox[
          RowBox[{"Cos", "[", "omega", "]"}], "3"], " ", 
         RowBox[{"Sin", "[", "omega", "]"}]}], "+", 
        RowBox[{"2", " ", "ecc", " ", 
         SuperscriptBox["si", "4"], " ", 
         RowBox[{"Cos", "[", "omega", "]"}], " ", 
         SuperscriptBox[
          RowBox[{"Sin", "[", "omega", "]"}], "3"]}]}], ")"}], " ", "sinf"}], 
     "+", 
     RowBox[{
      FractionBox["1", "4"], " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"4", " ", 
         SuperscriptBox["ecc", "2"]}], "-", 
        RowBox[{"4", " ", 
         SuperscriptBox["ecc", "2"], " ", 
         SuperscriptBox["si", "2"]}], "+", 
        RowBox[{
         SuperscriptBox["ecc", "2"], " ", 
         SuperscriptBox["si", "4"]}], "-", 
        RowBox[{"4", " ", 
         SuperscriptBox["ecc", "2"], " ", 
         SuperscriptBox["si", "2"], " ", 
         SuperscriptBox[
          RowBox[{"Cos", "[", "omega", "]"}], "2"]}], "+", 
        RowBox[{"2", " ", 
         SuperscriptBox["ecc", "2"], " ", 
         SuperscriptBox["si", "4"], " ", 
         SuperscriptBox[
          RowBox[{"Cos", "[", "omega", "]"}], "2"]}], "-", 
        RowBox[{"16", " ", 
         SuperscriptBox["si", "4"], " ", 
         SuperscriptBox[
          RowBox[{"Cos", "[", "omega", "]"}], "4"]}], "+", 
        RowBox[{
         SuperscriptBox["ecc", "2"], " ", 
         SuperscriptBox["si", "4"], " ", 
         SuperscriptBox[
          RowBox[{"Cos", "[", "omega", "]"}], "4"]}], "+", 
        RowBox[{"4", " ", 
         SuperscriptBox["ecc", "2"], " ", 
         SuperscriptBox["si", "2"], " ", 
         SuperscriptBox[
          RowBox[{"Sin", "[", "omega", "]"}], "2"]}], "-", 
        RowBox[{"2", " ", 
         SuperscriptBox["ecc", "2"], " ", 
         SuperscriptBox["si", "4"], " ", 
         SuperscriptBox[
          RowBox[{"Sin", "[", "omega", "]"}], "2"]}], "-", 
        RowBox[{"32", " ", 
         SuperscriptBox["si", "4"], " ", 
         SuperscriptBox[
          RowBox[{"Cos", "[", "omega", "]"}], "2"], " ", 
         SuperscriptBox[
          RowBox[{"Sin", "[", "omega", "]"}], "2"]}], "+", 
        RowBox[{"2", " ", 
         SuperscriptBox["ecc", "2"], " ", 
         SuperscriptBox["si", "4"], " ", 
         SuperscriptBox[
          RowBox[{"Cos", "[", "omega", "]"}], "2"], " ", 
         SuperscriptBox[
          RowBox[{"Sin", "[", "omega", "]"}], "2"]}], "-", 
        RowBox[{"16", " ", 
         SuperscriptBox["si", "4"], " ", 
         SuperscriptBox[
          RowBox[{"Sin", "[", "omega", "]"}], "4"]}], "+", 
        RowBox[{
         SuperscriptBox["ecc", "2"], " ", 
         SuperscriptBox["si", "4"], " ", 
         SuperscriptBox[
          RowBox[{"Sin", "[", "omega", "]"}], "4"]}]}], ")"}], " ", 
      RowBox[{"sinf", "^", "2"}]}], "+", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"8", " ", "ecc", " ", 
         SuperscriptBox["si", "2"], " ", 
         RowBox[{"Cos", "[", "omega", "]"}], " ", 
         RowBox[{"Sin", "[", "omega", "]"}]}], "-", 
        RowBox[{"4", " ", "ecc", " ", 
         SuperscriptBox["si", "4"], " ", 
         RowBox[{"Cos", "[", "omega", "]"}], " ", 
         RowBox[{"Sin", "[", "omega", "]"}]}]}], ")"}], " ", 
      RowBox[{"sinf", "^", "3"}]}], "+", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"4", " ", 
         SuperscriptBox["si", "4"], " ", 
         SuperscriptBox[
          RowBox[{"Cos", "[", "omega", "]"}], "4"]}], "+", 
        RowBox[{"8", " ", 
         SuperscriptBox["si", "4"], " ", 
         SuperscriptBox[
          RowBox[{"Cos", "[", "omega", "]"}], "2"], " ", 
         SuperscriptBox[
          RowBox[{"Sin", "[", "omega", "]"}], "2"]}], "+", 
        RowBox[{"4", " ", 
         SuperscriptBox["si", "4"], " ", 
         SuperscriptBox[
          RowBox[{"Sin", "[", "omega", "]"}], "4"]}]}], ")"}], " ", 
      RowBox[{"sinf", "^", "4"}]}]}], " ", "\[Equal]", " ", "0"}], ",", 
   "sinf"}], "]"}]], "Input",
 CellChangeTimes->{{3.754074292311687*^9, 3.754074312086014*^9}},
 CellLabel->"In[27]:=",ExpressionUUID->"d52e8a6a-bef1-4248-9b8e-9efa77596a74"],

Cell[BoxData[
 InterpretationBox[
  TagBox[
   FrameBox[GridBox[{
      {
       ItemBox[
        TagBox[
         RowBox[{"{", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"sinf", "\[Rule]", 
             RowBox[{
              RowBox[{"-", 
               FractionBox[
                RowBox[{
                 RowBox[{"2", " ", "ecc", " ", 
                  RowBox[{"Cos", "[", "omega", "]"}], " ", 
                  RowBox[{"Sin", "[", "omega", "]"}]}], "-", 
                 RowBox[{"ecc", " ", 
                  SuperscriptBox["si", "2"], " ", 
                  RowBox[{"Cos", "[", "omega", "]"}], " ", 
                  RowBox[{"Sin", "[", "omega", "]"}]}]}], 
                RowBox[{"4", " ", 
                 SuperscriptBox["si", "2"], " ", 
                 SuperscriptBox[
                  RowBox[{"(", 
                   RowBox[{
                    SuperscriptBox[
                    RowBox[{"Cos", "[", "omega", "]"}], "2"], "+", 
                    SuperscriptBox[
                    RowBox[{"Sin", "[", "omega", "]"}], "2"]}], ")"}], 
                  "2"]}]]}], "-", 
              RowBox[{
               FractionBox["1", "2"], " ", 
               SqrtBox[
                RowBox[{
                 FractionBox[
                  SuperscriptBox[
                   RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    TemplateBox[{"2"},
                    "OutputSizeLimit`Skeleton"], " ", 
                    TemplateBox[{"1"},
                    "OutputSizeLimit`Skeleton"]}], "-", 
                    TemplateBox[{"1"},
                    "OutputSizeLimit`Skeleton"]}], ")"}], "2"], 
                  RowBox[{"4", " ", 
                   SuperscriptBox["si", "4"], " ", 
                   SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    TemplateBox[{"1"},
                    "OutputSizeLimit`Skeleton"], "2"], "+", 
                    TemplateBox[{"1"},
                    "OutputSizeLimit`Skeleton"]}], ")"}], "4"]}]], "-", 
                 FractionBox[
                  TemplateBox[{"1"},
                   "OutputSizeLimit`Skeleton"], 
                  RowBox[{"16", " ", 
                   SuperscriptBox["si", "4"], " ", 
                   SuperscriptBox[
                    TemplateBox[{"1"},
                    "OutputSizeLimit`Skeleton"], "2"]}]], "+", 
                 FractionBox[
                  TemplateBox[{"1"},
                   "OutputSizeLimit`Skeleton"], 
                  TemplateBox[{"1"},
                   "OutputSizeLimit`Skeleton"]], "+", 
                 FractionBox[
                  TemplateBox[{"1"},
                   "OutputSizeLimit`Skeleton"], 
                  TemplateBox[{"1"},
                   "OutputSizeLimit`Skeleton"]], "+", 
                 FractionBox[
                  SuperscriptBox[
                   RowBox[{"(", 
                    TemplateBox[{"1"},
                    "OutputSizeLimit`Skeleton"], ")"}], 
                   RowBox[{"1", "/", "3"}]], 
                  RowBox[{"48", " ", 
                   SuperscriptBox["2", 
                    RowBox[{"1", "/", "3"}]], " ", 
                   SuperscriptBox["si", "4"]}]]}]]}], "-", 
              RowBox[{
               FractionBox["1", "2"], " ", 
               SqrtBox[
                TemplateBox[{"1"},
                 "OutputSizeLimit`Skeleton"]]}]}]}], "}"}], ",", 
           TemplateBox[{"2"},
            "OutputSizeLimit`Skeleton"], ",", 
           RowBox[{"{", 
            RowBox[{"sinf", "\[Rule]", 
             TemplateBox[{"1"},
              "OutputSizeLimit`Skeleton"]}], "}"}]}], "}"}],
         Short[#, 5]& ],
        BaseStyle->{Deployed -> False},
        StripOnInput->False]},
      {GridBox[{
         {
          TagBox[
           TooltipBox[
            StyleBox[
             StyleBox[
              DynamicBox[ToBoxes[
                FEPrivate`FrontEndResource[
                "FEStrings", "sizeBriefExplanation"], StandardForm],
               ImageSizeCache->{58., {2., 8.}}],
              StripOnInput->False,
              DynamicUpdating->True], "OSLText",
             StripOnInput->False],
            StyleBox[
             DynamicBox[
              ToBoxes[
               FEPrivate`FrontEndResource["FEStrings", "sizeExplanation"], 
               StandardForm]], DynamicUpdating -> True, StripOnInput -> 
             False]],
           Annotation[#, 
            Style[
             Dynamic[
              FEPrivate`FrontEndResource["FEStrings", "sizeExplanation"]], 
             DynamicUpdating -> True], "Tooltip"]& ], 
          ButtonBox[
           PaneSelectorBox[{False->
            StyleBox[
             StyleBox[
              DynamicBox[ToBoxes[
                FEPrivate`FrontEndResource["FEStrings", "sizeShowLess"], 
                StandardForm],
               ImageSizeCache->{50., {0., 8.}}],
              StripOnInput->False,
              DynamicUpdating->True], "OSLControl",
             StripOnInput->False], True->
            StyleBox[
             StyleBox[
              DynamicBox[ToBoxes[
                FEPrivate`FrontEndResource["FEStrings", "sizeShowLess"], 
                StandardForm]],
              StripOnInput->False,
              DynamicUpdating->True], "OSLControlActive",
             StripOnInput->False]}, Dynamic[
             CurrentValue["MouseOver"]],
            Alignment->Center,
            FrameMargins->0,
            ImageSize->{Automatic, 25}],
           Appearance->None,
           BaselinePosition->Baseline,
           
           ButtonFunction:>OutputSizeLimit`ButtonFunction[
            OutputSizeLimit`Defer, 27, 25571763906033481186, 5/2],
           Enabled->True,
           Evaluator->Automatic,
           Method->"Queued"], 
          ButtonBox[
           PaneSelectorBox[{False->
            StyleBox[
             StyleBox[
              DynamicBox[ToBoxes[
                FEPrivate`FrontEndResource["FEStrings", "sizeShowMore"], 
                StandardForm],
               ImageSizeCache->{56., {0., 8.}}],
              StripOnInput->False,
              DynamicUpdating->True], "OSLControl",
             StripOnInput->False], True->
            StyleBox[
             StyleBox[
              DynamicBox[ToBoxes[
                FEPrivate`FrontEndResource["FEStrings", "sizeShowMore"], 
                StandardForm]],
              StripOnInput->False,
              DynamicUpdating->True], "OSLControlActive",
             StripOnInput->False]}, Dynamic[
             CurrentValue["MouseOver"]],
            Alignment->Center,
            FrameMargins->0,
            ImageSize->{Automatic, 25}],
           Appearance->None,
           BaselinePosition->Baseline,
           
           ButtonFunction:>OutputSizeLimit`ButtonFunction[
            OutputSizeLimit`Defer, 27, 25571763906033481186, 5 2],
           Enabled->True,
           Evaluator->Automatic,
           Method->"Queued"], 
          ButtonBox[
           PaneSelectorBox[{False->
            StyleBox[
             StyleBox[
              DynamicBox[ToBoxes[
                FEPrivate`FrontEndResource["FEStrings", "sizeShowAll"], 
                StandardForm],
               ImageSizeCache->{42., {0., 8.}}],
              StripOnInput->False,
              DynamicUpdating->True], "OSLControl",
             StripOnInput->False], True->
            StyleBox[
             StyleBox[
              DynamicBox[ToBoxes[
                FEPrivate`FrontEndResource["FEStrings", "sizeShowAll"], 
                StandardForm]],
              StripOnInput->False,
              DynamicUpdating->True], "OSLControlActive",
             StripOnInput->False]}, Dynamic[
             CurrentValue["MouseOver"]],
            Alignment->Center,
            FrameMargins->0,
            ImageSize->{Automatic, 25}],
           Appearance->None,
           BaselinePosition->Baseline,
           
           ButtonFunction:>OutputSizeLimit`ButtonFunction[
            OutputSizeLimit`Defer, 27, 25571763906033481186, Infinity],
           Enabled->True,
           Evaluator->Automatic,
           Method->"Queued"], 
          ButtonBox[
           PaneSelectorBox[{False->
            StyleBox[
             StyleBox[
              DynamicBox[ToBoxes[
                FEPrivate`FrontEndResource["FEStrings", "sizeChangeLimit"], 
                StandardForm],
               ImageSizeCache->{74., {0., 8.}}],
              StripOnInput->False,
              DynamicUpdating->True], "OSLControl",
             StripOnInput->False], True->
            StyleBox[
             StyleBox[
              DynamicBox[ToBoxes[
                FEPrivate`FrontEndResource["FEStrings", "sizeChangeLimit"], 
                StandardForm]],
              StripOnInput->False,
              DynamicUpdating->True], "OSLControlActive",
             StripOnInput->False]}, Dynamic[
             CurrentValue["MouseOver"]],
            Alignment->Center,
            FrameMargins->0,
            ImageSize->{Automatic, 25}],
           Appearance->None,
           BaselinePosition->Baseline,
           ButtonFunction:>FrontEndExecute[{
              FrontEnd`SetOptions[
              FrontEnd`$FrontEnd, 
               FrontEnd`PreferencesSettings -> {"Page" -> "Advanced"}], 
              FrontEnd`FrontEndToken["PreferencesDialog"]}],
           Evaluator->None,
           Method->"Preemptive"]}
        },
        AutoDelete->False,
        FrameStyle->GrayLevel[0.85],
        GridBoxDividers->{"Columns" -> {False, {True}}},
        GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
        GridBoxSpacings->{"Columns" -> {{2}}}]}
     },
     DefaultBaseStyle->"Column",
     GridBoxAlignment->{
      "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
       "RowsIndexed" -> {}},
     GridBoxDividers->{
      "Columns" -> {{False}}, "ColumnsIndexed" -> {}, "Rows" -> {{False}}, 
       "RowsIndexed" -> {}},
     GridBoxItemSize->{
      "Columns" -> {{Automatic}}, "ColumnsIndexed" -> {}, "Rows" -> {{1.}}, 
       "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.5599999999999999]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], 
         Offset[1.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    BaseStyle->"OutputSizeLimit",
    FrameMargins->{{12, 12}, {0, 15}},
    FrameStyle->GrayLevel[0.85],
    RoundingRadius->5,
    StripOnInput->False],
   Deploy,
   DefaultBaseStyle->"Deploy"],
  If[25571763906033481186 === $SessionID, 
   Out[27], Message[
     MessageName[Syntax, "noinfoker"]]; Missing["NotAvailable"]; 
   Null]]], "Output",
 CellChangeTimes->{3.7540743127168303`*^9},
 CellLabel->"Out[27]=",ExpressionUUID->"47a64db1-4f12-4628-a3b3-714e4540e0c8"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"FullSimplify", "[", 
  RowBox[{
   RowBox[{"(", 
    RowBox[{
     RowBox[{"4", " ", 
      SuperscriptBox["si", "4"], " ", 
      SuperscriptBox[
       RowBox[{"Cos", "[", "omega", "]"}], "2"], " ", 
      SuperscriptBox[
       RowBox[{"Sin", "[", "omega", "]"}], "2"]}], "-", 
     RowBox[{
      SuperscriptBox["ecc", "2"], " ", 
      SuperscriptBox["si", "4"], " ", 
      SuperscriptBox[
       RowBox[{"Cos", "[", "omega", "]"}], "2"], " ", 
      SuperscriptBox[
       RowBox[{"Sin", "[", "omega", "]"}], "2"]}]}], ")"}], "+", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      RowBox[{
       RowBox[{"-", "4"}], " ", "ecc", " ", 
       SuperscriptBox["si", "2"], " ", 
       RowBox[{"Cos", "[", "omega", "]"}], " ", 
       RowBox[{"Sin", "[", "omega", "]"}]}], "+", 
      RowBox[{"2", " ", "ecc", " ", 
       SuperscriptBox["si", "4"], " ", 
       RowBox[{"Cos", "[", "omega", "]"}], " ", 
       RowBox[{"Sin", "[", "omega", "]"}]}], "-", 
      RowBox[{"2", " ", "ecc", " ", 
       SuperscriptBox["si", "4"], " ", 
       SuperscriptBox[
        RowBox[{"Cos", "[", "omega", "]"}], "3"], " ", 
       RowBox[{"Sin", "[", "omega", "]"}]}], "+", 
      RowBox[{"2", " ", "ecc", " ", 
       SuperscriptBox["si", "4"], " ", 
       RowBox[{"Cos", "[", "omega", "]"}], " ", 
       SuperscriptBox[
        RowBox[{"Sin", "[", "omega", "]"}], "3"]}]}], ")"}], " ", "sinf"}], 
   "+", 
   RowBox[{
    FractionBox["1", "4"], " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"4", " ", 
       SuperscriptBox["ecc", "2"]}], "-", 
      RowBox[{"4", " ", 
       SuperscriptBox["ecc", "2"], " ", 
       SuperscriptBox["si", "2"]}], "+", 
      RowBox[{
       SuperscriptBox["ecc", "2"], " ", 
       SuperscriptBox["si", "4"]}], "-", 
      RowBox[{"4", " ", 
       SuperscriptBox["ecc", "2"], " ", 
       SuperscriptBox["si", "2"], " ", 
       SuperscriptBox[
        RowBox[{"Cos", "[", "omega", "]"}], "2"]}], "+", 
      RowBox[{"2", " ", 
       SuperscriptBox["ecc", "2"], " ", 
       SuperscriptBox["si", "4"], " ", 
       SuperscriptBox[
        RowBox[{"Cos", "[", "omega", "]"}], "2"]}], "-", 
      RowBox[{"16", " ", 
       SuperscriptBox["si", "4"], " ", 
       SuperscriptBox[
        RowBox[{"Cos", "[", "omega", "]"}], "4"]}], "+", 
      RowBox[{
       SuperscriptBox["ecc", "2"], " ", 
       SuperscriptBox["si", "4"], " ", 
       SuperscriptBox[
        RowBox[{"Cos", "[", "omega", "]"}], "4"]}], "+", 
      RowBox[{"4", " ", 
       SuperscriptBox["ecc", "2"], " ", 
       SuperscriptBox["si", "2"], " ", 
       SuperscriptBox[
        RowBox[{"Sin", "[", "omega", "]"}], "2"]}], "-", 
      RowBox[{"2", " ", 
       SuperscriptBox["ecc", "2"], " ", 
       SuperscriptBox["si", "4"], " ", 
       SuperscriptBox[
        RowBox[{"Sin", "[", "omega", "]"}], "2"]}], "-", 
      RowBox[{"32", " ", 
       SuperscriptBox["si", "4"], " ", 
       SuperscriptBox[
        RowBox[{"Cos", "[", "omega", "]"}], "2"], " ", 
       SuperscriptBox[
        RowBox[{"Sin", "[", "omega", "]"}], "2"]}], "+", 
      RowBox[{"2", " ", 
       SuperscriptBox["ecc", "2"], " ", 
       SuperscriptBox["si", "4"], " ", 
       SuperscriptBox[
        RowBox[{"Cos", "[", "omega", "]"}], "2"], " ", 
       SuperscriptBox[
        RowBox[{"Sin", "[", "omega", "]"}], "2"]}], "-", 
      RowBox[{"16", " ", 
       SuperscriptBox["si", "4"], " ", 
       SuperscriptBox[
        RowBox[{"Sin", "[", "omega", "]"}], "4"]}], "+", 
      RowBox[{
       SuperscriptBox["ecc", "2"], " ", 
       SuperscriptBox["si", "4"], " ", 
       SuperscriptBox[
        RowBox[{"Sin", "[", "omega", "]"}], "4"]}]}], ")"}], " ", 
    RowBox[{"sinf", "^", "2"}]}], "+", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      RowBox[{"8", " ", "ecc", " ", 
       SuperscriptBox["si", "2"], " ", 
       RowBox[{"Cos", "[", "omega", "]"}], " ", 
       RowBox[{"Sin", "[", "omega", "]"}]}], "-", 
      RowBox[{"4", " ", "ecc", " ", 
       SuperscriptBox["si", "4"], " ", 
       RowBox[{"Cos", "[", "omega", "]"}], " ", 
       RowBox[{"Sin", "[", "omega", "]"}]}]}], ")"}], " ", 
    RowBox[{"sinf", "^", "3"}]}], "+", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      RowBox[{"4", " ", 
       SuperscriptBox["si", "4"], " ", 
       SuperscriptBox[
        RowBox[{"Cos", "[", "omega", "]"}], "4"]}], "+", 
      RowBox[{"8", " ", 
       SuperscriptBox["si", "4"], " ", 
       SuperscriptBox[
        RowBox[{"Cos", "[", "omega", "]"}], "2"], " ", 
       SuperscriptBox[
        RowBox[{"Sin", "[", "omega", "]"}], "2"]}], "+", 
      RowBox[{"4", " ", 
       SuperscriptBox["si", "4"], " ", 
       SuperscriptBox[
        RowBox[{"Sin", "[", "omega", "]"}], "4"]}]}], ")"}], " ", 
    RowBox[{"sinf", "^", "4"}]}]}], "]"}]], "Input",
 CellChangeTimes->{{3.754074323003889*^9, 3.754074327230991*^9}},
 CellLabel->"In[28]:=",ExpressionUUID->"88426e44-8dea-4e0e-bf8b-a2b71c6aad37"],

Cell[BoxData[
 RowBox[{
  FractionBox["1", "8"], " ", 
  RowBox[{"(", 
   RowBox[{
    RowBox[{
     RowBox[{"-", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "4"}], "+", 
        SuperscriptBox["ecc", "2"]}], ")"}]}], " ", 
     SuperscriptBox["si", "4"]}], "+", 
    RowBox[{"4", " ", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{
        RowBox[{"-", "8"}], " ", 
        SuperscriptBox["si", "4"]}], "+", 
       RowBox[{
        SuperscriptBox["ecc", "2"], " ", 
        RowBox[{"(", 
         RowBox[{"2", "-", 
          RowBox[{"2", " ", 
           SuperscriptBox["si", "2"]}], "+", 
          SuperscriptBox["si", "4"]}], ")"}]}]}], ")"}], " ", 
     SuperscriptBox["sinf", "2"]}], "+", 
    RowBox[{"32", " ", 
     SuperscriptBox["si", "4"], " ", 
     SuperscriptBox["sinf", "4"]}], "+", 
    RowBox[{
     SuperscriptBox["si", "2"], " ", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"4", " ", 
        SuperscriptBox["ecc", "2"], " ", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"-", "2"}], "+", 
          SuperscriptBox["si", "2"]}], ")"}], " ", 
        SuperscriptBox["sinf", "2"], " ", 
        RowBox[{"Cos", "[", 
         RowBox[{"2", " ", "omega"}], "]"}]}], "+", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{
          RowBox[{"-", "4"}], "+", 
          SuperscriptBox["ecc", "2"]}], ")"}], " ", 
        SuperscriptBox["si", "2"], " ", 
        RowBox[{"Cos", "[", 
         RowBox[{"4", " ", "omega"}], "]"}]}], "-", 
       RowBox[{"8", " ", "ecc", " ", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"-", "2"}], "+", 
          SuperscriptBox["si", "2"]}], ")"}], " ", "sinf", " ", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"-", "1"}], "+", 
          RowBox[{"2", " ", 
           SuperscriptBox["sinf", "2"]}]}], ")"}], " ", 
        RowBox[{"Sin", "[", 
         RowBox[{"2", " ", "omega"}], "]"}]}], "-", 
       RowBox[{"4", " ", "ecc", " ", 
        SuperscriptBox["si", "2"], " ", "sinf", " ", 
        RowBox[{"Sin", "[", 
         RowBox[{"4", " ", "omega"}], "]"}]}]}], ")"}]}]}], ")"}]}]], "Output",\

 CellChangeTimes->{3.75407432895986*^9},
 CellLabel->"Out[28]=",ExpressionUUID->"7c407a4b-d95f-4973-8724-e5c1b0a8045c"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Solve", "[", 
  RowBox[{
   RowBox[{
    RowBox[{"Out", "[", "28", "]"}], " ", "\[Equal]", " ", "0"}], ",", 
   "sinf"}], "]"}]], "Input",
 CellChangeTimes->{{3.754074334504529*^9, 3.7540743410673532`*^9}},
 CellLabel->"In[29]:=",ExpressionUUID->"54a9678c-5d93-4227-bbea-8162abf29706"],

Cell[BoxData[
 InterpretationBox[
  TagBox[
   FrameBox[GridBox[{
      {
       ItemBox[
        TagBox[
         RowBox[{"{", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"sinf", "\[Rule]", 
             RowBox[{
              RowBox[{"-", 
               FractionBox[
                RowBox[{
                 RowBox[{"2", " ", "ecc", " ", 
                  RowBox[{"Sin", "[", 
                   RowBox[{"2", " ", "omega"}], "]"}]}], "-", 
                 RowBox[{"ecc", " ", 
                  SuperscriptBox["si", "2"], " ", 
                  RowBox[{"Sin", "[", 
                   RowBox[{"2", " ", "omega"}], "]"}]}]}], 
                RowBox[{"8", " ", 
                 SuperscriptBox["si", "2"]}]]}], "-", 
              RowBox[{
               FractionBox["1", "2"], " ", 
               RowBox[{"\[Sqrt]", 
                RowBox[{"(", 
                 RowBox[{
                  RowBox[{"-", 
                   FractionBox[
                    RowBox[{
                    RowBox[{"2", " ", 
                    SuperscriptBox["ecc", "2"]}], "-", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["ecc", "2"], " ", 
                    SuperscriptBox["si", "2"]}], "-", 
                    RowBox[{"8", " ", 
                    SuperscriptBox["si", "4"]}], "+", 
                    RowBox[{
                    SuperscriptBox["ecc", "2"], " ", 
                    SuperscriptBox["si", "4"]}], "-", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["ecc", "2"], " ", 
                    SuperscriptBox["si", "2"], " ", 
                    RowBox[{"Cos", "[", 
                    RowBox[{"2", " ", "omega"}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox["ecc", "2"], " ", 
                    SuperscriptBox["si", "4"], " ", 
                    RowBox[{"Cos", "[", 
                    RowBox[{"2", " ", "omega"}], "]"}]}]}], 
                    RowBox[{"12", " ", 
                    SuperscriptBox["si", "4"]}]]}], "+", 
                  FractionBox[
                   SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", "ecc", " ", 
                    RowBox[{"Sin", "[", 
                    RowBox[{"2", " ", "omega"}], "]"}]}], "-", 
                    RowBox[{"ecc", " ", 
                    SuperscriptBox["si", "2"], " ", 
                    RowBox[{"Sin", "[", 
                    RowBox[{"2", " ", "omega"}], "]"}]}]}], ")"}], "2"], 
                   RowBox[{"16", " ", 
                    SuperscriptBox["si", "4"]}]], "+", 
                  RowBox[{
                   RowBox[{"(", 
                    RowBox[{
                    RowBox[{"16", " ", 
                    SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    SuperscriptBox["ecc", "2"]}], "-", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["ecc", "2"], " ", 
                    SuperscriptBox["si", "2"]}], "-", 
                    RowBox[{"8", " ", 
                    SuperscriptBox["si", "4"]}], "+", 
                    RowBox[{
                    SuperscriptBox["ecc", "2"], " ", 
                    SuperscriptBox["si", "4"]}], "-", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["ecc", "2"], " ", 
                    SuperscriptBox["si", "2"], " ", 
                    RowBox[{"Cos", "[", 
                    RowBox[{"2", " ", "omega"}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox["ecc", "2"], " ", 
                    SuperscriptBox["si", "4"], " ", 
                    RowBox[{"Cos", "[", 
                    RowBox[{"2", " ", "omega"}], "]"}]}]}], ")"}], "2"]}], 
                    "+", 
                    RowBox[{"384", " ", 
                    SuperscriptBox["si", "4"], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"4", " ", 
                    SuperscriptBox["si", "4"]}], "-", 
                    RowBox[{
                    SuperscriptBox["ecc", "2"], " ", 
                    SuperscriptBox["si", "4"]}], "-", 
                    RowBox[{"4", " ", 
                    SuperscriptBox["si", "4"], " ", 
                    RowBox[{"Cos", "[", 
                    RowBox[{"4", " ", "omega"}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox["ecc", "2"], " ", 
                    SuperscriptBox["si", "4"], " ", 
                    RowBox[{"Cos", "[", 
                    RowBox[{"4", " ", "omega"}], "]"}]}]}], ")"}]}], "+", 
                    RowBox[{"192", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", "ecc", " ", 
                    SuperscriptBox["si", "2"], " ", 
                    RowBox[{"Sin", "[", 
                    RowBox[{"2", " ", "omega"}], "]"}]}], "+", 
                    RowBox[{"ecc", " ", 
                    SuperscriptBox["si", "4"], " ", 
                    RowBox[{"Sin", "[", 
                    RowBox[{"2", " ", "omega"}], "]"}]}]}], ")"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "4"}], " ", "ecc", " ", 
                    SuperscriptBox["si", "2"], " ", 
                    RowBox[{"Sin", "[", 
                    RowBox[{"2", " ", "omega"}], "]"}]}], "+", 
                    RowBox[{"2", " ", "ecc", " ", 
                    SuperscriptBox["si", "4"], " ", 
                    RowBox[{"Sin", "[", 
                    RowBox[{"2", " ", "omega"}], "]"}]}], "-", 
                    RowBox[{"ecc", " ", 
                    SuperscriptBox["si", "4"], " ", 
                    RowBox[{"Sin", "[", 
                    RowBox[{"4", " ", "omega"}], "]"}]}]}], ")"}]}]}], ")"}], 
                   "/", 
                   RowBox[{"(", 
                    RowBox[{"48", " ", 
                    SuperscriptBox["2", 
                    RowBox[{"2", "/", "3"}]], " ", 
                    SuperscriptBox["si", "4"], " ", 
                    SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"128", " ", 
                    SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    SuperscriptBox["ecc", "2"]}], "-", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["ecc", "2"], " ", 
                    SuperscriptBox["si", "2"]}], "-", 
                    RowBox[{"8", " ", 
                    SuperscriptBox["si", "4"]}], "+", 
                    RowBox[{
                    SuperscriptBox["ecc", "2"], " ", 
                    SuperscriptBox["si", "4"]}], "-", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["ecc", "2"], " ", 
                    SuperscriptBox["si", "2"], " ", 
                    RowBox[{"Cos", "[", 
                    RowBox[{"2", " ", "omega"}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox["ecc", "2"], " ", 
                    SuperscriptBox["si", "4"], " ", 
                    RowBox[{"Cos", "[", 
                    RowBox[{"2", " ", "omega"}], "]"}]}]}], ")"}], "3"]}], 
                    "-", 
                    RowBox[{"9216", " ", 
                    SuperscriptBox["si", "4"], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    SuperscriptBox["ecc", "2"]}], "-", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["ecc", "2"], " ", 
                    SuperscriptBox["si", "2"]}], "-", 
                    RowBox[{"8", " ", 
                    SuperscriptBox["si", "4"]}], "+", 
                    RowBox[{
                    SuperscriptBox["ecc", "2"], " ", 
                    SuperscriptBox["si", "4"]}], "-", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["ecc", "2"], " ", 
                    SuperscriptBox["si", "2"], " ", 
                    RowBox[{"Cos", "[", 
                    RowBox[{"2", " ", "omega"}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox["ecc", "2"], " ", 
                    SuperscriptBox["si", "4"], " ", 
                    RowBox[{"Cos", "[", 
                    RowBox[{"2", " ", "omega"}], "]"}]}]}], ")"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"4", " ", 
                    SuperscriptBox["si", "4"]}], "-", 
                    RowBox[{
                    SuperscriptBox["ecc", "2"], " ", 
                    SuperscriptBox["si", "4"]}], "-", 
                    RowBox[{"4", " ", 
                    SuperscriptBox["si", "4"], " ", 
                    RowBox[{"Cos", "[", 
                    RowBox[{"4", " ", "omega"}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox["ecc", "2"], " ", 
                    SuperscriptBox["si", "4"], " ", 
                    RowBox[{"Cos", "[", 
                    RowBox[{"4", " ", "omega"}], "]"}]}]}], ")"}]}], "+", 
                    RowBox[{"6912", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"4", " ", 
                    SuperscriptBox["si", "4"]}], "-", 
                    RowBox[{
                    SuperscriptBox["ecc", "2"], " ", 
                    SuperscriptBox["si", "4"]}], "-", 
                    RowBox[{"4", " ", 
                    SuperscriptBox["si", "4"], " ", 
                    RowBox[{"Cos", "[", 
                    RowBox[{"4", " ", "omega"}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox["ecc", "2"], " ", 
                    SuperscriptBox["si", "4"], " ", 
                    RowBox[{"Cos", "[", 
                    RowBox[{"4", " ", "omega"}], "]"}]}]}], ")"}], " ", 
                    SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", "ecc", " ", 
                    SuperscriptBox["si", "2"], " ", 
                    RowBox[{"Sin", "[", 
                    RowBox[{"2", " ", "omega"}], "]"}]}], "+", 
                    RowBox[{"ecc", " ", 
                    SuperscriptBox["si", "4"], " ", 
                    RowBox[{"Sin", "[", 
                    RowBox[{"2", " ", "omega"}], "]"}]}]}], ")"}], "2"]}], 
                    "+", 
                    RowBox[{"2304", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    SuperscriptBox["ecc", "2"]}], "-", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["ecc", "2"], " ", 
                    SuperscriptBox["si", "2"]}], "-", 
                    RowBox[{"8", " ", 
                    SuperscriptBox["si", "4"]}], "+", 
                    RowBox[{
                    SuperscriptBox["ecc", "2"], " ", 
                    SuperscriptBox["si", "4"]}], "-", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["ecc", "2"], " ", 
                    SuperscriptBox["si", "2"], " ", 
                    RowBox[{"Cos", "[", 
                    RowBox[{"2", " ", "omega"}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox["ecc", "2"], " ", 
                    SuperscriptBox["si", "4"], " ", 
                    RowBox[{"Cos", "[", 
                    RowBox[{"2", " ", "omega"}], "]"}]}]}], ")"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", "ecc", " ", 
                    SuperscriptBox["si", "2"], " ", 
                    RowBox[{"Sin", "[", 
                    RowBox[{"2", " ", "omega"}], "]"}]}], "+", 
                    RowBox[{"ecc", " ", 
                    SuperscriptBox["si", "4"], " ", 
                    RowBox[{"Sin", "[", 
                    RowBox[{"2", " ", "omega"}], "]"}]}]}], ")"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "4"}], " ", "ecc", " ", 
                    SuperscriptBox["si", "2"], " ", 
                    RowBox[{"Sin", "[", 
                    RowBox[{"2", " ", "omega"}], "]"}]}], "+", 
                    RowBox[{"2", " ", "ecc", " ", 
                    SuperscriptBox["si", "4"], " ", 
                    RowBox[{"Sin", "[", 
                    RowBox[{"2", " ", "omega"}], "]"}]}], "-", 
                    RowBox[{"ecc", " ", 
                    SuperscriptBox["si", "4"], " ", 
                    RowBox[{"Sin", "[", 
                    RowBox[{"4", " ", "omega"}], "]"}]}]}], ")"}]}], "+", 
                    RowBox[{"13824", " ", 
                    SuperscriptBox["si", "4"], " ", 
                    SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "4"}], " ", "ecc", " ", 
                    SuperscriptBox["si", "2"], " ", 
                    RowBox[{"Sin", "[", 
                    RowBox[{"2", " ", "omega"}], "]"}]}], "+", 
                    RowBox[{"2", " ", "ecc", " ", 
                    SuperscriptBox["si", "4"], " ", 
                    RowBox[{"Sin", "[", 
                    RowBox[{"2", " ", "omega"}], "]"}]}], "-", 
                    RowBox[{"ecc", " ", 
                    SuperscriptBox["si", "4"], " ", 
                    RowBox[{"Sin", "[", 
                    RowBox[{"4", " ", "omega"}], "]"}]}]}], ")"}], "2"]}], 
                    "+", 
                    RowBox[{"\[Sqrt]", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "4"}], " ", 
                    SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"16", " ", 
                    SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    SuperscriptBox["ecc", "2"]}], "-", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["ecc", "2"], " ", 
                    SuperscriptBox["si", "2"]}], "-", 
                    RowBox[{"8", " ", 
                    SuperscriptBox["si", "4"]}], "+", 
                    RowBox[{
                    SuperscriptBox["ecc", "2"], " ", 
                    SuperscriptBox["si", "4"]}], "-", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["ecc", "2"], " ", 
                    SuperscriptBox["si", "2"], " ", 
                    RowBox[{"Cos", "[", 
                    RowBox[{"2", " ", "omega"}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox["ecc", "2"], " ", 
                    SuperscriptBox["si", "4"], " ", 
                    RowBox[{"Cos", "[", 
                    RowBox[{"2", " ", "omega"}], "]"}]}]}], ")"}], "2"]}], 
                    "+", 
                    RowBox[{"384", " ", 
                    SuperscriptBox["si", "4"], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"4", " ", 
                    SuperscriptBox["si", "4"]}], "-", 
                    RowBox[{
                    SuperscriptBox["ecc", "2"], " ", 
                    SuperscriptBox["si", "4"]}], "-", 
                    RowBox[{"4", " ", 
                    SuperscriptBox["si", "4"], " ", 
                    RowBox[{"Cos", "[", 
                    RowBox[{"4", " ", "omega"}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox["ecc", "2"], " ", 
                    SuperscriptBox["si", "4"], " ", 
                    RowBox[{"Cos", "[", 
                    RowBox[{"4", " ", "omega"}], "]"}]}]}], ")"}]}], "+", 
                    RowBox[{"192", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", "ecc", " ", 
                    SuperscriptBox["si", "2"], " ", 
                    RowBox[{"Sin", "[", 
                    RowBox[{"2", " ", "omega"}], "]"}]}], "+", 
                    RowBox[{"ecc", " ", 
                    SuperscriptBox["si", "4"], " ", 
                    RowBox[{"Sin", "[", 
                    RowBox[{"2", " ", "omega"}], "]"}]}]}], ")"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "4"}], " ", "ecc", " ", 
                    SuperscriptBox["si", "2"], " ", 
                    RowBox[{"Sin", "[", 
                    RowBox[{"2", " ", "omega"}], "]"}]}], "+", 
                    RowBox[{"2", " ", "ecc", " ", 
                    SuperscriptBox["si", "4"], " ", 
                    RowBox[{"Sin", "[", 
                    RowBox[{"2", " ", "omega"}], "]"}]}], "-", 
                    RowBox[{"ecc", " ", 
                    SuperscriptBox["si", "4"], " ", 
                    RowBox[{"Sin", "[", 
                    RowBox[{"4", " ", "omega"}], "]"}]}]}], ")"}]}]}], ")"}], 
                    "3"]}], "+", 
                    SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"128", " ", 
                    SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    SuperscriptBox["ecc", "2"]}], "-", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["ecc", "2"], " ", 
                    SuperscriptBox["si", "2"]}], "-", 
                    RowBox[{"8", " ", 
                    SuperscriptBox["si", "4"]}], "+", 
                    RowBox[{
                    SuperscriptBox["ecc", "2"], " ", 
                    SuperscriptBox["si", "4"]}], "-", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["ecc", "2"], " ", 
                    SuperscriptBox["si", "2"], " ", 
                    RowBox[{"Cos", "[", 
                    RowBox[{"2", " ", "omega"}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox["ecc", "2"], " ", 
                    SuperscriptBox["si", "4"], " ", 
                    RowBox[{"Cos", "[", 
                    RowBox[{"2", " ", "omega"}], "]"}]}]}], ")"}], "3"]}], 
                    "-", 
                    RowBox[{"9216", " ", 
                    SuperscriptBox["si", "4"], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    SuperscriptBox["ecc", "2"]}], "-", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["ecc", "2"], " ", 
                    SuperscriptBox["si", "2"]}], "-", 
                    RowBox[{"8", " ", 
                    SuperscriptBox["si", "4"]}], "+", 
                    RowBox[{
                    SuperscriptBox["ecc", "2"], " ", 
                    SuperscriptBox["si", "4"]}], "-", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["ecc", "2"], " ", 
                    SuperscriptBox["si", "2"], " ", 
                    RowBox[{"Cos", "[", 
                    RowBox[{"2", " ", "omega"}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox["ecc", "2"], " ", 
                    SuperscriptBox["si", "4"], " ", 
                    RowBox[{"Cos", "[", 
                    RowBox[{"2", " ", "omega"}], "]"}]}]}], ")"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"4", " ", 
                    SuperscriptBox["si", "4"]}], "-", 
                    RowBox[{
                    SuperscriptBox["ecc", "2"], " ", 
                    SuperscriptBox["si", "4"]}], "-", 
                    RowBox[{"4", " ", 
                    SuperscriptBox["si", "4"], " ", 
                    RowBox[{"Cos", "[", 
                    RowBox[{"4", " ", "omega"}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox["ecc", "2"], " ", 
                    SuperscriptBox["si", "4"], " ", 
                    RowBox[{"Cos", "[", 
                    RowBox[{"4", " ", "omega"}], "]"}]}]}], ")"}]}], "+", 
                    RowBox[{"6912", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"4", " ", 
                    SuperscriptBox["si", "4"]}], "-", 
                    RowBox[{
                    SuperscriptBox["ecc", "2"], " ", 
                    SuperscriptBox["si", "4"]}], "-", 
                    RowBox[{"4", " ", 
                    SuperscriptBox["si", "4"], " ", 
                    RowBox[{"Cos", "[", 
                    RowBox[{"4", " ", "omega"}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox["ecc", "2"], " ", 
                    SuperscriptBox["si", "4"], " ", 
                    RowBox[{"Cos", "[", 
                    RowBox[{"4", " ", "omega"}], "]"}]}]}], ")"}], " ", 
                    SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", "ecc", " ", 
                    SuperscriptBox["si", "2"], " ", 
                    RowBox[{"Sin", "[", 
                    RowBox[{"2", " ", "omega"}], "]"}]}], "+", 
                    RowBox[{"ecc", " ", 
                    SuperscriptBox["si", "4"], " ", 
                    RowBox[{"Sin", "[", 
                    RowBox[{"2", " ", "omega"}], "]"}]}]}], ")"}], "2"]}], 
                    "+", 
                    RowBox[{"2304", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    SuperscriptBox["ecc", "2"]}], "-", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["ecc", "2"], " ", 
                    SuperscriptBox["si", "2"]}], "-", 
                    RowBox[{"8", " ", 
                    SuperscriptBox["si", "4"]}], "+", 
                    RowBox[{
                    SuperscriptBox["ecc", "2"], " ", 
                    SuperscriptBox["si", "4"]}], "-", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["ecc", "2"], " ", 
                    SuperscriptBox["si", "2"], " ", 
                    RowBox[{"Cos", "[", 
                    RowBox[{"2", " ", "omega"}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox["ecc", "2"], " ", 
                    SuperscriptBox["si", "4"], " ", 
                    RowBox[{"Cos", "[", 
                    RowBox[{"2", " ", "omega"}], "]"}]}]}], ")"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", "ecc", " ", 
                    SuperscriptBox["si", "2"], " ", 
                    RowBox[{"Sin", "[", 
                    RowBox[{"2", " ", "omega"}], "]"}]}], "+", 
                    RowBox[{"ecc", " ", 
                    SuperscriptBox["si", "4"], " ", 
                    RowBox[{"Sin", "[", 
                    RowBox[{"2", " ", "omega"}], "]"}]}]}], ")"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "4"}], " ", "ecc", " ", 
                    SuperscriptBox["si", "2"], " ", 
                    RowBox[{"Sin", "[", 
                    RowBox[{"2", " ", "omega"}], "]"}]}], "+", 
                    RowBox[{"2", " ", "ecc", " ", 
                    SuperscriptBox["si", "4"], " ", 
                    RowBox[{"Sin", "[", 
                    RowBox[{"2", " ", "omega"}], "]"}]}], "-", 
                    RowBox[{"ecc", " ", 
                    SuperscriptBox["si", "4"], " ", 
                    RowBox[{"Sin", "[", 
                    RowBox[{"4", " ", "omega"}], "]"}]}]}], ")"}]}], "+", 
                    RowBox[{"13824", " ", 
                    SuperscriptBox["si", "4"], " ", 
                    SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "4"}], " ", "ecc", " ", 
                    SuperscriptBox["si", "2"], " ", 
                    RowBox[{"Sin", "[", 
                    RowBox[{"2", " ", "omega"}], "]"}]}], "+", 
                    RowBox[{"2", " ", "ecc", " ", 
                    SuperscriptBox["si", "4"], " ", 
                    RowBox[{"Sin", "[", 
                    RowBox[{"2", " ", "omega"}], "]"}]}], "-", 
                    RowBox[{"ecc", " ", 
                    SuperscriptBox["si", "4"], " ", 
                    RowBox[{"Sin", "[", 
                    RowBox[{"4", " ", "omega"}], "]"}]}]}], ")"}], "2"]}]}], 
                    ")"}], "2"]}], ")"}]}]}], ")"}], 
                    RowBox[{"1", "/", "3"}]]}], ")"}]}], "+", 
                  RowBox[{
                   FractionBox["1", 
                    RowBox[{"96", " ", 
                    SuperscriptBox["2", 
                    RowBox[{"1", "/", "3"}]], " ", 
                    SuperscriptBox["si", "4"]}]], 
                   SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"128", " ", 
                    SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    SuperscriptBox["ecc", "2"]}], "-", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["ecc", "2"], " ", 
                    SuperscriptBox["si", "2"]}], "-", 
                    RowBox[{"8", " ", 
                    SuperscriptBox["si", "4"]}], "+", 
                    RowBox[{
                    SuperscriptBox["ecc", "2"], " ", 
                    SuperscriptBox["si", "4"]}], "-", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["ecc", "2"], " ", 
                    SuperscriptBox["si", "2"], " ", 
                    RowBox[{"Cos", "[", 
                    RowBox[{"2", " ", "omega"}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox["ecc", "2"], " ", 
                    SuperscriptBox["si", "4"], " ", 
                    RowBox[{"Cos", "[", 
                    RowBox[{"2", " ", "omega"}], "]"}]}]}], ")"}], "3"]}], 
                    "-", 
                    RowBox[{"9216", " ", 
                    SuperscriptBox["si", "4"], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    SuperscriptBox["ecc", "2"]}], "-", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["ecc", "2"], " ", 
                    SuperscriptBox["si", "2"]}], "-", 
                    RowBox[{"8", " ", 
                    SuperscriptBox["si", "4"]}], "+", 
                    RowBox[{
                    SuperscriptBox["ecc", "2"], " ", 
                    SuperscriptBox["si", "4"]}], "-", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["ecc", "2"], " ", 
                    SuperscriptBox["si", "2"], " ", 
                    RowBox[{"Cos", "[", 
                    RowBox[{"2", " ", "omega"}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox["ecc", "2"], " ", 
                    SuperscriptBox["si", "4"], " ", 
                    RowBox[{"Cos", "[", 
                    RowBox[{"2", " ", "omega"}], "]"}]}]}], ")"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"4", " ", 
                    SuperscriptBox["si", "4"]}], "-", 
                    RowBox[{
                    SuperscriptBox["ecc", "2"], " ", 
                    SuperscriptBox["si", "4"]}], "-", 
                    RowBox[{"4", " ", 
                    SuperscriptBox["si", "4"], " ", 
                    RowBox[{"Cos", "[", 
                    RowBox[{"4", " ", "omega"}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox["ecc", "2"], " ", 
                    SuperscriptBox["si", "4"], " ", 
                    RowBox[{"Cos", "[", 
                    RowBox[{"4", " ", "omega"}], "]"}]}]}], ")"}]}], "+", 
                    RowBox[{"6912", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"4", " ", 
                    SuperscriptBox["si", "4"]}], "-", 
                    RowBox[{
                    SuperscriptBox["ecc", "2"], " ", 
                    SuperscriptBox["si", "4"]}], "-", 
                    RowBox[{"4", " ", 
                    SuperscriptBox["si", "4"], " ", 
                    RowBox[{"Cos", "[", 
                    RowBox[{"4", " ", "omega"}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox["ecc", "2"], " ", 
                    SuperscriptBox["si", "4"], " ", 
                    RowBox[{"Cos", "[", 
                    RowBox[{"4", " ", "omega"}], "]"}]}]}], ")"}], " ", 
                    SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", "ecc", " ", 
                    SuperscriptBox["si", "2"], " ", 
                    RowBox[{"Sin", "[", 
                    RowBox[{"2", " ", "omega"}], "]"}]}], "+", 
                    RowBox[{"ecc", " ", 
                    SuperscriptBox["si", "4"], " ", 
                    RowBox[{"Sin", "[", 
                    RowBox[{"2", " ", "omega"}], "]"}]}]}], ")"}], "2"]}], 
                    "+", 
                    RowBox[{"2304", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    SuperscriptBox["ecc", "2"]}], "-", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["ecc", "2"], " ", 
                    SuperscriptBox["si", "2"]}], "-", 
                    RowBox[{"8", " ", 
                    SuperscriptBox["si", "4"]}], "+", 
                    RowBox[{
                    SuperscriptBox["ecc", "2"], " ", 
                    SuperscriptBox["si", "4"]}], "-", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["ecc", "2"], " ", 
                    SuperscriptBox["si", "2"], " ", 
                    RowBox[{"Cos", "[", 
                    RowBox[{"2", " ", "omega"}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox["ecc", "2"], " ", 
                    SuperscriptBox["si", "4"], " ", 
                    RowBox[{"Cos", "[", 
                    RowBox[{"2", " ", "omega"}], "]"}]}]}], ")"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", "ecc", " ", 
                    SuperscriptBox["si", "2"], " ", 
                    RowBox[{"Sin", "[", 
                    RowBox[{"2", " ", "omega"}], "]"}]}], "+", 
                    RowBox[{"ecc", " ", 
                    SuperscriptBox["si", "4"], " ", 
                    RowBox[{"Sin", "[", 
                    RowBox[{"2", " ", "omega"}], "]"}]}]}], ")"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "4"}], " ", "ecc", " ", 
                    SuperscriptBox["si", "2"], " ", 
                    RowBox[{"Sin", "[", 
                    RowBox[{"2", " ", "omega"}], "]"}]}], "+", 
                    RowBox[{"2", " ", "ecc", " ", 
                    SuperscriptBox["si", "4"], " ", 
                    RowBox[{"Sin", "[", 
                    RowBox[{"2", " ", "omega"}], "]"}]}], "-", 
                    RowBox[{"ecc", " ", 
                    SuperscriptBox["si", "4"], " ", 
                    RowBox[{"Sin", "[", 
                    RowBox[{"4", " ", "omega"}], "]"}]}]}], ")"}]}], "+", 
                    RowBox[{"13824", " ", 
                    SuperscriptBox["si", "4"], " ", 
                    SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "4"}], " ", "ecc", " ", 
                    SuperscriptBox["si", "2"], " ", 
                    RowBox[{"Sin", "[", 
                    RowBox[{"2", " ", "omega"}], "]"}]}], "+", 
                    RowBox[{"2", " ", "ecc", " ", 
                    SuperscriptBox["si", "4"], " ", 
                    RowBox[{"Sin", "[", 
                    RowBox[{"2", " ", "omega"}], "]"}]}], "-", 
                    RowBox[{"ecc", " ", 
                    SuperscriptBox["si", "4"], " ", 
                    RowBox[{"Sin", "[", 
                    RowBox[{"4", " ", "omega"}], "]"}]}]}], ")"}], "2"]}], 
                    "+", 
                    RowBox[{"\[Sqrt]", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "4"}], " ", 
                    SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"16", " ", 
                    SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    SuperscriptBox["ecc", "2"]}], "-", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["ecc", "2"], " ", 
                    SuperscriptBox["si", "2"]}], "-", 
                    RowBox[{"8", " ", 
                    SuperscriptBox["si", "4"]}], "+", 
                    RowBox[{
                    SuperscriptBox["ecc", "2"], " ", 
                    SuperscriptBox["si", "4"]}], "-", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["ecc", "2"], " ", 
                    SuperscriptBox["si", "2"], " ", 
                    RowBox[{"Cos", "[", 
                    RowBox[{"2", " ", "omega"}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox["ecc", "2"], " ", 
                    SuperscriptBox["si", "4"], " ", 
                    RowBox[{"Cos", "[", 
                    RowBox[{"2", " ", "omega"}], "]"}]}]}], ")"}], "2"]}], 
                    "+", 
                    RowBox[{"384", " ", 
                    SuperscriptBox["si", "4"], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"4", " ", 
                    SuperscriptBox["si", "4"]}], "-", 
                    RowBox[{
                    SuperscriptBox["ecc", "2"], " ", 
                    SuperscriptBox["si", "4"]}], "-", 
                    RowBox[{"4", " ", 
                    SuperscriptBox["si", "4"], " ", 
                    RowBox[{"Cos", "[", 
                    RowBox[{"4", " ", "omega"}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox["ecc", "2"], " ", 
                    SuperscriptBox["si", "4"], " ", 
                    RowBox[{"Cos", "[", 
                    RowBox[{"4", " ", "omega"}], "]"}]}]}], ")"}]}], "+", 
                    RowBox[{"192", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", "ecc", " ", 
                    SuperscriptBox["si", "2"], " ", 
                    RowBox[{"Sin", "[", 
                    RowBox[{"2", " ", "omega"}], "]"}]}], "+", 
                    RowBox[{"ecc", " ", 
                    SuperscriptBox["si", "4"], " ", 
                    RowBox[{"Sin", "[", 
                    RowBox[{"2", " ", "omega"}], "]"}]}]}], ")"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "4"}], " ", "ecc", " ", 
                    SuperscriptBox["si", "2"], " ", 
                    RowBox[{"Sin", "[", 
                    RowBox[{"2", " ", "omega"}], "]"}]}], "+", 
                    RowBox[{"2", " ", "ecc", " ", 
                    SuperscriptBox["si", "4"], " ", 
                    RowBox[{"Sin", "[", 
                    RowBox[{"2", " ", "omega"}], "]"}]}], "-", 
                    RowBox[{"ecc", " ", 
                    SuperscriptBox["si", "4"], " ", 
                    RowBox[{"Sin", "[", 
                    RowBox[{"4", " ", "omega"}], "]"}]}]}], ")"}]}]}], ")"}], 
                    "3"]}], "+", 
                    SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"128", " ", 
                    SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    SuperscriptBox["ecc", "2"]}], "-", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["ecc", "2"], " ", 
                    SuperscriptBox["si", "2"]}], "-", 
                    RowBox[{"8", " ", 
                    SuperscriptBox["si", "4"]}], "+", 
                    RowBox[{
                    SuperscriptBox["ecc", "2"], " ", 
                    SuperscriptBox["si", "4"]}], "-", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["ecc", "2"], " ", 
                    SuperscriptBox["si", "2"], " ", 
                    RowBox[{"Cos", "[", 
                    RowBox[{"2", " ", "omega"}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox["ecc", "2"], " ", 
                    SuperscriptBox["si", "4"], " ", 
                    RowBox[{"Cos", "[", 
                    RowBox[{"2", " ", "omega"}], "]"}]}]}], ")"}], "3"]}], 
                    "-", 
                    RowBox[{"9216", " ", 
                    SuperscriptBox["si", "4"], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    SuperscriptBox["ecc", "2"]}], "-", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["ecc", "2"], " ", 
                    SuperscriptBox["si", "2"]}], "-", 
                    RowBox[{"8", " ", 
                    SuperscriptBox["si", "4"]}], "+", 
                    RowBox[{
                    SuperscriptBox["ecc", "2"], " ", 
                    SuperscriptBox["si", "4"]}], "-", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["ecc", "2"], " ", 
                    SuperscriptBox["si", "2"], " ", 
                    RowBox[{"Cos", "[", 
                    RowBox[{"2", " ", "omega"}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox["ecc", "2"], " ", 
                    SuperscriptBox["si", "4"], " ", 
                    RowBox[{"Cos", "[", 
                    RowBox[{"2", " ", "omega"}], "]"}]}]}], ")"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"4", " ", 
                    SuperscriptBox["si", "4"]}], "-", 
                    RowBox[{
                    SuperscriptBox["ecc", "2"], " ", 
                    SuperscriptBox["si", "4"]}], "-", 
                    RowBox[{"4", " ", 
                    SuperscriptBox["si", "4"], " ", 
                    RowBox[{"Cos", "[", 
                    RowBox[{"4", " ", "omega"}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox["ecc", "2"], " ", 
                    SuperscriptBox["si", "4"], " ", 
                    RowBox[{"Cos", "[", 
                    RowBox[{"4", " ", "omega"}], "]"}]}]}], ")"}]}], "+", 
                    RowBox[{"6912", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"4", " ", 
                    SuperscriptBox["si", "4"]}], "-", 
                    RowBox[{
                    SuperscriptBox["ecc", "2"], " ", 
                    SuperscriptBox["si", "4"]}], "-", 
                    RowBox[{"4", " ", 
                    SuperscriptBox["si", "4"], " ", 
                    RowBox[{"Cos", "[", 
                    RowBox[{"4", " ", "omega"}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox["ecc", "2"], " ", 
                    SuperscriptBox["si", "4"], " ", 
                    RowBox[{"Cos", "[", 
                    RowBox[{"4", " ", "omega"}], "]"}]}]}], ")"}], " ", 
                    SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", "ecc", " ", 
                    SuperscriptBox["si", "2"], " ", 
                    RowBox[{"Sin", "[", 
                    RowBox[{"2", " ", "omega"}], "]"}]}], "+", 
                    RowBox[{"ecc", " ", 
                    SuperscriptBox["si", "4"], " ", 
                    RowBox[{"Sin", "[", 
                    RowBox[{"2", " ", "omega"}], "]"}]}]}], ")"}], "2"]}], 
                    "+", 
                    RowBox[{"2304", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    SuperscriptBox["ecc", "2"]}], "-", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["ecc", "2"], " ", 
                    SuperscriptBox["si", "2"]}], "-", 
                    RowBox[{"8", " ", 
                    SuperscriptBox["si", "4"]}], "+", 
                    RowBox[{
                    SuperscriptBox["ecc", "2"], " ", 
                    SuperscriptBox["si", "4"]}], "-", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["ecc", "2"], " ", 
                    SuperscriptBox["si", "2"], " ", 
                    RowBox[{"Cos", "[", 
                    RowBox[{"2", " ", "omega"}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox["ecc", "2"], " ", 
                    SuperscriptBox["si", "4"], " ", 
                    RowBox[{"Cos", "[", 
                    RowBox[{"2", " ", "omega"}], "]"}]}]}], ")"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", "ecc", " ", 
                    SuperscriptBox["si", "2"], " ", 
                    RowBox[{"Sin", "[", 
                    RowBox[{"2", " ", "omega"}], "]"}]}], "+", 
                    RowBox[{"ecc", " ", 
                    SuperscriptBox["si", "4"], " ", 
                    RowBox[{"Sin", "[", 
                    RowBox[{"2", " ", "omega"}], "]"}]}]}], ")"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "4"}], " ", "ecc", " ", 
                    SuperscriptBox["si", "2"], " ", 
                    RowBox[{"Sin", "[", 
                    RowBox[{"2", " ", "omega"}], "]"}]}], "+", 
                    RowBox[{"2", " ", "ecc", " ", 
                    SuperscriptBox["si", "4"], " ", 
                    RowBox[{"Sin", "[", 
                    RowBox[{"2", " ", "omega"}], "]"}]}], "-", 
                    RowBox[{"ecc", " ", 
                    SuperscriptBox["si", "4"], " ", 
                    RowBox[{"Sin", "[", 
                    RowBox[{"4", " ", "omega"}], "]"}]}]}], ")"}]}], "+", 
                    RowBox[{"13824", " ", 
                    SuperscriptBox["si", "4"], " ", 
                    SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "4"}], " ", "ecc", " ", 
                    SuperscriptBox["si", "2"], " ", 
                    RowBox[{"Sin", "[", 
                    RowBox[{"2", " ", "omega"}], "]"}]}], "+", 
                    RowBox[{"2", " ", "ecc", " ", 
                    SuperscriptBox["si", "4"], " ", 
                    RowBox[{"Sin", "[", 
                    RowBox[{"2", " ", "omega"}], "]"}]}], "-", 
                    RowBox[{"ecc", " ", 
                    SuperscriptBox["si", "4"], " ", 
                    RowBox[{"Sin", "[", 
                    RowBox[{"4", " ", "omega"}], "]"}]}]}], ")"}], "2"]}]}], 
                    ")"}], "2"]}], ")"}]}]}], ")"}], 
                    RowBox[{"1", "/", "3"}]]}]}], ")"}]}]}], "-", 
              RowBox[{
               FractionBox["1", "2"], " ", 
               RowBox[{"\[Sqrt]", 
                RowBox[{"(", 
                 RowBox[{
                  RowBox[{"-", 
                   FractionBox[
                    RowBox[{
                    RowBox[{"2", " ", 
                    SuperscriptBox["ecc", "2"]}], "-", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["ecc", "2"], " ", 
                    SuperscriptBox["si", "2"]}], "-", 
                    RowBox[{"8", " ", 
                    SuperscriptBox["si", "4"]}], "+", 
                    RowBox[{
                    SuperscriptBox["ecc", "2"], " ", 
                    SuperscriptBox["si", "4"]}], "-", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["ecc", "2"], " ", 
                    SuperscriptBox["si", "2"], " ", 
                    RowBox[{"Cos", "[", 
                    RowBox[{"2", " ", "omega"}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox["ecc", "2"], " ", 
                    SuperscriptBox["si", "4"], " ", 
                    RowBox[{"Cos", "[", 
                    RowBox[{"2", " ", "omega"}], "]"}]}]}], 
                    RowBox[{"6", " ", 
                    SuperscriptBox["si", "4"]}]]}], "+", 
                  FractionBox[
                   SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", "ecc", " ", 
                    RowBox[{"Sin", "[", 
                    RowBox[{"2", " ", "omega"}], "]"}]}], "-", 
                    RowBox[{"ecc", " ", 
                    SuperscriptBox["si", "2"], " ", 
                    RowBox[{"Sin", "[", 
                    RowBox[{"2", " ", "omega"}], "]"}]}]}], ")"}], "2"], 
                   RowBox[{"8", " ", 
                    SuperscriptBox["si", "4"]}]], "-", 
                  RowBox[{
                   RowBox[{"(", 
                    RowBox[{
                    RowBox[{"16", " ", 
                    SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    SuperscriptBox["ecc", "2"]}], "-", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["ecc", "2"], " ", 
                    SuperscriptBox["si", "2"]}], "-", 
                    RowBox[{"8", " ", 
                    SuperscriptBox["si", "4"]}], "+", 
                    RowBox[{
                    SuperscriptBox["ecc", "2"], " ", 
                    SuperscriptBox["si", "4"]}], "-", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["ecc", "2"], " ", 
                    SuperscriptBox["si", "2"], " ", 
                    RowBox[{"Cos", "[", 
                    RowBox[{"2", " ", "omega"}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox["ecc", "2"], " ", 
                    SuperscriptBox["si", "4"], " ", 
                    RowBox[{"Cos", "[", 
                    RowBox[{"2", " ", "omega"}], "]"}]}]}], ")"}], "2"]}], 
                    "+", 
                    RowBox[{"384", " ", 
                    SuperscriptBox["si", "4"], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"4", " ", 
                    SuperscriptBox["si", "4"]}], "-", 
                    RowBox[{
                    SuperscriptBox["ecc", "2"], " ", 
                    SuperscriptBox["si", "4"]}], "-", 
                    RowBox[{"4", " ", 
                    SuperscriptBox["si", "4"], " ", 
                    RowBox[{"Cos", "[", 
                    RowBox[{"4", " ", "omega"}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox["ecc", "2"], " ", 
                    SuperscriptBox["si", "4"], " ", 
                    RowBox[{"Cos", "[", 
                    RowBox[{"4", " ", "omega"}], "]"}]}]}], ")"}]}], "+", 
                    RowBox[{"192", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", "ecc", " ", 
                    SuperscriptBox["si", "2"], " ", 
                    RowBox[{"Sin", "[", 
                    RowBox[{"2", " ", "omega"}], "]"}]}], "+", 
                    RowBox[{"ecc", " ", 
                    SuperscriptBox["si", "4"], " ", 
                    RowBox[{"Sin", "[", 
                    RowBox[{"2", " ", "omega"}], "]"}]}]}], ")"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "4"}], " ", "ecc", " ", 
                    SuperscriptBox["si", "2"], " ", 
                    RowBox[{"Sin", "[", 
                    RowBox[{"2", " ", "omega"}], "]"}]}], "+", 
                    RowBox[{"2", " ", "ecc", " ", 
                    SuperscriptBox["si", "4"], " ", 
                    RowBox[{"Sin", "[", 
                    RowBox[{"2", " ", "omega"}], "]"}]}], "-", 
                    RowBox[{"ecc", " ", 
                    SuperscriptBox["si", "4"], " ", 
                    RowBox[{"Sin", "[", 
                    RowBox[{"4", " ", "omega"}], "]"}]}]}], ")"}]}]}], ")"}], 
                   "/", 
                   RowBox[{"(", 
                    RowBox[{"48", " ", 
                    SuperscriptBox["2", 
                    RowBox[{"2", "/", "3"}]], " ", 
                    SuperscriptBox["si", "4"], " ", 
                    SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"128", " ", 
                    SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    SuperscriptBox["ecc", "2"]}], "-", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["ecc", "2"], " ", 
                    SuperscriptBox["si", "2"]}], "-", 
                    RowBox[{"8", " ", 
                    SuperscriptBox["si", "4"]}], "+", 
                    RowBox[{
                    SuperscriptBox["ecc", "2"], " ", 
                    SuperscriptBox["si", "4"]}], "-", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["ecc", "2"], " ", 
                    SuperscriptBox["si", "2"], " ", 
                    RowBox[{"Cos", "[", 
                    RowBox[{"2", " ", "omega"}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox["ecc", "2"], " ", 
                    SuperscriptBox["si", "4"], " ", 
                    RowBox[{"Cos", "[", 
                    RowBox[{"2", " ", "omega"}], "]"}]}]}], ")"}], "3"]}], 
                    "-", 
                    RowBox[{"9216", " ", 
                    SuperscriptBox["si", "4"], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    SuperscriptBox["ecc", "2"]}], "-", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["ecc", "2"], " ", 
                    SuperscriptBox["si", "2"]}], "-", 
                    RowBox[{"8", " ", 
                    SuperscriptBox["si", "4"]}], "+", 
                    RowBox[{
                    SuperscriptBox["ecc", "2"], " ", 
                    SuperscriptBox["si", "4"]}], "-", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["ecc", "2"], " ", 
                    SuperscriptBox["si", "2"], " ", 
                    RowBox[{"Cos", "[", 
                    RowBox[{"2", " ", "omega"}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox["ecc", "2"], " ", 
                    SuperscriptBox["si", "4"], " ", 
                    RowBox[{"Cos", "[", 
                    RowBox[{"2", " ", "omega"}], "]"}]}]}], ")"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"4", " ", 
                    SuperscriptBox["si", "4"]}], "-", 
                    RowBox[{
                    SuperscriptBox["ecc", "2"], " ", 
                    SuperscriptBox["si", "4"]}], "-", 
                    RowBox[{"4", " ", 
                    SuperscriptBox["si", "4"], " ", 
                    RowBox[{"Cos", "[", 
                    RowBox[{"4", " ", "omega"}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox["ecc", "2"], " ", 
                    SuperscriptBox["si", "4"], " ", 
                    RowBox[{"Cos", "[", 
                    RowBox[{"4", " ", "omega"}], "]"}]}]}], ")"}]}], "+", 
                    RowBox[{"6912", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"4", " ", 
                    SuperscriptBox["si", "4"]}], "-", 
                    RowBox[{
                    SuperscriptBox["ecc", "2"], " ", 
                    SuperscriptBox["si", "4"]}], "-", 
                    RowBox[{"4", " ", 
                    SuperscriptBox["si", "4"], " ", 
                    RowBox[{"Cos", "[", 
                    RowBox[{"4", " ", "omega"}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox["ecc", "2"], " ", 
                    SuperscriptBox["si", "4"], " ", 
                    RowBox[{"Cos", "[", 
                    RowBox[{"4", " ", "omega"}], "]"}]}]}], ")"}], " ", 
                    SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", "ecc", " ", 
                    SuperscriptBox["si", "2"], " ", 
                    RowBox[{"Sin", "[", 
                    RowBox[{"2", " ", "omega"}], "]"}]}], "+", 
                    RowBox[{"ecc", " ", 
                    SuperscriptBox["si", "4"], " ", 
                    RowBox[{"Sin", "[", 
                    RowBox[{"2", " ", "omega"}], "]"}]}]}], ")"}], "2"]}], 
                    "+", 
                    RowBox[{"2304", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    SuperscriptBox["ecc", "2"]}], "-", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["ecc", "2"], " ", 
                    SuperscriptBox["si", "2"]}], "-", 
                    RowBox[{"8", " ", 
                    SuperscriptBox["si", "4"]}], "+", 
                    RowBox[{
                    SuperscriptBox["ecc", "2"], " ", 
                    SuperscriptBox["si", "4"]}], "-", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["ecc", "2"], " ", 
                    SuperscriptBox["si", "2"], " ", 
                    RowBox[{"Cos", "[", 
                    RowBox[{"2", " ", "omega"}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox["ecc", "2"], " ", 
                    SuperscriptBox["si", "4"], " ", 
                    RowBox[{"Cos", "[", 
                    RowBox[{"2", " ", "omega"}], "]"}]}]}], ")"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", "ecc", " ", 
                    SuperscriptBox["si", "2"], " ", 
                    RowBox[{"Sin", "[", 
                    RowBox[{"2", " ", "omega"}], "]"}]}], "+", 
                    RowBox[{"ecc", " ", 
                    SuperscriptBox["si", "4"], " ", 
                    RowBox[{"Sin", "[", 
                    RowBox[{"2", " ", "omega"}], "]"}]}]}], ")"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "4"}], " ", "ecc", " ", 
                    SuperscriptBox["si", "2"], " ", 
                    RowBox[{"Sin", "[", 
                    RowBox[{"2", " ", "omega"}], "]"}]}], "+", 
                    RowBox[{"2", " ", "ecc", " ", 
                    SuperscriptBox["si", "4"], " ", 
                    RowBox[{"Sin", "[", 
                    RowBox[{"2", " ", "omega"}], "]"}]}], "-", 
                    RowBox[{"ecc", " ", 
                    SuperscriptBox["si", "4"], " ", 
                    RowBox[{"Sin", "[", 
                    RowBox[{"4", " ", "omega"}], "]"}]}]}], ")"}]}], "+", 
                    RowBox[{"13824", " ", 
                    SuperscriptBox["si", "4"], " ", 
                    SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "4"}], " ", "ecc", " ", 
                    SuperscriptBox["si", "2"], " ", 
                    RowBox[{"Sin", "[", 
                    RowBox[{"2", " ", "omega"}], "]"}]}], "+", 
                    RowBox[{"2", " ", "ecc", " ", 
                    SuperscriptBox["si", "4"], " ", 
                    RowBox[{"Sin", "[", 
                    RowBox[{"2", " ", "omega"}], "]"}]}], "-", 
                    RowBox[{"ecc", " ", 
                    SuperscriptBox["si", "4"], " ", 
                    RowBox[{"Sin", "[", 
                    RowBox[{"4", " ", "omega"}], "]"}]}]}], ")"}], "2"]}], 
                    "+", 
                    RowBox[{"\[Sqrt]", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "4"}], " ", 
                    SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"16", " ", 
                    SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    SuperscriptBox["ecc", "2"]}], "-", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["ecc", "2"], " ", 
                    SuperscriptBox["si", "2"]}], "-", 
                    RowBox[{"8", " ", 
                    SuperscriptBox["si", "4"]}], "+", 
                    RowBox[{
                    SuperscriptBox["ecc", "2"], " ", 
                    SuperscriptBox["si", "4"]}], "-", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["ecc", "2"], " ", 
                    SuperscriptBox["si", "2"], " ", 
                    RowBox[{"Cos", "[", 
                    RowBox[{"2", " ", "omega"}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox["ecc", "2"], " ", 
                    SuperscriptBox["si", "4"], " ", 
                    RowBox[{"Cos", "[", 
                    RowBox[{"2", " ", "omega"}], "]"}]}]}], ")"}], "2"]}], 
                    "+", 
                    RowBox[{"384", " ", 
                    SuperscriptBox["si", "4"], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"4", " ", 
                    SuperscriptBox["si", "4"]}], "-", 
                    RowBox[{
                    SuperscriptBox["ecc", "2"], " ", 
                    SuperscriptBox["si", "4"]}], "-", 
                    RowBox[{"4", " ", 
                    SuperscriptBox["si", "4"], " ", 
                    RowBox[{"Cos", "[", 
                    RowBox[{"4", " ", "omega"}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox["ecc", "2"], " ", 
                    SuperscriptBox["si", "4"], " ", 
                    RowBox[{"Cos", "[", 
                    RowBox[{"4", " ", "omega"}], "]"}]}]}], ")"}]}], "+", 
                    RowBox[{"192", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", "ecc", " ", 
                    SuperscriptBox["si", "2"], " ", 
                    RowBox[{"Sin", "[", 
                    RowBox[{"2", " ", "omega"}], "]"}]}], "+", 
                    RowBox[{"ecc", " ", 
                    SuperscriptBox["si", "4"], " ", 
                    RowBox[{"Sin", "[", 
                    RowBox[{"2", " ", "omega"}], "]"}]}]}], ")"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "4"}], " ", "ecc", " ", 
                    SuperscriptBox["si", "2"], " ", 
                    RowBox[{"Sin", "[", 
                    RowBox[{"2", " ", "omega"}], "]"}]}], "+", 
                    RowBox[{"2", " ", "ecc", " ", 
                    SuperscriptBox["si", "4"], " ", 
                    RowBox[{"Sin", "[", 
                    RowBox[{"2", " ", "omega"}], "]"}]}], "-", 
                    RowBox[{"ecc", " ", 
                    SuperscriptBox["si", "4"], " ", 
                    RowBox[{"Sin", "[", 
                    RowBox[{"4", " ", "omega"}], "]"}]}]}], ")"}]}]}], ")"}], 
                    "3"]}], "+", 
                    SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"128", " ", 
                    SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    SuperscriptBox["ecc", "2"]}], "-", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["ecc", "2"], " ", 
                    SuperscriptBox["si", "2"]}], "-", 
                    RowBox[{"8", " ", 
                    SuperscriptBox["si", "4"]}], "+", 
                    RowBox[{
                    SuperscriptBox["ecc", "2"], " ", 
                    SuperscriptBox["si", "4"]}], "-", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["ecc", "2"], " ", 
                    SuperscriptBox["si", "2"], " ", 
                    RowBox[{"Cos", "[", 
                    RowBox[{"2", " ", "omega"}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox["ecc", "2"], " ", 
                    SuperscriptBox["si", "4"], " ", 
                    RowBox[{"Cos", "[", 
                    RowBox[{"2", " ", "omega"}], "]"}]}]}], ")"}], "3"]}], 
                    "-", 
                    RowBox[{"9216", " ", 
                    SuperscriptBox["si", "4"], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    SuperscriptBox["ecc", "2"]}], "-", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["ecc", "2"], " ", 
                    SuperscriptBox["si", "2"]}], "-", 
                    RowBox[{"8", " ", 
                    SuperscriptBox["si", "4"]}], "+", 
                    RowBox[{
                    SuperscriptBox["ecc", "2"], " ", 
                    SuperscriptBox["si", "4"]}], "-", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["ecc", "2"], " ", 
                    SuperscriptBox["si", "2"], " ", 
                    RowBox[{"Cos", "[", 
                    RowBox[{"2", " ", "omega"}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox["ecc", "2"], " ", 
                    SuperscriptBox["si", "4"], " ", 
                    RowBox[{"Cos", "[", 
                    RowBox[{"2", " ", "omega"}], "]"}]}]}], ")"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"4", " ", 
                    SuperscriptBox["si", "4"]}], "-", 
                    RowBox[{
                    SuperscriptBox["ecc", "2"], " ", 
                    SuperscriptBox["si", "4"]}], "-", 
                    RowBox[{"4", " ", 
                    SuperscriptBox["si", "4"], " ", 
                    RowBox[{"Cos", "[", 
                    RowBox[{"4", " ", "omega"}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox["ecc", "2"], " ", 
                    SuperscriptBox["si", "4"], " ", 
                    RowBox[{"Cos", "[", 
                    RowBox[{"4", " ", "omega"}], "]"}]}]}], ")"}]}], "+", 
                    RowBox[{"6912", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"4", " ", 
                    SuperscriptBox["si", "4"]}], "-", 
                    RowBox[{
                    SuperscriptBox["ecc", "2"], " ", 
                    SuperscriptBox["si", "4"]}], "-", 
                    RowBox[{"4", " ", 
                    SuperscriptBox["si", "4"], " ", 
                    RowBox[{"Cos", "[", 
                    RowBox[{"4", " ", "omega"}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox["ecc", "2"], " ", 
                    SuperscriptBox["si", "4"], " ", 
                    RowBox[{"Cos", "[", 
                    RowBox[{"4", " ", "omega"}], "]"}]}]}], ")"}], " ", 
                    SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", "ecc", " ", 
                    SuperscriptBox["si", "2"], " ", 
                    RowBox[{"Sin", "[", 
                    RowBox[{"2", " ", "omega"}], "]"}]}], "+", 
                    RowBox[{"ecc", " ", 
                    SuperscriptBox["si", "4"], " ", 
                    RowBox[{"Sin", "[", 
                    RowBox[{"2", " ", "omega"}], "]"}]}]}], ")"}], "2"]}], 
                    "+", 
                    RowBox[{"2304", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    SuperscriptBox["ecc", "2"]}], "-", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["ecc", "2"], " ", 
                    SuperscriptBox["si", "2"]}], "-", 
                    RowBox[{"8", " ", 
                    SuperscriptBox["si", "4"]}], "+", 
                    RowBox[{
                    SuperscriptBox["ecc", "2"], " ", 
                    SuperscriptBox["si", "4"]}], "-", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["ecc", "2"], " ", 
                    SuperscriptBox["si", "2"], " ", 
                    RowBox[{"Cos", "[", 
                    RowBox[{"2", " ", "omega"}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox["ecc", "2"], " ", 
                    SuperscriptBox["si", "4"], " ", 
                    RowBox[{"Cos", "[", 
                    RowBox[{"2", " ", "omega"}], "]"}]}]}], ")"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", "ecc", " ", 
                    SuperscriptBox["si", "2"], " ", 
                    RowBox[{"Sin", "[", 
                    RowBox[{"2", " ", "omega"}], "]"}]}], "+", 
                    RowBox[{"ecc", " ", 
                    SuperscriptBox["si", "4"], " ", 
                    RowBox[{"Sin", "[", 
                    RowBox[{"2", " ", "omega"}], "]"}]}]}], ")"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "4"}], " ", "ecc", " ", 
                    SuperscriptBox["si", "2"], " ", 
                    RowBox[{"Sin", "[", 
                    RowBox[{"2", " ", "omega"}], "]"}]}], "+", 
                    RowBox[{"2", " ", "ecc", " ", 
                    SuperscriptBox["si", "4"], " ", 
                    RowBox[{"Sin", "[", 
                    RowBox[{"2", " ", "omega"}], "]"}]}], "-", 
                    RowBox[{"ecc", " ", 
                    SuperscriptBox["si", "4"], " ", 
                    RowBox[{"Sin", "[", 
                    RowBox[{"4", " ", "omega"}], "]"}]}]}], ")"}]}], "+", 
                    RowBox[{"13824", " ", 
                    SuperscriptBox["si", "4"], " ", 
                    SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "4"}], " ", "ecc", " ", 
                    SuperscriptBox["si", "2"], " ", 
                    RowBox[{"Sin", "[", 
                    RowBox[{"2", " ", "omega"}], "]"}]}], "+", 
                    RowBox[{"2", " ", "ecc", " ", 
                    SuperscriptBox["si", "4"], " ", 
                    RowBox[{"Sin", "[", 
                    RowBox[{"2", " ", "omega"}], "]"}]}], "-", 
                    RowBox[{"ecc", " ", 
                    SuperscriptBox["si", "4"], " ", 
                    RowBox[{"Sin", "[", 
                    RowBox[{"4", " ", "omega"}], "]"}]}]}], ")"}], "2"]}]}], 
                    ")"}], "2"]}], ")"}]}]}], ")"}], 
                    RowBox[{"1", "/", "3"}]]}], ")"}]}], "-", 
                  RowBox[{
                   FractionBox["1", 
                    RowBox[{"96", " ", 
                    SuperscriptBox["2", 
                    RowBox[{"1", "/", "3"}]], " ", 
                    SuperscriptBox["si", "4"]}]], 
                   SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"128", " ", 
                    SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    SuperscriptBox["ecc", "2"]}], "-", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["ecc", "2"], " ", 
                    SuperscriptBox["si", "2"]}], "-", 
                    RowBox[{"8", " ", 
                    SuperscriptBox["si", "4"]}], "+", 
                    RowBox[{
                    SuperscriptBox["ecc", "2"], " ", 
                    SuperscriptBox["si", "4"]}], "-", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["ecc", "2"], " ", 
                    SuperscriptBox["si", "2"], " ", 
                    RowBox[{"Cos", "[", 
                    RowBox[{"2", " ", "omega"}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox["ecc", "2"], " ", 
                    SuperscriptBox["si", "4"], " ", 
                    RowBox[{"Cos", "[", 
                    RowBox[{"2", " ", "omega"}], "]"}]}]}], ")"}], "3"]}], 
                    "-", 
                    RowBox[{"9216", " ", 
                    SuperscriptBox["si", "4"], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    SuperscriptBox["ecc", "2"]}], "-", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["ecc", "2"], " ", 
                    SuperscriptBox["si", "2"]}], "-", 
                    RowBox[{"8", " ", 
                    SuperscriptBox["si", "4"]}], "+", 
                    RowBox[{
                    SuperscriptBox["ecc", "2"], " ", 
                    SuperscriptBox["si", "4"]}], "-", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["ecc", "2"], " ", 
                    SuperscriptBox["si", "2"], " ", 
                    RowBox[{"Cos", "[", 
                    RowBox[{"2", " ", "omega"}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox["ecc", "2"], " ", 
                    SuperscriptBox["si", "4"], " ", 
                    RowBox[{"Cos", "[", 
                    RowBox[{"2", " ", "omega"}], "]"}]}]}], ")"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"4", " ", 
                    SuperscriptBox["si", "4"]}], "-", 
                    RowBox[{
                    SuperscriptBox["ecc", "2"], " ", 
                    SuperscriptBox["si", "4"]}], "-", 
                    RowBox[{"4", " ", 
                    SuperscriptBox["si", "4"], " ", 
                    RowBox[{"Cos", "[", 
                    RowBox[{"4", " ", "omega"}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox["ecc", "2"], " ", 
                    SuperscriptBox["si", "4"], " ", 
                    RowBox[{"Cos", "[", 
                    RowBox[{"4", " ", "omega"}], "]"}]}]}], ")"}]}], "+", 
                    RowBox[{"6912", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"4", " ", 
                    SuperscriptBox["si", "4"]}], "-", 
                    RowBox[{
                    SuperscriptBox["ecc", "2"], " ", 
                    SuperscriptBox["si", "4"]}], "-", 
                    RowBox[{"4", " ", 
                    SuperscriptBox["si", "4"], " ", 
                    RowBox[{"Cos", "[", 
                    RowBox[{"4", " ", "omega"}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox["ecc", "2"], " ", 
                    SuperscriptBox["si", "4"], " ", 
                    RowBox[{"Cos", "[", 
                    RowBox[{"4", " ", "omega"}], "]"}]}]}], ")"}], " ", 
                    SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", "ecc", " ", 
                    SuperscriptBox["si", "2"], " ", 
                    RowBox[{"Sin", "[", 
                    RowBox[{"2", " ", "omega"}], "]"}]}], "+", 
                    RowBox[{"ecc", " ", 
                    SuperscriptBox["si", "4"], " ", 
                    RowBox[{"Sin", "[", 
                    RowBox[{"2", " ", "omega"}], "]"}]}]}], ")"}], "2"]}], 
                    "+", 
                    RowBox[{"2304", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    SuperscriptBox["ecc", "2"]}], "-", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["ecc", "2"], " ", 
                    SuperscriptBox["si", "2"]}], "-", 
                    RowBox[{"8", " ", 
                    SuperscriptBox["si", "4"]}], "+", 
                    RowBox[{
                    SuperscriptBox["ecc", "2"], " ", 
                    SuperscriptBox["si", "4"]}], "-", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["ecc", "2"], " ", 
                    SuperscriptBox["si", "2"], " ", 
                    RowBox[{"Cos", "[", 
                    RowBox[{"2", " ", "omega"}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox["ecc", "2"], " ", 
                    SuperscriptBox["si", "4"], " ", 
                    RowBox[{"Cos", "[", 
                    RowBox[{"2", " ", "omega"}], "]"}]}]}], ")"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", "ecc", " ", 
                    SuperscriptBox["si", "2"], " ", 
                    RowBox[{"Sin", "[", 
                    RowBox[{"2", " ", "omega"}], "]"}]}], "+", 
                    RowBox[{"ecc", " ", 
                    SuperscriptBox["si", "4"], " ", 
                    RowBox[{"Sin", "[", 
                    RowBox[{"2", " ", "omega"}], "]"}]}]}], ")"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "4"}], " ", "ecc", " ", 
                    SuperscriptBox["si", "2"], " ", 
                    RowBox[{"Sin", "[", 
                    RowBox[{"2", " ", "omega"}], "]"}]}], "+", 
                    RowBox[{"2", " ", "ecc", " ", 
                    SuperscriptBox["si", "4"], " ", 
                    RowBox[{"Sin", "[", 
                    RowBox[{"2", " ", "omega"}], "]"}]}], "-", 
                    RowBox[{"ecc", " ", 
                    SuperscriptBox["si", "4"], " ", 
                    RowBox[{"Sin", "[", 
                    RowBox[{"4", " ", "omega"}], "]"}]}]}], ")"}]}], "+", 
                    RowBox[{"13824", " ", 
                    SuperscriptBox["si", "4"], " ", 
                    SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "4"}], " ", "ecc", " ", 
                    SuperscriptBox["si", "2"], " ", 
                    RowBox[{"Sin", "[", 
                    RowBox[{"2", " ", "omega"}], "]"}]}], "+", 
                    RowBox[{"2", " ", "ecc", " ", 
                    SuperscriptBox["si", "4"], " ", 
                    RowBox[{"Sin", "[", 
                    RowBox[{"2", " ", "omega"}], "]"}]}], "-", 
                    RowBox[{"ecc", " ", 
                    SuperscriptBox["si", "4"], " ", 
                    RowBox[{"Sin", "[", 
                    RowBox[{"4", " ", "omega"}], "]"}]}]}], ")"}], "2"]}], 
                    "+", 
                    RowBox[{"\[Sqrt]", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "4"}], " ", 
                    SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"16", " ", 
                    SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    SuperscriptBox["ecc", "2"]}], "-", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["ecc", "2"], " ", 
                    SuperscriptBox["si", "2"]}], "-", 
                    RowBox[{"8", " ", 
                    SuperscriptBox["si", "4"]}], "+", 
                    RowBox[{
                    SuperscriptBox["ecc", "2"], " ", 
                    SuperscriptBox["si", "4"]}], "-", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["ecc", "2"], " ", 
                    SuperscriptBox["si", "2"], " ", 
                    RowBox[{"Cos", "[", 
                    RowBox[{"2", " ", "omega"}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox["ecc", "2"], " ", 
                    SuperscriptBox["si", "4"], " ", 
                    RowBox[{"Cos", "[", 
                    RowBox[{"2", " ", "omega"}], "]"}]}]}], ")"}], "2"]}], 
                    "+", 
                    RowBox[{"384", " ", 
                    SuperscriptBox["si", "4"], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"4", " ", 
                    SuperscriptBox["si", "4"]}], "-", 
                    RowBox[{
                    SuperscriptBox["ecc", "2"], " ", 
                    SuperscriptBox["si", "4"]}], "-", 
                    RowBox[{"4", " ", 
                    SuperscriptBox["si", "4"], " ", 
                    RowBox[{"Cos", "[", 
                    RowBox[{"4", " ", "omega"}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox["ecc", "2"], " ", 
                    SuperscriptBox["si", "4"], " ", 
                    RowBox[{"Cos", "[", 
                    RowBox[{"4", " ", "omega"}], "]"}]}]}], ")"}]}], "+", 
                    RowBox[{"192", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", "ecc", " ", 
                    SuperscriptBox["si", "2"], " ", 
                    RowBox[{"Sin", "[", 
                    RowBox[{"2", " ", "omega"}], "]"}]}], "+", 
                    RowBox[{"ecc", " ", 
                    SuperscriptBox["si", "4"], " ", 
                    RowBox[{"Sin", "[", 
                    RowBox[{"2", " ", "omega"}], "]"}]}]}], ")"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "4"}], " ", "ecc", " ", 
                    SuperscriptBox["si", "2"], " ", 
                    RowBox[{"Sin", "[", 
                    RowBox[{"2", " ", "omega"}], "]"}]}], "+", 
                    RowBox[{"2", " ", "ecc", " ", 
                    SuperscriptBox["si", "4"], " ", 
                    RowBox[{"Sin", "[", 
                    RowBox[{"2", " ", "omega"}], "]"}]}], "-", 
                    RowBox[{"ecc", " ", 
                    SuperscriptBox["si", "4"], " ", 
                    RowBox[{"Sin", "[", 
                    RowBox[{"4", " ", "omega"}], "]"}]}]}], ")"}]}]}], ")"}], 
                    "3"]}], "+", 
                    SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"128", " ", 
                    SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    SuperscriptBox["ecc", "2"]}], "-", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["ecc", "2"], " ", 
                    SuperscriptBox["si", "2"]}], "-", 
                    RowBox[{"8", " ", 
                    SuperscriptBox["si", "4"]}], "+", 
                    RowBox[{
                    SuperscriptBox["ecc", "2"], " ", 
                    SuperscriptBox["si", "4"]}], "-", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["ecc", "2"], " ", 
                    SuperscriptBox["si", "2"], " ", 
                    RowBox[{"Cos", "[", 
                    RowBox[{"2", " ", "omega"}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox["ecc", "2"], " ", 
                    SuperscriptBox["si", "4"], " ", 
                    RowBox[{"Cos", "[", 
                    RowBox[{"2", " ", "omega"}], "]"}]}]}], ")"}], "3"]}], 
                    "-", 
                    RowBox[{"9216", " ", 
                    SuperscriptBox["si", "4"], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    SuperscriptBox["ecc", "2"]}], "-", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["ecc", "2"], " ", 
                    SuperscriptBox["si", "2"]}], "-", 
                    RowBox[{"8", " ", 
                    SuperscriptBox["si", "4"]}], "+", 
                    RowBox[{
                    SuperscriptBox["ecc", "2"], " ", 
                    SuperscriptBox["si", "4"]}], "-", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["ecc", "2"], " ", 
                    SuperscriptBox["si", "2"], " ", 
                    RowBox[{"Cos", "[", 
                    RowBox[{"2", " ", "omega"}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox["ecc", "2"], " ", 
                    SuperscriptBox["si", "4"], " ", 
                    RowBox[{"Cos", "[", 
                    RowBox[{"2", " ", "omega"}], "]"}]}]}], ")"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"4", " ", 
                    SuperscriptBox["si", "4"]}], "-", 
                    RowBox[{
                    SuperscriptBox["ecc", "2"], " ", 
                    SuperscriptBox["si", "4"]}], "-", 
                    RowBox[{"4", " ", 
                    SuperscriptBox["si", "4"], " ", 
                    RowBox[{"Cos", "[", 
                    RowBox[{"4", " ", "omega"}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox["ecc", "2"], " ", 
                    SuperscriptBox["si", "4"], " ", 
                    RowBox[{"Cos", "[", 
                    RowBox[{"4", " ", "omega"}], "]"}]}]}], ")"}]}], "+", 
                    RowBox[{"6912", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"4", " ", 
                    SuperscriptBox["si", "4"]}], "-", 
                    RowBox[{
                    SuperscriptBox["ecc", "2"], " ", 
                    SuperscriptBox["si", "4"]}], "-", 
                    RowBox[{"4", " ", 
                    SuperscriptBox["si", "4"], " ", 
                    RowBox[{"Cos", "[", 
                    RowBox[{"4", " ", "omega"}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox["ecc", "2"], " ", 
                    SuperscriptBox["si", "4"], " ", 
                    RowBox[{"Cos", "[", 
                    RowBox[{"4", " ", "omega"}], "]"}]}]}], ")"}], " ", 
                    SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", "ecc", " ", 
                    SuperscriptBox["si", "2"], " ", 
                    RowBox[{"Sin", "[", 
                    RowBox[{"2", " ", "omega"}], "]"}]}], "+", 
                    RowBox[{"ecc", " ", 
                    SuperscriptBox["si", "4"], " ", 
                    RowBox[{"Sin", "[", 
                    RowBox[{"2", " ", "omega"}], "]"}]}]}], ")"}], "2"]}], 
                    "+", 
                    RowBox[{"2304", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    SuperscriptBox["ecc", "2"]}], "-", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["ecc", "2"], " ", 
                    SuperscriptBox["si", "2"]}], "-", 
                    RowBox[{"8", " ", 
                    SuperscriptBox["si", "4"]}], "+", 
                    RowBox[{
                    SuperscriptBox["ecc", "2"], " ", 
                    SuperscriptBox["si", "4"]}], "-", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["ecc", "2"], " ", 
                    SuperscriptBox["si", "2"], " ", 
                    RowBox[{"Cos", "[", 
                    RowBox[{"2", " ", "omega"}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox["ecc", "2"], " ", 
                    SuperscriptBox["si", "4"], " ", 
                    RowBox[{"Cos", "[", 
                    RowBox[{"2", " ", "omega"}], "]"}]}]}], ")"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", "ecc", " ", 
                    SuperscriptBox["si", "2"], " ", 
                    RowBox[{"Sin", "[", 
                    RowBox[{"2", " ", "omega"}], "]"}]}], "+", 
                    RowBox[{"ecc", " ", 
                    SuperscriptBox["si", "4"], " ", 
                    RowBox[{"Sin", "[", 
                    RowBox[{"2", " ", "omega"}], "]"}]}]}], ")"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "4"}], " ", "ecc", " ", 
                    SuperscriptBox["si", "2"], " ", 
                    RowBox[{"Sin", "[", 
                    RowBox[{"2", " ", "omega"}], "]"}]}], "+", 
                    RowBox[{"2", " ", "ecc", " ", 
                    SuperscriptBox["si", "4"], " ", 
                    RowBox[{"Sin", "[", 
                    RowBox[{"2", " ", "omega"}], "]"}]}], "-", 
                    RowBox[{"ecc", " ", 
                    SuperscriptBox["si", "4"], " ", 
                    RowBox[{"Sin", "[", 
                    RowBox[{"4", " ", "omega"}], "]"}]}]}], ")"}]}], "+", 
                    RowBox[{"13824", " ", 
                    SuperscriptBox["si", "4"], " ", 
                    SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "4"}], " ", "ecc", " ", 
                    SuperscriptBox["si", "2"], " ", 
                    RowBox[{"Sin", "[", 
                    RowBox[{"2", " ", "omega"}], "]"}]}], "+", 
                    RowBox[{"2", " ", "ecc", " ", 
                    SuperscriptBox["si", "4"], " ", 
                    RowBox[{"Sin", "[", 
                    RowBox[{"2", " ", "omega"}], "]"}]}], "-", 
                    RowBox[{"ecc", " ", 
                    SuperscriptBox["si", "4"], " ", 
                    RowBox[{"Sin", "[", 
                    RowBox[{"4", " ", "omega"}], "]"}]}]}], ")"}], "2"]}]}], 
                    ")"}], "2"]}], ")"}]}]}], ")"}], 
                    RowBox[{"1", "/", "3"}]]}], "-", 
                  RowBox[{
                   RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    FractionBox["1", 
                    RowBox[{"4", " ", 
                    SuperscriptBox["si", "6"]}]], 
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    SuperscriptBox["ecc", "2"]}], "-", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["ecc", "2"], " ", 
                    SuperscriptBox["si", "2"]}], "-", 
                    RowBox[{"8", " ", 
                    SuperscriptBox["si", "4"]}], "+", 
                    RowBox[{
                    SuperscriptBox["ecc", "2"], " ", 
                    SuperscriptBox["si", "4"]}], "-", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["ecc", "2"], " ", 
                    SuperscriptBox["si", "2"], " ", 
                    RowBox[{"Cos", "[", 
                    RowBox[{"2", " ", "omega"}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox["ecc", "2"], " ", 
                    SuperscriptBox["si", "4"], " ", 
                    RowBox[{"Cos", "[", 
                    RowBox[{"2", " ", "omega"}], "]"}]}]}], ")"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", "ecc", " ", 
                    RowBox[{"Sin", "[", 
                    RowBox[{"2", " ", "omega"}], "]"}]}], "-", 
                    RowBox[{"ecc", " ", 
                    SuperscriptBox["si", "2"], " ", 
                    RowBox[{"Sin", "[", 
                    RowBox[{"2", " ", "omega"}], "]"}]}]}], ")"}]}]}], "-", 
                    FractionBox[
                    SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", "ecc", " ", 
                    RowBox[{"Sin", "[", 
                    RowBox[{"2", " ", "omega"}], "]"}]}], "-", 
                    RowBox[{"ecc", " ", 
                    SuperscriptBox["si", "2"], " ", 
                    RowBox[{"Sin", "[", 
                    RowBox[{"2", " ", "omega"}], "]"}]}]}], ")"}], "3"], 
                    RowBox[{"8", " ", 
                    SuperscriptBox["si", "6"]}]], "-", 
                    FractionBox[
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "4"}], " ", "ecc", " ", 
                    RowBox[{"Sin", "[", 
                    RowBox[{"2", " ", "omega"}], "]"}]}], "+", 
                    RowBox[{"2", " ", "ecc", " ", 
                    SuperscriptBox["si", "2"], " ", 
                    RowBox[{"Sin", "[", 
                    RowBox[{"2", " ", "omega"}], "]"}]}], "-", 
                    RowBox[{"ecc", " ", 
                    SuperscriptBox["si", "2"], " ", 
                    RowBox[{"Sin", "[", 
                    RowBox[{"4", " ", "omega"}], "]"}]}]}], 
                    SuperscriptBox["si", "2"]]}], ")"}], "/", 
                   RowBox[{"(", 
                    RowBox[{"4", " ", 
                    RowBox[{"\[Sqrt]", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"-", 
                    FractionBox[
                    RowBox[{
                    RowBox[{"2", " ", 
                    SuperscriptBox["ecc", "2"]}], "-", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["ecc", "2"], " ", 
                    SuperscriptBox["si", "2"]}], "-", 
                    RowBox[{"8", " ", 
                    SuperscriptBox["si", "4"]}], "+", 
                    RowBox[{
                    SuperscriptBox["ecc", "2"], " ", 
                    SuperscriptBox["si", "4"]}], "-", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["ecc", "2"], " ", 
                    SuperscriptBox["si", "2"], " ", 
                    RowBox[{"Cos", "[", 
                    RowBox[{"2", " ", "omega"}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox["ecc", "2"], " ", 
                    SuperscriptBox["si", "4"], " ", 
                    RowBox[{"Cos", "[", 
                    RowBox[{"2", " ", "omega"}], "]"}]}]}], 
                    RowBox[{"12", " ", 
                    SuperscriptBox["si", "4"]}]]}], "+", 
                    FractionBox[
                    SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", "ecc", " ", 
                    RowBox[{"Sin", "[", 
                    RowBox[{"2", " ", "omega"}], "]"}]}], "-", 
                    RowBox[{"ecc", " ", 
                    SuperscriptBox["si", "2"], " ", 
                    RowBox[{"Sin", "[", 
                    RowBox[{"2", " ", "omega"}], "]"}]}]}], ")"}], "2"], 
                    RowBox[{"16", " ", 
                    SuperscriptBox["si", "4"]}]], "+", 
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"16", " ", 
                    SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    SuperscriptBox["ecc", "2"]}], "-", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["ecc", "2"], " ", 
                    SuperscriptBox["si", "2"]}], "-", 
                    RowBox[{"8", " ", 
                    SuperscriptBox["si", "4"]}], "+", 
                    RowBox[{
                    SuperscriptBox["ecc", "2"], " ", 
                    SuperscriptBox["si", "4"]}], "-", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["ecc", "2"], " ", 
                    SuperscriptBox["si", "2"], " ", 
                    RowBox[{"Cos", "[", 
                    RowBox[{"2", " ", "omega"}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox["ecc", "2"], " ", 
                    SuperscriptBox["si", "4"], " ", 
                    RowBox[{"Cos", "[", 
                    RowBox[{"2", " ", "omega"}], "]"}]}]}], ")"}], "2"]}], 
                    "+", 
                    RowBox[{"384", " ", 
                    SuperscriptBox["si", "4"], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"4", " ", 
                    SuperscriptBox["si", "4"]}], "-", 
                    RowBox[{
                    SuperscriptBox["ecc", "2"], " ", 
                    SuperscriptBox["si", "4"]}], "-", 
                    RowBox[{"4", " ", 
                    SuperscriptBox["si", "4"], " ", 
                    RowBox[{"Cos", "[", 
                    RowBox[{"4", " ", "omega"}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox["ecc", "2"], " ", 
                    SuperscriptBox["si", "4"], " ", 
                    RowBox[{"Cos", "[", 
                    RowBox[{"4", " ", "omega"}], "]"}]}]}], ")"}]}], "+", 
                    RowBox[{"192", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", "ecc", " ", 
                    SuperscriptBox["si", "2"], " ", 
                    RowBox[{"Sin", "[", 
                    RowBox[{"2", " ", "omega"}], "]"}]}], "+", 
                    RowBox[{"ecc", " ", 
                    SuperscriptBox["si", "4"], " ", 
                    RowBox[{"Sin", "[", 
                    RowBox[{"2", " ", "omega"}], "]"}]}]}], ")"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "4"}], " ", "ecc", " ", 
                    SuperscriptBox["si", "2"], " ", 
                    RowBox[{"Sin", "[", 
                    RowBox[{"2", " ", "omega"}], "]"}]}], "+", 
                    RowBox[{"2", " ", "ecc", " ", 
                    SuperscriptBox["si", "4"], " ", 
                    RowBox[{"Sin", "[", 
                    RowBox[{"2", " ", "omega"}], "]"}]}], "-", 
                    RowBox[{"ecc", " ", 
                    SuperscriptBox["si", "4"], " ", 
                    RowBox[{"Sin", "[", 
                    RowBox[{"4", " ", "omega"}], "]"}]}]}], ")"}]}]}], ")"}], 
                    "/", 
                    RowBox[{"(", 
                    RowBox[{"48", " ", 
                    SuperscriptBox["2", 
                    RowBox[{"2", "/", "3"}]], " ", 
                    SuperscriptBox["si", "4"], " ", 
                    SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"128", " ", 
                    SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    SuperscriptBox["ecc", "2"]}], "-", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["ecc", "2"], " ", 
                    SuperscriptBox["si", "2"]}], "-", 
                    RowBox[{"8", " ", 
                    SuperscriptBox["si", "4"]}], "+", 
                    RowBox[{
                    SuperscriptBox["ecc", "2"], " ", 
                    SuperscriptBox["si", "4"]}], "-", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["ecc", "2"], " ", 
                    SuperscriptBox["si", "2"], " ", 
                    RowBox[{"Cos", "[", 
                    RowBox[{"2", " ", "omega"}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox["ecc", "2"], " ", 
                    SuperscriptBox["si", "4"], " ", 
                    RowBox[{"Cos", "[", 
                    RowBox[{"2", " ", "omega"}], "]"}]}]}], ")"}], "3"]}], 
                    "-", 
                    RowBox[{"9216", " ", 
                    SuperscriptBox["si", "4"], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    SuperscriptBox["ecc", "2"]}], "-", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["ecc", "2"], " ", 
                    SuperscriptBox["si", "2"]}], "-", 
                    RowBox[{"8", " ", 
                    SuperscriptBox["si", "4"]}], "+", 
                    RowBox[{
                    SuperscriptBox["ecc", "2"], " ", 
                    SuperscriptBox["si", "4"]}], "-", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["ecc", "2"], " ", 
                    SuperscriptBox["si", "2"], " ", 
                    RowBox[{"Cos", "[", 
                    RowBox[{"2", " ", "omega"}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox["ecc", "2"], " ", 
                    SuperscriptBox["si", "4"], " ", 
                    RowBox[{"Cos", "[", 
                    RowBox[{"2", " ", "omega"}], "]"}]}]}], ")"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"4", " ", 
                    SuperscriptBox["si", "4"]}], "-", 
                    RowBox[{
                    SuperscriptBox["ecc", "2"], " ", 
                    SuperscriptBox["si", "4"]}], "-", 
                    RowBox[{"4", " ", 
                    SuperscriptBox["si", "4"], " ", 
                    RowBox[{"Cos", "[", 
                    RowBox[{"4", " ", "omega"}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox["ecc", "2"], " ", 
                    SuperscriptBox["si", "4"], " ", 
                    RowBox[{"Cos", "[", 
                    RowBox[{"4", " ", "omega"}], "]"}]}]}], ")"}]}], "+", 
                    RowBox[{"6912", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"4", " ", 
                    SuperscriptBox["si", "4"]}], "-", 
                    RowBox[{
                    SuperscriptBox["ecc", "2"], " ", 
                    SuperscriptBox["si", "4"]}], "-", 
                    RowBox[{"4", " ", 
                    SuperscriptBox["si", "4"], " ", 
                    RowBox[{"Cos", "[", 
                    RowBox[{"4", " ", "omega"}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox["ecc", "2"], " ", 
                    SuperscriptBox["si", "4"], " ", 
                    RowBox[{"Cos", "[", 
                    RowBox[{"4", " ", "omega"}], "]"}]}]}], ")"}], " ", 
                    SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", "ecc", " ", 
                    SuperscriptBox["si", "2"], " ", 
                    RowBox[{"Sin", "[", 
                    RowBox[{"2", " ", "omega"}], "]"}]}], "+", 
                    RowBox[{"ecc", " ", 
                    SuperscriptBox["si", "4"], " ", 
                    RowBox[{"Sin", "[", 
                    RowBox[{"2", " ", "omega"}], "]"}]}]}], ")"}], "2"]}], 
                    "+", 
                    RowBox[{"2304", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    SuperscriptBox["ecc", "2"]}], "-", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["ecc", "2"], " ", 
                    SuperscriptBox["si", "2"]}], "-", 
                    RowBox[{"8", " ", 
                    SuperscriptBox["si", "4"]}], "+", 
                    RowBox[{
                    SuperscriptBox["ecc", "2"], " ", 
                    SuperscriptBox["si", "4"]}], "-", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["ecc", "2"], " ", 
                    SuperscriptBox["si", "2"], " ", 
                    RowBox[{"Cos", "[", 
                    RowBox[{"2", " ", "omega"}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox["ecc", "2"], " ", 
                    SuperscriptBox["si", "4"], " ", 
                    RowBox[{"Cos", "[", 
                    RowBox[{"2", " ", "omega"}], "]"}]}]}], ")"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", "ecc", " ", 
                    SuperscriptBox["si", "2"], " ", 
                    RowBox[{"Sin", "[", 
                    RowBox[{"2", " ", "omega"}], "]"}]}], "+", 
                    RowBox[{"ecc", " ", 
                    SuperscriptBox["si", "4"], " ", 
                    RowBox[{"Sin", "[", 
                    RowBox[{"2", " ", "omega"}], "]"}]}]}], ")"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "4"}], " ", "ecc", " ", 
                    SuperscriptBox["si", "2"], " ", 
                    RowBox[{"Sin", "[", 
                    RowBox[{"2", " ", "omega"}], "]"}]}], "+", 
                    RowBox[{"2", " ", "ecc", " ", 
                    SuperscriptBox["si", "4"], " ", 
                    RowBox[{"Sin", "[", 
                    RowBox[{"2", " ", "omega"}], "]"}]}], "-", 
                    RowBox[{"ecc", " ", 
                    SuperscriptBox["si", "4"], " ", 
                    RowBox[{"Sin", "[", 
                    RowBox[{"4", " ", "omega"}], "]"}]}]}], ")"}]}], "+", 
                    RowBox[{"13824", " ", 
                    SuperscriptBox["si", "4"], " ", 
                    SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "4"}], " ", "ecc", " ", 
                    SuperscriptBox["si", "2"], " ", 
                    RowBox[{"Sin", "[", 
                    RowBox[{"2", " ", "omega"}], "]"}]}], "+", 
                    RowBox[{"2", " ", "ecc", " ", 
                    SuperscriptBox["si", "4"], " ", 
                    RowBox[{"Sin", "[", 
                    RowBox[{"2", " ", "omega"}], "]"}]}], "-", 
                    RowBox[{"ecc", " ", 
                    SuperscriptBox["si", "4"], " ", 
                    RowBox[{"Sin", "[", 
                    RowBox[{"4", " ", "omega"}], "]"}]}]}], ")"}], "2"]}], 
                    "+", 
                    RowBox[{"\[Sqrt]", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "4"}], " ", 
                    SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"16", " ", 
                    SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    SuperscriptBox["ecc", "2"]}], "-", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["ecc", "2"], " ", 
                    SuperscriptBox["si", "2"]}], "-", 
                    RowBox[{"8", " ", 
                    SuperscriptBox["si", "4"]}], "+", 
                    RowBox[{
                    SuperscriptBox["ecc", "2"], " ", 
                    SuperscriptBox["si", "4"]}], "-", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["ecc", "2"], " ", 
                    SuperscriptBox["si", "2"], " ", 
                    RowBox[{"Cos", "[", 
                    RowBox[{"2", " ", "omega"}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox["ecc", "2"], " ", 
                    SuperscriptBox["si", "4"], " ", 
                    RowBox[{"Cos", "[", 
                    RowBox[{"2", " ", "omega"}], "]"}]}]}], ")"}], "2"]}], 
                    "+", 
                    RowBox[{"384", " ", 
                    SuperscriptBox["si", "4"], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"4", " ", 
                    SuperscriptBox["si", "4"]}], "-", 
                    RowBox[{
                    SuperscriptBox["ecc", "2"], " ", 
                    SuperscriptBox["si", "4"]}], "-", 
                    RowBox[{"4", " ", 
                    SuperscriptBox["si", "4"], " ", 
                    RowBox[{"Cos", "[", 
                    RowBox[{"4", " ", "omega"}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox["ecc", "2"], " ", 
                    SuperscriptBox["si", "4"], " ", 
                    RowBox[{"Cos", "[", 
                    RowBox[{"4", " ", "omega"}], "]"}]}]}], ")"}]}], "+", 
                    RowBox[{"192", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", "ecc", " ", 
                    SuperscriptBox["si", "2"], " ", 
                    RowBox[{"Sin", "[", 
                    RowBox[{"2", " ", "omega"}], "]"}]}], "+", 
                    RowBox[{"ecc", " ", 
                    SuperscriptBox["si", "4"], " ", 
                    RowBox[{"Sin", "[", 
                    RowBox[{"2", " ", "omega"}], "]"}]}]}], ")"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "4"}], " ", "ecc", " ", 
                    SuperscriptBox["si", "2"], " ", 
                    RowBox[{"Sin", "[", 
                    RowBox[{"2", " ", "omega"}], "]"}]}], "+", 
                    RowBox[{"2", " ", "ecc", " ", 
                    SuperscriptBox["si", "4"], " ", 
                    RowBox[{"Sin", "[", 
                    RowBox[{"2", " ", "omega"}], "]"}]}], "-", 
                    RowBox[{"ecc", " ", 
                    SuperscriptBox["si", "4"], " ", 
                    RowBox[{"Sin", "[", 
                    RowBox[{"4", " ", "omega"}], "]"}]}]}], ")"}]}]}], ")"}], 
                    "3"]}], "+", 
                    SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"128", " ", 
                    SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    SuperscriptBox["ecc", "2"]}], "-", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["ecc", "2"], " ", 
                    SuperscriptBox["si", "2"]}], "-", 
                    RowBox[{"8", " ", 
                    SuperscriptBox["si", "4"]}], "+", 
                    RowBox[{
                    SuperscriptBox["ecc", "2"], " ", 
                    SuperscriptBox["si", "4"]}], "-", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["ecc", "2"], " ", 
                    SuperscriptBox["si", "2"], " ", 
                    RowBox[{"Cos", "[", 
                    RowBox[{"2", " ", "omega"}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox["ecc", "2"], " ", 
                    SuperscriptBox["si", "4"], " ", 
                    RowBox[{"Cos", "[", 
                    RowBox[{"2", " ", "omega"}], "]"}]}]}], ")"}], "3"]}], 
                    "-", 
                    RowBox[{"9216", " ", 
                    SuperscriptBox["si", "4"], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    SuperscriptBox["ecc", "2"]}], "-", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["ecc", "2"], " ", 
                    SuperscriptBox["si", "2"]}], "-", 
                    RowBox[{"8", " ", 
                    SuperscriptBox["si", "4"]}], "+", 
                    RowBox[{
                    SuperscriptBox["ecc", "2"], " ", 
                    SuperscriptBox["si", "4"]}], "-", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["ecc", "2"], " ", 
                    SuperscriptBox["si", "2"], " ", 
                    RowBox[{"Cos", "[", 
                    RowBox[{"2", " ", "omega"}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox["ecc", "2"], " ", 
                    SuperscriptBox["si", "4"], " ", 
                    RowBox[{"Cos", "[", 
                    RowBox[{"2", " ", "omega"}], "]"}]}]}], ")"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"4", " ", 
                    SuperscriptBox["si", "4"]}], "-", 
                    RowBox[{
                    SuperscriptBox["ecc", "2"], " ", 
                    SuperscriptBox["si", "4"]}], "-", 
                    RowBox[{"4", " ", 
                    SuperscriptBox["si", "4"], " ", 
                    RowBox[{"Cos", "[", 
                    RowBox[{"4", " ", "omega"}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox["ecc", "2"], " ", 
                    SuperscriptBox["si", "4"], " ", 
                    RowBox[{"Cos", "[", 
                    RowBox[{"4", " ", "omega"}], "]"}]}]}], ")"}]}], "+", 
                    RowBox[{"6912", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"4", " ", 
                    SuperscriptBox["si", "4"]}], "-", 
                    RowBox[{
                    SuperscriptBox["ecc", "2"], " ", 
                    SuperscriptBox["si", "4"]}], "-", 
                    RowBox[{"4", " ", 
                    SuperscriptBox["si", "4"], " ", 
                    RowBox[{"Cos", "[", 
                    RowBox[{"4", " ", "omega"}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox["ecc", "2"], " ", 
                    SuperscriptBox["si", "4"], " ", 
                    RowBox[{"Cos", "[", 
                    RowBox[{"4", " ", "omega"}], "]"}]}]}], ")"}], " ", 
                    SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", "ecc", " ", 
                    SuperscriptBox["si", "2"], " ", 
                    RowBox[{"Sin", "[", 
                    RowBox[{"2", " ", "omega"}], "]"}]}], "+", 
                    RowBox[{"ecc", " ", 
                    SuperscriptBox["si", "4"], " ", 
                    RowBox[{"Sin", "[", 
                    RowBox[{"2", " ", "omega"}], "]"}]}]}], ")"}], "2"]}], 
                    "+", 
                    RowBox[{"2304", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    SuperscriptBox["ecc", "2"]}], "-", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["ecc", "2"], " ", 
                    SuperscriptBox["si", "2"]}], "-", 
                    RowBox[{"8", " ", 
                    SuperscriptBox["si", "4"]}], "+", 
                    RowBox[{
                    SuperscriptBox["ecc", "2"], " ", 
                    SuperscriptBox["si", "4"]}], "-", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["ecc", "2"], " ", 
                    SuperscriptBox["si", "2"], " ", 
                    RowBox[{"Cos", "[", 
                    RowBox[{"2", " ", "omega"}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox["ecc", "2"], " ", 
                    SuperscriptBox["si", "4"], " ", 
                    RowBox[{"Cos", "[", 
                    RowBox[{"2", " ", "omega"}], "]"}]}]}], ")"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", "ecc", " ", 
                    SuperscriptBox["si", "2"], " ", 
                    RowBox[{"Sin", "[", 
                    RowBox[{"2", " ", "omega"}], "]"}]}], "+", 
                    RowBox[{"ecc", " ", 
                    SuperscriptBox["si", "4"], " ", 
                    RowBox[{"Sin", "[", 
                    RowBox[{"2", " ", "omega"}], "]"}]}]}], ")"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "4"}], " ", "ecc", " ", 
                    SuperscriptBox["si", "2"], " ", 
                    RowBox[{"Sin", "[", 
                    RowBox[{"2", " ", "omega"}], "]"}]}], "+", 
                    RowBox[{"2", " ", "ecc", " ", 
                    SuperscriptBox["si", "4"], " ", 
                    RowBox[{"Sin", "[", 
                    RowBox[{"2", " ", "omega"}], "]"}]}], "-", 
                    RowBox[{"ecc", " ", 
                    SuperscriptBox["si", "4"], " ", 
                    RowBox[{"Sin", "[", 
                    RowBox[{"4", " ", "omega"}], "]"}]}]}], ")"}]}], "+", 
                    RowBox[{"13824", " ", 
                    SuperscriptBox["si", "4"], " ", 
                    SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "4"}], " ", "ecc", " ", 
                    SuperscriptBox["si", "2"], " ", 
                    RowBox[{"Sin", "[", 
                    RowBox[{"2", " ", "omega"}], "]"}]}], "+", 
                    RowBox[{"2", " ", "ecc", " ", 
                    SuperscriptBox["si", "4"], " ", 
                    RowBox[{"Sin", "[", 
                    RowBox[{"2", " ", "omega"}], "]"}]}], "-", 
                    RowBox[{"ecc", " ", 
                    SuperscriptBox["si", "4"], " ", 
                    RowBox[{"Sin", "[", 
                    RowBox[{"4", " ", "omega"}], "]"}]}]}], ")"}], "2"]}]}], 
                    ")"}], "2"]}], ")"}]}]}], ")"}], 
                    RowBox[{"1", "/", "3"}]]}], ")"}]}], "+", 
                    RowBox[{
                    FractionBox["1", 
                    RowBox[{"96", " ", 
                    SuperscriptBox["2", 
                    RowBox[{"1", "/", "3"}]], " ", 
                    SuperscriptBox["si", "4"]}]], 
                    SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"128", " ", 
                    SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    SuperscriptBox["ecc", "2"]}], "-", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["ecc", "2"], " ", 
                    SuperscriptBox["si", "2"]}], "-", 
                    RowBox[{"8", " ", 
                    SuperscriptBox["si", "4"]}], "+", 
                    RowBox[{
                    SuperscriptBox["ecc", "2"], " ", 
                    SuperscriptBox["si", "4"]}], "-", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["ecc", "2"], " ", 
                    SuperscriptBox["si", "2"], " ", 
                    RowBox[{"Cos", "[", 
                    RowBox[{"2", " ", "omega"}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox["ecc", "2"], " ", 
                    SuperscriptBox["si", "4"], " ", 
                    RowBox[{"Cos", "[", 
                    RowBox[{"2", " ", "omega"}], "]"}]}]}], ")"}], "3"]}], 
                    "-", 
                    RowBox[{"9216", " ", 
                    SuperscriptBox["si", "4"], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    SuperscriptBox["ecc", "2"]}], "-", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["ecc", "2"], " ", 
                    SuperscriptBox["si", "2"]}], "-", 
                    RowBox[{"8", " ", 
                    SuperscriptBox["si", "4"]}], "+", 
                    RowBox[{
                    SuperscriptBox["ecc", "2"], " ", 
                    SuperscriptBox["si", "4"]}], "-", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["ecc", "2"], " ", 
                    SuperscriptBox["si", "2"], " ", 
                    RowBox[{"Cos", "[", 
                    RowBox[{"2", " ", "omega"}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox["ecc", "2"], " ", 
                    SuperscriptBox["si", "4"], " ", 
                    RowBox[{"Cos", "[", 
                    RowBox[{"2", " ", "omega"}], "]"}]}]}], ")"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"4", " ", 
                    SuperscriptBox["si", "4"]}], "-", 
                    RowBox[{
                    SuperscriptBox["ecc", "2"], " ", 
                    SuperscriptBox["si", "4"]}], "-", 
                    RowBox[{"4", " ", 
                    SuperscriptBox["si", "4"], " ", 
                    RowBox[{"Cos", "[", 
                    RowBox[{"4", " ", "omega"}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox["ecc", "2"], " ", 
                    SuperscriptBox["si", "4"], " ", 
                    RowBox[{"Cos", "[", 
                    RowBox[{"4", " ", "omega"}], "]"}]}]}], ")"}]}], "+", 
                    RowBox[{"6912", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"4", " ", 
                    SuperscriptBox["si", "4"]}], "-", 
                    RowBox[{
                    SuperscriptBox["ecc", "2"], " ", 
                    SuperscriptBox["si", "4"]}], "-", 
                    RowBox[{"4", " ", 
                    SuperscriptBox["si", "4"], " ", 
                    RowBox[{"Cos", "[", 
                    RowBox[{"4", " ", "omega"}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox["ecc", "2"], " ", 
                    SuperscriptBox["si", "4"], " ", 
                    RowBox[{"Cos", "[", 
                    RowBox[{"4", " ", "omega"}], "]"}]}]}], ")"}], " ", 
                    SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", "ecc", " ", 
                    SuperscriptBox["si", "2"], " ", 
                    RowBox[{"Sin", "[", 
                    RowBox[{"2", " ", "omega"}], "]"}]}], "+", 
                    RowBox[{"ecc", " ", 
                    SuperscriptBox["si", "4"], " ", 
                    RowBox[{"Sin", "[", 
                    RowBox[{"2", " ", "omega"}], "]"}]}]}], ")"}], "2"]}], 
                    "+", 
                    RowBox[{"2304", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    SuperscriptBox["ecc", "2"]}], "-", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["ecc", "2"], " ", 
                    SuperscriptBox["si", "2"]}], "-", 
                    RowBox[{"8", " ", 
                    SuperscriptBox["si", "4"]}], "+", 
                    RowBox[{
                    SuperscriptBox["ecc", "2"], " ", 
                    SuperscriptBox["si", "4"]}], "-", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["ecc", "2"], " ", 
                    SuperscriptBox["si", "2"], " ", 
                    RowBox[{"Cos", "[", 
                    RowBox[{"2", " ", "omega"}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox["ecc", "2"], " ", 
                    SuperscriptBox["si", "4"], " ", 
                    RowBox[{"Cos", "[", 
                    RowBox[{"2", " ", "omega"}], "]"}]}]}], ")"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", "ecc", " ", 
                    SuperscriptBox["si", "2"], " ", 
                    RowBox[{"Sin", "[", 
                    RowBox[{"2", " ", "omega"}], "]"}]}], "+", 
                    RowBox[{"ecc", " ", 
                    SuperscriptBox["si", "4"], " ", 
                    RowBox[{"Sin", "[", 
                    RowBox[{"2", " ", "omega"}], "]"}]}]}], ")"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "4"}], " ", "ecc", " ", 
                    SuperscriptBox["si", "2"], " ", 
                    RowBox[{"Sin", "[", 
                    RowBox[{"2", " ", "omega"}], "]"}]}], "+", 
                    RowBox[{"2", " ", "ecc", " ", 
                    SuperscriptBox["si", "4"], " ", 
                    RowBox[{"Sin", "[", 
                    RowBox[{"2", " ", "omega"}], "]"}]}], "-", 
                    RowBox[{"ecc", " ", 
                    SuperscriptBox["si", "4"], " ", 
                    RowBox[{"Sin", "[", 
                    RowBox[{"4", " ", "omega"}], "]"}]}]}], ")"}]}], "+", 
                    RowBox[{"13824", " ", 
                    SuperscriptBox["si", "4"], " ", 
                    SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "4"}], " ", "ecc", " ", 
                    SuperscriptBox["si", "2"], " ", 
                    RowBox[{"Sin", "[", 
                    RowBox[{"2", " ", "omega"}], "]"}]}], "+", 
                    RowBox[{"2", " ", "ecc", " ", 
                    SuperscriptBox["si", "4"], " ", 
                    RowBox[{"Sin", "[", 
                    RowBox[{"2", " ", "omega"}], "]"}]}], "-", 
                    RowBox[{"ecc", " ", 
                    SuperscriptBox["si", "4"], " ", 
                    RowBox[{"Sin", "[", 
                    RowBox[{"4", " ", "omega"}], "]"}]}]}], ")"}], "2"]}], 
                    "+", 
                    RowBox[{"\[Sqrt]", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "4"}], " ", 
                    SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"16", " ", 
                    SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    SuperscriptBox["ecc", "2"]}], "-", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["ecc", "2"], " ", 
                    SuperscriptBox["si", "2"]}], "-", 
                    RowBox[{"8", " ", 
                    SuperscriptBox["si", "4"]}], "+", 
                    RowBox[{
                    SuperscriptBox["ecc", "2"], " ", 
                    SuperscriptBox["si", "4"]}], "-", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["ecc", "2"], " ", 
                    SuperscriptBox["si", "2"], " ", 
                    RowBox[{"Cos", "[", 
                    RowBox[{"2", " ", "omega"}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox["ecc", "2"], " ", 
                    SuperscriptBox["si", "4"], " ", 
                    RowBox[{"Cos", "[", 
                    RowBox[{"2", " ", "omega"}], "]"}]}]}], ")"}], "2"]}], 
                    "+", 
                    RowBox[{"384", " ", 
                    SuperscriptBox["si", "4"], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"4", " ", 
                    SuperscriptBox["si", "4"]}], "-", 
                    RowBox[{
                    SuperscriptBox["ecc", "2"], " ", 
                    SuperscriptBox["si", "4"]}], "-", 
                    RowBox[{"4", " ", 
                    SuperscriptBox["si", "4"], " ", 
                    RowBox[{"Cos", "[", 
                    RowBox[{"4", " ", "omega"}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox["ecc", "2"], " ", 
                    SuperscriptBox["si", "4"], " ", 
                    RowBox[{"Cos", "[", 
                    RowBox[{"4", " ", "omega"}], "]"}]}]}], ")"}]}], "+", 
                    RowBox[{"192", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", "ecc", " ", 
                    SuperscriptBox["si", "2"], " ", 
                    RowBox[{"Sin", "[", 
                    RowBox[{"2", " ", "omega"}], "]"}]}], "+", 
                    RowBox[{"ecc", " ", 
                    SuperscriptBox["si", "4"], " ", 
                    RowBox[{"Sin", "[", 
                    RowBox[{"2", " ", "omega"}], "]"}]}]}], ")"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "4"}], " ", "ecc", " ", 
                    SuperscriptBox["si", "2"], " ", 
                    RowBox[{"Sin", "[", 
                    RowBox[{"2", " ", "omega"}], "]"}]}], "+", 
                    RowBox[{"2", " ", "ecc", " ", 
                    SuperscriptBox["si", "4"], " ", 
                    RowBox[{"Sin", "[", 
                    RowBox[{"2", " ", "omega"}], "]"}]}], "-", 
                    RowBox[{"ecc", " ", 
                    SuperscriptBox["si", "4"], " ", 
                    RowBox[{"Sin", "[", 
                    RowBox[{"4", " ", "omega"}], "]"}]}]}], ")"}]}]}], ")"}], 
                    "3"]}], "+", 
                    SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"128", " ", 
                    SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    SuperscriptBox["ecc", "2"]}], "-", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["ecc", "2"], " ", 
                    SuperscriptBox["si", "2"]}], "-", 
                    RowBox[{"8", " ", 
                    SuperscriptBox["si", "4"]}], "+", 
                    RowBox[{
                    SuperscriptBox["ecc", "2"], " ", 
                    SuperscriptBox["si", "4"]}], "-", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["ecc", "2"], " ", 
                    SuperscriptBox["si", "2"], " ", 
                    RowBox[{"Cos", "[", 
                    RowBox[{"2", " ", "omega"}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox["ecc", "2"], " ", 
                    SuperscriptBox["si", "4"], " ", 
                    RowBox[{"Cos", "[", 
                    RowBox[{"2", " ", "omega"}], "]"}]}]}], ")"}], "3"]}], 
                    "-", 
                    RowBox[{"9216", " ", 
                    SuperscriptBox["si", "4"], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    SuperscriptBox["ecc", "2"]}], "-", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["ecc", "2"], " ", 
                    SuperscriptBox["si", "2"]}], "-", 
                    RowBox[{"8", " ", 
                    SuperscriptBox["si", "4"]}], "+", 
                    RowBox[{
                    SuperscriptBox["ecc", "2"], " ", 
                    SuperscriptBox["si", "4"]}], "-", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["ecc", "2"], " ", 
                    SuperscriptBox["si", "2"], " ", 
                    RowBox[{"Cos", "[", 
                    RowBox[{"2", " ", "omega"}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox["ecc", "2"], " ", 
                    SuperscriptBox["si", "4"], " ", 
                    RowBox[{"Cos", "[", 
                    RowBox[{"2", " ", "omega"}], "]"}]}]}], ")"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"4", " ", 
                    SuperscriptBox["si", "4"]}], "-", 
                    RowBox[{
                    SuperscriptBox["ecc", "2"], " ", 
                    SuperscriptBox["si", "4"]}], "-", 
                    RowBox[{"4", " ", 
                    SuperscriptBox["si", "4"], " ", 
                    RowBox[{"Cos", "[", 
                    RowBox[{"4", " ", "omega"}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox["ecc", "2"], " ", 
                    SuperscriptBox["si", "4"], " ", 
                    RowBox[{"Cos", "[", 
                    RowBox[{"4", " ", "omega"}], "]"}]}]}], ")"}]}], "+", 
                    RowBox[{"6912", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"4", " ", 
                    SuperscriptBox["si", "4"]}], "-", 
                    RowBox[{
                    SuperscriptBox["ecc", "2"], " ", 
                    SuperscriptBox["si", "4"]}], "-", 
                    RowBox[{"4", " ", 
                    SuperscriptBox["si", "4"], " ", 
                    RowBox[{"Cos", "[", 
                    RowBox[{"4", " ", "omega"}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox["ecc", "2"], " ", 
                    SuperscriptBox["si", "4"], " ", 
                    RowBox[{"Cos", "[", 
                    RowBox[{"4", " ", "omega"}], "]"}]}]}], ")"}], " ", 
                    SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", "ecc", " ", 
                    SuperscriptBox["si", "2"], " ", 
                    RowBox[{"Sin", "[", 
                    RowBox[{"2", " ", "omega"}], "]"}]}], "+", 
                    RowBox[{"ecc", " ", 
                    SuperscriptBox["si", "4"], " ", 
                    RowBox[{"Sin", "[", 
                    RowBox[{"2", " ", "omega"}], "]"}]}]}], ")"}], "2"]}], 
                    "+", 
                    RowBox[{"2304", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    SuperscriptBox["ecc", "2"]}], "-", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["ecc", "2"], " ", 
                    SuperscriptBox["si", "2"]}], "-", 
                    RowBox[{"8", " ", 
                    SuperscriptBox["si", "4"]}], "+", 
                    RowBox[{
                    SuperscriptBox["ecc", "2"], " ", 
                    SuperscriptBox["si", "4"]}], "-", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["ecc", "2"], " ", 
                    SuperscriptBox["si", "2"], " ", 
                    RowBox[{"Cos", "[", 
                    RowBox[{"2", " ", "omega"}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox["ecc", "2"], " ", 
                    SuperscriptBox["si", "4"], " ", 
                    RowBox[{"Cos", "[", 
                    RowBox[{"2", " ", "omega"}], "]"}]}]}], ")"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", "ecc", " ", 
                    SuperscriptBox["si", "2"], " ", 
                    RowBox[{"Sin", "[", 
                    RowBox[{"2", " ", "omega"}], "]"}]}], "+", 
                    RowBox[{"ecc", " ", 
                    SuperscriptBox["si", "4"], " ", 
                    RowBox[{"Sin", "[", 
                    RowBox[{"2", " ", "omega"}], "]"}]}]}], ")"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "4"}], " ", "ecc", " ", 
                    SuperscriptBox["si", "2"], " ", 
                    RowBox[{"Sin", "[", 
                    RowBox[{"2", " ", "omega"}], "]"}]}], "+", 
                    RowBox[{"2", " ", "ecc", " ", 
                    SuperscriptBox["si", "4"], " ", 
                    RowBox[{"Sin", "[", 
                    RowBox[{"2", " ", "omega"}], "]"}]}], "-", 
                    RowBox[{"ecc", " ", 
                    SuperscriptBox["si", "4"], " ", 
                    RowBox[{"Sin", "[", 
                    RowBox[{"4", " ", "omega"}], "]"}]}]}], ")"}]}], "+", 
                    RowBox[{"13824", " ", 
                    SuperscriptBox["si", "4"], " ", 
                    SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "4"}], " ", "ecc", " ", 
                    SuperscriptBox["si", "2"], " ", 
                    RowBox[{"Sin", "[", 
                    RowBox[{"2", " ", "omega"}], "]"}]}], "+", 
                    RowBox[{"2", " ", "ecc", " ", 
                    SuperscriptBox["si", "4"], " ", 
                    RowBox[{"Sin", "[", 
                    RowBox[{"2", " ", "omega"}], "]"}]}], "-", 
                    RowBox[{"ecc", " ", 
                    SuperscriptBox["si", "4"], " ", 
                    RowBox[{"Sin", "[", 
                    RowBox[{"4", " ", "omega"}], "]"}]}]}], ")"}], "2"]}]}], 
                    ")"}], "2"]}], ")"}]}]}], ")"}], 
                    RowBox[{"1", "/", "3"}]]}]}], ")"}]}]}], ")"}]}]}], 
                 ")"}]}]}]}]}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"sinf", "\[Rule]", 
             RowBox[{
              RowBox[{"-", 
               FractionBox[
                RowBox[{
                 RowBox[{"2", " ", "ecc", " ", 
                  RowBox[{"Sin", "[", 
                   RowBox[{"2", " ", "omega"}], "]"}]}], "-", 
                 RowBox[{"ecc", " ", 
                  SuperscriptBox["si", "2"], " ", 
                  RowBox[{"Sin", "[", 
                   RowBox[{"2", " ", "omega"}], "]"}]}]}], 
                RowBox[{"8", " ", 
                 SuperscriptBox["si", "2"]}]]}], "-", 
              RowBox[{
               FractionBox["1", "2"], " ", 
               RowBox[{"\[Sqrt]", 
                RowBox[{"(", 
                 RowBox[{
                  RowBox[{"-", 
                   FractionBox[
                    RowBox[{
                    RowBox[{"2", " ", 
                    SuperscriptBox["ecc", "2"]}], "-", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["ecc", "2"], " ", 
                    SuperscriptBox["si", "2"]}], "-", 
                    RowBox[{"8", " ", 
                    SuperscriptBox["si", "4"]}], "+", 
                    RowBox[{
                    SuperscriptBox["ecc", "2"], " ", 
                    SuperscriptBox["si", "4"]}], "-", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["ecc", "2"], " ", 
                    SuperscriptBox["si", "2"], " ", 
                    RowBox[{"Cos", "[", 
                    RowBox[{"2", " ", "omega"}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox["ecc", "2"], " ", 
                    SuperscriptBox["si", "4"], " ", 
                    RowBox[{"Cos", "[", 
                    RowBox[{"2", " ", "omega"}], "]"}]}]}], 
                    RowBox[{"12", " ", 
                    SuperscriptBox["si", "4"]}]]}], "+", 
                  FractionBox[
                   SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", "ecc", " ", 
                    RowBox[{"Sin", "[", 
                    RowBox[{"2", " ", "omega"}], "]"}]}], "-", 
                    TemplateBox[{"1"},
                    "OutputSizeLimit`Skeleton"]}], ")"}], "2"], 
                   RowBox[{"16", " ", 
                    SuperscriptBox["si", "4"]}]], "+", 
                  FractionBox[
                   TemplateBox[{"1"},
                    "OutputSizeLimit`Skeleton"], 
                   RowBox[{"48", " ", 
                    SuperscriptBox["2", 
                    RowBox[{"2", "/", "3"}]], " ", 
                    SuperscriptBox["si", "4"], " ", 
                    SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    TemplateBox[{"6"},
                    "OutputSizeLimit`Skeleton"], "+", 
                    SqrtBox[
                    TemplateBox[{"1"},
                    "OutputSizeLimit`Skeleton"]]}], ")"}], 
                    RowBox[{"1", "/", "3"}]]}]], "+", 
                  FractionBox[
                   SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    TemplateBox[{"6"},
                    "OutputSizeLimit`Skeleton"], "+", 
                    SqrtBox[
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "4"}], " ", 
                    SuperscriptBox[
                    TemplateBox[{"1"},
                    "OutputSizeLimit`Skeleton"], "3"]}], "+", 
                    SuperscriptBox[
                    TemplateBox[{"1"},
                    "OutputSizeLimit`Skeleton"], "2"]}]]}], ")"}], 
                    RowBox[{"1", "/", "3"}]], 
                   RowBox[{"96", " ", 
                    SuperscriptBox["2", 
                    RowBox[{"1", "/", "3"}]], " ", 
                    SuperscriptBox["si", "4"]}]]}], ")"}]}]}], "+", 
              RowBox[{
               FractionBox["1", "2"], " ", 
               RowBox[{"\[Sqrt]", 
                RowBox[{"(", 
                 RowBox[{
                  RowBox[{"-", 
                   FractionBox[
                    RowBox[{
                    RowBox[{"2", " ", 
                    SuperscriptBox["ecc", "2"]}], "-", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["ecc", "2"], " ", 
                    SuperscriptBox["si", "2"]}], "-", 
                    RowBox[{"8", " ", 
                    SuperscriptBox["si", "4"]}], "+", 
                    RowBox[{
                    SuperscriptBox["ecc", "2"], " ", 
                    SuperscriptBox["si", "4"]}], "-", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["ecc", "2"], " ", 
                    SuperscriptBox["si", "2"], " ", 
                    RowBox[{"Cos", "[", 
                    RowBox[{"2", " ", "omega"}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox["ecc", "2"], " ", 
                    SuperscriptBox["si", "4"], " ", 
                    RowBox[{"Cos", "[", 
                    RowBox[{"2", " ", "omega"}], "]"}]}]}], 
                    RowBox[{"6", " ", 
                    SuperscriptBox["si", "4"]}]]}], "+", 
                  FractionBox[
                   SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", "ecc", " ", 
                    RowBox[{"Sin", "[", 
                    RowBox[{"2", " ", "omega"}], "]"}]}], "-", 
                    RowBox[{"ecc", " ", 
                    SuperscriptBox["si", "2"], " ", 
                    RowBox[{"Sin", "[", 
                    RowBox[{"2", " ", "omega"}], "]"}]}]}], ")"}], "2"], 
                   RowBox[{"8", " ", 
                    SuperscriptBox["si", "4"]}]], "-", 
                  RowBox[{
                   RowBox[{"(", 
                    RowBox[{
                    RowBox[{"16", " ", 
                    SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    SuperscriptBox["ecc", "2"]}], "-", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["ecc", "2"], " ", 
                    SuperscriptBox["si", "2"]}], "-", 
                    RowBox[{"8", " ", 
                    SuperscriptBox["si", "4"]}], "+", 
                    RowBox[{
                    SuperscriptBox["ecc", "2"], " ", 
                    SuperscriptBox["si", "4"]}], "-", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["ecc", "2"], " ", 
                    SuperscriptBox["si", "2"], " ", 
                    RowBox[{"Cos", "[", 
                    RowBox[{"2", " ", "omega"}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox["ecc", "2"], " ", 
                    SuperscriptBox["si", "4"], " ", 
                    RowBox[{"Cos", "[", 
                    RowBox[{"2", " ", "omega"}], "]"}]}]}], ")"}], "2"]}], 
                    "+", 
                    RowBox[{"384", " ", 
                    SuperscriptBox["si", "4"], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"4", " ", 
                    SuperscriptBox["si", "4"]}], "-", 
                    RowBox[{
                    SuperscriptBox["ecc", "2"], " ", 
                    SuperscriptBox["si", "4"]}], "-", 
                    RowBox[{"4", " ", 
                    SuperscriptBox["si", "4"], " ", 
                    RowBox[{"Cos", "[", 
                    RowBox[{"4", " ", "omega"}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox["ecc", "2"], " ", 
                    SuperscriptBox["si", "4"], " ", 
                    RowBox[{"Cos", "[", 
                    RowBox[{"4", " ", "omega"}], "]"}]}]}], ")"}]}], "+", 
                    RowBox[{"192", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", "ecc", " ", 
                    SuperscriptBox["si", "2"], " ", 
                    RowBox[{"Sin", "[", 
                    RowBox[{"2", " ", "omega"}], "]"}]}], "+", 
                    RowBox[{"ecc", " ", 
                    SuperscriptBox["si", "4"], " ", 
                    RowBox[{"Sin", "[", 
                    RowBox[{"2", " ", "omega"}], "]"}]}]}], ")"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "4"}], " ", "ecc", " ", 
                    SuperscriptBox["si", "2"], " ", 
                    RowBox[{"Sin", "[", 
                    RowBox[{"2", " ", "omega"}], "]"}]}], "+", 
                    RowBox[{"2", " ", "ecc", " ", 
                    SuperscriptBox["si", "4"], " ", 
                    RowBox[{"Sin", "[", 
                    RowBox[{"2", " ", "omega"}], "]"}]}], "-", 
                    RowBox[{"ecc", " ", 
                    SuperscriptBox["si", "4"], " ", 
                    RowBox[{"Sin", "[", 
                    RowBox[{"4", " ", "omega"}], "]"}]}]}], ")"}]}]}], ")"}], 
                   "/", 
                   RowBox[{"(", 
                    RowBox[{"48", " ", 
                    SuperscriptBox["2", 
                    RowBox[{"2", "/", "3"}]], " ", 
                    SuperscriptBox["si", "4"], " ", 
                    SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    TemplateBox[{"6"},
                    "OutputSizeLimit`Skeleton"], "+", 
                    SqrtBox[
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "4"}], " ", 
                    SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"16", " ", 
                    SuperscriptBox[
                    TemplateBox[{"1"},
                    "OutputSizeLimit`Skeleton"], "2"]}], "+", 
                    TemplateBox[{"1"},
                    "OutputSizeLimit`Skeleton"], "+", 
                    TemplateBox[{"1"},
                    "OutputSizeLimit`Skeleton"]}], ")"}], "3"]}], "+", 
                    SuperscriptBox[
                    RowBox[{"(", 
                    TemplateBox[{"1"},
                    "OutputSizeLimit`Skeleton"], ")"}], "2"]}]]}], ")"}], 
                    RowBox[{"1", "/", "3"}]]}], ")"}]}], "-", 
                  RowBox[{
                   FractionBox["1", 
                    RowBox[{"96", " ", 
                    SuperscriptBox["2", 
                    RowBox[{"1", "/", "3"}]], " ", 
                    SuperscriptBox["si", "4"]}]], 
                   SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"128", " ", 
                    SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    SuperscriptBox["ecc", "2"]}], "-", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["ecc", "2"], " ", 
                    SuperscriptBox["si", "2"]}], "-", 
                    RowBox[{"8", " ", 
                    SuperscriptBox["si", "4"]}], "+", 
                    RowBox[{
                    SuperscriptBox["ecc", "2"], " ", 
                    SuperscriptBox["si", "4"]}], "-", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["ecc", "2"], " ", 
                    SuperscriptBox["si", "2"], " ", 
                    RowBox[{"Cos", "[", 
                    RowBox[{"2", " ", "omega"}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox["ecc", "2"], " ", 
                    SuperscriptBox["si", "4"], " ", 
                    RowBox[{"Cos", "[", 
                    RowBox[{"2", " ", "omega"}], "]"}]}]}], ")"}], "3"]}], 
                    "-", 
                    RowBox[{"9216", " ", 
                    SuperscriptBox["si", "4"], " ", 
                    RowBox[{"(", 
                    TemplateBox[{"1"},
                    "OutputSizeLimit`Skeleton"], ")"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"4", " ", 
                    SuperscriptBox["si", "4"]}], "-", 
                    RowBox[{
                    SuperscriptBox["ecc", "2"], " ", 
                    SuperscriptBox["si", "4"]}], "-", 
                    RowBox[{"4", " ", 
                    SuperscriptBox["si", "4"], " ", 
                    RowBox[{"Cos", "[", 
                    RowBox[{"4", " ", "omega"}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox["ecc", "2"], " ", 
                    SuperscriptBox["si", "4"], " ", 
                    RowBox[{"Cos", "[", 
                    RowBox[{"4", " ", "omega"}], "]"}]}]}], ")"}]}], "+", 
                    TemplateBox[{"2"},
                    "OutputSizeLimit`Skeleton"], "+", 
                    TemplateBox[{"1"},
                    "OutputSizeLimit`Skeleton"], "+", 
                    SqrtBox[
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "4"}], " ", 
                    SuperscriptBox[
                    RowBox[{"(", 
                    TemplateBox[{"1"},
                    "OutputSizeLimit`Skeleton"], ")"}], "3"]}], "+", 
                    SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    TemplateBox[{"5"},
                    "OutputSizeLimit`Skeleton"], "+", 
                    TemplateBox[{"1"},
                    "OutputSizeLimit`Skeleton"]}], ")"}], "2"]}]]}], ")"}], 
                    RowBox[{"1", "/", "3"}]]}], "-", 
                  RowBox[{
                   RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    FractionBox["1", 
                    RowBox[{"4", " ", 
                    SuperscriptBox["si", "6"]}]], 
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    SuperscriptBox["ecc", "2"]}], "-", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["ecc", "2"], " ", 
                    SuperscriptBox["si", "2"]}], "-", 
                    RowBox[{"8", " ", 
                    SuperscriptBox["si", "4"]}], "+", 
                    RowBox[{
                    SuperscriptBox["ecc", "2"], " ", 
                    SuperscriptBox["si", "4"]}], "-", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["ecc", "2"], " ", 
                    SuperscriptBox["si", "2"], " ", 
                    RowBox[{"Cos", "[", 
                    RowBox[{"2", " ", "omega"}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox["ecc", "2"], " ", 
                    SuperscriptBox["si", "4"], " ", 
                    RowBox[{"Cos", "[", 
                    RowBox[{"2", " ", "omega"}], "]"}]}]}], ")"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", "ecc", " ", 
                    RowBox[{"Sin", "[", 
                    RowBox[{"2", " ", "omega"}], "]"}]}], "-", 
                    RowBox[{"ecc", " ", 
                    SuperscriptBox["si", "2"], " ", 
                    RowBox[{"Sin", "[", 
                    RowBox[{"2", " ", "omega"}], "]"}]}]}], ")"}]}]}], "-", 
                    FractionBox[
                    SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", "ecc", " ", 
                    RowBox[{"Sin", "[", 
                    RowBox[{"2", " ", "omega"}], "]"}]}], "-", 
                    RowBox[{"ecc", " ", 
                    SuperscriptBox["si", "2"], " ", 
                    RowBox[{"Sin", "[", 
                    RowBox[{"2", " ", "omega"}], "]"}]}]}], ")"}], "3"], 
                    RowBox[{"8", " ", 
                    SuperscriptBox["si", "6"]}]], "-", 
                    FractionBox[
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "4"}], " ", "ecc", " ", 
                    RowBox[{"Sin", "[", 
                    RowBox[{"2", " ", "omega"}], "]"}]}], "+", 
                    RowBox[{"2", " ", "ecc", " ", 
                    SuperscriptBox["si", "2"], " ", 
                    RowBox[{"Sin", "[", 
                    RowBox[{"2", " ", "omega"}], "]"}]}], "-", 
                    RowBox[{"ecc", " ", 
                    SuperscriptBox["si", "2"], " ", 
                    RowBox[{"Sin", "[", 
                    RowBox[{"4", " ", "omega"}], "]"}]}]}], 
                    SuperscriptBox["si", "2"]]}], ")"}], "/", 
                   RowBox[{"(", 
                    RowBox[{"4", " ", 
                    RowBox[{"\[Sqrt]", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"-", 
                    FractionBox[
                    RowBox[{
                    RowBox[{"2", " ", 
                    SuperscriptBox["ecc", "2"]}], "-", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["ecc", "2"], " ", 
                    SuperscriptBox["si", "2"]}], "-", 
                    RowBox[{"8", " ", 
                    SuperscriptBox["si", "4"]}], "+", 
                    RowBox[{
                    SuperscriptBox["ecc", "2"], " ", 
                    SuperscriptBox["si", "4"]}], "-", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["ecc", "2"], " ", 
                    SuperscriptBox["si", "2"], " ", 
                    RowBox[{"Cos", "[", 
                    RowBox[{"2", " ", "omega"}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox["ecc", "2"], " ", 
                    SuperscriptBox["si", "4"], " ", 
                    RowBox[{"Cos", "[", 
                    RowBox[{"2", " ", "omega"}], "]"}]}]}], 
                    RowBox[{"12", " ", 
                    SuperscriptBox["si", "4"]}]]}], "+", 
                    FractionBox[
                    SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", "ecc", " ", 
                    RowBox[{"Sin", "[", 
                    RowBox[{"2", " ", "omega"}], "]"}]}], "-", 
                    RowBox[{"ecc", " ", 
                    SuperscriptBox["si", "2"], " ", 
                    RowBox[{"Sin", "[", 
                    RowBox[{"2", " ", "omega"}], "]"}]}]}], ")"}], "2"], 
                    RowBox[{"16", " ", 
                    SuperscriptBox["si", "4"]}]], "+", 
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"16", " ", 
                    SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    SuperscriptBox["ecc", "2"]}], "-", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["ecc", "2"], " ", 
                    SuperscriptBox["si", "2"]}], "-", 
                    RowBox[{"8", " ", 
                    SuperscriptBox["si", "4"]}], "+", 
                    RowBox[{
                    SuperscriptBox["ecc", "2"], " ", 
                    SuperscriptBox["si", "4"]}], "-", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["ecc", "2"], " ", 
                    SuperscriptBox["si", "2"], " ", 
                    RowBox[{"Cos", "[", 
                    RowBox[{"2", " ", "omega"}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox["ecc", "2"], " ", 
                    SuperscriptBox["si", "4"], " ", 
                    RowBox[{"Cos", "[", 
                    RowBox[{"2", " ", "omega"}], "]"}]}]}], ")"}], "2"]}], 
                    "+", 
                    RowBox[{"384", " ", 
                    SuperscriptBox["si", "4"], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"4", " ", 
                    SuperscriptBox["si", "4"]}], "-", 
                    RowBox[{
                    SuperscriptBox["ecc", "2"], " ", 
                    SuperscriptBox["si", "4"]}], "-", 
                    RowBox[{"4", " ", 
                    SuperscriptBox["si", "4"], " ", 
                    RowBox[{"Cos", "[", 
                    RowBox[{"4", " ", "omega"}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox["ecc", "2"], " ", 
                    SuperscriptBox["si", "4"], " ", 
                    RowBox[{"Cos", "[", 
                    RowBox[{"4", " ", "omega"}], "]"}]}]}], ")"}]}], "+", 
                    RowBox[{"192", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", "ecc", " ", 
                    SuperscriptBox["si", "2"], " ", 
                    RowBox[{"Sin", "[", 
                    RowBox[{"2", " ", "omega"}], "]"}]}], "+", 
                    RowBox[{"ecc", " ", 
                    SuperscriptBox["si", "4"], " ", 
                    RowBox[{"Sin", "[", 
                    RowBox[{"2", " ", "omega"}], "]"}]}]}], ")"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "4"}], " ", "ecc", " ", 
                    SuperscriptBox["si", "2"], " ", 
                    RowBox[{"Sin", "[", 
                    RowBox[{"2", " ", "omega"}], "]"}]}], "+", 
                    RowBox[{"2", " ", "ecc", " ", 
                    SuperscriptBox["si", "4"], " ", 
                    RowBox[{"Sin", "[", 
                    RowBox[{"2", " ", "omega"}], "]"}]}], "-", 
                    RowBox[{"ecc", " ", 
                    SuperscriptBox["si", "4"], " ", 
                    RowBox[{"Sin", "[", 
                    RowBox[{"4", " ", "omega"}], "]"}]}]}], ")"}]}]}], ")"}], 
                    "/", 
                    RowBox[{"(", 
                    RowBox[{"48", " ", 
                    SuperscriptBox["2", 
                    RowBox[{"2", "/", "3"}]], " ", 
                    SuperscriptBox["si", "4"], " ", 
                    SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    TemplateBox[{"6"},
                    "OutputSizeLimit`Skeleton"], "+", 
                    SqrtBox[
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "4"}], " ", 
                    SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"16", " ", 
                    SuperscriptBox[
                    TemplateBox[{"1"},
                    "OutputSizeLimit`Skeleton"], "2"]}], "+", 
                    TemplateBox[{"1"},
                    "OutputSizeLimit`Skeleton"], "+", 
                    TemplateBox[{"1"},
                    "OutputSizeLimit`Skeleton"]}], ")"}], "3"]}], "+", 
                    SuperscriptBox[
                    RowBox[{"(", 
                    TemplateBox[{"1"},
                    "OutputSizeLimit`Skeleton"], ")"}], "2"]}]]}], ")"}], 
                    RowBox[{"1", "/", "3"}]]}], ")"}]}], "+", 
                    FractionBox[
                    SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    TemplateBox[{"6"},
                    "OutputSizeLimit`Skeleton"], "+", 
                    SqrtBox[
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "4"}], " ", 
                    SuperscriptBox[
                    RowBox[{"(", 
                    TemplateBox[{"1"},
                    "OutputSizeLimit`Skeleton"], ")"}], "3"]}], "+", 
                    SuperscriptBox[
                    RowBox[{"(", 
                    TemplateBox[{"1"},
                    "OutputSizeLimit`Skeleton"], ")"}], "2"]}]]}], ")"}], 
                    RowBox[{"1", "/", "3"}]], 
                    RowBox[{"96", " ", 
                    SuperscriptBox["2", 
                    RowBox[{"1", "/", "3"}]], " ", 
                    SuperscriptBox["si", "4"]}]]}], ")"}]}]}], ")"}]}]}], 
                 ")"}]}]}]}]}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"sinf", "\[Rule]", 
             RowBox[{
              RowBox[{"-", 
               FractionBox[
                RowBox[{
                 RowBox[{"2", " ", "ecc", " ", 
                  RowBox[{"Sin", "[", 
                   RowBox[{"2", " ", "omega"}], "]"}]}], "-", 
                 RowBox[{"ecc", " ", 
                  SuperscriptBox["si", "2"], " ", 
                  RowBox[{"Sin", "[", 
                   RowBox[{"2", " ", "omega"}], "]"}]}]}], 
                RowBox[{"8", " ", 
                 SuperscriptBox["si", "2"]}]]}], "+", 
              RowBox[{
               FractionBox["1", "2"], " ", 
               TemplateBox[{"1"},
                "OutputSizeLimit`Skeleton"]}], "-", 
              RowBox[{
               FractionBox["1", "2"], " ", 
               SqrtBox[
                RowBox[{
                 RowBox[{"-", 
                  FractionBox[
                   TemplateBox[{"1"},
                    "OutputSizeLimit`Skeleton"], 
                   RowBox[{"6", " ", 
                    SuperscriptBox["si", "4"]}]]}], "+", 
                 FractionBox[
                  SuperscriptBox[
                   TemplateBox[{"1"},
                    "OutputSizeLimit`Skeleton"], "2"], 
                  RowBox[{"8", " ", 
                   SuperscriptBox["si", "4"]}]], "-", 
                 FractionBox[
                  TemplateBox[{"1"},
                   "OutputSizeLimit`Skeleton"], 
                  TemplateBox[{"1"},
                   "OutputSizeLimit`Skeleton"]], "-", 
                 FractionBox[
                  TemplateBox[{"1"},
                   "OutputSizeLimit`Skeleton"], 
                  TemplateBox[{"1"},
                   "OutputSizeLimit`Skeleton"]], "+", 
                 FractionBox[
                  TemplateBox[{"1"},
                   "OutputSizeLimit`Skeleton"], 
                  RowBox[{"4", " ", 
                   SqrtBox[
                    TemplateBox[{"1"},
                    "OutputSizeLimit`Skeleton"]]}]]}]]}]}]}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"sinf", "\[Rule]", 
             RowBox[{
              RowBox[{"-", 
               FractionBox[
                RowBox[{
                 RowBox[{"2", " ", "ecc", " ", 
                  RowBox[{"Sin", "[", 
                   RowBox[{"2", " ", "omega"}], "]"}]}], "-", 
                 RowBox[{"ecc", " ", 
                  SuperscriptBox["si", "2"], " ", 
                  RowBox[{"Sin", "[", 
                   RowBox[{"2", " ", "omega"}], "]"}]}]}], 
                RowBox[{"8", " ", 
                 SuperscriptBox["si", "2"]}]]}], "+", 
              RowBox[{
               FractionBox["1", "2"], " ", 
               RowBox[{"\[Sqrt]", 
                RowBox[{"(", 
                 RowBox[{
                  RowBox[{"-", 
                   FractionBox[
                    RowBox[{
                    RowBox[{"2", " ", 
                    SuperscriptBox["ecc", "2"]}], "-", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["ecc", "2"], " ", 
                    SuperscriptBox["si", "2"]}], "-", 
                    RowBox[{"8", " ", 
                    SuperscriptBox["si", "4"]}], "+", 
                    RowBox[{
                    SuperscriptBox["ecc", "2"], " ", 
                    SuperscriptBox["si", "4"]}], "-", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["ecc", "2"], " ", 
                    SuperscriptBox["si", "2"], " ", 
                    RowBox[{"Cos", "[", 
                    RowBox[{"2", " ", "omega"}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox["ecc", "2"], " ", 
                    SuperscriptBox["si", "4"], " ", 
                    RowBox[{"Cos", "[", 
                    RowBox[{"2", " ", "omega"}], "]"}]}]}], 
                    RowBox[{"12", " ", 
                    SuperscriptBox["si", "4"]}]]}], "+", 
                  FractionBox[
                   SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", "ecc", " ", 
                    RowBox[{"Sin", "[", 
                    RowBox[{"2", " ", "omega"}], "]"}]}], "-", 
                    RowBox[{"ecc", " ", 
                    SuperscriptBox["si", "2"], " ", 
                    RowBox[{"Sin", "[", 
                    RowBox[{"2", " ", "omega"}], "]"}]}]}], ")"}], "2"], 
                   RowBox[{"16", " ", 
                    SuperscriptBox["si", "4"]}]], "+", 
                  RowBox[{
                   RowBox[{"(", 
                    RowBox[{
                    RowBox[{"16", " ", 
                    SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    SuperscriptBox["ecc", "2"]}], "-", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["ecc", "2"], " ", 
                    SuperscriptBox["si", "2"]}], "-", 
                    RowBox[{"8", " ", 
                    SuperscriptBox["si", "4"]}], "+", 
                    RowBox[{
                    SuperscriptBox["ecc", "2"], " ", 
                    SuperscriptBox["si", "4"]}], "-", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["ecc", "2"], " ", 
                    SuperscriptBox["si", "2"], " ", 
                    RowBox[{"Cos", "[", 
                    RowBox[{"2", " ", "omega"}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox["ecc", "2"], " ", 
                    SuperscriptBox["si", "4"], " ", 
                    RowBox[{"Cos", "[", 
                    RowBox[{"2", " ", "omega"}], "]"}]}]}], ")"}], "2"]}], 
                    "+", 
                    RowBox[{"384", " ", 
                    SuperscriptBox["si", "4"], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"4", " ", 
                    SuperscriptBox["si", "4"]}], "-", 
                    RowBox[{
                    SuperscriptBox["ecc", "2"], " ", 
                    SuperscriptBox["si", "4"]}], "-", 
                    RowBox[{"4", " ", 
                    SuperscriptBox["si", "4"], " ", 
                    RowBox[{"Cos", "[", 
                    RowBox[{"4", " ", "omega"}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox["ecc", "2"], " ", 
                    SuperscriptBox["si", "4"], " ", 
                    RowBox[{"Cos", "[", 
                    RowBox[{"4", " ", "omega"}], "]"}]}]}], ")"}]}], "+", 
                    RowBox[{"192", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", "ecc", " ", 
                    SuperscriptBox["si", "2"], " ", 
                    RowBox[{"Sin", "[", 
                    RowBox[{"2", " ", "omega"}], "]"}]}], "+", 
                    RowBox[{"ecc", " ", 
                    SuperscriptBox["si", "4"], " ", 
                    RowBox[{"Sin", "[", 
                    RowBox[{"2", " ", "omega"}], "]"}]}]}], ")"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "4"}], " ", "ecc", " ", 
                    SuperscriptBox["si", "2"], " ", 
                    RowBox[{"Sin", "[", 
                    RowBox[{"2", " ", "omega"}], "]"}]}], "+", 
                    RowBox[{"2", " ", "ecc", " ", 
                    SuperscriptBox["si", "4"], " ", 
                    RowBox[{"Sin", "[", 
                    RowBox[{"2", " ", "omega"}], "]"}]}], "-", 
                    RowBox[{"ecc", " ", 
                    SuperscriptBox["si", "4"], " ", 
                    RowBox[{"Sin", "[", 
                    RowBox[{"4", " ", "omega"}], "]"}]}]}], ")"}]}]}], ")"}], 
                   "/", 
                   RowBox[{"(", 
                    RowBox[{"48", " ", 
                    SuperscriptBox["2", 
                    RowBox[{"2", "/", "3"}]], " ", 
                    SuperscriptBox["si", "4"], " ", 
                    SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"128", " ", 
                    SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    SuperscriptBox["ecc", "2"]}], "-", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["ecc", "2"], " ", 
                    SuperscriptBox["si", "2"]}], "-", 
                    RowBox[{"8", " ", 
                    SuperscriptBox["si", "4"]}], "+", 
                    RowBox[{
                    SuperscriptBox["ecc", "2"], " ", 
                    SuperscriptBox["si", "4"]}], "-", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["ecc", "2"], " ", 
                    SuperscriptBox["si", "2"], " ", 
                    RowBox[{"Cos", "[", 
                    RowBox[{"2", " ", "omega"}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox["ecc", "2"], " ", 
                    SuperscriptBox["si", "4"], " ", 
                    RowBox[{"Cos", "[", 
                    RowBox[{"2", " ", "omega"}], "]"}]}]}], ")"}], "3"]}], 
                    "-", 
                    RowBox[{"9216", " ", 
                    SuperscriptBox["si", "4"], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    SuperscriptBox["ecc", "2"]}], "-", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["ecc", "2"], " ", 
                    SuperscriptBox["si", "2"]}], "-", 
                    RowBox[{"8", " ", 
                    SuperscriptBox["si", "4"]}], "+", 
                    RowBox[{
                    SuperscriptBox["ecc", "2"], " ", 
                    SuperscriptBox["si", "4"]}], "-", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["ecc", "2"], " ", 
                    SuperscriptBox["si", "2"], " ", 
                    RowBox[{"Cos", "[", 
                    RowBox[{"2", " ", "omega"}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox["ecc", "2"], " ", 
                    SuperscriptBox["si", "4"], " ", 
                    RowBox[{"Cos", "[", 
                    RowBox[{"2", " ", "omega"}], "]"}]}]}], ")"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"4", " ", 
                    SuperscriptBox["si", "4"]}], "-", 
                    RowBox[{
                    SuperscriptBox["ecc", "2"], " ", 
                    SuperscriptBox["si", "4"]}], "-", 
                    RowBox[{"4", " ", 
                    SuperscriptBox["si", "4"], " ", 
                    RowBox[{"Cos", "[", 
                    RowBox[{"4", " ", "omega"}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox["ecc", "2"], " ", 
                    SuperscriptBox["si", "4"], " ", 
                    RowBox[{"Cos", "[", 
                    RowBox[{"4", " ", "omega"}], "]"}]}]}], ")"}]}], "+", 
                    RowBox[{"6912", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"4", " ", 
                    SuperscriptBox["si", "4"]}], "-", 
                    RowBox[{
                    SuperscriptBox["ecc", "2"], " ", 
                    SuperscriptBox["si", "4"]}], "-", 
                    TemplateBox[{"1"},
                    "OutputSizeLimit`Skeleton"], "+", 
                    RowBox[{
                    SuperscriptBox["ecc", "2"], " ", 
                    SuperscriptBox["si", "4"], " ", 
                    RowBox[{"Cos", "[", 
                    RowBox[{"4", " ", "omega"}], "]"}]}]}], ")"}], " ", 
                    SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", "ecc", " ", 
                    TemplateBox[{"1"},
                    "OutputSizeLimit`Skeleton"], " ", 
                    RowBox[{"Sin", "[", 
                    RowBox[{"2", " ", "omega"}], "]"}]}], "+", 
                    TemplateBox[{"1"},
                    "OutputSizeLimit`Skeleton"]}], ")"}], "2"]}], "+", 
                    TemplateBox[{"1"},
                    "OutputSizeLimit`Skeleton"], "+", 
                    RowBox[{"13824", " ", 
                    SuperscriptBox["si", "4"], " ", 
                    SuperscriptBox[
                    RowBox[{"(", 
                    TemplateBox[{"1"},
                    "OutputSizeLimit`Skeleton"], ")"}], "2"]}], "+", 
                    RowBox[{"\[Sqrt]", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "4"}], " ", 
                    SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"16", " ", 
                    SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    SuperscriptBox["ecc", "2"]}], "-", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["ecc", "2"], " ", 
                    SuperscriptBox["si", "2"]}], "-", 
                    RowBox[{"8", " ", 
                    SuperscriptBox["si", "4"]}], "+", 
                    RowBox[{
                    SuperscriptBox["ecc", "2"], " ", 
                    SuperscriptBox["si", "4"]}], "-", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["ecc", "2"], " ", 
                    SuperscriptBox["si", "2"], " ", 
                    RowBox[{"Cos", "[", 
                    RowBox[{"2", " ", "omega"}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox["ecc", "2"], " ", 
                    SuperscriptBox["si", "4"], " ", 
                    RowBox[{"Cos", "[", 
                    RowBox[{"2", " ", "omega"}], "]"}]}]}], ")"}], "2"]}], 
                    "+", 
                    RowBox[{"384", " ", 
                    SuperscriptBox["si", "4"], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"4", " ", 
                    SuperscriptBox["si", "4"]}], "-", 
                    RowBox[{
                    SuperscriptBox["ecc", "2"], " ", 
                    SuperscriptBox["si", "4"]}], "-", 
                    RowBox[{"4", " ", 
                    SuperscriptBox["si", "4"], " ", 
                    RowBox[{"Cos", "[", 
                    RowBox[{"4", " ", "omega"}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox["ecc", "2"], " ", 
                    SuperscriptBox["si", "4"], " ", 
                    RowBox[{"Cos", "[", 
                    RowBox[{"4", " ", "omega"}], "]"}]}]}], ")"}]}], "+", 
                    RowBox[{"192", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", "ecc", " ", 
                    SuperscriptBox["si", "2"], " ", 
                    RowBox[{"Sin", "[", 
                    RowBox[{"2", " ", "omega"}], "]"}]}], "+", 
                    RowBox[{"ecc", " ", 
                    SuperscriptBox["si", "4"], " ", 
                    RowBox[{"Sin", "[", 
                    RowBox[{"2", " ", "omega"}], "]"}]}]}], ")"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "4"}], " ", "ecc", " ", 
                    SuperscriptBox["si", "2"], " ", 
                    RowBox[{"Sin", "[", 
                    RowBox[{"2", " ", "omega"}], "]"}]}], "+", 
                    RowBox[{"2", " ", "ecc", " ", 
                    SuperscriptBox["si", "4"], " ", 
                    RowBox[{"Sin", "[", 
                    RowBox[{"2", " ", "omega"}], "]"}]}], "-", 
                    RowBox[{"ecc", " ", 
                    SuperscriptBox["si", "4"], " ", 
                    RowBox[{"Sin", "[", 
                    RowBox[{"4", " ", "omega"}], "]"}]}]}], ")"}]}]}], ")"}], 
                    "3"]}], "+", 
                    SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    TemplateBox[{"5"},
                    "OutputSizeLimit`Skeleton"], "+", 
                    RowBox[{"13824", " ", 
                    SuperscriptBox["si", "4"], " ", 
                    SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "4"}], " ", "ecc", " ", 
                    SuperscriptBox["si", "2"], " ", 
                    RowBox[{"Sin", "[", 
                    RowBox[{"2", " ", "omega"}], "]"}]}], "+", 
                    TemplateBox[{"1"},
                    "OutputSizeLimit`Skeleton"], "-", 
                    TemplateBox[{"1"},
                    "OutputSizeLimit`Skeleton"]}], ")"}], "2"]}]}], ")"}], 
                    "2"]}], ")"}]}]}], ")"}], 
                    RowBox[{"1", "/", "3"}]]}], ")"}]}], "+", 
                  RowBox[{
                   FractionBox["1", 
                    RowBox[{"96", " ", 
                    SuperscriptBox["2", 
                    RowBox[{"1", "/", "3"}]], " ", 
                    SuperscriptBox["si", "4"]}]], 
                   SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"128", " ", 
                    SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    SuperscriptBox["ecc", "2"]}], "-", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["ecc", "2"], " ", 
                    SuperscriptBox["si", "2"]}], "-", 
                    RowBox[{"8", " ", 
                    SuperscriptBox["si", "4"]}], "+", 
                    RowBox[{
                    SuperscriptBox["ecc", "2"], " ", 
                    SuperscriptBox["si", "4"]}], "-", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["ecc", "2"], " ", 
                    SuperscriptBox["si", "2"], " ", 
                    RowBox[{"Cos", "[", 
                    RowBox[{"2", " ", "omega"}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox["ecc", "2"], " ", 
                    SuperscriptBox["si", "4"], " ", 
                    RowBox[{"Cos", "[", 
                    RowBox[{"2", " ", "omega"}], "]"}]}]}], ")"}], "3"]}], 
                    "-", 
                    RowBox[{"9216", " ", 
                    SuperscriptBox["si", "4"], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    SuperscriptBox["ecc", "2"]}], "-", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["ecc", "2"], " ", 
                    SuperscriptBox["si", "2"]}], "-", 
                    RowBox[{"8", " ", 
                    SuperscriptBox["si", "4"]}], "+", 
                    RowBox[{
                    SuperscriptBox["ecc", "2"], " ", 
                    SuperscriptBox["si", "4"]}], "-", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["ecc", "2"], " ", 
                    SuperscriptBox["si", "2"], " ", 
                    RowBox[{"Cos", "[", 
                    RowBox[{"2", " ", "omega"}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox["ecc", "2"], " ", 
                    SuperscriptBox["si", "4"], " ", 
                    RowBox[{"Cos", "[", 
                    RowBox[{"2", " ", "omega"}], "]"}]}]}], ")"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"4", " ", 
                    SuperscriptBox["si", "4"]}], "-", 
                    RowBox[{
                    SuperscriptBox["ecc", "2"], " ", 
                    SuperscriptBox["si", "4"]}], "-", 
                    RowBox[{"4", " ", 
                    SuperscriptBox["si", "4"], " ", 
                    RowBox[{"Cos", "[", 
                    RowBox[{"4", " ", "omega"}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox["ecc", "2"], " ", 
                    SuperscriptBox["si", "4"], " ", 
                    RowBox[{"Cos", "[", 
                    RowBox[{"4", " ", "omega"}], "]"}]}]}], ")"}]}], "+", 
                    RowBox[{"6912", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"4", " ", 
                    SuperscriptBox["si", "4"]}], "-", 
                    RowBox[{
                    SuperscriptBox["ecc", "2"], " ", 
                    SuperscriptBox["si", "4"]}], "-", 
                    RowBox[{"4", " ", 
                    SuperscriptBox["si", "4"], " ", 
                    TemplateBox[{"1"},
                    "OutputSizeLimit`Skeleton"]}], "+", 
                    RowBox[{
                    SuperscriptBox["ecc", "2"], " ", 
                    SuperscriptBox["si", "4"], " ", 
                    RowBox[{"Cos", "[", 
                    RowBox[{"4", " ", "omega"}], "]"}]}]}], ")"}], " ", 
                    SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    TemplateBox[{"1"},
                    "OutputSizeLimit`Skeleton"], "+", 
                    TemplateBox[{"1"},
                    "OutputSizeLimit`Skeleton"]}], ")"}], "2"]}], "+", 
                    TemplateBox[{"1"},
                    "OutputSizeLimit`Skeleton"], "+", 
                    RowBox[{"13824", " ", 
                    SuperscriptBox["si", "4"], " ", 
                    SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "4"}], " ", "ecc", " ", 
                    SuperscriptBox["si", "2"], " ", 
                    RowBox[{"Sin", "[", 
                    RowBox[{"2", " ", "omega"}], "]"}]}], "+", 
                    RowBox[{"2", " ", "ecc", " ", 
                    SuperscriptBox["si", "4"], " ", 
                    RowBox[{"Sin", "[", 
                    RowBox[{"2", " ", "omega"}], "]"}]}], "-", 
                    RowBox[{"ecc", " ", 
                    SuperscriptBox["si", "4"], " ", 
                    RowBox[{"Sin", "[", 
                    RowBox[{"4", " ", "omega"}], "]"}]}]}], ")"}], "2"]}], 
                    "+", 
                    RowBox[{"\[Sqrt]", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "4"}], " ", 
                    SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"16", " ", 
                    SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    SuperscriptBox["ecc", "2"]}], "-", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["ecc", "2"], " ", 
                    SuperscriptBox["si", "2"]}], "-", 
                    RowBox[{"8", " ", 
                    SuperscriptBox["si", "4"]}], "+", 
                    RowBox[{
                    SuperscriptBox["ecc", "2"], " ", 
                    SuperscriptBox["si", "4"]}], "-", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["ecc", "2"], " ", 
                    SuperscriptBox["si", "2"], " ", 
                    RowBox[{"Cos", "[", 
                    RowBox[{"2", " ", "omega"}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox["ecc", "2"], " ", 
                    SuperscriptBox["si", "4"], " ", 
                    RowBox[{"Cos", "[", 
                    RowBox[{"2", " ", "omega"}], "]"}]}]}], ")"}], "2"]}], 
                    "+", 
                    RowBox[{"384", " ", 
                    SuperscriptBox["si", "4"], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"4", " ", 
                    SuperscriptBox["si", "4"]}], "-", 
                    RowBox[{
                    SuperscriptBox["ecc", "2"], " ", 
                    SuperscriptBox["si", "4"]}], "-", 
                    RowBox[{"4", " ", 
                    SuperscriptBox["si", "4"], " ", 
                    RowBox[{"Cos", "[", 
                    RowBox[{"4", " ", "omega"}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox["ecc", "2"], " ", 
                    SuperscriptBox["si", "4"], " ", 
                    RowBox[{"Cos", "[", 
                    RowBox[{"4", " ", "omega"}], "]"}]}]}], ")"}]}], "+", 
                    RowBox[{"192", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", "ecc", " ", 
                    SuperscriptBox["si", "2"], " ", 
                    RowBox[{"Sin", "[", 
                    RowBox[{"2", " ", "omega"}], "]"}]}], "+", 
                    RowBox[{"ecc", " ", 
                    SuperscriptBox["si", "4"], " ", 
                    RowBox[{"Sin", "[", 
                    RowBox[{"2", " ", "omega"}], "]"}]}]}], ")"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "4"}], " ", "ecc", " ", 
                    SuperscriptBox["si", "2"], " ", 
                    RowBox[{"Sin", "[", 
                    RowBox[{"2", " ", "omega"}], "]"}]}], "+", 
                    RowBox[{"2", " ", "ecc", " ", 
                    SuperscriptBox["si", "4"], " ", 
                    RowBox[{"Sin", "[", 
                    RowBox[{"2", " ", "omega"}], "]"}]}], "-", 
                    RowBox[{"ecc", " ", 
                    SuperscriptBox["si", "4"], " ", 
                    RowBox[{"Sin", "[", 
                    RowBox[{"4", " ", "omega"}], "]"}]}]}], ")"}]}]}], ")"}], 
                    "3"]}], "+", 
                    SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"128", " ", 
                    SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    SuperscriptBox["ecc", "2"]}], "-", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["ecc", "2"], " ", 
                    SuperscriptBox["si", "2"]}], "-", 
                    RowBox[{"8", " ", 
                    SuperscriptBox["si", "4"]}], "+", 
                    RowBox[{
                    SuperscriptBox["ecc", "2"], " ", 
                    SuperscriptBox["si", "4"]}], "-", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["ecc", "2"], " ", 
                    SuperscriptBox["si", "2"], " ", 
                    RowBox[{"Cos", "[", 
                    RowBox[{"2", " ", "omega"}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox["ecc", "2"], " ", 
                    SuperscriptBox["si", "4"], " ", 
                    RowBox[{"Cos", "[", 
                    RowBox[{"2", " ", "omega"}], "]"}]}]}], ")"}], "3"]}], 
                    "-", 
                    RowBox[{"9216", " ", 
                    SuperscriptBox["si", "4"], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    TemplateBox[{"8"},
                    "OutputSizeLimit`Skeleton"], "+", 
                    RowBox[{
                    SuperscriptBox["ecc", "2"], " ", 
                    SuperscriptBox["si", "4"], " ", 
                    RowBox[{"Cos", "[", 
                    RowBox[{"2", " ", 
                    TemplateBox[{"5"},
                    "OutputSizeLimit`Skeleton"]}], "]"}]}]}], ")"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"4", " ", 
                    SuperscriptBox["si", "4"]}], "-", 
                    RowBox[{
                    SuperscriptBox["ecc", "2"], " ", 
                    SuperscriptBox["si", "4"]}], "-", 
                    RowBox[{"4", " ", 
                    SuperscriptBox["si", "4"], " ", 
                    RowBox[{"Cos", "[", 
                    RowBox[{"4", " ", "omega"}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox["ecc", "2"], " ", 
                    SuperscriptBox["si", "4"], " ", 
                    RowBox[{"Cos", "[", 
                    RowBox[{"4", " ", "omega"}], "]"}]}]}], ")"}]}], "+", 
                    TemplateBox[{"1"},
                    "OutputSizeLimit`Skeleton"], "+", 
                    TemplateBox[{"1"},
                    "OutputSizeLimit`Skeleton"], "+", 
                    RowBox[{"13824", " ", 
                    SuperscriptBox["si", "4"], " ", 
                    SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "4"}], " ", "ecc", " ", 
                    SuperscriptBox["si", "2"], " ", 
                    RowBox[{"Sin", "[", 
                    RowBox[{"2", " ", "omega"}], "]"}]}], "+", 
                    RowBox[{"2", " ", "ecc", " ", 
                    SuperscriptBox["si", "4"], " ", 
                    RowBox[{"Sin", "[", 
                    RowBox[{"2", " ", "omega"}], "]"}]}], "-", 
                    RowBox[{"ecc", " ", 
                    SuperscriptBox["si", "4"], " ", 
                    RowBox[{"Sin", "[", 
                    RowBox[{"4", " ", "omega"}], "]"}]}]}], ")"}], "2"]}]}], 
                    ")"}], "2"]}], ")"}]}]}], ")"}], 
                    RowBox[{"1", "/", "3"}]]}]}], ")"}]}]}], "+", 
              RowBox[{
               FractionBox["1", "2"], " ", 
               RowBox[{"\[Sqrt]", 
                RowBox[{"(", 
                 RowBox[{
                  RowBox[{"-", 
                   FractionBox[
                    RowBox[{
                    RowBox[{"2", " ", 
                    SuperscriptBox["ecc", "2"]}], "-", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["ecc", "2"], " ", 
                    SuperscriptBox["si", "2"]}], "-", 
                    RowBox[{"8", " ", 
                    SuperscriptBox["si", "4"]}], "+", 
                    RowBox[{
                    SuperscriptBox["ecc", "2"], " ", 
                    SuperscriptBox["si", "4"]}], "-", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["ecc", "2"], " ", 
                    SuperscriptBox["si", "2"], " ", 
                    RowBox[{"Cos", "[", 
                    RowBox[{"2", " ", "omega"}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox["ecc", "2"], " ", 
                    SuperscriptBox["si", "4"], " ", 
                    RowBox[{"Cos", "[", 
                    RowBox[{"2", " ", "omega"}], "]"}]}]}], 
                    RowBox[{"6", " ", 
                    SuperscriptBox["si", "4"]}]]}], "+", 
                  FractionBox[
                   SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", "ecc", " ", 
                    RowBox[{"Sin", "[", 
                    RowBox[{"2", " ", "omega"}], "]"}]}], "-", 
                    RowBox[{"ecc", " ", 
                    SuperscriptBox["si", "2"], " ", 
                    RowBox[{"Sin", "[", 
                    RowBox[{"2", " ", "omega"}], "]"}]}]}], ")"}], "2"], 
                   RowBox[{"8", " ", 
                    SuperscriptBox["si", "4"]}]], "-", 
                  RowBox[{
                   RowBox[{"(", 
                    RowBox[{
                    RowBox[{"16", " ", 
                    SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    SuperscriptBox["ecc", "2"]}], "-", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["ecc", "2"], " ", 
                    SuperscriptBox["si", "2"]}], "-", 
                    RowBox[{"8", " ", 
                    SuperscriptBox["si", "4"]}], "+", 
                    RowBox[{
                    SuperscriptBox["ecc", "2"], " ", 
                    SuperscriptBox["si", "4"]}], "-", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["ecc", "2"], " ", 
                    SuperscriptBox["si", "2"], " ", 
                    RowBox[{"Cos", "[", 
                    RowBox[{"2", " ", "omega"}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox["ecc", "2"], " ", 
                    SuperscriptBox["si", "4"], " ", 
                    RowBox[{"Cos", "[", 
                    RowBox[{"2", " ", "omega"}], "]"}]}]}], ")"}], "2"]}], 
                    "+", 
                    RowBox[{"384", " ", 
                    SuperscriptBox["si", "4"], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"4", " ", 
                    SuperscriptBox["si", "4"]}], "-", 
                    RowBox[{
                    SuperscriptBox["ecc", "2"], " ", 
                    SuperscriptBox["si", "4"]}], "-", 
                    RowBox[{"4", " ", 
                    SuperscriptBox["si", "4"], " ", 
                    RowBox[{"Cos", "[", 
                    RowBox[{"4", " ", "omega"}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox["ecc", "2"], " ", 
                    SuperscriptBox["si", "4"], " ", 
                    RowBox[{"Cos", "[", 
                    RowBox[{"4", " ", "omega"}], "]"}]}]}], ")"}]}], "+", 
                    RowBox[{"192", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", "ecc", " ", 
                    SuperscriptBox["si", "2"], " ", 
                    RowBox[{"Sin", "[", 
                    RowBox[{"2", " ", "omega"}], "]"}]}], "+", 
                    RowBox[{"ecc", " ", 
                    SuperscriptBox["si", "4"], " ", 
                    RowBox[{"Sin", "[", 
                    RowBox[{"2", " ", "omega"}], "]"}]}]}], ")"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "4"}], " ", "ecc", " ", 
                    SuperscriptBox["si", "2"], " ", 
                    RowBox[{"Sin", "[", 
                    RowBox[{"2", " ", "omega"}], "]"}]}], "+", 
                    RowBox[{"2", " ", "ecc", " ", 
                    SuperscriptBox["si", "4"], " ", 
                    RowBox[{"Sin", "[", 
                    RowBox[{"2", " ", "omega"}], "]"}]}], "-", 
                    RowBox[{"ecc", " ", 
                    SuperscriptBox["si", "4"], " ", 
                    RowBox[{"Sin", "[", 
                    RowBox[{"4", " ", "omega"}], "]"}]}]}], ")"}]}]}], ")"}], 
                   "/", 
                   RowBox[{"(", 
                    RowBox[{"48", " ", 
                    SuperscriptBox["2", 
                    RowBox[{"2", "/", "3"}]], " ", 
                    SuperscriptBox["si", "4"], " ", 
                    SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"128", " ", 
                    SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    SuperscriptBox["ecc", "2"]}], "-", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["ecc", "2"], " ", 
                    SuperscriptBox["si", "2"]}], "-", 
                    RowBox[{"8", " ", 
                    SuperscriptBox["si", "4"]}], "+", 
                    RowBox[{
                    SuperscriptBox["ecc", "2"], " ", 
                    SuperscriptBox["si", "4"]}], "-", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["ecc", "2"], " ", 
                    SuperscriptBox["si", "2"], " ", 
                    RowBox[{"Cos", "[", 
                    RowBox[{"2", " ", "omega"}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox["ecc", "2"], " ", 
                    SuperscriptBox["si", "4"], " ", 
                    RowBox[{"Cos", "[", 
                    RowBox[{"2", " ", "omega"}], "]"}]}]}], ")"}], "3"]}], 
                    "-", 
                    RowBox[{"9216", " ", 
                    SuperscriptBox["si", "4"], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    SuperscriptBox["ecc", "2"]}], "-", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["ecc", "2"], " ", 
                    SuperscriptBox["si", "2"]}], "-", 
                    RowBox[{"8", " ", 
                    SuperscriptBox["si", "4"]}], "+", 
                    RowBox[{
                    SuperscriptBox["ecc", "2"], " ", 
                    SuperscriptBox["si", "4"]}], "-", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["ecc", "2"], " ", 
                    SuperscriptBox["si", "2"], " ", 
                    RowBox[{"Cos", "[", 
                    RowBox[{"2", " ", "omega"}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox["ecc", "2"], " ", 
                    SuperscriptBox["si", "4"], " ", 
                    RowBox[{"Cos", "[", 
                    RowBox[{"2", " ", "omega"}], "]"}]}]}], ")"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"4", " ", 
                    SuperscriptBox["si", "4"]}], "-", 
                    RowBox[{
                    SuperscriptBox["ecc", "2"], " ", 
                    SuperscriptBox["si", "4"]}], "-", 
                    RowBox[{"4", " ", 
                    SuperscriptBox["si", "4"], " ", 
                    RowBox[{"Cos", "[", 
                    RowBox[{"4", " ", "omega"}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox["ecc", "2"], " ", 
                    SuperscriptBox["si", "4"], " ", 
                    RowBox[{"Cos", "[", 
                    RowBox[{"4", " ", "omega"}], "]"}]}]}], ")"}]}], "+", 
                    RowBox[{"6912", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"4", " ", 
                    SuperscriptBox["si", "4"]}], "-", 
                    RowBox[{
                    SuperscriptBox["ecc", "2"], " ", 
                    SuperscriptBox["si", "4"]}], "-", 
                    RowBox[{"4", " ", 
                    SuperscriptBox["si", "4"], " ", 
                    RowBox[{"Cos", "[", 
                    RowBox[{"4", " ", "omega"}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox["ecc", "2"], " ", 
                    SuperscriptBox["si", "4"], " ", 
                    RowBox[{"Cos", "[", 
                    RowBox[{"4", " ", "omega"}], "]"}]}]}], ")"}], " ", 
                    SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", "ecc", " ", 
                    SuperscriptBox["si", "2"], " ", 
                    RowBox[{"Sin", "[", 
                    RowBox[{"2", " ", "omega"}], "]"}]}], "+", 
                    RowBox[{"ecc", " ", 
                    SuperscriptBox["si", "4"], " ", 
                    RowBox[{"Sin", "[", 
                    RowBox[{"2", " ", "omega"}], "]"}]}]}], ")"}], "2"]}], 
                    "+", 
                    RowBox[{"2304", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    SuperscriptBox["ecc", "2"]}], "-", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["ecc", "2"], " ", 
                    SuperscriptBox["si", "2"]}], "-", 
                    RowBox[{"8", " ", 
                    SuperscriptBox["si", "4"]}], "+", 
                    RowBox[{
                    SuperscriptBox["ecc", "2"], " ", 
                    SuperscriptBox["si", "4"]}], "-", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["ecc", "2"], " ", 
                    SuperscriptBox["si", "2"], " ", 
                    RowBox[{"Cos", "[", 
                    RowBox[{"2", " ", "omega"}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox["ecc", "2"], " ", 
                    SuperscriptBox["si", "4"], " ", 
                    RowBox[{"Cos", "[", 
                    RowBox[{"2", " ", "omega"}], "]"}]}]}], ")"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", "ecc", " ", 
                    TemplateBox[{"1"},
                    "OutputSizeLimit`Skeleton"], " ", 
                    RowBox[{"Sin", "[", 
                    RowBox[{"2", " ", "omega"}], "]"}]}], "+", 
                    TemplateBox[{"1"},
                    "OutputSizeLimit`Skeleton"]}], ")"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "4"}], " ", "ecc", " ", 
                    SuperscriptBox["si", "2"], " ", 
                    RowBox[{"Sin", "[", 
                    RowBox[{"2", " ", "omega"}], "]"}]}], "+", 
                    RowBox[{"2", " ", "ecc", " ", 
                    SuperscriptBox["si", "4"], " ", 
                    RowBox[{"Sin", "[", 
                    RowBox[{"2", " ", "omega"}], "]"}]}], "-", 
                    RowBox[{"ecc", " ", 
                    SuperscriptBox["si", "4"], " ", 
                    RowBox[{"Sin", "[", 
                    RowBox[{"4", " ", "omega"}], "]"}]}]}], ")"}]}], "+", 
                    RowBox[{"13824", " ", 
                    SuperscriptBox["si", "4"], " ", 
                    SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "4"}], " ", "ecc", " ", 
                    SuperscriptBox["si", "2"], " ", 
                    RowBox[{"Sin", "[", 
                    RowBox[{"2", " ", "omega"}], "]"}]}], "+", 
                    RowBox[{"2", " ", "ecc", " ", 
                    SuperscriptBox["si", "4"], " ", 
                    RowBox[{"Sin", "[", 
                    RowBox[{"2", " ", "omega"}], "]"}]}], "-", 
                    RowBox[{"ecc", " ", 
                    SuperscriptBox["si", "4"], " ", 
                    RowBox[{"Sin", "[", 
                    RowBox[{"4", " ", "omega"}], "]"}]}]}], ")"}], "2"]}], 
                    "+", 
                    RowBox[{"\[Sqrt]", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "4"}], " ", 
                    SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"16", " ", 
                    SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    SuperscriptBox["ecc", "2"]}], "-", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["ecc", "2"], " ", 
                    SuperscriptBox["si", "2"]}], "-", 
                    RowBox[{"8", " ", 
                    SuperscriptBox["si", "4"]}], "+", 
                    RowBox[{
                    SuperscriptBox["ecc", "2"], " ", 
                    SuperscriptBox["si", "4"]}], "-", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["ecc", "2"], " ", 
                    SuperscriptBox["si", "2"], " ", 
                    RowBox[{"Cos", "[", 
                    RowBox[{"2", " ", "omega"}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox["ecc", "2"], " ", 
                    SuperscriptBox["si", "4"], " ", 
                    RowBox[{"Cos", "[", 
                    RowBox[{"2", " ", "omega"}], "]"}]}]}], ")"}], "2"]}], 
                    "+", 
                    RowBox[{"384", " ", 
                    SuperscriptBox["si", "4"], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"4", " ", 
                    SuperscriptBox["si", "4"]}], "-", 
                    RowBox[{
                    SuperscriptBox["ecc", "2"], " ", 
                    SuperscriptBox["si", "4"]}], "-", 
                    RowBox[{"4", " ", 
                    SuperscriptBox["si", "4"], " ", 
                    RowBox[{"Cos", "[", 
                    RowBox[{"4", " ", "omega"}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox["ecc", "2"], " ", 
                    SuperscriptBox["si", "4"], " ", 
                    RowBox[{"Cos", "[", 
                    RowBox[{"4", " ", "omega"}], "]"}]}]}], ")"}]}], "+", 
                    RowBox[{"192", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", "ecc", " ", 
                    SuperscriptBox["si", "2"], " ", 
                    RowBox[{"Sin", "[", 
                    RowBox[{"2", " ", "omega"}], "]"}]}], "+", 
                    RowBox[{"ecc", " ", 
                    SuperscriptBox["si", "4"], " ", 
                    RowBox[{"Sin", "[", 
                    RowBox[{"2", " ", "omega"}], "]"}]}]}], ")"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "4"}], " ", "ecc", " ", 
                    SuperscriptBox["si", "2"], " ", 
                    RowBox[{"Sin", "[", 
                    RowBox[{"2", " ", "omega"}], "]"}]}], "+", 
                    RowBox[{"2", " ", "ecc", " ", 
                    SuperscriptBox["si", "4"], " ", 
                    RowBox[{"Sin", "[", 
                    RowBox[{"2", " ", "omega"}], "]"}]}], "-", 
                    RowBox[{"ecc", " ", 
                    SuperscriptBox["si", "4"], " ", 
                    RowBox[{"Sin", "[", 
                    RowBox[{"4", " ", "omega"}], "]"}]}]}], ")"}]}]}], ")"}], 
                    "3"]}], "+", 
                    SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"128", " ", 
                    SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    SuperscriptBox["ecc", "2"]}], "-", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["ecc", "2"], " ", 
                    SuperscriptBox["si", "2"]}], "-", 
                    RowBox[{"8", " ", 
                    SuperscriptBox["si", "4"]}], "+", 
                    RowBox[{
                    SuperscriptBox["ecc", "2"], " ", 
                    SuperscriptBox["si", "4"]}], "-", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["ecc", "2"], " ", 
                    SuperscriptBox["si", "2"], " ", 
                    RowBox[{"Cos", "[", 
                    RowBox[{"2", " ", "omega"}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox["ecc", "2"], " ", 
                    SuperscriptBox["si", "4"], " ", 
                    RowBox[{"Cos", "[", 
                    RowBox[{"2", " ", "omega"}], "]"}]}]}], ")"}], "3"]}], 
                    "-", 
                    RowBox[{"9216", " ", 
                    SuperscriptBox["si", "4"], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    SuperscriptBox["ecc", "2"]}], "-", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["ecc", "2"], " ", 
                    SuperscriptBox["si", "2"]}], "-", 
                    RowBox[{"8", " ", 
                    SuperscriptBox["si", "4"]}], "+", 
                    RowBox[{
                    SuperscriptBox["ecc", "2"], " ", 
                    SuperscriptBox["si", "4"]}], "-", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["ecc", "2"], " ", 
                    SuperscriptBox["si", "2"], " ", 
                    RowBox[{"Cos", "[", 
                    RowBox[{"2", " ", "omega"}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox["ecc", "2"], " ", 
                    SuperscriptBox["si", "4"], " ", 
                    RowBox[{"Cos", "[", 
                    RowBox[{"2", " ", "omega"}], "]"}]}]}], ")"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"4", " ", 
                    SuperscriptBox["si", "4"]}], "-", 
                    RowBox[{
                    SuperscriptBox["ecc", "2"], " ", 
                    SuperscriptBox["si", "4"]}], "-", 
                    RowBox[{"4", " ", 
                    SuperscriptBox["si", "4"], " ", 
                    RowBox[{"Cos", "[", 
                    RowBox[{"4", " ", "omega"}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox["ecc", "2"], " ", 
                    SuperscriptBox["si", "4"], " ", 
                    RowBox[{"Cos", "[", 
                    RowBox[{"4", " ", "omega"}], "]"}]}]}], ")"}]}], "+", 
                    RowBox[{"6912", " ", 
                    RowBox[{"(", 
                    TemplateBox[{"1"},
                    "OutputSizeLimit`Skeleton"], ")"}], " ", 
                    SuperscriptBox[
                    TemplateBox[{"1"},
                    "OutputSizeLimit`Skeleton"], "2"]}], "+", 
                    RowBox[{"2304", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    SuperscriptBox["ecc", "2"]}], "-", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["ecc", "2"], " ", 
                    SuperscriptBox["si", "2"]}], "-", 
                    RowBox[{"8", " ", 
                    SuperscriptBox["si", "4"]}], "+", 
                    RowBox[{
                    SuperscriptBox["ecc", "2"], " ", 
                    SuperscriptBox["si", "4"]}], "-", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["ecc", "2"], " ", 
                    SuperscriptBox["si", "2"], " ", 
                    RowBox[{"Cos", "[", 
                    RowBox[{"2", " ", "omega"}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox["ecc", "2"], " ", 
                    SuperscriptBox["si", "4"], " ", 
                    RowBox[{"Cos", "[", 
                    RowBox[{"2", " ", "omega"}], "]"}]}]}], ")"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    TemplateBox[{"1"},
                    "OutputSizeLimit`Skeleton"], "+", 
                    TemplateBox[{"1"},
                    "OutputSizeLimit`Skeleton"]}], ")"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "4"}], " ", "ecc", " ", 
                    SuperscriptBox["si", "2"], " ", 
                    RowBox[{"Sin", "[", 
                    RowBox[{"2", " ", "omega"}], "]"}]}], "+", 
                    RowBox[{"2", " ", "ecc", " ", 
                    SuperscriptBox["si", "4"], " ", 
                    RowBox[{"Sin", "[", 
                    RowBox[{"2", " ", "omega"}], "]"}]}], "-", 
                    RowBox[{"ecc", " ", 
                    SuperscriptBox["si", "4"], " ", 
                    RowBox[{"Sin", "[", 
                    RowBox[{"4", " ", "omega"}], "]"}]}]}], ")"}]}], "+", 
                    RowBox[{"13824", " ", 
                    SuperscriptBox["si", "4"], " ", 
                    SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "4"}], " ", "ecc", " ", 
                    SuperscriptBox["si", "2"], " ", 
                    RowBox[{"Sin", "[", 
                    RowBox[{"2", " ", "omega"}], "]"}]}], "+", 
                    RowBox[{"2", " ", "ecc", " ", 
                    SuperscriptBox["si", "4"], " ", 
                    RowBox[{"Sin", "[", 
                    RowBox[{"2", " ", "omega"}], "]"}]}], "-", 
                    RowBox[{"ecc", " ", 
                    SuperscriptBox["si", "4"], " ", 
                    RowBox[{"Sin", "[", 
                    RowBox[{"4", " ", "omega"}], "]"}]}]}], ")"}], "2"]}]}], 
                    ")"}], "2"]}], ")"}]}]}], ")"}], 
                    RowBox[{"1", "/", "3"}]]}], ")"}]}], "-", 
                  RowBox[{
                   FractionBox["1", 
                    RowBox[{"96", " ", 
                    SuperscriptBox["2", 
                    RowBox[{"1", "/", "3"}]], " ", 
                    SuperscriptBox["si", "4"]}]], 
                   SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"128", " ", 
                    SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    SuperscriptBox["ecc", "2"]}], "-", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["ecc", "2"], " ", 
                    SuperscriptBox["si", "2"]}], "-", 
                    RowBox[{"8", " ", 
                    SuperscriptBox["si", "4"]}], "+", 
                    RowBox[{
                    SuperscriptBox["ecc", "2"], " ", 
                    SuperscriptBox["si", "4"]}], "-", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["ecc", "2"], " ", 
                    SuperscriptBox["si", "2"], " ", 
                    RowBox[{"Cos", "[", 
                    RowBox[{"2", " ", "omega"}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox["ecc", "2"], " ", 
                    SuperscriptBox["si", "4"], " ", 
                    RowBox[{"Cos", "[", 
                    RowBox[{"2", " ", "omega"}], "]"}]}]}], ")"}], "3"]}], 
                    "-", 
                    RowBox[{"9216", " ", 
                    SuperscriptBox["si", "4"], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    SuperscriptBox["ecc", "2"]}], "-", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["ecc", "2"], " ", 
                    SuperscriptBox["si", "2"]}], "-", 
                    RowBox[{"8", " ", 
                    SuperscriptBox["si", "4"]}], "+", 
                    RowBox[{
                    SuperscriptBox["ecc", "2"], " ", 
                    SuperscriptBox["si", "4"]}], "-", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["ecc", "2"], " ", 
                    SuperscriptBox["si", "2"], " ", 
                    RowBox[{"Cos", "[", 
                    RowBox[{"2", " ", "omega"}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox["ecc", "2"], " ", 
                    SuperscriptBox["si", "4"], " ", 
                    RowBox[{"Cos", "[", 
                    RowBox[{"2", " ", "omega"}], "]"}]}]}], ")"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"4", " ", 
                    SuperscriptBox["si", "4"]}], "-", 
                    RowBox[{
                    SuperscriptBox["ecc", "2"], " ", 
                    SuperscriptBox["si", "4"]}], "-", 
                    RowBox[{"4", " ", 
                    SuperscriptBox["si", "4"], " ", 
                    RowBox[{"Cos", "[", 
                    RowBox[{"4", " ", "omega"}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox["ecc", "2"], " ", 
                    SuperscriptBox["si", "4"], " ", 
                    RowBox[{"Cos", "[", 
                    RowBox[{"4", " ", "omega"}], "]"}]}]}], ")"}]}], "+", 
                    RowBox[{"6912", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"4", " ", 
                    SuperscriptBox["si", "4"]}], "-", 
                    RowBox[{
                    SuperscriptBox["ecc", "2"], " ", 
                    SuperscriptBox["si", "4"]}], "-", 
                    RowBox[{"4", " ", 
                    SuperscriptBox["si", "4"], " ", 
                    RowBox[{"Cos", "[", 
                    RowBox[{"4", " ", "omega"}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox["ecc", "2"], " ", 
                    SuperscriptBox["si", "4"], " ", 
                    RowBox[{"Cos", "[", 
                    RowBox[{"4", " ", "omega"}], "]"}]}]}], ")"}], " ", 
                    SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", "ecc", " ", 
                    SuperscriptBox["si", "2"], " ", 
                    RowBox[{"Sin", "[", 
                    RowBox[{"2", " ", "omega"}], "]"}]}], "+", 
                    RowBox[{"ecc", " ", 
                    SuperscriptBox["si", "4"], " ", 
                    RowBox[{"Sin", "[", 
                    RowBox[{"2", " ", "omega"}], "]"}]}]}], ")"}], "2"]}], 
                    "+", 
                    RowBox[{"2304", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    SuperscriptBox["ecc", "2"]}], "-", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["ecc", "2"], " ", 
                    SuperscriptBox["si", "2"]}], "-", 
                    RowBox[{"8", " ", 
                    SuperscriptBox["si", "4"]}], "+", 
                    RowBox[{
                    SuperscriptBox["ecc", "2"], " ", 
                    SuperscriptBox["si", "4"]}], "-", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["ecc", "2"], " ", 
                    SuperscriptBox["si", "2"], " ", 
                    RowBox[{"Cos", "[", 
                    RowBox[{"2", " ", "omega"}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox["ecc", "2"], " ", 
                    SuperscriptBox["si", "4"], " ", 
                    RowBox[{"Cos", "[", 
                    RowBox[{"2", " ", "omega"}], "]"}]}]}], ")"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", "ecc", " ", 
                    SuperscriptBox["si", "2"], " ", 
                    RowBox[{"Sin", "[", 
                    RowBox[{"2", " ", "omega"}], "]"}]}], "+", 
                    RowBox[{"ecc", " ", 
                    SuperscriptBox["si", "4"], " ", 
                    RowBox[{"Sin", "[", 
                    RowBox[{"2", " ", "omega"}], "]"}]}]}], ")"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "4"}], " ", "ecc", " ", 
                    SuperscriptBox["si", "2"], " ", 
                    RowBox[{"Sin", "[", 
                    RowBox[{"2", " ", "omega"}], "]"}]}], "+", 
                    RowBox[{"2", " ", "ecc", " ", 
                    SuperscriptBox["si", "4"], " ", 
                    RowBox[{"Sin", "[", 
                    RowBox[{"2", " ", "omega"}], "]"}]}], "-", 
                    RowBox[{"ecc", " ", 
                    SuperscriptBox["si", "4"], " ", 
                    RowBox[{"Sin", "[", 
                    RowBox[{"4", " ", "omega"}], "]"}]}]}], ")"}]}], "+", 
                    RowBox[{"13824", " ", 
                    SuperscriptBox["si", "4"], " ", 
                    SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "4"}], " ", "ecc", " ", 
                    SuperscriptBox["si", "2"], " ", 
                    RowBox[{"Sin", "[", 
                    RowBox[{"2", " ", "omega"}], "]"}]}], "+", 
                    RowBox[{"2", " ", "ecc", " ", 
                    SuperscriptBox["si", "4"], " ", 
                    RowBox[{"Sin", "[", 
                    RowBox[{"2", " ", "omega"}], "]"}]}], "-", 
                    RowBox[{"ecc", " ", 
                    SuperscriptBox["si", "4"], " ", 
                    RowBox[{"Sin", "[", 
                    RowBox[{"4", " ", "omega"}], "]"}]}]}], ")"}], "2"]}], 
                    "+", 
                    RowBox[{"\[Sqrt]", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "4"}], " ", 
                    SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"16", " ", 
                    SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    SuperscriptBox["ecc", "2"]}], "-", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["ecc", "2"], " ", 
                    SuperscriptBox["si", "2"]}], "-", 
                    RowBox[{"8", " ", 
                    SuperscriptBox["si", "4"]}], "+", 
                    RowBox[{
                    SuperscriptBox["ecc", "2"], " ", 
                    SuperscriptBox["si", "4"]}], "-", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["ecc", "2"], " ", 
                    SuperscriptBox["si", "2"], " ", 
                    RowBox[{"Cos", "[", 
                    RowBox[{"2", " ", "omega"}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox["ecc", "2"], " ", 
                    SuperscriptBox["si", "4"], " ", 
                    RowBox[{"Cos", "[", 
                    RowBox[{"2", " ", "omega"}], "]"}]}]}], ")"}], "2"]}], 
                    "+", 
                    RowBox[{"384", " ", 
                    SuperscriptBox["si", "4"], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"4", " ", 
                    SuperscriptBox["si", "4"]}], "-", 
                    RowBox[{
                    SuperscriptBox["ecc", "2"], " ", 
                    SuperscriptBox["si", "4"]}], "-", 
                    RowBox[{"4", " ", 
                    SuperscriptBox["si", "4"], " ", 
                    RowBox[{"Cos", "[", 
                    RowBox[{"4", " ", "omega"}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox["ecc", "2"], " ", 
                    SuperscriptBox["si", "4"], " ", 
                    RowBox[{"Cos", "[", 
                    RowBox[{"4", " ", "omega"}], "]"}]}]}], ")"}]}], "+", 
                    RowBox[{"192", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", "ecc", " ", 
                    SuperscriptBox["si", "2"], " ", 
                    RowBox[{"Sin", "[", 
                    RowBox[{"2", " ", "omega"}], "]"}]}], "+", 
                    RowBox[{"ecc", " ", 
                    SuperscriptBox["si", "4"], " ", 
                    RowBox[{"Sin", "[", 
                    RowBox[{"2", " ", "omega"}], "]"}]}]}], ")"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "4"}], " ", "ecc", " ", 
                    SuperscriptBox["si", "2"], " ", 
                    RowBox[{"Sin", "[", 
                    RowBox[{"2", " ", "omega"}], "]"}]}], "+", 
                    RowBox[{"2", " ", "ecc", " ", 
                    SuperscriptBox["si", "4"], " ", 
                    RowBox[{"Sin", "[", 
                    RowBox[{"2", " ", "omega"}], "]"}]}], "-", 
                    RowBox[{"ecc", " ", 
                    SuperscriptBox["si", "4"], " ", 
                    RowBox[{"Sin", "[", 
                    RowBox[{"4", " ", "omega"}], "]"}]}]}], ")"}]}]}], ")"}], 
                    "3"]}], "+", 
                    SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"128", " ", 
                    SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    SuperscriptBox["ecc", "2"]}], "-", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["ecc", "2"], " ", 
                    SuperscriptBox["si", "2"]}], "-", 
                    RowBox[{"8", " ", 
                    SuperscriptBox["si", "4"]}], "+", 
                    RowBox[{
                    SuperscriptBox["ecc", "2"], " ", 
                    SuperscriptBox["si", "4"]}], "-", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["ecc", "2"], " ", 
                    SuperscriptBox["si", "2"], " ", 
                    RowBox[{"Cos", "[", 
                    RowBox[{"2", " ", "omega"}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox["ecc", "2"], " ", 
                    SuperscriptBox["si", "4"], " ", 
                    RowBox[{"Cos", "[", 
                    RowBox[{"2", " ", "omega"}], "]"}]}]}], ")"}], "3"]}], 
                    "-", 
                    RowBox[{"9216", " ", 
                    SuperscriptBox["si", "4"], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    SuperscriptBox["ecc", "2"]}], "-", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["ecc", "2"], " ", 
                    SuperscriptBox["si", "2"]}], "-", 
                    RowBox[{"8", " ", 
                    SuperscriptBox["si", "4"]}], "+", 
                    RowBox[{
                    SuperscriptBox["ecc", "2"], " ", 
                    SuperscriptBox["si", "4"]}], "-", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["ecc", "2"], " ", 
                    SuperscriptBox["si", "2"], " ", 
                    RowBox[{"Cos", "[", 
                    RowBox[{"2", " ", "omega"}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox["ecc", "2"], " ", 
                    SuperscriptBox["si", "4"], " ", 
                    RowBox[{"Cos", "[", 
                    RowBox[{"2", " ", "omega"}], "]"}]}]}], ")"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"4", " ", 
                    SuperscriptBox["si", "4"]}], "-", 
                    RowBox[{
                    SuperscriptBox["ecc", "2"], " ", 
                    SuperscriptBox["si", "4"]}], "-", 
                    RowBox[{"4", " ", 
                    SuperscriptBox["si", "4"], " ", 
                    RowBox[{"Cos", "[", 
                    RowBox[{"4", " ", "omega"}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox["ecc", "2"], " ", 
                    SuperscriptBox["si", "4"], " ", 
                    RowBox[{"Cos", "[", 
                    RowBox[{"4", " ", "omega"}], "]"}]}]}], ")"}]}], "+", 
                    RowBox[{"6912", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"4", " ", 
                    SuperscriptBox["si", "4"]}], "-", 
                    RowBox[{
                    SuperscriptBox["ecc", "2"], " ", 
                    SuperscriptBox["si", "4"]}], "-", 
                    RowBox[{"4", " ", 
                    SuperscriptBox["si", "4"], " ", 
                    RowBox[{"Cos", "[", 
                    RowBox[{"4", " ", "omega"}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox["ecc", "2"], " ", 
                    SuperscriptBox["si", "4"], " ", 
                    RowBox[{"Cos", "[", 
                    RowBox[{"4", " ", "omega"}], "]"}]}]}], ")"}], " ", 
                    SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", "ecc", " ", 
                    SuperscriptBox["si", "2"], " ", 
                    RowBox[{"Sin", "[", 
                    RowBox[{"2", " ", "omega"}], "]"}]}], "+", 
                    RowBox[{"ecc", " ", 
                    SuperscriptBox["si", "4"], " ", 
                    RowBox[{"Sin", "[", 
                    RowBox[{"2", " ", "omega"}], "]"}]}]}], ")"}], "2"]}], 
                    "+", 
                    RowBox[{"2304", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    SuperscriptBox["ecc", "2"]}], "-", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["ecc", "2"], " ", 
                    SuperscriptBox["si", "2"]}], "-", 
                    RowBox[{"8", " ", 
                    SuperscriptBox["si", "4"]}], "+", 
                    RowBox[{
                    SuperscriptBox["ecc", "2"], " ", 
                    SuperscriptBox["si", "4"]}], "-", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["ecc", "2"], " ", 
                    SuperscriptBox["si", "2"], " ", 
                    RowBox[{"Cos", "[", 
                    RowBox[{"2", " ", "omega"}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox["ecc", "2"], " ", 
                    SuperscriptBox["si", "4"], " ", 
                    RowBox[{"Cos", "[", 
                    RowBox[{"2", " ", "omega"}], "]"}]}]}], ")"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", "ecc", " ", 
                    SuperscriptBox["si", "2"], " ", 
                    RowBox[{"Sin", "[", 
                    RowBox[{"2", " ", "omega"}], "]"}]}], "+", 
                    RowBox[{"ecc", " ", 
                    SuperscriptBox["si", "4"], " ", 
                    RowBox[{"Sin", "[", 
                    RowBox[{"2", " ", "omega"}], "]"}]}]}], ")"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "4"}], " ", "ecc", " ", 
                    SuperscriptBox["si", "2"], " ", 
                    RowBox[{"Sin", "[", 
                    RowBox[{"2", " ", "omega"}], "]"}]}], "+", 
                    RowBox[{"2", " ", "ecc", " ", 
                    SuperscriptBox["si", "4"], " ", 
                    RowBox[{"Sin", "[", 
                    RowBox[{"2", " ", "omega"}], "]"}]}], "-", 
                    RowBox[{"ecc", " ", 
                    SuperscriptBox["si", "4"], " ", 
                    RowBox[{"Sin", "[", 
                    RowBox[{"4", " ", "omega"}], "]"}]}]}], ")"}]}], "+", 
                    RowBox[{"13824", " ", 
                    SuperscriptBox["si", "4"], " ", 
                    SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "4"}], " ", "ecc", " ", 
                    SuperscriptBox["si", "2"], " ", 
                    RowBox[{"Sin", "[", 
                    RowBox[{"2", " ", "omega"}], "]"}]}], "+", 
                    RowBox[{"2", " ", "ecc", " ", 
                    SuperscriptBox["si", "4"], " ", 
                    RowBox[{"Sin", "[", 
                    RowBox[{"2", " ", "omega"}], "]"}]}], "-", 
                    RowBox[{"ecc", " ", 
                    SuperscriptBox["si", "4"], " ", 
                    RowBox[{"Sin", "[", 
                    RowBox[{"4", " ", "omega"}], "]"}]}]}], ")"}], "2"]}]}], 
                    ")"}], "2"]}], ")"}]}]}], ")"}], 
                    RowBox[{"1", "/", "3"}]]}], "+", 
                  RowBox[{
                   RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    FractionBox["1", 
                    RowBox[{"4", " ", 
                    SuperscriptBox["si", "6"]}]], 
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    SuperscriptBox["ecc", "2"]}], "-", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["ecc", "2"], " ", 
                    SuperscriptBox["si", "2"]}], "-", 
                    RowBox[{"8", " ", 
                    SuperscriptBox["si", "4"]}], "+", 
                    RowBox[{
                    SuperscriptBox["ecc", "2"], " ", 
                    SuperscriptBox["si", "4"]}], "-", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["ecc", "2"], " ", 
                    SuperscriptBox["si", "2"], " ", 
                    RowBox[{"Cos", "[", 
                    RowBox[{"2", " ", "omega"}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox["ecc", "2"], " ", 
                    SuperscriptBox["si", "4"], " ", 
                    RowBox[{"Cos", "[", 
                    RowBox[{"2", " ", "omega"}], "]"}]}]}], ")"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", "ecc", " ", 
                    RowBox[{"Sin", "[", 
                    RowBox[{"2", " ", "omega"}], "]"}]}], "-", 
                    RowBox[{"ecc", " ", 
                    SuperscriptBox["si", "2"], " ", 
                    RowBox[{"Sin", "[", 
                    RowBox[{"2", " ", "omega"}], "]"}]}]}], ")"}]}]}], "-", 
                    FractionBox[
                    SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", "ecc", " ", 
                    RowBox[{"Sin", "[", 
                    RowBox[{"2", " ", "omega"}], "]"}]}], "-", 
                    RowBox[{"ecc", " ", 
                    SuperscriptBox["si", "2"], " ", 
                    RowBox[{"Sin", "[", 
                    RowBox[{"2", " ", "omega"}], "]"}]}]}], ")"}], "3"], 
                    RowBox[{"8", " ", 
                    SuperscriptBox["si", "6"]}]], "-", 
                    FractionBox[
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "4"}], " ", "ecc", " ", 
                    RowBox[{"Sin", "[", 
                    RowBox[{"2", " ", "omega"}], "]"}]}], "+", 
                    RowBox[{"2", " ", "ecc", " ", 
                    SuperscriptBox["si", "2"], " ", 
                    RowBox[{"Sin", "[", 
                    RowBox[{"2", " ", "omega"}], "]"}]}], "-", 
                    RowBox[{"ecc", " ", 
                    SuperscriptBox["si", "2"], " ", 
                    RowBox[{"Sin", "[", 
                    RowBox[{"4", " ", "omega"}], "]"}]}]}], 
                    SuperscriptBox["si", "2"]]}], ")"}], "/", 
                   RowBox[{"(", 
                    RowBox[{"4", " ", 
                    RowBox[{"\[Sqrt]", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"-", 
                    FractionBox[
                    RowBox[{
                    RowBox[{"2", " ", 
                    SuperscriptBox["ecc", "2"]}], "-", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["ecc", "2"], " ", 
                    SuperscriptBox["si", "2"]}], "-", 
                    RowBox[{"8", " ", 
                    SuperscriptBox["si", "4"]}], "+", 
                    RowBox[{
                    SuperscriptBox["ecc", "2"], " ", 
                    SuperscriptBox["si", "4"]}], "-", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["ecc", "2"], " ", 
                    SuperscriptBox["si", "2"], " ", 
                    RowBox[{"Cos", "[", 
                    RowBox[{"2", " ", "omega"}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox["ecc", "2"], " ", 
                    SuperscriptBox["si", "4"], " ", 
                    RowBox[{"Cos", "[", 
                    RowBox[{"2", " ", "omega"}], "]"}]}]}], 
                    RowBox[{"12", " ", 
                    SuperscriptBox["si", "4"]}]]}], "+", 
                    FractionBox[
                    SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", "ecc", " ", 
                    RowBox[{"Sin", "[", 
                    RowBox[{"2", " ", "omega"}], "]"}]}], "-", 
                    RowBox[{"ecc", " ", 
                    SuperscriptBox["si", "2"], " ", 
                    RowBox[{"Sin", "[", 
                    RowBox[{"2", " ", "omega"}], "]"}]}]}], ")"}], "2"], 
                    RowBox[{"16", " ", 
                    SuperscriptBox["si", "4"]}]], "+", 
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"16", " ", 
                    SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    SuperscriptBox["ecc", "2"]}], "-", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["ecc", "2"], " ", 
                    SuperscriptBox["si", "2"]}], "-", 
                    RowBox[{"8", " ", 
                    SuperscriptBox["si", "4"]}], "+", 
                    RowBox[{
                    SuperscriptBox["ecc", "2"], " ", 
                    SuperscriptBox["si", "4"]}], "-", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["ecc", "2"], " ", 
                    SuperscriptBox["si", "2"], " ", 
                    RowBox[{"Cos", "[", 
                    RowBox[{"2", " ", "omega"}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox["ecc", "2"], " ", 
                    SuperscriptBox["si", "4"], " ", 
                    RowBox[{"Cos", "[", 
                    RowBox[{"2", " ", "omega"}], "]"}]}]}], ")"}], "2"]}], 
                    "+", 
                    RowBox[{"384", " ", 
                    SuperscriptBox["si", "4"], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"4", " ", 
                    SuperscriptBox["si", "4"]}], "-", 
                    RowBox[{
                    SuperscriptBox["ecc", "2"], " ", 
                    SuperscriptBox["si", "4"]}], "-", 
                    RowBox[{"4", " ", 
                    SuperscriptBox["si", "4"], " ", 
                    RowBox[{"Cos", "[", 
                    RowBox[{"4", " ", "omega"}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox["ecc", "2"], " ", 
                    SuperscriptBox["si", "4"], " ", 
                    RowBox[{"Cos", "[", 
                    RowBox[{"4", " ", "omega"}], "]"}]}]}], ")"}]}], "+", 
                    RowBox[{"192", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", "ecc", " ", 
                    SuperscriptBox["si", "2"], " ", 
                    RowBox[{"Sin", "[", 
                    RowBox[{"2", " ", "omega"}], "]"}]}], "+", 
                    RowBox[{"ecc", " ", 
                    SuperscriptBox["si", "4"], " ", 
                    RowBox[{"Sin", "[", 
                    RowBox[{"2", " ", "omega"}], "]"}]}]}], ")"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "4"}], " ", "ecc", " ", 
                    SuperscriptBox["si", "2"], " ", 
                    RowBox[{"Sin", "[", 
                    RowBox[{"2", " ", "omega"}], "]"}]}], "+", 
                    RowBox[{"2", " ", "ecc", " ", 
                    SuperscriptBox["si", "4"], " ", 
                    RowBox[{"Sin", "[", 
                    RowBox[{"2", " ", "omega"}], "]"}]}], "-", 
                    RowBox[{"ecc", " ", 
                    SuperscriptBox["si", "4"], " ", 
                    RowBox[{"Sin", "[", 
                    RowBox[{"4", " ", "omega"}], "]"}]}]}], ")"}]}]}], ")"}], 
                    "/", 
                    RowBox[{"(", 
                    RowBox[{"48", " ", 
                    SuperscriptBox["2", 
                    RowBox[{"2", "/", "3"}]], " ", 
                    SuperscriptBox["si", "4"], " ", 
                    SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"128", " ", 
                    SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    SuperscriptBox["ecc", "2"]}], "-", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["ecc", "2"], " ", 
                    SuperscriptBox["si", "2"]}], "-", 
                    RowBox[{"8", " ", 
                    SuperscriptBox["si", "4"]}], "+", 
                    RowBox[{
                    SuperscriptBox["ecc", "2"], " ", 
                    SuperscriptBox["si", "4"]}], "-", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["ecc", "2"], " ", 
                    SuperscriptBox["si", "2"], " ", 
                    RowBox[{"Cos", "[", 
                    RowBox[{"2", " ", "omega"}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox["ecc", "2"], " ", 
                    SuperscriptBox["si", "4"], " ", 
                    RowBox[{"Cos", "[", 
                    RowBox[{"2", " ", "omega"}], "]"}]}]}], ")"}], "3"]}], 
                    "-", 
                    RowBox[{"9216", " ", 
                    SuperscriptBox["si", "4"], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    SuperscriptBox["ecc", "2"]}], "-", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["ecc", "2"], " ", 
                    SuperscriptBox["si", "2"]}], "-", 
                    RowBox[{"8", " ", 
                    SuperscriptBox["si", "4"]}], "+", 
                    RowBox[{
                    SuperscriptBox["ecc", "2"], " ", 
                    SuperscriptBox["si", "4"]}], "-", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["ecc", "2"], " ", 
                    SuperscriptBox["si", "2"], " ", 
                    RowBox[{"Cos", "[", 
                    RowBox[{"2", " ", "omega"}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox["ecc", "2"], " ", 
                    SuperscriptBox["si", "4"], " ", 
                    RowBox[{"Cos", "[", 
                    RowBox[{"2", " ", "omega"}], "]"}]}]}], ")"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"4", " ", 
                    SuperscriptBox["si", "4"]}], "-", 
                    RowBox[{
                    SuperscriptBox["ecc", "2"], " ", 
                    SuperscriptBox["si", "4"]}], "-", 
                    RowBox[{"4", " ", 
                    SuperscriptBox["si", "4"], " ", 
                    RowBox[{"Cos", "[", 
                    RowBox[{"4", " ", "omega"}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox["ecc", "2"], " ", 
                    SuperscriptBox["si", "4"], " ", 
                    RowBox[{"Cos", "[", 
                    RowBox[{"4", " ", "omega"}], "]"}]}]}], ")"}]}], "+", 
                    RowBox[{"6912", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"4", " ", 
                    SuperscriptBox["si", "4"]}], "-", 
                    RowBox[{
                    SuperscriptBox["ecc", "2"], " ", 
                    SuperscriptBox["si", "4"]}], "-", 
                    RowBox[{"4", " ", 
                    SuperscriptBox["si", "4"], " ", 
                    RowBox[{"Cos", "[", 
                    RowBox[{"4", " ", "omega"}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox["ecc", "2"], " ", 
                    SuperscriptBox["si", "4"], " ", 
                    RowBox[{"Cos", "[", 
                    RowBox[{"4", " ", "omega"}], "]"}]}]}], ")"}], " ", 
                    SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", "ecc", " ", 
                    SuperscriptBox["si", "2"], " ", 
                    RowBox[{"Sin", "[", 
                    RowBox[{"2", " ", "omega"}], "]"}]}], "+", 
                    RowBox[{"ecc", " ", 
                    SuperscriptBox["si", "4"], " ", 
                    RowBox[{"Sin", "[", 
                    RowBox[{"2", " ", "omega"}], "]"}]}]}], ")"}], "2"]}], 
                    "+", 
                    RowBox[{"2304", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    TemplateBox[{"8"},
                    "OutputSizeLimit`Skeleton"], "+", 
                    TemplateBox[{"1"},
                    "OutputSizeLimit`Skeleton"]}], ")"}], " ", 
                    RowBox[{"(", 
                    TemplateBox[{"1"},
                    "OutputSizeLimit`Skeleton"], ")"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "4"}], " ", "ecc", " ", 
                    SuperscriptBox["si", "2"], " ", 
                    RowBox[{"Sin", "[", 
                    RowBox[{"2", " ", "omega"}], "]"}]}], "+", 
                    RowBox[{"2", " ", "ecc", " ", 
                    SuperscriptBox["si", "4"], " ", 
                    RowBox[{"Sin", "[", 
                    RowBox[{"2", " ", "omega"}], "]"}]}], "-", 
                    RowBox[{"ecc", " ", 
                    SuperscriptBox["si", "4"], " ", 
                    RowBox[{"Sin", "[", 
                    RowBox[{"4", " ", "omega"}], "]"}]}]}], ")"}]}], "+", 
                    RowBox[{"13824", " ", 
                    SuperscriptBox["si", "4"], " ", 
                    SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "4"}], " ", "ecc", " ", 
                    SuperscriptBox["si", "2"], " ", 
                    RowBox[{"Sin", "[", 
                    RowBox[{"2", " ", "omega"}], "]"}]}], "+", 
                    RowBox[{"2", " ", "ecc", " ", 
                    SuperscriptBox["si", "4"], " ", 
                    RowBox[{"Sin", "[", 
                    RowBox[{"2", " ", "omega"}], "]"}]}], "-", 
                    RowBox[{"ecc", " ", 
                    SuperscriptBox["si", "4"], " ", 
                    RowBox[{"Sin", "[", 
                    RowBox[{"4", " ", "omega"}], "]"}]}]}], ")"}], "2"]}], 
                    "+", 
                    RowBox[{"\[Sqrt]", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "4"}], " ", 
                    SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"16", " ", 
                    SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    SuperscriptBox["ecc", "2"]}], "-", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["ecc", "2"], " ", 
                    SuperscriptBox["si", "2"]}], "-", 
                    RowBox[{"8", " ", 
                    SuperscriptBox["si", "4"]}], "+", 
                    RowBox[{
                    SuperscriptBox["ecc", "2"], " ", 
                    SuperscriptBox["si", "4"]}], "-", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["ecc", "2"], " ", 
                    SuperscriptBox["si", "2"], " ", 
                    RowBox[{"Cos", "[", 
                    RowBox[{"2", " ", "omega"}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox["ecc", "2"], " ", 
                    SuperscriptBox["si", "4"], " ", 
                    RowBox[{"Cos", "[", 
                    RowBox[{"2", " ", "omega"}], "]"}]}]}], ")"}], "2"]}], 
                    "+", 
                    RowBox[{"384", " ", 
                    SuperscriptBox["si", "4"], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"4", " ", 
                    SuperscriptBox["si", "4"]}], "-", 
                    RowBox[{
                    SuperscriptBox["ecc", "2"], " ", 
                    SuperscriptBox["si", "4"]}], "-", 
                    RowBox[{"4", " ", 
                    SuperscriptBox["si", "4"], " ", 
                    RowBox[{"Cos", "[", 
                    RowBox[{"4", " ", "omega"}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox["ecc", "2"], " ", 
                    SuperscriptBox["si", "4"], " ", 
                    RowBox[{"Cos", "[", 
                    RowBox[{"4", " ", "omega"}], "]"}]}]}], ")"}]}], "+", 
                    RowBox[{"192", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", "ecc", " ", 
                    SuperscriptBox["si", "2"], " ", 
                    RowBox[{"Sin", "[", 
                    RowBox[{"2", " ", "omega"}], "]"}]}], "+", 
                    RowBox[{"ecc", " ", 
                    SuperscriptBox["si", "4"], " ", 
                    RowBox[{"Sin", "[", 
                    RowBox[{"2", " ", "omega"}], "]"}]}]}], ")"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "4"}], " ", "ecc", " ", 
                    SuperscriptBox["si", "2"], " ", 
                    RowBox[{"Sin", "[", 
                    RowBox[{"2", " ", "omega"}], "]"}]}], "+", 
                    RowBox[{"2", " ", "ecc", " ", 
                    SuperscriptBox["si", "4"], " ", 
                    RowBox[{"Sin", "[", 
                    RowBox[{"2", " ", "omega"}], "]"}]}], "-", 
                    RowBox[{"ecc", " ", 
                    SuperscriptBox["si", "4"], " ", 
                    RowBox[{"Sin", "[", 
                    RowBox[{"4", " ", "omega"}], "]"}]}]}], ")"}]}]}], ")"}], 
                    "3"]}], "+", 
                    SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    TemplateBox[{"5"},
                    "OutputSizeLimit`Skeleton"], "+", 
                    RowBox[{"13824", " ", 
                    SuperscriptBox["si", "4"], " ", 
                    SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "4"}], " ", "ecc", " ", 
                    SuperscriptBox["si", "2"], " ", 
                    RowBox[{"Sin", "[", 
                    RowBox[{"2", " ", "omega"}], "]"}]}], "+", 
                    TemplateBox[{"1"},
                    "OutputSizeLimit`Skeleton"], "-", 
                    RowBox[{"ecc", " ", 
                    SuperscriptBox["si", "4"], " ", 
                    RowBox[{"Sin", "[", 
                    RowBox[{"4", " ", "omega"}], "]"}]}]}], ")"}], "2"]}]}], 
                    ")"}], "2"]}], ")"}]}]}], ")"}], 
                    RowBox[{"1", "/", "3"}]]}], ")"}]}], "+", 
                    RowBox[{
                    FractionBox["1", 
                    RowBox[{"96", " ", 
                    SuperscriptBox["2", 
                    RowBox[{"1", "/", "3"}]], " ", 
                    SuperscriptBox["si", "4"]}]], 
                    SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"128", " ", 
                    SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    SuperscriptBox["ecc", "2"]}], "-", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["ecc", "2"], " ", 
                    SuperscriptBox["si", "2"]}], "-", 
                    RowBox[{"8", " ", 
                    SuperscriptBox["si", "4"]}], "+", 
                    RowBox[{
                    SuperscriptBox["ecc", "2"], " ", 
                    SuperscriptBox["si", "4"]}], "-", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["ecc", "2"], " ", 
                    SuperscriptBox["si", "2"], " ", 
                    RowBox[{"Cos", "[", 
                    RowBox[{"2", " ", "omega"}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox["ecc", "2"], " ", 
                    SuperscriptBox["si", "4"], " ", 
                    RowBox[{"Cos", "[", 
                    RowBox[{"2", " ", "omega"}], "]"}]}]}], ")"}], "3"]}], 
                    "-", 
                    RowBox[{"9216", " ", 
                    SuperscriptBox["si", "4"], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    SuperscriptBox["ecc", "2"]}], "-", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["ecc", "2"], " ", 
                    SuperscriptBox["si", "2"]}], "-", 
                    RowBox[{"8", " ", 
                    SuperscriptBox["si", "4"]}], "+", 
                    RowBox[{
                    SuperscriptBox["ecc", "2"], " ", 
                    SuperscriptBox["si", "4"]}], "-", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["ecc", "2"], " ", 
                    SuperscriptBox["si", "2"], " ", 
                    RowBox[{"Cos", "[", 
                    RowBox[{"2", " ", "omega"}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox["ecc", "2"], " ", 
                    SuperscriptBox["si", "4"], " ", 
                    RowBox[{"Cos", "[", 
                    RowBox[{"2", " ", "omega"}], "]"}]}]}], ")"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"4", " ", 
                    SuperscriptBox["si", "4"]}], "-", 
                    RowBox[{
                    SuperscriptBox["ecc", "2"], " ", 
                    SuperscriptBox["si", "4"]}], "-", 
                    RowBox[{"4", " ", 
                    SuperscriptBox["si", "4"], " ", 
                    RowBox[{"Cos", "[", 
                    RowBox[{"4", " ", "omega"}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox["ecc", "2"], " ", 
                    SuperscriptBox["si", "4"], " ", 
                    RowBox[{"Cos", "[", 
                    RowBox[{"4", " ", "omega"}], "]"}]}]}], ")"}]}], "+", 
                    RowBox[{"6912", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"4", " ", 
                    SuperscriptBox["si", "4"]}], "-", 
                    RowBox[{
                    SuperscriptBox["ecc", "2"], " ", 
                    SuperscriptBox["si", "4"]}], "-", 
                    RowBox[{"4", " ", 
                    SuperscriptBox["si", "4"], " ", 
                    RowBox[{"Cos", "[", 
                    RowBox[{"4", " ", "omega"}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox["ecc", "2"], " ", 
                    SuperscriptBox["si", "4"], " ", 
                    RowBox[{"Cos", "[", 
                    RowBox[{"4", " ", "omega"}], "]"}]}]}], ")"}], " ", 
                    SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", "ecc", " ", 
                    SuperscriptBox["si", "2"], " ", 
                    RowBox[{"Sin", "[", 
                    RowBox[{"2", " ", "omega"}], "]"}]}], "+", 
                    RowBox[{"ecc", " ", 
                    SuperscriptBox["si", "4"], " ", 
                    RowBox[{"Sin", "[", 
                    RowBox[{"2", " ", "omega"}], "]"}]}]}], ")"}], "2"]}], 
                    "+", 
                    RowBox[{"2304", " ", 
                    RowBox[{"(", 
                    TemplateBox[{"1"},
                    "OutputSizeLimit`Skeleton"], ")"}], " ", 
                    TemplateBox[{"1"},
                    "OutputSizeLimit`Skeleton"], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "4"}], " ", "ecc", " ", 
                    SuperscriptBox["si", "2"], " ", 
                    RowBox[{"Sin", "[", 
                    RowBox[{"2", " ", "omega"}], "]"}]}], "+", 
                    RowBox[{"2", " ", "ecc", " ", 
                    SuperscriptBox["si", "4"], " ", 
                    RowBox[{"Sin", "[", 
                    RowBox[{"2", " ", "omega"}], "]"}]}], "-", 
                    RowBox[{"ecc", " ", 
                    SuperscriptBox["si", "4"], " ", 
                    RowBox[{"Sin", "[", 
                    RowBox[{"4", " ", "omega"}], "]"}]}]}], ")"}]}], "+", 
                    RowBox[{"13824", " ", 
                    SuperscriptBox["si", "4"], " ", 
                    SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "4"}], " ", "ecc", " ", 
                    SuperscriptBox["si", "2"], " ", 
                    RowBox[{"Sin", "[", 
                    RowBox[{"2", " ", "omega"}], "]"}]}], "+", 
                    RowBox[{"2", " ", "ecc", " ", 
                    SuperscriptBox["si", "4"], " ", 
                    RowBox[{"Sin", "[", 
                    RowBox[{"2", " ", "omega"}], "]"}]}], "-", 
                    RowBox[{"ecc", " ", 
                    SuperscriptBox["si", "4"], " ", 
                    RowBox[{"Sin", "[", 
                    RowBox[{"4", " ", "omega"}], "]"}]}]}], ")"}], "2"]}], 
                    "+", 
                    RowBox[{"\[Sqrt]", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "4"}], " ", 
                    SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"16", " ", 
                    SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    SuperscriptBox["ecc", "2"]}], "-", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["ecc", "2"], " ", 
                    SuperscriptBox["si", "2"]}], "-", 
                    RowBox[{"8", " ", 
                    SuperscriptBox["si", "4"]}], "+", 
                    RowBox[{
                    SuperscriptBox["ecc", "2"], " ", 
                    SuperscriptBox["si", "4"]}], "-", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["ecc", "2"], " ", 
                    SuperscriptBox["si", "2"], " ", 
                    RowBox[{"Cos", "[", 
                    RowBox[{"2", " ", "omega"}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox["ecc", "2"], " ", 
                    SuperscriptBox["si", "4"], " ", 
                    RowBox[{"Cos", "[", 
                    RowBox[{"2", " ", "omega"}], "]"}]}]}], ")"}], "2"]}], 
                    "+", 
                    RowBox[{"384", " ", 
                    SuperscriptBox["si", "4"], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"4", " ", 
                    SuperscriptBox["si", "4"]}], "-", 
                    RowBox[{
                    SuperscriptBox["ecc", "2"], " ", 
                    SuperscriptBox["si", "4"]}], "-", 
                    RowBox[{"4", " ", 
                    SuperscriptBox["si", "4"], " ", 
                    RowBox[{"Cos", "[", 
                    RowBox[{"4", " ", "omega"}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox["ecc", "2"], " ", 
                    SuperscriptBox["si", "4"], " ", 
                    RowBox[{"Cos", "[", 
                    RowBox[{"4", " ", "omega"}], "]"}]}]}], ")"}]}], "+", 
                    RowBox[{"192", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", "ecc", " ", 
                    SuperscriptBox["si", "2"], " ", 
                    RowBox[{"Sin", "[", 
                    RowBox[{"2", " ", "omega"}], "]"}]}], "+", 
                    RowBox[{"ecc", " ", 
                    SuperscriptBox["si", "4"], " ", 
                    RowBox[{"Sin", "[", 
                    RowBox[{"2", " ", "omega"}], "]"}]}]}], ")"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "4"}], " ", "ecc", " ", 
                    SuperscriptBox["si", "2"], " ", 
                    RowBox[{"Sin", "[", 
                    RowBox[{"2", " ", "omega"}], "]"}]}], "+", 
                    RowBox[{"2", " ", "ecc", " ", 
                    SuperscriptBox["si", "4"], " ", 
                    RowBox[{"Sin", "[", 
                    RowBox[{"2", " ", "omega"}], "]"}]}], "-", 
                    RowBox[{"ecc", " ", 
                    SuperscriptBox["si", "4"], " ", 
                    RowBox[{"Sin", "[", 
                    RowBox[{"4", " ", "omega"}], "]"}]}]}], ")"}]}]}], ")"}], 
                    "3"]}], "+", 
                    SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"128", " ", 
                    SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    SuperscriptBox["ecc", "2"]}], "-", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["ecc", "2"], " ", 
                    SuperscriptBox["si", "2"]}], "-", 
                    RowBox[{"8", " ", 
                    SuperscriptBox["si", "4"]}], "+", 
                    RowBox[{
                    SuperscriptBox["ecc", "2"], " ", 
                    SuperscriptBox["si", "4"]}], "-", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["ecc", "2"], " ", 
                    SuperscriptBox["si", "2"], " ", 
                    RowBox[{"Cos", "[", 
                    RowBox[{"2", " ", "omega"}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox["ecc", "2"], " ", 
                    SuperscriptBox["si", "4"], " ", 
                    RowBox[{"Cos", "[", 
                    RowBox[{"2", " ", "omega"}], "]"}]}]}], ")"}], "3"]}], 
                    "-", 
                    RowBox[{"9216", " ", 
                    SuperscriptBox["si", "4"], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    SuperscriptBox["ecc", "2"]}], "-", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["ecc", "2"], " ", 
                    SuperscriptBox["si", "2"]}], "-", 
                    RowBox[{"8", " ", 
                    SuperscriptBox["si", "4"]}], "+", 
                    RowBox[{
                    SuperscriptBox["ecc", "2"], " ", 
                    SuperscriptBox["si", "4"]}], "-", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["ecc", "2"], " ", 
                    SuperscriptBox["si", "2"], " ", 
                    RowBox[{"Cos", "[", 
                    RowBox[{"2", " ", "omega"}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox["ecc", "2"], " ", 
                    SuperscriptBox["si", "4"], " ", 
                    RowBox[{"Cos", "[", 
                    RowBox[{"2", " ", "omega"}], "]"}]}]}], ")"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"4", " ", 
                    SuperscriptBox["si", "4"]}], "-", 
                    RowBox[{
                    SuperscriptBox["ecc", "2"], " ", 
                    SuperscriptBox["si", "4"]}], "-", 
                    RowBox[{"4", " ", 
                    SuperscriptBox["si", "4"], " ", 
                    RowBox[{"Cos", "[", 
                    RowBox[{"4", " ", "omega"}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox["ecc", "2"], " ", 
                    SuperscriptBox["si", "4"], " ", 
                    RowBox[{"Cos", "[", 
                    RowBox[{"4", " ", "omega"}], "]"}]}]}], ")"}]}], "+", 
                    TemplateBox[{"1"},
                    "OutputSizeLimit`Skeleton"], "+", 
                    RowBox[{"2304", " ", 
                    RowBox[{"(", 
                    TemplateBox[{"1"},
                    "OutputSizeLimit`Skeleton"], ")"}], " ", 
                    TemplateBox[{"1"},
                    "OutputSizeLimit`Skeleton"], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "4"}], " ", "ecc", " ", 
                    SuperscriptBox["si", "2"], " ", 
                    RowBox[{"Sin", "[", 
                    RowBox[{"2", " ", "omega"}], "]"}]}], "+", 
                    RowBox[{"2", " ", "ecc", " ", 
                    SuperscriptBox["si", "4"], " ", 
                    RowBox[{"Sin", "[", 
                    RowBox[{"2", " ", "omega"}], "]"}]}], "-", 
                    RowBox[{"ecc", " ", 
                    SuperscriptBox["si", "4"], " ", 
                    RowBox[{"Sin", "[", 
                    RowBox[{"4", " ", "omega"}], "]"}]}]}], ")"}]}], "+", 
                    RowBox[{"13824", " ", 
                    SuperscriptBox["si", "4"], " ", 
                    SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "4"}], " ", "ecc", " ", 
                    SuperscriptBox["si", "2"], " ", 
                    RowBox[{"Sin", "[", 
                    RowBox[{"2", " ", "omega"}], "]"}]}], "+", 
                    RowBox[{"2", " ", "ecc", " ", 
                    SuperscriptBox["si", "4"], " ", 
                    RowBox[{"Sin", "[", 
                    RowBox[{"2", " ", "omega"}], "]"}]}], "-", 
                    RowBox[{"ecc", " ", 
                    SuperscriptBox["si", "4"], " ", 
                    RowBox[{"Sin", "[", 
                    RowBox[{"4", " ", "omega"}], "]"}]}]}], ")"}], "2"]}]}], 
                    ")"}], "2"]}], ")"}]}]}], ")"}], 
                    RowBox[{"1", "/", "3"}]]}]}], ")"}]}]}], ")"}]}]}], 
                 ")"}]}]}]}]}], "}"}]}], "}"}],
         Short[#, 320]& ],
        BaseStyle->{Deployed -> False},
        StripOnInput->False]},
      {GridBox[{
         {
          TagBox[
           TooltipBox[
            StyleBox[
             StyleBox[
              DynamicBox[ToBoxes[
                FEPrivate`FrontEndResource[
                "FEStrings", "sizeBriefExplanation"], StandardForm],
               ImageSizeCache->{58., {2., 8.}}],
              StripOnInput->False,
              DynamicUpdating->True], "OSLText",
             StripOnInput->False],
            StyleBox[
             DynamicBox[
              ToBoxes[
               FEPrivate`FrontEndResource["FEStrings", "sizeExplanation"], 
               StandardForm]], DynamicUpdating -> True, StripOnInput -> 
             False]],
           Annotation[#, 
            Style[
             Dynamic[
              FEPrivate`FrontEndResource["FEStrings", "sizeExplanation"]], 
             DynamicUpdating -> True], "Tooltip"]& ], 
          ButtonBox[
           PaneSelectorBox[{False->
            StyleBox[
             StyleBox[
              DynamicBox[ToBoxes[
                FEPrivate`FrontEndResource["FEStrings", "sizeShowLess"], 
                StandardForm],
               ImageSizeCache->{50., {0., 8.}}],
              StripOnInput->False,
              DynamicUpdating->True], "OSLControl",
             StripOnInput->False], True->
            StyleBox[
             StyleBox[
              DynamicBox[ToBoxes[
                FEPrivate`FrontEndResource["FEStrings", "sizeShowLess"], 
                StandardForm]],
              StripOnInput->False,
              DynamicUpdating->True], "OSLControlActive",
             StripOnInput->False]}, Dynamic[
             CurrentValue["MouseOver"]],
            Alignment->Center,
            FrameMargins->0,
            ImageSize->{Automatic, 25}],
           Appearance->None,
           BaselinePosition->Baseline,
           
           ButtonFunction:>OutputSizeLimit`ButtonFunction[
            OutputSizeLimit`Defer, 29, 25571763906033481186, 320/2],
           Enabled->True,
           Evaluator->Automatic,
           Method->"Queued"], 
          ButtonBox[
           PaneSelectorBox[{False->
            StyleBox[
             StyleBox[
              DynamicBox[ToBoxes[
                FEPrivate`FrontEndResource["FEStrings", "sizeShowMore"], 
                StandardForm],
               ImageSizeCache->{56., {0., 8.}}],
              StripOnInput->False,
              DynamicUpdating->True], "OSLControl",
             StripOnInput->False], True->
            StyleBox[
             StyleBox[
              DynamicBox[ToBoxes[
                FEPrivate`FrontEndResource["FEStrings", "sizeShowMore"], 
                StandardForm]],
              StripOnInput->False,
              DynamicUpdating->True], "OSLControlActive",
             StripOnInput->False]}, Dynamic[
             CurrentValue["MouseOver"]],
            Alignment->Center,
            FrameMargins->0,
            ImageSize->{Automatic, 25}],
           Appearance->None,
           BaselinePosition->Baseline,
           
           ButtonFunction:>OutputSizeLimit`ButtonFunction[
            OutputSizeLimit`Defer, 29, 25571763906033481186, 320 2],
           Enabled->True,
           Evaluator->Automatic,
           Method->"Queued"], 
          ButtonBox[
           PaneSelectorBox[{False->
            StyleBox[
             StyleBox[
              DynamicBox[ToBoxes[
                FEPrivate`FrontEndResource["FEStrings", "sizeShowAll"], 
                StandardForm],
               ImageSizeCache->{42., {0., 8.}}],
              StripOnInput->False,
              DynamicUpdating->True], "OSLControl",
             StripOnInput->False], True->
            StyleBox[
             StyleBox[
              DynamicBox[ToBoxes[
                FEPrivate`FrontEndResource["FEStrings", "sizeShowAll"], 
                StandardForm]],
              StripOnInput->False,
              DynamicUpdating->True], "OSLControlActive",
             StripOnInput->False]}, Dynamic[
             CurrentValue["MouseOver"]],
            Alignment->Center,
            FrameMargins->0,
            ImageSize->{Automatic, 25}],
           Appearance->None,
           BaselinePosition->Baseline,
           
           ButtonFunction:>OutputSizeLimit`ButtonFunction[
            OutputSizeLimit`Defer, 29, 25571763906033481186, Infinity],
           Enabled->True,
           Evaluator->Automatic,
           Method->"Queued"], 
          ButtonBox[
           PaneSelectorBox[{False->
            StyleBox[
             StyleBox[
              DynamicBox[ToBoxes[
                FEPrivate`FrontEndResource["FEStrings", "sizeChangeLimit"], 
                StandardForm],
               ImageSizeCache->{74., {0., 8.}}],
              StripOnInput->False,
              DynamicUpdating->True], "OSLControl",
             StripOnInput->False], True->
            StyleBox[
             StyleBox[
              DynamicBox[ToBoxes[
                FEPrivate`FrontEndResource["FEStrings", "sizeChangeLimit"], 
                StandardForm]],
              StripOnInput->False,
              DynamicUpdating->True], "OSLControlActive",
             StripOnInput->False]}, Dynamic[
             CurrentValue["MouseOver"]],
            Alignment->Center,
            FrameMargins->0,
            ImageSize->{Automatic, 25}],
           Appearance->None,
           BaselinePosition->Baseline,
           ButtonFunction:>FrontEndExecute[{
              FrontEnd`SetOptions[
              FrontEnd`$FrontEnd, 
               FrontEnd`PreferencesSettings -> {"Page" -> "Advanced"}], 
              FrontEnd`FrontEndToken["PreferencesDialog"]}],
           Evaluator->None,
           Method->"Preemptive"]}
        },
        AutoDelete->False,
        FrameStyle->GrayLevel[0.85],
        GridBoxDividers->{"Columns" -> {False, {True}}},
        GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
        GridBoxSpacings->{"Columns" -> {{2}}}]}
     },
     DefaultBaseStyle->"Column",
     GridBoxAlignment->{
      "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
       "RowsIndexed" -> {}},
     GridBoxDividers->{
      "Columns" -> {{False}}, "ColumnsIndexed" -> {}, "Rows" -> {{False}}, 
       "RowsIndexed" -> {}},
     GridBoxItemSize->{
      "Columns" -> {{Automatic}}, "ColumnsIndexed" -> {}, "Rows" -> {{1.}}, 
       "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.5599999999999999]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], 
         Offset[1.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    BaseStyle->"OutputSizeLimit",
    FrameMargins->{{12, 12}, {0, 15}},
    FrameStyle->GrayLevel[0.85],
    RoundingRadius->5,
    StripOnInput->False],
   Deploy,
   DefaultBaseStyle->"Deploy"],
  If[25571763906033481186 === $SessionID, 
   Out[29], Message[
     MessageName[Syntax, "noinfoker"]]; Missing["NotAvailable"]; 
   Null]]], "Output",
 CellChangeTimes->{3.754074341503036*^9},
 CellLabel->"Out[29]=",ExpressionUUID->"4fbb9524-7121-47fb-8a20-66e9791ecfbc"]
}, Open  ]]
},
WindowSize->{808, 751},
WindowMargins->{{12, Automatic}, {Automatic, 24}},
FrontEndVersion->"11.3 for Mac OS X x86 (32-bit, 64-bit Kernel) (March 5, \
2018)",
StyleDefinitions->"Default.nb"
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[CellGroupData[{
Cell[580, 22, 316, 7, 30, "Input",ExpressionUUID->"8ae2cdd8-4057-4693-a49d-3635cd58677f"],
Cell[899, 31, 862, 23, 56, "Output",ExpressionUUID->"5bdeea1d-fcc4-40d1-b164-a9191765ff63"]
}, Open  ]],
Cell[CellGroupData[{
Cell[1798, 59, 211, 3, 30, "Input",ExpressionUUID->"858cee10-8696-4b18-88a7-de60ffab86ae"],
Cell[2012, 64, 253, 6, 34, "Output",ExpressionUUID->"42356495-a8f5-4eb3-97b4-2b51217460c1"]
}, Open  ]],
Cell[CellGroupData[{
Cell[2302, 75, 290, 6, 30, "Input",ExpressionUUID->"cb0e16bb-3800-4489-ad21-7fdfdeacb54e"],
Cell[2595, 83, 1108, 33, 88, "Output",ExpressionUUID->"c92ff2f3-1997-40bb-b85e-83380d3a55cc"]
}, Open  ]],
Cell[CellGroupData[{
Cell[3740, 121, 790, 23, 52, "Input",ExpressionUUID->"c96a54e4-94b9-44b2-a517-e5829bf4f4bd"],
Cell[4533, 146, 3389, 96, 278, "Output",ExpressionUUID->"732eafa2-a62b-416f-9606-b665f3fc0f64"]
}, Open  ]],
Cell[CellGroupData[{
Cell[7959, 247, 209, 3, 30, "Input",ExpressionUUID->"6d625a42-2375-4558-bd2a-4b1760af137f"],
Cell[8171, 252, 1086, 34, 74, "Output",ExpressionUUID->"26518906-3ac9-4fac-b262-f5e9549d2623"]
}, Open  ]],
Cell[CellGroupData[{
Cell[9294, 291, 295, 7, 30, "Input",ExpressionUUID->"4e9cf2de-7959-4c16-8388-e143811a708b"],
Cell[9592, 300, 444, 11, 42, "Message",ExpressionUUID->"580cb522-d086-420c-b40c-5837b407bbd2"]
}, Open  ]],
Cell[CellGroupData[{
Cell[10073, 316, 475, 12, 30, "Input",ExpressionUUID->"ed1d97ab-8ff5-4b1e-b29e-b9a2f8e26759"],
Cell[10551, 330, 399, 11, 34, "Output",ExpressionUUID->"89e506fa-160c-4379-8f7b-ca832aa6d63c"]
}, Open  ]],
Cell[CellGroupData[{
Cell[10987, 346, 210, 3, 30, "Input",ExpressionUUID->"71520c40-265f-470c-97a5-7b592c512abe"],
Cell[11200, 351, 182, 3, 34, "Output",ExpressionUUID->"a19302c7-5c04-4c50-ad0a-6371c24cdb8e"]
}, Open  ]],
Cell[CellGroupData[{
Cell[11419, 359, 586, 16, 30, "Input",ExpressionUUID->"c26e6c5b-0f55-4498-8c87-6cc7a87df398"],
Cell[12008, 377, 565, 16, 34, "Output",ExpressionUUID->"6918e325-c637-43c4-94f1-a6c4a7ba032a"]
}, Open  ]],
Cell[CellGroupData[{
Cell[12610, 398, 210, 3, 30, "Input",ExpressionUUID->"7694460f-2875-4f33-96f6-65e734783c54"],
Cell[12823, 403, 1811, 50, 130, "Output",ExpressionUUID->"6327c6f6-9284-40bc-95da-5d6fa0dbb5aa"]
}, Open  ]],
Cell[CellGroupData[{
Cell[14671, 458, 211, 3, 30, "Input",ExpressionUUID->"2fd3094e-8af6-41cd-9196-944770fda4a6"],
Cell[14885, 463, 791, 25, 50, "Output",ExpressionUUID->"fff26b0f-92ac-4a0a-8e24-9ad8447697db"]
}, Open  ]],
Cell[CellGroupData[{
Cell[15713, 493, 235, 4, 30, "Input",ExpressionUUID->"21c9fa8a-8eec-40f1-b6de-6c02a5d93351"],
Cell[15951, 499, 1889, 50, 116, "Output",ExpressionUUID->"4d4e5d99-d443-4da1-ad3b-eb04d2a77c59"]
}, Open  ]],
Cell[17855, 552, 152, 3, 30, "Input",ExpressionUUID->"5e381d28-09fb-4071-ad9c-b19f4a12e2c4"],
Cell[CellGroupData[{
Cell[18032, 559, 2079, 55, 127, "Input",ExpressionUUID->"53638e90-c684-472c-a14e-4b9eee852044"],
Cell[20114, 616, 663, 18, 34, "Output",ExpressionUUID->"18ec782a-9f5e-4296-a5a1-87fd74777e59"]
}, Open  ]],
Cell[CellGroupData[{
Cell[20814, 639, 1818, 51, 128, "Input",ExpressionUUID->"8791fc7e-c9fe-4ed1-8034-763ad7e30d9a"],
Cell[22635, 692, 1862, 52, 132, "Output",ExpressionUUID->"d9674857-d47a-42ad-9445-c6640e862706"]
}, Open  ]],
Cell[CellGroupData[{
Cell[24534, 749, 206, 3, 30, "Input",ExpressionUUID->"aa4bd010-9c62-41b2-bd82-d0ab5e8a46a1"],
Cell[24743, 754, 793, 25, 50, "Output",ExpressionUUID->"a556cdf4-b028-4e44-8fc5-eeb44d4846a1"]
}, Open  ]],
Cell[CellGroupData[{
Cell[25573, 784, 2202, 62, 151, "Input",ExpressionUUID->"a05cd943-204a-401d-a160-f84f69ed3f48"],
Cell[27778, 848, 2201, 63, 135, "Output",ExpressionUUID->"ff29c719-8f57-4c6d-b7ea-c51d8bb216e1"]
}, Open  ]],
Cell[CellGroupData[{
Cell[30016, 916, 210, 3, 30, "Input",ExpressionUUID->"bc87635f-e0ee-4858-8281-dad81888b670"],
Cell[30229, 921, 1370, 41, 75, "Output",ExpressionUUID->"9a425acf-f08a-485b-93af-3dfb78b51431"]
}, Open  ]],
Cell[CellGroupData[{
Cell[31636, 967, 2492, 68, 186, "Input",ExpressionUUID->"f4f81b61-0b53-4ae5-ad01-9ce4cc901cb9"],
Cell[34131, 1037, 7121, 180, 232, "Output",ExpressionUUID->"04542604-12f3-434e-bdec-48a10954a488"]
}, Open  ]],
Cell[CellGroupData[{
Cell[41289, 1222, 5258, 139, 260, "Input",ExpressionUUID->"d52e8a6a-bef1-4248-9b8e-9efa77596a74"],
Cell[46550, 1363, 10998, 285, 211, "Output",ExpressionUUID->"47a64db1-4f12-4628-a3b3-714e4540e0c8"]
}, Open  ]],
Cell[CellGroupData[{
Cell[57585, 1653, 4928, 136, 237, "Input",ExpressionUUID->"88426e44-8dea-4e0e-bf8b-a2b71c6aad37"],
Cell[62516, 1791, 2239, 68, 98, "Output",ExpressionUUID->"7c407a4b-d95f-4973-8724-e5c1b0a8045c"]
}, Open  ]],
Cell[CellGroupData[{
Cell[64792, 1864, 309, 7, 30, "Input",ExpressionUUID->"54a9678c-5d93-4227-bbea-8162abf29706"],
Cell[65104, 1873, 275173, 6051, 9754, "Output",ExpressionUUID->"4fbb9524-7121-47fb-8a20-66e9791ecfbc"]
}, Open  ]]
}
]
*)

(* End of internal cache information *)

