(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 11.3' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       158,          7]
NotebookDataLength[    475095,      14261]
NotebookOptionsPosition[    412075,      13161]
NotebookOutlinePosition[    412432,      13177]
CellTagsIndexPosition[    412389,      13174]
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{
   "Deriving", " ", "recursion", " ", "relation", " ", "for", " ", "P", 
    RowBox[{"(", "G_n", ")"}]}], " ", "*)"}], 
  "\[IndentingNewLine]"}]], "Input",
 CellChangeTimes->{{3.750807324707922*^9, 
  3.750807338261128*^9}},ExpressionUUID->"d1915c0b-e743-47c9-9a43-\
051a9d6fa3e1"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Integrate", "[", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{"(", 
      RowBox[{"k2", "-", 
       RowBox[{
        RowBox[{"Sin", "[", "xi", "]"}], "^", "2"}]}], ")"}], "^", "m"}], "*", 
    RowBox[{"Cos", "[", "xi", "]"}]}], ",", "xi"}], "]"}]], "Input",
 CellChangeTimes->{{3.7508085574187527`*^9, 3.7508085751815577`*^9}, {
  3.7508087584067574`*^9, 3.7508087585499687`*^9}},
 CellLabel->"In[2]:=",ExpressionUUID->"1fc71b10-1d01-4ade-ace5-878ff80703be"],

Cell[BoxData[
 RowBox[{
  RowBox[{"Hypergeometric2F1", "[", 
   RowBox[{
    FractionBox["1", "2"], ",", 
    RowBox[{"-", "m"}], ",", 
    FractionBox["3", "2"], ",", 
    FractionBox[
     SuperscriptBox[
      RowBox[{"Sin", "[", "xi", "]"}], "2"], "k2"]}], "]"}], " ", 
  RowBox[{"Sin", "[", "xi", "]"}], " ", 
  SuperscriptBox[
   RowBox[{"(", 
    RowBox[{"k2", "-", 
     SuperscriptBox[
      RowBox[{"Sin", "[", "xi", "]"}], "2"]}], ")"}], "m"], " ", 
  SuperscriptBox[
   RowBox[{"(", 
    RowBox[{"1", "-", 
     FractionBox[
      SuperscriptBox[
       RowBox[{"Sin", "[", "xi", "]"}], "2"], "k2"]}], ")"}], 
   RowBox[{"-", "m"}]]}]], "Output",
 CellChangeTimes->{3.7508087597987022`*^9},
 CellLabel->"Out[2]=",ExpressionUUID->"96de66ee-f051-4804-b168-020f85f8add1"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"D", "[", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{"(", 
      RowBox[{"kk2", "-", 
       RowBox[{
        RowBox[{"Sin", "[", "xi", "]"}], "^", "2"}]}], ")"}], "^", 
     RowBox[{"(", 
      RowBox[{"mm", "-", "1"}], ")"}]}], "*", 
    RowBox[{"Cos", "[", "xi", "]"}]}], ",", "xi"}], "]"}]], "Input",
 CellChangeTimes->{{3.7508088293220997`*^9, 3.750808836302021*^9}, {
  3.7508175372281303`*^9, 3.750817571657689*^9}},
 CellLabel->"In[20]:=",ExpressionUUID->"3786b93c-700d-4c93-9bdc-5edb9d356652"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"-", "2"}], " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"-", "1"}], "+", "mm"}], ")"}], " ", 
   SuperscriptBox[
    RowBox[{"Cos", "[", "xi", "]"}], "2"], " ", 
   RowBox[{"Sin", "[", "xi", "]"}], " ", 
   SuperscriptBox[
    RowBox[{"(", 
     RowBox[{"kk2", "-", 
      SuperscriptBox[
       RowBox[{"Sin", "[", "xi", "]"}], "2"]}], ")"}], 
    RowBox[{
     RowBox[{"-", "2"}], "+", "mm"}]]}], "-", 
  RowBox[{
   RowBox[{"Sin", "[", "xi", "]"}], " ", 
   SuperscriptBox[
    RowBox[{"(", 
     RowBox[{"kk2", "-", 
      SuperscriptBox[
       RowBox[{"Sin", "[", "xi", "]"}], "2"]}], ")"}], 
    RowBox[{
     RowBox[{"-", "1"}], "+", "mm"}]]}]}]], "Output",
 CellChangeTimes->{
  3.7508088369248943`*^9, {3.750817540270321*^9, 3.7508175728919067`*^9}},
 CellLabel->"Out[20]=",ExpressionUUID->"ed67e68d-2d62-4f26-88a7-78e79f634fa5"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"FullSimplify", "[", "%", "]"}]], "Input",
 CellChangeTimes->{{3.7508088424366093`*^9, 3.750808844463471*^9}},
 CellLabel->"In[21]:=",ExpressionUUID->"10ad81dd-7a81-4940-87de-e3ead31f11e3"],

Cell[BoxData[
 RowBox[{
  RowBox[{"Sin", "[", "xi", "]"}], " ", 
  SuperscriptBox[
   RowBox[{"(", 
    RowBox[{"kk2", "-", 
     SuperscriptBox[
      RowBox[{"Sin", "[", "xi", "]"}], "2"]}], ")"}], 
   RowBox[{
    RowBox[{"-", "2"}], "+", "mm"}]], " ", 
  RowBox[{"(", 
   RowBox[{
    RowBox[{"-", "kk2"}], "-", 
    RowBox[{"2", " ", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"-", "1"}], "+", "mm"}], ")"}], " ", 
     SuperscriptBox[
      RowBox[{"Cos", "[", "xi", "]"}], "2"]}], "+", 
    SuperscriptBox[
     RowBox[{"Sin", "[", "xi", "]"}], "2"]}], ")"}]}]], "Output",
 CellChangeTimes->{
  3.750808845102058*^9, {3.750817541751327*^9, 3.750817575065548*^9}},
 CellLabel->"Out[21]=",ExpressionUUID->"f825b9e4-f8bc-4ae4-b120-a9cef49db201"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{"Now", ",", " ", 
    RowBox[{"try", " ", "out", " ", "the", " ", 
     RowBox[{"formula", ":"}]}]}], " ", "*)"}], "\[IndentingNewLine]", 
  RowBox[{"m", " ", "=", " ", "10"}]}]], "Input",
 CellChangeTimes->{{3.750816991557641*^9, 3.750817002379767*^9}},
 CellLabel->"In[5]:=",ExpressionUUID->"35cb7f13-4954-4fb6-a06a-aab6f2effe87"],

Cell[BoxData["10"], "Output",
 CellChangeTimes->{3.75081700329907*^9},
 CellLabel->"Out[5]=",ExpressionUUID->"98fbbcd3-b65d-427a-b71f-29701d0249d5"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"b", " ", "=", "0.001"}]], "Input",
 CellChangeTimes->{{3.75081700758538*^9, 3.75081703739904*^9}, {
  3.7508575694543953`*^9, 3.750857582448217*^9}, {3.750857676681734*^9, 
  3.750857678791993*^9}, {3.750857744276793*^9, 3.750857835438113*^9}, {
  3.750859442693378*^9, 3.750859484370976*^9}, {3.7508595802871304`*^9, 
  3.750859581854113*^9}, {3.750859623009747*^9, 3.750859644959361*^9}, {
  3.750859688630889*^9, 3.750859701173374*^9}},
 CellLabel->"In[87]:=",ExpressionUUID->"1ed833f4-47df-431b-872d-7f339e342d78"],

Cell[BoxData["0.001`"], "Output",
 CellChangeTimes->{{3.7508170159042788`*^9, 3.750817038751794*^9}, 
   3.750857408128681*^9, {3.75085757073381*^9, 3.7508575829695263`*^9}, 
   3.750857679396658*^9, {3.750857745188602*^9, 3.750857836300338*^9}, {
   3.750859448904817*^9, 3.750859506546439*^9}, 3.750859582222397*^9, {
   3.7508596252605658`*^9, 3.750859645748307*^9}, {3.750859690786784*^9, 
   3.7508597019717197`*^9}},
 CellLabel->"Out[87]=",ExpressionUUID->"d3561606-b515-4fdb-aa08-3c861db08803"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"r", "=", "0.1"}]], "Input",
 CellChangeTimes->{{3.75081701647985*^9, 3.7508170171713963`*^9}, {
  3.750859445420375*^9, 3.750859446363349*^9}, {3.750859619497239*^9, 
  3.750859621528172*^9}},
 CellLabel->"In[76]:=",ExpressionUUID->"cbc94491-6dd2-487a-9828-332f3c3542ac"],

Cell[BoxData["0.1`"], "Output",
 CellChangeTimes->{
  3.750817017500936*^9, 3.750857411281637*^9, 3.7508594506388197`*^9, 
   3.7508595084608707`*^9, {3.750859626627879*^9, 3.7508596480972843`*^9}},
 CellLabel->"Out[76]=",ExpressionUUID->"4a4d6177-c5da-4f83-aaa9-a655a1e5375d"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"k2", " ", "=", " ", 
  RowBox[{
   RowBox[{"(", 
    RowBox[{"1", "-", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{"r", "-", "b"}], ")"}], "^", "2"}]}], ")"}], "/", 
   RowBox[{"(", 
    RowBox[{"4", "*", "b", "*", "r"}], ")"}]}]}]], "Input",
 CellChangeTimes->{{3.75081701873102*^9, 3.750817024139739*^9}},
 CellLabel->"In[88]:=",ExpressionUUID->"90540e09-6eb1-4651-8ad3-00da2c4f5e0a"],

Cell[BoxData["2475.4975`"], "Output",
 CellChangeTimes->{{3.750817024451536*^9, 3.750817041368531*^9}, 
   3.75085741279706*^9, {3.750857572747294*^9, 3.75085758448643*^9}, 
   3.7508576811476393`*^9, {3.750857747320078*^9, 3.750857838431732*^9}, {
   3.75085945243646*^9, 3.7508595102809563`*^9}, 3.750859584239406*^9, {
   3.750859628209944*^9, 3.750859649729377*^9}, {3.7508596923882113`*^9, 
   3.7508597035184927`*^9}},
 CellLabel->"Out[88]=",ExpressionUUID->"eb3f69a5-625a-41e0-b939-2b6e35271ca1"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"M10", " ", "=", " ", 
  RowBox[{
   RowBox[{
    RowBox[{"(", 
     RowBox[{"4", "*", "b", "*", "r"}], ")"}], "^", "10"}], "*", 
   RowBox[{"Integrate", "[", 
    RowBox[{
     RowBox[{
      RowBox[{"(", 
       RowBox[{"k2", "-", 
        RowBox[{
         RowBox[{"Sin", "[", "xi", "]"}], "^", "2"}]}], ")"}], "^", "10"}], 
     ",", 
     RowBox[{"{", 
      RowBox[{"xi", ",", 
       RowBox[{"-", 
        RowBox[{"ArcSin", "[", 
         RowBox[{"Sqrt", "[", "k2", "]"}], "]"}]}], ",", 
       RowBox[{"ArcSin", "[", 
        RowBox[{"Sqrt", "[", "k2", "]"}], "]"}]}], "}"}]}], 
    "]"}]}]}]], "Input",
 CellChangeTimes->{{3.750817060235011*^9, 3.750817120079365*^9}},
 CellLabel->"In[11]:=",ExpressionUUID->"78af165f-db6a-45d7-abb4-ba8ce6f95741"],

Cell[BoxData["1.2721189872036481`*^-6"], "Output",
 CellChangeTimes->{3.75081712420185*^9},
 CellLabel->"Out[11]=",ExpressionUUID->"d457ab3d-ab99-415c-8f26-28bfd9ab2629"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"M9", " ", "=", " ", 
  RowBox[{
   RowBox[{
    RowBox[{"(", 
     RowBox[{"4", "*", "b", "*", "r"}], ")"}], "^", "9"}], "*", 
   RowBox[{"NIntegrate", "[", 
    RowBox[{
     RowBox[{
      RowBox[{"(", 
       RowBox[{"k2", "-", 
        RowBox[{
         RowBox[{"Sin", "[", "xi", "]"}], "^", "2"}]}], ")"}], "^", "9"}], 
     ",", 
     RowBox[{"{", 
      RowBox[{"xi", ",", 
       RowBox[{"-", 
        RowBox[{"ArcSin", "[", 
         RowBox[{"Sqrt", "[", "k2", "]"}], "]"}]}], ",", 
       RowBox[{"ArcSin", "[", 
        RowBox[{"Sqrt", "[", "k2", "]"}], "]"}]}], "}"}]}], 
    "]"}]}]}]], "Input",
 CellChangeTimes->{{3.75081713126772*^9, 3.750817158571068*^9}},
 CellLabel->"In[12]:=",ExpressionUUID->"bd8706e8-2f3c-4f16-9f3b-02d96d5e4d20"],

Cell[BoxData["4.821721763832447`*^-6"], "Output",
 CellChangeTimes->{3.750817159213633*^9},
 CellLabel->"Out[12]=",ExpressionUUID->"c34d23c7-399c-4737-a514-f42e5ff3cfe6"]
}, Open  ]],

Cell[BoxData[""], "Input",
 CellChangeTimes->{{3.750818813362253*^9, 
  3.7508188176931*^9}},ExpressionUUID->"bfde2906-6aa3-46c9-ab67-b9a0675f9dc3"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"M8", " ", "=", " ", 
  RowBox[{
   RowBox[{
    RowBox[{"(", 
     RowBox[{"4", "*", "b", "*", "r"}], ")"}], "^", "8"}], "*", 
   RowBox[{"NIntegrate", "[", 
    RowBox[{
     RowBox[{
      RowBox[{"(", 
       RowBox[{"k2", "-", 
        RowBox[{
         RowBox[{"Sin", "[", "xi", "]"}], "^", "2"}]}], ")"}], "^", "8"}], 
     ",", 
     RowBox[{"{", 
      RowBox[{"xi", ",", 
       RowBox[{"-", 
        RowBox[{"ArcSin", "[", 
         RowBox[{"Sqrt", "[", "k2", "]"}], "]"}]}], ",", 
       RowBox[{"ArcSin", "[", 
        RowBox[{"Sqrt", "[", "k2", "]"}], "]"}]}], "}"}]}], 
    "]"}]}]}]], "Input",
 CellChangeTimes->{{3.750819642656255*^9, 3.750819647503196*^9}},
 CellLabel->"In[25]:=",ExpressionUUID->"c81f187d-dbad-4af9-9726-e613301df7f5"],

Cell[BoxData["0.00001837965747074126`"], "Output",
 CellChangeTimes->{3.7508196482833652`*^9},
 CellLabel->"Out[25]=",ExpressionUUID->"b4cf742d-a392-463d-924d-5242b951f1a3"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"M10r", " ", "=", " ", 
  RowBox[{"4", "*", "b", "*", 
   RowBox[{"r", "/", 
    RowBox[{"(", 
     RowBox[{"2", "*", "m"}], ")"}]}], "*", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"2", "*", "m"}], "-", "1"}], ")"}], "*", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"2", "*", "k2"}], "-", "1"}], ")"}], "*", "M9"}], "+", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{"4", "*", "b", "*", "r"}], ")"}], "*", "2", "*", "k2", "*", 
      RowBox[{"(", 
       RowBox[{"1", "-", "k2"}], ")"}], "*", 
      RowBox[{"(", 
       RowBox[{"m", "-", "1"}], ")"}], "*", "M8"}]}], ")"}]}]}]], "Input",
 CellChangeTimes->{{3.7508196544126053`*^9, 3.750819686294574*^9}},
 CellLabel->"In[26]:=",ExpressionUUID->"f45f8e3c-7da8-4e3d-b062-63bd6eaddc2b"],

Cell[BoxData["1.2721189872022022`*^-6"], "Output",
 CellChangeTimes->{3.7508196874923553`*^9},
 CellLabel->"Out[26]=",ExpressionUUID->"1b5229d8-34f3-42a4-bd56-fba31b55a418"]
}, Open  ]],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{
   RowBox[{"Now", " ", "look", " ", "at", " ", "half"}], "-", 
   RowBox[{"integer", " ", 
    RowBox[{"values", ":"}]}]}], " ", "*)"}]], "Input",
 CellChangeTimes->{{3.750857360452056*^9, 3.750857368247923*^9}},
 CellLabel->"In[1]:=",ExpressionUUID->"7920ad1f-1100-48c7-b7ca-cb4eae7c054a"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"M7p5", " ", "=", " ", 
  RowBox[{
   RowBox[{
    RowBox[{"(", 
     RowBox[{"4", "*", "b", "*", "r"}], ")"}], "^", "7.5"}], "*", 
   RowBox[{"NIntegrate", "[", 
    RowBox[{
     RowBox[{
      RowBox[{"(", 
       RowBox[{"k2", "-", 
        RowBox[{
         RowBox[{"Sin", "[", "xi", "]"}], "^", "2"}]}], ")"}], "^", "7.5"}], 
     ",", 
     RowBox[{"{", 
      RowBox[{"xi", ",", 
       RowBox[{
        RowBox[{"-", "Pi"}], "/", "2"}], ",", 
       RowBox[{"Pi", "/", "2"}]}], "}"}]}], "]"}]}]}]], "Input",
 CellChangeTimes->{{3.750857372508224*^9, 3.7508573895913963`*^9}, {
  3.750857435713187*^9, 3.7508574364558163`*^9}, {3.750859556944668*^9, 
  3.750859561535578*^9}},
 CellLabel->"In[89]:=",ExpressionUUID->"73d55892-6a9e-4ce0-82da-78101236c915"],

Cell[BoxData["2.91347139243991`"], "Output",
 CellChangeTimes->{
  3.7508576002225437`*^9, 3.750857687933218*^9, {3.750859499409992*^9, 
   3.750859519131321*^9}, 3.7508595619874687`*^9, 3.7508595921248913`*^9, 
   3.7508596533650827`*^9, 3.75085970928596*^9},
 CellLabel->"Out[89]=",ExpressionUUID->"811f34e4-0346-4b63-a721-69dfba91c3b0"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"M8p5", " ", "=", " ", 
  RowBox[{
   RowBox[{
    RowBox[{"(", 
     RowBox[{"4", "*", "b", "*", "r"}], ")"}], "^", "8.5"}], "*", 
   RowBox[{"NIntegrate", "[", 
    RowBox[{
     RowBox[{
      RowBox[{"(", 
       RowBox[{"k2", "-", 
        RowBox[{
         RowBox[{"Sin", "[", "xi", "]"}], "^", "2"}]}], ")"}], "^", "8.5"}], 
     ",", 
     RowBox[{"{", 
      RowBox[{"xi", ",", 
       RowBox[{
        RowBox[{"-", "Pi"}], "/", "2"}], ",", 
       RowBox[{"Pi", "/", "2"}]}], "}"}]}], "]"}]}]}]], "Input",
 CellChangeTimes->{{3.750857439514839*^9, 3.750857450270093*^9}, {
  3.75085966061697*^9, 3.75085966484768*^9}},
 CellLabel->"In[90]:=",ExpressionUUID->"0cfd8842-74b7-4366-940d-81ab81bef18e"],

Cell[BoxData["2.8843342064794846`"], "Output",
 CellChangeTimes->{
  3.7508576068537683`*^9, 3.750857690783306*^9, {3.750859656031046*^9, 
   3.750859665217513*^9}, 3.750859710838344*^9},
 CellLabel->"Out[90]=",ExpressionUUID->"8fdede46-bb5d-4894-b428-2834293e89dd"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"M9p5", " ", "=", " ", 
  RowBox[{
   RowBox[{
    RowBox[{"(", 
     RowBox[{"4", "*", "b", "*", "r"}], ")"}], "^", "9.5"}], "*", 
   RowBox[{"NIntegrate", "[", 
    RowBox[{
     RowBox[{
      RowBox[{"(", 
       RowBox[{"k2", "-", 
        RowBox[{
         RowBox[{"Sin", "[", "xi", "]"}], "^", "2"}]}], ")"}], "^", "9.5"}], 
     ",", 
     RowBox[{"{", 
      RowBox[{"xi", ",", 
       RowBox[{
        RowBox[{"-", "Pi"}], "/", "2"}], ",", 
       RowBox[{"Pi", "/", "2"}]}], "}"}]}], "]"}]}]}]], "Input",
 CellChangeTimes->{{3.750857453882284*^9, 3.7508574653975077`*^9}, {
  3.750859669287878*^9, 3.7508596736871033`*^9}},
 CellLabel->"In[91]:=",ExpressionUUID->"a529dfae-60fa-42e1-8bb1-07e3980888c2"],

Cell[BoxData["2.8554884753704965`"], "Output",
 CellChangeTimes->{3.750857611470902*^9, 3.750857695429908*^9, 
  3.750859674033278*^9, 3.750859712586239*^9},
 CellLabel->"Out[91]=",ExpressionUUID->"56fee029-b871-4975-9194-69ce65f8fa71"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"m", " ", "=", " ", "9.5"}]], "Input",
 CellChangeTimes->{{3.750857474036015*^9, 3.7508574762628517`*^9}},
 CellLabel->"In[10]:=",ExpressionUUID->"3c0fb390-5145-4498-901e-889c183995be"],

Cell[BoxData["9.5`"], "Output",
 CellChangeTimes->{3.750857476755228*^9},
 CellLabel->"Out[10]=",ExpressionUUID->"e4a9a647-5cee-474d-b150-f25906a76ba1"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"M9p5r", " ", "=", " ", 
  RowBox[{
   RowBox[{"2", "*", 
    RowBox[{"(", 
     RowBox[{"1", "-", 
      RowBox[{"0.5", "/", "m"}]}], ")"}], "*", 
    RowBox[{"(", 
     RowBox[{"1", "-", 
      RowBox[{"r", "^", "2"}], "-", 
      RowBox[{"b", "^", "2"}]}], ")"}], "*", "M8p5"}], "+", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{"1", "-", 
      RowBox[{"1", "/", "m"}]}], ")"}], "*", 
    RowBox[{"(", 
     RowBox[{"1", "-", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{"b", "-", "r"}], ")"}], "^", "2"}]}], ")"}], "*", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{
       RowBox[{"(", 
        RowBox[{"b", "+", "r"}], ")"}], "^", "2"}], "-", "1"}], ")"}], "*", 
    "M7p5"}]}]}]], "Input",
 CellChangeTimes->{{3.750857479723186*^9, 3.750857521615971*^9}},
 CellLabel->"In[92]:=",ExpressionUUID->"59480239-0542-480d-9fc3-709a9f9153b5"],

Cell[BoxData["2.855488475370496`"], "Output",
 CellChangeTimes->{3.750857620838496*^9, 3.7508577026844997`*^9, 
  3.75085967898203*^9, 3.750859721955264*^9},
 CellLabel->"Out[92]=",ExpressionUUID->"4b2947b5-2e99-40e3-80f7-fb8876fca4e6"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"2", "*", 
  RowBox[{"(", 
   RowBox[{"1", "-", 
    RowBox[{"0.5", "/", "m"}]}], ")"}], "*", 
  RowBox[{"(", 
   RowBox[{"1", "-", 
    RowBox[{"r", "^", "2"}], "-", 
    RowBox[{"b", "^", "2"}]}], ")"}], "*", "M8p5"}]], "Input",
 CellChangeTimes->{3.750857659674017*^9},
 CellLabel->"In[93]:=",ExpressionUUID->"22f36ad2-96fa-49f8-87b1-256053b6ca21"],

Cell[BoxData["5.410398278047231`"], "Output",
 CellChangeTimes->{
  3.750857551281761*^9, 3.750857624090954*^9, {3.750857656261498*^9, 
   3.750857660293679*^9}, 3.7508577074141083`*^9, 3.75085972625735*^9},
 CellLabel->"Out[93]=",ExpressionUUID->"6035d903-0193-4881-9dc2-24e0f7f004c8"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"(", 
   RowBox[{"1", "-", 
    RowBox[{"1", "/", "m"}]}], ")"}], "*", 
  RowBox[{"(", 
   RowBox[{"1", "-", 
    RowBox[{
     RowBox[{"(", 
      RowBox[{"b", "-", "r"}], ")"}], "^", "2"}]}], ")"}], "*", 
  RowBox[{"(", 
   RowBox[{
    RowBox[{
     RowBox[{"(", 
      RowBox[{"b", "+", "r"}], ")"}], "^", "2"}], "-", "1"}], ")"}], "*", 
  "M7p5"}]], "Input",
 CellChangeTimes->{3.7508576663860693`*^9},
 CellLabel->"In[94]:=",ExpressionUUID->"31130cbc-ab12-4b81-9889-28ee3404bb70"],

Cell[BoxData[
 RowBox[{"-", "2.554909802676735`"}]], "Output",
 CellChangeTimes->{3.7508575574991913`*^9, 3.750857626072715*^9, 
  3.750857667142383*^9, 3.750857710249049*^9, 3.7508597290229883`*^9},
 CellLabel->"Out[94]=",ExpressionUUID->"00aca9b4-aa49-45e6-96f3-5bcbfb092424"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"PGn", " ", "=", " ", 
  RowBox[{
   RowBox[{
    RowBox[{"(", 
     RowBox[{"1", "+", 
      RowBox[{"r", "^", "2"}], "-", 
      RowBox[{"b", "^", "2"}]}], ")"}], "*", "M8p5"}], "-", 
   "M9p5"}]}]], "Input",
 CellChangeTimes->{{3.750859925377865*^9, 3.750859955223127*^9}},
 CellLabel->"In[95]:=",ExpressionUUID->"97188cf8-a7fc-439e-a595-31424a5637d5"],

Cell[BoxData["0.05768618883957677`"], "Output",
 CellChangeTimes->{3.750859955930464*^9},
 CellLabel->"Out[95]=",ExpressionUUID->"7458a7ff-92d3-4abf-9f35-d1efd7602481"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Integrate", "[", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{"(", 
      RowBox[{"1", "-", "w"}], ")"}], "^", "mm"}], "*", 
    RowBox[{"w", "^", 
     RowBox[{"(", 
      RowBox[{"j", "-", 
       RowBox[{"1", "/", "2"}]}], ")"}]}]}], ",", 
   RowBox[{"{", 
    RowBox[{"w", ",", "0", ",", "1"}], "}"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.750861634173867*^9, 3.750861666494988*^9}},
 CellLabel->"In[97]:=",ExpressionUUID->"ef9ebd9b-b59c-4b3d-8439-f7ea3638da3b"],

Cell[BoxData[
 RowBox[{"ConditionalExpression", "[", 
  RowBox[{
   FractionBox[
    RowBox[{
     RowBox[{"Gamma", "[", 
      RowBox[{
       FractionBox["1", "2"], "+", "j"}], "]"}], " ", 
     RowBox[{"Gamma", "[", 
      RowBox[{"1", "+", "mm"}], "]"}]}], 
    RowBox[{"Gamma", "[", 
     RowBox[{
      FractionBox["3", "2"], "+", "j", "+", "mm"}], "]"}]], ",", 
   RowBox[{
    RowBox[{
     RowBox[{"Re", "[", "j", "]"}], ">", 
     RowBox[{"-", 
      FractionBox["1", "2"]}]}], "&&", 
    RowBox[{
     RowBox[{"Re", "[", "mm", "]"}], ">", 
     RowBox[{"-", "1"}]}]}]}], "]"}]], "Output",
 CellChangeTimes->{{3.750861657458179*^9, 3.750861670070958*^9}},
 CellLabel->"Out[97]=",ExpressionUUID->"f7a83dd3-8dc5-4e28-9e80-fac4fd864a7c"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Integrate", "[", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"(", 
       RowBox[{"kk2", "-", "w"}], ")"}], "^", "mm"}], "/", 
     RowBox[{"Sqrt", "[", "w", "]"}]}], "/", 
    RowBox[{"Sqrt", "[", 
     RowBox[{"1", "-", "w"}], "]"}]}], ",", 
   RowBox[{"{", 
    RowBox[{"w", ",", "0", ",", "1"}], "}"}], ",", " ", 
   RowBox[{"Assumptions", "\[Rule]", " ", 
    RowBox[{"mm", " ", "\[Epsilon]", " ", 
     TemplateBox[{},
      "Integers"]}]}]}], "]"}]], "Input",
 CellChangeTimes->{{3.750898368065259*^9, 3.7508983863156347`*^9}, {
  3.750898528174157*^9, 3.750898571378137*^9}},
 CellLabel->
  "In[100]:=",ExpressionUUID->"31059212-fcfb-4b8d-8361-b995e367b344"],

Cell[BoxData[
 RowBox[{"ConditionalExpression", "[", 
  RowBox[{
   RowBox[{
    SuperscriptBox["kk2", "mm"], " ", "\[Pi]", " ", 
    RowBox[{"Hypergeometric2F1", "[", 
     RowBox[{
      FractionBox["1", "2"], ",", 
      RowBox[{"-", "mm"}], ",", "1", ",", 
      FractionBox["1", "kk2"]}], "]"}]}], ",", 
   RowBox[{
    RowBox[{"Re", "[", "kk2", "]"}], ">", "0"}]}], "]"}]], "Output",
 CellChangeTimes->{{3.7508983820462723`*^9, 3.7508983889819803`*^9}, 
   3.750898573273243*^9},
 CellLabel->
  "Out[100]=",ExpressionUUID->"27b3d99c-0bb6-416d-9cb0-c2cd9429455d"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Integrate", "[", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{"w", "^", "j"}], "/", 
     RowBox[{"Sqrt", "[", "w", "]"}]}], "/", 
    RowBox[{"Sqrt", "[", 
     RowBox[{"1", "-", "w"}], "]"}]}], ",", 
   RowBox[{"{", 
    RowBox[{"w", ",", "0", ",", "1"}], "}"}], ",", 
   RowBox[{"Assumptions", "\[Rule]", " ", 
    RowBox[{"j", " ", "\[Epsilon]", " ", 
     TemplateBox[{},
      "Integers"]}]}]}], "]"}]], "Input",
 CellChangeTimes->{{3.750898601591073*^9, 3.750898625355796*^9}},
 CellLabel->
  "In[101]:=",ExpressionUUID->"a74a6713-c354-4a45-8152-78bc8d60cfa7"],

Cell[BoxData[
 RowBox[{"ConditionalExpression", "[", 
  RowBox[{
   FractionBox[
    RowBox[{
     SqrtBox["\[Pi]"], " ", 
     RowBox[{"Gamma", "[", 
      RowBox[{
       FractionBox["1", "2"], "+", "j"}], "]"}]}], 
    RowBox[{"Gamma", "[", 
     RowBox[{"1", "+", "j"}], "]"}]], ",", 
   RowBox[{
    RowBox[{"Re", "[", "j", "]"}], ">", 
    RowBox[{"-", 
     FractionBox["1", "2"]}]}]}], "]"}]], "Output",
 CellChangeTimes->{3.750898627534391*^9},
 CellLabel->
  "Out[101]=",ExpressionUUID->"50458a6c-68d9-44f3-937f-deecf3f79feb"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Integrate", "[", 
  RowBox[{
   RowBox[{
    RowBox[{"(", 
     RowBox[{"1", "-", 
      RowBox[{
       RowBox[{
        RowBox[{"Sin", "[", "xi", "]"}], "^", "2"}], "/", "kk2"}]}], ")"}], 
    "^", "mm"}], ",", 
   RowBox[{"{", 
    RowBox[{"xi", ",", 
     RowBox[{
      RowBox[{"-", "Pi"}], "/", "2"}], ",", 
     RowBox[{"Pi", "/", "2"}]}], "}"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.750898737769264*^9, 3.750898754667879*^9}, {
  3.750898795789628*^9, 3.750898827364044*^9}},
 CellLabel->
  "In[108]:=",ExpressionUUID->"1f212697-5543-4e8e-a9cf-e6ebf00d47f8"],

Cell[BoxData[
 RowBox[{"ConditionalExpression", "[", 
  RowBox[{
   RowBox[{"\[Pi]", " ", 
    RowBox[{"Hypergeometric2F1", "[", 
     RowBox[{
      FractionBox["1", "2"], ",", 
      RowBox[{"-", "mm"}], ",", "1", ",", 
      FractionBox["1", "kk2"]}], "]"}]}], ",", 
   RowBox[{
    RowBox[{
     RowBox[{"Im", "[", "kk2", "]"}], "\[NotEqual]", "0"}], "||", 
    RowBox[{
     RowBox[{"Re", "[", "kk2", "]"}], "\[GreaterEqual]", "1"}], "||", 
    RowBox[{
     RowBox[{"Re", "[", "kk2", "]"}], "\[LessEqual]", "0"}]}]}], 
  "]"}]], "Output",
 CellChangeTimes->{{3.750898822957502*^9, 3.7508988389912977`*^9}},
 CellLabel->
  "Out[108]=",ExpressionUUID->"9c4400c1-7564-486a-8b8f-b2d94ac3a564"]
}, Open  ]],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{
   RowBox[{
   "Try", " ", "to", " ", "derive", " ", "analytic", " ", "expression", " ", 
    "for", " ", 
    RowBox[{"k", "^", "2"}]}], " ", ">", " ", "1."}], " ", "*)"}]], "Input",
 CellChangeTimes->{{3.75096652725845*^9, 3.750966539191156*^9}},
 CellLabel->"In[1]:=",ExpressionUUID->"4628d8be-91c0-43fc-925d-f92dc4aa2f51"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Integrate", "[", 
  RowBox[{
   RowBox[{
    RowBox[{"(", 
     RowBox[{"k2", "-", 
      RowBox[{
       RowBox[{"Sin", "[", "xi", "]"}], "^", "2"}]}], ")"}], "^", "0"}], ",", 
   
   RowBox[{"{", 
    RowBox[{"xi", ",", 
     RowBox[{
      RowBox[{"-", "Pi"}], "/", "2"}], ",", 
     RowBox[{"Pi", "/", "2"}]}], "}"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.750966542916665*^9, 3.7509665898536177`*^9}},
 CellLabel->"In[4]:=",ExpressionUUID->"30006eb5-4991-41ec-8e70-8cfeb77f1cc1"],

Cell[BoxData["\[Pi]"], "Output",
 CellChangeTimes->{{3.750966575762051*^9, 3.7509665900967503`*^9}},
 CellLabel->"Out[4]=",ExpressionUUID->"fc60d13a-88fa-441a-9f14-170bfaf3947d"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Integrate", "[", 
  RowBox[{
   RowBox[{
    RowBox[{"(", 
     RowBox[{"k2", "-", 
      RowBox[{
       RowBox[{"Sin", "[", "xi", "]"}], "^", "2"}]}], ")"}], "^", "1"}], ",", 
   
   RowBox[{"{", 
    RowBox[{"xi", ",", 
     RowBox[{
      RowBox[{"-", "Pi"}], "/", "2"}], ",", 
     RowBox[{"Pi", "/", "2"}]}], "}"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.750966594375024*^9, 3.750966594406155*^9}},
 CellLabel->"In[5]:=",ExpressionUUID->"732435d1-f3a6-4185-9e72-722834a4e2fe"],

Cell[BoxData[
 RowBox[{
  RowBox[{"(", 
   RowBox[{
    RowBox[{"-", 
     FractionBox["1", "2"]}], "+", "k2"}], ")"}], " ", "\[Pi]"}]], "Output",
 CellChangeTimes->{3.750966595001728*^9},
 CellLabel->"Out[5]=",ExpressionUUID->"be192b0f-4258-45bf-8012-f1b19b07c302"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Integrate", "[", 
  RowBox[{
   RowBox[{
    RowBox[{"(", 
     RowBox[{"k2", "-", 
      RowBox[{
       RowBox[{"Sin", "[", "xi", "]"}], "^", "2"}]}], ")"}], "^", "2"}], ",", 
   
   RowBox[{"{", 
    RowBox[{"xi", ",", 
     RowBox[{
      RowBox[{"-", "Pi"}], "/", "2"}], ",", 
     RowBox[{"Pi", "/", "2"}]}], "}"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.7509665977829514`*^9, 3.750966597869454*^9}},
 CellLabel->"In[6]:=",ExpressionUUID->"a33934eb-3fb8-4de8-b474-953e7760bc48"],

Cell[BoxData[
 RowBox[{
  RowBox[{"(", 
   RowBox[{
    FractionBox["3", "8"], "+", 
    RowBox[{
     RowBox[{"(", 
      RowBox[{
       RowBox[{"-", "1"}], "+", "k2"}], ")"}], " ", "k2"}]}], ")"}], " ", 
  "\[Pi]"}]], "Output",
 CellChangeTimes->{3.750966598285528*^9},
 CellLabel->"Out[6]=",ExpressionUUID->"dc38e5b1-8eb9-444a-b32c-934ac7e34579"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Integrate", "[", 
  RowBox[{
   RowBox[{
    RowBox[{"(", 
     RowBox[{"k2", "-", 
      RowBox[{
       RowBox[{"Sin", "[", "xi", "]"}], "^", "2"}]}], ")"}], "^", "3"}], ",", 
   
   RowBox[{"{", 
    RowBox[{"xi", ",", 
     RowBox[{
      RowBox[{"-", "Pi"}], "/", "2"}], ",", 
     RowBox[{"Pi", "/", "2"}]}], "}"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.7509666034946957`*^9, 3.750966603557251*^9}},
 CellLabel->"In[7]:=",ExpressionUUID->"4336e48e-a6fe-4334-adce-67b92dcd6a15"],

Cell[BoxData[
 RowBox[{
  FractionBox["1", "16"], " ", 
  RowBox[{"(", 
   RowBox[{
    RowBox[{"-", "1"}], "+", 
    RowBox[{"2", " ", "k2"}]}], ")"}], " ", 
  RowBox[{"(", 
   RowBox[{"5", "+", 
    RowBox[{"8", " ", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"-", "1"}], "+", "k2"}], ")"}], " ", "k2"}]}], ")"}], " ", 
  "\[Pi]"}]], "Output",
 CellChangeTimes->{3.7509666044024343`*^9},
 CellLabel->"Out[7]=",ExpressionUUID->"c0f2a8c8-45e7-45d0-9bdb-302d3fac7652"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Integrate", "[", 
  RowBox[{
   RowBox[{
    RowBox[{"(", 
     RowBox[{"k2", "-", 
      RowBox[{
       RowBox[{"Sin", "[", "xi", "]"}], "^", "2"}]}], ")"}], "^", "4"}], ",", 
   
   RowBox[{"{", 
    RowBox[{"xi", ",", 
     RowBox[{
      RowBox[{"-", "Pi"}], "/", "2"}], ",", 
     RowBox[{"Pi", "/", "2"}]}], "}"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.750966634005364*^9, 3.750966634492011*^9}},
 CellLabel->"In[8]:=",ExpressionUUID->"42579431-fb10-4206-870f-872cce0f6e41"],

Cell[BoxData[
 RowBox[{
  FractionBox["1", "128"], " ", 
  RowBox[{"(", 
   RowBox[{"35", "+", 
    RowBox[{"32", " ", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"-", "1"}], "+", "k2"}], ")"}], " ", "k2", " ", 
     RowBox[{"(", 
      RowBox[{"5", "+", 
       RowBox[{"4", " ", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"-", "1"}], "+", "k2"}], ")"}], " ", "k2"}]}], ")"}]}]}], 
   ")"}], " ", "\[Pi]"}]], "Output",
 CellChangeTimes->{3.750966635748927*^9},
 CellLabel->"Out[8]=",ExpressionUUID->"def25c09-d3e0-460d-81ed-a12669e47173"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Integrate", "[", 
  RowBox[{
   RowBox[{
    RowBox[{"(", 
     RowBox[{"k2", "-", 
      RowBox[{
       RowBox[{"Sin", "[", "xi", "]"}], "^", "2"}]}], ")"}], "^", "5"}], ",", 
   
   RowBox[{"{", 
    RowBox[{"xi", ",", 
     RowBox[{
      RowBox[{"-", "Pi"}], "/", "2"}], ",", 
     RowBox[{"Pi", "/", "2"}]}], "}"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.7509666380292807`*^9, 3.750966638075799*^9}},
 CellLabel->"In[9]:=",ExpressionUUID->"5c9a7318-346d-4711-b37f-97f7b8c6098a"],

Cell[BoxData[
 RowBox[{
  FractionBox["1", "256"], " ", 
  RowBox[{"(", 
   RowBox[{
    RowBox[{"-", "1"}], "+", 
    RowBox[{"2", " ", "k2"}]}], ")"}], " ", 
  RowBox[{"(", 
   RowBox[{"63", "+", 
    RowBox[{"32", " ", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"-", "1"}], "+", "k2"}], ")"}], " ", "k2", " ", 
     RowBox[{"(", 
      RowBox[{"7", "+", 
       RowBox[{"4", " ", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"-", "1"}], "+", "k2"}], ")"}], " ", "k2"}]}], ")"}]}]}], 
   ")"}], " ", "\[Pi]"}]], "Output",
 CellChangeTimes->{3.750966640415649*^9},
 CellLabel->"Out[9]=",ExpressionUUID->"c09e8dd9-a774-4493-9837-bd9f855d7b66"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Integrate", "[", 
  RowBox[{
   RowBox[{
    RowBox[{"(", 
     RowBox[{"k2", "-", 
      RowBox[{
       RowBox[{"Sin", "[", "xi", "]"}], "^", "2"}]}], ")"}], "^", "6"}], ",", 
   
   RowBox[{"{", 
    RowBox[{"xi", ",", 
     RowBox[{
      RowBox[{"-", "Pi"}], "/", "2"}], ",", 
     RowBox[{"Pi", "/", "2"}]}], "}"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.7509666465956583`*^9, 3.750966646643567*^9}},
 CellLabel->"In[10]:=",ExpressionUUID->"4dcb6bc3-a7a5-477b-a001-6ffaa87c51da"],

Cell[BoxData[
 FractionBox[
  RowBox[{
   RowBox[{"(", 
    RowBox[{"231", "+", 
     RowBox[{"8", " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "1"}], "+", "k2"}], ")"}], " ", "k2", " ", 
      RowBox[{"(", 
       RowBox[{"189", "+", 
        RowBox[{"16", " ", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"-", "1"}], "+", "k2"}], ")"}], " ", "k2", " ", 
         RowBox[{"(", 
          RowBox[{"21", "+", 
           RowBox[{"8", " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", "1"}], "+", "k2"}], ")"}], " ", "k2"}]}], 
          ")"}]}]}], ")"}]}]}], ")"}], " ", "\[Pi]"}], "1024"]], "Output",
 CellChangeTimes->{3.7509666496347723`*^9},
 CellLabel->"Out[10]=",ExpressionUUID->"f1e6393f-269f-4aea-b953-b0a12f130f68"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Series", "[", 
  RowBox[{"%", ",", 
   RowBox[{"{", 
    RowBox[{"k2", ",", "0", ",", "8"}], "}"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.750966660412177*^9, 3.750966666093491*^9}},
 CellLabel->"In[11]:=",ExpressionUUID->"90142b10-a55a-4160-b2e8-3e1a9f506e87"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
   FractionBox[
    RowBox[{"231", " ", "\[Pi]"}], "1024"], "-", 
   FractionBox[
    RowBox[{"189", " ", "\[Pi]", " ", "k2"}], "128"], "+", 
   FractionBox[
    RowBox[{"525", " ", "\[Pi]", " ", 
     SuperscriptBox["k2", "2"]}], "128"], "-", 
   FractionBox[
    RowBox[{"25", " ", "\[Pi]", " ", 
     SuperscriptBox["k2", "3"]}], "4"], "+", 
   FractionBox[
    RowBox[{"45", " ", "\[Pi]", " ", 
     SuperscriptBox["k2", "4"]}], "8"], "-", 
   RowBox[{"3", " ", "\[Pi]", " ", 
    SuperscriptBox["k2", "5"]}], "+", 
   RowBox[{"\[Pi]", " ", 
    SuperscriptBox["k2", "6"]}], "+", 
   InterpretationBox[
    SuperscriptBox[
     RowBox[{"O", "[", "k2", "]"}], "9"],
    SeriesData[$CellContext`k2, 0, {}, 0, 9, 1],
    Editable->False]}],
  SeriesData[$CellContext`k2, 0, {
   Rational[231, 1024] Pi, Rational[-189, 128] Pi, Rational[525, 128] Pi, 
    Rational[-25, 4] Pi, Rational[45, 8] Pi, (-3) Pi, Pi}, 0, 9, 1],
  Editable->False]], "Output",
 CellChangeTimes->{3.750966666562285*^9},
 CellLabel->"Out[11]=",ExpressionUUID->"d610b895-2498-46c5-9631-95e5243a3922"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Integrate", "[", 
  RowBox[{
   RowBox[{
    RowBox[{"(", 
     RowBox[{"-", 
      RowBox[{
       RowBox[{"Sin", "[", "xi", "]"}], "^", "2"}]}], ")"}], "^", "mmj"}], 
   ",", 
   RowBox[{"{", 
    RowBox[{"xi", ",", 
     RowBox[{
      RowBox[{"-", "Pi"}], "/", "2"}], ",", 
     RowBox[{"Pi", "/", "2"}]}], "}"}], ",", 
   RowBox[{"Assumptions", "\[Rule]", " ", 
    RowBox[{"mmj", " ", "\[Epsilon]", " ", 
     TemplateBox[{},
      "Integers"]}]}]}], "]"}]], "Input",
 CellChangeTimes->{{3.750966858062942*^9, 3.7509668892906027`*^9}, {
  3.751210081170116*^9, 3.751210086622382*^9}},
 CellLabel->"In[12]:=",ExpressionUUID->"bc24eb7a-5b57-4757-bb96-eb88d0f9ba34"],

Cell[BoxData[
 RowBox[{"ConditionalExpression", "[", 
  RowBox[{
   FractionBox[
    RowBox[{
     SuperscriptBox[
      RowBox[{"(", 
       RowBox[{"-", "1"}], ")"}], "mmj"], " ", 
     SqrtBox["\[Pi]"], " ", 
     RowBox[{"Gamma", "[", 
      RowBox[{
       FractionBox["1", "2"], "+", "mmj"}], "]"}]}], 
    RowBox[{"Gamma", "[", 
     RowBox[{"1", "+", "mmj"}], "]"}]], ",", 
   RowBox[{
    RowBox[{"Re", "[", "mmj", "]"}], ">", 
    RowBox[{"-", 
     FractionBox["1", "2"]}]}]}], "]"}]], "Output",
 CellChangeTimes->{3.750966893993629*^9},
 CellLabel->"Out[12]=",ExpressionUUID->"5ceacde5-32ed-448a-8f1d-81de84859943"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"4", "!!"}]], "Input",
 CellChangeTimes->{{3.750979188601408*^9, 3.750979189063347*^9}},
 CellLabel->"In[13]:=",ExpressionUUID->"7bacc67b-f5f0-4327-8ae4-b9403c484dc0"],

Cell[BoxData["8"], "Output",
 CellChangeTimes->{3.7509791895064373`*^9},
 CellLabel->"Out[13]=",ExpressionUUID->"bf0ec9a7-9976-4fc0-b24e-673add8103e3"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"10", "!!"}]], "Input",
 CellChangeTimes->{{3.750979196285708*^9, 3.750979198167012*^9}},
 CellLabel->"In[14]:=",ExpressionUUID->"bbd21278-74c4-4652-a1ac-ef5cc8cd01c8"],

Cell[BoxData["3840"], "Output",
 CellChangeTimes->{3.750979198476531*^9},
 CellLabel->"Out[14]=",ExpressionUUID->"fbbcaee3-c01d-4d97-b02d-6f9e7e3a995e"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"11", "!!"}]], "Input",
 CellChangeTimes->{{3.750979199157769*^9, 3.750979200670802*^9}},
 CellLabel->"In[15]:=",ExpressionUUID->"76c082ec-0b0d-4373-a493-c748ca264346"],

Cell[BoxData["10395"], "Output",
 CellChangeTimes->{3.750979201127261*^9},
 CellLabel->"Out[15]=",ExpressionUUID->"9a20a20b-c6a3-44e0-b3b5-e858c47d7098"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"11", "!"}]], "Input",
 CellChangeTimes->{{3.750979202861566*^9, 3.7509792041428213`*^9}},
 CellLabel->"In[16]:=",ExpressionUUID->"fe463fd9-79f1-47f7-9fc7-4d60526f6df1"],

Cell[BoxData["39916800"], "Output",
 CellChangeTimes->{3.750979204478426*^9},
 CellLabel->"Out[16]=",ExpressionUUID->"18da4783-452f-46a6-9ab1-b008aa67d335"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Integrate", "[", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{"(", 
      RowBox[{"k2", "-", 
       RowBox[{
        RowBox[{"Sin", "[", "xi", "]"}], "^", "2"}]}], ")"}], "^", "mmj"}], 
    "*", 
    RowBox[{"Sqrt", "[", 
     RowBox[{"k2", "-", 
      RowBox[{
       RowBox[{"Sin", "[", "xi", "]"}], "^", "2"}]}], "]"}]}], ",", 
   RowBox[{"{", 
    RowBox[{"xi", ",", 
     RowBox[{
      RowBox[{"-", "Pi"}], "/", "2"}], ",", 
     RowBox[{"Pi", "/", "2"}]}], "}"}], ",", 
   RowBox[{"Assumptions", "\[Rule]", " ", 
    RowBox[{"mmj", " ", "\[Epsilon]", " ", 
     TemplateBox[{},
      "Integers"]}]}]}], "]"}]], "Input",
 CellChangeTimes->{{3.751210098679578*^9, 3.751210105213945*^9}, {
  3.751210149015877*^9, 3.751210149100231*^9}},
 CellLabel->"In[34]:=",ExpressionUUID->"40fb478b-25a3-4e47-8206-fb346829a41b"],

Cell[BoxData[
 RowBox[{"ConditionalExpression", "[", 
  RowBox[{
   RowBox[{
    SuperscriptBox["k2", 
     RowBox[{
      FractionBox["1", "2"], "+", "mmj"}]], " ", "\[Pi]", " ", 
    RowBox[{"Hypergeometric2F1", "[", 
     RowBox[{
      FractionBox["1", "2"], ",", 
      RowBox[{
       RowBox[{"-", 
        FractionBox["1", "2"]}], "-", "mmj"}], ",", "1", ",", 
      FractionBox["1", "k2"]}], "]"}]}], ",", 
   RowBox[{
    RowBox[{"Re", "[", "k2", "]"}], ">", "0"}]}], "]"}]], "Output",
 CellChangeTimes->{3.75121011567292*^9, 3.751210156569882*^9},
 CellLabel->"Out[34]=",ExpressionUUID->"57d436bc-1f85-4932-bab7-71539d6c3227"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Integrate", "[", 
  RowBox[{
   RowBox[{
    RowBox[{"(", 
     RowBox[{"k2", "-", 
      RowBox[{
       RowBox[{"Sin", "[", "xi", "]"}], "^", "2"}]}], ")"}], "^", "mmj"}], 
   ",", 
   RowBox[{"{", 
    RowBox[{"xi", ",", 
     RowBox[{"-", 
      RowBox[{"ArcSin", "[", 
       RowBox[{"Sqrt", "[", "k2", "]"}], "]"}]}], ",", 
     RowBox[{"ArcSin", "[", 
      RowBox[{"Sqrt", "[", "k2", "]"}], "]"}]}], "}"}], ",", 
   RowBox[{"Assumptions", "\[Rule]", " ", 
    RowBox[{"mmj", " ", "\[Epsilon]", " ", 
     TemplateBox[{},
      "Integers"]}]}]}], "]"}]], "Input",
 CellChangeTimes->{{3.7512105444088783`*^9, 3.751210545799156*^9}, 
   3.7512105825224953`*^9},
 CellLabel->"In[36]:=",ExpressionUUID->"e810f793-b29b-461e-98cf-1566654f3efa"],

Cell[BoxData["$Aborted"], "Output",
 CellChangeTimes->{3.7512105482652693`*^9, 3.751210894945035*^9},
 CellLabel->"Out[36]=",ExpressionUUID->"022d46f7-9205-40ce-8d3b-97d827a00723"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"1", "-", 
  RowBox[{"u1", "*", 
   RowBox[{"(", 
    RowBox[{"1", "-", "mu"}], ")"}]}], "-", 
  RowBox[{"u2", "*", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{"1", "-", "mu"}], ")"}], "^", "2"}]}], "-", 
  RowBox[{"u3", "*", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{"1", "-", "mu"}], ")"}], "^", "3"}]}], "-", 
  RowBox[{"u4", "*", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{"1", "-", "mu"}], ")"}], "^", "4"}]}], "-", 
  RowBox[{"u5", "*", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{"1", "-", "mu"}], ")"}], "^", "5"}]}]}]], "Input",
 CellChangeTimes->{{3.751214890044641*^9, 3.7512149133247337`*^9}},
 CellLabel->"In[37]:=",ExpressionUUID->"ab3d4a35-479c-4ecd-8234-8e201e425d98"],

Cell[BoxData[
 RowBox[{"1", "-", 
  RowBox[{
   RowBox[{"(", 
    RowBox[{"1", "-", "mu"}], ")"}], " ", "u1"}], "-", 
  RowBox[{
   SuperscriptBox[
    RowBox[{"(", 
     RowBox[{"1", "-", "mu"}], ")"}], "2"], " ", "u2"}], "-", 
  RowBox[{
   SuperscriptBox[
    RowBox[{"(", 
     RowBox[{"1", "-", "mu"}], ")"}], "3"], " ", "u3"}], "-", 
  RowBox[{
   SuperscriptBox[
    RowBox[{"(", 
     RowBox[{"1", "-", "mu"}], ")"}], "4"], " ", "u4"}], "-", 
  RowBox[{
   SuperscriptBox[
    RowBox[{"(", 
     RowBox[{"1", "-", "mu"}], ")"}], "5"], " ", "u5"}]}]], "Output",
 CellChangeTimes->{3.751214918694126*^9},
 CellLabel->"Out[37]=",ExpressionUUID->"006e93e4-9149-4abb-b0e9-c29f12cd923f"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Expand", "[", "%", "]"}]], "Input",
 CellChangeTimes->{{3.75121491961134*^9, 3.751214922493908*^9}},
 CellLabel->"In[38]:=",ExpressionUUID->"dcc1e915-26db-4dec-b65a-9e63944a86d9"],

Cell[BoxData[
 RowBox[{"1", "-", "u1", "+", 
  RowBox[{"mu", " ", "u1"}], "-", "u2", "+", 
  RowBox[{"2", " ", "mu", " ", "u2"}], "-", 
  RowBox[{
   SuperscriptBox["mu", "2"], " ", "u2"}], "-", "u3", "+", 
  RowBox[{"3", " ", "mu", " ", "u3"}], "-", 
  RowBox[{"3", " ", 
   SuperscriptBox["mu", "2"], " ", "u3"}], "+", 
  RowBox[{
   SuperscriptBox["mu", "3"], " ", "u3"}], "-", "u4", "+", 
  RowBox[{"4", " ", "mu", " ", "u4"}], "-", 
  RowBox[{"6", " ", 
   SuperscriptBox["mu", "2"], " ", "u4"}], "+", 
  RowBox[{"4", " ", 
   SuperscriptBox["mu", "3"], " ", "u4"}], "-", 
  RowBox[{
   SuperscriptBox["mu", "4"], " ", "u4"}], "-", "u5", "+", 
  RowBox[{"5", " ", "mu", " ", "u5"}], "-", 
  RowBox[{"10", " ", 
   SuperscriptBox["mu", "2"], " ", "u5"}], "+", 
  RowBox[{"10", " ", 
   SuperscriptBox["mu", "3"], " ", "u5"}], "-", 
  RowBox[{"5", " ", 
   SuperscriptBox["mu", "4"], " ", "u5"}], "+", 
  RowBox[{
   SuperscriptBox["mu", "5"], " ", "u5"}]}]], "Output",
 CellChangeTimes->{3.751214922757948*^9},
 CellLabel->"Out[38]=",ExpressionUUID->"84de1ff4-8c9c-47fb-9565-091df2a531bc"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Series", "[", 
  RowBox[{"%", ",", 
   RowBox[{"{", 
    RowBox[{"mu", ",", "0", ",", "5"}], "}"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.7512149253138313`*^9, 3.75121492882817*^9}},
 CellLabel->"In[39]:=",ExpressionUUID->"6c390c43-dcee-476b-8480-533d61942938"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
   RowBox[{"(", 
    RowBox[{"1", "-", "u1", "-", "u2", "-", "u3", "-", "u4", "-", "u5"}], 
    ")"}], "+", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{"u1", "+", 
      RowBox[{"2", " ", "u2"}], "+", 
      RowBox[{"3", " ", "u3"}], "+", 
      RowBox[{"4", " ", "u4"}], "+", 
      RowBox[{"5", " ", "u5"}]}], ")"}], " ", "mu"}], "+", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      RowBox[{"-", "u2"}], "-", 
      RowBox[{"3", " ", "u3"}], "-", 
      RowBox[{"6", " ", "u4"}], "-", 
      RowBox[{"10", " ", "u5"}]}], ")"}], " ", 
    SuperscriptBox["mu", "2"]}], "+", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{"u3", "+", 
      RowBox[{"4", " ", "u4"}], "+", 
      RowBox[{"10", " ", "u5"}]}], ")"}], " ", 
    SuperscriptBox["mu", "3"]}], "+", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      RowBox[{"-", "u4"}], "-", 
      RowBox[{"5", " ", "u5"}]}], ")"}], " ", 
    SuperscriptBox["mu", "4"]}], "+", 
   RowBox[{"u5", " ", 
    SuperscriptBox["mu", "5"]}], "+", 
   InterpretationBox[
    SuperscriptBox[
     RowBox[{"O", "[", "mu", "]"}], "6"],
    SeriesData[$CellContext`mu, 0, {}, 0, 6, 1],
    Editable->False]}],
  SeriesData[$CellContext`mu, 0, {
   1 - $CellContext`u1 - $CellContext`u2 - $CellContext`u3 - $CellContext`u4 - \
$CellContext`u5, $CellContext`u1 + 2 $CellContext`u2 + 3 $CellContext`u3 + 
    4 $CellContext`u4 + 5 $CellContext`u5, -$CellContext`u2 - 
    3 $CellContext`u3 - 6 $CellContext`u4 - 
    10 $CellContext`u5, $CellContext`u3 + 4 $CellContext`u4 + 
    10 $CellContext`u5, -$CellContext`u4 - 
    5 $CellContext`u5, $CellContext`u5}, 0, 6, 1],
  Editable->False]], "Output",
 CellChangeTimes->{3.75121492919736*^9},
 CellLabel->"Out[39]=",ExpressionUUID->"0d58eb6d-5d86-4682-b57a-502e17d404f1"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Integrate", "[", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"(", 
       RowBox[{"1", "-", "w"}], ")"}], "^", 
      RowBox[{"(", 
       RowBox[{"m", "/", "2"}], ")"}]}], "/", 
     RowBox[{"Sqrt", "[", "w", "]"}]}], "/", 
    RowBox[{"Sqrt", "[", 
     RowBox[{"1", "-", 
      RowBox[{"k2", "*", "w"}]}], "]"}]}], ",", 
   RowBox[{"{", 
    RowBox[{"w", ",", "0", ",", "1"}], "}"}], ",", " ", 
   RowBox[{"Assumptions", "\[Rule]", " ", 
    RowBox[{"m", " ", "\[Epsilon]", " ", 
     TemplateBox[{},
      "Integers"]}]}]}], "]"}]], "Input",
 CellChangeTimes->{{3.7512185263814983`*^9, 3.751218558941451*^9}, {
  3.751321640927773*^9, 3.7513216423155413`*^9}},
 CellLabel->
  "In[125]:=",ExpressionUUID->"fd3bd3ae-3dcc-4961-a922-1d08e7fe7f8c"],

Cell[BoxData[
 RowBox[{"ConditionalExpression", "[", 
  RowBox[{
   RowBox[{
    SqrtBox["\[Pi]"], " ", 
    RowBox[{"Gamma", "[", 
     RowBox[{"1", "+", 
      FractionBox["m", "2"]}], "]"}], " ", 
    RowBox[{"Hypergeometric2F1Regularized", "[", 
     RowBox[{
      FractionBox["1", "2"], ",", 
      FractionBox["1", "2"], ",", 
      FractionBox[
       RowBox[{"3", "+", "m"}], "2"], ",", "k2"}], "]"}]}], ",", 
   RowBox[{
    RowBox[{"Re", "[", "m", "]"}], ">", 
    RowBox[{"-", "2"}]}]}], "]"}]], "Output",
 CellChangeTimes->{3.751218562547023*^9, 3.751321652340274*^9},
 CellLabel->
  "Out[125]=",ExpressionUUID->"0d5cc942-ca98-4346-82cd-ff1b5edff46a"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Integrate", "[", 
  RowBox[{
   RowBox[{"Sqrt", "[", 
    RowBox[{"k2", "-", 
     RowBox[{
      RowBox[{"Sin", "[", "xi", "]"}], "^", "2"}]}], "]"}], ",", 
   RowBox[{"{", 
    RowBox[{"xi", ",", 
     RowBox[{"-", 
      RowBox[{"ArcSin", "[", 
       RowBox[{"Sqrt", "[", "k2", "]"}], "]"}]}], ",", 
     RowBox[{"ArcSin", "[", 
      RowBox[{"Sqrt", "[", "k2", "]"}], "]"}]}], "}"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.75122748439397*^9, 3.751227495434182*^9}, 
   3.751227552289785*^9, {3.751227586120652*^9, 3.751227601550589*^9}, {
   3.751227782523637*^9, 3.75122779100847*^9}, 3.7512278723858957`*^9},
 CellLabel->"In[45]:=",ExpressionUUID->"5f11abe9-621d-47e4-81cc-80ae96109836"],

Cell[BoxData[
 RowBox[{"ConditionalExpression", "[", 
  RowBox[{
   FractionBox[
    RowBox[{"2", " ", 
     RowBox[{"EllipticE", "[", 
      RowBox[{
       RowBox[{"ArcSin", "[", 
        SqrtBox["k2"], "]"}], ",", 
       FractionBox["1", "k2"]}], "]"}], " ", 
     SqrtBox[
      RowBox[{"Sin", "[", 
       RowBox[{"2", " ", 
        RowBox[{"ArcSin", "[", 
         SqrtBox["k2"], "]"}]}], "]"}]]}], 
    SqrtBox[
     FractionBox[
      RowBox[{"Sin", "[", 
       RowBox[{"2", " ", 
        RowBox[{"ArcSin", "[", 
         SqrtBox["k2"], "]"}]}], "]"}], "k2"]]], ",", 
   RowBox[{
    RowBox[{
     RowBox[{"C", "[", "1", "]"}], "\[Element]", 
     TemplateBox[{},
      "Integers"]}], "&&", 
    RowBox[{
     RowBox[{"ArcSin", "[", 
      SqrtBox["k2"], "]"}], "\[GreaterEqual]", 
     RowBox[{"2", " ", "\[Pi]", " ", 
      RowBox[{"C", "[", "1", "]"}]}]}], "&&", 
    RowBox[{
     RowBox[{"C", "[", "1", "]"}], "\[GreaterEqual]", "0"}], "&&", 
    RowBox[{
     RowBox[{"Re", "[", "k2", "]"}], "\[GreaterEqual]", "0"}]}]}], 
  "]"}]], "Output",
 CellChangeTimes->{{3.751227593699391*^9, 3.751227601938998*^9}, 
   3.751227833965958*^9, 3.751227950749456*^9},
 CellLabel->"Out[45]=",ExpressionUUID->"805d1c64-4d93-4614-892c-a608ad6113df"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"FullSimplify", "[", "%", "]"}]], "Input",
 CellChangeTimes->{{3.751227605853877*^9, 3.751227609318161*^9}},
 CellLabel->"In[43]:=",ExpressionUUID->"211d8a2b-11a5-4f8e-a888-b01cb123eead"],

Cell[BoxData[
 RowBox[{
  FractionBox["1", "2"], " ", 
  RowBox[{"(", 
   RowBox[{
    RowBox[{"-", "kappa"}], "+", 
    RowBox[{"2", " ", "k2", " ", "kappa"}], "+", 
    RowBox[{"Sin", "[", "kappa", "]"}]}], ")"}]}]], "Output",
 CellChangeTimes->{3.751227609566804*^9},
 CellLabel->"Out[43]=",ExpressionUUID->"1b3e836f-676b-4a30-bd87-defd4345f555"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Integrate", "[", 
  RowBox[{
   RowBox[{"Sqrt", "[", 
    RowBox[{
     RowBox[{"(", 
      RowBox[{
       RowBox[{"1", "/", "w"}], "-", "1"}], ")"}], "/", 
     RowBox[{"(", 
      RowBox[{"1", "-", 
       RowBox[{"k2", "*", "w"}]}], ")"}]}], "]"}], ",", 
   RowBox[{"{", 
    RowBox[{"w", ",", "0", ",", "1"}], "}"}], ",", 
   RowBox[{"Assumptions", "\[Rule]", " ", 
    RowBox[{"k2", " ", "<", " ", "1"}]}]}], "]"}]], "Input",
 CellChangeTimes->{{3.751228106469242*^9, 3.751228154836397*^9}, {
  3.751228222308008*^9, 3.751228228090068*^9}, {3.7512283800633917`*^9, 
  3.751228395076545*^9}, {3.751229381622581*^9, 3.751229386803515*^9}},
 CellLabel->"In[50]:=",ExpressionUUID->"9cb52016-44d2-4047-b37a-1083d32825a2"],

Cell[BoxData[
 FractionBox[
  RowBox[{"2", " ", 
   SqrtBox[
    RowBox[{"1", "-", "k2"}]], " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"EllipticE", "[", 
      FractionBox["k2", 
       RowBox[{
        RowBox[{"-", "1"}], "+", "k2"}]], "]"}], "-", 
     RowBox[{"EllipticK", "[", 
      FractionBox["k2", 
       RowBox[{
        RowBox[{"-", "1"}], "+", "k2"}]], "]"}]}], ")"}]}], "k2"]], "Output",
 CellChangeTimes->{3.751228200526311*^9, 3.751228231470798*^9, 
  3.7512283967933493`*^9, 3.751229389356564*^9},
 CellLabel->"Out[50]=",ExpressionUUID->"9c8d17a1-4fbf-4b01-9395-535e46c583ea"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Integrate", "[", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"Sqrt", "[", 
       RowBox[{"1", "-", "w"}], "]"}], "^", "3"}], "/", 
     RowBox[{"Sqrt", "[", "w", "]"}]}], "/", 
    RowBox[{"Sqrt", "[", 
     RowBox[{"1", "-", 
      RowBox[{"k2", "*", "w"}]}], "]"}]}], ",", 
   RowBox[{"{", 
    RowBox[{"w", ",", "0", ",", "1"}], "}"}], ",", 
   RowBox[{"Assumptions", "\[Rule]", " ", 
    RowBox[{"k2", " ", "<", " ", "1"}]}]}], "]"}]], "Input",
 CellChangeTimes->{{3.751228315056594*^9, 3.7512283179350023`*^9}},
 CellLabel->"In[48]:=",ExpressionUUID->"f92a6bdc-b1d6-4c91-adcf-9f0b99402a57"],

Cell[BoxData[
 FractionBox[
  RowBox[{"2", " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "2"}], "+", 
        RowBox[{"4", " ", "k2"}]}], ")"}], " ", 
      RowBox[{"EllipticE", "[", "k2", "]"}]}], "+", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "1"}], "+", "k2"}], ")"}], " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "2"}], "+", 
        RowBox[{"3", " ", "k2"}]}], ")"}], " ", 
      RowBox[{"EllipticK", "[", "k2", "]"}]}]}], ")"}]}], 
  RowBox[{"3", " ", 
   SuperscriptBox["k2", "2"]}]]], "Output",
 CellChangeTimes->{3.7512283232285967`*^9},
 CellLabel->"Out[48]=",ExpressionUUID->"19a27bf5-0fd4-4b49-9937-1263519ed36c"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"-", "k2"}], "/", 
   RowBox[{"(", 
    RowBox[{"k2", "-", "1"}], ")"}]}], "/", 
  RowBox[{"(", 
   RowBox[{"1", "-", 
    RowBox[{"k2", "/", 
     RowBox[{"(", 
      RowBox[{"k2", "-", "1"}], ")"}]}]}], ")"}]}]], "Input",
 CellChangeTimes->{{3.751229624346651*^9, 3.751229636858808*^9}, {
  3.751229681948702*^9, 3.75122968450518*^9}},
 CellLabel->"In[53]:=",ExpressionUUID->"b0c40552-7669-4ac2-b1a0-a91180e63e2d"],

Cell[BoxData[
 RowBox[{"-", 
  FractionBox["k2", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      RowBox[{"-", "1"}], "+", "k2"}], ")"}], " ", 
    RowBox[{"(", 
     RowBox[{"1", "-", 
      FractionBox["k2", 
       RowBox[{
        RowBox[{"-", "1"}], "+", "k2"}]]}], ")"}]}]]}]], "Output",
 CellChangeTimes->{3.751229637297969*^9, 3.751229685446516*^9},
 CellLabel->"Out[53]=",ExpressionUUID->"54709761-35c9-4db8-9c13-00be45e437f0"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"FullSimplify", "[", "%", "]"}]], "Input",
 CellChangeTimes->{{3.751229638617433*^9, 3.751229641140082*^9}},
 CellLabel->"In[54]:=",ExpressionUUID->"5b93d288-724f-4889-8ad5-02486c257af3"],

Cell[BoxData["k2"], "Output",
 CellChangeTimes->{3.751229641883027*^9, 3.751229687382821*^9},
 CellLabel->"Out[54]=",ExpressionUUID->"c5656cbe-5cb3-489f-907b-c5ff2fc4b31f"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"1", "-", 
  RowBox[{"k2", "/", 
   RowBox[{"(", 
    RowBox[{"k2", "-", "1"}], ")"}]}]}]], "Input",
 CellChangeTimes->{{3.7512298444985313`*^9, 3.751229848891726*^9}},
 CellLabel->"In[55]:=",ExpressionUUID->"7fe22473-9d28-41e4-9946-2890d5d18f8c"],

Cell[BoxData[
 RowBox[{"1", "-", 
  FractionBox["k2", 
   RowBox[{
    RowBox[{"-", "1"}], "+", "k2"}]]}]], "Output",
 CellChangeTimes->{3.751229849975679*^9},
 CellLabel->"Out[55]=",ExpressionUUID->"6954c322-c0ce-4977-bfe7-a816ed1d4733"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"FullSimplify", "[", "%", "]"}]], "Input",
 CellChangeTimes->{{3.751229850713502*^9, 3.751229852973012*^9}},
 CellLabel->"In[56]:=",ExpressionUUID->"757e6c69-66f1-4053-83fe-cefd9e436276"],

Cell[BoxData[
 FractionBox["1", 
  RowBox[{"1", "-", "k2"}]]], "Output",
 CellChangeTimes->{3.751229853217885*^9},
 CellLabel->"Out[56]=",ExpressionUUID->"22cf120b-39bc-4f90-91f0-f561204100a5"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"EllipticE", "[", "0", "]"}]], "Input",
 CellChangeTimes->{{3.751230017348926*^9, 3.751230020983377*^9}},
 CellLabel->"In[57]:=",ExpressionUUID->"0ac89e92-e4c8-45fe-a3ab-617e03500fdf"],

Cell[BoxData[
 FractionBox["\[Pi]", "2"]], "Output",
 CellChangeTimes->{3.751230021703395*^9},
 CellLabel->"Out[57]=",ExpressionUUID->"accf04d7-c2ad-46d3-b33a-a1374c14f18e"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"EllipticE", "[", "1", "]"}]], "Input",
 CellChangeTimes->{{3.751230022579954*^9, 3.751230026503284*^9}},
 CellLabel->"In[58]:=",ExpressionUUID->"bb7eeea9-ad8b-4d66-b29e-ee7bfed1ef91"],

Cell[BoxData["1"], "Output",
 CellChangeTimes->{3.751230027087105*^9},
 CellLabel->"Out[58]=",ExpressionUUID->"555a4c3d-b1d2-4f80-933e-2fe2d86a2ebf"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"EllipticE", "[", "0.5", "]"}]], "Input",
 CellChangeTimes->{{3.751230028083643*^9, 3.751230031005427*^9}},
 CellLabel->"In[59]:=",ExpressionUUID->"c915257e-f591-4cba-8a28-2f4f2e64b3d3"],

Cell[BoxData["1.350643881047675`"], "Output",
 CellChangeTimes->{3.751230031621662*^9},
 CellLabel->"Out[59]=",ExpressionUUID->"c9a66888-0b73-463f-b98a-8fee6a4d52f2"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"EllipticE", "[", 
  RowBox[{"0.5", "/", 
   RowBox[{"(", 
    RowBox[{"0.5", "-", "1"}], ")"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.751230032499667*^9, 3.751230042429164*^9}},
 CellLabel->"In[60]:=",ExpressionUUID->"da571f9f-9e8a-4102-aede-feed991eeeaf"],

Cell[BoxData["1.9100988945138555`"], "Output",
 CellChangeTimes->{3.751230043223822*^9},
 CellLabel->"Out[60]=",ExpressionUUID->"aea10f1f-724d-471a-abb1-92b18174f86f"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"EllipticE", "[", "0.5", "]"}], "/", 
  RowBox[{"Sqrt", "[", 
   RowBox[{"1", "-", "0.5"}], "]"}]}]], "Input",
 CellChangeTimes->{{3.751230050611051*^9, 3.7512300855957127`*^9}, {
  3.7512304685699987`*^9, 3.75123049314219*^9}, {3.751230671962996*^9, 
  3.75123067628802*^9}, {3.751230972382092*^9, 3.751230987245702*^9}, {
  3.751244839708954*^9, 3.7512448476523943`*^9}, {3.7512448979794903`*^9, 
  3.751244898281405*^9}},
 CellLabel->"In[70]:=",ExpressionUUID->"9b672994-4cc2-429f-bb43-0ac33445d8fb"],

Cell[BoxData["1.9100988945138553`"], "Output",
 CellChangeTimes->{{3.7512300661244593`*^9, 3.751230086018261*^9}, {
   3.751230477601356*^9, 3.751230493435268*^9}, 3.751230672517851*^9, {
   3.751230973018424*^9, 3.751230984660206*^9}, 3.751244848037775*^9, 
   3.7512448990553923`*^9},
 CellLabel->"Out[70]=",ExpressionUUID->"5bab5f0d-f5ed-40c9-bda0-7e2e6b3582d7"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"EllipticK", "[", 
  RowBox[{"0.5", "/", 
   RowBox[{"(", 
    RowBox[{"0.5", "-", "1"}], ")"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.751244940337008*^9, 3.751244945577898*^9}},
 CellLabel->"In[71]:=",ExpressionUUID->"1494d482-4304-46b4-8606-da27bf2b062e"],

Cell[BoxData["1.3110287771460598`"], "Output",
 CellChangeTimes->{3.751244945888753*^9},
 CellLabel->"Out[71]=",ExpressionUUID->"c1a310a9-946e-49ca-a012-272c266e9d9c"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"EllipticK", "[", "0.5", "]"}], "*", 
  RowBox[{"Sqrt", "[", 
   RowBox[{"1", "-", "0.5"}], "]"}]}]], "Input",
 CellChangeTimes->{{3.7512449464958057`*^9, 3.751244953929535*^9}},
 CellLabel->"In[72]:=",ExpressionUUID->"6fef9437-b2c7-4452-92a2-2cc2e9f21dbf"],

Cell[BoxData["1.3110287771460598`"], "Output",
 CellChangeTimes->{3.7512449542905607`*^9},
 CellLabel->"Out[72]=",ExpressionUUID->"26889454-6964-48e2-8228-2913f2050c1d"]
}, Open  ]],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{
   RowBox[{
    RowBox[{"Now", " ", "for", " ", 
     RowBox[{"k", "^", "2"}]}], " ", ">", " ", "1"}], ",", " ", 
   RowBox[{"compute", " ", "first", " ", "few", " ", "M_m", " ", 
    RowBox[{"values", ":"}]}]}], " ", "*)"}]], "Input",
 CellChangeTimes->{{3.751245092098941*^9, 3.751245104587635*^9}},
 CellLabel->"In[73]:=",ExpressionUUID->"7c47cd91-c779-491a-b23a-c1f40b9826e3"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Integrate", "[", 
  RowBox[{
   RowBox[{"Sqrt", "[", 
    RowBox[{
     RowBox[{"(", 
      RowBox[{
       RowBox[{"1", "/", "w"}], "-", 
       RowBox[{"1", "/", "k2"}]}], ")"}], "/", 
     RowBox[{"(", 
      RowBox[{"1", "-", "w"}], ")"}]}], "]"}], ",", 
   RowBox[{"{", 
    RowBox[{"w", ",", "0", ",", "1"}], "}"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.751245106353664*^9, 3.751245127570932*^9}, {
   3.7512451778283367`*^9, 3.751245194376758*^9}, {3.751245224682776*^9, 
   3.751245228447668*^9}, {3.7512453130063343`*^9, 3.751245317844884*^9}, {
   3.7512453608535433`*^9, 3.751245380578776*^9}, 3.7512454380191708`*^9},
 CellLabel->"In[79]:=",ExpressionUUID->"eb4c984f-ef1b-4d45-814d-4f15ad604e81"],

Cell[BoxData[
 RowBox[{
  SubsuperscriptBox["\[Integral]", "0", "1"], 
  RowBox[{
   SqrtBox[
    FractionBox[
     RowBox[{
      RowBox[{"-", 
       FractionBox["1", "k2"]}], "+", 
      FractionBox["1", "w"]}], 
     RowBox[{"1", "-", "w"}]]], 
   RowBox[{"\[DifferentialD]", "w"}]}]}]], "Output",
 CellChangeTimes->{3.751245174875465*^9, 3.7512452235776777`*^9, 
  3.751245288522221*^9, 3.751245358980863*^9, 3.751245428815176*^9, 
  3.7512455664822702`*^9},
 CellLabel->"Out[79]=",ExpressionUUID->"5b5ae6ce-36fd-4519-8241-d4c5366b7e5f"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Integrate", "[", 
  RowBox[{
   RowBox[{"Sqrt", "[", 
    RowBox[{"1", "-", 
     RowBox[{"k2inv", "*", 
      RowBox[{
       RowBox[{"Sin", "[", "x", "]"}], "^", "2"}]}]}], "]"}], ",", 
   RowBox[{"{", 
    RowBox[{"x", ",", "0", ",", 
     RowBox[{"Pi", "/", "2"}]}], "}"}], ",", " ", 
   RowBox[{"Assumptions", "\[Rule]", " ", 
    RowBox[{"k2inv", " ", "<", " ", "1"}]}]}], "]"}]], "Input",
 CellChangeTimes->{{3.7512463478889313`*^9, 3.751246372457451*^9}, {
  3.751248581778583*^9, 3.7512486012227907`*^9}},
 CellLabel->
  "In[116]:=",ExpressionUUID->"4e1e62db-d79d-4cdd-b1e8-086170c9bdf8"],

Cell[BoxData[
 RowBox[{"EllipticE", "[", "k2inv", "]"}]], "Output",
 CellChangeTimes->{3.75124860286275*^9},
 CellLabel->
  "Out[116]=",ExpressionUUID->"94fc4946-b53c-46c9-b893-0f54534bbb93"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Integrate", "[", 
  RowBox[{
   RowBox[{
    RowBox[{"Sqrt", "[", 
     RowBox[{"1", "-", 
      RowBox[{"k2inv", "*", 
       RowBox[{
        RowBox[{"Sin", "[", "x", "]"}], "^", "2"}]}]}], "]"}], "^", "3"}], 
   ",", 
   RowBox[{"{", 
    RowBox[{"x", ",", "0", ",", 
     RowBox[{"Pi", "/", "2"}]}], "}"}], ",", " ", 
   RowBox[{"Assumptions", "\[Rule]", " ", 
    RowBox[{"k2inv", " ", "<", " ", "1"}]}]}], "]"}]], "Input",
 CellChangeTimes->{{3.751248629999198*^9, 3.7512486370135183`*^9}, {
  3.751248716573255*^9, 3.751248804575923*^9}},
 CellLabel->
  "In[120]:=",ExpressionUUID->"14805dc1-0b22-47d8-a893-574fa71bbe6a"],

Cell[BoxData[
 RowBox[{
  RowBox[{"-", 
   FractionBox["1", "3"]}], " ", 
  SqrtBox[
   RowBox[{"1", "-", "k2inv"}]], " ", 
  RowBox[{"(", 
   RowBox[{
    RowBox[{"2", " ", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"-", "2"}], "+", "k2inv"}], ")"}], " ", 
     RowBox[{"EllipticE", "[", 
      FractionBox["k2inv", 
       RowBox[{
        RowBox[{"-", "1"}], "+", "k2inv"}]], "]"}]}], "+", 
    RowBox[{"EllipticK", "[", 
     FractionBox["k2inv", 
      RowBox[{
       RowBox[{"-", "1"}], "+", "k2inv"}]], "]"}]}], ")"}]}]], "Output",
 CellChangeTimes->{3.751248642289081*^9, 3.751248742511303*^9, 
  3.75124880240865*^9, 3.75124890652639*^9},
 CellLabel->
  "Out[120]=",ExpressionUUID->"3e5c88d8-8827-47c0-ba0e-dc72decc2915"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"(", 
   RowBox[{"1", "-", 
    RowBox[{
     RowBox[{"(", 
      RowBox[{"r", "-", "b"}], ")"}], "^", "2"}]}], ")"}], "-", 
  RowBox[{"2", "*", "b", "*", "r"}]}]], "Input",
 CellChangeTimes->{{3.751248920017877*^9, 3.751248930979536*^9}},
 CellLabel->
  "In[121]:=",ExpressionUUID->"3bd82367-e2c3-4d33-8259-a72109f271b0"],

Cell[BoxData[
 RowBox[{"1", "-", 
  RowBox[{"2", " ", "b", " ", "r"}], "-", 
  SuperscriptBox[
   RowBox[{"(", 
    RowBox[{
     RowBox[{"-", "b"}], "+", "r"}], ")"}], "2"]}]], "Output",
 CellChangeTimes->{3.751248931365757*^9},
 CellLabel->
  "Out[121]=",ExpressionUUID->"de6b5d93-0318-4ae5-8607-51987f23ff1f"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"FullSimplify", "[", "%", "]"}]], "Input",
 CellChangeTimes->{{3.751248932873438*^9, 3.751248935276617*^9}},
 CellLabel->
  "In[122]:=",ExpressionUUID->"d4f8546e-dbc0-45fc-8d4f-aa53c84f8e99"],

Cell[BoxData[
 RowBox[{"1", "-", 
  SuperscriptBox["b", "2"], "-", 
  SuperscriptBox["r", "2"]}]], "Output",
 CellChangeTimes->{3.751248935597361*^9},
 CellLabel->
  "Out[122]=",ExpressionUUID->"7d627ab2-f566-40de-a238-a0be083ccd48"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"SeriesCoefficient", "[", 
  RowBox[{
   RowBox[{
    SqrtBox["\[Pi]"], " ", 
    RowBox[{"Gamma", "[", 
     RowBox[{"1", "+", 
      FractionBox["m", "2"]}], "]"}], " ", 
    RowBox[{"Hypergeometric2F1Regularized", "[", 
     RowBox[{
      FractionBox["1", "2"], ",", 
      FractionBox["1", "2"], ",", 
      FractionBox[
       RowBox[{"3", "+", "m"}], "2"], ",", "k2"}], "]"}]}], ",", 
   RowBox[{"{", 
    RowBox[{"k2", ",", "0", ",", "n"}], "}"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.751321164840823*^9, 3.7513211725945673`*^9}, {
  3.751321226432588*^9, 3.75132123928769*^9}, {3.751321664472476*^9, 
  3.751321681779126*^9}},
 CellLabel->
  "In[126]:=",ExpressionUUID->"08b24587-dc98-4c6a-bee0-b7e1ba15635d"],

Cell[BoxData[
 TagBox[GridBox[{
    {"\[Piecewise]", GridBox[{
       {
        FractionBox[
         RowBox[{
          RowBox[{"Gamma", "[", 
           RowBox[{"1", "+", 
            FractionBox["m", "2"]}], "]"}], " ", 
          SuperscriptBox[
           RowBox[{"Gamma", "[", 
            RowBox[{
             FractionBox["1", "2"], "+", "n"}], "]"}], "2"]}], 
         RowBox[{
          SqrtBox["\[Pi]"], " ", 
          RowBox[{"Gamma", "[", 
           RowBox[{"1", "+", "n"}], "]"}], " ", 
          RowBox[{"Gamma", "[", 
           RowBox[{
            FractionBox["3", "2"], "+", 
            FractionBox["m", "2"], "+", "n"}], "]"}]}]], 
        RowBox[{"n", "\[GreaterEqual]", "0"}]},
       {"0", 
        TagBox["True",
         "PiecewiseDefault",
         AutoDelete->True]}
      },
      AllowedDimensions->{2, Automatic},
      Editable->True,
      GridBoxAlignment->{
       "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
        "RowsIndexed" -> {}},
      GridBoxItemSize->{
       "Columns" -> {{Automatic}}, "ColumnsIndexed" -> {}, "Rows" -> {{1.}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.84]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}},
      Selectable->True]}
   },
   GridBoxAlignment->{
    "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
     "RowsIndexed" -> {}},
   GridBoxItemSize->{
    "Columns" -> {{Automatic}}, "ColumnsIndexed" -> {}, "Rows" -> {{1.}}, 
     "RowsIndexed" -> {}},
   GridBoxSpacings->{"Columns" -> {
       Offset[0.27999999999999997`], {
        Offset[0.35]}, 
       Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
       Offset[0.2], {
        Offset[0.4]}, 
       Offset[0.2]}, "RowsIndexed" -> {}}],
  "Piecewise",
  DeleteWithContents->True,
  Editable->False,
  SelectWithContents->True,
  Selectable->False]], "Output",
 CellChangeTimes->{3.7513216824664783`*^9},
 CellLabel->
  "Out[126]=",ExpressionUUID->"3c9acae0-c3c1-4a76-aa4e-e781d08523fe"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Series", "[", 
  RowBox[{
   RowBox[{
    SqrtBox["\[Pi]"], " ", 
    RowBox[{"Gamma", "[", 
     RowBox[{"1", "+", 
      FractionBox["m", "2"]}], "]"}], " ", 
    RowBox[{"Hypergeometric2F1Regularized", "[", 
     RowBox[{
      FractionBox["1", "2"], ",", 
      FractionBox["1", "2"], ",", 
      FractionBox[
       RowBox[{"3", "+", "m"}], "2"], ",", "k2"}], "]"}]}], ",", 
   RowBox[{"{", 
    RowBox[{"k2", ",", "0", ",", "3"}], "}"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.751321593355541*^9, 3.7513216041802273`*^9}, 
   3.75132169164734*^9},
 CellLabel->
  "In[127]:=",ExpressionUUID->"e11ee1ad-7321-45a5-8467-a07cc1fc424d"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
   FractionBox[
    RowBox[{
     SqrtBox["\[Pi]"], " ", 
     RowBox[{"Gamma", "[", 
      RowBox[{"1", "+", 
       FractionBox["m", "2"]}], "]"}]}], 
    RowBox[{"Gamma", "[", 
     FractionBox[
      RowBox[{"3", "+", "m"}], "2"], "]"}]], "+", 
   FractionBox[
    RowBox[{
     SqrtBox["\[Pi]"], " ", 
     RowBox[{"Gamma", "[", 
      RowBox[{"1", "+", 
       FractionBox["m", "2"]}], "]"}], " ", "k2"}], 
    RowBox[{"4", " ", 
     RowBox[{"Gamma", "[", 
      RowBox[{"1", "+", 
       FractionBox[
        RowBox[{"3", "+", "m"}], "2"]}], "]"}]}]], "+", 
   FractionBox[
    RowBox[{"9", " ", 
     SqrtBox["\[Pi]"], " ", 
     RowBox[{"Gamma", "[", 
      RowBox[{"1", "+", 
       FractionBox["m", "2"]}], "]"}], " ", 
     SuperscriptBox["k2", "2"]}], 
    RowBox[{"32", " ", 
     RowBox[{"Gamma", "[", 
      RowBox[{"2", "+", 
       FractionBox[
        RowBox[{"3", "+", "m"}], "2"]}], "]"}]}]], "+", 
   FractionBox[
    RowBox[{"75", " ", 
     SqrtBox["\[Pi]"], " ", 
     RowBox[{"Gamma", "[", 
      RowBox[{"1", "+", 
       FractionBox["m", "2"]}], "]"}], " ", 
     SuperscriptBox["k2", "3"]}], 
    RowBox[{"128", " ", 
     RowBox[{"Gamma", "[", 
      RowBox[{"3", "+", 
       FractionBox[
        RowBox[{"3", "+", "m"}], "2"]}], "]"}]}]], "+", 
   InterpretationBox[
    SuperscriptBox[
     RowBox[{"O", "[", "k2", "]"}], "4"],
    SeriesData[$CellContext`k2, 0, {}, 0, 4, 1],
    Editable->False]}],
  SeriesData[$CellContext`k2, 0, {
   Pi^Rational[1, 2] Gamma[1 + Rational[1, 2] $CellContext`m]/Gamma[
    Rational[1, 2] (3 + $CellContext`m)], Rational[1, 4] Pi^Rational[1, 2] 
    Gamma[1 + Rational[1, 2] $CellContext`m]/Gamma[
    1 + Rational[1, 2] (3 + $CellContext`m)], Rational[9, 32] 
    Pi^Rational[1, 2] Gamma[1 + Rational[1, 2] $CellContext`m]/Gamma[
    2 + Rational[1, 2] (3 + $CellContext`m)], Rational[75, 128] 
    Pi^Rational[1, 2] Gamma[1 + Rational[1, 2] $CellContext`m]/Gamma[
    3 + Rational[1, 2] (3 + $CellContext`m)]}, 0, 4, 1],
  Editable->False]], "Output",
 CellChangeTimes->{3.751321604502426*^9, 3.7513216924897757`*^9},
 CellLabel->
  "Out[127]=",ExpressionUUID->"a8907307-97b7-4ccc-9279-335ece45cdfb"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Integrate", "[", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"(", 
       RowBox[{"k2", "-", "w"}], ")"}], "^", 
      RowBox[{"(", 
       RowBox[{"m", "/", "2"}], ")"}]}], "/", 
     RowBox[{"Sqrt", "[", "w", "]"}]}], "/", 
    RowBox[{"Sqrt", "[", 
     RowBox[{"1", "-", "w"}], "]"}]}], ",", 
   RowBox[{"{", 
    RowBox[{"w", ",", "0", ",", "1"}], "}"}], ",", " ", 
   RowBox[{"Assumptions", "\[Rule]", " ", 
    RowBox[{"m", " ", "\[Epsilon]", " ", 
     TemplateBox[{},
      "Integers"]}]}]}], "]"}]], "Input",
 CellChangeTimes->{{3.751321798312643*^9, 3.751321836584734*^9}, 
   3.751321893689247*^9},
 CellLabel->
  "In[128]:=",ExpressionUUID->"87afa148-18d9-4348-baa7-af6a72b97428"],

Cell[BoxData[
 RowBox[{"ConditionalExpression", "[", 
  RowBox[{
   RowBox[{
    SuperscriptBox["k2", 
     RowBox[{"m", "/", "2"}]], " ", "\[Pi]", " ", 
    RowBox[{"Hypergeometric2F1", "[", 
     RowBox[{
      FractionBox["1", "2"], ",", 
      RowBox[{"-", 
       FractionBox["m", "2"]}], ",", "1", ",", 
      FractionBox["1", "k2"]}], "]"}]}], ",", 
   RowBox[{
    RowBox[{"Re", "[", "k2", "]"}], ">", "0"}]}], "]"}]], "Output",
 CellChangeTimes->{3.751321895979754*^9},
 CellLabel->
  "Out[128]=",ExpressionUUID->"a1f5db14-f64c-4170-bdb2-8171694f2695"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"SeriesCoefficient", "[", 
  RowBox[{
   RowBox[{"\[Pi]", " ", 
    RowBox[{"Hypergeometric2F1", "[", 
     RowBox[{
      FractionBox["1", "2"], ",", 
      RowBox[{"-", 
       FractionBox["m", "2"]}], ",", "1", ",", "k2inv"}], "]"}]}], ",", 
   RowBox[{"{", 
    RowBox[{"k2inv", ",", "0", ",", "n"}], "}"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.751321924108162*^9, 3.7513219674210367`*^9}},
 CellLabel->
  "In[130]:=",ExpressionUUID->"a5097cf1-a0a9-4d00-8763-2f8906fd21c2"],

Cell[BoxData[
 TagBox[GridBox[{
    {"\[Piecewise]", GridBox[{
       {
        FractionBox[
         RowBox[{
          SqrtBox["\[Pi]"], " ", 
          RowBox[{
           RowBox[{"(", 
            RowBox[{
             RowBox[{"-", 
              FractionBox["1", "2"]}], "+", "n"}], ")"}], "!"}], " ", 
          RowBox[{
           RowBox[{"(", 
            RowBox[{
             RowBox[{"-", "1"}], "-", 
             FractionBox["m", "2"], "+", "n"}], ")"}], "!"}]}], 
         RowBox[{
          RowBox[{
           RowBox[{"(", 
            RowBox[{
             RowBox[{"-", "1"}], "-", 
             FractionBox["m", "2"]}], ")"}], "!"}], " ", 
          SuperscriptBox[
           RowBox[{"(", 
            RowBox[{"n", "!"}], ")"}], "2"]}]], 
        RowBox[{"n", "\[GreaterEqual]", "0"}]},
       {"0", 
        TagBox["True",
         "PiecewiseDefault",
         AutoDelete->True]}
      },
      AllowedDimensions->{2, Automatic},
      Editable->True,
      GridBoxAlignment->{
       "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
        "RowsIndexed" -> {}},
      GridBoxItemSize->{
       "Columns" -> {{Automatic}}, "ColumnsIndexed" -> {}, "Rows" -> {{1.}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.84]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}},
      Selectable->True]}
   },
   GridBoxAlignment->{
    "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
     "RowsIndexed" -> {}},
   GridBoxItemSize->{
    "Columns" -> {{Automatic}}, "ColumnsIndexed" -> {}, "Rows" -> {{1.}}, 
     "RowsIndexed" -> {}},
   GridBoxSpacings->{"Columns" -> {
       Offset[0.27999999999999997`], {
        Offset[0.35]}, 
       Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
       Offset[0.2], {
        Offset[0.4]}, 
       Offset[0.2]}, "RowsIndexed" -> {}}],
  "Piecewise",
  DeleteWithContents->True,
  Editable->False,
  SelectWithContents->True,
  Selectable->False]], "Output",
 CellChangeTimes->{3.751321968192293*^9},
 CellLabel->
  "Out[130]=",ExpressionUUID->"0cdecb81-8059-41fa-bd89-164f4512c020"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Series", "[", 
  RowBox[{
   RowBox[{
    RowBox[{"\[Pi]", " ", 
     RowBox[{"Hypergeometric2F1", "[", 
      RowBox[{
       FractionBox["1", "2"], ",", 
       RowBox[{"-", 
        FractionBox["m", "2"]}], ",", "1", ",", "k2inv"}], "]"}]}], " ", "/.",
     " ", 
    RowBox[{"m", " ", "\[Rule]", " ", "8"}]}], ",", 
   RowBox[{"{", 
    RowBox[{"k2inv", ",", "0", ",", "20"}], "}"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.7513226134382153`*^9, 3.751322629142666*^9}},
 CellLabel->
  "In[140]:=",ExpressionUUID->"1245d683-ed41-4a7d-9ba0-a69413255a4d"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\[Pi]", "-", 
   RowBox[{"2", " ", "\[Pi]", " ", "k2inv"}], "+", 
   FractionBox[
    RowBox[{"9", " ", "\[Pi]", " ", 
     SuperscriptBox["k2inv", "2"]}], "4"], "-", 
   FractionBox[
    RowBox[{"5", " ", "\[Pi]", " ", 
     SuperscriptBox["k2inv", "3"]}], "4"], "+", 
   FractionBox[
    RowBox[{"35", " ", "\[Pi]", " ", 
     SuperscriptBox["k2inv", "4"]}], "128"], "+", 
   InterpretationBox[
    SuperscriptBox[
     RowBox[{"O", "[", "k2inv", "]"}], "21"],
    SeriesData[$CellContext`k2inv, 0, {}, 0, 21, 1],
    Editable->False]}],
  SeriesData[$CellContext`k2inv, 0, {
   Pi, (-2) Pi, Rational[9, 4] Pi, Rational[-5, 4] Pi, Rational[35, 128] Pi}, 
   0, 21, 1],
  Editable->False]], "Output",
 CellChangeTimes->{3.751322629609683*^9},
 CellLabel->
  "Out[140]=",ExpressionUUID->"9f2a4c9f-c18a-49af-a38b-879c5ca92643"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"(", 
   RowBox[{"-", "1"}], ")"}], "!"}]], "Input",
 CellChangeTimes->{{3.751325073365225*^9, 3.751325076085477*^9}},
 CellLabel->
  "In[141]:=",ExpressionUUID->"78d36074-6d5b-4b22-8ef1-872683c16be9"],

Cell[BoxData["ComplexInfinity"], "Output",
 CellChangeTimes->{3.751325076521551*^9},
 CellLabel->
  "Out[141]=",ExpressionUUID->"73d9afbd-a2fe-4e2c-8702-51887e2c1021"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"(", 
   RowBox[{"-", "2"}], ")"}], "!"}]], "Input",
 CellChangeTimes->{{3.751325078868186*^9, 3.751325080525874*^9}},
 CellLabel->
  "In[142]:=",ExpressionUUID->"e0f7b1e3-97c2-4dc4-8f4c-6afd32197b97"],

Cell[BoxData["ComplexInfinity"], "Output",
 CellChangeTimes->{3.75132508154877*^9},
 CellLabel->
  "Out[142]=",ExpressionUUID->"0de51c50-8812-464a-9907-4d429ea18500"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"(", 
   RowBox[{
    RowBox[{"-", "1"}], "/", "2"}], ")"}], "!"}]], "Input",
 CellChangeTimes->{{3.751325092874238*^9, 3.751325094219617*^9}},
 CellLabel->
  "In[143]:=",ExpressionUUID->"9877f167-1404-40e8-a8fd-0654f1c015d0"],

Cell[BoxData[
 SqrtBox["\[Pi]"]], "Output",
 CellChangeTimes->{3.751325094659115*^9},
 CellLabel->
  "Out[143]=",ExpressionUUID->"c52c163e-c188-4335-b75d-35b320645964"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"(", 
   RowBox[{
    RowBox[{"-", "3"}], "/", "2"}], ")"}], "!"}]], "Input",
 CellChangeTimes->{{3.7513250964663267`*^9, 3.751325100611189*^9}},
 CellLabel->
  "In[144]:=",ExpressionUUID->"4821d2b5-88b4-4db6-b59f-2ec250dfab22"],

Cell[BoxData[
 RowBox[{
  RowBox[{"-", "2"}], " ", 
  SqrtBox["\[Pi]"]}]], "Output",
 CellChangeTimes->{3.7513251010110292`*^9},
 CellLabel->
  "Out[144]=",ExpressionUUID->"3501ea7e-c624-4f47-aadc-e7709458d64c"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"(", 
   RowBox[{
    RowBox[{"-", "5"}], "/", "2"}], ")"}], "!"}]], "Input",
 CellChangeTimes->{{3.751325108700197*^9, 3.751325110093573*^9}},
 CellLabel->
  "In[145]:=",ExpressionUUID->"1759096d-f133-46d4-8632-3e9a01dcff79"],

Cell[BoxData[
 FractionBox[
  RowBox[{"4", " ", 
   SqrtBox["\[Pi]"]}], "3"]], "Output",
 CellChangeTimes->{3.751325110485024*^9},
 CellLabel->
  "Out[145]=",ExpressionUUID->"38a6b4e1-6080-4d83-99ff-445b1e8111bf"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Gamma", "[", 
    RowBox[{
     RowBox[{"m", "/", "2"}], "+", "1"}], "]"}], "/", 
   RowBox[{"Gamma", "[", 
    RowBox[{
     RowBox[{"m", "/", "2"}], "+", 
     RowBox[{"3", "/", "2"}]}], "]"}]}], " ", "/.", " ", 
  RowBox[{"m", " ", "\[Rule]", " ", "9"}]}]], "Input",
 CellChangeTimes->{{3.751325213089402*^9, 3.751325215491091*^9}, {
  3.751326325886533*^9, 3.751326371218802*^9}},
 CellLabel->
  "In[155]:=",ExpressionUUID->"c0e83b35-e2c0-4634-97f2-76a1b000f4bf"],

Cell[BoxData[
 FractionBox[
  RowBox[{"63", " ", 
   SqrtBox["\[Pi]"]}], "256"]], "Output",
 CellChangeTimes->{{3.7513263473752623`*^9, 3.751326371523513*^9}},
 CellLabel->
  "Out[155]=",ExpressionUUID->"672414e0-6d08-45f1-9bba-95b57388d5c9"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"(", 
    RowBox[{"1", "-", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{"b", "-", "r"}], ")"}], "^", "2"}]}], ")"}], "*", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{
      RowBox[{"(", 
       RowBox[{"b", "+", "r"}], ")"}], "^", "2"}], "-", "1"}], ")"}]}], "+", 
  RowBox[{
   RowBox[{"(", 
    RowBox[{"1", "+", 
     RowBox[{"r", "^", "2"}], "-", 
     RowBox[{"b", "^", "2"}]}], ")"}], "^", "2"}]}]], "Input",
 CellChangeTimes->{{3.751338857600638*^9, 3.7513388717145*^9}},
 CellLabel->
  "In[156]:=",ExpressionUUID->"a093d94d-45f0-4fb7-83b2-773f6c005b2b"],

Cell[BoxData[
 RowBox[{
  SuperscriptBox[
   RowBox[{"(", 
    RowBox[{"1", "-", 
     SuperscriptBox["b", "2"], "+", 
     SuperscriptBox["r", "2"]}], ")"}], "2"], "+", 
  RowBox[{
   RowBox[{"(", 
    RowBox[{"1", "-", 
     SuperscriptBox[
      RowBox[{"(", 
       RowBox[{"b", "-", "r"}], ")"}], "2"]}], ")"}], " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"-", "1"}], "+", 
     SuperscriptBox[
      RowBox[{"(", 
       RowBox[{"b", "+", "r"}], ")"}], "2"]}], ")"}]}]}]], "Output",
 CellChangeTimes->{3.751338872166955*^9},
 CellLabel->
  "Out[156]=",ExpressionUUID->"01a847ff-cce0-47c2-a022-914b1621d229"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"ExpandAll", "[", "%", "]"}]], "Input",
 CellChangeTimes->{{3.751338873857692*^9, 3.7513388788524437`*^9}},
 CellLabel->
  "In[157]:=",ExpressionUUID->"2dada989-38f1-44d7-ad33-cb54854edf46"],

Cell[BoxData[
 RowBox[{"4", " ", 
  SuperscriptBox["r", "2"]}]], "Output",
 CellChangeTimes->{3.75133887911593*^9},
 CellLabel->
  "Out[157]=",ExpressionUUID->"3c547ac3-3484-4307-bcbc-0e9af52890c9"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"(", 
    RowBox[{"1", "+", 
     RowBox[{"r", "^", "2"}], "-", 
     RowBox[{"b", "^", "2"}]}], ")"}], "*", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"r", "^", "2"}], "-", 
     RowBox[{"b", "^", "2"}], "-", "1"}], ")"}]}], "-", 
  RowBox[{
   RowBox[{"(", 
    RowBox[{"1", "-", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{"b", "-", "r"}], ")"}], "^", "2"}]}], ")"}], "*", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{
      RowBox[{"(", 
       RowBox[{"b", "+", "r"}], ")"}], "^", "2"}], "-", "1"}], 
    ")"}]}]}]], "Input",
 CellChangeTimes->{{3.75133961948742*^9, 3.7513396388955097`*^9}},
 CellLabel->
  "In[158]:=",ExpressionUUID->"777ad547-615e-4c91-9418-0c377d5e6183"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"(", 
    RowBox[{
     RowBox[{"-", "1"}], "-", 
     SuperscriptBox["b", "2"], "+", 
     SuperscriptBox["r", "2"]}], ")"}], " ", 
   RowBox[{"(", 
    RowBox[{"1", "-", 
     SuperscriptBox["b", "2"], "+", 
     SuperscriptBox["r", "2"]}], ")"}]}], "-", 
  RowBox[{
   RowBox[{"(", 
    RowBox[{"1", "-", 
     SuperscriptBox[
      RowBox[{"(", 
       RowBox[{"b", "-", "r"}], ")"}], "2"]}], ")"}], " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"-", "1"}], "+", 
     SuperscriptBox[
      RowBox[{"(", 
       RowBox[{"b", "+", "r"}], ")"}], "2"]}], ")"}]}]}]], "Output",
 CellChangeTimes->{3.751339639446599*^9},
 CellLabel->
  "Out[158]=",ExpressionUUID->"1c9db31f-fa32-43a9-92c4-13ac183a7f65"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"ExpandAll", "[", "%", "]"}]], "Input",
 CellChangeTimes->{{3.751339640181683*^9, 3.7513396451766768`*^9}},
 CellLabel->
  "In[159]:=",ExpressionUUID->"19c82e6b-ca62-43d6-8c2e-ab054dee36f3"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"-", "2"}], " ", 
   SuperscriptBox["b", "2"]}], "+", 
  RowBox[{"2", " ", 
   SuperscriptBox["b", "4"]}], "-", 
  RowBox[{"2", " ", 
   SuperscriptBox["r", "2"]}], "-", 
  RowBox[{"4", " ", 
   SuperscriptBox["b", "2"], " ", 
   SuperscriptBox["r", "2"]}], "+", 
  RowBox[{"2", " ", 
   SuperscriptBox["r", "4"]}]}]], "Output",
 CellChangeTimes->{3.75133964549551*^9},
 CellLabel->
  "Out[159]=",ExpressionUUID->"aefe3d28-4d3b-4e9c-9574-b00068b57a17"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"FullSimplify", "[", "%", "]"}]], "Input",
 CellChangeTimes->{{3.751339646989653*^9, 3.75133964849647*^9}},
 CellLabel->
  "In[160]:=",ExpressionUUID->"73dd69bf-d816-4677-ac90-7a7cff89a98a"],

Cell[BoxData[
 RowBox[{"2", " ", 
  RowBox[{"(", 
   RowBox[{
    SuperscriptBox["b", "4"], "-", 
    SuperscriptBox["r", "2"], "+", 
    SuperscriptBox["r", "4"], "-", 
    RowBox[{
     SuperscriptBox["b", "2"], " ", 
     RowBox[{"(", 
      RowBox[{"1", "+", 
       RowBox[{"2", " ", 
        SuperscriptBox["r", "2"]}]}], ")"}]}]}], ")"}]}]], "Output",
 CellChangeTimes->{3.751339648826067*^9},
 CellLabel->
  "Out[160]=",ExpressionUUID->"68c92b77-3529-4401-bb80-66a3737db410"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Series", "[", 
  RowBox[{
   RowBox[{
    RowBox[{"\[Pi]", " ", 
     RowBox[{"Hypergeometric2F1", "[", 
      RowBox[{
       FractionBox["1", "2"], ",", 
       RowBox[{"-", 
        FractionBox["m", "2"]}], ",", "1", ",", "k2inv"}], "]"}]}], " ", "/.",
     " ", 
    RowBox[{"m", " ", "\[Rule]", " ", "32"}]}], ",", 
   RowBox[{"{", 
    RowBox[{"k2inv", ",", "0", ",", "20"}], "}"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.751397011049715*^9, 3.751397011321691*^9}},
 CellLabel->
  "In[161]:=",ExpressionUUID->"fab5a790-fb7b-4e32-9b74-2a5c65e5faab"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\[Pi]", "-", 
   RowBox[{"8", " ", "\[Pi]", " ", "k2inv"}], "+", 
   RowBox[{"45", " ", "\[Pi]", " ", 
    SuperscriptBox["k2inv", "2"]}], "-", 
   RowBox[{"175", " ", "\[Pi]", " ", 
    SuperscriptBox["k2inv", "3"]}], "+", 
   FractionBox[
    RowBox[{"15925", " ", "\[Pi]", " ", 
     SuperscriptBox["k2inv", "4"]}], "32"], "-", 
   FractionBox[
    RowBox[{"17199", " ", "\[Pi]", " ", 
     SuperscriptBox["k2inv", "5"]}], "16"], "+", 
   FractionBox[
    RowBox[{"231231", " ", "\[Pi]", " ", 
     SuperscriptBox["k2inv", "6"]}], "128"], "-", 
   FractionBox[
    RowBox[{"306735", " ", "\[Pi]", " ", 
     SuperscriptBox["k2inv", "7"]}], "128"], "+", 
   FractionBox[
    RowBox[{"41409225", " ", "\[Pi]", " ", 
     SuperscriptBox["k2inv", "8"]}], "16384"], "-", 
   FractionBox[
    RowBox[{"8690825", " ", "\[Pi]", " ", 
     SuperscriptBox["k2inv", "9"]}], "4096"], "+", 
   FractionBox[
    RowBox[{"46235189", " ", "\[Pi]", " ", 
     SuperscriptBox["k2inv", "10"]}], "32768"], "-", 
   FractionBox[
    RowBox[{"24072867", " ", "\[Pi]", " ", 
     SuperscriptBox["k2inv", "11"]}], "32768"], "+", 
   FractionBox[
    RowBox[{"307597745", " ", "\[Pi]", " ", 
     SuperscriptBox["k2inv", "12"]}], "1048576"], "-", 
   FractionBox[
    RowBox[{"45502625", " ", "\[Pi]", " ", 
     SuperscriptBox["k2inv", "13"]}], "524288"], "+", 
   FractionBox[
    RowBox[{"75218625", " ", "\[Pi]", " ", 
     SuperscriptBox["k2inv", "14"]}], "4194304"], "-", 
   FractionBox[
    RowBox[{"9694845", " ", "\[Pi]", " ", 
     SuperscriptBox["k2inv", "15"]}], "4194304"], "+", 
   FractionBox[
    RowBox[{"300540195", " ", "\[Pi]", " ", 
     SuperscriptBox["k2inv", "16"]}], "2147483648"], "+", 
   InterpretationBox[
    SuperscriptBox[
     RowBox[{"O", "[", "k2inv", "]"}], "21"],
    SeriesData[$CellContext`k2inv, 0, {}, 0, 21, 1],
    Editable->False]}],
  SeriesData[$CellContext`k2inv, 0, {
   Pi, (-8) Pi, 45 Pi, (-175) Pi, Rational[15925, 32] Pi, 
    Rational[-17199, 16] Pi, Rational[231231, 128] Pi, Rational[-306735, 128] 
    Pi, Rational[41409225, 16384] Pi, Rational[-8690825, 4096] Pi, 
    Rational[46235189, 32768] Pi, Rational[-24072867, 32768] Pi, 
    Rational[307597745, 1048576] Pi, Rational[-45502625, 524288] Pi, 
    Rational[75218625, 4194304] Pi, Rational[-9694845, 4194304] Pi, 
    Rational[300540195, 2147483648] Pi}, 0, 21, 1],
  Editable->False]], "Output",
 CellChangeTimes->{3.751397012035984*^9},
 CellLabel->
  "Out[161]=",ExpressionUUID->"a1b39259-5dba-417b-8733-e35e4d88c7e8"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"N", "[", "%", "]"}]], "Input",
 CellChangeTimes->{{3.751397017816678*^9, 3.751397018442271*^9}},
 CellLabel->
  "In[162]:=",ExpressionUUID->"6cc0c08e-4b20-472e-9ed5-34598d68a9d3"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"3.141592653589793`", "-", 
   RowBox[{"25.132741228718345`", " ", 
    RowBox[{"(", 
     RowBox[{"k2inv", "+", "0.`"}], ")"}]}], "+", 
   RowBox[{"141.3716694115407`", " ", 
    SuperscriptBox[
     RowBox[{"(", 
      RowBox[{"k2inv", "+", "0.`"}], ")"}], "2"]}], "-", 
   RowBox[{"549.7787143782137`", " ", 
    SuperscriptBox[
     RowBox[{"(", 
      RowBox[{"k2inv", "+", "0.`"}], ")"}], "3"]}], "+", 
   RowBox[{"1563.4332190130456`", " ", 
    SuperscriptBox[
     RowBox[{"(", 
      RowBox[{"k2inv", "+", "0.`"}], ")"}], "4"]}], "-", 
   RowBox[{"3377.015753068178`", " ", 
    SuperscriptBox[
     RowBox[{"(", 
      RowBox[{"k2inv", "+", "0.`"}], ")"}], "5"]}], "+", 
   RowBox[{"5675.262585017355`", " ", 
    SuperscriptBox[
     RowBox[{"(", 
      RowBox[{"k2inv", "+", "0.`"}], ")"}], "6"]}], "-", 
   RowBox[{"7528.409551553635`", " ", 
    SuperscriptBox[
     RowBox[{"(", 
      RowBox[{"k2inv", "+", "0.`"}], ")"}], "7"]}], "+", 
   RowBox[{"7940.119448904224`", " ", 
    SuperscriptBox[
     RowBox[{"(", 
      RowBox[{"k2inv", "+", "0.`"}], ")"}], "8"]}], "-", 
   RowBox[{"6665.779290438114`", " ", 
    SuperscriptBox[
     RowBox[{"(", 
      RowBox[{"k2inv", "+", "0.`"}], ")"}], "9"]}], "+", 
   RowBox[{"4432.743228141346`", " ", 
    SuperscriptBox[
     RowBox[{"(", 
      RowBox[{"k2inv", "+", "0.`"}], ")"}], "10"]}], "-", 
   RowBox[{"2307.957217957891`", " ", 
    SuperscriptBox[
     RowBox[{"(", 
      RowBox[{"k2inv", "+", "0.`"}], ")"}], "11"]}], "+", 
   RowBox[{"921.58013911513`", " ", 
    SuperscriptBox[
     RowBox[{"(", 
      RowBox[{"k2inv", "+", "0.`"}], ")"}], "12"]}], "-", 
   RowBox[{"272.6568458920503`", " ", 
    SuperscriptBox[
     RowBox[{"(", 
      RowBox[{"k2inv", "+", "0.`"}], ")"}], "13"]}], "+", 
   RowBox[{"56.33980744197978`", " ", 
    SuperscriptBox[
     RowBox[{"(", 
      RowBox[{"k2inv", "+", "0.`"}], ")"}], "14"]}], "-", 
   RowBox[{"7.261575181410727`", " ", 
    SuperscriptBox[
     RowBox[{"(", 
      RowBox[{"k2inv", "+", "0.`"}], ")"}], "15"]}], "+", 
   RowBox[{"0.4396656848119776`", " ", 
    SuperscriptBox[
     RowBox[{"(", 
      RowBox[{"k2inv", "+", "0.`"}], ")"}], "16"]}], "+", 
   InterpretationBox[
    SuperscriptBox[
     RowBox[{"O", "[", 
      RowBox[{"k2inv", "+", "0.`"}], "]"}], "21"],
    SeriesData[$CellContext`k2inv, 0., {}, 0, 21, 1],
    Editable->False]}],
  SeriesData[$CellContext`k2inv, 0., {3.141592653589793, -25.132741228718345`,
    141.3716694115407, -549.7787143782137, 
   1563.4332190130456`, -3377.015753068178, 
   5675.262585017355, -7528.409551553635, 
   7940.119448904224, -6665.779290438114, 
   4432.743228141346, -2307.957217957891, 921.58013911513, -272.6568458920503,
    56.33980744197978, -7.261575181410727, 0.4396656848119776}, 0, 21, 1],
  Editable->False]], "Output",
 CellChangeTimes->{3.751397018774878*^9},
 CellLabel->
  "Out[162]=",ExpressionUUID->"fb2778dc-8907-4205-9da3-fb972c5da316"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 FractionBox[
  RowBox[{
   SqrtBox["\[Pi]"], " ", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      RowBox[{"-", 
       FractionBox["1", "2"]}], "+", "n"}], ")"}], "!"}], " ", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      RowBox[{"-", "1"}], "-", 
      FractionBox["m", "2"], "+", "n"}], ")"}], "!"}]}], 
  RowBox[{
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      RowBox[{"-", "1"}], "-", 
      FractionBox["m", "2"]}], ")"}], "!"}], " ", 
   SuperscriptBox[
    RowBox[{"(", 
     RowBox[{"n", "!"}], ")"}], "2"]}]]], "Input",
 CellLabel->
  "In[163]:=",ExpressionUUID->"9fcc9154-b036-4489-861b-fc3731945656"],

Cell[BoxData[
 FractionBox[
  RowBox[{
   SqrtBox["\[Pi]"], " ", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      RowBox[{"-", 
       FractionBox["1", "2"]}], "+", "n"}], ")"}], "!"}], " ", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      RowBox[{"-", "1"}], "-", 
      FractionBox["m", "2"], "+", "n"}], ")"}], "!"}]}], 
  RowBox[{
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      RowBox[{"-", "1"}], "-", 
      FractionBox["m", "2"]}], ")"}], "!"}], " ", 
   SuperscriptBox[
    RowBox[{"(", 
     RowBox[{"n", "!"}], ")"}], "2"]}]]], "Output",
 CellChangeTimes->{3.751397177813122*^9},
 CellLabel->
  "Out[163]=",ExpressionUUID->"30a25940-b660-4467-a642-12149eb43174"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  FractionBox[
   RowBox[{
    SqrtBox["\[Pi]"], " ", 
    RowBox[{
     RowBox[{"(", 
      RowBox[{
       RowBox[{"-", 
        FractionBox["1", "2"]}], "+", "n"}], ")"}], "!"}], " ", 
    RowBox[{
     RowBox[{"(", 
      RowBox[{
       RowBox[{"-", "1"}], "-", 
       FractionBox["m", "2"], "+", "n"}], ")"}], "!"}]}], 
   RowBox[{
    RowBox[{
     RowBox[{"(", 
      RowBox[{
       RowBox[{"-", "1"}], "-", 
       FractionBox["m", "2"]}], ")"}], "!"}], " ", 
    SuperscriptBox[
     RowBox[{"(", 
      RowBox[{"n", "!"}], ")"}], "2"]}]], "/", 
  RowBox[{"(", 
   FractionBox[
    RowBox[{
     SqrtBox["\[Pi]"], " ", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", 
         FractionBox["1", "2"]}], "+", "n", "-", "1"}], ")"}], "!"}], " ", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "1"}], "-", 
        FractionBox["m", "2"], "+", "n", "-", "1"}], ")"}], "!"}]}], 
    RowBox[{
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "1"}], "-", 
        FractionBox["m", "2"]}], ")"}], "!"}], " ", 
     SuperscriptBox[
      RowBox[{"(", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{"n", "-", "1"}], ")"}], "!"}], ")"}], "2"]}]], 
   ")"}]}]], "Input",
 CellChangeTimes->{{3.751397190753911*^9, 3.751397208183923*^9}},
 CellLabel->
  "In[164]:=",ExpressionUUID->"83a7afcb-5224-482f-8d59-f019e167c6d7"],

Cell[BoxData[
 FractionBox[
  RowBox[{
   SuperscriptBox[
    RowBox[{"(", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "1"}], "+", "n"}], ")"}], "!"}], ")"}], "2"], " ", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      RowBox[{"-", 
       FractionBox["1", "2"]}], "+", "n"}], ")"}], "!"}], " ", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      RowBox[{"-", "1"}], "-", 
      FractionBox["m", "2"], "+", "n"}], ")"}], "!"}]}], 
  RowBox[{
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      RowBox[{"-", 
       FractionBox["3", "2"]}], "+", "n"}], ")"}], "!"}], " ", 
   SuperscriptBox[
    RowBox[{"(", 
     RowBox[{"n", "!"}], ")"}], "2"], " ", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      RowBox[{"-", "2"}], "-", 
      FractionBox["m", "2"], "+", "n"}], ")"}], "!"}]}]]], "Output",
 CellChangeTimes->{3.751397209623263*^9},
 CellLabel->
  "Out[164]=",ExpressionUUID->"7fcbf47c-ad18-4c9b-9330-b27da68bb6cf"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"FullSimplify", "[", "%", "]"}]], "Input",
 CellChangeTimes->{{3.751397211364224*^9, 3.751397213016934*^9}},
 CellLabel->
  "In[165]:=",ExpressionUUID->"6d6456ad-8dec-46e0-9233-d9ef14bda5fc"],

Cell[BoxData[
 RowBox[{"-", 
  FractionBox[
   RowBox[{
    RowBox[{"(", 
     RowBox[{"2", "+", "m", "-", 
      RowBox[{"2", " ", "n"}]}], ")"}], " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"-", "1"}], "+", 
      RowBox[{"2", " ", "n"}]}], ")"}]}], 
   RowBox[{"4", " ", 
    SuperscriptBox["n", "2"]}]]}]], "Output",
 CellChangeTimes->{3.7513972134348*^9},
 CellLabel->
  "Out[165]=",ExpressionUUID->"215544de-1008-46b6-b580-ed99b58a404b"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  FractionBox[
   RowBox[{
    RowBox[{"Gamma", "[", 
     RowBox[{"1", "+", 
      FractionBox["m", "2"]}], "]"}], " ", 
    SuperscriptBox[
     RowBox[{"Gamma", "[", 
      RowBox[{
       FractionBox["1", "2"], "+", "n"}], "]"}], "2"]}], 
   RowBox[{
    SqrtBox["\[Pi]"], " ", 
    RowBox[{"Gamma", "[", 
     RowBox[{"1", "+", "n"}], "]"}], " ", 
    RowBox[{"Gamma", "[", 
     RowBox[{
      FractionBox["3", "2"], "+", 
      FractionBox["m", "2"], "+", "n"}], "]"}]}]], "/", 
  RowBox[{"(", 
   FractionBox[
    RowBox[{
     RowBox[{"Gamma", "[", 
      RowBox[{"1", "+", 
       FractionBox["m", "2"]}], "]"}], " ", 
     SuperscriptBox[
      RowBox[{"Gamma", "[", 
       RowBox[{
        FractionBox["1", "2"], "+", "n", "-", "1"}], "]"}], "2"]}], 
    RowBox[{
     SqrtBox["\[Pi]"], " ", 
     RowBox[{"Gamma", "[", 
      RowBox[{"1", "+", "n", "-", "1"}], "]"}], " ", 
     RowBox[{"Gamma", "[", 
      RowBox[{
       FractionBox["3", "2"], "+", 
       FractionBox["m", "2"], "+", "n", "-", "1"}], "]"}]}]], 
   ")"}]}]], "Input",
 CellChangeTimes->{{3.751397484986013*^9, 3.751397493793545*^9}},
 CellLabel->
  "In[166]:=",ExpressionUUID->"1c98a040-3698-4e24-8659-174ffe71faac"],

Cell[BoxData[
 FractionBox[
  RowBox[{
   RowBox[{"Gamma", "[", "n", "]"}], " ", 
   SuperscriptBox[
    RowBox[{"Gamma", "[", 
     RowBox[{
      FractionBox["1", "2"], "+", "n"}], "]"}], "2"], " ", 
   RowBox[{"Gamma", "[", 
    RowBox[{
     FractionBox["1", "2"], "+", 
     FractionBox["m", "2"], "+", "n"}], "]"}]}], 
  RowBox[{
   SuperscriptBox[
    RowBox[{"Gamma", "[", 
     RowBox[{
      RowBox[{"-", 
       FractionBox["1", "2"]}], "+", "n"}], "]"}], "2"], " ", 
   RowBox[{"Gamma", "[", 
    RowBox[{"1", "+", "n"}], "]"}], " ", 
   RowBox[{"Gamma", "[", 
    RowBox[{
     FractionBox["3", "2"], "+", 
     FractionBox["m", "2"], "+", "n"}], "]"}]}]]], "Output",
 CellChangeTimes->{3.751397494487845*^9},
 CellLabel->
  "Out[166]=",ExpressionUUID->"33575818-dc38-437e-9f6d-8c8b79e8cd16"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"FullSimplify", "[", "%", "]"}]], "Input",
 CellChangeTimes->{{3.751397495108582*^9, 3.751397497928669*^9}},
 CellLabel->
  "In[167]:=",ExpressionUUID->"54a01fd9-8074-4f2e-ad6b-90905bce88c6"],

Cell[BoxData[
 FractionBox[
  SuperscriptBox[
   RowBox[{"(", 
    RowBox[{"1", "-", 
     RowBox[{"2", " ", "n"}]}], ")"}], "2"], 
  RowBox[{"2", " ", "n", " ", 
   RowBox[{"(", 
    RowBox[{"1", "+", "m", "+", 
     RowBox[{"2", " ", "n"}]}], ")"}]}]]], "Output",
 CellChangeTimes->{3.7513974982975407`*^9},
 CellLabel->
  "Out[167]=",ExpressionUUID->"b8a0c9f3-559f-4cfc-9797-8ea9752b9d90"]
}, Open  ]],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{"Look", " ", "at", " ", "derivative", " ", 
   RowBox[{"formulae", ":"}]}], " ", "*)"}]], "Input",
 CellChangeTimes->{{3.751404549085835*^9, 3.751404556708048*^9}},
 CellLabel->
  "In[168]:=",ExpressionUUID->"35879a62-e09f-49af-87d3-ac58f69a08bc"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"dpndr", " ", "=", " ", 
  RowBox[{
   RowBox[{"2", "*", "r", "*", "Mn"}], " ", "+", " ", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{"1", "+", 
      RowBox[{"r", "^", "2"}], "-", 
      RowBox[{"b", "^", "2"}]}], ")"}], "*", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{
       RowBox[{"n", "/", "2"}], "/", "r"}], "*", 
      RowBox[{"(", 
       RowBox[{"Mn", "+", 
        RowBox[{"Mnm2", "*", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"b", "^", "2"}], "-", "1", "-", 
           RowBox[{"r", "^", "2"}]}], ")"}]}]}], ")"}]}], ")"}]}], " ", "-", 
   " ", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"(", 
       RowBox[{"n", "+", "2"}], ")"}], "/", "2"}], "/", "r"}], "*", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"2", "*", 
         RowBox[{"(", 
          RowBox[{"1", "-", 
           RowBox[{"1", "/", 
            RowBox[{"(", 
             RowBox[{"n", "+", "2"}], ")"}]}]}], ")"}], "*", 
         RowBox[{"(", 
          RowBox[{"1", "-", 
           RowBox[{"r", "^", "2"}], "-", 
           RowBox[{"b", "^", "2"}]}], ")"}], "*", "Mn"}], "+", 
        RowBox[{
         RowBox[{"(", 
          RowBox[{"1", "-", 
           RowBox[{"2", "/", 
            RowBox[{"(", 
             RowBox[{"n", "+", "2"}], ")"}]}]}], ")"}], "*", 
         RowBox[{"(", 
          RowBox[{"1", "-", 
           RowBox[{
            RowBox[{"(", 
             RowBox[{"b", "-", "r"}], ")"}], "^", "2"}]}], ")"}], "*", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{
            RowBox[{"(", 
             RowBox[{"b", "+", "r"}], ")"}], "^", "2"}], "-", "1"}], ")"}], 
         "*", "Mnm2"}]}], ")"}], "+", 
      RowBox[{"Mn", "*", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"b", "^", "2"}], "-", "1", "-", 
         RowBox[{"r", "^", "2"}]}], ")"}]}]}], ")"}]}]}]}]], "Input",
 CellChangeTimes->{{3.7514045662666903`*^9, 3.751404657590786*^9}, {
  3.751404781404052*^9, 3.751404840471833*^9}},
 CellLabel->
  "In[173]:=",ExpressionUUID->"b145f133-ad06-485f-a15f-d57148d76816"],

Cell[BoxData[
 RowBox[{
  RowBox[{"2", " ", "Mn", " ", "r"}], "+", 
  FractionBox[
   RowBox[{"n", " ", 
    RowBox[{"(", 
     RowBox[{"1", "-", 
      SuperscriptBox["b", "2"], "+", 
      SuperscriptBox["r", "2"]}], ")"}], " ", 
    RowBox[{"(", 
     RowBox[{"Mn", "+", 
      RowBox[{"Mnm2", " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"-", "1"}], "+", 
         SuperscriptBox["b", "2"], "-", 
         SuperscriptBox["r", "2"]}], ")"}]}]}], ")"}]}], 
   RowBox[{"2", " ", "r"}]], "-", 
  FractionBox[
   RowBox[{
    RowBox[{"(", 
     RowBox[{"2", "+", "n"}], ")"}], " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"2", " ", "Mn", " ", 
       RowBox[{"(", 
        RowBox[{"1", "-", 
         FractionBox["1", 
          RowBox[{"2", "+", "n"}]]}], ")"}], " ", 
       RowBox[{"(", 
        RowBox[{"1", "-", 
         SuperscriptBox["b", "2"], "-", 
         SuperscriptBox["r", "2"]}], ")"}]}], "+", 
      RowBox[{"Mn", " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"-", "1"}], "+", 
         SuperscriptBox["b", "2"], "-", 
         SuperscriptBox["r", "2"]}], ")"}]}], "+", 
      RowBox[{"Mnm2", " ", 
       RowBox[{"(", 
        RowBox[{"1", "-", 
         FractionBox["2", 
          RowBox[{"2", "+", "n"}]]}], ")"}], " ", 
       RowBox[{"(", 
        RowBox[{"1", "-", 
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{"b", "-", "r"}], ")"}], "2"]}], ")"}], " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"-", "1"}], "+", 
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{"b", "+", "r"}], ")"}], "2"]}], ")"}]}]}], ")"}]}], 
   RowBox[{"2", " ", "r"}]]}]], "Output",
 CellChangeTimes->{3.7514046589546747`*^9, 3.75140484143642*^9},
 CellLabel->
  "Out[173]=",ExpressionUUID->"12f776bf-1c8c-41ca-8d18-046e93b564a0"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"FullSimplify", "[", "%", "]"}]], "Input",
 CellChangeTimes->{{3.7514046607001057`*^9, 3.751404662423074*^9}},
 CellLabel->
  "In[174]:=",ExpressionUUID->"574896b2-1f7c-4ec7-b513-1f9f61fcb096"],

Cell[BoxData[
 RowBox[{"2", " ", 
  RowBox[{"(", 
   RowBox[{
    RowBox[{
     RowBox[{"-", "Mnm2"}], " ", "n"}], "+", 
    RowBox[{"Mn", " ", 
     RowBox[{"(", 
      RowBox[{"2", "+", "n"}], ")"}]}]}], ")"}], " ", "r"}]], "Output",
 CellChangeTimes->{3.751404663465624*^9, 3.751404843820491*^9},
 CellLabel->
  "Out[174]=",ExpressionUUID->"805767dd-d4de-47dd-b1cb-34558b7356ab"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"dpndb", " ", "=", " ", 
  RowBox[{
   RowBox[{
    RowBox[{"-", "2"}], "*", "b", "*", "Mn"}], " ", "+", " ", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{"1", "+", 
      RowBox[{"r", "^", "2"}], "-", 
      RowBox[{"b", "^", "2"}]}], ")"}], "*", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{
       RowBox[{"n", "/", "2"}], "/", "b"}], "*", 
      RowBox[{"(", 
       RowBox[{"Mn", "+", 
        RowBox[{"Mnm2", "*", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"-", 
            RowBox[{"b", "^", "2"}]}], "-", "1", "+", 
           RowBox[{"r", "^", "2"}]}], ")"}]}]}], ")"}]}], ")"}]}], " ", "-", 
   " ", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"(", 
       RowBox[{"n", "+", "2"}], ")"}], "/", "2"}], "/", "b"}], "*", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"2", "*", 
         RowBox[{"(", 
          RowBox[{"1", "-", 
           RowBox[{"1", "/", 
            RowBox[{"(", 
             RowBox[{"n", "+", "2"}], ")"}]}]}], ")"}], "*", 
         RowBox[{"(", 
          RowBox[{"1", "-", 
           RowBox[{"r", "^", "2"}], "-", 
           RowBox[{"b", "^", "2"}]}], ")"}], "*", "Mn"}], "+", 
        RowBox[{
         RowBox[{"(", 
          RowBox[{"1", "-", 
           RowBox[{"2", "/", 
            RowBox[{"(", 
             RowBox[{"n", "+", "2"}], ")"}]}]}], ")"}], "*", 
         RowBox[{"(", 
          RowBox[{"1", "-", 
           RowBox[{
            RowBox[{"(", 
             RowBox[{"b", "-", "r"}], ")"}], "^", "2"}]}], ")"}], "*", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{
            RowBox[{"(", 
             RowBox[{"b", "+", "r"}], ")"}], "^", "2"}], "-", "1"}], ")"}], 
         "*", "Mnm2"}]}], ")"}], "+", 
      RowBox[{"Mn", "*", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"-", 
          RowBox[{"b", "^", "2"}]}], "-", "1", "+", 
         RowBox[{"r", "^", "2"}]}], ")"}]}]}], ")"}]}]}]}]], "Input",
 CellChangeTimes->{{3.751424726322105*^9, 3.751424803357923*^9}},
 CellLabel->
  "In[175]:=",ExpressionUUID->"78996889-9249-4f23-87a1-36b0e1336c1f"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"-", "2"}], " ", "b", " ", "Mn"}], "+", 
  FractionBox[
   RowBox[{"n", " ", 
    RowBox[{"(", 
     RowBox[{"1", "-", 
      SuperscriptBox["b", "2"], "+", 
      SuperscriptBox["r", "2"]}], ")"}], " ", 
    RowBox[{"(", 
     RowBox[{"Mn", "+", 
      RowBox[{"Mnm2", " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"-", "1"}], "-", 
         SuperscriptBox["b", "2"], "+", 
         SuperscriptBox["r", "2"]}], ")"}]}]}], ")"}]}], 
   RowBox[{"2", " ", "b"}]], "-", 
  FractionBox[
   RowBox[{
    RowBox[{"(", 
     RowBox[{"2", "+", "n"}], ")"}], " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"2", " ", "Mn", " ", 
       RowBox[{"(", 
        RowBox[{"1", "-", 
         FractionBox["1", 
          RowBox[{"2", "+", "n"}]]}], ")"}], " ", 
       RowBox[{"(", 
        RowBox[{"1", "-", 
         SuperscriptBox["b", "2"], "-", 
         SuperscriptBox["r", "2"]}], ")"}]}], "+", 
      RowBox[{"Mn", " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"-", "1"}], "-", 
         SuperscriptBox["b", "2"], "+", 
         SuperscriptBox["r", "2"]}], ")"}]}], "+", 
      RowBox[{"Mnm2", " ", 
       RowBox[{"(", 
        RowBox[{"1", "-", 
         FractionBox["2", 
          RowBox[{"2", "+", "n"}]]}], ")"}], " ", 
       RowBox[{"(", 
        RowBox[{"1", "-", 
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{"b", "-", "r"}], ")"}], "2"]}], ")"}], " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"-", "1"}], "+", 
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{"b", "+", "r"}], ")"}], "2"]}], ")"}]}]}], ")"}]}], 
   RowBox[{"2", " ", "b"}]]}]], "Output",
 CellChangeTimes->{3.751424821572803*^9},
 CellLabel->
  "Out[175]=",ExpressionUUID->"638e7e7b-361b-468e-9d4b-78eddf7a584a"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"FullSimplify", "[", "%", "]"}]], "Input",
 CellChangeTimes->{{3.751424823174337*^9, 3.75142482489745*^9}},
 CellLabel->
  "In[176]:=",ExpressionUUID->"85876291-4024-4b6c-8b04-d94be6a02a7b"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   SuperscriptBox["b", "3"], " ", "Mnm2", " ", "n"}], "+", 
  FractionBox[
   RowBox[{"n", " ", 
    SuperscriptBox["r", "2"], " ", 
    RowBox[{"(", 
     RowBox[{"Mn", "+", 
      RowBox[{"Mnm2", " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"-", "1"}], "+", 
         SuperscriptBox["r", "2"]}], ")"}]}]}], ")"}]}], "b"], "+", 
  RowBox[{"b", " ", "n", " ", 
   RowBox[{"(", 
    RowBox[{"Mn", "-", 
     RowBox[{"Mnm2", " ", 
      RowBox[{"(", 
       RowBox[{"1", "+", 
        RowBox[{"2", " ", 
         SuperscriptBox["r", "2"]}]}], ")"}]}]}], ")"}]}]}]], "Output",
 CellChangeTimes->{3.7514248252953367`*^9},
 CellLabel->
  "Out[176]=",ExpressionUUID->"a80247d7-bcbb-4a52-9fe5-ae89c6f6f0bf"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Together", "[", "%", "]"}]], "Input",
 CellChangeTimes->{{3.751424848031742*^9, 3.751424850897728*^9}},
 CellLabel->
  "In[177]:=",ExpressionUUID->"e6757c9a-0fc6-4d53-80e1-edf97142632d"],

Cell[BoxData[
 FractionBox[
  RowBox[{
   RowBox[{
    SuperscriptBox["b", "2"], " ", "Mn", " ", "n"}], "-", 
   RowBox[{
    SuperscriptBox["b", "2"], " ", "Mnm2", " ", "n"}], "+", 
   RowBox[{
    SuperscriptBox["b", "4"], " ", "Mnm2", " ", "n"}], "+", 
   RowBox[{"Mn", " ", "n", " ", 
    SuperscriptBox["r", "2"]}], "-", 
   RowBox[{"Mnm2", " ", "n", " ", 
    SuperscriptBox["r", "2"]}], "-", 
   RowBox[{"2", " ", 
    SuperscriptBox["b", "2"], " ", "Mnm2", " ", "n", " ", 
    SuperscriptBox["r", "2"]}], "+", 
   RowBox[{"Mnm2", " ", "n", " ", 
    SuperscriptBox["r", "4"]}]}], "b"]], "Output",
 CellChangeTimes->{3.751424851295762*^9},
 CellLabel->
  "Out[177]=",ExpressionUUID->"b4682108-2e12-497b-9ff9-a9aa9255fa2a"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Simplify", "[", "%", "]"}]], "Input",
 CellChangeTimes->{{3.751424854062996*^9, 3.751424855305378*^9}},
 CellLabel->
  "In[178]:=",ExpressionUUID->"fdccea86-710c-448f-8aa8-6265f48986ed"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   SuperscriptBox["b", "3"], " ", "Mnm2", " ", "n"}], "+", 
  FractionBox[
   RowBox[{"n", " ", 
    SuperscriptBox["r", "2"], " ", 
    RowBox[{"(", 
     RowBox[{"Mn", "+", 
      RowBox[{"Mnm2", " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"-", "1"}], "+", 
         SuperscriptBox["r", "2"]}], ")"}]}]}], ")"}]}], "b"], "+", 
  RowBox[{"b", " ", "n", " ", 
   RowBox[{"(", 
    RowBox[{"Mn", "-", 
     RowBox[{"Mnm2", " ", 
      RowBox[{"(", 
       RowBox[{"1", "+", 
        RowBox[{"2", " ", 
         SuperscriptBox["r", "2"]}]}], ")"}]}]}], ")"}]}]}]], "Output",
 CellChangeTimes->{3.751424855702703*^9},
 CellLabel->
  "Out[178]=",ExpressionUUID->"ed9e97e0-448b-4699-a962-185aa9cfd55b"]
}, Open  ]],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{
   RowBox[{
   "Carry", " ", "out", " ", "series", " ", "expansion", " ", "of", " ", 
    RowBox[{"dP", "/", "db"}], " ", "near", " ", "b"}], "=", "0"}], " ", 
  "*)"}]], "Input",
 CellChangeTimes->{{3.7515048435443077`*^9, 3.751504857328348*^9}},
 CellLabel->"In[1]:=",ExpressionUUID->"a5befca0-7da7-4202-aac6-4f2e47772775"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"k2", " ", "=", " ", 
  RowBox[{
   RowBox[{"(", 
    RowBox[{"1", "-", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{"r", "-", "b"}], ")"}], "^", "2"}]}], ")"}], "/", 
   RowBox[{"(", 
    RowBox[{"4", "*", "b", "*", "r"}], ")"}]}]}]], "Input",
 CellChangeTimes->{{3.7515048710467377`*^9, 3.751504894279253*^9}},
 CellLabel->"In[2]:=",ExpressionUUID->"16aeb155-6ef6-4502-ad11-ceb2880ab83b"],

Cell[BoxData[
 FractionBox[
  RowBox[{"1", "-", 
   SuperscriptBox[
    RowBox[{"(", 
     RowBox[{
      RowBox[{"-", "b"}], "+", "r"}], ")"}], "2"]}], 
  RowBox[{"4", " ", "b", " ", "r"}]]], "Output",
 CellChangeTimes->{3.751504894621859*^9},
 CellLabel->"Out[2]=",ExpressionUUID->"5e40d9bc-9aec-4716-8b9a-5ce1317903c0"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"kappa", "=", " ", 
  RowBox[{"2", "*", 
   RowBox[{"ArcSin", "[", 
    RowBox[{"Sqrt", "[", "k2", "]"}], "]"}]}]}]], "Input",
 CellChangeTimes->{{3.751504897044817*^9, 3.751504903719809*^9}},
 CellLabel->"In[3]:=",ExpressionUUID->"c97f43a6-9c0f-4c7b-a633-eea496aac009"],

Cell[BoxData[
 RowBox[{"2", " ", 
  RowBox[{"ArcSin", "[", 
   RowBox[{
    FractionBox["1", "2"], " ", 
    SqrtBox[
     FractionBox[
      RowBox[{"1", "-", 
       SuperscriptBox[
        RowBox[{"(", 
         RowBox[{
          RowBox[{"-", "b"}], "+", "r"}], ")"}], "2"]}], 
      RowBox[{"b", " ", "r"}]]]}], "]"}]}]], "Output",
 CellChangeTimes->{3.751504904465802*^9},
 CellLabel->"Out[3]=",ExpressionUUID->"1d88262a-b9a6-44b7-821a-7774c5a8d719"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"D", "[", " ", 
  RowBox[{
   RowBox[{
    RowBox[{"n", "/", "b"}], "*", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{
       RowBox[{"Integrate", "[", 
        RowBox[{
         RowBox[{
          RowBox[{"(", 
           RowBox[{
            RowBox[{"(", 
             RowBox[{"1", "-", 
              RowBox[{
               RowBox[{"(", 
                RowBox[{"r", "-", "b"}], ")"}], "^", "2"}]}], ")"}], "-", 
            RowBox[{"4", "*", "b", "*", "r", "*", 
             RowBox[{
              RowBox[{"Sin", "[", "phi", "]"}], "^", "2"}]}]}], ")"}], "^", 
          RowBox[{"(", 
           RowBox[{"n", "/", "2"}], ")"}]}], ",", 
         RowBox[{"{", 
          RowBox[{"phi", ",", 
           RowBox[{
            RowBox[{"-", "kappa"}], "/", "2"}], ",", 
           RowBox[{"kappa", "/", "2"}]}], "}"}]}], "]"}], "*", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"b", "^", "2"}], "+", 
         RowBox[{"r", "^", "2"}]}], ")"}]}], "+", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{
         RowBox[{
          RowBox[{"(", 
           RowBox[{
            RowBox[{"b", "^", "2"}], "-", 
            RowBox[{"r", "^", "2"}]}], ")"}], "^", "2"}], "-", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"b", "^", "2"}], "+", 
           RowBox[{"r", "^", "2"}]}], ")"}]}], ")"}], "*", 
       RowBox[{"Integrate", "[", 
        RowBox[{
         RowBox[{
          RowBox[{"(", 
           RowBox[{
            RowBox[{"(", 
             RowBox[{"1", "-", 
              RowBox[{
               RowBox[{"(", 
                RowBox[{"r", "-", "b"}], ")"}], "^", "2"}]}], ")"}], "-", 
            RowBox[{"4", "*", "b", "*", "r", "*", 
             RowBox[{
              RowBox[{"Sin", "[", "phi", "]"}], "^", "2"}]}]}], ")"}], "^", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"n", "/", "2"}], "-", "1"}], ")"}]}], ",", 
         RowBox[{"{", 
          RowBox[{"phi", ",", 
           RowBox[{
            RowBox[{"-", "kappa"}], "/", "2"}], ",", 
           RowBox[{"kappa", "/", "2"}]}], "}"}]}], "]"}]}]}], ")"}]}], ",", 
   "b"}], "]"}]], "Input",
 CellChangeTimes->{{3.7515049092615356`*^9, 3.75150504377381*^9}, {
  3.751505234081533*^9, 3.751505243703267*^9}},
 CellLabel->"In[6]:=",ExpressionUUID->"720c5172-a198-48ca-afa7-81bf12ddd59c"],

Cell[BoxData["$Aborted"], "Output",
 CellChangeTimes->{3.7515050333785677`*^9, 3.751505136271541*^9, 
  3.751505558792862*^9},
 CellLabel->"Out[6]=",ExpressionUUID->"9b15e2df-9f67-405e-86cf-7166f8f63e42"]
}, Open  ]],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{"d", "^", "2"}], 
     RowBox[{"P", "/", 
      RowBox[{"db", "^", "2"}]}]}], " ", "|", " ", "b"}], "=", "0"}], " ", 
  "*)"}]], "Input",
 CellChangeTimes->{{3.751505612917407*^9, 3.7515056217266808`*^9}},
 CellLabel->"In[7]:=",ExpressionUUID->"3074f8a2-cbfd-4c46-a497-4bdee35d38fe"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"-", "n"}], "/", 
    RowBox[{"b", "^", "2"}]}], "*", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{
      RowBox[{"(", 
       RowBox[{"Mn", "-", "Mnm2"}], ")"}], "*", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"b", "^", "2"}], "+", 
        RowBox[{"r", "^", "2"}]}], ")"}]}], "+", 
     RowBox[{
      RowBox[{
       RowBox[{"(", 
        RowBox[{
         RowBox[{"b", "^", "2"}], "-", 
         RowBox[{"r", "^", "2"}]}], ")"}], "^", "2"}], "*", "Mnm2"}]}], 
    ")"}]}], "+", 
  RowBox[{
   RowBox[{"n", "/", "b"}], "*", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"2", "*", "b", "*", 
      RowBox[{"(", 
       RowBox[{"Mn", "-", "Mnm2"}], ")"}]}], "+", 
     RowBox[{"4", "*", "b", "*", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"b", "^", "2"}], "-", 
        RowBox[{"r", "^", "2"}]}], ")"}], "*", "Mnm2"}]}], ")"}]}], "+", 
  RowBox[{
   RowBox[{"n", "/", "b"}], "*", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"b", "^", "2"}], "+", 
        RowBox[{"r", "^", "2"}]}], ")"}], "*", 
      RowBox[{
       RowBox[{"n", "/", "2"}], "/", "b"}], "*", 
      RowBox[{"(", 
       RowBox[{"Mn", "+", 
        RowBox[{"Mnm2", "*", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"r", "^", "2"}], "-", "1", "-", 
           RowBox[{"b", "^", "2"}]}], ")"}]}]}], ")"}]}], "+", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{
         RowBox[{"(", 
          RowBox[{
           RowBox[{"b", "^", "2"}], "-", 
           RowBox[{"r", "^", "2"}]}], ")"}], "^", "2"}], "-", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"b", "^", "2"}], "+", 
          RowBox[{"r", "^", "2"}]}], ")"}]}], ")"}], "*", 
      RowBox[{
       RowBox[{
        RowBox[{"(", 
         RowBox[{"n", "-", "2"}], ")"}], "/", "2"}], "/", "b"}], "*", 
      RowBox[{"(", 
       RowBox[{"Mnm2", "+", 
        RowBox[{"Mnm4", "*", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"r", "^", "2"}], "-", "1", "-", 
           RowBox[{"b", "^", "2"}]}], ")"}]}]}], ")"}]}]}], 
    ")"}]}]}]], "Input",
 CellChangeTimes->{{3.751505624587901*^9, 3.751505626678722*^9}, {
  3.751505671827242*^9, 3.751505682619073*^9}, {3.751509161999617*^9, 
  3.751509229979986*^9}},
 CellLabel->"In[8]:=",ExpressionUUID->"209c7467-1250-4b5e-99db-2aca94a6b24b"],

Cell[BoxData[
 RowBox[{
  FractionBox[
   RowBox[{"n", " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"2", " ", "b", " ", 
       RowBox[{"(", 
        RowBox[{"Mn", "-", "Mnm2"}], ")"}]}], "+", 
      RowBox[{"4", " ", "b", " ", "Mnm2", " ", 
       RowBox[{"(", 
        RowBox[{
         SuperscriptBox["b", "2"], "-", 
         SuperscriptBox["r", "2"]}], ")"}]}]}], ")"}]}], "b"], "-", 
  FractionBox[
   RowBox[{"n", " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"Mnm2", " ", 
       SuperscriptBox[
        RowBox[{"(", 
         RowBox[{
          SuperscriptBox["b", "2"], "-", 
          SuperscriptBox["r", "2"]}], ")"}], "2"]}], "+", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{"Mn", "-", "Mnm2"}], ")"}], " ", 
       RowBox[{"(", 
        RowBox[{
         SuperscriptBox["b", "2"], "+", 
         SuperscriptBox["r", "2"]}], ")"}]}]}], ")"}]}], 
   SuperscriptBox["b", "2"]], "+", 
  FractionBox[
   RowBox[{"n", " ", 
    RowBox[{"(", 
     RowBox[{
      FractionBox[
       RowBox[{"n", " ", 
        RowBox[{"(", 
         RowBox[{
          SuperscriptBox["b", "2"], "+", 
          SuperscriptBox["r", "2"]}], ")"}], " ", 
        RowBox[{"(", 
         RowBox[{"Mn", "+", 
          RowBox[{"Mnm2", " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"-", "1"}], "-", 
             SuperscriptBox["b", "2"], "+", 
             SuperscriptBox["r", "2"]}], ")"}]}]}], ")"}]}], 
       RowBox[{"2", " ", "b"}]], "+", 
      FractionBox[
       RowBox[{
        RowBox[{"(", 
         RowBox[{
          RowBox[{"-", "2"}], "+", "n"}], ")"}], " ", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"-", 
           SuperscriptBox["b", "2"]}], "-", 
          SuperscriptBox["r", "2"], "+", 
          SuperscriptBox[
           RowBox[{"(", 
            RowBox[{
             SuperscriptBox["b", "2"], "-", 
             SuperscriptBox["r", "2"]}], ")"}], "2"]}], ")"}], " ", 
        RowBox[{"(", 
         RowBox[{"Mnm2", "+", 
          RowBox[{"Mnm4", " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"-", "1"}], "-", 
             SuperscriptBox["b", "2"], "+", 
             SuperscriptBox["r", "2"]}], ")"}]}]}], ")"}]}], 
       RowBox[{"2", " ", "b"}]]}], ")"}]}], "b"]}]], "Output",
 CellChangeTimes->{3.751509274343021*^9},
 CellLabel->"Out[8]=",ExpressionUUID->"2d6bb8f8-a486-4dcf-8f84-084b0982febb"]
}, Open  ]],

Cell[BoxData[
 RowBox[{"FullSimplify", "[", "%", "]"}]], "Input",
 CellChangeTimes->{{3.751509276840868*^9, 3.751509279051654*^9}},
 CellLabel->"In[9]:=",ExpressionUUID->"f39a09f7-8ee6-4539-964e-b0aefb8b58bb"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{
     FractionBox["1", 
      RowBox[{"2", " ", 
       SuperscriptBox["b", "2"]}]], "n", " ", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{
        RowBox[{"-", 
         SuperscriptBox["b", "6"]}], " ", "Mnm4", " ", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"-", "2"}], "+", "n"}], ")"}]}], "+", 
       RowBox[{
        SuperscriptBox["b", "4"], " ", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"4", " ", "Mnm2"}], "+", 
          RowBox[{"3", " ", "Mnm4", " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"-", "2"}], "+", "n"}], ")"}], " ", 
           SuperscriptBox["r", "2"]}]}], ")"}]}], "+", 
       RowBox[{
        SuperscriptBox["b", "2"], " ", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"Mn", " ", 
           RowBox[{"(", 
            RowBox[{"2", "+", "n"}], ")"}]}], "-", 
          RowBox[{"2", " ", "Mnm2", " ", "n", " ", 
           RowBox[{"(", 
            RowBox[{"1", "+", 
             SuperscriptBox["r", "2"]}], ")"}]}], "-", 
          RowBox[{"Mnm4", " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"-", "2"}], "+", "n"}], ")"}], " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"-", "1"}], "-", 
             RowBox[{"2", " ", 
              SuperscriptBox["r", "2"]}], "+", 
             RowBox[{"3", " ", 
              SuperscriptBox["r", "4"]}]}], ")"}]}]}], ")"}]}], "+", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{
          RowBox[{"-", "2"}], "+", "n"}], ")"}], " ", 
        SuperscriptBox["r", "2"], " ", 
        RowBox[{"(", 
         RowBox[{"Mn", "+", 
          RowBox[{
           RowBox[{"(", 
            RowBox[{
             RowBox[{"-", "1"}], "+", 
             SuperscriptBox["r", "2"]}], ")"}], " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"2", " ", "Mnm2"}], "+", 
             RowBox[{"Mnm4", " ", 
              RowBox[{"(", 
               RowBox[{
                RowBox[{"-", "1"}], "+", 
                SuperscriptBox["r", "2"]}], ")"}]}]}], ")"}]}]}], ")"}]}]}], 
      ")"}]}], " ", "/.", " ", 
    RowBox[{"Mn", " ", "\[Rule]", " ", 
     RowBox[{
      RowBox[{
       RowBox[{"(", 
        RowBox[{"1", "-", 
         RowBox[{"r", "^", "2"}]}], ")"}], "^", 
       RowBox[{"(", 
        RowBox[{"n", "/", "2"}], ")"}]}], "*", "Pi"}]}]}], " ", "/.", " ", 
   RowBox[{"Mnm2", " ", "\[Rule]", " ", 
    RowBox[{
     RowBox[{
      RowBox[{"(", 
       RowBox[{"1", "-", 
        RowBox[{"r", "^", "2"}]}], ")"}], "^", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"n", "/", "2"}], "-", "1"}], ")"}]}], "*", "Pi"}]}]}], " ", "/.",
   " ", 
  RowBox[{"Mnm4", " ", "\[Rule]", " ", 
   RowBox[{
    RowBox[{
     RowBox[{"(", 
      RowBox[{"1", "-", 
       RowBox[{"r", "^", "2"}]}], ")"}], "^", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"n", "/", "2"}], "-", "2"}], ")"}]}], "*", "Pi"}]}]}]], "Input",
 CellChangeTimes->{{3.751509289975183*^9, 3.751509322966354*^9}},
 CellLabel->"In[10]:=",ExpressionUUID->"40c810d4-b859-49db-b39f-64cd8e067258"],

Cell[BoxData[
 RowBox[{
  FractionBox["1", 
   RowBox[{"2", " ", 
    SuperscriptBox["b", "2"]}]], 
  RowBox[{"n", " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{
      RowBox[{"-", 
       SuperscriptBox["b", "6"]}], " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "2"}], "+", "n"}], ")"}], " ", "\[Pi]", " ", 
      SuperscriptBox[
       RowBox[{"(", 
        RowBox[{"1", "-", 
         SuperscriptBox["r", "2"]}], ")"}], 
       RowBox[{
        RowBox[{"-", "2"}], "+", 
        FractionBox["n", "2"]}]]}], "+", 
     RowBox[{
      SuperscriptBox["b", "4"], " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"3", " ", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"-", "2"}], "+", "n"}], ")"}], " ", "\[Pi]", " ", 
         SuperscriptBox["r", "2"], " ", 
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{"1", "-", 
            SuperscriptBox["r", "2"]}], ")"}], 
          RowBox[{
           RowBox[{"-", "2"}], "+", 
           FractionBox["n", "2"]}]]}], "+", 
        RowBox[{"4", " ", "\[Pi]", " ", 
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{"1", "-", 
            SuperscriptBox["r", "2"]}], ")"}], 
          RowBox[{
           RowBox[{"-", "1"}], "+", 
           FractionBox["n", "2"]}]]}]}], ")"}]}], "+", 
     RowBox[{
      SuperscriptBox["b", "2"], " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{
         RowBox[{"(", 
          RowBox[{"2", "+", "n"}], ")"}], " ", "\[Pi]", " ", 
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{"1", "-", 
            SuperscriptBox["r", "2"]}], ")"}], 
          RowBox[{"n", "/", "2"}]]}], "-", 
        RowBox[{"2", " ", "n", " ", "\[Pi]", " ", 
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{"1", "-", 
            SuperscriptBox["r", "2"]}], ")"}], 
          RowBox[{
           RowBox[{"-", "1"}], "+", 
           FractionBox["n", "2"]}]], " ", 
         RowBox[{"(", 
          RowBox[{"1", "+", 
           SuperscriptBox["r", "2"]}], ")"}]}], "-", 
        RowBox[{
         RowBox[{"(", 
          RowBox[{
           RowBox[{"-", "2"}], "+", "n"}], ")"}], " ", "\[Pi]", " ", 
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{"1", "-", 
            SuperscriptBox["r", "2"]}], ")"}], 
          RowBox[{
           RowBox[{"-", "2"}], "+", 
           FractionBox["n", "2"]}]], " ", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"-", "1"}], "-", 
           RowBox[{"2", " ", 
            SuperscriptBox["r", "2"]}], "+", 
           RowBox[{"3", " ", 
            SuperscriptBox["r", "4"]}]}], ")"}]}]}], ")"}]}], "+", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "2"}], "+", "n"}], ")"}], " ", 
      SuperscriptBox["r", "2"], " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"\[Pi]", " ", 
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{"1", "-", 
            SuperscriptBox["r", "2"]}], ")"}], 
          RowBox[{"n", "/", "2"}]]}], "+", 
        RowBox[{
         RowBox[{"(", 
          RowBox[{
           RowBox[{"-", "1"}], "+", 
           SuperscriptBox["r", "2"]}], ")"}], " ", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"2", " ", "\[Pi]", " ", 
            SuperscriptBox[
             RowBox[{"(", 
              RowBox[{"1", "-", 
               SuperscriptBox["r", "2"]}], ")"}], 
             RowBox[{
              RowBox[{"-", "1"}], "+", 
              FractionBox["n", "2"]}]]}], "+", 
           RowBox[{"\[Pi]", " ", 
            SuperscriptBox[
             RowBox[{"(", 
              RowBox[{"1", "-", 
               SuperscriptBox["r", "2"]}], ")"}], 
             RowBox[{
              RowBox[{"-", "2"}], "+", 
              FractionBox["n", "2"]}]], " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", "1"}], "+", 
              SuperscriptBox["r", "2"]}], ")"}]}]}], ")"}]}]}], ")"}]}]}], 
    ")"}]}]}]], "Output",
 CellChangeTimes->{3.751509323323161*^9},
 CellLabel->"Out[10]=",ExpressionUUID->"aff119ac-385c-4f12-a719-36984f4ace6a"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"FullSimplify", "[", "%", "]"}]], "Input",
 CellChangeTimes->{{3.7515093241251287`*^9, 3.751509325486457*^9}},
 CellLabel->"In[11]:=",ExpressionUUID->"57cfc8fb-9075-4b7f-8bd9-4369fd7fbac4"],

Cell[BoxData[
 RowBox[{
  FractionBox["1", "2"], " ", "n", " ", "\[Pi]", " ", 
  SuperscriptBox[
   RowBox[{"(", 
    RowBox[{"1", "-", 
     SuperscriptBox["r", "2"]}], ")"}], 
   RowBox[{
    FractionBox["1", "2"], " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"-", "4"}], "+", "n"}], ")"}]}]], " ", 
  RowBox[{"(", 
   RowBox[{
    RowBox[{
     RowBox[{"-", 
      SuperscriptBox["b", "4"]}], " ", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"-", "2"}], "+", "n"}], ")"}]}], "+", 
    RowBox[{"8", " ", 
     SuperscriptBox["r", "2"], " ", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"-", "1"}], "+", 
       SuperscriptBox["r", "2"]}], ")"}]}], "+", 
    RowBox[{
     SuperscriptBox["b", "2"], " ", 
     RowBox[{"(", 
      RowBox[{"4", "+", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{
          RowBox[{"-", "10"}], "+", 
          RowBox[{"3", " ", "n"}]}], ")"}], " ", 
        SuperscriptBox["r", "2"]}]}], ")"}]}]}], ")"}]}]], "Output",
 CellChangeTimes->{3.7515093258840303`*^9},
 CellLabel->"Out[11]=",ExpressionUUID->"df968256-af7e-409b-848f-b9cc35b5b824"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"%", " ", "/.", " ", 
  RowBox[{"b", " ", "\[Rule]", " ", "0"}]}]], "Input",
 CellChangeTimes->{{3.751509330281003*^9, 3.75150933220261*^9}},
 CellLabel->"In[12]:=",ExpressionUUID->"fc00b7e5-f2e0-4cad-b0e0-a1c080de65f2"],

Cell[BoxData[
 RowBox[{"4", " ", "n", " ", "\[Pi]", " ", 
  SuperscriptBox["r", "2"], " ", 
  SuperscriptBox[
   RowBox[{"(", 
    RowBox[{"1", "-", 
     SuperscriptBox["r", "2"]}], ")"}], 
   RowBox[{
    FractionBox["1", "2"], " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"-", "4"}], "+", "n"}], ")"}]}]], " ", 
  RowBox[{"(", 
   RowBox[{
    RowBox[{"-", "1"}], "+", 
    SuperscriptBox["r", "2"]}], ")"}]}]], "Output",
 CellChangeTimes->{3.7515093327344713`*^9},
 CellLabel->"Out[12]=",ExpressionUUID->"f7433286-4fd8-445e-97f0-deefd89641da"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"FullSimplify", "[", "%", "]"}]], "Input",
 CellChangeTimes->{{3.751509334864725*^9, 3.751509336707802*^9}},
 CellLabel->"In[13]:=",ExpressionUUID->"c96cf9a1-db35-445f-8c03-4f21278ad905"],

Cell[BoxData[
 RowBox[{
  RowBox[{"-", "4"}], " ", "n", " ", "\[Pi]", " ", 
  SuperscriptBox["r", "2"], " ", 
  SuperscriptBox[
   RowBox[{"(", 
    RowBox[{"1", "-", 
     SuperscriptBox["r", "2"]}], ")"}], 
   RowBox[{
    RowBox[{"-", "1"}], "+", 
    FractionBox["n", "2"]}]]}]], "Output",
 CellChangeTimes->{3.751509337010199*^9},
 CellLabel->"Out[13]=",ExpressionUUID->"4906d4e5-834f-426d-827f-f11f371d3491"]
}, Open  ]],

Cell[BoxData[""], "Input",
 CellChangeTimes->{{3.751509377163124*^9, 
  3.751509378333232*^9}},ExpressionUUID->"863eb811-4d33-451f-abbf-\
9ed4ef8a96f4"],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{
   RowBox[{
    RowBox[{"dP", "/", "db"}], " ", "|", " ", "b"}], "=", "0"}], " ", 
  "*)"}]], "Input",
 CellChangeTimes->{{3.751509484284012*^9, 3.751509489597163*^9}},
 CellLabel->"In[14]:=",ExpressionUUID->"9153557b-53c4-433d-8355-e0ea777f4e8a"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"n", "/", "b"}], "*", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{
       RowBox[{"(", 
        RowBox[{"Mn", " ", "-", " ", "Mnm2"}], ")"}], "*", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"b", "^", "2"}], "+", 
         RowBox[{"r", "^", "2"}]}], ")"}]}], "+", 
      RowBox[{
       RowBox[{
        RowBox[{"(", 
         RowBox[{
          RowBox[{"b", "^", "2"}], "-", 
          RowBox[{"r", "^", "2"}]}], ")"}], "^", "2"}], "*", "Mnm2"}]}], 
     ")"}]}], "/.", " ", 
   RowBox[{"Mn", " ", "\[Rule]", " ", 
    RowBox[{
     RowBox[{
      RowBox[{"(", 
       RowBox[{"1", "-", 
        RowBox[{"r", "^", "2"}]}], ")"}], "^", 
      RowBox[{"(", 
       RowBox[{"n", "/", "2"}], ")"}]}], "*", "Pi"}]}]}], " ", "/.", " ", 
  RowBox[{"Mnm2", " ", "\[Rule]", " ", 
   RowBox[{
    RowBox[{
     RowBox[{"(", 
      RowBox[{"1", "-", 
       RowBox[{"r", "^", "2"}]}], ")"}], "^", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"n", "/", "2"}], "-", "1"}], ")"}]}], "*", "Pi"}]}]}]], "Input",\

 CellChangeTimes->{{3.751509492427642*^9, 3.751509527134428*^9}},
 CellLabel->"In[15]:=",ExpressionUUID->"3eb7ecca-8314-4def-80a5-04ea86a06760"],

Cell[BoxData[
 FractionBox[
  RowBox[{"n", " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"\[Pi]", " ", 
      SuperscriptBox[
       RowBox[{"(", 
        RowBox[{"1", "-", 
         SuperscriptBox["r", "2"]}], ")"}], 
       RowBox[{
        RowBox[{"-", "1"}], "+", 
        FractionBox["n", "2"]}]], " ", 
      SuperscriptBox[
       RowBox[{"(", 
        RowBox[{
         SuperscriptBox["b", "2"], "-", 
         SuperscriptBox["r", "2"]}], ")"}], "2"]}], "+", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        SuperscriptBox["b", "2"], "+", 
        SuperscriptBox["r", "2"]}], ")"}], " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{
         RowBox[{"-", "\[Pi]"}], " ", 
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{"1", "-", 
            SuperscriptBox["r", "2"]}], ")"}], 
          RowBox[{
           RowBox[{"-", "1"}], "+", 
           FractionBox["n", "2"]}]]}], "+", 
        RowBox[{"\[Pi]", " ", 
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{"1", "-", 
            SuperscriptBox["r", "2"]}], ")"}], 
          RowBox[{"n", "/", "2"}]]}]}], ")"}]}]}], ")"}]}], "b"]], "Output",
 CellChangeTimes->{3.751509528161422*^9},
 CellLabel->"Out[15]=",ExpressionUUID->"499ec4de-461f-4c98-bbd9-c5880ce2d840"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"FullSimplify", "[", "%", "]"}]], "Input",
 CellChangeTimes->{{3.751509529291069*^9, 3.751509530973015*^9}},
 CellLabel->"In[16]:=",ExpressionUUID->"24235662-2f2a-4b2d-b421-630a8f80eb61"],

Cell[BoxData[
 RowBox[{"b", " ", "n", " ", "\[Pi]", " ", 
  RowBox[{"(", 
   RowBox[{
    SuperscriptBox["b", "2"], "-", 
    RowBox[{"3", " ", 
     SuperscriptBox["r", "2"]}]}], ")"}], " ", 
  SuperscriptBox[
   RowBox[{"(", 
    RowBox[{"1", "-", 
     SuperscriptBox["r", "2"]}], ")"}], 
   RowBox[{
    RowBox[{"-", "1"}], "+", 
    FractionBox["n", "2"]}]]}]], "Output",
 CellChangeTimes->{3.751509531330097*^9},
 CellLabel->"Out[16]=",ExpressionUUID->"f9499199-98db-4175-b913-aa628e99e0fb"]
}, Open  ]],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{
   RowBox[{"Series", " ", "solution", " ", "near", " ", "b"}], "=", "0"}], 
  " ", "*)"}]], "Input",
 CellChangeTimes->{{3.75157279577907*^9, 3.751572820432214*^9}},
 CellLabel->"In[17]:=",ExpressionUUID->"6e22fdad-41ca-4ebb-b78e-45ca7a6bb46e"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Series", "[", 
  RowBox[{
   RowBox[{"2", "*", "r", "*", 
    RowBox[{
     RowBox[{"(", 
      RowBox[{"1", "-", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{"r", "-", "b"}], ")"}], "^", "2"}], "-", 
       RowBox[{"4", "*", "b", "*", "r", "*", 
        RowBox[{
         RowBox[{"Sin", "[", "xi", "]"}], "^", "2"}]}]}], ")"}], "^", 
     RowBox[{"(", 
      RowBox[{"n", "/", "2"}], ")"}]}], "*", 
    RowBox[{"(", 
     RowBox[{"r", "-", "b", "+", 
      RowBox[{"2", "*", "b", "*", 
       RowBox[{
        RowBox[{"Sin", "[", "xi", "]"}], "^", "2"}]}]}], ")"}]}], ",", 
   RowBox[{"{", 
    RowBox[{"b", ",", "0", ",", "3"}], "}"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.751572843413864*^9, 3.75157288022361*^9}, {
  3.751573003572653*^9, 3.75157300363583*^9}, {3.7515731776159687`*^9, 
  3.7515731815007277`*^9}, {3.751573217774425*^9, 3.751573233077894*^9}, {
  3.751573585417656*^9, 3.751573608949788*^9}, {3.751573648529454*^9, 
  3.75157364951849*^9}},
 CellLabel->"In[35]:=",ExpressionUUID->"624eaba1-ecd8-43b5-89c6-9397b541b4ae"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
   RowBox[{"2", " ", 
    SuperscriptBox["r", "2"], " ", 
    SuperscriptBox[
     RowBox[{"(", 
      RowBox[{"1", "-", 
       SuperscriptBox["r", "2"]}], ")"}], 
     RowBox[{"n", "/", "2"}]]}], "+", 
   FractionBox[
    RowBox[{"2", " ", "r", " ", 
     SuperscriptBox[
      RowBox[{"(", 
       RowBox[{"1", "-", 
        SuperscriptBox["r", "2"]}], ")"}], 
      RowBox[{"n", "/", "2"}]], " ", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"-", "1"}], "+", 
       SuperscriptBox["r", "2"], "+", 
       RowBox[{"n", " ", 
        SuperscriptBox["r", "2"]}]}], ")"}], " ", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"-", "1"}], "+", 
       RowBox[{"2", " ", 
        SuperscriptBox[
         RowBox[{"Sin", "[", "xi", "]"}], "2"]}]}], ")"}], " ", "b"}], 
    RowBox[{
     RowBox[{"-", "1"}], "+", 
     SuperscriptBox["r", "2"]}]], "+", 
   FractionBox[
    RowBox[{"n", " ", 
     SuperscriptBox["r", "2"], " ", 
     SuperscriptBox[
      RowBox[{"(", 
       RowBox[{"1", "-", 
        SuperscriptBox["r", "2"]}], ")"}], 
      RowBox[{"n", "/", "2"}]], " ", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"-", "3"}], "+", 
       SuperscriptBox["r", "2"], "+", 
       RowBox[{"n", " ", 
        SuperscriptBox["r", "2"]}], "+", 
       RowBox[{"8", " ", 
        SuperscriptBox[
         RowBox[{"Sin", "[", "xi", "]"}], "2"]}], "-", 
       RowBox[{"4", " ", "n", " ", 
        SuperscriptBox["r", "2"], " ", 
        SuperscriptBox[
         RowBox[{"Sin", "[", "xi", "]"}], "2"]}], "-", 
       RowBox[{"8", " ", 
        SuperscriptBox[
         RowBox[{"Sin", "[", "xi", "]"}], "4"]}], "+", 
       RowBox[{"4", " ", "n", " ", 
        SuperscriptBox["r", "2"], " ", 
        SuperscriptBox[
         RowBox[{"Sin", "[", "xi", "]"}], "4"]}]}], ")"}], " ", 
     SuperscriptBox["b", "2"]}], 
    SuperscriptBox[
     RowBox[{"(", 
      RowBox[{
       RowBox[{"-", "1"}], "+", 
       SuperscriptBox["r", "2"]}], ")"}], "2"]], "+", 
   RowBox[{
    FractionBox["1", 
     RowBox[{"3", " ", 
      SuperscriptBox[
       RowBox[{"(", 
        RowBox[{
         RowBox[{"-", "1"}], "+", 
         SuperscriptBox["r", "2"]}], ")"}], "3"]}]], 
    RowBox[{"n", " ", "r", " ", 
     SuperscriptBox[
      RowBox[{"(", 
       RowBox[{"1", "-", 
        SuperscriptBox["r", "2"]}], ")"}], 
      RowBox[{"n", "/", "2"}]], " ", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"-", "1"}], "+", 
       RowBox[{"2", " ", 
        SuperscriptBox[
         RowBox[{"Sin", "[", "xi", "]"}], "2"]}]}], ")"}], " ", 
     RowBox[{"(", 
      RowBox[{"3", "+", 
       RowBox[{"6", " ", 
        SuperscriptBox["r", "2"]}], "-", 
       RowBox[{"6", " ", "n", " ", 
        SuperscriptBox["r", "2"]}], "-", 
       SuperscriptBox["r", "4"], "+", 
       RowBox[{
        SuperscriptBox["n", "2"], " ", 
        SuperscriptBox["r", "4"]}], "-", 
       RowBox[{"24", " ", 
        SuperscriptBox["r", "2"], " ", 
        SuperscriptBox[
         RowBox[{"Sin", "[", "xi", "]"}], "2"]}], "+", 
       RowBox[{"12", " ", "n", " ", 
        SuperscriptBox["r", "2"], " ", 
        SuperscriptBox[
         RowBox[{"Sin", "[", "xi", "]"}], "2"]}], "-", 
       RowBox[{"8", " ", 
        SuperscriptBox["r", "4"], " ", 
        SuperscriptBox[
         RowBox[{"Sin", "[", "xi", "]"}], "2"]}], "+", 
       RowBox[{"12", " ", "n", " ", 
        SuperscriptBox["r", "4"], " ", 
        SuperscriptBox[
         RowBox[{"Sin", "[", "xi", "]"}], "2"]}], "-", 
       RowBox[{"4", " ", 
        SuperscriptBox["n", "2"], " ", 
        SuperscriptBox["r", "4"], " ", 
        SuperscriptBox[
         RowBox[{"Sin", "[", "xi", "]"}], "2"]}], "+", 
       RowBox[{"24", " ", 
        SuperscriptBox["r", "2"], " ", 
        SuperscriptBox[
         RowBox[{"Sin", "[", "xi", "]"}], "4"]}], "-", 
       RowBox[{"12", " ", "n", " ", 
        SuperscriptBox["r", "2"], " ", 
        SuperscriptBox[
         RowBox[{"Sin", "[", "xi", "]"}], "4"]}], "+", 
       RowBox[{"8", " ", 
        SuperscriptBox["r", "4"], " ", 
        SuperscriptBox[
         RowBox[{"Sin", "[", "xi", "]"}], "4"]}], "-", 
       RowBox[{"12", " ", "n", " ", 
        SuperscriptBox["r", "4"], " ", 
        SuperscriptBox[
         RowBox[{"Sin", "[", "xi", "]"}], "4"]}], "+", 
       RowBox[{"4", " ", 
        SuperscriptBox["n", "2"], " ", 
        SuperscriptBox["r", "4"], " ", 
        SuperscriptBox[
         RowBox[{"Sin", "[", "xi", "]"}], "4"]}]}], ")"}], " ", 
     SuperscriptBox["b", "3"]}]}], "+", 
   InterpretationBox[
    SuperscriptBox[
     RowBox[{"O", "[", "b", "]"}], "4"],
    SeriesData[$CellContext`b, 0, {}, 0, 4, 1],
    Editable->False]}],
  SeriesData[$CellContext`b, 0, {
   2 $CellContext`r^2 (1 - $CellContext`r^2)^(Rational[1, 2] $CellContext`n), 
    2 $CellContext`r (1 - $CellContext`r^2)^(
      Rational[1, 
        2] $CellContext`n) (-1 + $CellContext`r^2)^(-1) (-1 + \
$CellContext`r^2 + $CellContext`n $CellContext`r^2) (-1 + 
     2 Sin[$CellContext`xi]^2), $CellContext`n $CellContext`r^2 (
      1 - $CellContext`r^2)^(
      Rational[1, 
        2] $CellContext`n) (-1 + $CellContext`r^2)^(-2) (-3 + \
$CellContext`r^2 + $CellContext`n $CellContext`r^2 + 8 Sin[$CellContext`xi]^2 - 
     4 $CellContext`n $CellContext`r^2 Sin[$CellContext`xi]^2 - 8 
     Sin[$CellContext`xi]^4 + 
     4 $CellContext`n $CellContext`r^2 Sin[$CellContext`xi]^4), 
    Rational[1, 3] $CellContext`n $CellContext`r (1 - $CellContext`r^2)^(
      Rational[1, 2] $CellContext`n) (-1 + $CellContext`r^2)^(-3) (-1 + 
     2 Sin[$CellContext`xi]^2) (3 + 6 $CellContext`r^2 - 
     6 $CellContext`n $CellContext`r^2 - $CellContext`r^4 + $CellContext`n^2 \
$CellContext`r^4 - 24 $CellContext`r^2 Sin[$CellContext`xi]^2 + 
     12 $CellContext`n $CellContext`r^2 Sin[$CellContext`xi]^2 - 
     8 $CellContext`r^4 Sin[$CellContext`xi]^2 + 
     12 $CellContext`n $CellContext`r^4 Sin[$CellContext`xi]^2 - 
     4 $CellContext`n^2 $CellContext`r^4 Sin[$CellContext`xi]^2 + 
     24 $CellContext`r^2 Sin[$CellContext`xi]^4 - 
     12 $CellContext`n $CellContext`r^2 Sin[$CellContext`xi]^4 + 
     8 $CellContext`r^4 Sin[$CellContext`xi]^4 - 
     12 $CellContext`n $CellContext`r^4 Sin[$CellContext`xi]^4 + 
     4 $CellContext`n^2 $CellContext`r^4 Sin[$CellContext`xi]^4)}, 0, 4, 1],
  Editable->False]], "Output",
 CellChangeTimes->{
  3.751573262266612*^9, {3.75157362577802*^9, 3.75157365046717*^9}},
 CellLabel->"Out[35]=",ExpressionUUID->"5d9c0a40-4111-4158-88ca-139ef7b3b93e"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"FullSimplify", "[", 
  RowBox[{"Normal", "[", "%", "]"}], "]"}]], "Input",
 CellChangeTimes->{{3.75157288330868*^9, 3.751572885096499*^9}, {
  3.751573247271351*^9, 3.751573267795883*^9}},
 CellLabel->"In[36]:=",ExpressionUUID->"370c461f-7abb-45eb-978e-7ff901f6d34c"],

Cell[BoxData[
 RowBox[{
  FractionBox["1", "3"], " ", "r", " ", 
  SuperscriptBox[
   RowBox[{"(", 
    RowBox[{"1", "-", 
     SuperscriptBox["r", "2"]}], ")"}], 
   RowBox[{"n", "/", "2"}]], " ", 
  RowBox[{"(", 
   RowBox[{
    RowBox[{"6", " ", "r"}], "-", 
    FractionBox[
     RowBox[{"6", " ", "b", " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "1"}], "+", 
        RowBox[{
         RowBox[{"(", 
          RowBox[{"1", "+", "n"}], ")"}], " ", 
         SuperscriptBox["r", "2"]}]}], ")"}], " ", 
      RowBox[{"Cos", "[", 
       RowBox[{"2", " ", "xi"}], "]"}]}], 
     RowBox[{
      RowBox[{"-", "1"}], "+", 
      SuperscriptBox["r", "2"]}]], "-", 
    FractionBox[
     RowBox[{
      SuperscriptBox["b", "3"], " ", "n", " ", 
      RowBox[{"Cos", "[", 
       RowBox[{"2", " ", "xi"}], "]"}], " ", 
      RowBox[{"(", 
       RowBox[{"6", "+", 
        RowBox[{
         RowBox[{"(", 
          RowBox[{"6", "-", 
           RowBox[{"9", " ", "n"}]}], ")"}], " ", 
         SuperscriptBox["r", "2"]}], "+", 
        RowBox[{
         RowBox[{"(", 
          RowBox[{
           RowBox[{"-", "1"}], "+", "n"}], ")"}], " ", 
         RowBox[{"(", 
          RowBox[{"4", "+", "n"}], ")"}], " ", 
         SuperscriptBox["r", "4"]}], "+", 
        RowBox[{
         RowBox[{"(", 
          RowBox[{
           RowBox[{"-", "2"}], "+", "n"}], ")"}], " ", 
         SuperscriptBox["r", "2"], " ", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"-", "3"}], "+", 
           RowBox[{
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", "1"}], "+", "n"}], ")"}], " ", 
            SuperscriptBox["r", "2"]}]}], ")"}], " ", 
         RowBox[{"Cos", "[", 
          RowBox[{"4", " ", "xi"}], "]"}]}]}], ")"}]}], 
     RowBox[{"2", " ", 
      SuperscriptBox[
       RowBox[{"(", 
        RowBox[{
         RowBox[{"-", "1"}], "+", 
         SuperscriptBox["r", "2"]}], ")"}], "3"]}]], "+", 
    FractionBox[
     RowBox[{"3", " ", 
      SuperscriptBox["b", "2"], " ", "n", " ", "r", " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "4"}], "+", 
        RowBox[{
         RowBox[{"(", 
          RowBox[{"2", "+", "n"}], ")"}], " ", 
         SuperscriptBox["r", "2"]}], "+", 
        RowBox[{
         RowBox[{"(", 
          RowBox[{
           RowBox[{"-", "2"}], "+", 
           RowBox[{"n", " ", 
            SuperscriptBox["r", "2"]}]}], ")"}], " ", 
         RowBox[{"Cos", "[", 
          RowBox[{"4", " ", "xi"}], "]"}]}]}], ")"}]}], 
     RowBox[{"2", " ", 
      SuperscriptBox[
       RowBox[{"(", 
        RowBox[{
         RowBox[{"-", "1"}], "+", 
         SuperscriptBox["r", "2"]}], ")"}], "2"]}]]}], ")"}]}]], "Output",
 CellChangeTimes->{
  3.751572887697084*^9, 3.751573007093995*^9, {3.75157324281551*^9, 
   3.751573269658564*^9}, 3.7515736296052837`*^9, 3.751573662684643*^9},
 CellLabel->"Out[36]=",ExpressionUUID->"39134828-f5e3-4de7-b721-206b2cced5f0"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Integrate", "[", 
  RowBox[{"%", ",", 
   RowBox[{"{", 
    RowBox[{"xi", ",", 
     RowBox[{
      RowBox[{"-", "Pi"}], "/", "2"}], ",", 
     RowBox[{"Pi", "/", "2"}]}], "}"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.751572892236988*^9, 3.751572904005958*^9}},
 CellLabel->"In[37]:=",ExpressionUUID->"a474babe-7d4f-48b5-9616-f1d8f624a958"],

Cell[BoxData[
 RowBox[{
  FractionBox["1", "2"], " ", "\[Pi]", " ", 
  SuperscriptBox["r", "2"], " ", 
  SuperscriptBox[
   RowBox[{"(", 
    RowBox[{"1", "-", 
     SuperscriptBox["r", "2"]}], ")"}], 
   RowBox[{"n", "/", "2"}]], " ", 
  RowBox[{"(", 
   RowBox[{"4", "+", 
    FractionBox[
     RowBox[{
      SuperscriptBox["b", "2"], " ", "n", " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "4"}], "+", 
        RowBox[{
         RowBox[{"(", 
          RowBox[{"2", "+", "n"}], ")"}], " ", 
         SuperscriptBox["r", "2"]}]}], ")"}]}], 
     SuperscriptBox[
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "1"}], "+", 
        SuperscriptBox["r", "2"]}], ")"}], "2"]]}], ")"}]}]], "Output",
 CellChangeTimes->{3.751572915405079*^9, 3.75157301215528*^9, 
  3.751573344514339*^9, 3.7515736323793497`*^9, 3.751573669552713*^9},
 CellLabel->"Out[37]=",ExpressionUUID->"23dad21a-24df-4b12-a419-90c88ac030ae"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"FullSimplify", "[", "%", "]"}]], "Input",
 CellChangeTimes->{{3.751573680218215*^9, 3.75157368567697*^9}},
 CellLabel->"In[38]:=",ExpressionUUID->"8863660d-6c8d-4a80-9523-49861b641848"],

Cell[BoxData[
 RowBox[{
  FractionBox["1", "2"], " ", "\[Pi]", " ", 
  SuperscriptBox["r", "2"], " ", 
  SuperscriptBox[
   RowBox[{"(", 
    RowBox[{"1", "-", 
     SuperscriptBox["r", "2"]}], ")"}], 
   RowBox[{"n", "/", "2"}]], " ", 
  RowBox[{"(", 
   RowBox[{"4", "+", 
    FractionBox[
     RowBox[{
      SuperscriptBox["b", "2"], " ", "n", " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "4"}], "+", 
        RowBox[{
         RowBox[{"(", 
          RowBox[{"2", "+", "n"}], ")"}], " ", 
         SuperscriptBox["r", "2"]}]}], ")"}]}], 
     SuperscriptBox[
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "1"}], "+", 
        SuperscriptBox["r", "2"]}], ")"}], "2"]]}], ")"}]}]], "Output",
 CellChangeTimes->{3.7515736862361927`*^9},
 CellLabel->"Out[38]=",ExpressionUUID->"66c6fb23-c3df-4a4d-b366-94b555919c39"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"%", " ", "/.", " ", 
  RowBox[{"n", " ", "\[Rule]", " ", "2"}]}]], "Input",
 CellChangeTimes->{{3.751573911056662*^9, 3.751573917945281*^9}},
 CellLabel->"In[42]:=",ExpressionUUID->"fce71a6c-a970-4d8a-a3c5-ee9713d8f1e6"],

Cell[BoxData[
 RowBox[{
  RowBox[{"-", "4"}], " ", 
  SuperscriptBox["b", "2"], " ", "\[Pi]"}]], "Output",
 CellChangeTimes->{3.7515739183024883`*^9},
 CellLabel->"Out[42]=",ExpressionUUID->"b1c5274e-3e9f-4005-945e-e038d3d8aab0"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"Out", "[", "38", "]"}], " ", "/.", " ", 
  RowBox[{"n", " ", "\[Rule]", " ", "3"}]}]], "Input",
 CellChangeTimes->{{3.751573980922267*^9, 3.751573984483774*^9}},
 CellLabel->"In[43]:=",ExpressionUUID->"c62c0eaf-4bb5-42d5-ae95-91101f2e04d5"],

Cell[BoxData[
 RowBox[{
  FractionBox["1", "2"], " ", "\[Pi]", " ", 
  SuperscriptBox["r", "2"], " ", 
  SuperscriptBox[
   RowBox[{"(", 
    RowBox[{"1", "-", 
     SuperscriptBox["r", "2"]}], ")"}], 
   RowBox[{"3", "/", "2"}]], " ", 
  RowBox[{"(", 
   RowBox[{"4", "+", 
    FractionBox[
     RowBox[{"3", " ", 
      SuperscriptBox["b", "2"], " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "4"}], "+", 
        RowBox[{"5", " ", 
         SuperscriptBox["r", "2"]}]}], ")"}]}], 
     SuperscriptBox[
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "1"}], "+", 
        SuperscriptBox["r", "2"]}], ")"}], "2"]]}], ")"}]}]], "Output",
 CellChangeTimes->{3.7515739848611*^9},
 CellLabel->"Out[43]=",ExpressionUUID->"ca4fb9b1-8285-4a64-b0fb-c495e53e1eb0"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"FullSimplify", "[", "%", "]"}]], "Input",
 CellChangeTimes->{{3.751573986673827*^9, 3.751573988821042*^9}},
 CellLabel->"In[44]:=",ExpressionUUID->"15d7be1c-1783-473c-ab07-cd695d7d5f6a"],

Cell[BoxData[
 RowBox[{
  FractionBox["1", "2"], " ", "\[Pi]", " ", 
  SuperscriptBox["r", "2"], " ", 
  SuperscriptBox[
   RowBox[{"(", 
    RowBox[{"1", "-", 
     SuperscriptBox["r", "2"]}], ")"}], 
   RowBox[{"3", "/", "2"}]], " ", 
  RowBox[{"(", 
   RowBox[{"4", "+", 
    FractionBox[
     RowBox[{"3", " ", 
      SuperscriptBox["b", "2"], " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "4"}], "+", 
        RowBox[{"5", " ", 
         SuperscriptBox["r", "2"]}]}], ")"}]}], 
     SuperscriptBox[
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "1"}], "+", 
        SuperscriptBox["r", "2"]}], ")"}], "2"]]}], ")"}]}]], "Output",
 CellChangeTimes->{3.751573989196435*^9},
 CellLabel->"Out[44]=",ExpressionUUID->"547a8aca-d104-4b69-8287-d523a601450e"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"Out", "[", "38", "]"}], " ", "/.", " ", 
  RowBox[{"n", " ", "\[Rule]", " ", "4"}]}]], "Input",
 CellChangeTimes->{{3.751574046117223*^9, 3.75157405036581*^9}},
 CellLabel->"In[45]:=",ExpressionUUID->"82ded603-4e7c-4b38-9aa1-2485bd57ac59"],

Cell[BoxData[
 RowBox[{
  FractionBox["1", "2"], " ", "\[Pi]", " ", 
  SuperscriptBox["r", "2"], " ", 
  SuperscriptBox[
   RowBox[{"(", 
    RowBox[{"1", "-", 
     SuperscriptBox["r", "2"]}], ")"}], "2"], " ", 
  RowBox[{"(", 
   RowBox[{"4", "+", 
    FractionBox[
     RowBox[{"4", " ", 
      SuperscriptBox["b", "2"], " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "4"}], "+", 
        RowBox[{"6", " ", 
         SuperscriptBox["r", "2"]}]}], ")"}]}], 
     SuperscriptBox[
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "1"}], "+", 
        SuperscriptBox["r", "2"]}], ")"}], "2"]]}], ")"}]}]], "Output",
 CellChangeTimes->{3.751574050650806*^9},
 CellLabel->"Out[45]=",ExpressionUUID->"a8e2ff25-cefa-482b-a5f1-da1fb2673fea"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"FullSimplify", "[", "%", "]"}]], "Input",
 CellChangeTimes->{{3.751574051675992*^9, 3.751574054815381*^9}},
 CellLabel->"In[46]:=",ExpressionUUID->"a480f42f-39b0-4b35-9ff1-9205ae676186"],

Cell[BoxData[
 RowBox[{"2", " ", "\[Pi]", " ", 
  SuperscriptBox["r", "2"], " ", 
  RowBox[{"(", 
   RowBox[{
    SuperscriptBox[
     RowBox[{"(", 
      RowBox[{
       RowBox[{"-", "1"}], "+", 
       SuperscriptBox["r", "2"]}], ")"}], "2"], "+", 
    RowBox[{
     SuperscriptBox["b", "2"], " ", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"-", "4"}], "+", 
       RowBox[{"6", " ", 
        SuperscriptBox["r", "2"]}]}], ")"}]}]}], ")"}]}]], "Output",
 CellChangeTimes->{3.751574055133272*^9},
 CellLabel->"Out[46]=",ExpressionUUID->"5324b109-ccc8-4242-bbad-1a815fb50dc8"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Limit", "[", 
  RowBox[{"%", ",", " ", 
   RowBox[{"r", " ", "\[Rule]", " ", "1"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.751574061412962*^9, 3.751574067870699*^9}},
 CellLabel->"In[47]:=",ExpressionUUID->"bddc8cdb-1027-4fd3-b2eb-0f2312f5bb68"],

Cell[BoxData[
 RowBox[{"4", " ", 
  SuperscriptBox["b", "2"], " ", "\[Pi]"}]], "Output",
 CellChangeTimes->{3.7515740682522*^9},
 CellLabel->"Out[47]=",ExpressionUUID->"c464d6a0-641a-4ab5-b85a-8bf9b12e03ab"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Limit", "[", 
  RowBox[{
   RowBox[{"Out", "[", "43", "]"}], ",", " ", 
   RowBox[{"r", "\[Rule]", " ", "1"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.751574073384169*^9, 3.751574082816766*^9}},
 CellLabel->"In[48]:=",ExpressionUUID->"27c9c2c7-3d56-4d04-b7a7-2fc96d78c7e3"],

Cell[BoxData["Indeterminate"], "Output",
 CellChangeTimes->{3.75157408337463*^9},
 CellLabel->"Out[48]=",ExpressionUUID->"2fb4c794-8858-443f-b7a9-56c0a1f8d535"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"D", "[", 
  RowBox[{
   RowBox[{"Out", "[", "38", "]"}], ",", "r"}], "]"}]], "Input",
 CellChangeTimes->{{3.751574493425416*^9, 3.751574496514542*^9}},
 CellLabel->"In[50]:=",ExpressionUUID->"d2062cc5-527a-4fcf-91be-cf60bcfda989"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   FractionBox["1", "2"], " ", "\[Pi]", " ", 
   SuperscriptBox["r", "2"], " ", 
   SuperscriptBox[
    RowBox[{"(", 
     RowBox[{"1", "-", 
      SuperscriptBox["r", "2"]}], ")"}], 
    RowBox[{"n", "/", "2"}]], " ", 
   RowBox[{"(", 
    RowBox[{
     FractionBox[
      RowBox[{"2", " ", 
       SuperscriptBox["b", "2"], " ", "n", " ", 
       RowBox[{"(", 
        RowBox[{"2", "+", "n"}], ")"}], " ", "r"}], 
      SuperscriptBox[
       RowBox[{"(", 
        RowBox[{
         RowBox[{"-", "1"}], "+", 
         SuperscriptBox["r", "2"]}], ")"}], "2"]], "-", 
     FractionBox[
      RowBox[{"4", " ", 
       SuperscriptBox["b", "2"], " ", "n", " ", "r", " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"-", "4"}], "+", 
         RowBox[{
          RowBox[{"(", 
           RowBox[{"2", "+", "n"}], ")"}], " ", 
          SuperscriptBox["r", "2"]}]}], ")"}]}], 
      SuperscriptBox[
       RowBox[{"(", 
        RowBox[{
         RowBox[{"-", "1"}], "+", 
         SuperscriptBox["r", "2"]}], ")"}], "3"]]}], ")"}]}], "-", 
  RowBox[{
   FractionBox["1", "2"], " ", "n", " ", "\[Pi]", " ", 
   SuperscriptBox["r", "3"], " ", 
   SuperscriptBox[
    RowBox[{"(", 
     RowBox[{"1", "-", 
      SuperscriptBox["r", "2"]}], ")"}], 
    RowBox[{
     RowBox[{"-", "1"}], "+", 
     FractionBox["n", "2"]}]], " ", 
   RowBox[{"(", 
    RowBox[{"4", "+", 
     FractionBox[
      RowBox[{
       SuperscriptBox["b", "2"], " ", "n", " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"-", "4"}], "+", 
         RowBox[{
          RowBox[{"(", 
           RowBox[{"2", "+", "n"}], ")"}], " ", 
          SuperscriptBox["r", "2"]}]}], ")"}]}], 
      SuperscriptBox[
       RowBox[{"(", 
        RowBox[{
         RowBox[{"-", "1"}], "+", 
         SuperscriptBox["r", "2"]}], ")"}], "2"]]}], ")"}]}], "+", 
  RowBox[{"\[Pi]", " ", "r", " ", 
   SuperscriptBox[
    RowBox[{"(", 
     RowBox[{"1", "-", 
      SuperscriptBox["r", "2"]}], ")"}], 
    RowBox[{"n", "/", "2"}]], " ", 
   RowBox[{"(", 
    RowBox[{"4", "+", 
     FractionBox[
      RowBox[{
       SuperscriptBox["b", "2"], " ", "n", " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"-", "4"}], "+", 
         RowBox[{
          RowBox[{"(", 
           RowBox[{"2", "+", "n"}], ")"}], " ", 
          SuperscriptBox["r", "2"]}]}], ")"}]}], 
      SuperscriptBox[
       RowBox[{"(", 
        RowBox[{
         RowBox[{"-", "1"}], "+", 
         SuperscriptBox["r", "2"]}], ")"}], "2"]]}], ")"}]}]}]], "Output",
 CellChangeTimes->{3.751574496946241*^9},
 CellLabel->"Out[50]=",ExpressionUUID->"ea7b360b-4fcc-436c-be5e-5c097984a3fe"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"FullSimplify", "[", "%", "]"}]], "Input",
 CellChangeTimes->{{3.7515744976647797`*^9, 3.751574499059724*^9}},
 CellLabel->"In[51]:=",ExpressionUUID->"ef7ae34b-bd35-4e54-8dca-9d01dc31f8f7"],

Cell[BoxData[
 RowBox[{
  RowBox[{"-", 
   FractionBox["1", "2"]}], " ", "\[Pi]", " ", "r", " ", 
  SuperscriptBox[
   RowBox[{"(", 
    RowBox[{"1", "-", 
     SuperscriptBox["r", "2"]}], ")"}], 
   RowBox[{
    FractionBox["1", "2"], " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"-", "6"}], "+", "n"}], ")"}]}]], " ", 
  RowBox[{"(", 
   RowBox[{
    RowBox[{"4", " ", 
     SuperscriptBox[
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "1"}], "+", 
        SuperscriptBox["r", "2"]}], ")"}], "2"], " ", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"-", "2"}], "+", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{"2", "+", "n"}], ")"}], " ", 
        SuperscriptBox["r", "2"]}]}], ")"}]}], "+", 
    RowBox[{
     SuperscriptBox["b", "2"], " ", "n", " ", 
     RowBox[{"(", 
      RowBox[{"8", "-", 
       RowBox[{"8", " ", "n", " ", 
        SuperscriptBox["r", "2"]}], "+", 
       RowBox[{"n", " ", 
        RowBox[{"(", 
         RowBox[{"2", "+", "n"}], ")"}], " ", 
        SuperscriptBox["r", "4"]}]}], ")"}]}]}], ")"}]}]], "Output",
 CellChangeTimes->{3.751574499836791*^9},
 CellLabel->"Out[51]=",ExpressionUUID->"dc7e969f-1b13-48f5-9b3c-827e49eb6af2"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"ExpandAll", "[", 
  RowBox[{"Out", "[", "51", "]"}], "]"}]], "Input",
 CellChangeTimes->{{3.751574673515648*^9, 3.751574680780367*^9}},
 CellLabel->"In[55]:=",ExpressionUUID->"63f4b314-38fa-465d-8ba3-fa1208e71123"],

Cell[BoxData[
 RowBox[{
  FractionBox[
   RowBox[{"8", " ", "\[Pi]", " ", "r", " ", 
    SuperscriptBox[
     RowBox[{"(", 
      RowBox[{"1", "-", 
       SuperscriptBox["r", "2"]}], ")"}], 
     RowBox[{"n", "/", "2"}]]}], 
   RowBox[{"2", "-", 
    RowBox[{"6", " ", 
     SuperscriptBox["r", "2"]}], "+", 
    RowBox[{"6", " ", 
     SuperscriptBox["r", "4"]}], "-", 
    RowBox[{"2", " ", 
     SuperscriptBox["r", "6"]}]}]], "-", 
  FractionBox[
   RowBox[{"8", " ", 
    SuperscriptBox["b", "2"], " ", "n", " ", "\[Pi]", " ", "r", " ", 
    SuperscriptBox[
     RowBox[{"(", 
      RowBox[{"1", "-", 
       SuperscriptBox["r", "2"]}], ")"}], 
     RowBox[{"n", "/", "2"}]]}], 
   RowBox[{"2", "-", 
    RowBox[{"6", " ", 
     SuperscriptBox["r", "2"]}], "+", 
    RowBox[{"6", " ", 
     SuperscriptBox["r", "4"]}], "-", 
    RowBox[{"2", " ", 
     SuperscriptBox["r", "6"]}]}]], "-", 
  FractionBox[
   RowBox[{"24", " ", "\[Pi]", " ", 
    SuperscriptBox["r", "3"], " ", 
    SuperscriptBox[
     RowBox[{"(", 
      RowBox[{"1", "-", 
       SuperscriptBox["r", "2"]}], ")"}], 
     RowBox[{"n", "/", "2"}]]}], 
   RowBox[{"2", "-", 
    RowBox[{"6", " ", 
     SuperscriptBox["r", "2"]}], "+", 
    RowBox[{"6", " ", 
     SuperscriptBox["r", "4"]}], "-", 
    RowBox[{"2", " ", 
     SuperscriptBox["r", "6"]}]}]], "-", 
  FractionBox[
   RowBox[{"4", " ", "n", " ", "\[Pi]", " ", 
    SuperscriptBox["r", "3"], " ", 
    SuperscriptBox[
     RowBox[{"(", 
      RowBox[{"1", "-", 
       SuperscriptBox["r", "2"]}], ")"}], 
     RowBox[{"n", "/", "2"}]]}], 
   RowBox[{"2", "-", 
    RowBox[{"6", " ", 
     SuperscriptBox["r", "2"]}], "+", 
    RowBox[{"6", " ", 
     SuperscriptBox["r", "4"]}], "-", 
    RowBox[{"2", " ", 
     SuperscriptBox["r", "6"]}]}]], "+", 
  FractionBox[
   RowBox[{"8", " ", 
    SuperscriptBox["b", "2"], " ", 
    SuperscriptBox["n", "2"], " ", "\[Pi]", " ", 
    SuperscriptBox["r", "3"], " ", 
    SuperscriptBox[
     RowBox[{"(", 
      RowBox[{"1", "-", 
       SuperscriptBox["r", "2"]}], ")"}], 
     RowBox[{"n", "/", "2"}]]}], 
   RowBox[{"2", "-", 
    RowBox[{"6", " ", 
     SuperscriptBox["r", "2"]}], "+", 
    RowBox[{"6", " ", 
     SuperscriptBox["r", "4"]}], "-", 
    RowBox[{"2", " ", 
     SuperscriptBox["r", "6"]}]}]], "+", 
  FractionBox[
   RowBox[{"24", " ", "\[Pi]", " ", 
    SuperscriptBox["r", "5"], " ", 
    SuperscriptBox[
     RowBox[{"(", 
      RowBox[{"1", "-", 
       SuperscriptBox["r", "2"]}], ")"}], 
     RowBox[{"n", "/", "2"}]]}], 
   RowBox[{"2", "-", 
    RowBox[{"6", " ", 
     SuperscriptBox["r", "2"]}], "+", 
    RowBox[{"6", " ", 
     SuperscriptBox["r", "4"]}], "-", 
    RowBox[{"2", " ", 
     SuperscriptBox["r", "6"]}]}]], "+", 
  FractionBox[
   RowBox[{"8", " ", "n", " ", "\[Pi]", " ", 
    SuperscriptBox["r", "5"], " ", 
    SuperscriptBox[
     RowBox[{"(", 
      RowBox[{"1", "-", 
       SuperscriptBox["r", "2"]}], ")"}], 
     RowBox[{"n", "/", "2"}]]}], 
   RowBox[{"2", "-", 
    RowBox[{"6", " ", 
     SuperscriptBox["r", "2"]}], "+", 
    RowBox[{"6", " ", 
     SuperscriptBox["r", "4"]}], "-", 
    RowBox[{"2", " ", 
     SuperscriptBox["r", "6"]}]}]], "-", 
  FractionBox[
   RowBox[{"2", " ", 
    SuperscriptBox["b", "2"], " ", 
    SuperscriptBox["n", "2"], " ", "\[Pi]", " ", 
    SuperscriptBox["r", "5"], " ", 
    SuperscriptBox[
     RowBox[{"(", 
      RowBox[{"1", "-", 
       SuperscriptBox["r", "2"]}], ")"}], 
     RowBox[{"n", "/", "2"}]]}], 
   RowBox[{"2", "-", 
    RowBox[{"6", " ", 
     SuperscriptBox["r", "2"]}], "+", 
    RowBox[{"6", " ", 
     SuperscriptBox["r", "4"]}], "-", 
    RowBox[{"2", " ", 
     SuperscriptBox["r", "6"]}]}]], "-", 
  FractionBox[
   RowBox[{
    SuperscriptBox["b", "2"], " ", 
    SuperscriptBox["n", "3"], " ", "\[Pi]", " ", 
    SuperscriptBox["r", "5"], " ", 
    SuperscriptBox[
     RowBox[{"(", 
      RowBox[{"1", "-", 
       SuperscriptBox["r", "2"]}], ")"}], 
     RowBox[{"n", "/", "2"}]]}], 
   RowBox[{"2", "-", 
    RowBox[{"6", " ", 
     SuperscriptBox["r", "2"]}], "+", 
    RowBox[{"6", " ", 
     SuperscriptBox["r", "4"]}], "-", 
    RowBox[{"2", " ", 
     SuperscriptBox["r", "6"]}]}]], "-", 
  FractionBox[
   RowBox[{"8", " ", "\[Pi]", " ", 
    SuperscriptBox["r", "7"], " ", 
    SuperscriptBox[
     RowBox[{"(", 
      RowBox[{"1", "-", 
       SuperscriptBox["r", "2"]}], ")"}], 
     RowBox[{"n", "/", "2"}]]}], 
   RowBox[{"2", "-", 
    RowBox[{"6", " ", 
     SuperscriptBox["r", "2"]}], "+", 
    RowBox[{"6", " ", 
     SuperscriptBox["r", "4"]}], "-", 
    RowBox[{"2", " ", 
     SuperscriptBox["r", "6"]}]}]], "-", 
  FractionBox[
   RowBox[{"4", " ", "n", " ", "\[Pi]", " ", 
    SuperscriptBox["r", "7"], " ", 
    SuperscriptBox[
     RowBox[{"(", 
      RowBox[{"1", "-", 
       SuperscriptBox["r", "2"]}], ")"}], 
     RowBox[{"n", "/", "2"}]]}], 
   RowBox[{"2", "-", 
    RowBox[{"6", " ", 
     SuperscriptBox["r", "2"]}], "+", 
    RowBox[{"6", " ", 
     SuperscriptBox["r", "4"]}], "-", 
    RowBox[{"2", " ", 
     SuperscriptBox["r", "6"]}]}]]}]], "Output",
 CellChangeTimes->{{3.751574676342149*^9, 3.7515746815039873`*^9}},
 CellLabel->"Out[55]=",ExpressionUUID->"bc5e283c-e6e3-438d-9ecd-7dbfbb536747"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"FullSimplify", "[", "%", "]"}]], "Input",
 CellChangeTimes->{{3.751574683171238*^9, 3.7515746846854897`*^9}},
 CellLabel->"In[56]:=",ExpressionUUID->"8b083bf6-586a-4956-ab61-9191c0a9a587"],

Cell[BoxData[
 RowBox[{
  RowBox[{"-", 
   FractionBox["1", "2"]}], " ", "\[Pi]", " ", "r", " ", 
  SuperscriptBox[
   RowBox[{"(", 
    RowBox[{"1", "-", 
     SuperscriptBox["r", "2"]}], ")"}], 
   RowBox[{
    FractionBox["1", "2"], " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"-", "6"}], "+", "n"}], ")"}]}]], " ", 
  RowBox[{"(", 
   RowBox[{
    RowBox[{"4", " ", 
     SuperscriptBox[
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "1"}], "+", 
        SuperscriptBox["r", "2"]}], ")"}], "2"], " ", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"-", "2"}], "+", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{"2", "+", "n"}], ")"}], " ", 
        SuperscriptBox["r", "2"]}]}], ")"}]}], "+", 
    RowBox[{
     SuperscriptBox["b", "2"], " ", "n", " ", 
     RowBox[{"(", 
      RowBox[{"8", "-", 
       RowBox[{"8", " ", "n", " ", 
        SuperscriptBox["r", "2"]}], "+", 
       RowBox[{"n", " ", 
        RowBox[{"(", 
         RowBox[{"2", "+", "n"}], ")"}], " ", 
        SuperscriptBox["r", "4"]}]}], ")"}]}]}], ")"}]}]], "Output",
 CellChangeTimes->{3.7515746849453373`*^9},
 CellLabel->"Out[56]=",ExpressionUUID->"9194cd3d-a5a6-4234-b3a4-22345119b54a"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"D", "[", 
  RowBox[{
   RowBox[{"Out", "[", "38", "]"}], ",", "b"}], "]"}]], "Input",
 CellChangeTimes->{{3.751574698048016*^9, 3.751574700345142*^9}},
 CellLabel->"In[57]:=",ExpressionUUID->"73aa2eb3-4512-4c92-9a98-7c4917ef7380"],

Cell[BoxData[
 FractionBox[
  RowBox[{"b", " ", "n", " ", "\[Pi]", " ", 
   SuperscriptBox["r", "2"], " ", 
   SuperscriptBox[
    RowBox[{"(", 
     RowBox[{"1", "-", 
      SuperscriptBox["r", "2"]}], ")"}], 
    RowBox[{"n", "/", "2"}]], " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"-", "4"}], "+", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{"2", "+", "n"}], ")"}], " ", 
      SuperscriptBox["r", "2"]}]}], ")"}]}], 
  SuperscriptBox[
   RowBox[{"(", 
    RowBox[{
     RowBox[{"-", "1"}], "+", 
     SuperscriptBox["r", "2"]}], ")"}], "2"]]], "Output",
 CellChangeTimes->{3.75157470074795*^9},
 CellLabel->"Out[57]=",ExpressionUUID->"f8ea5fbb-1cbc-4d01-8c3b-c0e0fa720bb0"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"FullSimplify", "[", "%", "]"}]], "Input",
 CellChangeTimes->{{3.751574701518138*^9, 3.751574704065548*^9}},
 CellLabel->"In[58]:=",ExpressionUUID->"bc60e938-ffc4-4650-95c2-de9137169453"],

Cell[BoxData[
 RowBox[{"b", " ", "n", " ", "\[Pi]", " ", 
  SuperscriptBox["r", "2"], " ", 
  SuperscriptBox[
   RowBox[{"(", 
    RowBox[{"1", "-", 
     SuperscriptBox["r", "2"]}], ")"}], 
   RowBox[{
    FractionBox["1", "2"], " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"-", "4"}], "+", "n"}], ")"}]}]], " ", 
  RowBox[{"(", 
   RowBox[{
    RowBox[{"-", "4"}], "+", 
    RowBox[{
     RowBox[{"(", 
      RowBox[{"2", "+", "n"}], ")"}], " ", 
     SuperscriptBox["r", "2"]}]}], ")"}]}]], "Output",
 CellChangeTimes->{3.751574704454121*^9},
 CellLabel->"Out[58]=",ExpressionUUID->"7e3a7a01-b992-4c26-a66e-df1715cce43e"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Limit", "[", 
  RowBox[{
   RowBox[{
    RowBox[{"Out", "[", "38", "]"}], " ", "/.", " ", 
    RowBox[{"n", " ", "\[Rule]", " ", "2"}]}], ",", " ", 
   RowBox[{"r", " ", "\[Rule]", " ", "1"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.7515748848280067`*^9, 3.751574905716567*^9}, {
  3.751574993845962*^9, 3.751575011396072*^9}, {3.7515751006529913`*^9, 
  3.751575100721601*^9}},
 CellLabel->"In[67]:=",ExpressionUUID->"eebbbe06-8202-483b-b0f2-85926737d128"],

Cell[BoxData[
 RowBox[{
  RowBox[{"-", "4"}], " ", 
  SuperscriptBox["b", "2"], " ", "\[Pi]"}]], "Output",
 CellChangeTimes->{
  3.75157490665672*^9, {3.7515749962636833`*^9, 3.7515750118447723`*^9}, 
   3.751575101132555*^9},
 CellLabel->"Out[67]=",ExpressionUUID->"fb58f131-b0e9-4bb7-bac7-6bd18f3fc005"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"Out", "[", "51", "]"}], " ", "/.", " ", 
  RowBox[{"n", " ", "\[Rule]", " ", "2"}]}]], "Input",
 CellChangeTimes->{{3.751575164691366*^9, 3.7515751914595346`*^9}},
 CellLabel->"In[69]:=",ExpressionUUID->"9f5e9182-fa26-44bd-a56c-27b8439cabf1"],

Cell[BoxData[
 RowBox[{"-", 
  FractionBox[
   RowBox[{"\[Pi]", " ", "r", " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"4", " ", 
       SuperscriptBox[
        RowBox[{"(", 
         RowBox[{
          RowBox[{"-", "1"}], "+", 
          SuperscriptBox["r", "2"]}], ")"}], "2"], " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"-", "2"}], "+", 
         RowBox[{"4", " ", 
          SuperscriptBox["r", "2"]}]}], ")"}]}], "+", 
      RowBox[{"2", " ", 
       SuperscriptBox["b", "2"], " ", 
       RowBox[{"(", 
        RowBox[{"8", "-", 
         RowBox[{"16", " ", 
          SuperscriptBox["r", "2"]}], "+", 
         RowBox[{"8", " ", 
          SuperscriptBox["r", "4"]}]}], ")"}]}]}], ")"}]}], 
   RowBox[{"2", " ", 
    SuperscriptBox[
     RowBox[{"(", 
      RowBox[{"1", "-", 
       SuperscriptBox["r", "2"]}], ")"}], "2"]}]]}]], "Output",
 CellChangeTimes->{{3.751575167764923*^9, 3.7515751917978077`*^9}},
 CellLabel->"Out[69]=",ExpressionUUID->"e15291d4-a7fa-496c-bf63-2dd749ca2954"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"FullSimplify", "[", "%", "]"}]], "Input",
 CellChangeTimes->{{3.7515751931537647`*^9, 3.751575194548711*^9}},
 CellLabel->"In[70]:=",ExpressionUUID->"0e12da61-d49b-42ca-aea5-a3d006d231f3"],

Cell[BoxData[
 RowBox[{
  RowBox[{"-", "4"}], " ", "\[Pi]", " ", "r", " ", 
  RowBox[{"(", 
   RowBox[{
    RowBox[{"-", "1"}], "+", 
    RowBox[{"2", " ", 
     SuperscriptBox["b", "2"]}], "+", 
    RowBox[{"2", " ", 
     SuperscriptBox["r", "2"]}]}], ")"}]}]], "Output",
 CellChangeTimes->{3.751575194803919*^9},
 CellLabel->"Out[70]=",ExpressionUUID->"f99505a3-1d6d-495b-a586-594973542974"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"D", "[", 
  RowBox[{
   RowBox[{"Out", "[", "38", "]"}], ",", "b"}], "]"}]], "Input",
 CellChangeTimes->{{3.7515753080541153`*^9, 3.75157531102306*^9}},
 CellLabel->"In[71]:=",ExpressionUUID->"9dc140dc-173d-4476-942f-aa94987faf14"],

Cell[BoxData[
 FractionBox[
  RowBox[{"b", " ", "n", " ", "\[Pi]", " ", 
   SuperscriptBox["r", "2"], " ", 
   SuperscriptBox[
    RowBox[{"(", 
     RowBox[{"1", "-", 
      SuperscriptBox["r", "2"]}], ")"}], 
    RowBox[{"n", "/", "2"}]], " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"-", "4"}], "+", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{"2", "+", "n"}], ")"}], " ", 
      SuperscriptBox["r", "2"]}]}], ")"}]}], 
  SuperscriptBox[
   RowBox[{"(", 
    RowBox[{
     RowBox[{"-", "1"}], "+", 
     SuperscriptBox["r", "2"]}], ")"}], "2"]]], "Output",
 CellChangeTimes->{3.751575311323514*^9},
 CellLabel->"Out[71]=",ExpressionUUID->"b5be5606-9782-44f9-bb6a-9e3a5df54999"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"%", " ", "/.", " ", 
  RowBox[{"n", " ", "\[Rule]", " ", "2"}]}]], "Input",
 CellChangeTimes->{{3.751575315255417*^9, 3.751575317106225*^9}},
 CellLabel->"In[72]:=",ExpressionUUID->"390ff774-84a1-4b0b-b42c-676cedfd62ad"],

Cell[BoxData[
 FractionBox[
  RowBox[{"2", " ", "b", " ", "\[Pi]", " ", 
   SuperscriptBox["r", "2"], " ", 
   RowBox[{"(", 
    RowBox[{"1", "-", 
     SuperscriptBox["r", "2"]}], ")"}], " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"-", "4"}], "+", 
     RowBox[{"4", " ", 
      SuperscriptBox["r", "2"]}]}], ")"}]}], 
  SuperscriptBox[
   RowBox[{"(", 
    RowBox[{
     RowBox[{"-", "1"}], "+", 
     SuperscriptBox["r", "2"]}], ")"}], "2"]]], "Output",
 CellChangeTimes->{3.751575317408223*^9},
 CellLabel->"Out[72]=",ExpressionUUID->"d6aac006-7d61-4f7e-9892-9e6ce149312a"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"FullSimplify", "[", "%", "]"}]], "Input",
 CellChangeTimes->{{3.751575318848689*^9, 3.751575320251236*^9}},
 CellLabel->"In[73]:=",ExpressionUUID->"c6ab7122-b118-4224-aeec-ec86947dcaa0"],

Cell[BoxData[
 RowBox[{
  RowBox[{"-", "8"}], " ", "b", " ", "\[Pi]", " ", 
  SuperscriptBox["r", "2"]}]], "Output",
 CellChangeTimes->{3.7515753205062237`*^9},
 CellLabel->"Out[73]=",ExpressionUUID->"1fbfde19-2639-4de0-bef8-7901896ffb83"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"Out", "[", "71", "]"}], " ", "/.", " ", 
  RowBox[{"n", " ", "\[Rule]", " ", "3"}]}]], "Input",
 CellChangeTimes->{{3.751575352335998*^9, 3.751575355345335*^9}},
 CellLabel->"In[74]:=",ExpressionUUID->"e6928f14-ff02-49ce-9ab2-557aa51ac57d"],

Cell[BoxData[
 FractionBox[
  RowBox[{"3", " ", "b", " ", "\[Pi]", " ", 
   SuperscriptBox["r", "2"], " ", 
   SuperscriptBox[
    RowBox[{"(", 
     RowBox[{"1", "-", 
      SuperscriptBox["r", "2"]}], ")"}], 
    RowBox[{"3", "/", "2"}]], " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"-", "4"}], "+", 
     RowBox[{"5", " ", 
      SuperscriptBox["r", "2"]}]}], ")"}]}], 
  SuperscriptBox[
   RowBox[{"(", 
    RowBox[{
     RowBox[{"-", "1"}], "+", 
     SuperscriptBox["r", "2"]}], ")"}], "2"]]], "Output",
 CellChangeTimes->{3.751575355679508*^9},
 CellLabel->"Out[74]=",ExpressionUUID->"85573fbd-676a-4383-8bfb-bd110a7c9ac5"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"FullSimplify", "[", "%", "]"}]], "Input",
 CellChangeTimes->{{3.751575356871821*^9, 3.7515753582577667`*^9}},
 CellLabel->"In[75]:=",ExpressionUUID->"b1c12649-1650-4cee-8a26-f2cd0bd72248"],

Cell[BoxData[
 FractionBox[
  RowBox[{"3", " ", "b", " ", "\[Pi]", " ", 
   SuperscriptBox["r", "2"], " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"-", "4"}], "+", 
     RowBox[{"5", " ", 
      SuperscriptBox["r", "2"]}]}], ")"}]}], 
  SqrtBox[
   RowBox[{"1", "-", 
    SuperscriptBox["r", "2"]}]]]], "Output",
 CellChangeTimes->{3.75157535851895*^9},
 CellLabel->"Out[75]=",ExpressionUUID->"f1193e11-20ed-468a-82c7-3f2bd85f8f2e"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"Out", "[", "38", "]"}], " ", "/.", " ", 
  RowBox[{"n", " ", "\[Rule]", " ", "3"}]}]], "Input",
 CellChangeTimes->{{3.7515755164818983`*^9, 3.751575519330809*^9}},
 CellLabel->"In[76]:=",ExpressionUUID->"cef8178b-43dc-409d-b3b7-83e7813c12d4"],

Cell[BoxData[
 RowBox[{
  FractionBox["1", "2"], " ", "\[Pi]", " ", 
  SuperscriptBox["r", "2"], " ", 
  SuperscriptBox[
   RowBox[{"(", 
    RowBox[{"1", "-", 
     SuperscriptBox["r", "2"]}], ")"}], 
   RowBox[{"3", "/", "2"}]], " ", 
  RowBox[{"(", 
   RowBox[{"4", "+", 
    FractionBox[
     RowBox[{"3", " ", 
      SuperscriptBox["b", "2"], " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "4"}], "+", 
        RowBox[{"5", " ", 
         SuperscriptBox["r", "2"]}]}], ")"}]}], 
     SuperscriptBox[
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "1"}], "+", 
        SuperscriptBox["r", "2"]}], ")"}], "2"]]}], ")"}]}]], "Output",
 CellChangeTimes->{3.7515755196323013`*^9},
 CellLabel->"Out[76]=",ExpressionUUID->"1a76f79e-3984-4427-8e09-4a90809bc359"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"FullSimplify", "[", "%", "]"}]], "Input",
 CellChangeTimes->{{3.751575521641057*^9, 3.751575523747919*^9}},
 CellLabel->"In[77]:=",ExpressionUUID->"93751e6a-25a8-4c1c-956a-5489051ab77e"],

Cell[BoxData[
 RowBox[{
  FractionBox["1", "2"], " ", "\[Pi]", " ", 
  SuperscriptBox["r", "2"], " ", 
  SuperscriptBox[
   RowBox[{"(", 
    RowBox[{"1", "-", 
     SuperscriptBox["r", "2"]}], ")"}], 
   RowBox[{"3", "/", "2"}]], " ", 
  RowBox[{"(", 
   RowBox[{"4", "+", 
    FractionBox[
     RowBox[{"3", " ", 
      SuperscriptBox["b", "2"], " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "4"}], "+", 
        RowBox[{"5", " ", 
         SuperscriptBox["r", "2"]}]}], ")"}]}], 
     SuperscriptBox[
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "1"}], "+", 
        SuperscriptBox["r", "2"]}], ")"}], "2"]]}], ")"}]}]], "Output",
 CellChangeTimes->{3.751575524088448*^9},
 CellLabel->"Out[77]=",ExpressionUUID->"878b27f6-3d7f-4263-b2b4-f355849657a5"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Limit", "[", 
  RowBox[{"%", ",", " ", 
   RowBox[{"r", "\[Rule]", " ", "1"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.751575526440879*^9, 3.751575531306264*^9}},
 CellLabel->"In[78]:=",ExpressionUUID->"b7bf1038-4a6d-4d32-a07a-1853b3cf3bff"],

Cell[BoxData["Indeterminate"], "Output",
 CellChangeTimes->{3.7515755328183527`*^9},
 CellLabel->"Out[78]=",ExpressionUUID->"cea5c990-cb7c-4269-88a9-e5f77c03d2c9"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"Out", "[", "51", "]"}], " ", "/.", " ", 
  RowBox[{"n", " ", "\[Rule]", " ", "3"}]}]], "Input",
 CellChangeTimes->{{3.751575674908823*^9, 3.751575678565756*^9}},
 CellLabel->"In[79]:=",ExpressionUUID->"e30dfcce-1543-4a9a-b8e1-104c5296d006"],

Cell[BoxData[
 RowBox[{"-", 
  FractionBox[
   RowBox[{"\[Pi]", " ", "r", " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"4", " ", 
       SuperscriptBox[
        RowBox[{"(", 
         RowBox[{
          RowBox[{"-", "1"}], "+", 
          SuperscriptBox["r", "2"]}], ")"}], "2"], " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"-", "2"}], "+", 
         RowBox[{"5", " ", 
          SuperscriptBox["r", "2"]}]}], ")"}]}], "+", 
      RowBox[{"3", " ", 
       SuperscriptBox["b", "2"], " ", 
       RowBox[{"(", 
        RowBox[{"8", "-", 
         RowBox[{"24", " ", 
          SuperscriptBox["r", "2"]}], "+", 
         RowBox[{"15", " ", 
          SuperscriptBox["r", "4"]}]}], ")"}]}]}], ")"}]}], 
   RowBox[{"2", " ", 
    SuperscriptBox[
     RowBox[{"(", 
      RowBox[{"1", "-", 
       SuperscriptBox["r", "2"]}], ")"}], 
     RowBox[{"3", "/", "2"}]]}]]}]], "Output",
 CellChangeTimes->{3.751575678864839*^9},
 CellLabel->"Out[79]=",ExpressionUUID->"6347e8bc-519a-43ee-81aa-12ee62e94730"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"FullSimplify", "[", "%", "]"}]], "Input",
 CellChangeTimes->{{3.751575680068796*^9, 3.751575682558982*^9}},
 CellLabel->"In[80]:=",ExpressionUUID->"61c985b9-eeb6-4b17-9cf9-6b041ff387f3"],

Cell[BoxData[
 RowBox[{"-", 
  FractionBox[
   RowBox[{"\[Pi]", " ", "r", " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"4", " ", 
       SuperscriptBox[
        RowBox[{"(", 
         RowBox[{
          RowBox[{"-", "1"}], "+", 
          SuperscriptBox["r", "2"]}], ")"}], "2"], " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"-", "2"}], "+", 
         RowBox[{"5", " ", 
          SuperscriptBox["r", "2"]}]}], ")"}]}], "+", 
      RowBox[{"3", " ", 
       SuperscriptBox["b", "2"], " ", 
       RowBox[{"(", 
        RowBox[{"8", "-", 
         RowBox[{"24", " ", 
          SuperscriptBox["r", "2"]}], "+", 
         RowBox[{"15", " ", 
          SuperscriptBox["r", "4"]}]}], ")"}]}]}], ")"}]}], 
   RowBox[{"2", " ", 
    SuperscriptBox[
     RowBox[{"(", 
      RowBox[{"1", "-", 
       SuperscriptBox["r", "2"]}], ")"}], 
     RowBox[{"3", "/", "2"}]]}]]}]], "Output",
 CellChangeTimes->{3.751575682902115*^9},
 CellLabel->"Out[80]=",ExpressionUUID->"e3386211-0f87-451b-8a7d-0a35016af7c4"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Limit", "[", 
  RowBox[{"%", ",", " ", 
   RowBox[{"r", " ", "\[Rule]", " ", "1"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.751576133082505*^9, 3.751576136530262*^9}},
 CellLabel->"In[81]:=",ExpressionUUID->"b410a9a0-b05c-45ae-96fa-5cc3c2a84ddf"],

Cell[BoxData["Indeterminate"], "Output",
 CellChangeTimes->{3.7515761372386303`*^9},
 CellLabel->"Out[81]=",ExpressionUUID->"bfc004c0-3501-4b90-a8c2-f3d41a0bddb8"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Sqrt", "[", 
  RowBox[{"1", "-", 
   RowBox[{"0.5", "^", "2"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.751576159756672*^9, 3.751576164669718*^9}},
 CellLabel->"In[82]:=",ExpressionUUID->"14d0434f-f637-4f7c-accf-69cc5b250ef7"],

Cell[BoxData["0.8660254037844386`"], "Output",
 CellChangeTimes->{3.7515761649167423`*^9},
 CellLabel->"Out[82]=",ExpressionUUID->"ac0844b0-7c4b-4d45-9c8c-d4694099f368"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Limit", "[", 
  RowBox[{
   RowBox[{
    RowBox[{"Out", "[", "51", "]"}], "/.", " ", 
    RowBox[{"n", " ", "\[Rule]", " ", "4"}]}], ",", " ", 
   RowBox[{"r", "\[Rule]", " ", "1"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.751578773987836*^9, 3.751578878390658*^9}},
 CellLabel->"In[91]:=",ExpressionUUID->"be9fe267-4b85-4224-ae17-252f7ac9ef3d"],

Cell[BoxData[
 RowBox[{"32", " ", 
  SuperscriptBox["b", "2"], " ", "\[Pi]"}]], "Output",
 CellChangeTimes->{{3.751578810205537*^9, 3.7515788431715937`*^9}, {
  3.751578873207247*^9, 3.7515788787922173`*^9}},
 CellLabel->"Out[91]=",ExpressionUUID->"83f2bce0-b6e0-4fba-b7c6-d32eb75580d7"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Limit", "[", 
  RowBox[{
   RowBox[{
    RowBox[{"Out", "[", "38", "]"}], " ", "/.", " ", 
    RowBox[{"n", " ", "\[Rule]", " ", "4"}]}], ",", " ", 
   RowBox[{"r", "\[Rule]", " ", "1"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.7515789182912197`*^9, 3.7515789285636053`*^9}},
 CellLabel->"In[92]:=",ExpressionUUID->"042f958d-7bba-475b-ad41-cd1c410db574"],

Cell[BoxData[
 RowBox[{"4", " ", 
  SuperscriptBox["b", "2"], " ", "\[Pi]"}]], "Output",
 CellChangeTimes->{3.751578929599308*^9},
 CellLabel->"Out[92]=",ExpressionUUID->"2ddedbb8-1d56-40ff-95d4-3cd17351e3dd"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"Out", "[", "38", "]"}], " ", "/.", " ", 
  RowBox[{"n", " ", "\[Rule]", " ", "4"}]}]], "Input",
 CellChangeTimes->{{3.751578956465193*^9, 3.751578959993885*^9}},
 CellLabel->"In[93]:=",ExpressionUUID->"a246d2b5-9258-4367-97e8-51bdaaa01da4"],

Cell[BoxData[
 RowBox[{
  FractionBox["1", "2"], " ", "\[Pi]", " ", 
  SuperscriptBox["r", "2"], " ", 
  SuperscriptBox[
   RowBox[{"(", 
    RowBox[{"1", "-", 
     SuperscriptBox["r", "2"]}], ")"}], "2"], " ", 
  RowBox[{"(", 
   RowBox[{"4", "+", 
    FractionBox[
     RowBox[{"4", " ", 
      SuperscriptBox["b", "2"], " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "4"}], "+", 
        RowBox[{"6", " ", 
         SuperscriptBox["r", "2"]}]}], ")"}]}], 
     SuperscriptBox[
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "1"}], "+", 
        SuperscriptBox["r", "2"]}], ")"}], "2"]]}], ")"}]}]], "Output",
 CellChangeTimes->{3.751578960805204*^9},
 CellLabel->"Out[93]=",ExpressionUUID->"ced5ddc7-5591-4a53-a56d-b1afdb53c37a"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"FullSimplify", "[", "%", "]"}]], "Input",
 CellChangeTimes->{{3.751578964935796*^9, 3.7515789676586447`*^9}},
 CellLabel->"In[94]:=",ExpressionUUID->"c9628259-7619-49a4-a079-6fdf0ccf18de"],

Cell[BoxData[
 RowBox[{"2", " ", "\[Pi]", " ", 
  SuperscriptBox["r", "2"], " ", 
  RowBox[{"(", 
   RowBox[{
    SuperscriptBox[
     RowBox[{"(", 
      RowBox[{
       RowBox[{"-", "1"}], "+", 
       SuperscriptBox["r", "2"]}], ")"}], "2"], "+", 
    RowBox[{
     SuperscriptBox["b", "2"], " ", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"-", "4"}], "+", 
       RowBox[{"6", " ", 
        SuperscriptBox["r", "2"]}]}], ")"}]}]}], ")"}]}]], "Output",
 CellChangeTimes->{3.75157896795512*^9},
 CellLabel->"Out[94]=",ExpressionUUID->"e7704b89-f1ca-4f60-849a-56ad9857413e"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"Out", "[", "38", "]"}], " ", "/.", " ", 
  RowBox[{"n", " ", "\[Rule]", "5"}]}]], "Input",
 CellChangeTimes->{{3.7515790090462713`*^9, 3.751579013334762*^9}},
 CellLabel->"In[95]:=",ExpressionUUID->"11d40462-9c0d-475b-b318-099a5ab54e9d"],

Cell[BoxData[
 RowBox[{
  FractionBox["1", "2"], " ", "\[Pi]", " ", 
  SuperscriptBox["r", "2"], " ", 
  SuperscriptBox[
   RowBox[{"(", 
    RowBox[{"1", "-", 
     SuperscriptBox["r", "2"]}], ")"}], 
   RowBox[{"5", "/", "2"}]], " ", 
  RowBox[{"(", 
   RowBox[{"4", "+", 
    FractionBox[
     RowBox[{"5", " ", 
      SuperscriptBox["b", "2"], " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "4"}], "+", 
        RowBox[{"7", " ", 
         SuperscriptBox["r", "2"]}]}], ")"}]}], 
     SuperscriptBox[
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "1"}], "+", 
        SuperscriptBox["r", "2"]}], ")"}], "2"]]}], ")"}]}]], "Output",
 CellChangeTimes->{3.751579013762233*^9},
 CellLabel->"Out[95]=",ExpressionUUID->"a798a381-81da-491c-97b2-fcfe3369c190"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"FullSimplify", "[", "%", "]"}]], "Input",
 CellChangeTimes->{{3.7515790146441603`*^9, 3.751579016047978*^9}},
 CellLabel->"In[96]:=",ExpressionUUID->"1f263930-930c-46f5-9d63-4a3c82aa885e"],

Cell[BoxData[
 RowBox[{
  FractionBox["1", "2"], " ", "\[Pi]", " ", 
  SuperscriptBox["r", "2"], " ", 
  SuperscriptBox[
   RowBox[{"(", 
    RowBox[{"1", "-", 
     SuperscriptBox["r", "2"]}], ")"}], 
   RowBox[{"5", "/", "2"}]], " ", 
  RowBox[{"(", 
   RowBox[{"4", "+", 
    FractionBox[
     RowBox[{"5", " ", 
      SuperscriptBox["b", "2"], " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "4"}], "+", 
        RowBox[{"7", " ", 
         SuperscriptBox["r", "2"]}]}], ")"}]}], 
     SuperscriptBox[
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "1"}], "+", 
        SuperscriptBox["r", "2"]}], ")"}], "2"]]}], ")"}]}]], "Output",
 CellChangeTimes->{3.751579016410754*^9},
 CellLabel->"Out[96]=",ExpressionUUID->"8f311790-c9a8-4446-aa50-86b44e85524b"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Limit", "[", 
  RowBox[{"%", ",", " ", 
   RowBox[{"r", "\[Rule]", " ", "1"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.751579018293139*^9, 3.75157902150238*^9}},
 CellLabel->"In[97]:=",ExpressionUUID->"69dbeebd-6753-408c-bfc2-38e6e0ee1eef"],

Cell[BoxData["0"], "Output",
 CellChangeTimes->{3.751579021882839*^9},
 CellLabel->"Out[97]=",ExpressionUUID->"ed9014ed-bf83-4bfa-94e4-5f28a9023f23"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"Out", "[", "38", "]"}], " ", "/.", " ", 
  RowBox[{"n", " ", "\[Rule]", " ", "2"}]}]], "Input",
 CellChangeTimes->{{3.751579044116069*^9, 3.751579047101204*^9}},
 CellLabel->"In[98]:=",ExpressionUUID->"ea6db3c6-2451-4e42-a0f1-7b2d8a305c82"],

Cell[BoxData[
 RowBox[{
  FractionBox["1", "2"], " ", "\[Pi]", " ", 
  SuperscriptBox["r", "2"], " ", 
  RowBox[{"(", 
   RowBox[{"1", "-", 
    SuperscriptBox["r", "2"]}], ")"}], " ", 
  RowBox[{"(", 
   RowBox[{"4", "+", 
    FractionBox[
     RowBox[{"2", " ", 
      SuperscriptBox["b", "2"], " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "4"}], "+", 
        RowBox[{"4", " ", 
         SuperscriptBox["r", "2"]}]}], ")"}]}], 
     SuperscriptBox[
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "1"}], "+", 
        SuperscriptBox["r", "2"]}], ")"}], "2"]]}], ")"}]}]], "Output",
 CellChangeTimes->{3.751579047381282*^9},
 CellLabel->"Out[98]=",ExpressionUUID->"d7266d03-abdd-4137-ba55-8ceffbf9f9f7"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Limit", "[", 
  RowBox[{"%", ",", " ", 
   RowBox[{"r", " ", "\[Rule]", " ", "1"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.751579049499247*^9, 3.75157905518864*^9}},
 CellLabel->"In[99]:=",ExpressionUUID->"b791223b-f6a6-43df-ae36-d00d533f4684"],

Cell[BoxData[
 RowBox[{
  RowBox[{"-", "4"}], " ", 
  SuperscriptBox["b", "2"], " ", "\[Pi]"}]], "Output",
 CellChangeTimes->{3.751579055517*^9},
 CellLabel->"Out[99]=",ExpressionUUID->"4853d9ec-e11d-4745-aa10-1fe5a338e7c6"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"Out", "[", "71", "]"}], " ", "/.", " ", 
  RowBox[{"n", " ", "\[Rule]", " ", "4"}]}]], "Input",
 CellChangeTimes->{{3.7515790956097927`*^9, 3.751579101122652*^9}},
 CellLabel->
  "In[100]:=",ExpressionUUID->"0f5935f2-80d1-46f2-960a-68380f52d09e"],

Cell[BoxData[
 FractionBox[
  RowBox[{"4", " ", "b", " ", "\[Pi]", " ", 
   SuperscriptBox["r", "2"], " ", 
   SuperscriptBox[
    RowBox[{"(", 
     RowBox[{"1", "-", 
      SuperscriptBox["r", "2"]}], ")"}], "2"], " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"-", "4"}], "+", 
     RowBox[{"6", " ", 
      SuperscriptBox["r", "2"]}]}], ")"}]}], 
  SuperscriptBox[
   RowBox[{"(", 
    RowBox[{
     RowBox[{"-", "1"}], "+", 
     SuperscriptBox["r", "2"]}], ")"}], "2"]]], "Output",
 CellChangeTimes->{3.7515791047036867`*^9},
 CellLabel->
  "Out[100]=",ExpressionUUID->"866c6d76-81a2-495f-81dd-2672b0e8febb"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Limit", "[", 
  RowBox[{"%", ",", " ", 
   RowBox[{"r", "\[Rule]", " ", "1"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.751579105872696*^9, 3.7515791096260023`*^9}},
 CellLabel->
  "In[101]:=",ExpressionUUID->"de121326-2b68-4b33-995c-ae6a87590c4b"],

Cell[BoxData[
 RowBox[{"8", " ", "b", " ", "\[Pi]"}]], "Output",
 CellChangeTimes->{3.751579110437503*^9},
 CellLabel->
  "Out[101]=",ExpressionUUID->"46c7fc64-8639-4359-8c59-496e6b7cdbe0"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Integrate", "[", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{"2", "*", "r", "*", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{"1", "-", 
         RowBox[{
          RowBox[{"(", 
           RowBox[{"r", "-", "b"}], ")"}], "^", "2"}], "-", 
         RowBox[{"4", "*", "b", "*", "r", "*", 
          RowBox[{
           RowBox[{"Sin", "[", "xi", "]"}], "^", "2"}]}]}], ")"}], "^", 
       RowBox[{"(", 
        RowBox[{"n", "/", "2"}], ")"}]}], "*", 
      RowBox[{"(", 
       RowBox[{"r", "-", "b", "+", 
        RowBox[{"2", "*", "b", "*", 
         RowBox[{
          RowBox[{"Sin", "[", "xi", "]"}], "^", "2"}]}]}], ")"}]}], " ", "/.",
      " ", 
     RowBox[{"n", " ", "\[Rule]", " ", "3"}]}], " ", "/.", " ", 
    RowBox[{"r", " ", "\[Rule]", " ", "1"}]}], ",", 
   RowBox[{"{", 
    RowBox[{"xi", ",", 
     RowBox[{
      RowBox[{"-", "Pi"}], "/", "2"}], ",", 
     RowBox[{"Pi", "/", "2"}]}], "}"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.751579161633113*^9, 3.751579190692473*^9}, {
  3.7515792651111917`*^9, 3.7515792712278967`*^9}, {3.751579352645158*^9, 
  3.7515793573712063`*^9}, {3.751580082762807*^9, 
  3.751580082841577*^9}},ExpressionUUID->"697970de-4399-4e5a-9298-\
22ad33f77418"],

Cell[BoxData[
 RowBox[{
  RowBox[{"-", "2"}], " ", 
  SuperscriptBox["b", "4"], " ", 
  RowBox[{"(", 
   RowBox[{"9", "+", 
    RowBox[{"4", " ", 
     SuperscriptBox["b", "2"]}]}], ")"}], " ", "\[Pi]"}]], "Output",
 CellChangeTimes->{
  3.7515791921801662`*^9, 3.751579265981449*^9, {3.751579351306163*^9, 
   3.751579358972334*^9}},
 CellLabel->
  "Out[106]=",ExpressionUUID->"d75bcf99-661e-422d-979e-6b03b4440d0f"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Integrate", "[", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{"2", "*", "r", "*", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{"1", "-", 
         RowBox[{
          RowBox[{"(", 
           RowBox[{"r", "-", "b"}], ")"}], "^", "2"}], "-", 
         RowBox[{"4", "*", "b", "*", "r", "*", 
          RowBox[{
           RowBox[{"Sin", "[", "xi", "]"}], "^", "2"}]}]}], ")"}], "^", 
       RowBox[{"(", 
        RowBox[{"n", "/", "2"}], ")"}]}], "*", 
      RowBox[{"(", 
       RowBox[{"r", "-", "b", "+", 
        RowBox[{"2", "*", "b", "*", 
         RowBox[{
          RowBox[{"Sin", "[", "xi", "]"}], "^", "2"}]}]}], ")"}]}], " ", "/.",
      " ", 
     RowBox[{"n", " ", "\[Rule]", " ", "3"}]}], "/.", " ", 
    RowBox[{"r", " ", "\[Rule]", " ", "1.0000001"}]}], ",", 
   RowBox[{"{", 
    RowBox[{"xi", ",", 
     RowBox[{
      RowBox[{"-", "Pi"}], "/", "2"}], ",", 
     RowBox[{"Pi", "/", "2"}]}], "}"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.751580044607285*^9, 3.751580075475382*^9}},
 CellLabel->
  "In[108]:=",ExpressionUUID->"0435fa21-61e2-497c-b413-2f1ff42c440f"],

Cell[BoxData["$Aborted"], "Output",
 CellChangeTimes->{3.751580049846704*^9, 3.751580101095954*^9},
 CellLabel->
  "Out[108]=",ExpressionUUID->"c62791c4-03c7-4b4d-a856-ca0d4560520e"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"Out", "[", "38", "]"}], " ", "/.", " ", 
  RowBox[{"n", " ", "\[Rule]", " ", "3"}]}]], "Input",
 CellChangeTimes->{{3.7515804061629744`*^9, 3.751580413610978*^9}, {
  3.7515804442124243`*^9, 3.7515804442572927`*^9}},
 CellLabel->
  "In[111]:=",ExpressionUUID->"2a377fcd-ca04-437f-aa55-8d8c28198e7d"],

Cell[BoxData[
 RowBox[{
  FractionBox["1", "2"], " ", "\[Pi]", " ", 
  SuperscriptBox["r", "2"], " ", 
  SuperscriptBox[
   RowBox[{"(", 
    RowBox[{"1", "-", 
     SuperscriptBox["r", "2"]}], ")"}], 
   RowBox[{"3", "/", "2"}]], " ", 
  RowBox[{"(", 
   RowBox[{"4", "+", 
    FractionBox[
     RowBox[{"3", " ", 
      SuperscriptBox["b", "2"], " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "4"}], "+", 
        RowBox[{"5", " ", 
         SuperscriptBox["r", "2"]}]}], ")"}]}], 
     SuperscriptBox[
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "1"}], "+", 
        SuperscriptBox["r", "2"]}], ")"}], "2"]]}], ")"}]}]], "Output",
 CellChangeTimes->{3.75158041392653*^9, 3.751580445076908*^9},
 CellLabel->
  "Out[111]=",ExpressionUUID->"918e06f7-901b-4dd3-b912-b88acf04b97f"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"FullSimplify", "[", "%", "]"}]], "Input",
 CellChangeTimes->{{3.7515804154171658`*^9, 3.751580417491838*^9}},
 CellLabel->
  "In[112]:=",ExpressionUUID->"bddc603f-ba3e-439c-92f0-54226427ba52"],

Cell[BoxData[
 RowBox[{
  FractionBox["1", "2"], " ", "\[Pi]", " ", 
  SuperscriptBox["r", "2"], " ", 
  SuperscriptBox[
   RowBox[{"(", 
    RowBox[{"1", "-", 
     SuperscriptBox["r", "2"]}], ")"}], 
   RowBox[{"3", "/", "2"}]], " ", 
  RowBox[{"(", 
   RowBox[{"4", "+", 
    FractionBox[
     RowBox[{"3", " ", 
      SuperscriptBox["b", "2"], " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "4"}], "+", 
        RowBox[{"5", " ", 
         SuperscriptBox["r", "2"]}]}], ")"}]}], 
     SuperscriptBox[
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "1"}], "+", 
        SuperscriptBox["r", "2"]}], ")"}], "2"]]}], ")"}]}]], "Output",
 CellChangeTimes->{{3.75158041782557*^9, 3.751580447059565*^9}},
 CellLabel->
  "Out[112]=",ExpressionUUID->"bd9e1ed0-346e-4595-ba89-bedb2162175b"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"Out", "[", "112", "]"}], "/.", " ", 
  RowBox[{"r", " ", "->", " ", 
   RowBox[{"1", "-", "eps"}]}]}]], "Input",
 CellChangeTimes->{{3.751580455766773*^9, 3.75158047885546*^9}, {
  3.751580510935902*^9, 3.7515805121964283`*^9}},
 CellLabel->
  "In[117]:=",ExpressionUUID->"cf6c7ff9-5593-41a8-a80d-5b7ec2955384"],

Cell[BoxData[
 RowBox[{
  FractionBox["1", "2"], " ", 
  RowBox[{"(", 
   RowBox[{"4", "+", 
    FractionBox[
     RowBox[{"3", " ", 
      SuperscriptBox["b", "2"], " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "4"}], "+", 
        RowBox[{"5", " ", 
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{"1", "-", "eps"}], ")"}], "2"]}]}], ")"}]}], 
     SuperscriptBox[
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "1"}], "+", 
        SuperscriptBox[
         RowBox[{"(", 
          RowBox[{"1", "-", "eps"}], ")"}], "2"]}], ")"}], "2"]]}], ")"}], 
  " ", 
  SuperscriptBox[
   RowBox[{"(", 
    RowBox[{"1", "-", 
     SuperscriptBox[
      RowBox[{"(", 
       RowBox[{"1", "-", "eps"}], ")"}], "2"]}], ")"}], 
   RowBox[{"3", "/", "2"}]], " ", 
  SuperscriptBox[
   RowBox[{"(", 
    RowBox[{"1", "-", "eps"}], ")"}], "2"], " ", "\[Pi]"}]], "Output",
 CellChangeTimes->{{3.751580462754732*^9, 3.751580479314838*^9}, 
   3.751580512995695*^9},
 CellLabel->
  "Out[117]=",ExpressionUUID->"07a04169-5eb3-4e17-9cde-760bbe40a0e8"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"FullSimplify", "[", "%", "]"}]], "Input",
 CellChangeTimes->{{3.751580480949665*^9, 3.7515804833202953`*^9}},
 CellLabel->
  "In[118]:=",ExpressionUUID->"e254bd5c-3973-4fc5-893b-759b422ab8e1"],

Cell[BoxData[
 RowBox[{
  FractionBox["1", "2"], " ", 
  SuperscriptBox[
   RowBox[{"(", 
    RowBox[{
     RowBox[{"-", "1"}], "+", "eps"}], ")"}], "2"], " ", 
  SuperscriptBox[
   RowBox[{"(", 
    RowBox[{
     RowBox[{"-", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "2"}], "+", "eps"}], ")"}]}], " ", "eps"}], ")"}], 
   RowBox[{"3", "/", "2"}]], " ", 
  RowBox[{"(", 
   RowBox[{"4", "+", 
    FractionBox[
     RowBox[{"3", " ", 
      SuperscriptBox["b", "2"], " ", 
      RowBox[{"(", 
       RowBox[{"1", "+", 
        RowBox[{"5", " ", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"-", "2"}], "+", "eps"}], ")"}], " ", "eps"}]}], ")"}]}], 
     RowBox[{
      SuperscriptBox[
       RowBox[{"(", 
        RowBox[{
         RowBox[{"-", "2"}], "+", "eps"}], ")"}], "2"], " ", 
      SuperscriptBox["eps", "2"]}]]}], ")"}], " ", "\[Pi]"}]], "Output",
 CellChangeTimes->{3.751580483873356*^9, 3.751580515139243*^9},
 CellLabel->
  "Out[118]=",ExpressionUUID->"ea25120c-eef5-4741-a201-8d4e5cee972d"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Series", "[", 
  RowBox[{"%", ",", 
   RowBox[{"{", 
    RowBox[{"eps", ",", "0", ",", "3"}], "}"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.7515805532283154`*^9, 3.751580557581332*^9}},
 CellLabel->
  "In[119]:=",ExpressionUUID->"28a3058c-3f73-4b83-9793-c0f2939d2081"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
   FractionBox[
    RowBox[{"3", " ", 
     SuperscriptBox["b", "2"], " ", "\[Pi]"}], 
    RowBox[{"2", " ", 
     SqrtBox["2"], " ", 
     SqrtBox["eps"]}]], "-", 
   FractionBox[
    RowBox[{"141", " ", 
     RowBox[{"(", 
      RowBox[{
       SuperscriptBox["b", "2"], " ", "\[Pi]"}], ")"}], " ", 
     SqrtBox["eps"]}], 
    RowBox[{"8", " ", 
     SqrtBox["2"]}]], "+", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      RowBox[{"4", " ", 
       SqrtBox["2"], " ", "\[Pi]"}], "+", 
      FractionBox[
       RowBox[{"2217", " ", 
        SuperscriptBox["b", "2"], " ", "\[Pi]"}], 
       RowBox[{"64", " ", 
        SqrtBox["2"]}]]}], ")"}], " ", 
    SuperscriptBox["eps", 
     RowBox[{"3", "/", "2"}]]}], "+", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      RowBox[{
       RowBox[{"-", "11"}], " ", 
       SqrtBox["2"], " ", "\[Pi]"}], "-", 
      FractionBox[
       RowBox[{"5601", " ", 
        SuperscriptBox["b", "2"], " ", "\[Pi]"}], 
       RowBox[{"256", " ", 
        SqrtBox["2"]}]]}], ")"}], " ", 
    SuperscriptBox["eps", 
     RowBox[{"5", "/", "2"}]]}], "+", 
   InterpretationBox[
    SuperscriptBox[
     RowBox[{"O", "[", "eps", "]"}], 
     RowBox[{"7", "/", "2"}]],
    SeriesData[$CellContext`eps, 0, {}, -1, 7, 2],
    Editable->False]}],
  SeriesData[$CellContext`eps, 0, {
   Rational[3, 2] 2^Rational[-1, 2] $CellContext`b^2 Pi, 0, Rational[-141, 8] 
    2^Rational[-1, 2] $CellContext`b^2 Pi, 0, 4 2^Rational[1, 2] Pi + 
    Rational[2217, 64] 2^Rational[-1, 2] $CellContext`b^2 Pi, 
    0, (-11) 2^Rational[1, 2] Pi + 
    Rational[-5601, 256] 2^Rational[-1, 2] $CellContext`b^2 Pi}, -1, 7, 2],
  Editable->False]], "Output",
 CellChangeTimes->{3.751580558111998*^9},
 CellLabel->
  "Out[119]=",ExpressionUUID->"48982771-6251-4d1e-a029-090716cf380c"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"FullSimplify", "[", "%", "]"}]], "Input",
 CellChangeTimes->{{3.7515805593162737`*^9, 3.751580560934821*^9}},
 CellLabel->
  "In[120]:=",ExpressionUUID->"48342f30-7a9b-4aec-a680-99148983eb87"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
   FractionBox[
    RowBox[{"3", " ", 
     SuperscriptBox["b", "2"], " ", "\[Pi]"}], 
    RowBox[{"2", " ", 
     SqrtBox["2"], " ", 
     SqrtBox["eps"]}]], "-", 
   FractionBox[
    RowBox[{"141", " ", 
     RowBox[{"(", 
      RowBox[{
       SuperscriptBox["b", "2"], " ", "\[Pi]"}], ")"}], " ", 
     SqrtBox["eps"]}], 
    RowBox[{"8", " ", 
     SqrtBox["2"]}]], "+", 
   FractionBox[
    RowBox[{
     RowBox[{"(", 
      RowBox[{"512", "+", 
       RowBox[{"2217", " ", 
        SuperscriptBox["b", "2"]}]}], ")"}], " ", "\[Pi]", " ", 
     SuperscriptBox["eps", 
      RowBox[{"3", "/", "2"}]]}], 
    RowBox[{"64", " ", 
     SqrtBox["2"]}]], "-", 
   FractionBox[
    RowBox[{
     RowBox[{"(", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{"5632", "+", 
         RowBox[{"5601", " ", 
          SuperscriptBox["b", "2"]}]}], ")"}], " ", "\[Pi]"}], ")"}], " ", 
     SuperscriptBox["eps", 
      RowBox[{"5", "/", "2"}]]}], 
    RowBox[{"256", " ", 
     SqrtBox["2"]}]], "+", 
   InterpretationBox[
    SuperscriptBox[
     RowBox[{"O", "[", "eps", "]"}], 
     RowBox[{"7", "/", "2"}]],
    SeriesData[$CellContext`eps, 0, {}, -1, 7, 2],
    Editable->False]}],
  SeriesData[$CellContext`eps, 0, {
   Rational[3, 2] 2^Rational[-1, 2] $CellContext`b^2 Pi, 0, Rational[-141, 8] 
    2^Rational[-1, 2] $CellContext`b^2 Pi, 0, Rational[1, 64] 
    2^Rational[-1, 2] (512 + 2217 $CellContext`b^2) Pi, 0, Rational[-1, 256] 
    2^Rational[-1, 2] (5632 + 5601 $CellContext`b^2) Pi}, -1, 7, 2],
  Editable->False]], "Output",
 CellChangeTimes->{3.751580561216887*^9},
 CellLabel->
  "Out[120]=",ExpressionUUID->"a94c886d-87c4-437d-ba55-1b7c7c819348"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"Out", "[", "38", "]"}], " ", "/.", " ", 
  RowBox[{"n", "\[Rule]", " ", "4"}]}]], "Input",
 CellChangeTimes->{{3.751580610549457*^9, 3.751580620382637*^9}},
 CellLabel->
  "In[122]:=",ExpressionUUID->"a708ad45-996f-4b17-a09e-93482b2cbb73"],

Cell[BoxData[
 RowBox[{
  FractionBox["1", "2"], " ", "\[Pi]", " ", 
  SuperscriptBox["r", "2"], " ", 
  SuperscriptBox[
   RowBox[{"(", 
    RowBox[{"1", "-", 
     SuperscriptBox["r", "2"]}], ")"}], "2"], " ", 
  RowBox[{"(", 
   RowBox[{"4", "+", 
    FractionBox[
     RowBox[{"4", " ", 
      SuperscriptBox["b", "2"], " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "4"}], "+", 
        RowBox[{"6", " ", 
         SuperscriptBox["r", "2"]}]}], ")"}]}], 
     SuperscriptBox[
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "1"}], "+", 
        SuperscriptBox["r", "2"]}], ")"}], "2"]]}], ")"}]}]], "Output",
 CellChangeTimes->{{3.751580615466979*^9, 3.751580620725738*^9}},
 CellLabel->
  "Out[122]=",ExpressionUUID->"7d831a0a-f787-4922-a835-5efb0651519a"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"FullSimplify", "[", "%", "]"}]], "Input",
 CellChangeTimes->{{3.7515806217098207`*^9, 3.751580623231717*^9}},
 CellLabel->
  "In[123]:=",ExpressionUUID->"073b686d-d825-4a1a-a418-dd5d32541cbf"],

Cell[BoxData[
 RowBox[{"2", " ", "\[Pi]", " ", 
  SuperscriptBox["r", "2"], " ", 
  RowBox[{"(", 
   RowBox[{
    SuperscriptBox[
     RowBox[{"(", 
      RowBox[{
       RowBox[{"-", "1"}], "+", 
       SuperscriptBox["r", "2"]}], ")"}], "2"], "+", 
    RowBox[{
     SuperscriptBox["b", "2"], " ", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"-", "4"}], "+", 
       RowBox[{"6", " ", 
        SuperscriptBox["r", "2"]}]}], ")"}]}]}], ")"}]}]], "Output",
 CellChangeTimes->{3.751580623516007*^9},
 CellLabel->
  "Out[123]=",ExpressionUUID->"a60614c9-2024-4b9d-bb36-9f3bbbc1047b"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Integrate", "[", 
  RowBox[{
   RowBox[{"2", "*", "r", "*", 
    RowBox[{
     RowBox[{"(", 
      RowBox[{"1", "-", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{"r", "-", "b"}], ")"}], "^", "2"}], "-", 
       RowBox[{"4", "*", "b", "*", "r", "*", 
        RowBox[{
         RowBox[{"Sin", "[", "xi", "]"}], "^", "2"}]}]}], ")"}], "^", "2"}], 
    "*", 
    RowBox[{"(", 
     RowBox[{"r", "-", "b", "+", 
      RowBox[{"2", "*", "b", "*", 
       RowBox[{
        RowBox[{"Sin", "[", "xi", "]"}], "^", "2"}]}]}], ")"}]}], ",", 
   RowBox[{"{", 
    RowBox[{"xi", ",", 
     RowBox[{
      RowBox[{"-", "Pi"}], "/", "2"}], ",", 
     RowBox[{"Pi", "/", "2"}]}], "}"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.751580694174644*^9, 3.7515807436249533`*^9}, {
  3.751580793199328*^9, 3.751580823492618*^9}},
 CellLabel->
  "In[124]:=",ExpressionUUID->"ba7464e0-0f4c-4be4-91bc-069bd26c2b72"],

Cell[BoxData[
 RowBox[{"2", " ", "\[Pi]", " ", 
  SuperscriptBox["r", "2"], " ", 
  RowBox[{"(", 
   RowBox[{
    RowBox[{"3", " ", 
     SuperscriptBox["b", "4"]}], "+", 
    SuperscriptBox[
     RowBox[{"(", 
      RowBox[{
       RowBox[{"-", "1"}], "+", 
       SuperscriptBox["r", "2"]}], ")"}], "2"], "+", 
    RowBox[{
     SuperscriptBox["b", "2"], " ", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"-", "4"}], "+", 
       RowBox[{"6", " ", 
        SuperscriptBox["r", "2"]}]}], ")"}]}]}], ")"}]}]], "Output",
 CellChangeTimes->{3.751580827210991*^9},
 CellLabel->
  "Out[124]=",ExpressionUUID->"18c1cc0e-c37a-44dd-a698-918431501db8"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"FullSimplify", "[", "%", "]"}]], "Input",
 CellChangeTimes->{{3.7515808333188047`*^9, 3.7515808348097687`*^9}},
 CellLabel->
  "In[125]:=",ExpressionUUID->"8a1a492f-ac6d-48e6-947e-6ec11a874e5e"],

Cell[BoxData[
 RowBox[{"2", " ", "\[Pi]", " ", 
  SuperscriptBox["r", "2"], " ", 
  RowBox[{"(", 
   RowBox[{
    RowBox[{"3", " ", 
     SuperscriptBox["b", "4"]}], "+", 
    SuperscriptBox[
     RowBox[{"(", 
      RowBox[{
       RowBox[{"-", "1"}], "+", 
       SuperscriptBox["r", "2"]}], ")"}], "2"], "+", 
    RowBox[{
     SuperscriptBox["b", "2"], " ", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"-", "4"}], "+", 
       RowBox[{"6", " ", 
        SuperscriptBox["r", "2"]}]}], ")"}]}]}], ")"}]}]], "Output",
 CellChangeTimes->{3.75158083513739*^9},
 CellLabel->
  "Out[125]=",ExpressionUUID->"840444e1-9bc0-496c-921e-78d7027fe627"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Series", "[", 
  RowBox[{
   RowBox[{
    RowBox[{"2", "*", "r", "*", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{"1", "-", 
        RowBox[{
         RowBox[{"(", 
          RowBox[{"r", "-", "b"}], ")"}], "^", "2"}], "-", 
        RowBox[{"4", "*", "b", "*", "r", "*", 
         RowBox[{
          RowBox[{"Sin", "[", "xi", "]"}], "^", "2"}]}]}], ")"}], "^", 
      RowBox[{"(", 
       RowBox[{"n", "/", "2"}], ")"}]}], "*", 
     RowBox[{"(", 
      RowBox[{"r", "-", "b", "+", 
       RowBox[{"2", "*", "b", "*", 
        RowBox[{
         RowBox[{"Sin", "[", "xi", "]"}], "^", "2"}]}]}], ")"}]}], " ", "/.", 
    " ", 
    RowBox[{"r", " ", "\[Rule]", " ", 
     RowBox[{"1", "-", "eps"}]}]}], ",", 
   RowBox[{"{", 
    RowBox[{"b", ",", "0", ",", "3"}], "}"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.751581304370858*^9, 3.7515813109947367`*^9}},
 CellLabel->
  "In[126]:=",ExpressionUUID->"e46241ed-1536-41f7-8bd2-730188e23aba"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
   RowBox[{"2", " ", 
    SuperscriptBox[
     RowBox[{"(", 
      RowBox[{
       RowBox[{"-", "1"}], "+", "eps"}], ")"}], "2"], " ", 
    SuperscriptBox[
     RowBox[{"(", 
      RowBox[{
       RowBox[{"2", " ", "eps"}], "-", 
       SuperscriptBox["eps", "2"]}], ")"}], 
     RowBox[{"n", "/", "2"}]]}], "-", 
   FractionBox[
    RowBox[{"2", " ", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{
         RowBox[{"-", "1"}], "+", "eps"}], ")"}], " ", 
       SuperscriptBox[
        RowBox[{"(", 
         RowBox[{
          RowBox[{"2", " ", "eps"}], "-", 
          SuperscriptBox["eps", "2"]}], ")"}], 
        RowBox[{"n", "/", "2"}]], " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{
          RowBox[{"-", "2"}], " ", "eps"}], "+", 
         SuperscriptBox["eps", "2"], "+", "n", "-", 
         RowBox[{"2", " ", "eps", " ", "n"}], "+", 
         RowBox[{
          SuperscriptBox["eps", "2"], " ", "n"}]}], ")"}], " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"-", "1"}], "+", 
         RowBox[{"2", " ", 
          SuperscriptBox[
           RowBox[{"Sin", "[", "xi", "]"}], "2"]}]}], ")"}]}], ")"}], " ", 
     "b"}], 
    RowBox[{
     RowBox[{"(", 
      RowBox[{
       RowBox[{"-", "2"}], "+", "eps"}], ")"}], " ", "eps"}]], "+", 
   RowBox[{
    FractionBox["1", 
     RowBox[{
      SuperscriptBox[
       RowBox[{"(", 
        RowBox[{
         RowBox[{"-", "2"}], "+", "eps"}], ")"}], "2"], " ", 
      SuperscriptBox["eps", "2"]}]], 
    RowBox[{
     SuperscriptBox[
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "1"}], "+", "eps"}], ")"}], "2"], " ", 
     SuperscriptBox[
      RowBox[{"(", 
       RowBox[{
        RowBox[{"2", " ", "eps"}], "-", 
        SuperscriptBox["eps", "2"]}], ")"}], 
      RowBox[{"n", "/", "2"}]], " ", "n", " ", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"-", "2"}], "-", 
       RowBox[{"2", " ", "eps"}], "+", 
       SuperscriptBox["eps", "2"], "+", "n", "-", 
       RowBox[{"2", " ", "eps", " ", "n"}], "+", 
       RowBox[{
        SuperscriptBox["eps", "2"], " ", "n"}], "+", 
       RowBox[{"8", " ", 
        SuperscriptBox[
         RowBox[{"Sin", "[", "xi", "]"}], "2"]}], "-", 
       RowBox[{"4", " ", "n", " ", 
        SuperscriptBox[
         RowBox[{"Sin", "[", "xi", "]"}], "2"]}], "+", 
       RowBox[{"8", " ", "eps", " ", "n", " ", 
        SuperscriptBox[
         RowBox[{"Sin", "[", "xi", "]"}], "2"]}], "-", 
       RowBox[{"4", " ", 
        SuperscriptBox["eps", "2"], " ", "n", " ", 
        SuperscriptBox[
         RowBox[{"Sin", "[", "xi", "]"}], "2"]}], "-", 
       RowBox[{"8", " ", 
        SuperscriptBox[
         RowBox[{"Sin", "[", "xi", "]"}], "4"]}], "+", 
       RowBox[{"4", " ", "n", " ", 
        SuperscriptBox[
         RowBox[{"Sin", "[", "xi", "]"}], "4"]}], "-", 
       RowBox[{"8", " ", "eps", " ", "n", " ", 
        SuperscriptBox[
         RowBox[{"Sin", "[", "xi", "]"}], "4"]}], "+", 
       RowBox[{"4", " ", 
        SuperscriptBox["eps", "2"], " ", "n", " ", 
        SuperscriptBox[
         RowBox[{"Sin", "[", "xi", "]"}], "4"]}]}], ")"}], " ", 
     SuperscriptBox["b", "2"]}]}], "+", 
   RowBox[{"2", " ", 
    RowBox[{"(", 
     RowBox[{"1", "-", "eps"}], ")"}], " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{
       RowBox[{"(", 
        RowBox[{
         RowBox[{"-", "1"}], "+", 
         RowBox[{"2", " ", 
          SuperscriptBox[
           RowBox[{"Sin", "[", "xi", "]"}], "2"]}]}], ")"}], " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{
          RowBox[{"-", 
           FractionBox["1", "2"]}], " ", 
          SuperscriptBox[
           RowBox[{"(", 
            RowBox[{
             RowBox[{"2", " ", "eps"}], "-", 
             SuperscriptBox["eps", "2"]}], ")"}], 
           RowBox[{
            RowBox[{"-", "1"}], "+", 
            FractionBox["n", "2"]}]], " ", "n"}], "+", 
         RowBox[{
          FractionBox["1", "4"], " ", 
          SuperscriptBox[
           RowBox[{"(", 
            RowBox[{
             RowBox[{"2", " ", "eps"}], "-", 
             SuperscriptBox["eps", "2"]}], ")"}], 
           RowBox[{
            RowBox[{"-", "2"}], "+", 
            FractionBox["n", "2"]}]], " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"-", "1"}], "+", 
            FractionBox["n", "2"]}], ")"}], " ", "n", " ", 
          SuperscriptBox[
           RowBox[{"(", 
            RowBox[{"2", "-", 
             RowBox[{"2", " ", "eps"}], "-", 
             RowBox[{"4", " ", 
              SuperscriptBox[
               RowBox[{"Sin", "[", "xi", "]"}], "2"]}], "+", 
             RowBox[{"4", " ", "eps", " ", 
              SuperscriptBox[
               RowBox[{"Sin", "[", "xi", "]"}], "2"]}]}], ")"}], "2"]}]}], 
        ")"}]}], "+", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{"1", "-", "eps"}], ")"}], " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{
          FractionBox["1", "4"], " ", 
          SuperscriptBox[
           RowBox[{"(", 
            RowBox[{
             RowBox[{"2", " ", "eps"}], "-", 
             SuperscriptBox["eps", "2"]}], ")"}], 
           RowBox[{
            RowBox[{"-", "2"}], "+", 
            FractionBox["n", "2"]}]], " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"-", "1"}], "+", 
            FractionBox["n", "2"]}], ")"}], " ", "n", " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"-", "4"}], "+", 
            RowBox[{"4", " ", "eps"}], "+", 
            RowBox[{"8", " ", 
             SuperscriptBox[
              RowBox[{"Sin", "[", "xi", "]"}], "2"]}], "-", 
            RowBox[{"8", " ", "eps", " ", 
             SuperscriptBox[
              RowBox[{"Sin", "[", "xi", "]"}], "2"]}]}], ")"}]}], "+", 
         RowBox[{
          FractionBox["1", "12"], " ", 
          SuperscriptBox[
           RowBox[{"(", 
            RowBox[{
             RowBox[{"2", " ", "eps"}], "-", 
             SuperscriptBox["eps", "2"]}], ")"}], 
           RowBox[{
            RowBox[{"-", "3"}], "+", 
            FractionBox["n", "2"]}]], " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"-", "2"}], "+", 
            FractionBox["n", "2"]}], ")"}], " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"-", "1"}], "+", 
            FractionBox["n", "2"]}], ")"}], " ", "n", " ", 
          SuperscriptBox[
           RowBox[{"(", 
            RowBox[{"2", "-", 
             RowBox[{"2", " ", "eps"}], "-", 
             RowBox[{"4", " ", 
              SuperscriptBox[
               RowBox[{"Sin", "[", "xi", "]"}], "2"]}], "+", 
             RowBox[{"4", " ", "eps", " ", 
              SuperscriptBox[
               RowBox[{"Sin", "[", "xi", "]"}], "2"]}]}], ")"}], "3"]}]}], 
        ")"}]}]}], ")"}], " ", 
    SuperscriptBox["b", "3"]}], "+", 
   InterpretationBox[
    SuperscriptBox[
     RowBox[{"O", "[", "b", "]"}], "4"],
    SeriesData[$CellContext`b, 0, {}, 0, 4, 1],
    Editable->False]}],
  SeriesData[$CellContext`b, 0, {
   2 (-1 + $CellContext`eps)^2 (2 $CellContext`eps - $CellContext`eps^2)^(
      Rational[1, 
        2] $CellContext`n), (-2) (-2 + $CellContext`eps)^(-1) (-1 + \
$CellContext`eps) $CellContext`eps^(-1) (
      2 $CellContext`eps - $CellContext`eps^2)^(
      Rational[1, 
        2] $CellContext`n) ((-2) $CellContext`eps + $CellContext`eps^2 + \
$CellContext`n - 
     2 $CellContext`eps $CellContext`n + $CellContext`eps^2 $CellContext`n) \
(-1 + 2 Sin[$CellContext`xi]^2), (-2 + $CellContext`eps)^(-2) (-1 + \
$CellContext`eps)^2 $CellContext`eps^(-2) (
      2 $CellContext`eps - $CellContext`eps^2)^(
      Rational[1, 2] $CellContext`n) $CellContext`n (-2 - 
     2 $CellContext`eps + $CellContext`eps^2 + $CellContext`n - 
     2 $CellContext`eps $CellContext`n + $CellContext`eps^2 $CellContext`n + 
     8 Sin[$CellContext`xi]^2 - 4 $CellContext`n Sin[$CellContext`xi]^2 + 
     8 $CellContext`eps $CellContext`n Sin[$CellContext`xi]^2 - 
     4 $CellContext`eps^2 $CellContext`n Sin[$CellContext`xi]^2 - 8 
     Sin[$CellContext`xi]^4 + 4 $CellContext`n Sin[$CellContext`xi]^4 - 
     8 $CellContext`eps $CellContext`n Sin[$CellContext`xi]^4 + 
     4 $CellContext`eps^2 $CellContext`n Sin[$CellContext`xi]^4), 
    2 (1 - $CellContext`eps) ((-1 + 2 Sin[$CellContext`xi]^2) (
       Rational[-1, 2] (2 $CellContext`eps - $CellContext`eps^2)^(-1 + 
          Rational[1, 2] $CellContext`n) $CellContext`n + 
       Rational[
         1, 4] (2 $CellContext`eps - $CellContext`eps^2)^(-2 + 
          Rational[1, 2] $CellContext`n) (-1 + 
         Rational[1, 2] $CellContext`n) $CellContext`n (2 - 
          2 $CellContext`eps - 4 Sin[$CellContext`xi]^2 + 
          4 $CellContext`eps Sin[$CellContext`xi]^2)^2) + (
       1 - $CellContext`eps) (
       Rational[
         1, 4] (2 $CellContext`eps - $CellContext`eps^2)^(-2 + 
          Rational[1, 2] $CellContext`n) (-1 + 
         Rational[1, 2] $CellContext`n) $CellContext`n (-4 + 
         4 $CellContext`eps + 8 Sin[$CellContext`xi]^2 - 8 $CellContext`eps 
         Sin[$CellContext`xi]^2) + 
       Rational[
         1, 12] (2 $CellContext`eps - $CellContext`eps^2)^(-3 + 
          Rational[1, 2] $CellContext`n) (-2 + 
         Rational[1, 2] $CellContext`n) (-1 + 
         Rational[1, 2] $CellContext`n) $CellContext`n (2 - 
          2 $CellContext`eps - 4 Sin[$CellContext`xi]^2 + 
          4 $CellContext`eps Sin[$CellContext`xi]^2)^3))}, 0, 4, 1],
  Editable->False]], "Output",
 CellChangeTimes->{3.75158131330726*^9},
 CellLabel->
  "Out[126]=",ExpressionUUID->"330a52a4-4f5c-49be-a4c5-80b7590b89c8"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"FullSimplify", "[", "%", "]"}]], "Input",
 CellChangeTimes->{{3.751581314622281*^9, 3.7515813167374363`*^9}},
 CellLabel->
  "In[127]:=",ExpressionUUID->"b77887f9-c471-4142-b343-76a9c811747a"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
   RowBox[{"2", " ", 
    SuperscriptBox[
     RowBox[{"(", 
      RowBox[{
       RowBox[{"-", "1"}], "+", "eps"}], ")"}], "2"], " ", 
    SuperscriptBox[
     RowBox[{"(", 
      RowBox[{
       RowBox[{"-", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"-", "2"}], "+", "eps"}], ")"}]}], " ", "eps"}], ")"}], 
     RowBox[{"n", "/", "2"}]]}], "-", 
   RowBox[{"2", " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "1"}], "+", "eps"}], ")"}], " ", 
      SuperscriptBox[
       RowBox[{"(", 
        RowBox[{
         RowBox[{"-", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"-", "2"}], "+", "eps"}], ")"}]}], " ", "eps"}], ")"}], 
       RowBox[{
        FractionBox["1", "2"], " ", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"-", "2"}], "+", "n"}], ")"}]}]], " ", 
      RowBox[{"(", 
       RowBox[{"n", "+", 
        RowBox[{
         RowBox[{"(", 
          RowBox[{
           RowBox[{"-", "2"}], "+", "eps"}], ")"}], " ", "eps", " ", 
         RowBox[{"(", 
          RowBox[{"1", "+", "n"}], ")"}]}]}], ")"}], " ", 
      RowBox[{"Cos", "[", 
       RowBox[{"2", " ", "xi"}], "]"}]}], ")"}], " ", "b"}], "+", 
   RowBox[{
    FractionBox["1", "2"], " ", 
    SuperscriptBox[
     RowBox[{"(", 
      RowBox[{
       RowBox[{"-", "1"}], "+", "eps"}], ")"}], "2"], " ", 
    SuperscriptBox[
     RowBox[{"(", 
      RowBox[{
       RowBox[{"-", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"-", "2"}], "+", "eps"}], ")"}]}], " ", "eps"}], ")"}], 
     RowBox[{
      FractionBox["1", "2"], " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "4"}], "+", "n"}], ")"}]}]], " ", "n", " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"-", "2"}], "+", "n", "+", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{
         RowBox[{"-", "2"}], "+", "eps"}], ")"}], " ", "eps", " ", 
       RowBox[{"(", 
        RowBox[{"2", "+", "n"}], ")"}]}], "+", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{
         RowBox[{"-", "2"}], "+", 
         RowBox[{
          SuperscriptBox[
           RowBox[{"(", 
            RowBox[{
             RowBox[{"-", "1"}], "+", "eps"}], ")"}], "2"], " ", "n"}]}], 
        ")"}], " ", 
       RowBox[{"Cos", "[", 
        RowBox[{"4", " ", "xi"}], "]"}]}]}], ")"}], " ", 
    SuperscriptBox["b", "2"]}], "-", 
   RowBox[{
    FractionBox["1", "6"], " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "1"}], "+", "eps"}], ")"}], " ", 
      SuperscriptBox[
       RowBox[{"(", 
        RowBox[{
         RowBox[{"-", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"-", "2"}], "+", "eps"}], ")"}]}], " ", "eps"}], ")"}], 
       RowBox[{
        FractionBox["1", "2"], " ", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"-", "6"}], "+", "n"}], ")"}]}]], " ", "n", " ", 
      RowBox[{"Cos", "[", 
       RowBox[{"2", " ", "xi"}], "]"}], " ", 
      RowBox[{"(", 
       RowBox[{"8", "+", 
        RowBox[{"2", " ", "eps", " ", 
         RowBox[{"(", 
          RowBox[{"2", "+", 
           RowBox[{"eps", " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", "9"}], "-", 
              RowBox[{"2", " ", 
               RowBox[{"(", 
                RowBox[{
                 RowBox[{"-", "4"}], "+", "eps"}], ")"}], " ", "eps"}]}], 
             ")"}]}]}], ")"}]}], "+", 
        RowBox[{"3", " ", 
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{
            RowBox[{"-", "1"}], "+", "eps"}], ")"}], "2"], " ", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"-", "2"}], "+", 
           RowBox[{
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", "2"}], "+", "eps"}], ")"}], " ", "eps"}]}], ")"}], 
         " ", "n"}], "+", 
        RowBox[{
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{
            RowBox[{"-", "1"}], "+", "eps"}], ")"}], "4"], " ", 
         SuperscriptBox["n", "2"]}], "+", 
        RowBox[{
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{
            RowBox[{"-", "1"}], "+", "eps"}], ")"}], "2"], " ", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"-", "2"}], "+", "n"}], ")"}], " ", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"-", "4"}], "+", 
           RowBox[{
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", "2"}], "+", "eps"}], ")"}], " ", "eps", " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", "1"}], "+", "n"}], ")"}]}], "+", "n"}], ")"}], " ", 
         RowBox[{"Cos", "[", 
          RowBox[{"4", " ", "xi"}], "]"}]}]}], ")"}]}], ")"}], " ", 
    SuperscriptBox["b", "3"]}], "+", 
   InterpretationBox[
    SuperscriptBox[
     RowBox[{"O", "[", "b", "]"}], "4"],
    SeriesData[$CellContext`b, 0, {}, 0, 4, 1],
    Editable->False]}],
  SeriesData[$CellContext`b, 0, {
   2 (-1 + $CellContext`eps)^2 (-(-2 + $CellContext`eps) $CellContext`eps)^(
      Rational[1, 
        2] $CellContext`n), (-2) (-1 + $CellContext`eps) (-(-2 + \
$CellContext`eps) $CellContext`eps)^(
      Rational[1, 
        2] (-2 + $CellContext`n)) ($CellContext`n + (-2 + $CellContext`eps) \
$CellContext`eps (1 + $CellContext`n)) Cos[2 $CellContext`xi], 
    Rational[1, 
      2] (-1 + $CellContext`eps)^2 (-(-2 + $CellContext`eps) \
$CellContext`eps)^(
      Rational[1, 
        2] (-4 + $CellContext`n)) $CellContext`n (-2 + $CellContext`n + (-2 + \
$CellContext`eps) $CellContext`eps (
       2 + $CellContext`n) + (-2 + (-1 + $CellContext`eps)^2 $CellContext`n) 
      Cos[4 $CellContext`xi]), 
    Rational[-1, 
      6] (-1 + $CellContext`eps) (-(-2 + $CellContext`eps) $CellContext`eps)^(
      Rational[1, 2] (-6 + $CellContext`n)) $CellContext`n 
    Cos[2 $CellContext`xi] (8 + 
     2 $CellContext`eps (
       2 + $CellContext`eps (-9 - 
         2 (-4 + $CellContext`eps) $CellContext`eps)) + 
     3 (-1 + $CellContext`eps)^2 (-2 + (-2 + $CellContext`eps) \
$CellContext`eps) $CellContext`n + (-1 + $CellContext`eps)^4 $CellContext`n^2 + \
(-1 + $CellContext`eps)^2 (-2 + $CellContext`n) (-4 + (-2 + $CellContext`eps) \
$CellContext`eps (-1 + $CellContext`n) + $CellContext`n) 
      Cos[4 $CellContext`xi])}, 0, 4, 1],
  Editable->False]], "Output",
 CellChangeTimes->{3.751581320911295*^9},
 CellLabel->
  "Out[127]=",ExpressionUUID->"4256dcd8-79a1-44cb-91e9-405e70a24115"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Integrate", "[", 
  RowBox[{
   RowBox[{"Normal", "[", "%", "]"}], ",", 
   RowBox[{"{", 
    RowBox[{"xi", ",", 
     RowBox[{
      RowBox[{"-", "Pi"}], "/", "2"}], ",", 
     RowBox[{"Pi", "/", "2"}]}], "}"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.751581327717371*^9, 3.751581337391004*^9}},
 CellLabel->
  "In[128]:=",ExpressionUUID->"96cae3aa-5ee8-4cb9-a8ba-31f8fe1e349e"],

Cell[BoxData[
 RowBox[{
  FractionBox["1", "2"], " ", 
  RowBox[{"(", 
   RowBox[{
    RowBox[{"-", "1"}], "+", "eps"}], ")"}], " ", 
  SuperscriptBox[
   RowBox[{"(", 
    RowBox[{
     RowBox[{"-", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "2"}], "+", "eps"}], ")"}]}], " ", "eps"}], ")"}], 
   RowBox[{"n", "/", "2"}]], " ", 
  RowBox[{"(", 
   RowBox[{
    RowBox[{"-", "4"}], "+", 
    RowBox[{"4", " ", "eps"}], "+", 
    FractionBox[
     RowBox[{
      SuperscriptBox["b", "2"], " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "1"}], "+", "eps"}], ")"}], " ", "n", " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "2"}], "+", "n", "+", 
        RowBox[{
         RowBox[{"(", 
          RowBox[{
           RowBox[{"-", "2"}], "+", "eps"}], ")"}], " ", "eps", " ", 
         RowBox[{"(", 
          RowBox[{"2", "+", "n"}], ")"}]}]}], ")"}]}], 
     RowBox[{
      SuperscriptBox[
       RowBox[{"(", 
        RowBox[{
         RowBox[{"-", "2"}], "+", "eps"}], ")"}], "2"], " ", 
      SuperscriptBox["eps", "2"]}]]}], ")"}], " ", "\[Pi]"}]], "Output",
 CellChangeTimes->{3.751581340655469*^9},
 CellLabel->
  "Out[128]=",ExpressionUUID->"d3e53138-744d-4da0-9084-25813207ec1e"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Limit", "[", 
  RowBox[{"%", ",", " ", 
   RowBox[{"eps", " ", "\[Rule]", " ", "0"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.751581369873288*^9, 3.7515813750264807`*^9}},
 CellLabel->
  "In[129]:=",ExpressionUUID->"86a00f26-1c92-4359-9f1a-a2fddfc66532"],

Cell[BoxData[
 RowBox[{"ConditionalExpression", "[", 
  RowBox[{"ComplexInfinity", ",", 
   RowBox[{
    RowBox[{
     SuperscriptBox["b", "2"], "\[Element]", 
     TemplateBox[{},
      "Reals"]}], "&&", 
    RowBox[{"0", "<", "n", "<", "2"}]}]}], "]"}]], "Output",
 CellChangeTimes->{3.75158138157651*^9},
 CellLabel->
  "Out[129]=",ExpressionUUID->"31bef77e-0cfe-4a79-bbf1-f48504fd5968"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Series", "[", 
  RowBox[{
   RowBox[{"Out", "[", "128", "]"}], ",", 
   RowBox[{"{", 
    RowBox[{"eps", ",", "0", ",", "3"}], "}"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.751581390593595*^9, 3.751581397307602*^9}},
 CellLabel->
  "In[130]:=",ExpressionUUID->"b058de96-1043-47c9-a364-a7db40622d17"],

Cell[BoxData[
 RowBox[{
  SuperscriptBox[
   RowBox[{"(", 
    RowBox[{
     RowBox[{"-", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "2"}], "+", "eps"}], ")"}]}], " ", "eps"}], ")"}], 
   RowBox[{"n", "/", "2"}]], " ", 
  RowBox[{"(", 
   InterpretationBox[
    RowBox[{
     FractionBox[
      RowBox[{
       RowBox[{
        RowBox[{"-", "2"}], " ", 
        SuperscriptBox["b", "2"], " ", "n", " ", "\[Pi]"}], "+", 
       RowBox[{
        SuperscriptBox["b", "2"], " ", 
        SuperscriptBox["n", "2"], " ", "\[Pi]"}]}], 
      RowBox[{"8", " ", 
       SuperscriptBox["eps", "2"]}]], "+", 
     FractionBox[
      RowBox[{
       RowBox[{
        RowBox[{"-", 
         FractionBox["1", "4"]}], " ", 
        SuperscriptBox["b", "2"], " ", "n", " ", "\[Pi]"}], "-", 
       RowBox[{
        FractionBox["3", "8"], " ", 
        SuperscriptBox["b", "2"], " ", 
        SuperscriptBox["n", "2"], " ", "\[Pi]"}]}], "eps"], "+", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"2", " ", "\[Pi]"}], "+", 
       RowBox[{
        FractionBox["13", "16"], " ", 
        SuperscriptBox["b", "2"], " ", "n", " ", "\[Pi]"}], "+", 
       RowBox[{
        FractionBox["11", "32"], " ", 
        SuperscriptBox["b", "2"], " ", 
        SuperscriptBox["n", "2"], " ", "\[Pi]"}]}], ")"}], "+", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{
         RowBox[{"-", "4"}], " ", "\[Pi]"}], "-", 
        RowBox[{
         FractionBox["1", "8"], " ", 
         SuperscriptBox["b", "2"], " ", "n", " ", "\[Pi]"}], "-", 
        RowBox[{
         FractionBox["1", "16"], " ", 
         SuperscriptBox["b", "2"], " ", 
         SuperscriptBox["n", "2"], " ", "\[Pi]"}]}], ")"}], " ", "eps"}], "+", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"2", " ", "\[Pi]"}], "-", 
        RowBox[{
         FractionBox["5", "64"], " ", 
         SuperscriptBox["b", "2"], " ", "n", " ", "\[Pi]"}], "-", 
        RowBox[{
         FractionBox["3", "128"], " ", 
         SuperscriptBox["b", "2"], " ", 
         SuperscriptBox["n", "2"], " ", "\[Pi]"}]}], ")"}], " ", 
      SuperscriptBox["eps", "2"]}], "+", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{
         RowBox[{"-", 
          FractionBox["3", "64"]}], " ", 
         SuperscriptBox["b", "2"], " ", "n", " ", "\[Pi]"}], "-", 
        RowBox[{
         FractionBox["1", "128"], " ", 
         SuperscriptBox["b", "2"], " ", 
         SuperscriptBox["n", "2"], " ", "\[Pi]"}]}], ")"}], " ", 
      SuperscriptBox["eps", "3"]}], "+", 
     InterpretationBox[
      SuperscriptBox[
       RowBox[{"O", "[", "eps", "]"}], "4"],
      SeriesData[$CellContext`eps, 0, {}, -2, 4, 1],
      Editable->False]}],
    SeriesData[$CellContext`eps, 0, {
     Rational[1, 8] ((-2) $CellContext`b^2 $CellContext`n 
        Pi + $CellContext`b^2 $CellContext`n^2 Pi), 
      Rational[-1, 4] $CellContext`b^2 $CellContext`n Pi + 
      Rational[-3, 8] $CellContext`b^2 $CellContext`n^2 Pi, 2 Pi + 
      Rational[13, 16] $CellContext`b^2 $CellContext`n Pi + 
      Rational[11, 32] $CellContext`b^2 $CellContext`n^2 Pi, (-4) Pi + 
      Rational[-1, 8] $CellContext`b^2 $CellContext`n Pi + 
      Rational[-1, 16] $CellContext`b^2 $CellContext`n^2 Pi, 2 Pi + 
      Rational[-5, 64] $CellContext`b^2 $CellContext`n Pi + 
      Rational[-3, 128] $CellContext`b^2 $CellContext`n^2 Pi, 
      Rational[-3, 64] $CellContext`b^2 $CellContext`n Pi + 
      Rational[-1, 128] $CellContext`b^2 $CellContext`n^2 Pi}, -2, 4, 1],
    Editable->False], ")"}]}]], "Output",
 CellChangeTimes->{3.751581397647917*^9},
 CellLabel->
  "Out[130]=",ExpressionUUID->"44b003e8-92a8-44f3-90fc-ff789d0ef2bc"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Series", "[", 
  RowBox[{
   RowBox[{
    RowBox[{"2", "*", "r", "*", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{"1", "-", 
        RowBox[{
         RowBox[{"(", 
          RowBox[{"r", "-", "b"}], ")"}], "^", "2"}], "-", 
        RowBox[{"4", "*", "b", "*", "r", "*", 
         RowBox[{
          RowBox[{"Sin", "[", "xi", "]"}], "^", "2"}]}]}], ")"}], "^", 
      RowBox[{"(", 
       RowBox[{"n", "/", "2"}], ")"}]}], "*", 
     RowBox[{"(", 
      RowBox[{"r", "-", "b", "+", 
       RowBox[{"2", "*", "b", "*", 
        RowBox[{
         RowBox[{"Sin", "[", "xi", "]"}], "^", "2"}]}]}], ")"}]}], " ", "/.", 
    " ", 
    RowBox[{"r", " ", "\[Rule]", " ", 
     RowBox[{"1", "-", "eps"}]}]}], ",", 
   RowBox[{"{", 
    RowBox[{"eps", ",", "0", ",", "3"}], "}"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.751581487834814*^9, 3.7515814886891813`*^9}},
 CellLabel->
  "In[131]:=",ExpressionUUID->"28685c05-f2c7-451a-963c-8b948aa52eee"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
   RowBox[{"2", " ", 
    SuperscriptBox[
     RowBox[{"(", 
      RowBox[{
       RowBox[{"2", " ", "b"}], "-", 
       SuperscriptBox["b", "2"], "-", 
       RowBox[{"4", " ", "b", " ", 
        SuperscriptBox[
         RowBox[{"Sin", "[", "xi", "]"}], "2"]}]}], ")"}], 
     RowBox[{"n", "/", "2"}]], " ", 
    RowBox[{"(", 
     RowBox[{"1", "-", "b", "+", 
      RowBox[{"2", " ", "b", " ", 
       SuperscriptBox[
        RowBox[{"Sin", "[", "xi", "]"}], "2"]}]}], ")"}]}], "+", 
   RowBox[{"2", " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{
       SuperscriptBox[
        RowBox[{"(", 
         RowBox[{
          RowBox[{"2", " ", "b"}], "-", 
          SuperscriptBox["b", "2"], "-", 
          RowBox[{"4", " ", "b", " ", 
           SuperscriptBox[
            RowBox[{"Sin", "[", "xi", "]"}], "2"]}]}], ")"}], 
        RowBox[{"n", "/", "2"}]], " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"-", "2"}], "+", "b", "-", 
         RowBox[{"2", " ", "b", " ", 
          SuperscriptBox[
           RowBox[{"Sin", "[", "xi", "]"}], "2"]}]}], ")"}]}], "+", 
      RowBox[{
       FractionBox["1", "2"], " ", "n", " ", 
       SuperscriptBox[
        RowBox[{"(", 
         RowBox[{
          RowBox[{"2", " ", "b"}], "-", 
          SuperscriptBox["b", "2"], "-", 
          RowBox[{"4", " ", "b", " ", 
           SuperscriptBox[
            RowBox[{"Sin", "[", "xi", "]"}], "2"]}]}], ")"}], 
        RowBox[{
         RowBox[{"-", "1"}], "+", 
         FractionBox["n", "2"]}]], " ", 
       RowBox[{"(", 
        RowBox[{"1", "-", "b", "+", 
         RowBox[{"2", " ", "b", " ", 
          SuperscriptBox[
           RowBox[{"Sin", "[", "xi", "]"}], "2"]}]}], ")"}], " ", 
       RowBox[{"(", 
        RowBox[{"2", "-", 
         RowBox[{"2", " ", "b"}], "+", 
         RowBox[{"4", " ", "b", " ", 
          SuperscriptBox[
           RowBox[{"Sin", "[", "xi", "]"}], "2"]}]}], ")"}]}]}], ")"}], " ", 
    "eps"}], "+", 
   RowBox[{"2", " ", 
    RowBox[{"(", 
     RowBox[{
      SuperscriptBox[
       RowBox[{"(", 
        RowBox[{
         RowBox[{"2", " ", "b"}], "-", 
         SuperscriptBox["b", "2"], "-", 
         RowBox[{"4", " ", "b", " ", 
          SuperscriptBox[
           RowBox[{"Sin", "[", "xi", "]"}], "2"]}]}], ")"}], 
       RowBox[{"n", "/", "2"}]], "+", 
      RowBox[{
       FractionBox["1", "2"], " ", "n", " ", 
       SuperscriptBox[
        RowBox[{"(", 
         RowBox[{
          RowBox[{"2", " ", "b"}], "-", 
          SuperscriptBox["b", "2"], "-", 
          RowBox[{"4", " ", "b", " ", 
           SuperscriptBox[
            RowBox[{"Sin", "[", "xi", "]"}], "2"]}]}], ")"}], 
        RowBox[{
         RowBox[{"-", "1"}], "+", 
         FractionBox["n", "2"]}]], " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"-", "2"}], "+", "b", "-", 
         RowBox[{"2", " ", "b", " ", 
          SuperscriptBox[
           RowBox[{"Sin", "[", "xi", "]"}], "2"]}]}], ")"}], " ", 
       RowBox[{"(", 
        RowBox[{"2", "-", 
         RowBox[{"2", " ", "b"}], "+", 
         RowBox[{"4", " ", "b", " ", 
          SuperscriptBox[
           RowBox[{"Sin", "[", "xi", "]"}], "2"]}]}], ")"}]}], "+", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{"1", "-", "b", "+", 
         RowBox[{"2", " ", "b", " ", 
          SuperscriptBox[
           RowBox[{"Sin", "[", "xi", "]"}], "2"]}]}], ")"}], " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{
          RowBox[{"-", 
           FractionBox["1", "2"]}], " ", "n", " ", 
          SuperscriptBox[
           RowBox[{"(", 
            RowBox[{
             RowBox[{"2", " ", "b"}], "-", 
             SuperscriptBox["b", "2"], "-", 
             RowBox[{"4", " ", "b", " ", 
              SuperscriptBox[
               RowBox[{"Sin", "[", "xi", "]"}], "2"]}]}], ")"}], 
           RowBox[{
            RowBox[{"-", "1"}], "+", 
            FractionBox["n", "2"]}]]}], "+", 
         RowBox[{
          FractionBox["1", "4"], " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"-", "1"}], "+", 
            FractionBox["n", "2"]}], ")"}], " ", "n", " ", 
          SuperscriptBox[
           RowBox[{"(", 
            RowBox[{
             RowBox[{"2", " ", "b"}], "-", 
             SuperscriptBox["b", "2"], "-", 
             RowBox[{"4", " ", "b", " ", 
              SuperscriptBox[
               RowBox[{"Sin", "[", "xi", "]"}], "2"]}]}], ")"}], 
           RowBox[{
            RowBox[{"-", "2"}], "+", 
            FractionBox["n", "2"]}]], " ", 
          SuperscriptBox[
           RowBox[{"(", 
            RowBox[{"2", "-", 
             RowBox[{"2", " ", "b"}], "+", 
             RowBox[{"4", " ", "b", " ", 
              SuperscriptBox[
               RowBox[{"Sin", "[", "xi", "]"}], "2"]}]}], ")"}], "2"]}]}], 
        ")"}]}]}], ")"}], " ", 
    SuperscriptBox["eps", "2"]}], "+", 
   RowBox[{"2", " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{
       FractionBox["1", "2"], " ", "n", " ", 
       SuperscriptBox[
        RowBox[{"(", 
         RowBox[{
          RowBox[{"2", " ", "b"}], "-", 
          SuperscriptBox["b", "2"], "-", 
          RowBox[{"4", " ", "b", " ", 
           SuperscriptBox[
            RowBox[{"Sin", "[", "xi", "]"}], "2"]}]}], ")"}], 
        RowBox[{
         RowBox[{"-", "1"}], "+", 
         FractionBox["n", "2"]}]], " ", 
       RowBox[{"(", 
        RowBox[{"2", "-", 
         RowBox[{"2", " ", "b"}], "+", 
         RowBox[{"4", " ", "b", " ", 
          SuperscriptBox[
           RowBox[{"Sin", "[", "xi", "]"}], "2"]}]}], ")"}]}], "+", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{
         RowBox[{"-", "2"}], "+", "b", "-", 
         RowBox[{"2", " ", "b", " ", 
          SuperscriptBox[
           RowBox[{"Sin", "[", "xi", "]"}], "2"]}]}], ")"}], " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{
          RowBox[{"-", 
           FractionBox["1", "2"]}], " ", "n", " ", 
          SuperscriptBox[
           RowBox[{"(", 
            RowBox[{
             RowBox[{"2", " ", "b"}], "-", 
             SuperscriptBox["b", "2"], "-", 
             RowBox[{"4", " ", "b", " ", 
              SuperscriptBox[
               RowBox[{"Sin", "[", "xi", "]"}], "2"]}]}], ")"}], 
           RowBox[{
            RowBox[{"-", "1"}], "+", 
            FractionBox["n", "2"]}]]}], "+", 
         RowBox[{
          FractionBox["1", "4"], " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"-", "1"}], "+", 
            FractionBox["n", "2"]}], ")"}], " ", "n", " ", 
          SuperscriptBox[
           RowBox[{"(", 
            RowBox[{
             RowBox[{"2", " ", "b"}], "-", 
             SuperscriptBox["b", "2"], "-", 
             RowBox[{"4", " ", "b", " ", 
              SuperscriptBox[
               RowBox[{"Sin", "[", "xi", "]"}], "2"]}]}], ")"}], 
           RowBox[{
            RowBox[{"-", "2"}], "+", 
            FractionBox["n", "2"]}]], " ", 
          SuperscriptBox[
           RowBox[{"(", 
            RowBox[{"2", "-", 
             RowBox[{"2", " ", "b"}], "+", 
             RowBox[{"4", " ", "b", " ", 
              SuperscriptBox[
               RowBox[{"Sin", "[", "xi", "]"}], "2"]}]}], ")"}], "2"]}]}], 
        ")"}]}], "+", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{"1", "-", "b", "+", 
         RowBox[{"2", " ", "b", " ", 
          SuperscriptBox[
           RowBox[{"Sin", "[", "xi", "]"}], "2"]}]}], ")"}], " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{
          FractionBox["1", "4"], " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"-", "1"}], "+", 
            FractionBox["n", "2"]}], ")"}], " ", "n", " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"-", "4"}], "+", 
            RowBox[{"4", " ", "b"}], "-", 
            RowBox[{"8", " ", "b", " ", 
             SuperscriptBox[
              RowBox[{"Sin", "[", "xi", "]"}], "2"]}]}], ")"}], " ", 
          SuperscriptBox[
           RowBox[{"(", 
            RowBox[{
             RowBox[{"2", " ", "b"}], "-", 
             SuperscriptBox["b", "2"], "-", 
             RowBox[{"4", " ", "b", " ", 
              SuperscriptBox[
               RowBox[{"Sin", "[", "xi", "]"}], "2"]}]}], ")"}], 
           RowBox[{
            RowBox[{"-", "2"}], "+", 
            FractionBox["n", "2"]}]]}], "+", 
         RowBox[{
          FractionBox["1", "12"], " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"-", "2"}], "+", 
            FractionBox["n", "2"]}], ")"}], " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"-", "1"}], "+", 
            FractionBox["n", "2"]}], ")"}], " ", "n", " ", 
          SuperscriptBox[
           RowBox[{"(", 
            RowBox[{
             RowBox[{"2", " ", "b"}], "-", 
             SuperscriptBox["b", "2"], "-", 
             RowBox[{"4", " ", "b", " ", 
              SuperscriptBox[
               RowBox[{"Sin", "[", "xi", "]"}], "2"]}]}], ")"}], 
           RowBox[{
            RowBox[{"-", "3"}], "+", 
            FractionBox["n", "2"]}]], " ", 
          SuperscriptBox[
           RowBox[{"(", 
            RowBox[{"2", "-", 
             RowBox[{"2", " ", "b"}], "+", 
             RowBox[{"4", " ", "b", " ", 
              SuperscriptBox[
               RowBox[{"Sin", "[", "xi", "]"}], "2"]}]}], ")"}], "3"]}]}], 
        ")"}]}]}], ")"}], " ", 
    SuperscriptBox["eps", "3"]}], "+", 
   InterpretationBox[
    SuperscriptBox[
     RowBox[{"O", "[", "eps", "]"}], "4"],
    SeriesData[$CellContext`eps, 0, {}, 0, 4, 1],
    Editable->False]}],
  SeriesData[$CellContext`eps, 0, {
   2 (2 $CellContext`b - $CellContext`b^2 - 4 $CellContext`b 
      Sin[$CellContext`xi]^2)^(Rational[1, 2] $CellContext`n) (
     1 - $CellContext`b + 2 $CellContext`b Sin[$CellContext`xi]^2), 
    2 ((2 $CellContext`b - $CellContext`b^2 - 4 $CellContext`b 
        Sin[$CellContext`xi]^2)^(
        Rational[1, 2] $CellContext`n) (-2 + $CellContext`b - 
       2 $CellContext`b Sin[$CellContext`xi]^2) + 
     Rational[1, 2] $CellContext`n (2 $CellContext`b - $CellContext`b^2 - 
        4 $CellContext`b Sin[$CellContext`xi]^2)^(-1 + 
        Rational[1, 2] $CellContext`n) (1 - $CellContext`b + 
       2 $CellContext`b Sin[$CellContext`xi]^2) (2 - 2 $CellContext`b + 
       4 $CellContext`b Sin[$CellContext`xi]^2)), 
    2 ((2 $CellContext`b - $CellContext`b^2 - 4 $CellContext`b 
       Sin[$CellContext`xi]^2)^(Rational[1, 2] $CellContext`n) + 
     Rational[1, 2] $CellContext`n (2 $CellContext`b - $CellContext`b^2 - 
        4 $CellContext`b Sin[$CellContext`xi]^2)^(-1 + 
        Rational[1, 2] $CellContext`n) (-2 + $CellContext`b - 
       2 $CellContext`b Sin[$CellContext`xi]^2) (2 - 2 $CellContext`b + 
       4 $CellContext`b Sin[$CellContext`xi]^2) + (1 - $CellContext`b + 
       2 $CellContext`b Sin[$CellContext`xi]^2) (
       Rational[-1, 2] $CellContext`n (2 $CellContext`b - $CellContext`b^2 - 
          4 $CellContext`b Sin[$CellContext`xi]^2)^(-1 + 
          Rational[1, 2] $CellContext`n) + 
       Rational[1, 4] (-1 + 
         Rational[1, 2] $CellContext`n) $CellContext`n (
          2 $CellContext`b - $CellContext`b^2 - 4 $CellContext`b 
          Sin[$CellContext`xi]^2)^(-2 + Rational[1, 2] $CellContext`n) (2 - 
          2 $CellContext`b + 4 $CellContext`b Sin[$CellContext`xi]^2)^2)), 
    2 (Rational[
       1, 2] $CellContext`n (2 $CellContext`b - $CellContext`b^2 - 
        4 $CellContext`b Sin[$CellContext`xi]^2)^(-1 + 
        Rational[1, 2] $CellContext`n) (2 - 2 $CellContext`b + 
       4 $CellContext`b Sin[$CellContext`xi]^2) + (-2 + $CellContext`b - 
       2 $CellContext`b Sin[$CellContext`xi]^2) (
       Rational[-1, 2] $CellContext`n (2 $CellContext`b - $CellContext`b^2 - 
          4 $CellContext`b Sin[$CellContext`xi]^2)^(-1 + 
          Rational[1, 2] $CellContext`n) + 
       Rational[1, 4] (-1 + 
         Rational[1, 2] $CellContext`n) $CellContext`n (
          2 $CellContext`b - $CellContext`b^2 - 4 $CellContext`b 
          Sin[$CellContext`xi]^2)^(-2 + Rational[1, 2] $CellContext`n) (2 - 
          2 $CellContext`b + 4 $CellContext`b Sin[$CellContext`xi]^2)^2) + (
       1 - $CellContext`b + 2 $CellContext`b Sin[$CellContext`xi]^2) (
       Rational[1, 4] (-1 + Rational[1, 2] $CellContext`n) $CellContext`n (-4 + 
         4 $CellContext`b - 8 $CellContext`b 
         Sin[$CellContext`xi]^2) (2 $CellContext`b - $CellContext`b^2 - 
          4 $CellContext`b Sin[$CellContext`xi]^2)^(-2 + 
          Rational[1, 2] $CellContext`n) + 
       Rational[1, 12] (-2 + Rational[1, 2] $CellContext`n) (-1 + 
         Rational[1, 2] $CellContext`n) $CellContext`n (
          2 $CellContext`b - $CellContext`b^2 - 4 $CellContext`b 
          Sin[$CellContext`xi]^2)^(-3 + Rational[1, 2] $CellContext`n) (2 - 
          2 $CellContext`b + 4 $CellContext`b Sin[$CellContext`xi]^2)^3))}, 0,
    4, 1],
  Editable->False]], "Output",
 CellChangeTimes->{3.751581490488804*^9},
 CellLabel->
  "Out[131]=",ExpressionUUID->"5f950a66-5d7a-4838-bf67-d99b3dbbb929"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"FullSimplify", "[", 
  RowBox[{"Normal", "[", 
   RowBox[{"Out", "[", "131", "]"}], "]"}], "]"}]], "Input",
 CellChangeTimes->{{3.751581493654874*^9, 3.751581524574585*^9}},
 CellLabel->
  "In[133]:=",ExpressionUUID->"30c16df9-b5fc-4c9a-b322-4ea5028f257b"],

Cell[BoxData["$Aborted"], "Output",
 CellChangeTimes->{3.751581515568548*^9, 3.75158160980532*^9},
 CellLabel->
  "Out[133]=",ExpressionUUID->"ec749145-9dc4-4e2a-a25b-2389cbf9834a"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Integrate", "[", 
  RowBox[{
   RowBox[{
    RowBox[{"Normal", "[", 
     RowBox[{"Out", "[", "131", "]"}], "]"}], " ", "/.", " ", 
    RowBox[{"n", " ", "\[Rule]", " ", "3"}]}], ",", 
   RowBox[{"{", 
    RowBox[{"xi", ",", 
     RowBox[{
      RowBox[{"-", "Pi"}], "/", "2"}], ",", 
     RowBox[{"Pi", "/", "2"}]}], "}"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.751581612342341*^9, 3.751581621910735*^9}, {
  3.751581689598187*^9, 3.751581692916296*^9}},
 CellLabel->
  "In[135]:=",ExpressionUUID->"b95a10fc-6715-4cf5-933b-d98b852f8d5e"],

Cell[BoxData[
 TemplateBox[{
  "Refine","fas","\"Warning: one or more assumptions evaluated to False.\"",2,
   135,9,25554948073909081868,"Local"},
  "MessageTemplate"]], "Message", "MSG",
 CellChangeTimes->{3.751581733372992*^9},
 CellLabel->
  "During evaluation of \
In[135]:=",ExpressionUUID->"a496dcb7-e036-4917-8677-bd015d0ee7c2"],

Cell[BoxData[
 TemplateBox[{
  "Refine","fas","\"Warning: one or more assumptions evaluated to False.\"",2,
   135,10,25554948073909081868,"Local"},
  "MessageTemplate"]], "Message", "MSG",
 CellChangeTimes->{3.751581733419223*^9},
 CellLabel->
  "During evaluation of \
In[135]:=",ExpressionUUID->"31e636dd-873a-4a80-aec8-5fbc2876c659"],

Cell[BoxData[
 RowBox[{"ConditionalExpression", "[", 
  RowBox[{
   RowBox[{"-", 
    RowBox[{
     FractionBox["1", 
      RowBox[{"15", " ", 
       SuperscriptBox[
        RowBox[{"(", 
         RowBox[{
          RowBox[{"-", "b"}], " ", 
          RowBox[{"(", 
           RowBox[{"2", "+", "b"}], ")"}]}], ")"}], 
        RowBox[{"3", "/", "2"}]]}]], 
     RowBox[{
      SqrtBox[
       FractionBox[
        RowBox[{"2", "+", "b"}], 
        RowBox[{
         RowBox[{"-", "2"}], "+", "b"}]]], " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{
         RowBox[{"(", 
          RowBox[{
           RowBox[{"6", " ", 
            SuperscriptBox["b", "8"]}], "+", 
           RowBox[{"30", " ", 
            SuperscriptBox["eps", "3"]}], "+", 
           RowBox[{"60", " ", 
            SuperscriptBox["b", "2"], " ", "eps", " ", 
            RowBox[{"(", 
             RowBox[{"12", "+", 
              RowBox[{"eps", " ", 
               RowBox[{"(", 
                RowBox[{
                 RowBox[{"-", "39"}], "+", 
                 RowBox[{"41", " ", "eps"}]}], ")"}]}]}], ")"}]}], "+", 
           RowBox[{
            SuperscriptBox["b", "6"], " ", 
            RowBox[{"(", 
             RowBox[{"128", "-", 
              RowBox[{"25", " ", "eps", " ", 
               RowBox[{"(", 
                RowBox[{"16", "+", 
                 RowBox[{
                  RowBox[{"(", 
                   RowBox[{
                    RowBox[{"-", "11"}], "+", "eps"}], ")"}], " ", "eps"}]}], 
                ")"}]}]}], ")"}]}], "-", 
           RowBox[{
            SuperscriptBox["b", "4"], " ", 
            RowBox[{"(", 
             RowBox[{"608", "+", 
              RowBox[{"5", " ", "eps", " ", 
               RowBox[{"(", 
                RowBox[{
                 RowBox[{"-", "284"}], "+", 
                 RowBox[{"103", " ", "eps", " ", 
                  RowBox[{"(", 
                   RowBox[{"1", "+", "eps"}], ")"}]}]}], ")"}]}]}], ")"}]}]}],
           ")"}], " ", 
         RowBox[{"EllipticE", "[", 
          RowBox[{"-", 
           FractionBox["4", 
            RowBox[{
             RowBox[{"-", "2"}], "+", "b"}]]}], "]"}]}], "-", 
        RowBox[{"b", " ", 
         RowBox[{"(", 
          RowBox[{"2", "+", "b"}], ")"}], " ", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"6", " ", 
            SuperscriptBox["b", "6"]}], "+", 
           RowBox[{"30", " ", 
            SuperscriptBox["eps", "2"], " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", "3"}], "+", 
              RowBox[{"7", " ", "eps"}]}], ")"}]}], "-", 
           RowBox[{
            SuperscriptBox["b", "4"], " ", 
            RowBox[{"(", 
             RowBox[{"4", "+", 
              RowBox[{"25", " ", 
               RowBox[{"(", 
                RowBox[{
                 RowBox[{"-", "4"}], "+", "eps"}], ")"}], " ", 
               RowBox[{"(", 
                RowBox[{
                 RowBox[{"-", "1"}], "+", "eps"}], ")"}], " ", "eps"}]}], 
             ")"}]}], "+", 
           RowBox[{"5", " ", 
            SuperscriptBox["b", "2"], " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", "16"}], "+", 
              RowBox[{"eps", " ", 
               RowBox[{"(", 
                RowBox[{"80", "+", 
                 RowBox[{"eps", " ", 
                  RowBox[{"(", 
                   RowBox[{
                    RowBox[{"-", "91"}], "+", 
                    RowBox[{"17", " ", "eps"}]}], ")"}]}]}], ")"}]}]}], 
             ")"}]}]}], ")"}], " ", 
         RowBox[{"EllipticK", "[", 
          RowBox[{"-", 
           FractionBox["4", 
            RowBox[{
             RowBox[{"-", "2"}], "+", "b"}]]}], "]"}]}]}], ")"}]}]}]}], ",", 
   RowBox[{"b", "\[Equal]", "0"}]}], "]"}]], "Output",
 CellChangeTimes->{3.7515816878870173`*^9, 3.751581782064237*^9},
 CellLabel->
  "Out[135]=",ExpressionUUID->"53b48277-5ede-4366-92a5-7ddbd13faf0f"]
}, Open  ]],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{"Try", " ", "again"}], " ", "*)"}]], "Input",
 CellChangeTimes->{{3.7515958656082907`*^9, 3.751595870032461*^9}},
 CellLabel->
  "In[136]:=",ExpressionUUID->"b4aaed45-b450-460f-b57e-92673537301b"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"D", "[", 
  RowBox[{
   RowBox[{"2", "*", "r", "*", 
    RowBox[{
     RowBox[{"(", 
      RowBox[{"1", "-", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{"b", "-", "r"}], ")"}], "^", "2"}], "-", 
       RowBox[{"4", "*", "b", "*", "r", "*", 
        RowBox[{
         RowBox[{"Sin", "[", "xi", "]"}], "^", "2"}]}]}], ")"}], "^", 
     RowBox[{"(", 
      RowBox[{"n", "/", "2"}], ")"}]}], "*", 
    RowBox[{"(", 
     RowBox[{"r", "-", "b", "+", 
      RowBox[{"2", "*", "b", "*", 
       RowBox[{
        RowBox[{"Sin", "[", "xi", "]"}], "^", "2"}]}]}], ")"}]}], ",", 
   RowBox[{"{", 
    RowBox[{"b", ",", "2"}], "}"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.751595910227543*^9, 3.751595956896978*^9}, {
  3.751596066403541*^9, 3.75159610000196*^9}},
 CellLabel->
  "In[145]:=",ExpressionUUID->"84308119-7477-4457-a429-3ddf26fd14d8"],

Cell[BoxData[
 RowBox[{"2", " ", "r", " ", 
  RowBox[{"(", 
   RowBox[{
    RowBox[{"n", " ", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"-", "1"}], "+", 
       RowBox[{"2", " ", 
        SuperscriptBox[
         RowBox[{"Sin", "[", "xi", "]"}], "2"]}]}], ")"}], " ", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{
        RowBox[{"-", "2"}], " ", 
        RowBox[{"(", 
         RowBox[{"b", "-", "r"}], ")"}]}], "-", 
       RowBox[{"4", " ", "r", " ", 
        SuperscriptBox[
         RowBox[{"Sin", "[", "xi", "]"}], "2"]}]}], ")"}], " ", 
     SuperscriptBox[
      RowBox[{"(", 
       RowBox[{"1", "-", 
        SuperscriptBox[
         RowBox[{"(", 
          RowBox[{"b", "-", "r"}], ")"}], "2"], "-", 
        RowBox[{"4", " ", "b", " ", "r", " ", 
         SuperscriptBox[
          RowBox[{"Sin", "[", "xi", "]"}], "2"]}]}], ")"}], 
      RowBox[{
       RowBox[{"-", "1"}], "+", 
       FractionBox["n", "2"]}]]}], "+", 
    RowBox[{
     RowBox[{"(", 
      RowBox[{
       RowBox[{"-", "b"}], "+", "r", "+", 
       RowBox[{"2", " ", "b", " ", 
        SuperscriptBox[
         RowBox[{"Sin", "[", "xi", "]"}], "2"]}]}], ")"}], " ", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{
        FractionBox["1", "2"], " ", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"-", "1"}], "+", 
          FractionBox["n", "2"]}], ")"}], " ", "n", " ", 
        SuperscriptBox[
         RowBox[{"(", 
          RowBox[{
           RowBox[{
            RowBox[{"-", "2"}], " ", 
            RowBox[{"(", 
             RowBox[{"b", "-", "r"}], ")"}]}], "-", 
           RowBox[{"4", " ", "r", " ", 
            SuperscriptBox[
             RowBox[{"Sin", "[", "xi", "]"}], "2"]}]}], ")"}], "2"], " ", 
        SuperscriptBox[
         RowBox[{"(", 
          RowBox[{"1", "-", 
           SuperscriptBox[
            RowBox[{"(", 
             RowBox[{"b", "-", "r"}], ")"}], "2"], "-", 
           RowBox[{"4", " ", "b", " ", "r", " ", 
            SuperscriptBox[
             RowBox[{"Sin", "[", "xi", "]"}], "2"]}]}], ")"}], 
         RowBox[{
          RowBox[{"-", "2"}], "+", 
          FractionBox["n", "2"]}]]}], "-", 
       RowBox[{"n", " ", 
        SuperscriptBox[
         RowBox[{"(", 
          RowBox[{"1", "-", 
           SuperscriptBox[
            RowBox[{"(", 
             RowBox[{"b", "-", "r"}], ")"}], "2"], "-", 
           RowBox[{"4", " ", "b", " ", "r", " ", 
            SuperscriptBox[
             RowBox[{"Sin", "[", "xi", "]"}], "2"]}]}], ")"}], 
         RowBox[{
          RowBox[{"-", "1"}], "+", 
          FractionBox["n", "2"]}]]}]}], ")"}]}]}], ")"}]}]], "Output",
 CellChangeTimes->{3.75159595779821*^9, 3.751596070779481*^9, 
  3.7515961015503273`*^9},
 CellLabel->
  "Out[145]=",ExpressionUUID->"f9dfdb35-9307-4b91-b548-9e6ecf5b1149"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"FullSimplify", "[", "%", "]"}]], "Input",
 CellChangeTimes->{{3.751595962327298*^9, 3.751595975264995*^9}},
 CellLabel->
  "In[146]:=",ExpressionUUID->"a24496ca-f6a4-4550-8506-d883bc884afc"],

Cell[BoxData[
 RowBox[{
  FractionBox["1", "2"], " ", "n", " ", "r", " ", 
  SuperscriptBox[
   RowBox[{"(", 
    RowBox[{"1", "-", 
     SuperscriptBox["b", "2"], "-", 
     SuperscriptBox["r", "2"], "+", 
     RowBox[{"2", " ", "b", " ", "r", " ", 
      RowBox[{"Cos", "[", 
       RowBox[{"2", " ", "xi"}], "]"}]}]}], ")"}], 
   RowBox[{
    FractionBox["1", "2"], " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"-", "4"}], "+", "n"}], ")"}]}]], " ", 
  RowBox[{"(", 
   RowBox[{
    RowBox[{
     RowBox[{"-", "b"}], " ", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"-", "12"}], "+", 
       RowBox[{"4", " ", 
        SuperscriptBox["b", "2"], " ", 
        RowBox[{"(", 
         RowBox[{"1", "+", "n"}], ")"}]}], "+", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{"10", "+", 
          RowBox[{"11", " ", "n"}]}], ")"}], " ", 
        SuperscriptBox["r", "2"]}]}], ")"}], " ", 
     RowBox[{"Cos", "[", 
      RowBox[{"2", " ", "xi"}], "]"}]}], "+", 
    RowBox[{"r", " ", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"-", "8"}], "+", 
       RowBox[{
        SuperscriptBox["b", "2"], " ", 
        RowBox[{"(", 
         RowBox[{"4", "+", 
          RowBox[{"8", " ", "n"}]}], ")"}]}], "+", 
       RowBox[{"2", " ", 
        RowBox[{"(", 
         RowBox[{"2", "+", "n"}], ")"}], " ", 
        SuperscriptBox["r", "2"]}], "+", 
       RowBox[{"2", " ", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"-", "2"}], "+", 
          RowBox[{"2", " ", 
           SuperscriptBox["b", "2"], " ", 
           RowBox[{"(", 
            RowBox[{"2", "+", "n"}], ")"}]}], "+", 
          RowBox[{"n", " ", 
           SuperscriptBox["r", "2"]}]}], ")"}], " ", 
        RowBox[{"Cos", "[", 
         RowBox[{"4", " ", "xi"}], "]"}]}], "-", 
       RowBox[{"b", " ", 
        RowBox[{"(", 
         RowBox[{"2", "+", "n"}], ")"}], " ", "r", " ", 
        RowBox[{"Cos", "[", 
         RowBox[{"6", " ", "xi"}], "]"}]}]}], ")"}]}]}], ")"}]}]], "Output",
 CellChangeTimes->{3.751595978464015*^9, 3.751596073085513*^9, 
  3.751596105758771*^9},
 CellLabel->
  "Out[146]=",ExpressionUUID->"f848cd25-8777-4af6-8bd9-4d324f8becff"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"%", " ", "/.", " ", 
  RowBox[{"b", " ", "\[Rule]", " ", "0"}]}]], "Input",
 CellChangeTimes->{{3.7515959806941547`*^9, 3.751595989655911*^9}},
 CellLabel->
  "In[147]:=",ExpressionUUID->"13eb3317-6e08-4e00-88d5-8960e671ff48"],

Cell[BoxData[
 RowBox[{
  FractionBox["1", "2"], " ", "n", " ", 
  SuperscriptBox["r", "2"], " ", 
  SuperscriptBox[
   RowBox[{"(", 
    RowBox[{"1", "-", 
     SuperscriptBox["r", "2"]}], ")"}], 
   RowBox[{
    FractionBox["1", "2"], " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"-", "4"}], "+", "n"}], ")"}]}]], " ", 
  RowBox[{"(", 
   RowBox[{
    RowBox[{"-", "8"}], "+", 
    RowBox[{"2", " ", 
     RowBox[{"(", 
      RowBox[{"2", "+", "n"}], ")"}], " ", 
     SuperscriptBox["r", "2"]}], "+", 
    RowBox[{"2", " ", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"-", "2"}], "+", 
       RowBox[{"n", " ", 
        SuperscriptBox["r", "2"]}]}], ")"}], " ", 
     RowBox[{"Cos", "[", 
      RowBox[{"4", " ", "xi"}], "]"}]}]}], ")"}]}]], "Output",
 CellChangeTimes->{3.7515959901687202`*^9, 3.751596074362033*^9, 
  3.7515961070131607`*^9},
 CellLabel->
  "Out[147]=",ExpressionUUID->"b90e4993-a692-44b4-9322-05c006ca4efa"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Integrate", "[", 
  RowBox[{"%", ",", 
   RowBox[{"{", 
    RowBox[{"xi", ",", 
     RowBox[{
      RowBox[{"-", "Pi"}], "/", "2"}], ",", 
     RowBox[{"Pi", "/", "2"}]}], "}"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.7515960834952583`*^9, 3.751596093849642*^9}},
 CellLabel->
  "In[148]:=",ExpressionUUID->"b1f52e4d-00b4-4d3d-a681-ea61dcdcf5b9"],

Cell[BoxData[
 RowBox[{"n", " ", "\[Pi]", " ", 
  SuperscriptBox["r", "2"], " ", 
  SuperscriptBox[
   RowBox[{"(", 
    RowBox[{"1", "-", 
     SuperscriptBox["r", "2"]}], ")"}], 
   RowBox[{
    FractionBox["1", "2"], " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"-", "4"}], "+", "n"}], ")"}]}]], " ", 
  RowBox[{"(", 
   RowBox[{
    RowBox[{"-", "4"}], "+", 
    RowBox[{
     RowBox[{"(", 
      RowBox[{"2", "+", "n"}], ")"}], " ", 
     SuperscriptBox["r", "2"]}]}], ")"}]}]], "Output",
 CellChangeTimes->{{3.751596094207389*^9, 3.7515961098855877`*^9}},
 CellLabel->
  "Out[148]=",ExpressionUUID->"9169152a-519e-4628-ac77-b5d946b1d9e5"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"2", "*", "r", "*", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{"1", "-", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{"b", "-", "r"}], ")"}], "^", "2"}], "-", 
      RowBox[{"4", "*", "b", "*", "r", "*", 
       RowBox[{
        RowBox[{"Sin", "[", "xi", "]"}], "^", "2"}]}]}], ")"}], "^", 
    RowBox[{"(", 
     RowBox[{"n", "/", "2"}], ")"}]}], "*", 
   RowBox[{"(", 
    RowBox[{"r", "-", "b", "+", 
     RowBox[{"2", "*", "b", "*", 
      RowBox[{
       RowBox[{"Sin", "[", "xi", "]"}], "^", "2"}]}]}], ")"}]}], " ", "/.", 
  " ", 
  RowBox[{"b", " ", "\[Rule]", " ", "0"}]}]], "Input",
 CellChangeTimes->{{3.751596246811182*^9, 3.751596248337818*^9}},
 CellLabel->
  "In[149]:=",ExpressionUUID->"fbcb74a4-dab4-4716-a6e0-c53563aed5eb"],

Cell[BoxData[
 RowBox[{"2", " ", 
  SuperscriptBox["r", "2"], " ", 
  SuperscriptBox[
   RowBox[{"(", 
    RowBox[{"1", "-", 
     SuperscriptBox["r", "2"]}], ")"}], 
   RowBox[{"n", "/", "2"}]]}]], "Output",
 CellChangeTimes->{3.75159624907241*^9},
 CellLabel->
  "Out[149]=",ExpressionUUID->"7388b862-f652-4f47-8605-7da359a01ab8"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Integrate", "[", 
  RowBox[{
   RowBox[{
    RowBox[{"2", "*", "r", "*", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{"1", "-", 
        RowBox[{
         RowBox[{"(", 
          RowBox[{"b", "-", "r"}], ")"}], "^", "2"}], "-", 
        RowBox[{"4", "*", "b", "*", "r", "*", 
         RowBox[{
          RowBox[{"Sin", "[", "xi", "]"}], "^", "2"}]}]}], ")"}], "^", 
      RowBox[{"(", 
       RowBox[{"n", "/", "2"}], ")"}]}], "*", 
     RowBox[{"(", 
      RowBox[{"r", "-", "b", "+", 
       RowBox[{"2", "*", "b", "*", 
        RowBox[{
         RowBox[{"Sin", "[", "xi", "]"}], "^", "2"}]}]}], ")"}]}], " ", "/.", 
    " ", 
    RowBox[{"n", " ", "\[Rule]", " ", "2"}]}], ",", 
   RowBox[{"{", 
    RowBox[{"xi", ",", 
     RowBox[{
      RowBox[{"-", "Pi"}], "/", "2"}], ",", 
     RowBox[{"Pi", "/", "2"}]}], "}"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.7515962988345833`*^9, 3.751596311161421*^9}},
 CellLabel->
  "In[150]:=",ExpressionUUID->"75f71584-7320-4272-8d5a-044a84aa3887"],

Cell[BoxData[
 RowBox[{
  RowBox[{"-", "2"}], " ", "\[Pi]", " ", 
  SuperscriptBox["r", "2"], " ", 
  RowBox[{"(", 
   RowBox[{
    RowBox[{"-", "1"}], "+", 
    RowBox[{"2", " ", 
     SuperscriptBox["b", "2"]}], "+", 
    SuperscriptBox["r", "2"]}], ")"}]}]], "Output",
 CellChangeTimes->{3.751596312276205*^9},
 CellLabel->
  "Out[150]=",ExpressionUUID->"e0c457e7-fe10-4211-b277-1aff27f46def"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Integrate", "[", 
  RowBox[{
   RowBox[{
    RowBox[{"2", "*", "r", "*", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{"1", "-", 
        RowBox[{
         RowBox[{"(", 
          RowBox[{"b", "-", "r"}], ")"}], "^", "2"}], "-", 
        RowBox[{"4", "*", "b", "*", "r", "*", 
         RowBox[{
          RowBox[{"Sin", "[", "xi", "]"}], "^", "2"}]}]}], ")"}], "^", 
      RowBox[{"(", 
       RowBox[{"n", "/", "2"}], ")"}]}], "*", 
     RowBox[{"(", 
      RowBox[{"r", "-", "b", "+", 
       RowBox[{"2", "*", "b", "*", 
        RowBox[{
         RowBox[{"Sin", "[", "xi", "]"}], "^", "2"}]}]}], ")"}]}], " ", "/.", 
    " ", 
    RowBox[{"n", " ", "\[Rule]", " ", "3"}]}], ",", 
   RowBox[{"{", 
    RowBox[{"xi", ",", 
     RowBox[{
      RowBox[{"-", "Pi"}], "/", "2"}], ",", 
     RowBox[{"Pi", "/", "2"}]}], "}"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.751596373478139*^9, 3.751596373507968*^9}},
 CellLabel->
  "In[151]:=",ExpressionUUID->"e20b25cb-3961-40e0-9b13-ea72d6714551"],

Cell[BoxData[
 RowBox[{"ConditionalExpression", "[", 
  RowBox[{
   RowBox[{
    RowBox[{"-", 
     FractionBox["2", "15"]}], " ", 
    SqrtBox[
     RowBox[{
      RowBox[{"-", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"-", "1"}], "+", "b", "+", "r"}], ")"}]}], " ", 
      RowBox[{"(", 
       RowBox[{"1", "+", "b", "+", "r"}], ")"}]}]], " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{
       RowBox[{"(", 
        RowBox[{
         RowBox[{"3", " ", 
          SuperscriptBox[
           RowBox[{"(", 
            RowBox[{
             RowBox[{"-", "1"}], "+", 
             SuperscriptBox["b", "2"]}], ")"}], "2"]}], "+", 
         RowBox[{"2", " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"-", "23"}], "+", 
            RowBox[{"41", " ", 
             SuperscriptBox["b", "2"]}]}], ")"}], " ", 
          SuperscriptBox["r", "2"]}], "+", 
         RowBox[{"43", " ", 
          SuperscriptBox["r", "4"]}]}], ")"}], " ", 
       RowBox[{"EllipticE", "[", 
        FractionBox[
         RowBox[{"4", " ", "b", " ", "r"}], 
         RowBox[{
          RowBox[{"(", 
           RowBox[{
            RowBox[{"-", "1"}], "+", "b", "+", "r"}], ")"}], " ", 
          RowBox[{"(", 
           RowBox[{"1", "+", "b", "+", "r"}], ")"}]}]], "]"}]}], "-", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{
         RowBox[{"-", "1"}], "+", "b", "-", "r"}], ")"}], " ", 
       RowBox[{"(", 
        RowBox[{"1", "+", "b", "-", "r"}], ")"}], " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"-", "3"}], "+", 
         RowBox[{"3", " ", 
          SuperscriptBox["b", "2"]}], "+", 
         RowBox[{"13", " ", 
          SuperscriptBox["r", "2"]}]}], ")"}], " ", 
       RowBox[{"EllipticK", "[", 
        FractionBox[
         RowBox[{"4", " ", "b", " ", "r"}], 
         RowBox[{
          RowBox[{"(", 
           RowBox[{
            RowBox[{"-", "1"}], "+", "b", "+", "r"}], ")"}], " ", 
          RowBox[{"(", 
           RowBox[{"1", "+", "b", "+", "r"}], ")"}]}]], "]"}]}]}], ")"}]}], 
   ",", 
   RowBox[{
    RowBox[{
     RowBox[{"Re", "[", 
      SuperscriptBox[
       RowBox[{"(", 
        RowBox[{"b", "+", "r"}], ")"}], "2"], "]"}], "<", "1"}], "&&", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{
       RowBox[{"Re", "[", 
        FractionBox[
         RowBox[{
          RowBox[{"-", "1"}], "+", 
          SuperscriptBox["b", "2"], "+", 
          SuperscriptBox["r", "2"]}], 
         RowBox[{"b", " ", "r"}]], "]"}], "\[GreaterEqual]", "2"}], "||", 
      RowBox[{
       RowBox[{"Re", "[", 
        FractionBox[
         RowBox[{
          RowBox[{"-", "1"}], "+", 
          SuperscriptBox["b", "2"], "+", 
          SuperscriptBox["r", "2"]}], 
         RowBox[{"b", " ", "r"}]], "]"}], "\[LessEqual]", 
       RowBox[{"-", "2"}]}], "||", 
      RowBox[{
       FractionBox[
        RowBox[{
         RowBox[{"-", "1"}], "+", 
         SuperscriptBox["b", "2"], "+", 
         SuperscriptBox["r", "2"]}], 
        RowBox[{"b", " ", "r"}]], "\[NotElement]", 
       TemplateBox[{},
        "Reals"]}]}], ")"}]}]}], "]"}]], "Output",
 CellChangeTimes->{3.751596585488655*^9},
 CellLabel->
  "Out[151]=",ExpressionUUID->"378d33af-854e-40d0-8874-df568c7c36b9"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Normal", "[", "%", "]"}]], "Input",
 CellChangeTimes->{{3.751596600958531*^9, 3.751596603097259*^9}},
 CellLabel->
  "In[152]:=",ExpressionUUID->"16563eb9-4d60-455a-9b0d-740e0b7ff5f3"],

Cell[BoxData[
 RowBox[{
  RowBox[{"-", 
   FractionBox["2", "15"]}], " ", 
  SqrtBox[
   RowBox[{
    RowBox[{"-", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"-", "1"}], "+", "b", "+", "r"}], ")"}]}], " ", 
    RowBox[{"(", 
     RowBox[{"1", "+", "b", "+", "r"}], ")"}]}]], " ", 
  RowBox[{"(", 
   RowBox[{
    RowBox[{
     RowBox[{"(", 
      RowBox[{
       RowBox[{"3", " ", 
        SuperscriptBox[
         RowBox[{"(", 
          RowBox[{
           RowBox[{"-", "1"}], "+", 
           SuperscriptBox["b", "2"]}], ")"}], "2"]}], "+", 
       RowBox[{"2", " ", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"-", "23"}], "+", 
          RowBox[{"41", " ", 
           SuperscriptBox["b", "2"]}]}], ")"}], " ", 
        SuperscriptBox["r", "2"]}], "+", 
       RowBox[{"43", " ", 
        SuperscriptBox["r", "4"]}]}], ")"}], " ", 
     RowBox[{"EllipticE", "[", 
      FractionBox[
       RowBox[{"4", " ", "b", " ", "r"}], 
       RowBox[{
        RowBox[{"(", 
         RowBox[{
          RowBox[{"-", "1"}], "+", "b", "+", "r"}], ")"}], " ", 
        RowBox[{"(", 
         RowBox[{"1", "+", "b", "+", "r"}], ")"}]}]], "]"}]}], "-", 
    RowBox[{
     RowBox[{"(", 
      RowBox[{
       RowBox[{"-", "1"}], "+", "b", "-", "r"}], ")"}], " ", 
     RowBox[{"(", 
      RowBox[{"1", "+", "b", "-", "r"}], ")"}], " ", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"-", "3"}], "+", 
       RowBox[{"3", " ", 
        SuperscriptBox["b", "2"]}], "+", 
       RowBox[{"13", " ", 
        SuperscriptBox["r", "2"]}]}], ")"}], " ", 
     RowBox[{"EllipticK", "[", 
      FractionBox[
       RowBox[{"4", " ", "b", " ", "r"}], 
       RowBox[{
        RowBox[{"(", 
         RowBox[{
          RowBox[{"-", "1"}], "+", "b", "+", "r"}], ")"}], " ", 
        RowBox[{"(", 
         RowBox[{"1", "+", "b", "+", "r"}], ")"}]}]], "]"}]}]}], 
   ")"}]}]], "Output",
 CellChangeTimes->{3.751596603454955*^9},
 CellLabel->
  "Out[152]=",ExpressionUUID->"4ecd8954-ae66-418d-a306-90a5d77a040c"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"FullSimplify", "[", "%", "]"}]], "Input",
 CellChangeTimes->{{3.751596604421689*^9, 3.7515966066570797`*^9}},
 CellLabel->
  "In[153]:=",ExpressionUUID->"7402f492-a310-4277-bd07-447ecc81b6f3"],

Cell[BoxData[
 RowBox[{
  RowBox[{"-", 
   FractionBox["2", "15"]}], " ", 
  SqrtBox[
   RowBox[{
    RowBox[{"-", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"-", "1"}], "+", "b", "+", "r"}], ")"}]}], " ", 
    RowBox[{"(", 
     RowBox[{"1", "+", "b", "+", "r"}], ")"}]}]], " ", 
  RowBox[{"(", 
   RowBox[{
    RowBox[{
     RowBox[{"(", 
      RowBox[{
       RowBox[{"3", " ", 
        SuperscriptBox[
         RowBox[{"(", 
          RowBox[{
           RowBox[{"-", "1"}], "+", 
           SuperscriptBox["b", "2"]}], ")"}], "2"]}], "+", 
       RowBox[{"2", " ", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"-", "23"}], "+", 
          RowBox[{"41", " ", 
           SuperscriptBox["b", "2"]}]}], ")"}], " ", 
        SuperscriptBox["r", "2"]}], "+", 
       RowBox[{"43", " ", 
        SuperscriptBox["r", "4"]}]}], ")"}], " ", 
     RowBox[{"EllipticE", "[", 
      FractionBox[
       RowBox[{"4", " ", "b", " ", "r"}], 
       RowBox[{
        RowBox[{"(", 
         RowBox[{
          RowBox[{"-", "1"}], "+", "b", "+", "r"}], ")"}], " ", 
        RowBox[{"(", 
         RowBox[{"1", "+", "b", "+", "r"}], ")"}]}]], "]"}]}], "-", 
    RowBox[{
     RowBox[{"(", 
      RowBox[{
       RowBox[{"-", "1"}], "+", "b", "-", "r"}], ")"}], " ", 
     RowBox[{"(", 
      RowBox[{"1", "+", "b", "-", "r"}], ")"}], " ", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"-", "3"}], "+", 
       RowBox[{"3", " ", 
        SuperscriptBox["b", "2"]}], "+", 
       RowBox[{"13", " ", 
        SuperscriptBox["r", "2"]}]}], ")"}], " ", 
     RowBox[{"EllipticK", "[", 
      FractionBox[
       RowBox[{"4", " ", "b", " ", "r"}], 
       RowBox[{
        RowBox[{"(", 
         RowBox[{
          RowBox[{"-", "1"}], "+", "b", "+", "r"}], ")"}], " ", 
        RowBox[{"(", 
         RowBox[{"1", "+", "b", "+", "r"}], ")"}]}]], "]"}]}]}], 
   ")"}]}]], "Output",
 CellChangeTimes->{3.751596607718205*^9},
 CellLabel->
  "Out[153]=",ExpressionUUID->"dedc6704-e70d-4e48-8b26-cc89efada380"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Series", "[", 
  RowBox[{
   RowBox[{"Out", "[", "153", "]"}], ",", 
   RowBox[{"{", 
    RowBox[{"b", ",", "0", ",", "2"}], "}"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.75159713722978*^9, 3.751597145735179*^9}},
 CellLabel->
  "In[157]:=",ExpressionUUID->"b70d2432-b21e-4238-9dcc-6035e54c0824"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
   RowBox[{"(", 
    RowBox[{
     RowBox[{"2", " ", "\[Pi]", " ", 
      SuperscriptBox["r", "2"], " ", 
      SqrtBox[
       RowBox[{"1", "-", 
        SuperscriptBox["r", "2"]}]]}], "-", 
     RowBox[{"2", " ", "\[Pi]", " ", 
      SuperscriptBox["r", "4"], " ", 
      SqrtBox[
       RowBox[{"1", "-", 
        SuperscriptBox["r", "2"]}]]}]}], ")"}], "+", 
   FractionBox[
    RowBox[{"3", " ", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{
        RowBox[{"-", "4"}], " ", "\[Pi]", " ", 
        SuperscriptBox["r", "2"]}], "+", 
       RowBox[{"5", " ", "\[Pi]", " ", 
        SuperscriptBox["r", "4"]}]}], ")"}], " ", 
     SuperscriptBox["b", "2"]}], 
    RowBox[{"2", " ", 
     SqrtBox[
      RowBox[{"1", "-", 
       SuperscriptBox["r", "2"]}]]}]], "+", 
   InterpretationBox[
    SuperscriptBox[
     RowBox[{"O", "[", "b", "]"}], "3"],
    SeriesData[$CellContext`b, 0, {}, 0, 3, 1],
    Editable->False]}],
  SeriesData[$CellContext`b, 0, {
   2 Pi $CellContext`r^2 (1 - $CellContext`r^2)^Rational[1, 2] - 2 
    Pi $CellContext`r^4 (1 - $CellContext`r^2)^Rational[1, 2], 0, 
    Rational[3, 2] (1 - $CellContext`r^2)^
     Rational[-1, 2] ((-4) Pi $CellContext`r^2 + 5 Pi $CellContext`r^4)}, 0, 
   3, 1],
  Editable->False]], "Output",
 CellChangeTimes->{3.75159714669925*^9},
 CellLabel->
  "Out[157]=",ExpressionUUID->"da519e4c-b823-46cb-a232-33e6d916ee65"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"FullSimplify", "[", "%", "]"}]], "Input",
 CellChangeTimes->{{3.751597148164674*^9, 3.75159715011203*^9}},
 CellLabel->
  "In[158]:=",ExpressionUUID->"7e0257fb-d722-412c-aefd-f8edb33fab96"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
   RowBox[{"2", " ", "\[Pi]", " ", 
    SuperscriptBox["r", "2"], " ", 
    SuperscriptBox[
     RowBox[{"(", 
      RowBox[{"1", "-", 
       SuperscriptBox["r", "2"]}], ")"}], 
     RowBox[{"3", "/", "2"}]]}], "+", 
   FractionBox[
    RowBox[{"3", " ", "\[Pi]", " ", 
     SuperscriptBox["r", "2"], " ", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"-", "4"}], "+", 
       RowBox[{"5", " ", 
        SuperscriptBox["r", "2"]}]}], ")"}], " ", 
     SuperscriptBox["b", "2"]}], 
    RowBox[{"2", " ", 
     SqrtBox[
      RowBox[{"1", "-", 
       SuperscriptBox["r", "2"]}]]}]], "+", 
   InterpretationBox[
    SuperscriptBox[
     RowBox[{"O", "[", "b", "]"}], "3"],
    SeriesData[$CellContext`b, 0, {}, 0, 3, 1],
    Editable->False]}],
  SeriesData[$CellContext`b, 0, {
   2 Pi $CellContext`r^2 (1 - $CellContext`r^2)^Rational[3, 2], 0, 
    Rational[3, 2] 
    Pi $CellContext`r^2 (1 - $CellContext`r^2)^Rational[-1, 2] (-4 + 
     5 $CellContext`r^2)}, 0, 3, 1],
  Editable->False]], "Output",
 CellChangeTimes->{3.7515971504527197`*^9},
 CellLabel->
  "Out[158]=",ExpressionUUID->"2ef4728d-e0cf-49a3-9dc9-61730eff6bc9"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Integrate", "[", 
  RowBox[{
   RowBox[{
    RowBox[{"4", "*", "r", "*", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{"1", "-", 
        RowBox[{
         RowBox[{"(", 
          RowBox[{"b", "-", "r"}], ")"}], "^", "2"}], "-", 
        RowBox[{"4", "*", "b", "*", "r", "*", 
         RowBox[{
          RowBox[{"Sin", "[", "xi", "]"}], "^", "2"}]}]}], ")"}], "^", 
      RowBox[{"(", 
       RowBox[{"n", "/", "2"}], ")"}]}], "*", 
     RowBox[{"(", 
      RowBox[{"r", "-", "b", "+", 
       RowBox[{"2", "*", "b", "*", 
        RowBox[{
         RowBox[{"Sin", "[", "xi", "]"}], "^", "2"}]}]}], ")"}]}], " ", "/.", 
    " ", 
    RowBox[{"n", " ", "\[Rule]", " ", "3"}]}], ",", 
   RowBox[{"{", 
    RowBox[{"xi", ",", "0", ",", 
     RowBox[{"ArcSin", "[", 
      RowBox[{"Sqrt", "[", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{"1", "-", 
          RowBox[{
           RowBox[{"(", 
            RowBox[{"b", "-", "r"}], ")"}], "^", "2"}]}], ")"}], "/", 
        RowBox[{"(", 
         RowBox[{"4", "*", "b", "*", "r"}], ")"}]}], "]"}], "]"}]}], "}"}]}], 
  "]"}]], "Input",
 CellChangeTimes->{{3.751597460047368*^9, 3.751597480869375*^9}},
 CellLabel->
  "In[159]:=",ExpressionUUID->"02793c26-e651-4305-84ce-a6c264177ffa"],

Cell[BoxData["$Aborted"], "Output",
 CellChangeTimes->{3.751597576031518*^9},
 CellLabel->
  "Out[159]=",ExpressionUUID->"1c3165ec-b50d-4adc-ac14-201e9ffb2d66"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{
    RowBox[{
     RowBox[{"Try", " ", "again", " ", "for", " ", "b"}], "+", "r"}], " ", 
    "\[GreaterEqual]", " ", "1"}], " ", "*)"}], "\[IndentingNewLine]", 
  RowBox[{"Series", "[", 
   RowBox[{
    RowBox[{"2", "*", "r", "*", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{"1", "-", 
        RowBox[{
         RowBox[{"(", 
          RowBox[{"r", "-", "b"}], ")"}], "^", "2"}], "-", 
        RowBox[{"4", "*", "b", "*", "r", "*", 
         RowBox[{
          RowBox[{"Sin", "[", "xi", "]"}], "^", "2"}]}]}], ")"}], "^", 
      RowBox[{"(", 
       RowBox[{"n", "/", "2"}], ")"}]}], "*", 
     RowBox[{"(", 
      RowBox[{"r", "-", "b", "+", 
       RowBox[{"2", "*", "b", "*", 
        RowBox[{
         RowBox[{"Sin", "[", "xi", "]"}], "^", "2"}]}]}], ")"}]}], ",", 
    RowBox[{"{", 
     RowBox[{"b", ",", "0", ",", "3"}], "}"}]}], "]"}]}]], "Input",
 CellChangeTimes->{{3.751597641071478*^9, 3.751597652861833*^9}},
 CellLabel->
  "In[160]:=",ExpressionUUID->"5cc87adc-2180-42e8-a971-82353801d5f4"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
   RowBox[{"2", " ", 
    SuperscriptBox["r", "2"], " ", 
    SuperscriptBox[
     RowBox[{"(", 
      RowBox[{"1", "-", 
       SuperscriptBox["r", "2"]}], ")"}], 
     RowBox[{"n", "/", "2"}]]}], "+", 
   FractionBox[
    RowBox[{"2", " ", "r", " ", 
     SuperscriptBox[
      RowBox[{"(", 
       RowBox[{"1", "-", 
        SuperscriptBox["r", "2"]}], ")"}], 
      RowBox[{"n", "/", "2"}]], " ", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"-", "1"}], "+", 
       SuperscriptBox["r", "2"], "+", 
       RowBox[{"n", " ", 
        SuperscriptBox["r", "2"]}]}], ")"}], " ", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"-", "1"}], "+", 
       RowBox[{"2", " ", 
        SuperscriptBox[
         RowBox[{"Sin", "[", "xi", "]"}], "2"]}]}], ")"}], " ", "b"}], 
    RowBox[{
     RowBox[{"-", "1"}], "+", 
     SuperscriptBox["r", "2"]}]], "+", 
   FractionBox[
    RowBox[{"n", " ", 
     SuperscriptBox["r", "2"], " ", 
     SuperscriptBox[
      RowBox[{"(", 
       RowBox[{"1", "-", 
        SuperscriptBox["r", "2"]}], ")"}], 
      RowBox[{"n", "/", "2"}]], " ", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"-", "3"}], "+", 
       SuperscriptBox["r", "2"], "+", 
       RowBox[{"n", " ", 
        SuperscriptBox["r", "2"]}], "+", 
       RowBox[{"8", " ", 
        SuperscriptBox[
         RowBox[{"Sin", "[", "xi", "]"}], "2"]}], "-", 
       RowBox[{"4", " ", "n", " ", 
        SuperscriptBox["r", "2"], " ", 
        SuperscriptBox[
         RowBox[{"Sin", "[", "xi", "]"}], "2"]}], "-", 
       RowBox[{"8", " ", 
        SuperscriptBox[
         RowBox[{"Sin", "[", "xi", "]"}], "4"]}], "+", 
       RowBox[{"4", " ", "n", " ", 
        SuperscriptBox["r", "2"], " ", 
        SuperscriptBox[
         RowBox[{"Sin", "[", "xi", "]"}], "4"]}]}], ")"}], " ", 
     SuperscriptBox["b", "2"]}], 
    SuperscriptBox[
     RowBox[{"(", 
      RowBox[{
       RowBox[{"-", "1"}], "+", 
       SuperscriptBox["r", "2"]}], ")"}], "2"]], "+", 
   RowBox[{
    FractionBox["1", 
     RowBox[{"3", " ", 
      SuperscriptBox[
       RowBox[{"(", 
        RowBox[{
         RowBox[{"-", "1"}], "+", 
         SuperscriptBox["r", "2"]}], ")"}], "3"]}]], 
    RowBox[{"n", " ", "r", " ", 
     SuperscriptBox[
      RowBox[{"(", 
       RowBox[{"1", "-", 
        SuperscriptBox["r", "2"]}], ")"}], 
      RowBox[{"n", "/", "2"}]], " ", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"-", "1"}], "+", 
       RowBox[{"2", " ", 
        SuperscriptBox[
         RowBox[{"Sin", "[", "xi", "]"}], "2"]}]}], ")"}], " ", 
     RowBox[{"(", 
      RowBox[{"3", "+", 
       RowBox[{"6", " ", 
        SuperscriptBox["r", "2"]}], "-", 
       RowBox[{"6", " ", "n", " ", 
        SuperscriptBox["r", "2"]}], "-", 
       SuperscriptBox["r", "4"], "+", 
       RowBox[{
        SuperscriptBox["n", "2"], " ", 
        SuperscriptBox["r", "4"]}], "-", 
       RowBox[{"24", " ", 
        SuperscriptBox["r", "2"], " ", 
        SuperscriptBox[
         RowBox[{"Sin", "[", "xi", "]"}], "2"]}], "+", 
       RowBox[{"12", " ", "n", " ", 
        SuperscriptBox["r", "2"], " ", 
        SuperscriptBox[
         RowBox[{"Sin", "[", "xi", "]"}], "2"]}], "-", 
       RowBox[{"8", " ", 
        SuperscriptBox["r", "4"], " ", 
        SuperscriptBox[
         RowBox[{"Sin", "[", "xi", "]"}], "2"]}], "+", 
       RowBox[{"12", " ", "n", " ", 
        SuperscriptBox["r", "4"], " ", 
        SuperscriptBox[
         RowBox[{"Sin", "[", "xi", "]"}], "2"]}], "-", 
       RowBox[{"4", " ", 
        SuperscriptBox["n", "2"], " ", 
        SuperscriptBox["r", "4"], " ", 
        SuperscriptBox[
         RowBox[{"Sin", "[", "xi", "]"}], "2"]}], "+", 
       RowBox[{"24", " ", 
        SuperscriptBox["r", "2"], " ", 
        SuperscriptBox[
         RowBox[{"Sin", "[", "xi", "]"}], "4"]}], "-", 
       RowBox[{"12", " ", "n", " ", 
        SuperscriptBox["r", "2"], " ", 
        SuperscriptBox[
         RowBox[{"Sin", "[", "xi", "]"}], "4"]}], "+", 
       RowBox[{"8", " ", 
        SuperscriptBox["r", "4"], " ", 
        SuperscriptBox[
         RowBox[{"Sin", "[", "xi", "]"}], "4"]}], "-", 
       RowBox[{"12", " ", "n", " ", 
        SuperscriptBox["r", "4"], " ", 
        SuperscriptBox[
         RowBox[{"Sin", "[", "xi", "]"}], "4"]}], "+", 
       RowBox[{"4", " ", 
        SuperscriptBox["n", "2"], " ", 
        SuperscriptBox["r", "4"], " ", 
        SuperscriptBox[
         RowBox[{"Sin", "[", "xi", "]"}], "4"]}]}], ")"}], " ", 
     SuperscriptBox["b", "3"]}]}], "+", 
   InterpretationBox[
    SuperscriptBox[
     RowBox[{"O", "[", "b", "]"}], "4"],
    SeriesData[$CellContext`b, 0, {}, 0, 4, 1],
    Editable->False]}],
  SeriesData[$CellContext`b, 0, {
   2 $CellContext`r^2 (1 - $CellContext`r^2)^(Rational[1, 2] $CellContext`n), 
    2 $CellContext`r (1 - $CellContext`r^2)^(
      Rational[1, 
        2] $CellContext`n) (-1 + $CellContext`r^2)^(-1) (-1 + \
$CellContext`r^2 + $CellContext`n $CellContext`r^2) (-1 + 
     2 Sin[$CellContext`xi]^2), $CellContext`n $CellContext`r^2 (
      1 - $CellContext`r^2)^(
      Rational[1, 
        2] $CellContext`n) (-1 + $CellContext`r^2)^(-2) (-3 + \
$CellContext`r^2 + $CellContext`n $CellContext`r^2 + 8 Sin[$CellContext`xi]^2 - 
     4 $CellContext`n $CellContext`r^2 Sin[$CellContext`xi]^2 - 8 
     Sin[$CellContext`xi]^4 + 
     4 $CellContext`n $CellContext`r^2 Sin[$CellContext`xi]^4), 
    Rational[1, 3] $CellContext`n $CellContext`r (1 - $CellContext`r^2)^(
      Rational[1, 2] $CellContext`n) (-1 + $CellContext`r^2)^(-3) (-1 + 
     2 Sin[$CellContext`xi]^2) (3 + 6 $CellContext`r^2 - 
     6 $CellContext`n $CellContext`r^2 - $CellContext`r^4 + $CellContext`n^2 \
$CellContext`r^4 - 24 $CellContext`r^2 Sin[$CellContext`xi]^2 + 
     12 $CellContext`n $CellContext`r^2 Sin[$CellContext`xi]^2 - 
     8 $CellContext`r^4 Sin[$CellContext`xi]^2 + 
     12 $CellContext`n $CellContext`r^4 Sin[$CellContext`xi]^2 - 
     4 $CellContext`n^2 $CellContext`r^4 Sin[$CellContext`xi]^2 + 
     24 $CellContext`r^2 Sin[$CellContext`xi]^4 - 
     12 $CellContext`n $CellContext`r^2 Sin[$CellContext`xi]^4 + 
     8 $CellContext`r^4 Sin[$CellContext`xi]^4 - 
     12 $CellContext`n $CellContext`r^4 Sin[$CellContext`xi]^4 + 
     4 $CellContext`n^2 $CellContext`r^4 Sin[$CellContext`xi]^4)}, 0, 4, 1],
  Editable->False]], "Output",
 CellChangeTimes->{3.7515976535643797`*^9},
 CellLabel->
  "Out[160]=",ExpressionUUID->"234fe8f8-5dc0-4ae1-af5e-658b81bd9840"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Integrate", "[", 
  RowBox[{
   RowBox[{"Normal", "[", 
    RowBox[{"Out", "[", "160", "]"}], "]"}], ",", 
   RowBox[{"{", 
    RowBox[{"xi", ",", 
     RowBox[{"-", 
      RowBox[{"ArcSin", "[", 
       RowBox[{"Sqrt", "[", 
        RowBox[{
         RowBox[{"(", 
          RowBox[{"1", "-", 
           RowBox[{
            RowBox[{"(", 
             RowBox[{"b", "-", "r"}], ")"}], "^", "2"}]}], ")"}], "/", 
         RowBox[{"(", 
          RowBox[{"4", "*", "b", "*", "r"}], ")"}]}], "]"}], "]"}]}], ",", 
     RowBox[{"ArcSin", "[", 
      RowBox[{"Sqrt", "[", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{"1", "-", 
          RowBox[{
           RowBox[{"(", 
            RowBox[{"b", "-", "r"}], ")"}], "^", "2"}]}], ")"}], "/", 
        RowBox[{"(", 
         RowBox[{"4", "*", "b", "*", "r"}], ")"}]}], "]"}], "]"}]}], "}"}]}], 
  "]"}]], "Input",
 CellChangeTimes->{{3.7515976591871157`*^9, 3.751597713783894*^9}, {
  3.751597805427709*^9, 3.751597809616681*^9}},
 CellLabel->
  "In[164]:=",ExpressionUUID->"db4e7a2a-931b-4d48-b6e1-89436dd560e9"],

Cell[BoxData[
 RowBox[{
  FractionBox["1", "3"], " ", "r", " ", 
  SuperscriptBox[
   RowBox[{"(", 
    RowBox[{"1", "-", 
     SuperscriptBox["r", "2"]}], ")"}], 
   RowBox[{"n", "/", "2"}]], " ", 
  RowBox[{"(", 
   RowBox[{
    RowBox[{"-", 
     FractionBox[
      RowBox[{"3", " ", "b", " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"-", "1"}], "+", 
         RowBox[{
          RowBox[{"(", 
           RowBox[{"1", "+", "n"}], ")"}], " ", 
          SuperscriptBox["r", "2"]}]}], ")"}], " ", 
       SqrtBox[
        RowBox[{"-", 
         FractionBox[
          RowBox[{
           SuperscriptBox["b", "4"], "+", 
           SuperscriptBox[
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", "1"}], "+", 
              SuperscriptBox["r", "2"]}], ")"}], "2"], "-", 
           RowBox[{"2", " ", 
            SuperscriptBox["b", "2"], " ", 
            RowBox[{"(", 
             RowBox[{"1", "+", 
              SuperscriptBox["r", "2"]}], ")"}]}]}], 
          RowBox[{
           SuperscriptBox["b", "2"], " ", 
           SuperscriptBox["r", "2"]}]]}]]}], 
      RowBox[{
       RowBox[{"-", "1"}], "+", 
       SuperscriptBox["r", "2"]}]]}], "+", 
    RowBox[{"12", " ", "r", " ", 
     RowBox[{"ArcSin", "[", 
      RowBox[{
       FractionBox["1", "2"], " ", 
       SqrtBox[
        FractionBox[
         RowBox[{"1", "-", 
          SuperscriptBox[
           RowBox[{"(", 
            RowBox[{"b", "-", "r"}], ")"}], "2"]}], 
         RowBox[{"b", " ", "r"}]]]}], "]"}]}], "+", 
    FractionBox[
     RowBox[{"3", " ", 
      SuperscriptBox["b", "2"], " ", "n", " ", "r", " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"4", " ", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"-", "4"}], "+", 
           RowBox[{
            RowBox[{"(", 
             RowBox[{"2", "+", "n"}], ")"}], " ", 
            SuperscriptBox["r", "2"]}]}], ")"}], " ", 
         RowBox[{"ArcSin", "[", 
          RowBox[{
           FractionBox["1", "2"], " ", 
           SqrtBox[
            FractionBox[
             RowBox[{"1", "-", 
              SuperscriptBox[
               RowBox[{"(", 
                RowBox[{"b", "-", "r"}], ")"}], "2"]}], 
             RowBox[{"b", " ", "r"}]]]}], "]"}]}], "+", 
        RowBox[{
         RowBox[{"(", 
          RowBox[{
           RowBox[{"-", "2"}], "+", 
           RowBox[{"n", " ", 
            SuperscriptBox["r", "2"]}]}], ")"}], " ", 
         RowBox[{"Sin", "[", 
          RowBox[{"4", " ", 
           RowBox[{"ArcSin", "[", 
            RowBox[{
             FractionBox["1", "2"], " ", 
             SqrtBox[
              FractionBox[
               RowBox[{"1", "-", 
                SuperscriptBox[
                 RowBox[{"(", 
                  RowBox[{"b", "-", "r"}], ")"}], "2"]}], 
               RowBox[{"b", " ", "r"}]]]}], "]"}]}], "]"}]}]}], ")"}]}], 
     RowBox[{"4", " ", 
      SuperscriptBox[
       RowBox[{"(", 
        RowBox[{
         RowBox[{"-", "1"}], "+", 
         SuperscriptBox["r", "2"]}], ")"}], "2"]}]], "-", 
    RowBox[{
     FractionBox["1", 
      RowBox[{"12", " ", 
       SuperscriptBox[
        RowBox[{"(", 
         RowBox[{
          RowBox[{"-", "1"}], "+", 
          SuperscriptBox["r", "2"]}], ")"}], "3"]}]], 
     RowBox[{
      SuperscriptBox["b", "3"], " ", "n", " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"9", " ", 
         RowBox[{"(", 
          RowBox[{"4", "+", 
           RowBox[{
            RowBox[{"(", 
             RowBox[{"6", "-", 
              RowBox[{"7", " ", "n"}]}], ")"}], " ", 
            SuperscriptBox["r", "2"]}], "+", 
           RowBox[{
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", "2"}], "+", "n", "+", 
              SuperscriptBox["n", "2"]}], ")"}], " ", 
            SuperscriptBox["r", "4"]}]}], ")"}], " ", 
         RowBox[{"Sin", "[", 
          RowBox[{"2", " ", 
           RowBox[{"ArcSin", "[", 
            RowBox[{
             FractionBox["1", "2"], " ", 
             SqrtBox[
              FractionBox[
               RowBox[{"1", "-", 
                SuperscriptBox[
                 RowBox[{"(", 
                  RowBox[{"b", "-", "r"}], ")"}], "2"]}], 
               RowBox[{"b", " ", "r"}]]]}], "]"}]}], "]"}]}], "+", 
        RowBox[{
         RowBox[{"(", 
          RowBox[{
           RowBox[{"-", "2"}], "+", "n"}], ")"}], " ", 
         SuperscriptBox["r", "2"], " ", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"-", "3"}], "+", 
           RowBox[{
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", "1"}], "+", "n"}], ")"}], " ", 
            SuperscriptBox["r", "2"]}]}], ")"}], " ", 
         RowBox[{"Sin", "[", 
          RowBox[{"6", " ", 
           RowBox[{"ArcSin", "[", 
            RowBox[{
             FractionBox["1", "2"], " ", 
             SqrtBox[
              FractionBox[
               RowBox[{"1", "-", 
                SuperscriptBox[
                 RowBox[{"(", 
                  RowBox[{"b", "-", "r"}], ")"}], "2"]}], 
               RowBox[{"b", " ", "r"}]]]}], "]"}]}], "]"}]}]}], ")"}]}]}]}], 
   ")"}]}]], "Output",
 CellChangeTimes->{{3.751597687494246*^9, 3.751597703082358*^9}, 
   3.751597753886366*^9, 3.751597820583426*^9},
 CellLabel->
  "Out[164]=",ExpressionUUID->"94bfc56a-4d19-4f88-b261-62936b87755a"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"FullSimplify", "[", "%", "]"}]], "Input",
 CellChangeTimes->{{3.7515978321852303`*^9, 3.751597833925355*^9}},
 CellLabel->
  "In[165]:=",ExpressionUUID->"f3ebc42e-3831-467e-b31f-d6f3de5e4370"],

Cell[BoxData["$Aborted"], "Output",
 CellChangeTimes->{3.7515978701420403`*^9},
 CellLabel->
  "Out[165]=",ExpressionUUID->"c87b1a63-7c40-44ed-9cea-92e834a3dd03"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Series", "[", 
  RowBox[{
   RowBox[{"Out", "[", "164", "]"}], ",", 
   RowBox[{"{", 
    RowBox[{"b", ",", "0", ",", "3"}], "}"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.751597873596496*^9, 3.751597882077298*^9}},
 CellLabel->
  "In[166]:=",ExpressionUUID->"1e0cd9a9-36c4-4fa8-a714-96f14ccffcb4"],

Cell[BoxData["$Aborted"], "Output",
 CellChangeTimes->{3.751598329824061*^9},
 CellLabel->
  "Out[166]=",ExpressionUUID->"970e8ee2-95b2-467b-82a5-cad6b2df8a76"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Series", "[", 
  RowBox[{
   RowBox[{"2", "*", "r", "*", 
    RowBox[{
     RowBox[{"(", 
      RowBox[{"1", "-", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{"b", "-", "r"}], ")"}], "^", "2"}], "-", 
       RowBox[{"4", "*", "b", "*", "r", "*", 
        RowBox[{
         RowBox[{"Sin", "[", "xi", "]"}], "^", "2"}]}]}], ")"}], "^", 
     RowBox[{"(", 
      RowBox[{"n", "/", "2"}], ")"}]}], "*", 
    RowBox[{"(", 
     RowBox[{"r", "-", "b", "+", 
      RowBox[{"2", "*", "b", "*", 
       RowBox[{
        RowBox[{"Sin", "[", "xi", "]"}], "^", "2"}]}]}], ")"}]}], ",", 
   RowBox[{"{", 
    RowBox[{"r", ",", "1", ",", "2"}], "}"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.75159986588519*^9, 3.7515998721168623`*^9}},
 CellLabel->
  "In[167]:=",ExpressionUUID->"e2d7cb6f-0ca0-4c3b-be3c-474ef0ed0703"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
   RowBox[{"2", " ", 
    SuperscriptBox[
     RowBox[{"(", 
      RowBox[{
       RowBox[{"2", " ", "b"}], "-", 
       SuperscriptBox["b", "2"], "-", 
       RowBox[{"4", " ", "b", " ", 
        SuperscriptBox[
         RowBox[{"Sin", "[", "xi", "]"}], "2"]}]}], ")"}], 
     RowBox[{"n", "/", "2"}]], " ", 
    RowBox[{"(", 
     RowBox[{"1", "-", "b", "+", 
      RowBox[{"2", " ", "b", " ", 
       SuperscriptBox[
        RowBox[{"Sin", "[", "xi", "]"}], "2"]}]}], ")"}]}], "+", 
   RowBox[{"2", " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{
       FractionBox["1", "2"], " ", "n", " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"-", "2"}], "+", 
         RowBox[{"2", " ", "b"}], "-", 
         RowBox[{"4", " ", "b", " ", 
          SuperscriptBox[
           RowBox[{"Sin", "[", "xi", "]"}], "2"]}]}], ")"}], " ", 
       SuperscriptBox[
        RowBox[{"(", 
         RowBox[{
          RowBox[{"2", " ", "b"}], "-", 
          SuperscriptBox["b", "2"], "-", 
          RowBox[{"4", " ", "b", " ", 
           SuperscriptBox[
            RowBox[{"Sin", "[", "xi", "]"}], "2"]}]}], ")"}], 
        RowBox[{
         RowBox[{"-", "1"}], "+", 
         FractionBox["n", "2"]}]], " ", 
       RowBox[{"(", 
        RowBox[{"1", "-", "b", "+", 
         RowBox[{"2", " ", "b", " ", 
          SuperscriptBox[
           RowBox[{"Sin", "[", "xi", "]"}], "2"]}]}], ")"}]}], "+", 
      RowBox[{
       SuperscriptBox[
        RowBox[{"(", 
         RowBox[{
          RowBox[{"2", " ", "b"}], "-", 
          SuperscriptBox["b", "2"], "-", 
          RowBox[{"4", " ", "b", " ", 
           SuperscriptBox[
            RowBox[{"Sin", "[", "xi", "]"}], "2"]}]}], ")"}], 
        RowBox[{"n", "/", "2"}]], " ", 
       RowBox[{"(", 
        RowBox[{"2", "-", "b", "+", 
         RowBox[{"2", " ", "b", " ", 
          SuperscriptBox[
           RowBox[{"Sin", "[", "xi", "]"}], "2"]}]}], ")"}]}]}], ")"}], " ", 
    RowBox[{"(", 
     RowBox[{"r", "-", "1"}], ")"}]}], "+", 
   RowBox[{"2", " ", 
    RowBox[{"(", 
     RowBox[{
      SuperscriptBox[
       RowBox[{"(", 
        RowBox[{
         RowBox[{"2", " ", "b"}], "-", 
         SuperscriptBox["b", "2"], "-", 
         RowBox[{"4", " ", "b", " ", 
          SuperscriptBox[
           RowBox[{"Sin", "[", "xi", "]"}], "2"]}]}], ")"}], 
       RowBox[{"n", "/", "2"}]], "+", 
      RowBox[{
       FractionBox["1", "2"], " ", "n", " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"-", "2"}], "+", 
         RowBox[{"2", " ", "b"}], "-", 
         RowBox[{"4", " ", "b", " ", 
          SuperscriptBox[
           RowBox[{"Sin", "[", "xi", "]"}], "2"]}]}], ")"}], " ", 
       SuperscriptBox[
        RowBox[{"(", 
         RowBox[{
          RowBox[{"2", " ", "b"}], "-", 
          SuperscriptBox["b", "2"], "-", 
          RowBox[{"4", " ", "b", " ", 
           SuperscriptBox[
            RowBox[{"Sin", "[", "xi", "]"}], "2"]}]}], ")"}], 
        RowBox[{
         RowBox[{"-", "1"}], "+", 
         FractionBox["n", "2"]}]], " ", 
       RowBox[{"(", 
        RowBox[{"2", "-", "b", "+", 
         RowBox[{"2", " ", "b", " ", 
          SuperscriptBox[
           RowBox[{"Sin", "[", "xi", "]"}], "2"]}]}], ")"}]}], "+", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{"1", "-", "b", "+", 
         RowBox[{"2", " ", "b", " ", 
          SuperscriptBox[
           RowBox[{"Sin", "[", "xi", "]"}], "2"]}]}], ")"}], " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{
          FractionBox["1", "4"], " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"-", "1"}], "+", 
            FractionBox["n", "2"]}], ")"}], " ", "n", " ", 
          SuperscriptBox[
           RowBox[{"(", 
            RowBox[{
             RowBox[{"-", "2"}], "+", 
             RowBox[{"2", " ", "b"}], "-", 
             RowBox[{"4", " ", "b", " ", 
              SuperscriptBox[
               RowBox[{"Sin", "[", "xi", "]"}], "2"]}]}], ")"}], "2"], " ", 
          SuperscriptBox[
           RowBox[{"(", 
            RowBox[{
             RowBox[{"2", " ", "b"}], "-", 
             SuperscriptBox["b", "2"], "-", 
             RowBox[{"4", " ", "b", " ", 
              SuperscriptBox[
               RowBox[{"Sin", "[", "xi", "]"}], "2"]}]}], ")"}], 
           RowBox[{
            RowBox[{"-", "2"}], "+", 
            FractionBox["n", "2"]}]]}], "-", 
         RowBox[{
          FractionBox["1", "2"], " ", "n", " ", 
          SuperscriptBox[
           RowBox[{"(", 
            RowBox[{
             RowBox[{"2", " ", "b"}], "-", 
             SuperscriptBox["b", "2"], "-", 
             RowBox[{"4", " ", "b", " ", 
              SuperscriptBox[
               RowBox[{"Sin", "[", "xi", "]"}], "2"]}]}], ")"}], 
           RowBox[{
            RowBox[{"-", "1"}], "+", 
            FractionBox["n", "2"]}]]}]}], ")"}]}]}], ")"}], " ", 
    SuperscriptBox[
     RowBox[{"(", 
      RowBox[{"r", "-", "1"}], ")"}], "2"]}], "+", 
   InterpretationBox[
    SuperscriptBox[
     RowBox[{"O", "[", 
      RowBox[{"r", "-", "1"}], "]"}], "3"],
    SeriesData[$CellContext`r, 1, {}, 0, 3, 1],
    Editable->False]}],
  SeriesData[$CellContext`r, 1, {
   2 (2 $CellContext`b - $CellContext`b^2 - 4 $CellContext`b 
      Sin[$CellContext`xi]^2)^(Rational[1, 2] $CellContext`n) (
     1 - $CellContext`b + 2 $CellContext`b Sin[$CellContext`xi]^2), 
    2 (Rational[1, 2] $CellContext`n (-2 + 2 $CellContext`b - 
       4 $CellContext`b 
       Sin[$CellContext`xi]^2) (2 $CellContext`b - $CellContext`b^2 - 
        4 $CellContext`b Sin[$CellContext`xi]^2)^(-1 + 
        Rational[1, 2] $CellContext`n) (1 - $CellContext`b + 
       2 $CellContext`b Sin[$CellContext`xi]^2) + (
        2 $CellContext`b - $CellContext`b^2 - 4 $CellContext`b 
        Sin[$CellContext`xi]^2)^(Rational[1, 2] $CellContext`n) (
       2 - $CellContext`b + 2 $CellContext`b Sin[$CellContext`xi]^2)), 
    2 ((2 $CellContext`b - $CellContext`b^2 - 4 $CellContext`b 
       Sin[$CellContext`xi]^2)^(Rational[1, 2] $CellContext`n) + 
     Rational[1, 2] $CellContext`n (-2 + 2 $CellContext`b - 4 $CellContext`b 
       Sin[$CellContext`xi]^2) (2 $CellContext`b - $CellContext`b^2 - 
        4 $CellContext`b Sin[$CellContext`xi]^2)^(-1 + 
        Rational[1, 2] $CellContext`n) (2 - $CellContext`b + 
       2 $CellContext`b Sin[$CellContext`xi]^2) + (1 - $CellContext`b + 
       2 $CellContext`b Sin[$CellContext`xi]^2) (
       Rational[1, 4] (-1 + 
         Rational[1, 2] $CellContext`n) $CellContext`n (-2 + 2 $CellContext`b - 
          4 $CellContext`b Sin[$CellContext`xi]^2)^2 (
          2 $CellContext`b - $CellContext`b^2 - 4 $CellContext`b 
          Sin[$CellContext`xi]^2)^(-2 + Rational[1, 2] $CellContext`n) + 
       Rational[-1, 2] $CellContext`n (2 $CellContext`b - $CellContext`b^2 - 
          4 $CellContext`b Sin[$CellContext`xi]^2)^(-1 + 
          Rational[1, 2] $CellContext`n)))}, 0, 3, 1],
  Editable->False]], "Output",
 CellChangeTimes->{3.751599872585104*^9},
 CellLabel->
  "Out[167]=",ExpressionUUID->"afca4bc3-a158-410c-8ea2-2f2fc8bbb4eb"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Integrate", "[", 
  RowBox[{"%", ",", 
   RowBox[{"{", 
    RowBox[{"xi", ",", 
     RowBox[{
      RowBox[{"-", "Pi"}], "/", "2"}], ",", 
     RowBox[{"Pi", "/", "2"}]}], "}"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.751599875275077*^9, 3.751599881884117*^9}},
 CellLabel->
  "In[168]:=",ExpressionUUID->"827cfb52-3a9a-4e94-a724-574ab7bf1326"],

Cell[BoxData["$Aborted"], "Output",
 CellChangeTimes->{3.751599930437641*^9},
 CellLabel->
  "Out[168]=",ExpressionUUID->"dc98bf45-b20d-4518-9e07-2761701852ac"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Series", "[", 
  RowBox[{
   RowBox[{"Normal", "[", 
    RowBox[{"Out", "[", "167", "]"}], "]"}], ",", 
   RowBox[{"{", 
    RowBox[{"b", ",", "0", ",", "3"}], "}"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.751599934947225*^9, 3.751599943755728*^9}},
 CellLabel->
  "In[169]:=",ExpressionUUID->"e556a5cd-8a19-4084-80f8-93ce2ce7a98f"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"(", 
    InterpretationBox[
     RowBox[{"2", "+", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{
         RowBox[{"-", "2"}], "+", 
         RowBox[{"4", " ", 
          SuperscriptBox[
           RowBox[{"Sin", "[", "xi", "]"}], "2"]}]}], ")"}], " ", "b"}], "+", 
      
      InterpretationBox[
       SuperscriptBox[
        RowBox[{"O", "[", "b", "]"}], "5"],
       SeriesData[$CellContext`b, 0, {}, 0, 5, 1],
       Editable->False]}],
     SeriesData[$CellContext`b, 0, {2, -2 + 4 Sin[$CellContext`xi]^2}, 0, 5, 
      1],
     Editable->False], ")"}], " ", 
   SuperscriptBox[
    RowBox[{"(", 
     RowBox[{
      RowBox[{"2", " ", "b"}], "-", 
      SuperscriptBox["b", "2"], "-", 
      RowBox[{"4", " ", "b", " ", 
       SuperscriptBox[
        RowBox[{"Sin", "[", "xi", "]"}], "2"]}]}], ")"}], 
    RowBox[{"n", "/", "2"}]]}], "+", 
  RowBox[{"2", " ", 
   SuperscriptBox[
    RowBox[{"(", 
     RowBox[{
      RowBox[{"-", "1"}], "+", "r"}], ")"}], "2"], " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{
      RowBox[{"(", 
       InterpretationBox[
        RowBox[{
         RowBox[{
          FractionBox["1", "2"], " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"-", "2"}], "+", "n"}], ")"}], " ", "n"}], "+", 
         RowBox[{
          FractionBox["3", "2"], " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"-", "2"}], "+", "n"}], ")"}], " ", "n", " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"-", "1"}], "+", 
            RowBox[{"2", " ", 
             SuperscriptBox[
              RowBox[{"Sin", "[", "xi", "]"}], "2"]}]}], ")"}], " ", "b"}], 
         "+", 
         RowBox[{
          RowBox[{"(", 
           RowBox[{
            RowBox[{
             RowBox[{"(", 
              RowBox[{
               RowBox[{"-", "2"}], "+", "n"}], ")"}], " ", "n", " ", 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                RowBox[{"-", "1"}], "+", 
                RowBox[{"2", " ", 
                 SuperscriptBox[
                  RowBox[{"Sin", "[", "xi", "]"}], "2"]}]}], ")"}], "2"]}], 
            "+", 
            RowBox[{
             FractionBox["1", "2"], " ", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"-", "2"}], "+", "n"}], ")"}], " ", "n", " ", 
             RowBox[{"(", 
              RowBox[{"1", "-", 
               RowBox[{"4", " ", 
                SuperscriptBox[
                 RowBox[{"Sin", "[", "xi", "]"}], "2"]}], "+", 
               RowBox[{"4", " ", 
                SuperscriptBox[
                 RowBox[{"Sin", "[", "xi", "]"}], "4"]}]}], ")"}]}]}], ")"}], 
          " ", 
          SuperscriptBox["b", "2"]}], "+", 
         RowBox[{
          FractionBox["1", "2"], " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"-", "2"}], "+", "n"}], ")"}], " ", "n", " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"-", "1"}], "+", 
            RowBox[{"2", " ", 
             SuperscriptBox[
              RowBox[{"Sin", "[", "xi", "]"}], "2"]}]}], ")"}], " ", 
          RowBox[{"(", 
           RowBox[{"1", "-", 
            RowBox[{"4", " ", 
             SuperscriptBox[
              RowBox[{"Sin", "[", "xi", "]"}], "2"]}], "+", 
            RowBox[{"4", " ", 
             SuperscriptBox[
              RowBox[{"Sin", "[", "xi", "]"}], "4"]}]}], ")"}], " ", 
          SuperscriptBox["b", "3"]}], "+", 
         InterpretationBox[
          SuperscriptBox[
           RowBox[{"O", "[", "b", "]"}], "8"],
          SeriesData[$CellContext`b, 0, {}, 0, 8, 1],
          Editable->False]}],
        SeriesData[$CellContext`b, 0, {
         Rational[1, 2] (-2 + $CellContext`n) $CellContext`n, 
          Rational[3, 2] (-2 + $CellContext`n) $CellContext`n (-1 + 
           2 
            Sin[$CellContext`xi]^2), (-2 + $CellContext`n) $CellContext`n (-1 + 
             2 Sin[$CellContext`xi]^2)^2 + 
          Rational[1, 2] (-2 + $CellContext`n) $CellContext`n (1 - 4 
            Sin[$CellContext`xi]^2 + 4 Sin[$CellContext`xi]^4), 
          Rational[1, 2] (-2 + $CellContext`n) $CellContext`n (-1 + 
           2 Sin[$CellContext`xi]^2) (1 - 4 Sin[$CellContext`xi]^2 + 
           4 Sin[$CellContext`xi]^4)}, 0, 8, 1],
        Editable->False], ")"}], " ", 
      SuperscriptBox[
       RowBox[{"(", 
        RowBox[{
         RowBox[{"2", " ", "b"}], "-", 
         SuperscriptBox["b", "2"], "-", 
         RowBox[{"4", " ", "b", " ", 
          SuperscriptBox[
           RowBox[{"Sin", "[", "xi", "]"}], "2"]}]}], ")"}], 
       RowBox[{
        RowBox[{"-", "2"}], "+", 
        FractionBox["n", "2"]}]]}], "+", 
     RowBox[{
      RowBox[{"(", 
       InterpretationBox[
        RowBox[{
         RowBox[{"-", 
          FractionBox["n", "2"]}], "+", 
         RowBox[{
          FractionBox["1", "2"], " ", "n", " ", 
          RowBox[{"(", 
           RowBox[{"1", "-", 
            RowBox[{"2", " ", 
             SuperscriptBox[
              RowBox[{"Sin", "[", "xi", "]"}], "2"]}]}], ")"}], " ", "b"}], 
         "+", 
         InterpretationBox[
          SuperscriptBox[
           RowBox[{"O", "[", "b", "]"}], "8"],
          SeriesData[$CellContext`b, 0, {}, 0, 8, 1],
          Editable->False]}],
        SeriesData[$CellContext`b, 0, {
         Rational[-1, 2] $CellContext`n, 
          Rational[1, 2] $CellContext`n (1 - 2 Sin[$CellContext`xi]^2)}, 0, 8,
          1],
        Editable->False], ")"}], " ", 
      SuperscriptBox[
       RowBox[{"(", 
        RowBox[{
         RowBox[{"2", " ", "b"}], "-", 
         SuperscriptBox["b", "2"], "-", 
         RowBox[{"4", " ", "b", " ", 
          SuperscriptBox[
           RowBox[{"Sin", "[", "xi", "]"}], "2"]}]}], ")"}], 
       RowBox[{
        RowBox[{"-", "1"}], "+", 
        FractionBox["n", "2"]}]]}], "+", 
     RowBox[{
      RowBox[{"(", 
       InterpretationBox[
        RowBox[{
         RowBox[{"-", 
          RowBox[{"2", " ", "n"}]}], "+", 
         RowBox[{
          RowBox[{"(", 
           RowBox[{
            RowBox[{"3", " ", "n"}], "-", 
            RowBox[{"6", " ", "n", " ", 
             SuperscriptBox[
              RowBox[{"Sin", "[", "xi", "]"}], "2"]}]}], ")"}], " ", "b"}], 
         "+", 
         RowBox[{
          RowBox[{"(", 
           RowBox[{
            RowBox[{"-", "n"}], "+", 
            RowBox[{"4", " ", "n", " ", 
             SuperscriptBox[
              RowBox[{"Sin", "[", "xi", "]"}], "2"]}], "-", 
            RowBox[{"4", " ", "n", " ", 
             SuperscriptBox[
              RowBox[{"Sin", "[", "xi", "]"}], "4"]}]}], ")"}], " ", 
          SuperscriptBox["b", "2"]}], "+", 
         InterpretationBox[
          SuperscriptBox[
           RowBox[{"O", "[", "b", "]"}], "7"],
          SeriesData[$CellContext`b, 0, {}, 0, 7, 1],
          Editable->False]}],
        SeriesData[$CellContext`b, 
         0, {(-2) $CellContext`n, 3 $CellContext`n - 6 $CellContext`n 
          Sin[$CellContext`xi]^2, -$CellContext`n + 
          4 $CellContext`n Sin[$CellContext`xi]^2 - 4 $CellContext`n 
          Sin[$CellContext`xi]^4}, 0, 7, 1],
        Editable->False], ")"}], " ", 
      SuperscriptBox[
       RowBox[{"(", 
        RowBox[{
         RowBox[{"2", " ", "b"}], "-", 
         SuperscriptBox["b", "2"], "-", 
         RowBox[{"4", " ", "b", " ", 
          SuperscriptBox[
           RowBox[{"Sin", "[", "xi", "]"}], "2"]}]}], ")"}], 
       RowBox[{
        RowBox[{"-", "1"}], "+", 
        FractionBox["n", "2"]}]]}], "+", 
     SuperscriptBox[
      RowBox[{"(", 
       RowBox[{
        RowBox[{"2", " ", "b"}], "-", 
        SuperscriptBox["b", "2"], "-", 
        RowBox[{"4", " ", "b", " ", 
         SuperscriptBox[
          RowBox[{"Sin", "[", "xi", "]"}], "2"]}]}], ")"}], 
      RowBox[{"n", "/", "2"}]]}], ")"}]}], "+", 
  RowBox[{"2", " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"-", "1"}], "+", "r"}], ")"}], " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{
      RowBox[{"(", 
       InterpretationBox[
        RowBox[{
         RowBox[{"-", "n"}], "+", 
         RowBox[{
          RowBox[{"(", 
           RowBox[{
            RowBox[{"2", " ", "n"}], "-", 
            RowBox[{"4", " ", "n", " ", 
             SuperscriptBox[
              RowBox[{"Sin", "[", "xi", "]"}], "2"]}]}], ")"}], " ", "b"}], 
         "+", 
         RowBox[{
          RowBox[{"(", 
           RowBox[{
            RowBox[{"-", "n"}], "+", 
            RowBox[{"4", " ", "n", " ", 
             SuperscriptBox[
              RowBox[{"Sin", "[", "xi", "]"}], "2"]}], "-", 
            RowBox[{"4", " ", "n", " ", 
             SuperscriptBox[
              RowBox[{"Sin", "[", "xi", "]"}], "4"]}]}], ")"}], " ", 
          SuperscriptBox["b", "2"]}], "+", 
         InterpretationBox[
          SuperscriptBox[
           RowBox[{"O", "[", "b", "]"}], "7"],
          SeriesData[$CellContext`b, 0, {}, 0, 7, 1],
          Editable->False]}],
        SeriesData[$CellContext`b, 
         0, {-$CellContext`n, 2 $CellContext`n - 4 $CellContext`n 
          Sin[$CellContext`xi]^2, -$CellContext`n + 
          4 $CellContext`n Sin[$CellContext`xi]^2 - 4 $CellContext`n 
          Sin[$CellContext`xi]^4}, 0, 7, 1],
        Editable->False], ")"}], " ", 
      SuperscriptBox[
       RowBox[{"(", 
        RowBox[{
         RowBox[{"2", " ", "b"}], "-", 
         SuperscriptBox["b", "2"], "-", 
         RowBox[{"4", " ", "b", " ", 
          SuperscriptBox[
           RowBox[{"Sin", "[", "xi", "]"}], "2"]}]}], ")"}], 
       RowBox[{
        RowBox[{"-", "1"}], "+", 
        FractionBox["n", "2"]}]]}], "+", 
     RowBox[{
      RowBox[{"(", 
       InterpretationBox[
        RowBox[{"2", "+", 
         RowBox[{
          RowBox[{"(", 
           RowBox[{
            RowBox[{"-", "1"}], "+", 
            RowBox[{"2", " ", 
             SuperscriptBox[
              RowBox[{"Sin", "[", "xi", "]"}], "2"]}]}], ")"}], " ", "b"}], 
         "+", 
         InterpretationBox[
          SuperscriptBox[
           RowBox[{"O", "[", "b", "]"}], "7"],
          SeriesData[$CellContext`b, 0, {}, 0, 7, 1],
          Editable->False]}],
        SeriesData[$CellContext`b, 0, {2, -1 + 2 Sin[$CellContext`xi]^2}, 0, 
         7, 1],
        Editable->False], ")"}], " ", 
      SuperscriptBox[
       RowBox[{"(", 
        RowBox[{
         RowBox[{"2", " ", "b"}], "-", 
         SuperscriptBox["b", "2"], "-", 
         RowBox[{"4", " ", "b", " ", 
          SuperscriptBox[
           RowBox[{"Sin", "[", "xi", "]"}], "2"]}]}], ")"}], 
       RowBox[{"n", "/", "2"}]]}]}], ")"}]}]}]], "Output",
 CellChangeTimes->{3.7515999446414557`*^9},
 CellLabel->
  "Out[169]=",ExpressionUUID->"e09bace4-7142-43d8-bac1-510f481d33b3"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Normal", "[", "%", "]"}]], "Input",
 CellChangeTimes->{{3.75159997378303*^9, 3.751599975017337*^9}},
 CellLabel->
  "In[170]:=",ExpressionUUID->"a6c5831f-4bdc-42fc-9a94-7096adcddaa6"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   SuperscriptBox[
    RowBox[{"(", 
     RowBox[{
      RowBox[{"2", " ", "b"}], "-", 
      SuperscriptBox["b", "2"], "-", 
      RowBox[{"4", " ", "b", " ", 
       SuperscriptBox[
        RowBox[{"Sin", "[", "xi", "]"}], "2"]}]}], ")"}], 
    RowBox[{"n", "/", "2"}]], " ", 
   RowBox[{"(", 
    RowBox[{"2", "+", 
     RowBox[{"b", " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "2"}], "+", 
        RowBox[{"4", " ", 
         SuperscriptBox[
          RowBox[{"Sin", "[", "xi", "]"}], "2"]}]}], ")"}]}]}], ")"}]}], "+", 
  
  RowBox[{"2", " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"-", "1"}], "+", "r"}], ")"}], " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{
      SuperscriptBox[
       RowBox[{"(", 
        RowBox[{
         RowBox[{"2", " ", "b"}], "-", 
         SuperscriptBox["b", "2"], "-", 
         RowBox[{"4", " ", "b", " ", 
          SuperscriptBox[
           RowBox[{"Sin", "[", "xi", "]"}], "2"]}]}], ")"}], 
       RowBox[{"n", "/", "2"}]], " ", 
      RowBox[{"(", 
       RowBox[{"2", "+", 
        RowBox[{"b", " ", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"-", "1"}], "+", 
           RowBox[{"2", " ", 
            SuperscriptBox[
             RowBox[{"Sin", "[", "xi", "]"}], "2"]}]}], ")"}]}]}], ")"}]}], 
     "+", 
     RowBox[{
      SuperscriptBox[
       RowBox[{"(", 
        RowBox[{
         RowBox[{"2", " ", "b"}], "-", 
         SuperscriptBox["b", "2"], "-", 
         RowBox[{"4", " ", "b", " ", 
          SuperscriptBox[
           RowBox[{"Sin", "[", "xi", "]"}], "2"]}]}], ")"}], 
       RowBox[{
        RowBox[{"-", "1"}], "+", 
        FractionBox["n", "2"]}]], " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "n"}], "+", 
        RowBox[{"b", " ", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"2", " ", "n"}], "-", 
           RowBox[{"4", " ", "n", " ", 
            SuperscriptBox[
             RowBox[{"Sin", "[", "xi", "]"}], "2"]}]}], ")"}]}], "+", 
        RowBox[{
         SuperscriptBox["b", "2"], " ", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"-", "n"}], "+", 
           RowBox[{"4", " ", "n", " ", 
            SuperscriptBox[
             RowBox[{"Sin", "[", "xi", "]"}], "2"]}], "-", 
           RowBox[{"4", " ", "n", " ", 
            SuperscriptBox[
             RowBox[{"Sin", "[", "xi", "]"}], "4"]}]}], ")"}]}]}], ")"}]}]}], 
    ")"}]}], "+", 
  RowBox[{"2", " ", 
   SuperscriptBox[
    RowBox[{"(", 
     RowBox[{
      RowBox[{"-", "1"}], "+", "r"}], ")"}], "2"], " ", 
   RowBox[{"(", 
    RowBox[{
     SuperscriptBox[
      RowBox[{"(", 
       RowBox[{
        RowBox[{"2", " ", "b"}], "-", 
        SuperscriptBox["b", "2"], "-", 
        RowBox[{"4", " ", "b", " ", 
         SuperscriptBox[
          RowBox[{"Sin", "[", "xi", "]"}], "2"]}]}], ")"}], 
      RowBox[{"n", "/", "2"}]], "+", 
     RowBox[{
      SuperscriptBox[
       RowBox[{"(", 
        RowBox[{
         RowBox[{"2", " ", "b"}], "-", 
         SuperscriptBox["b", "2"], "-", 
         RowBox[{"4", " ", "b", " ", 
          SuperscriptBox[
           RowBox[{"Sin", "[", "xi", "]"}], "2"]}]}], ")"}], 
       RowBox[{
        RowBox[{"-", "1"}], "+", 
        FractionBox["n", "2"]}]], " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", 
         FractionBox["n", "2"]}], "+", 
        RowBox[{
         FractionBox["1", "2"], " ", "b", " ", "n", " ", 
         RowBox[{"(", 
          RowBox[{"1", "-", 
           RowBox[{"2", " ", 
            SuperscriptBox[
             RowBox[{"Sin", "[", "xi", "]"}], "2"]}]}], ")"}]}]}], ")"}]}], 
     "+", 
     RowBox[{
      SuperscriptBox[
       RowBox[{"(", 
        RowBox[{
         RowBox[{"2", " ", "b"}], "-", 
         SuperscriptBox["b", "2"], "-", 
         RowBox[{"4", " ", "b", " ", 
          SuperscriptBox[
           RowBox[{"Sin", "[", "xi", "]"}], "2"]}]}], ")"}], 
       RowBox[{
        RowBox[{"-", "1"}], "+", 
        FractionBox["n", "2"]}]], " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{
         RowBox[{"-", "2"}], " ", "n"}], "+", 
        RowBox[{"b", " ", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"3", " ", "n"}], "-", 
           RowBox[{"6", " ", "n", " ", 
            SuperscriptBox[
             RowBox[{"Sin", "[", "xi", "]"}], "2"]}]}], ")"}]}], "+", 
        RowBox[{
         SuperscriptBox["b", "2"], " ", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"-", "n"}], "+", 
           RowBox[{"4", " ", "n", " ", 
            SuperscriptBox[
             RowBox[{"Sin", "[", "xi", "]"}], "2"]}], "-", 
           RowBox[{"4", " ", "n", " ", 
            SuperscriptBox[
             RowBox[{"Sin", "[", "xi", "]"}], "4"]}]}], ")"}]}]}], ")"}]}], 
     "+", 
     RowBox[{
      SuperscriptBox[
       RowBox[{"(", 
        RowBox[{
         RowBox[{"2", " ", "b"}], "-", 
         SuperscriptBox["b", "2"], "-", 
         RowBox[{"4", " ", "b", " ", 
          SuperscriptBox[
           RowBox[{"Sin", "[", "xi", "]"}], "2"]}]}], ")"}], 
       RowBox[{
        RowBox[{"-", "2"}], "+", 
        FractionBox["n", "2"]}]], " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{
         FractionBox["1", "2"], " ", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"-", "2"}], "+", "n"}], ")"}], " ", "n"}], "+", 
        RowBox[{
         FractionBox["3", "2"], " ", "b", " ", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"-", "2"}], "+", "n"}], ")"}], " ", "n", " ", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"-", "1"}], "+", 
           RowBox[{"2", " ", 
            SuperscriptBox[
             RowBox[{"Sin", "[", "xi", "]"}], "2"]}]}], ")"}]}], "+", 
        RowBox[{
         FractionBox["1", "2"], " ", 
         SuperscriptBox["b", "3"], " ", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"-", "2"}], "+", "n"}], ")"}], " ", "n", " ", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"-", "1"}], "+", 
           RowBox[{"2", " ", 
            SuperscriptBox[
             RowBox[{"Sin", "[", "xi", "]"}], "2"]}]}], ")"}], " ", 
         RowBox[{"(", 
          RowBox[{"1", "-", 
           RowBox[{"4", " ", 
            SuperscriptBox[
             RowBox[{"Sin", "[", "xi", "]"}], "2"]}], "+", 
           RowBox[{"4", " ", 
            SuperscriptBox[
             RowBox[{"Sin", "[", "xi", "]"}], "4"]}]}], ")"}]}], "+", 
        RowBox[{
         SuperscriptBox["b", "2"], " ", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", "2"}], "+", "n"}], ")"}], " ", "n", " ", 
            SuperscriptBox[
             RowBox[{"(", 
              RowBox[{
               RowBox[{"-", "1"}], "+", 
               RowBox[{"2", " ", 
                SuperscriptBox[
                 RowBox[{"Sin", "[", "xi", "]"}], "2"]}]}], ")"}], "2"]}], 
           "+", 
           RowBox[{
            FractionBox["1", "2"], " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", "2"}], "+", "n"}], ")"}], " ", "n", " ", 
            RowBox[{"(", 
             RowBox[{"1", "-", 
              RowBox[{"4", " ", 
               SuperscriptBox[
                RowBox[{"Sin", "[", "xi", "]"}], "2"]}], "+", 
              RowBox[{"4", " ", 
               SuperscriptBox[
                RowBox[{"Sin", "[", "xi", "]"}], "4"]}]}], ")"}]}]}], 
          ")"}]}]}], ")"}]}]}], ")"}]}]}]], "Output",
 CellChangeTimes->{3.7515999753306847`*^9},
 CellLabel->
  "Out[170]=",ExpressionUUID->"0d22c9c4-ead5-4ddf-a298-78dec2e333d9"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"2", "*", "r", "*", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{"1", "-", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{"b", "-", "r"}], ")"}], "^", "2"}], "-", 
      RowBox[{"4", "*", "b", "*", "r", "*", 
       RowBox[{
        RowBox[{"Sin", "[", "xi", "]"}], "^", "2"}]}]}], ")"}], "^", 
    RowBox[{"(", 
     RowBox[{"n", "/", "2"}], ")"}]}], "*", 
   RowBox[{"(", 
    RowBox[{"r", "-", "b", "+", 
     RowBox[{"2", "*", "b", "*", 
      RowBox[{
       RowBox[{"Sin", "[", "xi", "]"}], "^", "2"}]}]}], ")"}]}], " ", "/.", 
  " ", 
  RowBox[{"r", " ", "\[Rule]", " ", "1"}]}]], "Input",
 CellChangeTimes->{{3.751600114060973*^9, 3.7516001161714897`*^9}},
 CellLabel->
  "In[171]:=",ExpressionUUID->"c84adf8d-9d05-4dbd-8e3e-28a5c7f5e2db"],

Cell[BoxData[
 RowBox[{"2", " ", 
  SuperscriptBox[
   RowBox[{"(", 
    RowBox[{"1", "-", 
     SuperscriptBox[
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "1"}], "+", "b"}], ")"}], "2"], "-", 
     RowBox[{"4", " ", "b", " ", 
      SuperscriptBox[
       RowBox[{"Sin", "[", "xi", "]"}], "2"]}]}], ")"}], 
   RowBox[{"n", "/", "2"}]], " ", 
  RowBox[{"(", 
   RowBox[{"1", "-", "b", "+", 
    RowBox[{"2", " ", "b", " ", 
     SuperscriptBox[
      RowBox[{"Sin", "[", "xi", "]"}], "2"]}]}], ")"}]}]], "Output",
 CellChangeTimes->{3.7516001165598583`*^9},
 CellLabel->
  "Out[171]=",ExpressionUUID->"f490f36d-b90c-452b-b3fe-c8a42b4b3fac"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"FullSimplify", "[", "%", "]"}]], "Input",
 CellChangeTimes->{{3.751600117618498*^9, 3.7516001205407124`*^9}},
 CellLabel->
  "In[172]:=",ExpressionUUID->"4fcb95de-1628-4424-9ac1-746393c5ddb0"],

Cell[BoxData[
 RowBox[{
  RowBox[{"-", "2"}], " ", 
  SuperscriptBox[
   RowBox[{"(", 
    RowBox[{
     RowBox[{"-", "b"}], " ", 
     RowBox[{"(", 
      RowBox[{"b", "-", 
       RowBox[{"2", " ", 
        RowBox[{"Cos", "[", 
         RowBox[{"2", " ", "xi"}], "]"}]}]}], ")"}]}], ")"}], 
   RowBox[{"n", "/", "2"}]], " ", 
  RowBox[{"(", 
   RowBox[{
    RowBox[{"-", "1"}], "+", 
    RowBox[{"b", " ", 
     RowBox[{"Cos", "[", 
      RowBox[{"2", " ", "xi"}], "]"}]}]}], ")"}]}]], "Output",
 CellChangeTimes->{3.7516001208926086`*^9},
 CellLabel->
  "Out[172]=",ExpressionUUID->"b0fedd08-570b-4257-863c-f886d097f24d"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Integrate", "[", 
  RowBox[{"%", ",", 
   RowBox[{"{", 
    RowBox[{"xi", ",", 
     RowBox[{
      RowBox[{"-", "Pi"}], "/", "2"}], ",", 
     RowBox[{"Pi", "/", "2"}]}], "}"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.751600122898343*^9, 3.751600128506989*^9}},
 CellLabel->
  "In[173]:=",ExpressionUUID->"9db6a7f0-2bc4-4e62-b1b8-f874f547b165"],

Cell[BoxData["$Aborted"], "Output",
 CellChangeTimes->{3.751600159513734*^9},
 CellLabel->
  "Out[173]=",ExpressionUUID->"b8b23c61-1f7f-445f-9cf2-860b4390a1d6"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"D", "[", 
  RowBox[{
   RowBox[{"Out", "[", "172", "]"}], ",", 
   RowBox[{"{", 
    RowBox[{"b", ",", "2"}], "}"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.751600160904183*^9, 3.751600181613696*^9}},
 CellLabel->
  "In[176]:=",ExpressionUUID->"67132a99-39d2-47db-8982-30707e6bdf43"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"-", "2"}], " ", "n", " ", 
   SuperscriptBox[
    RowBox[{"(", 
     RowBox[{
      RowBox[{"-", "b"}], " ", 
      RowBox[{"(", 
       RowBox[{"b", "-", 
        RowBox[{"2", " ", 
         RowBox[{"Cos", "[", 
          RowBox[{"2", " ", "xi"}], "]"}]}]}], ")"}]}], ")"}], 
    RowBox[{
     RowBox[{"-", "1"}], "+", 
     FractionBox["n", "2"]}]], " ", 
   RowBox[{"Cos", "[", 
    RowBox[{"2", " ", "xi"}], "]"}], " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{
      RowBox[{"-", "2"}], " ", "b"}], "+", 
     RowBox[{"2", " ", 
      RowBox[{"Cos", "[", 
       RowBox[{"2", " ", "xi"}], "]"}]}]}], ")"}]}], "-", 
  RowBox[{"2", " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"-", "1"}], "+", 
     RowBox[{"b", " ", 
      RowBox[{"Cos", "[", 
       RowBox[{"2", " ", "xi"}], "]"}]}]}], ")"}], " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{
      RowBox[{"-", "n"}], " ", 
      SuperscriptBox[
       RowBox[{"(", 
        RowBox[{
         RowBox[{"-", "b"}], " ", 
         RowBox[{"(", 
          RowBox[{"b", "-", 
           RowBox[{"2", " ", 
            RowBox[{"Cos", "[", 
             RowBox[{"2", " ", "xi"}], "]"}]}]}], ")"}]}], ")"}], 
       RowBox[{
        RowBox[{"-", "1"}], "+", 
        FractionBox["n", "2"]}]]}], "+", 
     RowBox[{
      FractionBox["1", "2"], " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "1"}], "+", 
        FractionBox["n", "2"]}], ")"}], " ", "n", " ", 
      SuperscriptBox[
       RowBox[{"(", 
        RowBox[{
         RowBox[{"-", "b"}], " ", 
         RowBox[{"(", 
          RowBox[{"b", "-", 
           RowBox[{"2", " ", 
            RowBox[{"Cos", "[", 
             RowBox[{"2", " ", "xi"}], "]"}]}]}], ")"}]}], ")"}], 
       RowBox[{
        RowBox[{"-", "2"}], "+", 
        FractionBox["n", "2"]}]], " ", 
      SuperscriptBox[
       RowBox[{"(", 
        RowBox[{
         RowBox[{
          RowBox[{"-", "2"}], " ", "b"}], "+", 
         RowBox[{"2", " ", 
          RowBox[{"Cos", "[", 
           RowBox[{"2", " ", "xi"}], "]"}]}]}], ")"}], "2"]}]}], 
    ")"}]}]}]], "Output",
 CellChangeTimes->{{3.7516001649327717`*^9, 3.751600182235312*^9}},
 CellLabel->
  "Out[176]=",ExpressionUUID->"a0624247-f838-46d9-950e-feea60a14675"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"%", " ", "/.", " ", 
  RowBox[{"b", " ", "\[Rule]", " ", "0"}]}]], "Input",
 CellChangeTimes->{{3.75160016579046*^9, 3.751600167479851*^9}},
 CellLabel->
  "In[177]:=",ExpressionUUID->"3a7b7ebb-c6cc-420c-b78b-bedb6307ef64"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"-", "4"}], " ", 
   SuperscriptBox["0", 
    RowBox[{
     RowBox[{"-", "1"}], "+", 
     FractionBox["n", "2"]}]], " ", "n", " ", 
   SuperscriptBox[
    RowBox[{"Cos", "[", 
     RowBox[{"2", " ", "xi"}], "]"}], "2"]}], "+", 
  RowBox[{"2", " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{
      RowBox[{"-", 
       SuperscriptBox["0", 
        RowBox[{
         RowBox[{"-", "1"}], "+", 
         FractionBox["n", "2"]}]]}], " ", "n"}], "+", 
     RowBox[{"2", " ", 
      SuperscriptBox["0", 
       RowBox[{
        RowBox[{"-", "2"}], "+", 
        FractionBox["n", "2"]}]], " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "1"}], "+", 
        FractionBox["n", "2"]}], ")"}], " ", "n", " ", 
      SuperscriptBox[
       RowBox[{"Cos", "[", 
        RowBox[{"2", " ", "xi"}], "]"}], "2"]}]}], ")"}]}]}]], "Output",
 CellChangeTimes->{{3.75160016786661*^9, 3.751600184982613*^9}},
 CellLabel->
  "Out[177]=",ExpressionUUID->"833bc333-2adf-4f64-bb44-2d9c4b53d7c3"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Integrate", "[", 
  RowBox[{
   RowBox[{
    RowBox[{"Out", "[", "171", "]"}], " ", "/.", " ", 
    RowBox[{"n", " ", "\[Rule]", " ", "3"}]}], ",", 
   RowBox[{"{", 
    RowBox[{"xi", ",", 
     RowBox[{
      RowBox[{"-", "Pi"}], "/", "2"}], ",", 
     RowBox[{"Pi", "/", "2"}]}], "}"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.7516002463448772`*^9, 3.7516002565112143`*^9}},
 CellLabel->
  "In[179]:=",ExpressionUUID->"ce852c62-6613-45ca-bb65-4d63f37de4d7"],

Cell[BoxData["$Aborted"], "Output",
 CellChangeTimes->{3.751600254268979*^9, 3.751600297826721*^9},
 CellLabel->
  "Out[179]=",ExpressionUUID->"eece3429-2628-4b11-87cc-69f0f1537989"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Integrate", "[", 
  RowBox[{
   RowBox[{"Out", "[", "177", "]"}], ",", 
   RowBox[{"{", 
    RowBox[{"xi", ",", 
     RowBox[{
      RowBox[{"-", "Pi"}], "/", "2"}], ",", 
     RowBox[{"Pi", "/", "2"}]}], "}"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.7516002989438343`*^9, 3.751600308648446*^9}},
 CellLabel->
  "In[180]:=",ExpressionUUID->"a6deb991-491f-4e69-b143-3326f4dfc12b"],

Cell[BoxData[
 RowBox[{
  RowBox[{"(", 
   RowBox[{
    RowBox[{
     RowBox[{"-", "4"}], " ", 
     SuperscriptBox["0", 
      RowBox[{
       RowBox[{"-", "1"}], "+", 
       FractionBox["n", "2"]}]]}], "+", 
    RowBox[{
     SuperscriptBox["0", 
      RowBox[{
       RowBox[{"-", "2"}], "+", 
       FractionBox["n", "2"]}]], " ", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"-", "2"}], "+", "n"}], ")"}]}]}], ")"}], " ", "n", " ", 
  "\[Pi]"}]], "Output",
 CellChangeTimes->{3.751600309127434*^9},
 CellLabel->
  "Out[180]=",ExpressionUUID->"28cafa38-a17d-4af2-80a9-962a407fcafe"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"2", "*", "r", "*", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{"1", "-", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{"b", "-", "r"}], ")"}], "^", "2"}], "-", 
      RowBox[{"4", "*", "b", "*", "r", "*", 
       RowBox[{
        RowBox[{"Sin", "[", "xi", "]"}], "^", "2"}]}]}], ")"}], "^", 
    RowBox[{"(", 
     RowBox[{"n", "/", "2"}], ")"}]}], "*", 
   RowBox[{"(", 
    RowBox[{"r", "-", "b", "+", 
     RowBox[{"2", "*", "b", "*", 
      RowBox[{
       RowBox[{"Sin", "[", "xi", "]"}], "^", "2"}]}]}], ")"}]}], " ", "/.", 
  " ", 
  RowBox[{"r", " ", "\[Rule]", " ", "1"}]}]], "Input",
 CellChangeTimes->{{3.751601323262426*^9, 3.751601324829039*^9}},
 CellLabel->
  "In[181]:=",ExpressionUUID->"0092f0bc-50b4-45ba-af00-f8ebd3dbe137"],

Cell[BoxData[
 RowBox[{"2", " ", 
  SuperscriptBox[
   RowBox[{"(", 
    RowBox[{"1", "-", 
     SuperscriptBox[
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "1"}], "+", "b"}], ")"}], "2"], "-", 
     RowBox[{"4", " ", "b", " ", 
      SuperscriptBox[
       RowBox[{"Sin", "[", "xi", "]"}], "2"]}]}], ")"}], 
   RowBox[{"n", "/", "2"}]], " ", 
  RowBox[{"(", 
   RowBox[{"1", "-", "b", "+", 
    RowBox[{"2", " ", "b", " ", 
     SuperscriptBox[
      RowBox[{"Sin", "[", "xi", "]"}], "2"]}]}], ")"}]}]], "Output",
 CellChangeTimes->{3.751601325535858*^9},
 CellLabel->
  "Out[181]=",ExpressionUUID->"5f7c1701-7437-4b48-b714-d9d98cebc53c"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Series", "[", 
  RowBox[{"%", ",", 
   RowBox[{"{", 
    RowBox[{"b", ",", "0", ",", "3"}], "}"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.751601327579733*^9, 3.751601332164897*^9}},
 CellLabel->
  "In[182]:=",ExpressionUUID->"f92a69aa-47af-40eb-8055-bbb235cf8262"],

Cell[BoxData[
 RowBox[{
  RowBox[{"(", 
   InterpretationBox[
    RowBox[{"2", "+", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "2"}], "+", 
        RowBox[{"4", " ", 
         SuperscriptBox[
          RowBox[{"Sin", "[", "xi", "]"}], "2"]}]}], ")"}], " ", "b"}], "+", 
     InterpretationBox[
      SuperscriptBox[
       RowBox[{"O", "[", "b", "]"}], "4"],
      SeriesData[$CellContext`b, 0, {}, 0, 4, 1],
      Editable->False]}],
    SeriesData[$CellContext`b, 0, {2, -2 + 4 Sin[$CellContext`xi]^2}, 0, 4, 1],
    Editable->False], ")"}], " ", 
  SuperscriptBox[
   RowBox[{"(", 
    RowBox[{"1", "-", 
     SuperscriptBox[
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "1"}], "+", "b"}], ")"}], "2"], "-", 
     RowBox[{"4", " ", "b", " ", 
      SuperscriptBox[
       RowBox[{"Sin", "[", "xi", "]"}], "2"]}]}], ")"}], 
   RowBox[{"n", "/", "2"}]]}]], "Output",
 CellChangeTimes->{3.751601333289312*^9},
 CellLabel->
  "Out[182]=",ExpressionUUID->"18b364d4-2506-4939-b8c5-c2388b5c6d8b"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Normal", "[", "%", "]"}]], "Input",
 CellChangeTimes->{{3.751601336340104*^9, 3.751601337917848*^9}},
 CellLabel->
  "In[183]:=",ExpressionUUID->"33b69ed4-06da-45ab-a606-c5ef8cf94d3a"],

Cell[BoxData[
 RowBox[{
  SuperscriptBox[
   RowBox[{"(", 
    RowBox[{"1", "-", 
     SuperscriptBox[
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "1"}], "+", "b"}], ")"}], "2"], "-", 
     RowBox[{"4", " ", "b", " ", 
      SuperscriptBox[
       RowBox[{"Sin", "[", "xi", "]"}], "2"]}]}], ")"}], 
   RowBox[{"n", "/", "2"}]], " ", 
  RowBox[{"(", 
   RowBox[{"2", "+", 
    RowBox[{"b", " ", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"-", "2"}], "+", 
       RowBox[{"4", " ", 
        SuperscriptBox[
         RowBox[{"Sin", "[", "xi", "]"}], "2"]}]}], ")"}]}]}], 
   ")"}]}]], "Output",
 CellChangeTimes->{3.751601338207314*^9},
 CellLabel->
  "Out[183]=",ExpressionUUID->"3b96167d-6764-4e2c-88c8-0760caa7b02a"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"D", "[", 
  RowBox[{
   RowBox[{"Out", "[", "181", "]"}], ",", 
   RowBox[{"{", 
    RowBox[{"b", ",", "2"}], "}"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.751601349017816*^9, 3.751601354673273*^9}},
 CellLabel->
  "In[184]:=",ExpressionUUID->"d448a514-5f10-44f0-8021-c3b346cd23a0"],

Cell[BoxData[
 RowBox[{
  RowBox[{"2", " ", "n", " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{
      RowBox[{"-", "2"}], " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "1"}], "+", "b"}], ")"}]}], "-", 
     RowBox[{"4", " ", 
      SuperscriptBox[
       RowBox[{"Sin", "[", "xi", "]"}], "2"]}]}], ")"}], " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"-", "1"}], "+", 
     RowBox[{"2", " ", 
      SuperscriptBox[
       RowBox[{"Sin", "[", "xi", "]"}], "2"]}]}], ")"}], " ", 
   SuperscriptBox[
    RowBox[{"(", 
     RowBox[{"1", "-", 
      SuperscriptBox[
       RowBox[{"(", 
        RowBox[{
         RowBox[{"-", "1"}], "+", "b"}], ")"}], "2"], "-", 
      RowBox[{"4", " ", "b", " ", 
       SuperscriptBox[
        RowBox[{"Sin", "[", "xi", "]"}], "2"]}]}], ")"}], 
    RowBox[{
     RowBox[{"-", "1"}], "+", 
     FractionBox["n", "2"]}]]}], "+", 
  RowBox[{"2", " ", 
   RowBox[{"(", 
    RowBox[{"1", "-", "b", "+", 
     RowBox[{"2", " ", "b", " ", 
      SuperscriptBox[
       RowBox[{"Sin", "[", "xi", "]"}], "2"]}]}], ")"}], " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{
      FractionBox["1", "2"], " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "1"}], "+", 
        FractionBox["n", "2"]}], ")"}], " ", "n", " ", 
      SuperscriptBox[
       RowBox[{"(", 
        RowBox[{
         RowBox[{
          RowBox[{"-", "2"}], " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"-", "1"}], "+", "b"}], ")"}]}], "-", 
         RowBox[{"4", " ", 
          SuperscriptBox[
           RowBox[{"Sin", "[", "xi", "]"}], "2"]}]}], ")"}], "2"], " ", 
      SuperscriptBox[
       RowBox[{"(", 
        RowBox[{"1", "-", 
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{
            RowBox[{"-", "1"}], "+", "b"}], ")"}], "2"], "-", 
         RowBox[{"4", " ", "b", " ", 
          SuperscriptBox[
           RowBox[{"Sin", "[", "xi", "]"}], "2"]}]}], ")"}], 
       RowBox[{
        RowBox[{"-", "2"}], "+", 
        FractionBox["n", "2"]}]]}], "-", 
     RowBox[{"n", " ", 
      SuperscriptBox[
       RowBox[{"(", 
        RowBox[{"1", "-", 
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{
            RowBox[{"-", "1"}], "+", "b"}], ")"}], "2"], "-", 
         RowBox[{"4", " ", "b", " ", 
          SuperscriptBox[
           RowBox[{"Sin", "[", "xi", "]"}], "2"]}]}], ")"}], 
       RowBox[{
        RowBox[{"-", "1"}], "+", 
        FractionBox["n", "2"]}]]}]}], ")"}]}]}]], "Output",
 CellChangeTimes->{3.751601360777526*^9},
 CellLabel->
  "Out[184]=",ExpressionUUID->"92ea4652-46f0-4949-88c7-8c2538d0c869"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"%", " ", "/.", " ", 
  RowBox[{"b", " ", "\[Rule]", " ", "0"}]}]], "Input",
 CellChangeTimes->{{3.751601367353715*^9, 3.7516013692828007`*^9}},
 CellLabel->
  "In[185]:=",ExpressionUUID->"89e12e0a-a393-4893-8a48-3e8c4ec17aea"],

Cell[BoxData[
 RowBox[{
  RowBox[{"2", " ", 
   SuperscriptBox["0", 
    RowBox[{
     RowBox[{"-", "1"}], "+", 
     FractionBox["n", "2"]}]], " ", "n", " ", 
   RowBox[{"(", 
    RowBox[{"2", "-", 
     RowBox[{"4", " ", 
      SuperscriptBox[
       RowBox[{"Sin", "[", "xi", "]"}], "2"]}]}], ")"}], " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"-", "1"}], "+", 
     RowBox[{"2", " ", 
      SuperscriptBox[
       RowBox[{"Sin", "[", "xi", "]"}], "2"]}]}], ")"}]}], "+", 
  RowBox[{"2", " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{
      RowBox[{"-", 
       SuperscriptBox["0", 
        RowBox[{
         RowBox[{"-", "1"}], "+", 
         FractionBox["n", "2"]}]]}], " ", "n"}], "+", 
     RowBox[{
      FractionBox["1", "2"], " ", 
      SuperscriptBox["0", 
       RowBox[{
        RowBox[{"-", "2"}], "+", 
        FractionBox["n", "2"]}]], " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "1"}], "+", 
        FractionBox["n", "2"]}], ")"}], " ", "n", " ", 
      SuperscriptBox[
       RowBox[{"(", 
        RowBox[{"2", "-", 
         RowBox[{"4", " ", 
          SuperscriptBox[
           RowBox[{"Sin", "[", "xi", "]"}], "2"]}]}], ")"}], "2"]}]}], 
    ")"}]}]}]], "Output",
 CellChangeTimes->{3.751601371358535*^9},
 CellLabel->
  "Out[185]=",ExpressionUUID->"b9b6aa10-63ed-4569-8af0-a8f456acafd9"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Integrate", "[", 
  RowBox[{
   RowBox[{
    RowBox[{"Out", "[", "181", "]"}], " ", "/.", " ", 
    RowBox[{"n", " ", "\[Rule]", " ", "2"}]}], ",", 
   RowBox[{"{", 
    RowBox[{"xi", ",", 
     RowBox[{"-", 
      RowBox[{"ArcSin", "[", 
       RowBox[{"Sqrt", "[", 
        RowBox[{
         RowBox[{"(", 
          RowBox[{"2", "-", "b"}], ")"}], "/", "4"}], "]"}], "]"}]}], ",", 
     RowBox[{"ArcSin", "[", 
      RowBox[{"Sqrt", "[", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{"2", "-", "b"}], ")"}], "/", "4"}], "]"}], "]"}]}], "}"}]}], 
  "]"}]], "Input",
 CellChangeTimes->{{3.751601376932905*^9, 3.7516013897291727`*^9}, {
  3.751601419925775*^9, 3.751601433518701*^9}, {3.751601564436648*^9, 
  3.751601589274891*^9}},
 CellLabel->
  "In[186]:=",ExpressionUUID->"00c93afc-aeea-42ee-9acc-e60907ce88c5"],

Cell[BoxData[
 RowBox[{
  FractionBox["1", "2"], " ", "b", " ", 
  RowBox[{"(", 
   RowBox[{
    RowBox[{
     SqrtBox[
      RowBox[{"4", "-", 
       SuperscriptBox["b", "2"]}]], " ", 
     RowBox[{"(", 
      RowBox[{"4", "+", 
       SuperscriptBox["b", "2"]}], ")"}]}], "-", 
    RowBox[{"16", " ", "b", " ", 
     RowBox[{"ArcCsc", "[", 
      FractionBox["2", 
       SqrtBox[
        RowBox[{"2", "-", "b"}]]], "]"}]}]}], ")"}]}]], "Output",
 CellChangeTimes->{3.751601590484474*^9},
 CellLabel->
  "Out[186]=",ExpressionUUID->"b592f94e-926e-4192-99c9-5e5df4ca3d4d"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"FullSimplify", "[", "%", "]"}]], "Input",
 CellChangeTimes->{{3.7516015927122707`*^9, 3.751601594690117*^9}},
 CellLabel->
  "In[187]:=",ExpressionUUID->"0d9db497-8cff-4e1a-a6fd-1e5c9f3f36c0"],

Cell[BoxData[
 RowBox[{
  FractionBox["1", "2"], " ", "b", " ", 
  RowBox[{"(", 
   RowBox[{
    RowBox[{
     SqrtBox[
      RowBox[{"4", "-", 
       SuperscriptBox["b", "2"]}]], " ", 
     RowBox[{"(", 
      RowBox[{"4", "+", 
       SuperscriptBox["b", "2"]}], ")"}]}], "-", 
    RowBox[{"16", " ", "b", " ", 
     RowBox[{"ArcCsc", "[", 
      FractionBox["2", 
       SqrtBox[
        RowBox[{"2", "-", "b"}]]], "]"}]}]}], ")"}]}]], "Output",
 CellChangeTimes->{3.751601595098881*^9},
 CellLabel->
  "Out[187]=",ExpressionUUID->"e234058e-38f0-434c-9975-e465050c203e"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Series", "[", 
  RowBox[{"%", ",", 
   RowBox[{"{", 
    RowBox[{"b", ",", "0", ",", "2"}], "}"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.7516016007987757`*^9, 3.751601604863963*^9}},
 CellLabel->
  "In[188]:=",ExpressionUUID->"e75d44fe-f324-41ea-b44d-325a96641c93"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
   RowBox[{"4", " ", "b"}], "-", 
   RowBox[{"2", " ", "\[Pi]", " ", 
    SuperscriptBox["b", "2"]}], "+", 
   InterpretationBox[
    SuperscriptBox[
     RowBox[{"O", "[", "b", "]"}], "3"],
    SeriesData[$CellContext`b, 0, {}, 1, 3, 1],
    Editable->False]}],
  SeriesData[$CellContext`b, 0, {4, (-2) Pi}, 1, 3, 1],
  Editable->False]], "Output",
 CellChangeTimes->{3.751601607141984*^9},
 CellLabel->
  "Out[188]=",ExpressionUUID->"9cafafa7-5478-4576-990b-aafc97c7dada"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"D", "[", 
  RowBox[{
   RowBox[{"2", " ", 
    SuperscriptBox[
     RowBox[{"(", 
      RowBox[{"1", "-", 
       SuperscriptBox[
        RowBox[{"(", 
         RowBox[{
          RowBox[{"-", "1"}], "+", "b"}], ")"}], "2"], "-", 
       RowBox[{"4", " ", "b", " ", 
        SuperscriptBox[
         RowBox[{"Sin", "[", "xi", "]"}], "2"]}]}], ")"}], 
     RowBox[{"n", "/", "2"}]], " ", 
    RowBox[{"(", 
     RowBox[{"1", "-", "b", "+", 
      RowBox[{"2", " ", "b", " ", 
       SuperscriptBox[
        RowBox[{"Sin", "[", "xi", "]"}], "2"]}]}], ")"}]}], ",", "b"}], 
  "]"}]], "Input",
 CellChangeTimes->{{3.75160173427835*^9, 3.75160173786264*^9}},
 CellLabel->
  "In[189]:=",ExpressionUUID->"f5e559f7-2b07-4e99-a439-b37883955245"],

Cell[BoxData[
 RowBox[{
  RowBox[{"2", " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"-", "1"}], "+", 
     RowBox[{"2", " ", 
      SuperscriptBox[
       RowBox[{"Sin", "[", "xi", "]"}], "2"]}]}], ")"}], " ", 
   SuperscriptBox[
    RowBox[{"(", 
     RowBox[{"1", "-", 
      SuperscriptBox[
       RowBox[{"(", 
        RowBox[{
         RowBox[{"-", "1"}], "+", "b"}], ")"}], "2"], "-", 
      RowBox[{"4", " ", "b", " ", 
       SuperscriptBox[
        RowBox[{"Sin", "[", "xi", "]"}], "2"]}]}], ")"}], 
    RowBox[{"n", "/", "2"}]]}], "+", 
  RowBox[{"n", " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{
      RowBox[{"-", "2"}], " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "1"}], "+", "b"}], ")"}]}], "-", 
     RowBox[{"4", " ", 
      SuperscriptBox[
       RowBox[{"Sin", "[", "xi", "]"}], "2"]}]}], ")"}], " ", 
   SuperscriptBox[
    RowBox[{"(", 
     RowBox[{"1", "-", 
      SuperscriptBox[
       RowBox[{"(", 
        RowBox[{
         RowBox[{"-", "1"}], "+", "b"}], ")"}], "2"], "-", 
      RowBox[{"4", " ", "b", " ", 
       SuperscriptBox[
        RowBox[{"Sin", "[", "xi", "]"}], "2"]}]}], ")"}], 
    RowBox[{
     RowBox[{"-", "1"}], "+", 
     FractionBox["n", "2"]}]], " ", 
   RowBox[{"(", 
    RowBox[{"1", "-", "b", "+", 
     RowBox[{"2", " ", "b", " ", 
      SuperscriptBox[
       RowBox[{"Sin", "[", "xi", "]"}], "2"]}]}], ")"}]}]}]], "Output",
 CellChangeTimes->{3.751601738837188*^9},
 CellLabel->
  "Out[189]=",ExpressionUUID->"20abdccb-b3b4-40ae-820e-e4ef41cc5ec1"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"FullSimplify", "[", "%", "]"}]], "Input",
 CellChangeTimes->{{3.7516017450843983`*^9, 3.7516017477458563`*^9}},
 CellLabel->
  "In[190]:=",ExpressionUUID->"d8365e24-7bfc-4c00-a862-959c1eef5c10"],

Cell[BoxData[
 RowBox[{
  SuperscriptBox[
   RowBox[{"(", 
    RowBox[{
     RowBox[{"-", "b"}], " ", 
     RowBox[{"(", 
      RowBox[{"b", "-", 
       RowBox[{"2", " ", 
        RowBox[{"Cos", "[", 
         RowBox[{"2", " ", "xi"}], "]"}]}]}], ")"}]}], ")"}], 
   RowBox[{
    FractionBox["1", "2"], " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"-", "2"}], "+", "n"}], ")"}]}]], " ", 
  RowBox[{"(", 
   RowBox[{
    RowBox[{"2", " ", 
     RowBox[{"(", 
      RowBox[{"n", "+", 
       RowBox[{
        SuperscriptBox["b", "2"], " ", 
        RowBox[{"(", 
         RowBox[{"1", "+", "n"}], ")"}]}]}], ")"}], " ", 
     RowBox[{"Cos", "[", 
      RowBox[{"2", " ", "xi"}], "]"}]}], "-", 
    RowBox[{"b", " ", 
     RowBox[{"(", 
      RowBox[{"2", "+", 
       RowBox[{"3", " ", "n"}], "+", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{"2", "+", "n"}], ")"}], " ", 
        RowBox[{"Cos", "[", 
         RowBox[{"4", " ", "xi"}], "]"}]}]}], ")"}]}]}], ")"}]}]], "Output",
 CellChangeTimes->{3.751601748770028*^9},
 CellLabel->
  "Out[190]=",ExpressionUUID->"9bf684bc-56ee-4f38-a3f0-080f984bc4a6"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"%", " ", "/.", " ", 
  RowBox[{"b", " ", "\[Rule]", " ", "0"}]}]], "Input",
 CellChangeTimes->{{3.751601753119254*^9, 3.7516017552402163`*^9}},
 CellLabel->
  "In[191]:=",ExpressionUUID->"98483556-c5d8-453b-8a49-7fddff287cb7"],

Cell[BoxData[
 RowBox[{"2", " ", 
  SuperscriptBox["0", 
   RowBox[{
    FractionBox["1", "2"], " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"-", "2"}], "+", "n"}], ")"}]}]], " ", "n", " ", 
  RowBox[{"Cos", "[", 
   RowBox[{"2", " ", "xi"}], "]"}]}]], "Output",
 CellChangeTimes->{3.751601755640226*^9},
 CellLabel->
  "Out[191]=",ExpressionUUID->"042a00b9-e4fa-4dc7-bc7e-5db0e5e86bd8"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Integrate", "[", 
  RowBox[{"%", ",", 
   RowBox[{"{", 
    RowBox[{"xi", ",", 
     RowBox[{"-", 
      RowBox[{"ArcSin", "[", 
       RowBox[{"Sqrt", "[", 
        RowBox[{
         RowBox[{"(", 
          RowBox[{"2", "-", "b"}], ")"}], "/", "4"}], "]"}], "]"}]}], ",", 
     RowBox[{"ArcSin", "[", 
      RowBox[{"Sqrt", "[", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{"2", "-", "b"}], ")"}], "/", "4"}], "]"}], "]"}]}], "}"}]}], 
  "]"}]], "Input",
 CellChangeTimes->{{3.751601766393722*^9, 3.751601781940111*^9}},
 CellLabel->
  "In[192]:=",ExpressionUUID->"4502b4de-59f5-4078-b88f-29584d84fe71"],

Cell[BoxData[
 RowBox[{
  SuperscriptBox["0", 
   RowBox[{
    FractionBox["1", "2"], " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"-", "2"}], "+", "n"}], ")"}]}]], " ", 
  SqrtBox[
   RowBox[{"4", "-", 
    SuperscriptBox["b", "2"]}]], " ", "n"}]], "Output",
 CellChangeTimes->{3.751601782597056*^9},
 CellLabel->
  "Out[192]=",ExpressionUUID->"e9f0d80b-dadb-4293-9157-1188d0e1aa09"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"k2", " ", "=", " ", 
  RowBox[{
   RowBox[{"(", 
    RowBox[{"1", "-", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{"r", "-", "b"}], ")"}], "^", "2"}]}], ")"}], "/", 
   RowBox[{"(", 
    RowBox[{"4", "*", "b", "*", "r"}], ")"}]}]}]], "Input",
 CellChangeTimes->{{3.751601980612585*^9, 3.751601986501013*^9}},
 CellLabel->
  "In[193]:=",ExpressionUUID->"23689683-7847-4572-90f7-77fd8db4d294"],

Cell[BoxData[
 FractionBox[
  RowBox[{"1", "-", 
   SuperscriptBox[
    RowBox[{"(", 
     RowBox[{
      RowBox[{"-", "b"}], "+", "r"}], ")"}], "2"]}], 
  RowBox[{"4", " ", "b", " ", "r"}]]], "Output",
 CellChangeTimes->{3.7516019871401463`*^9},
 CellLabel->
  "Out[193]=",ExpressionUUID->"1a068f70-675c-4a05-b5bb-ffccf5780264"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"k2", " ", "/.", " ", 
  RowBox[{"r", " ", "\[Rule]", " ", "1"}]}]], "Input",
 CellChangeTimes->{{3.7516019885956497`*^9, 3.7516019915966253`*^9}},
 CellLabel->
  "In[194]:=",ExpressionUUID->"1e3b2e42-608e-4ffc-a2ca-03cfd852861e"],

Cell[BoxData[
 FractionBox[
  RowBox[{"1", "-", 
   SuperscriptBox[
    RowBox[{"(", 
     RowBox[{"1", "-", "b"}], ")"}], "2"]}], 
  RowBox[{"4", " ", "b"}]]], "Output",
 CellChangeTimes->{3.751601991973936*^9},
 CellLabel->
  "Out[194]=",ExpressionUUID->"872a422f-9cb1-4f62-8ebc-c6c0172cde27"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"FullSimplify", "[", "%", "]"}]], "Input",
 CellChangeTimes->{{3.751601992811487*^9, 3.751601995045858*^9}},
 CellLabel->
  "In[195]:=",ExpressionUUID->"c4adba34-cddd-4ad4-99e3-2b252dceaf77"],

Cell[BoxData[
 FractionBox[
  RowBox[{"2", "-", "b"}], "4"]], "Output",
 CellChangeTimes->{3.751601995404002*^9},
 CellLabel->
  "Out[195]=",ExpressionUUID->"c9a6cba2-a0d1-4816-8596-6320d6ac5ddf"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Integrate", "[", 
  RowBox[{
   RowBox[{
    RowBox[{"Out", "[", "189", "]"}], " ", "/.", " ", 
    RowBox[{"n", " ", "\[Rule]", " ", "2"}]}], ",", 
   RowBox[{"{", 
    RowBox[{"xi", ",", 
     RowBox[{"-", 
      RowBox[{"ArcSin", "[", 
       RowBox[{"Sqrt", "[", 
        RowBox[{
         RowBox[{"(", 
          RowBox[{"2", "-", "b"}], ")"}], "/", "4"}], "]"}], "]"}]}], ",", 
     RowBox[{"ArcSin", "[", 
      RowBox[{"Sqrt", "[", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{"2", "-", "b"}], ")"}], "/", "4"}], "]"}], "]"}]}], "}"}]}], 
  "]"}]], "Input",
 CellChangeTimes->{{3.751602006186829*^9, 3.751602031377552*^9}},
 CellLabel->
  "In[196]:=",ExpressionUUID->"ccd96485-0c0d-42ab-a194-5f0785175770"],

Cell[BoxData[
 RowBox[{"2", " ", 
  RowBox[{"(", 
   RowBox[{
    RowBox[{
     SqrtBox[
      RowBox[{"4", "-", 
       SuperscriptBox["b", "2"]}]], " ", 
     RowBox[{"(", 
      RowBox[{"1", "+", 
       SuperscriptBox["b", "2"]}], ")"}]}], "-", 
    RowBox[{"8", " ", "b", " ", 
     RowBox[{"ArcSin", "[", 
      FractionBox[
       SqrtBox[
        RowBox[{"2", "-", "b"}]], "2"], "]"}]}]}], ")"}]}]], "Output",
 CellChangeTimes->{3.7516020321432657`*^9},
 CellLabel->
  "Out[196]=",ExpressionUUID->"faa20adb-e945-4e95-82af-d744d12fee1e"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"FullS", "[", "%", "]"}]], "Input",
 CellChangeTimes->{{3.751602034110708*^9, 3.751602035527691*^9}},
 CellLabel->
  "In[197]:=",ExpressionUUID->"bcf0048a-2fda-4f15-b56d-204816ba30b8"],

Cell[BoxData[
 RowBox[{"FullS", "[", 
  RowBox[{"2", " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{
      SqrtBox[
       RowBox[{"4", "-", 
        SuperscriptBox["b", "2"]}]], " ", 
      RowBox[{"(", 
       RowBox[{"1", "+", 
        SuperscriptBox["b", "2"]}], ")"}]}], "-", 
     RowBox[{"8", " ", "b", " ", 
      RowBox[{"ArcSin", "[", 
       FractionBox[
        SqrtBox[
         RowBox[{"2", "-", "b"}]], "2"], "]"}]}]}], ")"}]}], "]"}]], "Output",\

 CellChangeTimes->{3.7516020358667192`*^9},
 CellLabel->
  "Out[197]=",ExpressionUUID->"1ab73c07-ddaf-4dbf-a84a-3669f5e096bc"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"FullSimplify", "[", 
  RowBox[{"Out", "[", "196", "]"}], "]"}]], "Input",
 CellChangeTimes->{{3.7516020382625237`*^9, 3.751602043503291*^9}},
 CellLabel->
  "In[198]:=",ExpressionUUID->"fcda365c-dc7e-4810-8567-3de14178dc4d"],

Cell[BoxData[
 RowBox[{"2", " ", 
  RowBox[{"(", 
   RowBox[{
    RowBox[{
     SqrtBox[
      RowBox[{"4", "-", 
       SuperscriptBox["b", "2"]}]], " ", 
     RowBox[{"(", 
      RowBox[{"1", "+", 
       SuperscriptBox["b", "2"]}], ")"}]}], "-", 
    RowBox[{"8", " ", "b", " ", 
     RowBox[{"ArcCsc", "[", 
      FractionBox["2", 
       SqrtBox[
        RowBox[{"2", "-", "b"}]]], "]"}]}]}], ")"}]}]], "Output",
 CellChangeTimes->{3.751602044086739*^9},
 CellLabel->
  "Out[198]=",ExpressionUUID->"e0ef3456-13b5-490f-898b-5ff4677eb4c1"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Series", "[", 
  RowBox[{"%", ",", 
   RowBox[{"{", 
    RowBox[{"b", ",", "0", ",", "2"}], "}"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.75160204939027*^9, 3.7516020556390047`*^9}},
 CellLabel->
  "In[199]:=",ExpressionUUID->"9e21e795-6ecc-4d66-b128-147fdde25371"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"4", "-", 
   RowBox[{"4", " ", "\[Pi]", " ", "b"}], "+", 
   FractionBox[
    RowBox[{"15", " ", 
     SuperscriptBox["b", "2"]}], "2"], "+", 
   InterpretationBox[
    SuperscriptBox[
     RowBox[{"O", "[", "b", "]"}], "3"],
    SeriesData[$CellContext`b, 0, {}, 0, 3, 1],
    Editable->False]}],
  SeriesData[$CellContext`b, 0, {4, (-4) Pi, 
    Rational[15, 2]}, 0, 3, 1],
  Editable->False]], "Output",
 CellChangeTimes->{3.751602055988389*^9},
 CellLabel->
  "Out[199]=",ExpressionUUID->"4c9cd1dc-8bcd-4134-91f8-d644239ef486"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Integrate", "[", 
  RowBox[{
   RowBox[{
    RowBox[{"2", " ", 
     SuperscriptBox[
      RowBox[{"(", 
       RowBox[{"1", "-", 
        SuperscriptBox[
         RowBox[{"(", 
          RowBox[{
           RowBox[{"-", "1"}], "+", "b"}], ")"}], "2"], "-", 
        RowBox[{"4", " ", "b", " ", 
         SuperscriptBox[
          RowBox[{"Sin", "[", "xi", "]"}], "2"]}]}], ")"}], 
      RowBox[{"n", "/", "2"}]], " ", 
     RowBox[{"(", 
      RowBox[{"1", "-", "b", "+", 
       RowBox[{"2", " ", "b", " ", 
        SuperscriptBox[
         RowBox[{"Sin", "[", "xi", "]"}], "2"]}]}], ")"}]}], " ", "/.", " ", 
    RowBox[{"n", " ", "\[Rule]", " ", "2"}]}], ",", 
   RowBox[{"{", 
    RowBox[{"xi", ",", 
     RowBox[{"-", 
      RowBox[{"ArcSin", "[", 
       RowBox[{"Sqrt", "[", 
        RowBox[{
         RowBox[{"(", 
          RowBox[{"2", "-", "b"}], ")"}], "/", "4"}], "]"}], "]"}]}], ",", 
     RowBox[{"ArcSin", "[", 
      RowBox[{"Sqrt", "[", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{"2", "-", "b"}], ")"}], "/", "4"}], "]"}], "]"}]}], "}"}]}], 
  "]"}]], "Input",
 CellChangeTimes->{{3.751602179517939*^9, 3.751602199256702*^9}},
 CellLabel->
  "In[200]:=",ExpressionUUID->"a4ec6815-7e97-4ea2-8770-9f91f339daf5"],

Cell[BoxData[
 RowBox[{
  FractionBox["1", "2"], " ", "b", " ", 
  RowBox[{"(", 
   RowBox[{
    RowBox[{
     SqrtBox[
      RowBox[{"4", "-", 
       SuperscriptBox["b", "2"]}]], " ", 
     RowBox[{"(", 
      RowBox[{"4", "+", 
       SuperscriptBox["b", "2"]}], ")"}]}], "-", 
    RowBox[{"16", " ", "b", " ", 
     RowBox[{"ArcCsc", "[", 
      FractionBox["2", 
       SqrtBox[
        RowBox[{"2", "-", "b"}]]], "]"}]}]}], ")"}]}]], "Output",
 CellChangeTimes->{3.7516022006277*^9},
 CellLabel->
  "Out[200]=",ExpressionUUID->"77e2a544-a536-4c0d-b891-b57ba9cead8d"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"D", "[", 
  RowBox[{"%", ",", "b"}], "]"}]], "Input",
 CellChangeTimes->{{3.7516022019251127`*^9, 3.7516022037253313`*^9}},
 CellLabel->
  "In[201]:=",ExpressionUUID->"e3979540-857c-42d8-8676-3e495cb54c3c"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   FractionBox["1", "2"], " ", "b", " ", 
   RowBox[{"(", 
    RowBox[{
     FractionBox[
      RowBox[{"4", " ", "b"}], 
      RowBox[{
       SqrtBox[
        RowBox[{"1", "+", 
         RowBox[{
          FractionBox["1", "4"], " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"-", "2"}], "+", "b"}], ")"}]}]}]], " ", 
       SqrtBox[
        RowBox[{"2", "-", "b"}]]}]], "+", 
     RowBox[{"2", " ", "b", " ", 
      SqrtBox[
       RowBox[{"4", "-", 
        SuperscriptBox["b", "2"]}]]}], "-", 
     FractionBox[
      RowBox[{"b", " ", 
       RowBox[{"(", 
        RowBox[{"4", "+", 
         SuperscriptBox["b", "2"]}], ")"}]}], 
      SqrtBox[
       RowBox[{"4", "-", 
        SuperscriptBox["b", "2"]}]]], "-", 
     RowBox[{"16", " ", 
      RowBox[{"ArcCsc", "[", 
       FractionBox["2", 
        SqrtBox[
         RowBox[{"2", "-", "b"}]]], "]"}]}]}], ")"}]}], "+", 
  RowBox[{
   FractionBox["1", "2"], " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{
      SqrtBox[
       RowBox[{"4", "-", 
        SuperscriptBox["b", "2"]}]], " ", 
      RowBox[{"(", 
       RowBox[{"4", "+", 
        SuperscriptBox["b", "2"]}], ")"}]}], "-", 
     RowBox[{"16", " ", "b", " ", 
      RowBox[{"ArcCsc", "[", 
       FractionBox["2", 
        SqrtBox[
         RowBox[{"2", "-", "b"}]]], "]"}]}]}], ")"}]}]}]], "Output",
 CellChangeTimes->{3.7516022057076187`*^9},
 CellLabel->
  "Out[201]=",ExpressionUUID->"fd520fb6-37fb-4f27-8c8d-8f0e6950a5e1"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"FullSimplify", "[", "%", "]"}]], "Input",
 CellChangeTimes->{{3.751602208652186*^9, 3.751602210574726*^9}},
 CellLabel->
  "In[202]:=",ExpressionUUID->"5656bb51-75ce-403b-b95a-8b3df1b121be"],

Cell[BoxData[
 RowBox[{"2", " ", 
  RowBox[{"(", 
   RowBox[{
    RowBox[{
     SqrtBox[
      RowBox[{"4", "-", 
       SuperscriptBox["b", "2"]}]], " ", 
     RowBox[{"(", 
      RowBox[{"1", "+", 
       SuperscriptBox["b", "2"]}], ")"}]}], "-", 
    RowBox[{"8", " ", "b", " ", 
     RowBox[{"ArcCsc", "[", 
      FractionBox["2", 
       SqrtBox[
        RowBox[{"2", "-", "b"}]]], "]"}]}]}], ")"}]}]], "Output",
 CellChangeTimes->{3.751602210923311*^9},
 CellLabel->
  "Out[202]=",ExpressionUUID->"8736f850-6a36-4649-92ff-943206b75eda"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Series", "[", 
  RowBox[{"%", ",", 
   RowBox[{"{", 
    RowBox[{"b", ",", "0", ",", "2"}], "}"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.7516022133960648`*^9, 3.751602217781007*^9}},
 CellLabel->
  "In[203]:=",ExpressionUUID->"410c7c09-aa71-4b8d-a1b2-530fded6396c"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"4", "-", 
   RowBox[{"4", " ", "\[Pi]", " ", "b"}], "+", 
   FractionBox[
    RowBox[{"15", " ", 
     SuperscriptBox["b", "2"]}], "2"], "+", 
   InterpretationBox[
    SuperscriptBox[
     RowBox[{"O", "[", "b", "]"}], "3"],
    SeriesData[$CellContext`b, 0, {}, 0, 3, 1],
    Editable->False]}],
  SeriesData[$CellContext`b, 0, {4, (-4) Pi, 
    Rational[15, 2]}, 0, 3, 1],
  Editable->False]], "Output",
 CellChangeTimes->{3.751602218045042*^9},
 CellLabel->
  "Out[203]=",ExpressionUUID->"453e17be-ad22-4d55-b675-84989b3aea35"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"D", "[", 
  RowBox[{
   RowBox[{"2", " ", 
    SuperscriptBox[
     RowBox[{"(", 
      RowBox[{"1", "-", 
       SuperscriptBox[
        RowBox[{"(", 
         RowBox[{
          RowBox[{"-", "1"}], "+", "b"}], ")"}], "2"], "-", 
       RowBox[{"4", " ", "b", " ", 
        SuperscriptBox[
         RowBox[{"Sin", "[", "xi", "]"}], "2"]}]}], ")"}], 
     RowBox[{"n", "/", "2"}]], " ", 
    RowBox[{"(", 
     RowBox[{"1", "-", "b", "+", 
      RowBox[{"2", " ", "b", " ", 
       SuperscriptBox[
        RowBox[{"Sin", "[", "xi", "]"}], "2"]}]}], ")"}]}], " ", ",", "b"}], 
  "]"}]], "Input",
 CellChangeTimes->{{3.751602306884295*^9, 3.751602306954731*^9}, {
  3.751602469179611*^9, 3.751602474903955*^9}},
 CellLabel->
  "In[205]:=",ExpressionUUID->"b5c386f3-cb50-4d5f-81ef-e4fb18d1618a"],

Cell[BoxData[
 RowBox[{
  RowBox[{"2", " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"-", "1"}], "+", 
     RowBox[{"2", " ", 
      SuperscriptBox[
       RowBox[{"Sin", "[", "xi", "]"}], "2"]}]}], ")"}], " ", 
   SuperscriptBox[
    RowBox[{"(", 
     RowBox[{"1", "-", 
      SuperscriptBox[
       RowBox[{"(", 
        RowBox[{
         RowBox[{"-", "1"}], "+", "b"}], ")"}], "2"], "-", 
      RowBox[{"4", " ", "b", " ", 
       SuperscriptBox[
        RowBox[{"Sin", "[", "xi", "]"}], "2"]}]}], ")"}], 
    RowBox[{"n", "/", "2"}]]}], "+", 
  RowBox[{"n", " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{
      RowBox[{"-", "2"}], " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "1"}], "+", "b"}], ")"}]}], "-", 
     RowBox[{"4", " ", 
      SuperscriptBox[
       RowBox[{"Sin", "[", "xi", "]"}], "2"]}]}], ")"}], " ", 
   SuperscriptBox[
    RowBox[{"(", 
     RowBox[{"1", "-", 
      SuperscriptBox[
       RowBox[{"(", 
        RowBox[{
         RowBox[{"-", "1"}], "+", "b"}], ")"}], "2"], "-", 
      RowBox[{"4", " ", "b", " ", 
       SuperscriptBox[
        RowBox[{"Sin", "[", "xi", "]"}], "2"]}]}], ")"}], 
    RowBox[{
     RowBox[{"-", "1"}], "+", 
     FractionBox["n", "2"]}]], " ", 
   RowBox[{"(", 
    RowBox[{"1", "-", "b", "+", 
     RowBox[{"2", " ", "b", " ", 
      SuperscriptBox[
       RowBox[{"Sin", "[", "xi", "]"}], "2"]}]}], ")"}]}]}]], "Output",
 CellChangeTimes->{3.751602399692669*^9, 3.7516024757839127`*^9},
 CellLabel->
  "Out[205]=",ExpressionUUID->"6c8e536e-b422-413c-8336-47d1c91539bc"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"FullSimplify", "[", "%", "]"}]], "Input",
 CellChangeTimes->{{3.751602492601169*^9, 3.751602495874207*^9}},
 CellLabel->
  "In[206]:=",ExpressionUUID->"7c527c1d-8904-41f5-8ef7-9297067e95cf"],

Cell[BoxData[
 RowBox[{
  SuperscriptBox[
   RowBox[{"(", 
    RowBox[{
     RowBox[{"-", "b"}], " ", 
     RowBox[{"(", 
      RowBox[{"b", "-", 
       RowBox[{"2", " ", 
        RowBox[{"Cos", "[", 
         RowBox[{"2", " ", "xi"}], "]"}]}]}], ")"}]}], ")"}], 
   RowBox[{
    FractionBox["1", "2"], " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"-", "2"}], "+", "n"}], ")"}]}]], " ", 
  RowBox[{"(", 
   RowBox[{
    RowBox[{"2", " ", 
     RowBox[{"(", 
      RowBox[{"n", "+", 
       RowBox[{
        SuperscriptBox["b", "2"], " ", 
        RowBox[{"(", 
         RowBox[{"1", "+", "n"}], ")"}]}]}], ")"}], " ", 
     RowBox[{"Cos", "[", 
      RowBox[{"2", " ", "xi"}], "]"}]}], "-", 
    RowBox[{"b", " ", 
     RowBox[{"(", 
      RowBox[{"2", "+", 
       RowBox[{"3", " ", "n"}], "+", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{"2", "+", "n"}], ")"}], " ", 
        RowBox[{"Cos", "[", 
         RowBox[{"4", " ", "xi"}], "]"}]}]}], ")"}]}]}], ")"}]}]], "Output",
 CellChangeTimes->{3.751602497370854*^9},
 CellLabel->
  "Out[206]=",ExpressionUUID->"61218a4f-aa0b-4232-9f87-967cf558bd2c"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Integrate", "[", 
  RowBox[{
   RowBox[{"%", "/.", " ", 
    RowBox[{"n", " ", "\[Rule]", " ", "2"}]}], ",", 
   RowBox[{"{", 
    RowBox[{"xi", ",", 
     RowBox[{"-", 
      RowBox[{"ArcSin", "[", 
       RowBox[{"Sqrt", "[", 
        RowBox[{
         RowBox[{"(", 
          RowBox[{"2", "-", "b"}], ")"}], "/", "4"}], "]"}], "]"}]}], ",", 
     RowBox[{"ArcSin", "[", 
      RowBox[{"Sqrt", "[", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{"2", "-", "b"}], ")"}], "/", "4"}], "]"}], "]"}]}], "}"}]}], 
  "]"}]], "Input",
 CellChangeTimes->{{3.7516025302664013`*^9, 3.7516025367497873`*^9}},
 CellLabel->
  "In[207]:=",ExpressionUUID->"f4546377-cad4-45fd-9343-1b8525f17a75"],

Cell[BoxData[
 RowBox[{"2", " ", 
  RowBox[{"(", 
   RowBox[{
    RowBox[{
     SqrtBox[
      RowBox[{"4", "-", 
       SuperscriptBox["b", "2"]}]], " ", 
     RowBox[{"(", 
      RowBox[{"1", "+", 
       SuperscriptBox["b", "2"]}], ")"}]}], "-", 
    RowBox[{"8", " ", "b", " ", 
     RowBox[{"ArcSin", "[", 
      FractionBox[
       SqrtBox[
        RowBox[{"2", "-", "b"}]], "2"], "]"}]}]}], ")"}]}]], "Output",
 CellChangeTimes->{3.7516025377824993`*^9},
 CellLabel->
  "Out[207]=",ExpressionUUID->"07bda768-6ef8-4c4d-9031-1325992bb954"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Integrate", "[", 
  RowBox[{
   RowBox[{
    RowBox[{"Out", "[", "206", "]"}], " ", "/.", " ", 
    RowBox[{"n", " ", "\[Rule]", " ", "4"}]}], ",", 
   RowBox[{"{", 
    RowBox[{"xi", ",", 
     RowBox[{"-", 
      RowBox[{"ArcSin", "[", 
       RowBox[{"Sqrt", "[", 
        RowBox[{
         RowBox[{"(", 
          RowBox[{"2", "-", "b"}], ")"}], "/", "4"}], "]"}], "]"}]}], ",", 
     RowBox[{"ArcSin", "[", 
      RowBox[{"Sqrt", "[", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{"2", "-", "b"}], ")"}], "/", "4"}], "]"}], "]"}]}], "}"}]}], 
  "]"}]], "Input",
 CellChangeTimes->{{3.7516025401788273`*^9, 3.7516025533409653`*^9}},
 CellLabel->
  "In[208]:=",ExpressionUUID->"819b5fd4-ad58-44eb-9a4f-84d5be55ce7a"],

Cell[BoxData[
 RowBox[{
  RowBox[{"-", "2"}], " ", "b", " ", 
  RowBox[{"(", 
   RowBox[{
    RowBox[{"b", " ", 
     SqrtBox[
      RowBox[{"4", "-", 
       SuperscriptBox["b", "2"]}]], " ", 
     RowBox[{"(", 
      RowBox[{"9", "+", 
       SuperscriptBox["b", "2"]}], ")"}]}], "-", 
    RowBox[{"8", " ", 
     RowBox[{"(", 
      RowBox[{"1", "+", 
       RowBox[{"3", " ", 
        SuperscriptBox["b", "2"]}]}], ")"}], " ", 
     RowBox[{"ArcSin", "[", 
      FractionBox[
       SqrtBox[
        RowBox[{"2", "-", "b"}]], "2"], "]"}]}]}], ")"}]}]], "Output",
 CellChangeTimes->{3.7516025548184137`*^9},
 CellLabel->
  "Out[208]=",ExpressionUUID->"63922a4a-630f-489b-8197-43005607904a"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Integrate", "[", 
  RowBox[{
   RowBox[{
    RowBox[{"Out", "[", "206", "]"}], " ", "/.", " ", 
    RowBox[{"n", " ", "\[Rule]", " ", "3"}]}], ",", 
   RowBox[{"{", 
    RowBox[{"xi", ",", 
     RowBox[{"-", 
      RowBox[{"ArcSin", "[", 
       RowBox[{"Sqrt", "[", 
        RowBox[{
         RowBox[{"(", 
          RowBox[{"2", "-", "b"}], ")"}], "/", "4"}], "]"}], "]"}]}], ",", 
     RowBox[{"ArcSin", "[", 
      RowBox[{"Sqrt", "[", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{"2", "-", "b"}], ")"}], "/", "4"}], "]"}], "]"}]}], "}"}]}], 
  "]"}]], "Input",
 CellChangeTimes->{{3.7516025638674593`*^9, 3.75160256493018*^9}},
 CellLabel->
  "In[209]:=",ExpressionUUID->"b604368b-2666-44ab-89aa-a2dd088d770a"],

Cell[BoxData["$Aborted"], "Output",
 CellChangeTimes->{3.7516028245060873`*^9},
 CellLabel->
  "Out[209]=",ExpressionUUID->"92a380ef-b4e7-4b52-8476-ec11812249fa"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Mn", " ", "=", " ", 
  RowBox[{"Pi", "*", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{"1", "-", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{"b", "-", "r"}], ")"}], "^", "2"}]}], ")"}], "^", 
    RowBox[{"(", 
     RowBox[{"n", "/", "2"}], ")"}]}], "*", 
   RowBox[{"Hypergeometric2F1", "[", 
    RowBox[{
     RowBox[{"1", "/", "2"}], ",", 
     RowBox[{
      RowBox[{"-", "n"}], "/", "2"}], ",", "1", ",", 
     RowBox[{"4", "*", "b", "*", 
      RowBox[{"r", "/", 
       RowBox[{"(", 
        RowBox[{"1", "-", 
         RowBox[{
          RowBox[{"(", 
           RowBox[{"b", "-", "r"}], ")"}], "^", "2"}]}], ")"}]}]}]}], 
    "]"}]}]}]], "Input",
 CellChangeTimes->{{3.752077362787139*^9, 3.7520774012584763`*^9}},
 CellLabel->"In[10]:=",ExpressionUUID->"e8cc0749-b4a5-40a0-aedc-04832981663e"],

Cell[BoxData[
 RowBox[{"\[Pi]", " ", 
  SuperscriptBox[
   RowBox[{"(", 
    RowBox[{"1", "-", 
     SuperscriptBox[
      RowBox[{"(", 
       RowBox[{"b", "-", "r"}], ")"}], "2"]}], ")"}], 
   RowBox[{"n", "/", "2"}]], " ", 
  RowBox[{"Hypergeometric2F1", "[", 
   RowBox[{
    FractionBox["1", "2"], ",", 
    RowBox[{"-", 
     FractionBox["n", "2"]}], ",", "1", ",", 
    FractionBox[
     RowBox[{"4", " ", "b", " ", "r"}], 
     RowBox[{"1", "-", 
      SuperscriptBox[
       RowBox[{"(", 
        RowBox[{"b", "-", "r"}], ")"}], "2"]}]]}], "]"}]}]], "Output",
 CellChangeTimes->{3.752077402413328*^9},
 CellLabel->"Out[10]=",ExpressionUUID->"6a245992-d535-4588-91f0-6b2fd03f9244"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"D", "[", 
  RowBox[{"%", ",", "b"}], "]"}]], "Input",
 CellChangeTimes->{{3.7520774032398443`*^9, 3.7520774049857283`*^9}},
 CellLabel->"In[11]:=",ExpressionUUID->"f3b5a9a7-b8be-432e-bf53-56b215d80038"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"-", "n"}], " ", "\[Pi]", " ", 
   SuperscriptBox[
    RowBox[{"(", 
     RowBox[{"1", "-", 
      SuperscriptBox[
       RowBox[{"(", 
        RowBox[{"b", "-", "r"}], ")"}], "2"]}], ")"}], 
    RowBox[{
     RowBox[{"-", "1"}], "+", 
     FractionBox["n", "2"]}]], " ", 
   RowBox[{"(", 
    RowBox[{"b", "-", "r"}], ")"}], " ", 
   RowBox[{"Hypergeometric2F1", "[", 
    RowBox[{
     FractionBox["1", "2"], ",", 
     RowBox[{"-", 
      FractionBox["n", "2"]}], ",", "1", ",", 
     FractionBox[
      RowBox[{"4", " ", "b", " ", "r"}], 
      RowBox[{"1", "-", 
       SuperscriptBox[
        RowBox[{"(", 
         RowBox[{"b", "-", "r"}], ")"}], "2"]}]]}], "]"}]}], "-", 
  RowBox[{
   FractionBox["1", "4"], " ", "n", " ", "\[Pi]", " ", 
   SuperscriptBox[
    RowBox[{"(", 
     RowBox[{"1", "-", 
      SuperscriptBox[
       RowBox[{"(", 
        RowBox[{"b", "-", "r"}], ")"}], "2"]}], ")"}], 
    RowBox[{"n", "/", "2"}]], " ", 
   RowBox[{"(", 
    RowBox[{
     FractionBox[
      RowBox[{"4", " ", "r"}], 
      RowBox[{"1", "-", 
       SuperscriptBox[
        RowBox[{"(", 
         RowBox[{"b", "-", "r"}], ")"}], "2"]}]], "+", 
     FractionBox[
      RowBox[{"8", " ", "b", " ", 
       RowBox[{"(", 
        RowBox[{"b", "-", "r"}], ")"}], " ", "r"}], 
      SuperscriptBox[
       RowBox[{"(", 
        RowBox[{"1", "-", 
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{"b", "-", "r"}], ")"}], "2"]}], ")"}], "2"]]}], ")"}], " ", 
   RowBox[{"Hypergeometric2F1", "[", 
    RowBox[{
     FractionBox["3", "2"], ",", 
     RowBox[{"1", "-", 
      FractionBox["n", "2"]}], ",", "2", ",", 
     FractionBox[
      RowBox[{"4", " ", "b", " ", "r"}], 
      RowBox[{"1", "-", 
       SuperscriptBox[
        RowBox[{"(", 
         RowBox[{"b", "-", "r"}], ")"}], "2"]}]]}], "]"}]}]}]], "Output",
 CellChangeTimes->{3.752077405550915*^9},
 CellLabel->"Out[11]=",ExpressionUUID->"4464ff38-a43c-44d0-93ac-51eaba494201"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"FullSimplify", "[", "%", "]"}]], "Input",
 CellChangeTimes->{{3.752077407615349*^9, 3.7520774096107616`*^9}},
 CellLabel->"In[12]:=",ExpressionUUID->"688c0a60-c76e-4b16-a402-903289f44330"],

Cell[BoxData[
 RowBox[{
  RowBox[{"-", "n"}], " ", "\[Pi]", " ", 
  SuperscriptBox[
   RowBox[{"(", 
    RowBox[{"1", "-", 
     SuperscriptBox[
      RowBox[{"(", 
       RowBox[{"b", "-", "r"}], ")"}], "2"]}], ")"}], 
   RowBox[{
    FractionBox["1", "2"], " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"-", "4"}], "+", "n"}], ")"}]}]], " ", 
  RowBox[{"(", 
   RowBox[{
    RowBox[{
     RowBox[{"(", 
      RowBox[{"1", "-", 
       SuperscriptBox[
        RowBox[{"(", 
         RowBox[{"b", "-", "r"}], ")"}], "2"]}], ")"}], " ", 
     RowBox[{"(", 
      RowBox[{"b", "-", "r"}], ")"}], " ", 
     RowBox[{"Hypergeometric2F1", "[", 
      RowBox[{
       FractionBox["1", "2"], ",", 
       RowBox[{"-", 
        FractionBox["n", "2"]}], ",", "1", ",", 
       RowBox[{"-", 
        FractionBox[
         RowBox[{"4", " ", "b", " ", "r"}], 
         RowBox[{
          RowBox[{"-", "1"}], "+", 
          SuperscriptBox[
           RowBox[{"(", 
            RowBox[{"b", "-", "r"}], ")"}], "2"]}]]}]}], "]"}]}], "+", 
    RowBox[{"r", " ", 
     RowBox[{"(", 
      RowBox[{"1", "+", 
       SuperscriptBox["b", "2"], "-", 
       SuperscriptBox["r", "2"]}], ")"}], " ", 
     RowBox[{"Hypergeometric2F1", "[", 
      RowBox[{
       FractionBox["3", "2"], ",", 
       RowBox[{"1", "-", 
        FractionBox["n", "2"]}], ",", "2", ",", 
       RowBox[{"-", 
        FractionBox[
         RowBox[{"4", " ", "b", " ", "r"}], 
         RowBox[{
          RowBox[{"-", "1"}], "+", 
          SuperscriptBox[
           RowBox[{"(", 
            RowBox[{"b", "-", "r"}], ")"}], "2"]}]]}]}], "]"}]}]}], 
   ")"}]}]], "Output",
 CellChangeTimes->{3.752077411095492*^9},
 CellLabel->"Out[12]=",ExpressionUUID->"731eac68-605b-4bd9-9b4d-51026390c629"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Integrate", "[", 
  RowBox[{
   RowBox[{
    RowBox[{"Sin", "[", "xi", "]"}], "^", "2"}], ",", 
   RowBox[{"{", 
    RowBox[{"xi", ",", 
     RowBox[{
      RowBox[{"-", "kappa"}], "/", "2"}], ",", 
     RowBox[{"kappa", "/", "2"}]}], "}"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.752079756913252*^9, 3.752079790039175*^9}},
 CellLabel->"In[13]:=",ExpressionUUID->"63d1b673-d6fa-4b9f-9875-fba550967b91"],

Cell[BoxData[
 RowBox[{
  FractionBox["1", "2"], " ", 
  RowBox[{"(", 
   RowBox[{"kappa", "-", 
    RowBox[{"Sin", "[", "kappa", "]"}]}], ")"}]}]], "Output",
 CellChangeTimes->{3.752079790458482*^9},
 CellLabel->"Out[13]=",ExpressionUUID->"e14a8379-2864-4054-834c-7cea37efb389"]
}, Open  ]],

Cell[BoxData[""], "Input",
 CellChangeTimes->{{3.752079791374545*^9, 
  3.752079792230805*^9}},ExpressionUUID->"37564d03-f739-4ec3-b8da-\
5a3ecc8dbdf3"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Integrate", "[", 
  RowBox[{
   RowBox[{
    RowBox[{"Sin", "[", "xi", "]"}], "^", "2"}], ",", 
   RowBox[{"{", 
    RowBox[{"xi", ",", 
     RowBox[{
      RowBox[{"-", "Pi"}], "/", "2"}], ",", 
     RowBox[{"Pi", "/", "2"}]}], "}"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.752079913209218*^9, 3.752079914911352*^9}},
 CellLabel->"In[14]:=",ExpressionUUID->"77e9bbcb-f4aa-4e7a-a695-0dc576c422eb"],

Cell[BoxData[
 FractionBox["\[Pi]", "2"]], "Output",
 CellChangeTimes->{3.7520799152440166`*^9},
 CellLabel->"Out[14]=",ExpressionUUID->"81b64ecb-18cd-4860-b763-90a6a5b954e6"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Integrate", "[", 
  RowBox[{
   RowBox[{
    RowBox[{"Sqrt", "[", 
     RowBox[{"k2", "-", 
      RowBox[{
       RowBox[{"Sin", "[", "xi", "]"}], "^", "2"}]}], "]"}], "*", 
    RowBox[{
     RowBox[{"Sin", "[", "xi", "]"}], "^", "2"}]}], ",", 
   RowBox[{"{", 
    RowBox[{"xi", ",", 
     RowBox[{"-", 
      RowBox[{"ArcSin", "[", 
       RowBox[{"Sqrt", "[", "k2", "]"}], "]"}]}], ",", 
     RowBox[{"ArcSin", "[", 
      RowBox[{"Sqrt", "[", "k2", "]"}], "]"}]}], "}"}], ",", 
   RowBox[{"Assumptions", "\[Rule]", " ", 
    RowBox[{"k2", " ", "<", " ", "1"}]}]}], "]"}]], "Input",
 CellChangeTimes->{{3.752079931664*^9, 3.752079947054154*^9}, 
   3.752079979133555*^9, {3.752080046337975*^9, 3.752080079829856*^9}, {
   3.752080185570118*^9, 3.752080192974875*^9}, {3.752080229558374*^9, 
   3.752080257643997*^9}},
 CellLabel->"In[19]:=",ExpressionUUID->"2c6ee22c-559a-4805-b164-b30a6c5135a7"],

Cell[BoxData["$Aborted"], "Output",
 CellChangeTimes->{3.752080044381002*^9, 3.75208017997255*^9, 
  3.7520802246095533`*^9, 3.752080633422659*^9},
 CellLabel->"Out[19]=",ExpressionUUID->"8c389bf2-4869-42e3-81df-36948f77357c"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Integrate", "[", 
  RowBox[{
   RowBox[{"Sqrt", "[", 
    RowBox[{"w", "*", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{"1", "-", "w"}], ")"}], "/", 
      RowBox[{"(", 
       RowBox[{"1", "-", "w"}], ")"}]}]}], "]"}], ",", 
   RowBox[{"{", 
    RowBox[{"w", ",", "0", ",", "1"}], "}"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.752080782183868*^9, 3.75208080776873*^9}, {
  3.7520810519233418`*^9, 3.7520810748401423`*^9}, {3.7520812183307056`*^9, 
  3.752081251909051*^9}, {3.752081880329632*^9, 3.752081962250105*^9}, {
  3.7520820280078163`*^9, 3.752082032509276*^9}, {3.752090746172176*^9, 
  3.752090746584466*^9}},
 CellLabel->"In[13]:=",ExpressionUUID->"79d97a71-d524-4e7f-ab18-840e1f72b88d"],

Cell[BoxData[
 FractionBox["2", "3"]], "Output",
 CellChangeTimes->{3.752082033169539*^9, 3.752090747131095*^9},
 CellLabel->"Out[13]=",ExpressionUUID->"6beb9932-b489-4eba-ac8b-44795a16dcd5"]
}, Open  ]],

Cell[BoxData[
 RowBox[{"Integrate", "[", 
  RowBox[{
   RowBox[{"Sqrt", "[", 
    RowBox[{"w", "*", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{"1", "-", "w"}], ")"}], "/", 
      RowBox[{"(", 
       RowBox[{"1", "-", 
        RowBox[{"a", "*", "w"}]}], ")"}]}]}], "]"}], ",", 
   RowBox[{"{", 
    RowBox[{"w", ",", "0", ",", "1"}], "}"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.7520820384310207`*^9, 3.752082038589731*^9}, {
  3.7520907572031717`*^9, 3.7520907618316517`*^9}, {3.752090850836141*^9, 
  3.752090852370245*^9}},
 CellLabel->"In[15]:=",ExpressionUUID->"555e0e22-5723-4774-b302-d0b45ef62813"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Integrate", "[", 
  RowBox[{
   RowBox[{"Sqrt", "[", 
    RowBox[{"w", "*", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{"1", "-", "w"}], ")"}], "/", 
      RowBox[{"(", 
       RowBox[{"1", "-", 
        RowBox[{
         RowBox[{"1", "/", "3"}], "*", "w"}]}], ")"}]}]}], "]"}], ",", 
   RowBox[{"{", 
    RowBox[{"w", ",", "0", ",", "1"}], "}"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.752082045326459*^9, 3.7520820496450777`*^9}},
 CellLabel->"In[10]:=",ExpressionUUID->"926f1aa3-465b-4f1c-b6fa-4c3a7fb93302"],

Cell[BoxData[
 RowBox[{
  RowBox[{"10", " ", 
   RowBox[{"EllipticE", "[", 
    FractionBox["1", "3"], "]"}]}], "-", 
  RowBox[{"8", " ", 
   RowBox[{"EllipticK", "[", 
    FractionBox["1", "3"], "]"}]}]}]], "Output",
 CellChangeTimes->{{3.752082046352253*^9, 3.752082050579043*^9}},
 CellLabel->"Out[10]=",ExpressionUUID->"206e1afa-2ef5-4d3c-b72d-a7357ff1e767"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Integrate", "[", 
  RowBox[{
   RowBox[{"Sqrt", "[", 
    RowBox[{"w", "*", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{"1", "-", "w"}], ")"}], "/", 
      RowBox[{"(", 
       RowBox[{"1", "-", 
        RowBox[{
         RowBox[{"1", "/", "6"}], "*", "w"}]}], ")"}]}]}], "]"}], ",", 
   RowBox[{"{", 
    RowBox[{"w", ",", "0", ",", "1"}], "}"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.752082114193276*^9, 3.7520821144010572`*^9}},
 CellLabel->"In[11]:=",ExpressionUUID->"f8b3bbb2-d71f-4f91-ba64-afeea877727f"],

Cell[BoxData[
 RowBox[{
  RowBox[{"44", " ", 
   RowBox[{"EllipticE", "[", 
    FractionBox["1", "6"], "]"}]}], "-", 
  RowBox[{"40", " ", 
   RowBox[{"EllipticK", "[", 
    FractionBox["1", "6"], "]"}]}]}]], "Output",
 CellChangeTimes->{3.752082116220292*^9},
 CellLabel->"Out[11]=",ExpressionUUID->"11bbbc6e-7b99-424c-a324-61809ed71736"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Integrate", "[", 
  RowBox[{
   RowBox[{"Sqrt", "[", 
    RowBox[{"w", "*", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{"1", "-", "w"}], ")"}], "/", 
      RowBox[{"(", 
       RowBox[{"1", "-", 
        RowBox[{
         RowBox[{"1", "/", "7"}], "*", "w"}]}], ")"}]}]}], "]"}], ",", 
   RowBox[{"{", 
    RowBox[{"w", ",", "0", ",", "1"}], "}"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.75208206428304*^9, 3.752082067463763*^9}, {
  3.752082199590461*^9, 3.752082201899769*^9}},
 CellLabel->"In[12]:=",ExpressionUUID->"9bd9f9e3-9a17-4387-aaab-518695e149f3"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   FractionBox["182", "3"], " ", 
   RowBox[{"EllipticE", "[", 
    FractionBox["1", "7"], "]"}]}], "-", 
  RowBox[{"56", " ", 
   RowBox[{"EllipticK", "[", 
    FractionBox["1", "7"], "]"}]}]}]], "Output",
 CellChangeTimes->{3.752082203686062*^9},
 CellLabel->"Out[12]=",ExpressionUUID->"c7b29fa7-c28b-477f-a1f6-82b47d1bdb9f"]
}, Open  ]],

Cell[BoxData[
 RowBox[{"Integrate", "[", 
  RowBox[{
   RowBox[{"Sqrt", "[", 
    RowBox[{"w", "*", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{"1", "-", "w"}], ")"}], "/", 
      RowBox[{"(", 
       RowBox[{"1", "-", 
        RowBox[{
         RowBox[{"1", "/", "8"}], "*", "w"}]}], ")"}]}]}], "]"}], ",", 
   RowBox[{"{", 
    RowBox[{"w", ",", "0", ",", "1"}], "}"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.752091066205915*^9, 3.752091070662489*^9}},
 CellLabel->"In[16]:=",ExpressionUUID->"ece6da69-06cf-4948-8d3e-c27c40d07519"],

Cell[BoxData[{
 RowBox[{
  RowBox[{"80", " ", 
   RowBox[{"EllipticE", "[", 
    FractionBox["1", "8"], "]"}]}], "-", 
  RowBox[{
   FractionBox["224", "3"], " ", 
   RowBox[{"EllipticK", "[", 
    FractionBox["1", "8"], "]"}]}]}], "\[IndentingNewLine]", 
 RowBox[{"Integrate", "[", 
  RowBox[{
   RowBox[{"Sqrt", "[", 
    RowBox[{"w", "*", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{"1", "-", "w"}], ")"}], "/", 
      RowBox[{"(", 
       RowBox[{"1", "-", 
        RowBox[{
         RowBox[{"1", "/", "4"}], "*", "w"}]}], ")"}]}]}], "]"}], ",", 
   RowBox[{"{", 
    RowBox[{"w", ",", "0", ",", "1"}], "}"}]}], "]"}]}], "Input",
 CellChangeTimes->{{3.752091433686708*^9, 3.7520914365263968`*^9}},
 CellLabel->"In[19]:=",ExpressionUUID->"df7b40e0-f0e3-4219-8500-d4364b6afe77"],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"80", " ", 
   RowBox[{"EllipticE", "[", 
    FractionBox["1", "8"], "]"}]}], "-", 
  RowBox[{
   FractionBox["224", "3"], " ", 
   RowBox[{"EllipticK", "[", 
    FractionBox["1", "8"], "]"}]}]}], "\[IndentingNewLine]", 
 RowBox[{"Integrate", "[", 
  RowBox[{
   RowBox[{"Sqrt", "[", 
    RowBox[{"w", "*", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{"1", "-", "w"}], ")"}], "/", 
      RowBox[{"(", 
       RowBox[{"1", "-", 
        RowBox[{
         RowBox[{"1", "/", "5"}], "*", "w"}]}], ")"}]}]}], "]"}], ",", 
   RowBox[{"{", 
    RowBox[{"w", ",", "0", ",", "1"}], "}"}]}], "]"}]}], "Input",
 CellChangeTimes->{{3.7520914522212677`*^9, 3.752091455229192*^9}},
 CellLabel->"In[23]:=",ExpressionUUID->"e520e3b1-e733-4392-9aff-39ac2d945253"],

Cell[BoxData[
 RowBox[{
  RowBox[{"80", " ", 
   RowBox[{"EllipticE", "[", 
    FractionBox["1", "8"], "]"}]}], "-", 
  RowBox[{
   FractionBox["224", "3"], " ", 
   RowBox[{"EllipticK", "[", 
    FractionBox["1", "8"], "]"}]}]}]], "Output",
 CellChangeTimes->{{3.7520914386706038`*^9, 3.752091458406363*^9}, 
   3.7520915205642023`*^9},
 CellLabel->"Out[23]=",ExpressionUUID->"e162ac97-d6da-4b34-940d-94a3fbb317c4"],

Cell[BoxData[
 RowBox[{
  RowBox[{"30", " ", 
   RowBox[{"EllipticE", "[", 
    FractionBox["1", "5"], "]"}]}], "-", 
  RowBox[{
   FractionBox["80", "3"], " ", 
   RowBox[{"EllipticK", "[", 
    FractionBox["1", "5"], "]"}]}]}]], "Output",
 CellChangeTimes->{{3.7520914386706038`*^9, 3.752091458406363*^9}, 
   3.752091520819293*^9},
 CellLabel->"Out[24]=",ExpressionUUID->"42dc8110-eba6-4c6f-a823-bd71a9e9b138"]
}, Open  ]],

Cell[BoxData[
 RowBox[{"FindSequenceFunction", "[", 
  RowBox[{"{", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"3", ",", "10"}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"4", ",", 
      RowBox[{"56", "/", "3"}]}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"5", ",", "30"}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"6", ",", "44"}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"7", ",", 
      RowBox[{"182", "/", "3"}]}], "}"}]}], "}"}], "]"}]], "Input",
 CellChangeTimes->{{3.752091256519788*^9, 3.7520913040942783`*^9}, {
  3.752091356294446*^9, 3.752091358963213*^9}, {3.752091572462741*^9, 
  3.752091592924829*^9}},ExpressionUUID->"bae67879-9940-4742-9617-\
ba06e5295880"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  FractionBox["2", "3"], " ", 
  RowBox[{"(", 
   RowBox[{"6", "+", 
    RowBox[{"7", " ", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"-", "2"}], "+", "#1"}], ")"}]}], "+", 
    RowBox[{"2", " ", 
     SuperscriptBox[
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "2"}], "+", "#1"}], ")"}], "2"]}]}], ")"}]}]], "Input",
 CellChangeTimes->{{3.7520923249451447`*^9, 3.7520923249596577`*^9}},
 CellLabel->"In[42]:=",ExpressionUUID->"1b523354-ee25-41ff-a845-d1c1d87416f5"],

Cell[BoxData[
 RowBox[{
  FractionBox["2", "3"], " ", 
  RowBox[{"(", 
   RowBox[{"6", "+", 
    RowBox[{"7", " ", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"-", "2"}], "+", "#1"}], ")"}]}], "+", 
    RowBox[{"2", " ", 
     SuperscriptBox[
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "2"}], "+", "#1"}], ")"}], "2"]}]}], ")"}]}]], "Output",
 CellChangeTimes->{3.752092326249176*^9},
 CellLabel->"Out[42]=",ExpressionUUID->"38e614f6-25fe-4db4-bc4d-f2c2716a0783"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"FullSimplify", "[", "%", "]"}]], "Input",
 CellChangeTimes->{{3.75209232722225*^9, 3.752092330256475*^9}},
 CellLabel->"In[43]:=",ExpressionUUID->"f03ac957-7b11-4933-82d8-04a9a5a2ff89"],

Cell[BoxData[
 RowBox[{
  FractionBox["2", "3"], " ", "#1", " ", 
  RowBox[{"(", 
   RowBox[{
    RowBox[{"-", "1"}], "+", 
    RowBox[{"2", " ", "#1"}]}], ")"}]}]], "Output",
 CellChangeTimes->{3.752092331712924*^9},
 CellLabel->"Out[43]=",ExpressionUUID->"eb765494-ab79-4ff3-a0f8-109babc76b99"]
}, Open  ]],

Cell[BoxData[
 RowBox[{"FindSequenceFunction", "[", 
  RowBox[{"{", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"3", ",", 
      RowBox[{"-", "8"}]}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"4", ",", 
      RowBox[{
       RowBox[{"-", "48"}], "/", "3"}]}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"5", ",", 
      RowBox[{
       RowBox[{"-", "80"}], "/", "3"}]}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"6", ",", 
      RowBox[{"-", "40"}]}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"7", ",", 
      RowBox[{"-", "56"}]}], "}"}]}], "}"}], "]"}]], "Input",
 CellChangeTimes->{{3.752091478717019*^9, 3.7520915089722557`*^9}, {
  3.752091540943862*^9, 3.752091600436142*^9}},
 CellLabel->"In[27]:=",ExpressionUUID->"c1310ec8-9f1d-4093-bf07-4b6b7c85f7fb"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"-", 
   FractionBox["4", "3"]}], " ", 
  RowBox[{"(", 
   RowBox[{"2", "+", 
    RowBox[{"3", " ", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"-", "2"}], "+", "#1"}], ")"}]}], "+", 
    SuperscriptBox[
     RowBox[{"(", 
      RowBox[{
       RowBox[{"-", "2"}], "+", "#1"}], ")"}], "2"]}], ")"}]}]], "Input",
 CellChangeTimes->{{3.752092374446206*^9, 3.752092374457788*^9}},
 CellLabel->"In[44]:=",ExpressionUUID->"dd0048a5-6bc6-4300-8ec6-cecfce8390bd"],

Cell[BoxData[
 RowBox[{
  RowBox[{"-", 
   FractionBox["4", "3"]}], " ", 
  RowBox[{"(", 
   RowBox[{"2", "+", 
    RowBox[{"3", " ", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"-", "2"}], "+", "#1"}], ")"}]}], "+", 
    SuperscriptBox[
     RowBox[{"(", 
      RowBox[{
       RowBox[{"-", "2"}], "+", "#1"}], ")"}], "2"]}], ")"}]}]], "Output",
 CellChangeTimes->{3.752092375226831*^9},
 CellLabel->"Out[44]=",ExpressionUUID->"b7363952-2bda-4f8c-9a03-5a064eb3fc5e"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"FullSimplify", "[", "%", "]"}]], "Input",
 CellChangeTimes->{{3.752092376722653*^9, 3.752092378301524*^9}},
 CellLabel->"In[45]:=",ExpressionUUID->"ddd49fb3-696a-42ab-8ed4-e8d7744a6aff"],

Cell[BoxData[
 RowBox[{
  RowBox[{"-", 
   FractionBox["4", "3"]}], " ", 
  RowBox[{"(", 
   RowBox[{
    RowBox[{"-", "1"}], "+", "#1"}], ")"}], " ", "#1"}]], "Output",
 CellChangeTimes->{3.7520923785854483`*^9},
 CellLabel->"Out[45]=",ExpressionUUID->"78ac848e-ab96-4db3-ab04-f87d8f37b4b9"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Integrate", "[", 
  RowBox[{
   RowBox[{"Sqrt", "[", 
    RowBox[{"w", "*", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{"1", "-", "w"}], ")"}], "/", 
      RowBox[{"(", 
       RowBox[{"1", "-", 
        RowBox[{
         RowBox[{"1", "/", "5"}], "*", "w"}]}], ")"}]}]}], "]"}], ",", 
   RowBox[{"{", 
    RowBox[{"w", ",", "0", ",", "1"}], "}"}]}], "]"}]], "Input",
 CellChangeTimes->{3.7520915360014687`*^9},
 CellLabel->"In[25]:=",ExpressionUUID->"b6d8ab6f-a972-4676-8a58-4b2212d0b35f"],

Cell[BoxData[
 RowBox[{
  RowBox[{"30", " ", 
   RowBox[{"EllipticE", "[", 
    FractionBox["1", "5"], "]"}]}], "-", 
  RowBox[{
   FractionBox["80", "3"], " ", 
   RowBox[{"EllipticK", "[", 
    FractionBox["1", "5"], "]"}]}]}]], "Output",
 CellChangeTimes->{3.7520915369104843`*^9},
 CellLabel->"Out[25]=",ExpressionUUID->"38eefbc2-4f94-40ac-b611-ac4e55710e39"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Integrate", "[", 
  RowBox[{
   RowBox[{"Sqrt", "[", 
    RowBox[{"w", "*", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{"1", "-", "w"}], ")"}], "/", 
      RowBox[{"(", 
       RowBox[{"1", "-", 
        RowBox[{
         RowBox[{"1", "/", "4"}], "*", "w"}]}], ")"}]}]}], "]"}], ",", 
   RowBox[{"{", 
    RowBox[{"w", ",", "0", ",", "1"}], "}"}]}], "]"}]], "Input",
 CellLabel->"In[26]:=",ExpressionUUID->"76e87f15-a746-4035-a070-17734d6c1c37"],

Cell[BoxData[
 RowBox[{
  FractionBox["8", "3"], " ", 
  RowBox[{"(", 
   RowBox[{
    RowBox[{"7", " ", 
     RowBox[{"EllipticE", "[", 
      FractionBox["1", "4"], "]"}]}], "-", 
    RowBox[{"6", " ", 
     RowBox[{"EllipticK", "[", 
      FractionBox["1", "4"], "]"}]}]}], ")"}]}]], "Output",
 CellChangeTimes->{3.7520915537334547`*^9},
 CellLabel->"Out[26]=",ExpressionUUID->"c2369917-e6ce-4aa8-b876-d0c80f7efb1c"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"NIntegrate", "[", 
  RowBox[{
   RowBox[{
    RowBox[{"Sqrt", "[", 
     RowBox[{"4", "*", "b", "*", "r"}], "]"}], "*", 
    RowBox[{"Sqrt", "[", 
     RowBox[{"k2", "-", 
      RowBox[{
       RowBox[{"Sin", "[", "xi", "]"}], "^", "2"}]}], "]"}], "*", 
    RowBox[{
     RowBox[{"Sin", "[", "xi", "]"}], "^", "2"}]}], ",", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"{", 
       RowBox[{"xi", ",", 
        RowBox[{"-", 
         RowBox[{"ArcSin", "[", 
          RowBox[{"Sqrt", "[", "k2", "]"}], "]"}]}], ",", 
        RowBox[{"ArcSin", "[", 
         RowBox[{"Sqrt", "[", "k2", "]"}], "]"}]}], "}"}], " ", "/.", " ", 
      RowBox[{"k2", " ", "\[Rule]", " ", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{"1", "-", 
          RowBox[{
           RowBox[{"(", 
            RowBox[{"b", "-", "r"}], ")"}], "^", "2"}]}], ")"}], "/", 
        RowBox[{"(", 
         RowBox[{"4", "*", "b", "*", "r"}], ")"}]}]}]}], " ", "/.", " ", 
     RowBox[{"r", " ", "\[Rule]", " ", "0.5"}]}], " ", "/.", " ", 
    RowBox[{"b", " ", "\[Rule]", " ", "0.95"}]}]}], "]"}]], "Input",
 CellChangeTimes->{{3.7520918123096027`*^9, 3.7520919214400587`*^9}, {
  3.752091971584895*^9, 3.752091991836794*^9}},
 CellLabel->"In[32]:=",ExpressionUUID->"5bb16a0a-9006-4d5f-8288-ec5f21c0342a"],

Cell[BoxData[
 TemplateBox[{
  "NIntegrate","inumr",
   "\"The integrand \\!\\(\\*RowBox[{\\\"2\\\", \\\" \\\", SqrtBox[RowBox[{\\\
\"b\\\", \\\" \\\", \\\"r\\\"}]], \\\" \\\", SuperscriptBox[RowBox[{\\\"Sin\\\
\", \\\"[\\\", \\\"xi\\\", \\\"]\\\"}], \\\"2\\\"], \\\" \\\", \
SqrtBox[RowBox[{\\\"k2\\\", \\\"-\\\", SuperscriptBox[RowBox[{\\\"Sin\\\", \\\
\"[\\\", \\\"xi\\\", \\\"]\\\"}], \\\"2\\\"]}]]}]\\) has evaluated to \
non-numerical values for all sampling points in the region with boundaries \
\\!\\(\\*RowBox[{\\\"{\\\", RowBox[{\\\"{\\\", RowBox[{\\\"0\\\", \\\",\\\", \
\\\"0.7047862329871987`\\\"}], \\\"}\\\"}], \\\"}\\\"}]\\).\"",2,32,9,
   25558727817744323038,"Local"},
  "MessageTemplate"]], "Message", "MSG",
 CellChangeTimes->{
  3.7520919236373663`*^9, {3.752091974193054*^9, 3.752091994010572*^9}},
 CellLabel->
  "During evaluation of \
In[32]:=",ExpressionUUID->"2e461d33-cc83-4532-aee9-aeb345525b0c"],

Cell[BoxData[
 RowBox[{"NIntegrate", "[", 
  RowBox[{
   RowBox[{
    SqrtBox[
     RowBox[{"4", " ", "b", " ", "r"}]], " ", 
    SqrtBox[
     RowBox[{"k2", "-", 
      SuperscriptBox[
       RowBox[{"Sin", "[", "xi", "]"}], "2"]}]], " ", 
    SuperscriptBox[
     RowBox[{"Sin", "[", "xi", "]"}], "2"]}], ",", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"{", 
       RowBox[{"xi", ",", 
        RowBox[{"-", 
         RowBox[{"ArcSin", "[", 
          SqrtBox["k2"], "]"}]}], ",", 
        RowBox[{"ArcSin", "[", 
         SqrtBox["k2"], "]"}]}], "}"}], "/.", "\[VeryThinSpace]", 
      RowBox[{"k2", "\[Rule]", 
       FractionBox[
        RowBox[{"1", "-", 
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{"b", "-", "r"}], ")"}], "2"]}], 
        RowBox[{"4", " ", "b", " ", "r"}]]}]}], "/.", "\[VeryThinSpace]", 
     RowBox[{"r", "\[Rule]", "0.5`"}]}], "/.", "\[VeryThinSpace]", 
    RowBox[{"b", "\[Rule]", "0.95`"}]}]}], "]"}]], "Output",
 CellChangeTimes->{
  3.7520919236406803`*^9, {3.752091974265833*^9, 3.7520919940306063`*^9}},
 CellLabel->"Out[32]=",ExpressionUUID->"ccc98cd1-c23e-4f57-b9ba-e32fa832a6b7"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"k2", " ", "\[Rule]", " ", 
    RowBox[{
     RowBox[{"(", 
      RowBox[{"1", "-", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{"b", "-", "r"}], ")"}], "^", "2"}]}], ")"}], "/", 
     RowBox[{"(", 
      RowBox[{"4", "*", "b", "*", "r"}], ")"}]}]}], " ", "/.", " ", 
   RowBox[{"r", " ", "\[Rule]", " ", "0.1"}]}], " ", "/.", " ", 
  RowBox[{"b", " ", "\[Rule]", " ", "0.95"}]}]], "Input",
 CellChangeTimes->{{3.752092003937736*^9, 3.752092006340435*^9}},
 CellLabel->"In[33]:=",ExpressionUUID->"2e585d26-9bbf-4058-98d9-3b677f953e69"],

Cell[BoxData[
 RowBox[{"k2", "\[Rule]", "0.7302631578947371`"}]], "Output",
 CellChangeTimes->{3.752092007226416*^9},
 CellLabel->"Out[33]=",ExpressionUUID->"37fb9309-a5b2-4c95-8227-030ad8171674"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"r", " ", "=", " ", "0.1"}]], "Input",
 CellChangeTimes->{{3.752092011809923*^9, 3.752092014978532*^9}},
 CellLabel->"In[34]:=",ExpressionUUID->"8b9ae90a-8fa8-474d-a4ca-811cd02a2c07"],

Cell[BoxData["0.1`"], "Output",
 CellChangeTimes->{3.752092015379158*^9},
 CellLabel->"Out[34]=",ExpressionUUID->"16b8b79f-4d0f-4554-89a4-ec4286af17d3"]
}, Open  ]],

Cell[BoxData[
 RowBox[{"b", "=", "0.95"}]], "Input",
 CellChangeTimes->{{3.752092015753107*^9, 3.7520920166265078`*^9}},
 CellLabel->"In[35]:=",ExpressionUUID->"9086ecce-05a6-4260-9fc6-e50bd9642347"],

Cell[CellGroupData[{

Cell[BoxData["0.95"], "Input",
 CellChangeTimes->{{3.7520920364731693`*^9, 3.752092038128969*^9}},
 CellLabel->"In[37]:=",ExpressionUUID->"40eecb30-ef86-430f-8e5e-1c5d2302e0d1"],

Cell[BoxData["0.95`"], "Output",
 CellChangeTimes->{3.752092038559031*^9},
 CellLabel->"Out[37]=",ExpressionUUID->"64c714b4-de53-4318-a1e6-b4127eedfa60"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"k2", " ", "=", " ", 
  RowBox[{
   RowBox[{"(", 
    RowBox[{"1", "-", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{"b", "-", "r"}], ")"}], "^", "2"}]}], ")"}], "/", 
   RowBox[{"(", 
    RowBox[{"4", "*", "b", "*", "r"}], ")"}]}]}]], "Input",
 CellChangeTimes->{{3.752092039688085*^9, 3.752092046024774*^9}},
 CellLabel->"In[38]:=",ExpressionUUID->"ae895fe4-e7fc-44dd-ac0c-ffccd5cadde1"],

Cell[BoxData["0.7302631578947371`"], "Output",
 CellChangeTimes->{3.752092046363555*^9},
 CellLabel->"Out[38]=",ExpressionUUID->"9c56df2c-f9d0-4ee6-8b9f-6532fa695185"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"NIntegrate", "[", 
  RowBox[{
   RowBox[{
    RowBox[{"Sqrt", "[", 
     RowBox[{"4", "*", "b", "*", "r"}], "]"}], "*", 
    RowBox[{"Sqrt", "[", 
     RowBox[{"k2", "-", 
      RowBox[{
       RowBox[{"Sin", "[", "xi", "]"}], "^", "2"}]}], "]"}], "*", 
    RowBox[{
     RowBox[{"Sin", "[", "xi", "]"}], "^", "2"}]}], ",", 
   RowBox[{"{", 
    RowBox[{"xi", ",", 
     RowBox[{"-", 
      RowBox[{"ArcSin", "[", 
       RowBox[{"Sqrt", "[", "k2", "]"}], "]"}]}], ",", 
     RowBox[{"ArcSin", "[", 
      RowBox[{"Sqrt", "[", "k2", "]"}], "]"}]}], "}"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.7520920182890043`*^9, 3.752092028571383*^9}, {
  3.7520921334129477`*^9, 3.752092136211513*^9}, {3.7520923984608297`*^9, 
  3.7520924008272057`*^9}},
 CellLabel->"In[47]:=",ExpressionUUID->"e0d5bc15-1a46-487e-b66d-263f4fbcc022"],

Cell[BoxData["0.16778041697039614`"], "Output",
 CellChangeTimes->{{3.752092029298081*^9, 3.752092048922042*^9}, 
   3.752092137813817*^9, 3.7520924012352953`*^9},
 CellLabel->"Out[47]=",ExpressionUUID->"9dd27162-b6d6-431f-bcbb-12cada6907a1"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"2", "/", "3"}], "*", 
  RowBox[{"Sqrt", "[", 
   RowBox[{"4", "*", "b", "*", "r"}], "]"}], "*", 
  RowBox[{"(", 
   RowBox[{
    RowBox[{
     RowBox[{"(", 
      RowBox[{"2", "-", "k2"}], ")"}], "*", 
     RowBox[{"EllipticE", "[", "k2", "]"}]}], "-", 
    RowBox[{"2", "*", 
     RowBox[{"(", 
      RowBox[{"1", "-", "k2"}], ")"}], "*", 
     RowBox[{"EllipticK", "[", "k2", "]"}]}]}], ")"}]}]], "Input",
 CellChangeTimes->{{3.7520920564051237`*^9, 3.752092080079844*^9}, {
  3.7520923917824697`*^9, 3.752092392299432*^9}},
 CellLabel->"In[46]:=",ExpressionUUID->"3d787c8f-442b-4f89-937e-6a03610e6dae"],

Cell[BoxData["0.1677804169703872`"], "Output",
 CellChangeTimes->{3.7520920811231117`*^9, 3.752092394154471*^9},
 CellLabel->"Out[46]=",ExpressionUUID->"350169eb-bd15-43ad-a3fd-041b7714ba0e"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Integrate", "[", 
  RowBox[{
   RowBox[{
    RowBox[{"Sqrt", "[", 
     RowBox[{"k2", "-", 
      RowBox[{
       RowBox[{"Sin", "[", "xi", "]"}], "^", "2"}]}], "]"}], "*", 
    RowBox[{
     RowBox[{"Sin", "[", "xi", "]"}], "^", "2"}]}], ",", 
   RowBox[{"{", 
    RowBox[{"xi", ",", 
     RowBox[{
      RowBox[{"-", "Pi"}], "/", "2"}], ",", 
     RowBox[{"Pi", "/", "2"}]}], "}"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.752092465662466*^9, 3.75209248058213*^9}},
 CellLabel->"In[1]:=",ExpressionUUID->"2ee046d4-9eb4-484e-91f3-c6339f3547f0"],

Cell[BoxData[
 RowBox[{"ConditionalExpression", "[", 
  RowBox[{
   RowBox[{
    RowBox[{"-", 
     FractionBox["2", "3"]}], " ", 
    SqrtBox["k2"], " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{
       RowBox[{"(", 
        RowBox[{
         RowBox[{"-", "2"}], "+", "k2"}], ")"}], " ", 
       RowBox[{"EllipticE", "[", 
        FractionBox["1", "k2"], "]"}]}], "-", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{
         RowBox[{"-", "1"}], "+", "k2"}], ")"}], " ", 
       RowBox[{"EllipticK", "[", 
        FractionBox["1", "k2"], "]"}]}]}], ")"}]}], ",", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      RowBox[{
       RowBox[{"Im", "[", "k2", "]"}], "\[NotEqual]", "0"}], "&&", 
      RowBox[{
       RowBox[{"Re", "[", "k2", "]"}], ">", "0"}]}], ")"}], "||", 
    RowBox[{
     RowBox[{"Re", "[", "k2", "]"}], "\[GreaterEqual]", "1"}]}]}], 
  "]"}]], "Output",
 CellChangeTimes->{3.7520926227452593`*^9},
 CellLabel->"Out[1]=",ExpressionUUID->"aa90bb82-0fbb-4aa6-8af4-024fe401623e"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"r", "=", "0.1"}]], "Input",
 CellChangeTimes->{{3.752094723040576*^9, 3.752094724467353*^9}},
 CellLabel->"In[1]:=",ExpressionUUID->"187d98ea-fea0-43c4-8851-0cdcb8f2c1cd"],

Cell[BoxData["0.1`"], "Output",
 CellChangeTimes->{3.75209472534184*^9},
 CellLabel->"Out[1]=",ExpressionUUID->"626bd98e-6c6c-43f1-a968-b59246ccb394"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"b", "=", "0.5"}]], "Input",
 CellChangeTimes->{{3.752094725593472*^9, 3.752094726196197*^9}},
 CellLabel->"In[2]:=",ExpressionUUID->"45726860-e057-453f-b5b1-4ada2f6e8b28"],

Cell[BoxData["0.5`"], "Output",
 CellChangeTimes->{3.7520947266572113`*^9},
 CellLabel->"Out[2]=",ExpressionUUID->"7681a9b0-5a7b-464a-8d5f-b1de98df2e84"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"k2", " ", "=", " ", 
  RowBox[{
   RowBox[{"(", 
    RowBox[{"1", "-", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{"b", "-", "r"}], ")"}], "^", "2"}]}], ")"}], "/", 
   RowBox[{"(", 
    RowBox[{"4", "*", "b", "*", "r"}], ")"}]}]}]], "Input",
 CellChangeTimes->{{3.7520947274273443`*^9, 3.752094734635769*^9}},
 CellLabel->"In[3]:=",ExpressionUUID->"61b4d569-9268-4093-b1fd-eb6858d4c4fe"],

Cell[BoxData["4.2`"], "Output",
 CellChangeTimes->{3.7520947349607077`*^9},
 CellLabel->"Out[3]=",ExpressionUUID->"5fde8338-ff2c-42c4-9f38-d62dc8779458"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"NIntegrate", "[", 
  RowBox[{
   RowBox[{
    RowBox[{"Sqrt", "[", 
     RowBox[{"4", "*", "b", "*", "r"}], "]"}], "*", 
    RowBox[{"Sqrt", "[", 
     RowBox[{"k2", "-", 
      RowBox[{
       RowBox[{"Sin", "[", "xi", "]"}], "^", "2"}]}], "]"}], "*", 
    RowBox[{
     RowBox[{"Sin", "[", "xi", "]"}], "^", "2"}]}], ",", 
   RowBox[{"{", 
    RowBox[{"xi", ",", 
     RowBox[{
      RowBox[{"-", "Pi"}], "/", "2"}], ",", 
     RowBox[{"Pi", "/", "2"}]}], "}"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.752094742861085*^9, 3.752094746267089*^9}},
 CellLabel->"In[4]:=",ExpressionUUID->"978b60c2-6400-4deb-9c33-cb9787c4ba40"],

Cell[BoxData["1.3039721773572446`"], "Output",
 CellChangeTimes->{3.752094746791885*^9},
 CellLabel->"Out[4]=",ExpressionUUID->"e21eaddc-50b0-48ff-ba15-208300b9db5a"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"2", "/", "3"}], "*", 
  RowBox[{"Sqrt", "[", 
   RowBox[{"4", "*", "b", "*", "r"}], "]"}], "*", 
  RowBox[{"Sqrt", "[", "k2", "]"}], "*", 
  RowBox[{"(", 
   RowBox[{
    RowBox[{
     RowBox[{"(", 
      RowBox[{"2", "-", "k2"}], ")"}], "*", 
     RowBox[{"EllipticE", "[", 
      RowBox[{"1", "/", "k2"}], "]"}]}], "-", 
    RowBox[{
     RowBox[{"(", 
      RowBox[{"1", "-", "k2"}], ")"}], "*", 
     RowBox[{"EllipticK", "[", 
      RowBox[{"1", "/", "k2"}], "]"}]}]}], ")"}]}]], "Input",
 CellChangeTimes->{{3.752094754177452*^9, 3.752094819854533*^9}},
 CellLabel->"In[6]:=",ExpressionUUID->"4a8d8383-b110-4ea0-8167-4d1da129aaac"],

Cell[BoxData["1.3039721773572566`"], "Output",
 CellChangeTimes->{{3.752094802050878*^9, 3.752094820313304*^9}},
 CellLabel->"Out[6]=",ExpressionUUID->"0751e428-7c5d-463d-bb15-43f0b0788617"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Integrate", "[", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{"(", 
      RowBox[{"1", "-", "w"}], ")"}], "^", 
     RowBox[{"(", 
      RowBox[{"n", "/", "2"}], ")"}]}], "*", 
    RowBox[{
     RowBox[{"Sqrt", "[", "w", "]"}], "/", 
     RowBox[{"Sqrt", "[", 
      RowBox[{"1", "-", 
       RowBox[{"k2", "*", "w"}]}], "]"}]}]}], ",", 
   RowBox[{"{", 
    RowBox[{"w", ",", "0", ",", "1"}], "}"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.752111960340145*^9, 3.752111977350891*^9}},
 CellLabel->"In[1]:=",ExpressionUUID->"16c4fff0-b899-4059-b5a9-3fee0a873183"],

Cell[BoxData[
 RowBox[{"ConditionalExpression", "[", 
  RowBox[{
   RowBox[{
    FractionBox["1", "2"], " ", 
    SqrtBox["\[Pi]"], " ", 
    RowBox[{"Gamma", "[", 
     RowBox[{"1", "+", 
      FractionBox["n", "2"]}], "]"}], " ", 
    RowBox[{"Hypergeometric2F1Regularized", "[", 
     RowBox[{
      FractionBox["1", "2"], ",", 
      FractionBox["3", "2"], ",", 
      FractionBox[
       RowBox[{"5", "+", "n"}], "2"], ",", "k2"}], "]"}]}], ",", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      RowBox[{
       RowBox[{"Re", "[", "k2", "]"}], "\[LessEqual]", "1"}], "||", 
      RowBox[{"k2", "\[NotElement]", 
       TemplateBox[{},
        "Reals"]}]}], ")"}], "&&", 
    RowBox[{
     RowBox[{"Re", "[", "n", "]"}], ">", 
     RowBox[{"-", "2"}]}]}]}], "]"}]], "Output",
 CellChangeTimes->{3.752111982074883*^9},
 CellLabel->"Out[1]=",ExpressionUUID->"87a9426c-dc6c-40ec-85e5-e019d8ef0c6c"]
}, Open  ]],

Cell[BoxData[
 RowBox[{"Normal", "[", 
  RowBox[{"Out", "[", "1", "]"}], "]"}]], "Input",
 CellChangeTimes->{{3.752112529671051*^9, 3.7521125328233356`*^9}},
 CellLabel->"In[9]:=",ExpressionUUID->"022503cb-ab3c-4f29-9931-fd301dc71a4d"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"SeriesCoefficient", "[", 
  RowBox[{
   RowBox[{
    FractionBox["1", "2"], " ", 
    SqrtBox["\[Pi]"], " ", 
    RowBox[{"Gamma", "[", 
     RowBox[{"1", "+", 
      FractionBox["n", "2"]}], "]"}], " ", 
    RowBox[{"Hypergeometric2F1Regularized", "[", 
     RowBox[{
      FractionBox["1", "2"], ",", 
      FractionBox["3", "2"], ",", 
      FractionBox[
       RowBox[{"5", "+", "n"}], "2"], ",", "k2"}], "]"}]}], ",", 
   RowBox[{"{", 
    RowBox[{"k2", ",", "0", ",", "m"}], "}"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.752112537376861*^9, 3.752112561302841*^9}},
 CellLabel->"In[10]:=",ExpressionUUID->"f4b2c31a-d099-46f6-bf07-06ed8b0279d6"],

Cell[BoxData[
 TagBox[GridBox[{
    {"\[Piecewise]", GridBox[{
       {
        FractionBox[
         RowBox[{
          RowBox[{"Gamma", "[", 
           RowBox[{
            FractionBox["1", "2"], "+", "m"}], "]"}], " ", 
          RowBox[{"Gamma", "[", 
           RowBox[{
            FractionBox["3", "2"], "+", "m"}], "]"}], " ", 
          RowBox[{"Gamma", "[", 
           RowBox[{"1", "+", 
            FractionBox["n", "2"]}], "]"}]}], 
         RowBox[{
          SqrtBox["\[Pi]"], " ", 
          RowBox[{"Gamma", "[", 
           RowBox[{"1", "+", "m"}], "]"}], " ", 
          RowBox[{"Gamma", "[", 
           RowBox[{
            FractionBox["5", "2"], "+", "m", "+", 
            FractionBox["n", "2"]}], "]"}]}]], 
        RowBox[{"m", "\[GreaterEqual]", "0"}]},
       {"0", 
        TagBox["True",
         "PiecewiseDefault",
         AutoDelete->True]}
      },
      AllowedDimensions->{2, Automatic},
      Editable->True,
      GridBoxAlignment->{
       "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
        "RowsIndexed" -> {}},
      GridBoxItemSize->{
       "Columns" -> {{Automatic}}, "ColumnsIndexed" -> {}, "Rows" -> {{1.}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.84]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}},
      Selectable->True]}
   },
   GridBoxAlignment->{
    "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
     "RowsIndexed" -> {}},
   GridBoxItemSize->{
    "Columns" -> {{Automatic}}, "ColumnsIndexed" -> {}, "Rows" -> {{1.}}, 
     "RowsIndexed" -> {}},
   GridBoxSpacings->{"Columns" -> {
       Offset[0.27999999999999997`], {
        Offset[0.35]}, 
       Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
       Offset[0.2], {
        Offset[0.4]}, 
       Offset[0.2]}, "RowsIndexed" -> {}}],
  "Piecewise",
  DeleteWithContents->True,
  Editable->False,
  SelectWithContents->True,
  Selectable->False]], "Output",
 CellChangeTimes->{3.7521125619585733`*^9},
 CellLabel->"Out[10]=",ExpressionUUID->"4777db88-0b72-49e3-9a9b-78343c3e0b65"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  FractionBox[
   RowBox[{
    RowBox[{"Gamma", "[", 
     RowBox[{
      FractionBox["1", "2"], "+", "m"}], "]"}], " ", 
    RowBox[{"Gamma", "[", 
     RowBox[{
      FractionBox["3", "2"], "+", "m"}], "]"}], " ", 
    RowBox[{"Gamma", "[", 
     RowBox[{"1", "+", 
      FractionBox["n", "2"]}], "]"}]}], 
   RowBox[{
    SqrtBox["\[Pi]"], " ", 
    RowBox[{"Gamma", "[", 
     RowBox[{"1", "+", "m"}], "]"}], " ", 
    RowBox[{"Gamma", "[", 
     RowBox[{
      FractionBox["5", "2"], "+", "m", "+", 
      FractionBox["n", "2"]}], "]"}]}]], "/", 
  RowBox[{"(", 
   FractionBox[
    RowBox[{
     RowBox[{"Gamma", "[", 
      RowBox[{
       FractionBox["1", "2"], "+", "m", "-", "1"}], "]"}], " ", 
     RowBox[{"Gamma", "[", 
      RowBox[{
       FractionBox["3", "2"], "+", "m", "-", "1"}], "]"}], " ", 
     RowBox[{"Gamma", "[", 
      RowBox[{"1", "+", 
       FractionBox["n", "2"]}], "]"}]}], 
    RowBox[{
     SqrtBox["\[Pi]"], " ", 
     RowBox[{"Gamma", "[", 
      RowBox[{"1", "+", "m", "-", "1"}], "]"}], " ", 
     RowBox[{"Gamma", "[", 
      RowBox[{
       FractionBox["5", "2"], "+", "m", "+", 
       FractionBox["n", "2"], "-", "1"}], "]"}]}]], ")"}]}]], "Input",
 CellChangeTimes->{{3.752112569351499*^9, 3.752112579678729*^9}},
 CellLabel->"In[11]:=",ExpressionUUID->"29442691-8953-4596-a3e0-9236cb08ec0d"],

Cell[BoxData[
 FractionBox[
  RowBox[{
   RowBox[{"Gamma", "[", "m", "]"}], " ", 
   RowBox[{"Gamma", "[", 
    RowBox[{
     FractionBox["3", "2"], "+", "m"}], "]"}], " ", 
   RowBox[{"Gamma", "[", 
    RowBox[{
     FractionBox["3", "2"], "+", "m", "+", 
     FractionBox["n", "2"]}], "]"}]}], 
  RowBox[{
   RowBox[{"Gamma", "[", 
    RowBox[{
     RowBox[{"-", 
      FractionBox["1", "2"]}], "+", "m"}], "]"}], " ", 
   RowBox[{"Gamma", "[", 
    RowBox[{"1", "+", "m"}], "]"}], " ", 
   RowBox[{"Gamma", "[", 
    RowBox[{
     FractionBox["5", "2"], "+", "m", "+", 
     FractionBox["n", "2"]}], "]"}]}]]], "Output",
 CellChangeTimes->{3.7521125806098537`*^9},
 CellLabel->"Out[11]=",ExpressionUUID->"5cd8a87a-c8fb-4e8f-8a04-695bc8bea891"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"FullSimplify", "[", "%", "]"}]], "Input",
 CellChangeTimes->{{3.752112581404755*^9, 3.752112582838831*^9}},
 CellLabel->"In[12]:=",ExpressionUUID->"7a1058a0-414b-44e4-9272-8fb3409349aa"],

Cell[BoxData[
 FractionBox[
  RowBox[{
   RowBox[{"-", "1"}], "+", 
   RowBox[{"4", " ", 
    SuperscriptBox["m", "2"]}]}], 
  RowBox[{"2", " ", "m", " ", 
   RowBox[{"(", 
    RowBox[{"3", "+", 
     RowBox[{"2", " ", "m"}], "+", "n"}], ")"}]}]]], "Output",
 CellChangeTimes->{3.752112583151881*^9},
 CellLabel->"Out[12]=",ExpressionUUID->"917339d9-1dd9-4c53-ae3e-3ad525e1fa81"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Series", "[", 
  RowBox[{
   RowBox[{
    FractionBox["1", "2"], " ", 
    SqrtBox["\[Pi]"], " ", 
    RowBox[{"Gamma", "[", 
     RowBox[{"1", "+", 
      FractionBox["n", "2"]}], "]"}], " ", 
    RowBox[{"Hypergeometric2F1Regularized", "[", 
     RowBox[{
      FractionBox["1", "2"], ",", 
      FractionBox["3", "2"], ",", 
      FractionBox[
       RowBox[{"5", "+", "n"}], "2"], ",", "k2"}], "]"}]}], ",", 
   RowBox[{"{", 
    RowBox[{"k2", ",", "0", ",", "0"}], "}"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.7521126069725847`*^9, 3.7521126218744183`*^9}},
 CellLabel->"In[13]:=",ExpressionUUID->"b24f7105-f017-4d7f-91bb-aea312e7fec8"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
   FractionBox[
    RowBox[{
     SqrtBox["\[Pi]"], " ", 
     RowBox[{"Gamma", "[", 
      RowBox[{"1", "+", 
       FractionBox["n", "2"]}], "]"}]}], 
    RowBox[{"2", " ", 
     RowBox[{"Gamma", "[", 
      FractionBox[
       RowBox[{"5", "+", "n"}], "2"], "]"}]}]], "+", 
   InterpretationBox[
    SuperscriptBox[
     RowBox[{"O", "[", "k2", "]"}], "1"],
    SeriesData[$CellContext`k2, 0, {}, 0, 1, 1],
    Editable->False]}],
  SeriesData[$CellContext`k2, 0, {
   Rational[1, 2] Pi^Rational[1, 2] Gamma[1 + Rational[1, 2] $CellContext`n]/
    Gamma[Rational[1, 2] (5 + $CellContext`n)]}, 0, 1, 1],
  Editable->False]], "Output",
 CellChangeTimes->{3.7521126222188396`*^9},
 CellLabel->"Out[13]=",ExpressionUUID->"213a51e0-b1f8-48f4-97b4-ed1f5b30c6a5"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"FullSimplify", "[", "%", "]"}]], "Input",
 CellChangeTimes->{{3.7521126233368063`*^9, 3.7521126249069157`*^9}},
 CellLabel->"In[14]:=",ExpressionUUID->"0182448c-8e26-4885-a043-176858aa0d97"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
   FractionBox[
    RowBox[{
     SqrtBox["\[Pi]"], " ", 
     RowBox[{"Gamma", "[", 
      RowBox[{"1", "+", 
       FractionBox["n", "2"]}], "]"}]}], 
    RowBox[{"2", " ", 
     RowBox[{"Gamma", "[", 
      FractionBox[
       RowBox[{"5", "+", "n"}], "2"], "]"}]}]], "+", 
   InterpretationBox[
    SuperscriptBox[
     RowBox[{"O", "[", "k2", "]"}], "1"],
    SeriesData[$CellContext`k2, 0, {}, 0, 1, 1],
    Editable->False]}],
  SeriesData[$CellContext`k2, 0, {
   Rational[1, 2] Pi^Rational[1, 2] Gamma[1 + Rational[1, 2] $CellContext`n]/
    Gamma[Rational[1, 2] (5 + $CellContext`n)]}, 0, 1, 1],
  Editable->False]], "Output",
 CellChangeTimes->{3.752112625199298*^9},
 CellLabel->"Out[14]=",ExpressionUUID->"53231e71-2c72-47ac-b983-2bad5219b243"]
}, Open  ]],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{
   RowBox[{"Quadratic", " ", "limb"}], "-", "darkening"}], " ", 
  "*)"}]], "Input",
 CellChangeTimes->{{3.7524194670625963`*^9, 3.752419473205145*^9}},
 CellLabel->"In[1]:=",ExpressionUUID->"3139a6ce-b55a-450d-b429-8ace3342a289"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"(", 
  RowBox[{"1", "-", 
   RowBox[{"2", "*", 
    RowBox[{"(", 
     RowBox[{"1", "-", "mu"}], ")"}]}], "-", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{"-", "1"}], ")"}], "*", 
    RowBox[{
     RowBox[{"(", 
      RowBox[{"1", "-", "mu"}], ")"}], "^", "2"}]}]}], ")"}]], "Input",
 CellChangeTimes->{{3.752419477040403*^9, 3.7524195007367687`*^9}},
 CellLabel->"In[4]:=",ExpressionUUID->"6f3cac95-0fb5-4842-9dc8-e8e4d0cb7ea4"],

Cell[BoxData[
 RowBox[{"1", "-", 
  RowBox[{"2", " ", 
   RowBox[{"(", 
    RowBox[{"1", "-", "mu"}], ")"}]}], "+", 
  SuperscriptBox[
   RowBox[{"(", 
    RowBox[{"1", "-", "mu"}], ")"}], "2"]}]], "Output",
 CellChangeTimes->{{3.7524194908770943`*^9, 3.7524195018916473`*^9}},
 CellLabel->"Out[4]=",ExpressionUUID->"58d1f92a-3d90-4ca7-bab5-0a7388e25ca8"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"FullSimplify", "[", "%", "]"}]], "Input",
 CellChangeTimes->{{3.7524194917594967`*^9, 3.7524194943702507`*^9}},
 CellLabel->"In[5]:=",ExpressionUUID->"171e6b52-334e-4d68-ab13-5d85b78c6e32"],

Cell[BoxData[
 SuperscriptBox["mu", "2"]], "Output",
 CellChangeTimes->{{3.752419494691053*^9, 3.752419503271181*^9}},
 CellLabel->"Out[5]=",ExpressionUUID->"e7182d71-e6a9-4393-8d6e-2d5d82665053"]
}, Open  ]],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{
   RowBox[{"Testing", " ", "limb"}], "-", 
   RowBox[{"darkening", " ", "transformation"}]}], " ", "*)"}]], "Input",
 CellChangeTimes->{{3.752425041221422*^9, 3.752425049284707*^9}},
 CellLabel->"In[6]:=",ExpressionUUID->"009da15e-1419-4b8d-a9f3-e4cec3fd16f3"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"1", "-", 
  RowBox[{"u1", "*", 
   RowBox[{"(", 
    RowBox[{"1", "-", "mu"}], ")"}]}], "-", 
  RowBox[{"u2", "*", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{"1", "-", "mu"}], ")"}], "^", "2"}]}], "-", 
  RowBox[{"u3", "*", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{"1", "-", "mu"}], ")"}], "^", "3"}]}], "-", 
  RowBox[{"u4", "*", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{"1", "-", "mu"}], ")"}], "^", "4"}]}], "-", 
  RowBox[{"u5", "*", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{"1", "-", "mu"}], ")"}], "^", "5"}]}], "-", 
  RowBox[{"u6", "*", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{"1", "-", "mu"}], ")"}], "^", "6"}]}]}]], "Input",
 CellChangeTimes->{{3.752425069511319*^9, 3.752425094582152*^9}},
 CellLabel->"In[7]:=",ExpressionUUID->"3e891763-efa6-4e93-8694-e3ce24a7fec8"],

Cell[BoxData[
 RowBox[{"1", "-", 
  RowBox[{
   RowBox[{"(", 
    RowBox[{"1", "-", "mu"}], ")"}], " ", "u1"}], "-", 
  RowBox[{
   SuperscriptBox[
    RowBox[{"(", 
     RowBox[{"1", "-", "mu"}], ")"}], "2"], " ", "u2"}], "-", 
  RowBox[{
   SuperscriptBox[
    RowBox[{"(", 
     RowBox[{"1", "-", "mu"}], ")"}], "3"], " ", "u3"}], "-", 
  RowBox[{
   SuperscriptBox[
    RowBox[{"(", 
     RowBox[{"1", "-", "mu"}], ")"}], "4"], " ", "u4"}], "-", 
  RowBox[{
   SuperscriptBox[
    RowBox[{"(", 
     RowBox[{"1", "-", "mu"}], ")"}], "5"], " ", "u5"}], "-", 
  RowBox[{
   SuperscriptBox[
    RowBox[{"(", 
     RowBox[{"1", "-", "mu"}], ")"}], "6"], " ", "u6"}]}]], "Output",
 CellChangeTimes->{3.7524250949659233`*^9},
 CellLabel->"Out[7]=",ExpressionUUID->"73ba8d8c-5600-4ebd-a5fa-6c32936c2b68"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Expand", "[", "%", "]"}]], "Input",
 CellChangeTimes->{{3.752425095564053*^9, 3.7524250983437433`*^9}},
 CellLabel->"In[8]:=",ExpressionUUID->"09fe2406-ae6f-46f9-a0d3-517ef7dbfc70"],

Cell[BoxData[
 RowBox[{"1", "-", "u1", "+", 
  RowBox[{"mu", " ", "u1"}], "-", "u2", "+", 
  RowBox[{"2", " ", "mu", " ", "u2"}], "-", 
  RowBox[{
   SuperscriptBox["mu", "2"], " ", "u2"}], "-", "u3", "+", 
  RowBox[{"3", " ", "mu", " ", "u3"}], "-", 
  RowBox[{"3", " ", 
   SuperscriptBox["mu", "2"], " ", "u3"}], "+", 
  RowBox[{
   SuperscriptBox["mu", "3"], " ", "u3"}], "-", "u4", "+", 
  RowBox[{"4", " ", "mu", " ", "u4"}], "-", 
  RowBox[{"6", " ", 
   SuperscriptBox["mu", "2"], " ", "u4"}], "+", 
  RowBox[{"4", " ", 
   SuperscriptBox["mu", "3"], " ", "u4"}], "-", 
  RowBox[{
   SuperscriptBox["mu", "4"], " ", "u4"}], "-", "u5", "+", 
  RowBox[{"5", " ", "mu", " ", "u5"}], "-", 
  RowBox[{"10", " ", 
   SuperscriptBox["mu", "2"], " ", "u5"}], "+", 
  RowBox[{"10", " ", 
   SuperscriptBox["mu", "3"], " ", "u5"}], "-", 
  RowBox[{"5", " ", 
   SuperscriptBox["mu", "4"], " ", "u5"}], "+", 
  RowBox[{
   SuperscriptBox["mu", "5"], " ", "u5"}], "-", "u6", "+", 
  RowBox[{"6", " ", "mu", " ", "u6"}], "-", 
  RowBox[{"15", " ", 
   SuperscriptBox["mu", "2"], " ", "u6"}], "+", 
  RowBox[{"20", " ", 
   SuperscriptBox["mu", "3"], " ", "u6"}], "-", 
  RowBox[{"15", " ", 
   SuperscriptBox["mu", "4"], " ", "u6"}], "+", 
  RowBox[{"6", " ", 
   SuperscriptBox["mu", "5"], " ", "u6"}], "-", 
  RowBox[{
   SuperscriptBox["mu", "6"], " ", "u6"}]}]], "Output",
 CellChangeTimes->{3.7524250986477633`*^9},
 CellLabel->"Out[8]=",ExpressionUUID->"ec03b1a9-f235-41a3-a3db-1885fa5f2402"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Series", "[", 
  RowBox[{"%", ",", 
   RowBox[{"{", 
    RowBox[{"mu", ",", "0", ",", "6"}], "}"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.7524251005341053`*^9, 3.752425105062248*^9}},
 CellLabel->"In[9]:=",ExpressionUUID->"7b6e9e95-9e00-4fb0-b26a-5f7d5632d515"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
   RowBox[{"(", 
    RowBox[{
    "1", "-", "u1", "-", "u2", "-", "u3", "-", "u4", "-", "u5", "-", "u6"}], 
    ")"}], "+", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{"u1", "+", 
      RowBox[{"2", " ", "u2"}], "+", 
      RowBox[{"3", " ", "u3"}], "+", 
      RowBox[{"4", " ", "u4"}], "+", 
      RowBox[{"5", " ", "u5"}], "+", 
      RowBox[{"6", " ", "u6"}]}], ")"}], " ", "mu"}], "+", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      RowBox[{"-", "u2"}], "-", 
      RowBox[{"3", " ", "u3"}], "-", 
      RowBox[{"6", " ", "u4"}], "-", 
      RowBox[{"10", " ", "u5"}], "-", 
      RowBox[{"15", " ", "u6"}]}], ")"}], " ", 
    SuperscriptBox["mu", "2"]}], "+", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{"u3", "+", 
      RowBox[{"4", " ", "u4"}], "+", 
      RowBox[{"10", " ", "u5"}], "+", 
      RowBox[{"20", " ", "u6"}]}], ")"}], " ", 
    SuperscriptBox["mu", "3"]}], "+", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      RowBox[{"-", "u4"}], "-", 
      RowBox[{"5", " ", "u5"}], "-", 
      RowBox[{"15", " ", "u6"}]}], ")"}], " ", 
    SuperscriptBox["mu", "4"]}], "+", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{"u5", "+", 
      RowBox[{"6", " ", "u6"}]}], ")"}], " ", 
    SuperscriptBox["mu", "5"]}], "-", 
   RowBox[{"u6", " ", 
    SuperscriptBox["mu", "6"]}], "+", 
   InterpretationBox[
    SuperscriptBox[
     RowBox[{"O", "[", "mu", "]"}], "7"],
    SeriesData[$CellContext`mu, 0, {}, 0, 7, 1],
    Editable->False]}],
  SeriesData[$CellContext`mu, 0, {
   1 - $CellContext`u1 - $CellContext`u2 - $CellContext`u3 - $CellContext`u4 - \
$CellContext`u5 - $CellContext`u6, $CellContext`u1 + 2 $CellContext`u2 + 
    3 $CellContext`u3 + 4 $CellContext`u4 + 5 $CellContext`u5 + 
    6 $CellContext`u6, -$CellContext`u2 - 3 $CellContext`u3 - 
    6 $CellContext`u4 - 10 $CellContext`u5 - 
    15 $CellContext`u6, $CellContext`u3 + 4 $CellContext`u4 + 
    10 $CellContext`u5 + 20 $CellContext`u6, -$CellContext`u4 - 
    5 $CellContext`u5 - 15 $CellContext`u6, $CellContext`u5 + 
    6 $CellContext`u6, -$CellContext`u6}, 0, 7, 1],
  Editable->False]], "Output",
 CellChangeTimes->{3.7524251054647417`*^9},
 CellLabel->"Out[9]=",ExpressionUUID->"ff92756f-b834-40fc-bae7-24b41358e5fc"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Binomial", "[", 
  RowBox[{"5", ",", "4"}], "]"}]], "Input",
 CellChangeTimes->{{3.752425112158864*^9, 3.752425118086995*^9}},
 CellLabel->"In[10]:=",ExpressionUUID->"be23aefc-18b6-4c78-9350-8d4db9c996a3"],

Cell[BoxData["5"], "Output",
 CellChangeTimes->{3.752425118398553*^9},
 CellLabel->"Out[10]=",ExpressionUUID->"abe16516-b473-44a0-bfe8-835795e98fa5"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Binomial", "[", 
  RowBox[{"6", ",", "4"}], "]"}]], "Input",
 CellChangeTimes->{{3.752425119661428*^9, 3.752425122014866*^9}},
 CellLabel->"In[11]:=",ExpressionUUID->"225970af-3965-4c38-8f50-6fa53d05c5ca"],

Cell[BoxData["15"], "Output",
 CellChangeTimes->{3.7524251223357687`*^9},
 CellLabel->"Out[11]=",ExpressionUUID->"3385a80d-d302-452f-829b-d256b975c413"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Binomial", "[", 
  RowBox[{"4", ",", "2"}], "]"}]], "Input",
 CellChangeTimes->{{3.752425313327119*^9, 3.752425318422773*^9}},
 CellLabel->"In[13]:=",ExpressionUUID->"db31d9e2-0e10-4e5f-abbb-4ad87edb50a0"],

Cell[BoxData["6"], "Output",
 CellChangeTimes->{{3.752425315111013*^9, 3.752425318709921*^9}},
 CellLabel->"Out[13]=",ExpressionUUID->"3c6f2dbf-96e1-4322-a14f-994c3e32f0ac"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Binomial", "[", 
  RowBox[{"5", ",", "2"}], "]"}]], "Input",
 CellChangeTimes->{{3.752425321773815*^9, 3.752425325838707*^9}},
 CellLabel->"In[14]:=",ExpressionUUID->"41fae29e-fe8f-4e61-afda-ab6699ad7ec9"],

Cell[BoxData["10"], "Output",
 CellChangeTimes->{3.75242532606278*^9},
 CellLabel->"Out[14]=",ExpressionUUID->"97043063-0381-4ee9-be2a-3907cbe2789d"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Binomial", "[", 
  RowBox[{"6", ",", "2"}], "]"}]], "Input",
 CellChangeTimes->{{3.752425329269878*^9, 3.752425332814592*^9}},
 CellLabel->"In[15]:=",ExpressionUUID->"31d8e0cd-2d54-4158-8e37-25855e5ac0dd"],

Cell[BoxData["15"], "Output",
 CellChangeTimes->{3.752425333131606*^9},
 CellLabel->"Out[15]=",ExpressionUUID->"9c45213f-a433-4e03-8677-32194ef3d3dd"]
}, Open  ]]
},
WindowSize->{914, 705},
WindowMargins->{{Automatic, 152}, {-210, Automatic}},
FrontEndVersion->"11.3 for Mac OS X x86 (32-bit, 64-bit Kernel) (March 5, \
2018)",
StyleDefinitions->"Default.nb"
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[558, 20, 340, 9, 52, "Input",ExpressionUUID->"d1915c0b-e743-47c9-9a43-051a9d6fa3e1"],
Cell[CellGroupData[{
Cell[923, 33, 488, 12, 30, "Input",ExpressionUUID->"1fc71b10-1d01-4ade-ace5-878ff80703be"],
Cell[1414, 47, 780, 24, 56, "Output",ExpressionUUID->"96de66ee-f051-4804-b168-020f85f8add1"]
}, Open  ]],
Cell[CellGroupData[{
Cell[2231, 76, 532, 14, 30, "Input",ExpressionUUID->"3786b93c-700d-4c93-9bdc-5edb9d356652"],
Cell[2766, 92, 890, 28, 38, "Output",ExpressionUUID->"ed67e68d-2d62-4f26-88a7-78e79f634fa5"]
}, Open  ]],
Cell[CellGroupData[{
Cell[3693, 125, 212, 3, 30, "Input",ExpressionUUID->"10ad81dd-7a81-4940-87de-e3ead31f11e3"],
Cell[3908, 130, 756, 23, 38, "Output",ExpressionUUID->"f825b9e4-f8bc-4ae4-b120-a9cef49db201"]
}, Open  ]],
Cell[CellGroupData[{
Cell[4701, 158, 389, 8, 52, "Input",ExpressionUUID->"35cb7f13-4954-4fb6-a06a-aab6f2effe87"],
Cell[5093, 168, 148, 2, 34, "Output",ExpressionUUID->"98fbbcd3-b65d-427a-b71f-29701d0249d5"]
}, Open  ]],
Cell[CellGroupData[{
Cell[5278, 175, 542, 8, 30, "Input",ExpressionUUID->"1ed833f4-47df-431b-872d-7f339e342d78"],
Cell[5823, 185, 501, 7, 34, "Output",ExpressionUUID->"d3561606-b515-4fdb-aa08-3c861db08803"]
}, Open  ]],
Cell[CellGroupData[{
Cell[6361, 197, 295, 5, 30, "Input",ExpressionUUID->"cbc94491-6dd2-487a-9828-332f3c3542ac"],
Cell[6659, 204, 277, 4, 34, "Output",ExpressionUUID->"4a4d6177-c5da-4f83-aaa9-a655a1e5375d"]
}, Open  ]],
Cell[CellGroupData[{
Cell[6973, 213, 416, 11, 30, "Input",ExpressionUUID->"90540e09-6eb1-4651-8ad3-00da2c4f5e0a"],
Cell[7392, 226, 503, 7, 34, "Output",ExpressionUUID->"eb3f69a5-625a-41e0-b939-2b6e35271ca1"]
}, Open  ]],
Cell[CellGroupData[{
Cell[7932, 238, 779, 23, 30, "Input",ExpressionUUID->"78af165f-db6a-45d7-abb4-ba8ce6f95741"],
Cell[8714, 263, 170, 2, 34, "Output",ExpressionUUID->"d457ab3d-ab99-415c-8f26-28bfd9ab2629"]
}, Open  ]],
Cell[CellGroupData[{
Cell[8921, 270, 776, 23, 30, "Input",ExpressionUUID->"bd8706e8-2f3c-4f16-9f3b-02d96d5e4d20"],
Cell[9700, 295, 170, 2, 34, "Output",ExpressionUUID->"c34d23c7-399c-4737-a514-f42e5ff3cfe6"]
}, Open  ]],
Cell[9885, 300, 148, 2, 30, "Input",ExpressionUUID->"bfde2906-6aa3-46c9-ab67-b9a0675f9dc3"],
Cell[CellGroupData[{
Cell[10058, 306, 777, 23, 30, "Input",ExpressionUUID->"c81f187d-dbad-4af9-9726-e613301df7f5"],
Cell[10838, 331, 173, 2, 34, "Output",ExpressionUUID->"b4cf742d-a392-463d-924d-5242b951f1a3"]
}, Open  ]],
Cell[CellGroupData[{
Cell[11048, 338, 826, 23, 30, "Input",ExpressionUUID->"f45f8e3c-7da8-4e3d-b062-63bd6eaddc2b"],
Cell[11877, 363, 173, 2, 34, "Output",ExpressionUUID->"1b5229d8-34f3-42a4-bd56-fba31b55a418"]
}, Open  ]],
Cell[12065, 368, 336, 7, 30, "Input",ExpressionUUID->"7920ad1f-1100-48c7-b7ca-cb4eae7c054a"],
Cell[CellGroupData[{
Cell[12426, 379, 785, 22, 30, "Input",ExpressionUUID->"73d55892-6a9e-4ce0-82da-78101236c915"],
Cell[13214, 403, 339, 5, 34, "Output",ExpressionUUID->"811f34e4-0346-4b63-a721-69dfba91c3b0"]
}, Open  ]],
Cell[CellGroupData[{
Cell[13590, 413, 730, 21, 30, "Input",ExpressionUUID->"0cfd8842-74b7-4366-940d-81ab81bef18e"],
Cell[14323, 436, 266, 4, 34, "Output",ExpressionUUID->"8fdede46-bb5d-4894-b428-2834293e89dd"]
}, Open  ]],
Cell[CellGroupData[{
Cell[14626, 445, 736, 21, 30, "Input",ExpressionUUID->"a529dfae-60fa-42e1-8bb1-07e3980888c2"],
Cell[15365, 468, 236, 3, 34, "Output",ExpressionUUID->"56fee029-b871-4975-9194-69ce65f8fa71"]
}, Open  ]],
Cell[CellGroupData[{
Cell[15638, 476, 208, 3, 30, "Input",ExpressionUUID->"3c0fb390-5145-4498-901e-889c183995be"],
Cell[15849, 481, 152, 2, 34, "Output",ExpressionUUID->"e4a9a647-5cee-474d-b150-f25906a76ba1"]
}, Open  ]],
Cell[CellGroupData[{
Cell[16038, 488, 873, 27, 30, "Input",ExpressionUUID->"59480239-0542-480d-9fc3-709a9f9153b5"],
Cell[16914, 517, 236, 3, 34, "Output",ExpressionUUID->"4b2947b5-2e99-40e3-80f7-fb8876fca4e6"]
}, Open  ]],
Cell[CellGroupData[{
Cell[17187, 525, 374, 10, 30, "Input",ExpressionUUID->"22f36ad2-96fa-49f8-87b1-256053b6ca21"],
Cell[17564, 537, 286, 4, 34, "Output",ExpressionUUID->"6035d903-0193-4881-9dc2-24e0f7f004c8"]
}, Open  ]],
Cell[CellGroupData[{
Cell[17887, 546, 520, 17, 30, "Input",ExpressionUUID->"31130cbc-ab12-4b81-9889-28ee3404bb70"],
Cell[18410, 565, 278, 4, 34, "Output",ExpressionUUID->"00aca9b4-aa49-45e6-96f3-5bcbfb092424"]
}, Open  ]],
Cell[CellGroupData[{
Cell[18725, 574, 378, 10, 30, "Input",ExpressionUUID->"97188cf8-a7fc-439e-a595-31424a5637d5"],
Cell[19106, 586, 168, 2, 34, "Output",ExpressionUUID->"7458a7ff-92d3-4abf-9f35-d1efd7602481"]
}, Open  ]],
Cell[CellGroupData[{
Cell[19311, 593, 498, 14, 30, "Input",ExpressionUUID->"ef9ebd9b-b59c-4b3d-8439-f7ea3638da3b"],
Cell[19812, 609, 744, 22, 65, "Output",ExpressionUUID->"f7a83dd3-8dc5-4e28-9e80-fac4fd864a7c"]
}, Open  ]],
Cell[CellGroupData[{
Cell[20593, 636, 711, 20, 30, "Input",ExpressionUUID->"31059212-fcfb-4b8d-8361-b995e367b344"],
Cell[21307, 658, 568, 15, 50, "Output",ExpressionUUID->"27b3d99c-0bb6-416d-9cb0-c2cd9429455d"]
}, Open  ]],
Cell[CellGroupData[{
Cell[21912, 678, 596, 17, 30, "Input",ExpressionUUID->"a74a6713-c354-4a45-8152-78bc8d60cfa7"],
Cell[22511, 697, 536, 17, 60, "Output",ExpressionUUID->"50458a6c-68d9-44f3-937f-deecf3f79feb"]
}, Open  ]],
Cell[CellGroupData[{
Cell[23084, 719, 594, 18, 30, "Input",ExpressionUUID->"1f212697-5543-4e8e-a9cf-e6ebf00d47f8"],
Cell[23681, 739, 695, 19, 50, "Output",ExpressionUUID->"9c4400c1-7564-486a-8b8f-b2d94ac3a564"]
}, Open  ]],
Cell[24391, 761, 372, 8, 30, "Input",ExpressionUUID->"4628d8be-91c0-43fc-925d-f92dc4aa2f51"],
Cell[CellGroupData[{
Cell[24788, 773, 510, 15, 30, "Input",ExpressionUUID->"30006eb5-4991-41ec-8e70-8cfeb77f1cc1"],
Cell[25301, 790, 178, 2, 34, "Output",ExpressionUUID->"fc60d13a-88fa-441a-9f14-170bfaf3947d"]
}, Open  ]],
Cell[CellGroupData[{
Cell[25516, 797, 508, 15, 30, "Input",ExpressionUUID->"732435d1-f3a6-4185-9e72-722834a4e2fe"],
Cell[26027, 814, 266, 7, 50, "Output",ExpressionUUID->"be192b0f-4258-45bf-8012-f1b19b07c302"]
}, Open  ]],
Cell[CellGroupData[{
Cell[26330, 826, 510, 15, 30, "Input",ExpressionUUID->"a33934eb-3fb8-4de8-b474-953e7760bc48"],
Cell[26843, 843, 350, 11, 51, "Output",ExpressionUUID->"dc38e5b1-8eb9-444a-b32c-934ac7e34579"]
}, Open  ]],
Cell[CellGroupData[{
Cell[27230, 859, 510, 15, 30, "Input",ExpressionUUID->"4336e48e-a6fe-4334-adce-67b92dcd6a15"],
Cell[27743, 876, 474, 15, 51, "Output",ExpressionUUID->"c0f2a8c8-45e7-45d0-9bdb-302d3fac7652"]
}, Open  ]],
Cell[CellGroupData[{
Cell[28254, 896, 508, 15, 30, "Input",ExpressionUUID->"42579431-fb10-4206-870f-872cce0f6e41"],
Cell[28765, 913, 561, 17, 51, "Output",ExpressionUUID->"def25c09-d3e0-460d-81ed-a12669e47173"]
}, Open  ]],
Cell[CellGroupData[{
Cell[29363, 935, 510, 15, 30, "Input",ExpressionUUID->"5c9a7318-346d-4711-b37f-97f7b8c6098a"],
Cell[29876, 952, 664, 21, 51, "Output",ExpressionUUID->"c09e8dd9-a774-4493-9837-bd9f855d7b66"]
}, Open  ]],
Cell[CellGroupData[{
Cell[30577, 978, 511, 15, 30, "Input",ExpressionUUID->"4dcb6bc3-a7a5-477b-a001-6ffaa87c51da"],
Cell[31091, 995, 790, 23, 52, "Output",ExpressionUUID->"f1e6393f-269f-4aea-b953-b0a12f130f68"]
}, Open  ]],
Cell[CellGroupData[{
Cell[31918, 1023, 287, 6, 30, "Input",ExpressionUUID->"90142b10-a55a-4160-b2e8-3e1a9f506e87"],
Cell[32208, 1031, 1117, 30, 54, "Output",ExpressionUUID->"d610b895-2498-46c5-9631-95e5243a3922"]
}, Open  ]],
Cell[CellGroupData[{
Cell[33362, 1066, 693, 20, 30, "Input",ExpressionUUID->"bc24eb7a-5b57-4757-bb96-eb88d0f9ba34"],
Cell[34058, 1088, 627, 19, 60, "Output",ExpressionUUID->"5ceacde5-32ed-448a-8f1d-81de84859943"]
}, Open  ]],
Cell[CellGroupData[{
Cell[34722, 1112, 190, 3, 30, "Input",ExpressionUUID->"7bacc67b-f5f0-4327-8ae4-b9403c484dc0"],
Cell[34915, 1117, 151, 2, 34, "Output",ExpressionUUID->"bf0ec9a7-9976-4fc0-b24e-673add8103e3"]
}, Open  ]],
Cell[CellGroupData[{
Cell[35103, 1124, 191, 3, 30, "Input",ExpressionUUID->"bbd21278-74c4-4652-a1ac-ef5cc8cd01c8"],
Cell[35297, 1129, 152, 2, 34, "Output",ExpressionUUID->"fbbcaee3-c01d-4d97-b02d-6f9e7e3a995e"]
}, Open  ]],
Cell[CellGroupData[{
Cell[35486, 1136, 191, 3, 30, "Input",ExpressionUUID->"76c082ec-0b0d-4373-a493-c748ca264346"],
Cell[35680, 1141, 153, 2, 34, "Output",ExpressionUUID->"9a20a20b-c6a3-44e0-b3b5-e858c47d7098"]
}, Open  ]],
Cell[CellGroupData[{
Cell[35870, 1148, 192, 3, 30, "Input",ExpressionUUID->"fe463fd9-79f1-47f7-9fc7-4d60526f6df1"],
Cell[36065, 1153, 156, 2, 34, "Output",ExpressionUUID->"18da4783-452f-46a6-9ab1-b008aa67d335"]
}, Open  ]],
Cell[CellGroupData[{
Cell[36258, 1160, 850, 25, 30, "Input",ExpressionUUID->"40fb478b-25a3-4e47-8206-fb346829a41b"],
Cell[37111, 1187, 636, 17, 49, "Output",ExpressionUUID->"57d436bc-1f85-4932-bab7-71539d6c3227"]
}, Open  ]],
Cell[CellGroupData[{
Cell[37784, 1209, 769, 22, 30, "Input",ExpressionUUID->"e810f793-b29b-461e-98cf-1566654f3efa"],
Cell[38556, 1233, 180, 2, 34, "Output",ExpressionUUID->"022d46f7-9205-40ce-8d3b-97d827a00723"]
}, Open  ]],
Cell[CellGroupData[{
Cell[38773, 1240, 710, 22, 30, "Input",ExpressionUUID->"ab3d4a35-479c-4ecd-8234-8e201e425d98"],
Cell[39486, 1264, 689, 22, 34, "Output",ExpressionUUID->"006e93e4-9149-4abb-b0e9-c29f12cd923f"]
}, Open  ]],
Cell[CellGroupData[{
Cell[40212, 1291, 203, 3, 30, "Input",ExpressionUUID->"dcc1e915-26db-4dec-b65a-9e63944a86d9"],
Cell[40418, 1296, 1093, 28, 56, "Output",ExpressionUUID->"84de1ff4-8c9c-47fb-9565-091df2a531bc"]
}, Open  ]],
Cell[CellGroupData[{
Cell[41548, 1329, 288, 6, 30, "Input",ExpressionUUID->"6c390c43-dcee-476b-8480-533d61942938"],
Cell[41839, 1337, 1793, 50, 56, "Output",ExpressionUUID->"0d58eb6d-5d86-4682-b57a-502e17d404f1"]
}, Open  ]],
Cell[CellGroupData[{
Cell[43669, 1392, 792, 23, 30, "Input",ExpressionUUID->"fd3bd3ae-3dcc-4961-a922-1d08e7fe7f8c"],
Cell[44464, 1417, 664, 19, 50, "Output",ExpressionUUID->"0d5cc942-ca98-4346-82cd-ff1b5edff46a"]
}, Open  ]],
Cell[CellGroupData[{
Cell[45165, 1441, 720, 17, 30, "Input",ExpressionUUID->"5f11abe9-621d-47e4-81cc-80ae96109836"],
Cell[45888, 1460, 1251, 38, 143, "Output",ExpressionUUID->"805d1c64-4d93-4614-892c-a608ad6113df"]
}, Open  ]],
Cell[CellGroupData[{
Cell[47176, 1503, 210, 3, 30, "Input",ExpressionUUID->"211d8a2b-11a5-4f8e-a888-b01cb123eead"],
Cell[47389, 1508, 349, 9, 50, "Output",ExpressionUUID->"1b3e836f-676b-4a30-bd87-defd4345f555"]
}, Open  ]],
Cell[CellGroupData[{
Cell[47775, 1522, 746, 18, 30, "Input",ExpressionUUID->"9cb52016-44d2-4047-b37a-1083d32825a2"],
Cell[48524, 1542, 598, 17, 59, "Output",ExpressionUUID->"9c8d17a1-4fbf-4b01-9395-535e46c583ea"]
}, Open  ]],
Cell[CellGroupData[{
Cell[49159, 1564, 641, 17, 30, "Input",ExpressionUUID->"f92a6bdc-b1d6-4c91-adcf-9f0b99402a57"],
Cell[49803, 1583, 734, 23, 53, "Output",ExpressionUUID->"19a27bf5-0fd4-4b49-9937-1263519ed36c"]
}, Open  ]],
Cell[CellGroupData[{
Cell[50574, 1611, 462, 13, 30, "Input",ExpressionUUID->"b0c40552-7669-4ac2-b1a0-a91180e63e2d"],
Cell[51039, 1626, 438, 13, 60, "Output",ExpressionUUID->"54709761-35c9-4db8-9c13-00be45e437f0"]
}, Open  ]],
Cell[CellGroupData[{
Cell[51514, 1644, 210, 3, 30, "Input",ExpressionUUID->"5b93d288-724f-4889-8ad5-02486c257af3"],
Cell[51727, 1649, 172, 2, 34, "Output",ExpressionUUID->"c5656cbe-5cb3-489f-907b-c5ff2fc4b31f"]
}, Open  ]],
Cell[CellGroupData[{
Cell[51936, 1656, 270, 6, 30, "Input",ExpressionUUID->"7fe22473-9d28-41e4-9946-2890d5d18f8c"],
Cell[52209, 1664, 238, 6, 51, "Output",ExpressionUUID->"6954c322-c0ce-4977-bfe7-a816ed1d4733"]
}, Open  ]],
Cell[CellGroupData[{
Cell[52484, 1675, 210, 3, 30, "Input",ExpressionUUID->"757e6c69-66f1-4053-83fe-cefd9e436276"],
Cell[52697, 1680, 193, 4, 50, "Output",ExpressionUUID->"22cf120b-39bc-4f90-91f0-f561204100a5"]
}, Open  ]],
Cell[CellGroupData[{
Cell[52927, 1689, 207, 3, 30, "Input",ExpressionUUID->"0ac89e92-e4c8-45fe-a3ab-617e03500fdf"],
Cell[53137, 1694, 173, 3, 47, "Output",ExpressionUUID->"accf04d7-c2ad-46d3-b33a-a1374c14f18e"]
}, Open  ]],
Cell[CellGroupData[{
Cell[53347, 1702, 207, 3, 30, "Input",ExpressionUUID->"bb7eeea9-ad8b-4d66-b29e-ee7bfed1ef91"],
Cell[53557, 1707, 149, 2, 34, "Output",ExpressionUUID->"555a4c3d-b1d2-4f80-933e-2fe2d86a2ebf"]
}, Open  ]],
Cell[CellGroupData[{
Cell[53743, 1714, 209, 3, 30, "Input",ExpressionUUID->"c915257e-f591-4cba-8a28-2f4f2e64b3d3"],
Cell[53955, 1719, 166, 2, 34, "Output",ExpressionUUID->"c9a66888-0b73-463f-b98a-8fee6a4d52f2"]
}, Open  ]],
Cell[CellGroupData[{
Cell[54158, 1726, 283, 6, 30, "Input",ExpressionUUID->"da571f9f-9e8a-4102-aede-feed991eeeaf"],
Cell[54444, 1734, 167, 2, 34, "Output",ExpressionUUID->"aea10f1f-724d-471a-abb1-92b18174f86f"]
}, Open  ]],
Cell[CellGroupData[{
Cell[54648, 1741, 537, 10, 30, "Input",ExpressionUUID->"9b672994-4cc2-429f-bb43-0ac33445d8fb"],
Cell[55188, 1753, 365, 5, 34, "Output",ExpressionUUID->"5bab5f0d-f5ed-40c9-bda0-7e2e6b3582d7"]
}, Open  ]],
Cell[CellGroupData[{
Cell[55590, 1763, 283, 6, 30, "Input",ExpressionUUID->"1494d482-4304-46b4-8606-da27bf2b062e"],
Cell[55876, 1771, 167, 2, 34, "Output",ExpressionUUID->"c1a310a9-946e-49ca-a012-272c266e9d9c"]
}, Open  ]],
Cell[CellGroupData[{
Cell[56080, 1778, 291, 6, 30, "Input",ExpressionUUID->"6fef9437-b2c7-4452-92a2-2cc2e9f21dbf"],
Cell[56374, 1786, 169, 2, 34, "Output",ExpressionUUID->"26889454-6964-48e2-8228-2913f2050c1d"]
}, Open  ]],
Cell[56558, 1791, 426, 9, 30, "Input",ExpressionUUID->"7c47cd91-c779-491a-b23a-c1f40b9826e3"],
Cell[CellGroupData[{
Cell[57009, 1804, 735, 17, 30, "Input",ExpressionUUID->"eb4c984f-ef1b-4d45-814d-4f15ad604e81"],
Cell[57747, 1823, 542, 15, 71, "Output",ExpressionUUID->"5b5ae6ce-36fd-4519-8241-d4c5366b7e5f"]
}, Open  ]],
Cell[CellGroupData[{
Cell[58326, 1843, 621, 16, 30, "Input",ExpressionUUID->"4e1e62db-d79d-4cdd-b1e8-086170c9bdf8"],
Cell[58950, 1861, 191, 4, 34, "Output",ExpressionUUID->"94fc4946-b53c-46c9-b893-0f54534bbb93"]
}, Open  ]],
Cell[CellGroupData[{
Cell[59178, 1870, 652, 18, 30, "Input",ExpressionUUID->"14805dc1-0b22-47d8-a893-574fa71bbe6a"],
Cell[59833, 1890, 738, 23, 52, "Output",ExpressionUUID->"3e5c88d8-8827-47c0-ba0e-dc72decc2915"]
}, Open  ]],
Cell[CellGroupData[{
Cell[60608, 1918, 356, 10, 30, "Input",ExpressionUUID->"3bd82367-e2c3-4d33-8259-a72109f271b0"],
Cell[60967, 1930, 312, 9, 34, "Output",ExpressionUUID->"de6b5d93-0318-4ae5-8607-51987f23ff1f"]
}, Open  ]],
Cell[CellGroupData[{
Cell[61316, 1944, 214, 4, 30, "Input",ExpressionUUID->"d4f8546e-dbc0-45fc-8d4f-aa53c84f8e99"],
Cell[61533, 1950, 233, 6, 34, "Output",ExpressionUUID->"7d627ab2-f566-40de-a238-a0be083ccd48"]
}, Open  ]],
Cell[CellGroupData[{
Cell[61803, 1961, 745, 20, 47, "Input",ExpressionUUID->"08b24587-dc98-4c6a-bee0-b7e1ba15635d"],
Cell[62551, 1983, 2211, 64, 77, "Output",ExpressionUUID->"3c9acae0-c3c1-4a76-aa4e-e781d08523fe"]
}, Open  ]],
Cell[CellGroupData[{
Cell[64799, 2052, 662, 19, 47, "Input",ExpressionUUID->"e11ee1ad-7321-45a5-8467-a07cc1fc424d"],
Cell[65464, 2073, 2216, 64, 66, "Output",ExpressionUUID->"a8907307-97b7-4ccc-9279-335ece45cdfb"]
}, Open  ]],
Cell[CellGroupData[{
Cell[67717, 2142, 738, 22, 30, "Input",ExpressionUUID->"87afa148-18d9-4348-baa7-af6a72b97428"],
Cell[68458, 2166, 561, 16, 50, "Output",ExpressionUUID->"a1f5db14-f64c-4170-bdb2-8171694f2695"]
}, Open  ]],
Cell[CellGroupData[{
Cell[69056, 2187, 504, 13, 47, "Input",ExpressionUUID->"a5097cf1-a0a9-4d00-8763-2f8906fd21c2"],
Cell[69563, 2202, 2311, 69, 75, "Output",ExpressionUUID->"0cdecb81-8059-41fa-bd89-164f4512c020"]
}, Open  ]],
Cell[CellGroupData[{
Cell[71911, 2276, 581, 16, 47, "Input",ExpressionUUID->"1245d683-ed41-4a7d-9ba0-a69413255a4d"],
Cell[72495, 2294, 871, 24, 54, "Output",ExpressionUUID->"9f2a4c9f-c18a-49af-a38b-879c5ca92643"]
}, Open  ]],
Cell[CellGroupData[{
Cell[73403, 2323, 235, 6, 30, "Input",ExpressionUUID->"78d36074-6d5b-4b22-8ef1-872683c16be9"],
Cell[73641, 2331, 167, 3, 34, "Output",ExpressionUUID->"73d9afbd-a2fe-4e2c-8702-51887e2c1021"]
}, Open  ]],
Cell[CellGroupData[{
Cell[73845, 2339, 235, 6, 30, "Input",ExpressionUUID->"e0f7b1e3-97c2-4dc4-8f4c-6afd32197b97"],
Cell[74083, 2347, 166, 3, 34, "Output",ExpressionUUID->"0de51c50-8812-464a-9907-4d429ea18500"]
}, Open  ]],
Cell[CellGroupData[{
Cell[74286, 2355, 260, 7, 30, "Input",ExpressionUUID->"9877f167-1404-40e8-a8fd-0654f1c015d0"],
Cell[74549, 2364, 168, 4, 35, "Output",ExpressionUUID->"c52c163e-c188-4335-b75d-35b320645964"]
}, Open  ]],
Cell[CellGroupData[{
Cell[74754, 2373, 262, 7, 30, "Input",ExpressionUUID->"4821d2b5-88b4-4db6-b59f-2ec250dfab22"],
Cell[75019, 2382, 211, 6, 35, "Output",ExpressionUUID->"3501ea7e-c624-4f47-aadc-e7709458d64c"]
}, Open  ]],
Cell[CellGroupData[{
Cell[75267, 2393, 260, 7, 30, "Input",ExpressionUUID->"1759096d-f133-46d4-8632-3e9a01dcff79"],
Cell[75530, 2402, 213, 6, 55, "Output",ExpressionUUID->"38a6b4e1-6080-4d83-99ff-445b1e8111bf"]
}, Open  ]],
Cell[CellGroupData[{
Cell[75780, 2413, 514, 14, 30, "Input",ExpressionUUID->"c0e83b35-e2c0-4634-97f2-76a1b000f4bf"],
Cell[76297, 2429, 242, 6, 55, "Output",ExpressionUUID->"672414e0-6d08-45f1-9bba-95b57388d5c9"]
}, Open  ]],
Cell[CellGroupData[{
Cell[76576, 2440, 613, 20, 30, "Input",ExpressionUUID->"a093d94d-45f0-4fb7-83b2-773f6c005b2b"],
Cell[77192, 2462, 618, 21, 38, "Output",ExpressionUUID->"01a847ff-cce0-47c2-a022-914b1621d229"]
}, Open  ]],
Cell[CellGroupData[{
Cell[77847, 2488, 213, 4, 30, "Input",ExpressionUUID->"2dada989-38f1-44d7-ad33-cb54854edf46"],
Cell[78063, 2494, 198, 5, 34, "Output",ExpressionUUID->"3c547ac3-3484-4307-bcbc-0e9af52890c9"]
}, Open  ]],
Cell[CellGroupData[{
Cell[78298, 2504, 732, 25, 30, "Input",ExpressionUUID->"777ad547-615e-4c91-9418-0c377d5e6183"],
Cell[79033, 2531, 751, 26, 37, "Output",ExpressionUUID->"1c9db31f-fa32-43a9-92c4-13ac183a7f65"]
}, Open  ]],
Cell[CellGroupData[{
Cell[79821, 2562, 213, 4, 30, "Input",ExpressionUUID->"19c82e6b-ca62-43d6-8c2e-ab054dee36f3"],
Cell[80037, 2568, 498, 16, 34, "Output",ExpressionUUID->"aefe3d28-4d3b-4e9c-9574-b00068b57a17"]
}, Open  ]],
Cell[CellGroupData[{
Cell[80572, 2589, 213, 4, 30, "Input",ExpressionUUID->"73dd69bf-d816-4677-ac90-7a7cff89a98a"],
Cell[80788, 2595, 483, 15, 37, "Output",ExpressionUUID->"68c92b77-3529-4401-bb80-66a3737db410"]
}, Open  ]],
Cell[CellGroupData[{
Cell[81308, 2615, 580, 16, 47, "Input",ExpressionUUID->"fab5a790-fb7b-4e32-9b74-2a5c65e5faab"],
Cell[81891, 2633, 2558, 63, 140, "Output",ExpressionUUID->"a1b39259-5dba-417b-8733-e35e4d88c7e8"]
}, Open  ]],
Cell[CellGroupData[{
Cell[84486, 2701, 203, 4, 30, "Input",ExpressionUUID->"6cc0c08e-4b20-472e-9ed5-34598d68a9d3"],
Cell[84692, 2707, 2986, 82, 98, "Output",ExpressionUUID->"fb2778dc-8907-4205-9da3-fb972c5da316"]
}, Open  ]],
Cell[CellGroupData[{
Cell[87715, 2794, 636, 24, 66, "Input",ExpressionUUID->"9fcc9154-b036-4489-861b-fc3731945656"],
Cell[88354, 2820, 679, 25, 67, "Output",ExpressionUUID->"30a25940-b660-4467-a642-12149eb43174"]
}, Open  ]],
Cell[CellGroupData[{
Cell[89070, 2850, 1422, 52, 66, "Input",ExpressionUUID->"83a7afcb-5224-482f-8d59-f019e167c6d7"],
Cell[90495, 2904, 950, 35, 66, "Output",ExpressionUUID->"7fcbf47c-ad18-4c9b-9330-b27da68bb6cf"]
}, Open  ]],
Cell[CellGroupData[{
Cell[91482, 2944, 214, 4, 30, "Input",ExpressionUUID->"6d6456ad-8dec-46e0-9233-d9ef14bda5fc"],
Cell[91699, 2950, 451, 15, 51, "Output",ExpressionUUID->"215544de-1008-46b6-b580-ed99b58a404b"]
}, Open  ]],
Cell[CellGroupData[{
Cell[92187, 2970, 1224, 40, 66, "Input",ExpressionUUID->"1c98a040-3698-4e24-8659-174ffe71faac"],
Cell[93414, 3012, 805, 26, 67, "Output",ExpressionUUID->"33575818-dc38-437e-9f6d-8c8b79e8cd16"]
}, Open  ]],
Cell[CellGroupData[{
Cell[94256, 3043, 214, 4, 30, "Input",ExpressionUUID->"54a01fd9-8074-4f2e-ad6b-90905bce88c6"],
Cell[94473, 3049, 392, 12, 55, "Output",ExpressionUUID->"b8a0c9f3-559f-4cfc-9797-8ea9752b9d90"]
}, Open  ]],
Cell[94880, 3064, 292, 6, 30, "Input",ExpressionUUID->"35879a62-e09f-49af-87d3-ac58f69a08bc"],
Cell[CellGroupData[{
Cell[95197, 3074, 2101, 65, 94, "Input",ExpressionUUID->"b145f133-ad06-485f-a15f-d57148d76816"],
Cell[97301, 3141, 1823, 58, 101, "Output",ExpressionUUID->"12f776bf-1c8c-41ca-8d18-046e93b564a0"]
}, Open  ]],
Cell[CellGroupData[{
Cell[99161, 3204, 216, 4, 30, "Input",ExpressionUUID->"574896b2-1f7c-4ec7-b513-1f9f61fcb096"],
Cell[99380, 3210, 382, 11, 34, "Output",ExpressionUUID->"805767dd-d4de-47dd-b1cb-34558b7356ab"]
}, Open  ]],
Cell[CellGroupData[{
Cell[99799, 3226, 2124, 67, 94, "Input",ExpressionUUID->"78996889-9249-4f23-87a1-36b0e1336c1f"],
Cell[101926, 3295, 1819, 59, 103, "Output",ExpressionUUID->"638e7e7b-361b-468e-9d4b-78eddf7a584a"]
}, Open  ]],
Cell[CellGroupData[{
Cell[103782, 3359, 213, 4, 30, "Input",ExpressionUUID->"85876291-4024-4b6c-8b04-d94be6a02a7b"],
Cell[103998, 3365, 751, 24, 56, "Output",ExpressionUUID->"a80247d7-bcbb-4a52-9fe5-ae89c6f6f0bf"]
}, Open  ]],
Cell[CellGroupData[{
Cell[104786, 3394, 210, 4, 30, "Input",ExpressionUUID->"e6757c9a-0fc6-4d53-80e1-edf97142632d"],
Cell[104999, 3400, 729, 20, 54, "Output",ExpressionUUID->"b4682108-2e12-497b-9ff9-a9aa9255fa2a"]
}, Open  ]],
Cell[CellGroupData[{
Cell[105765, 3425, 210, 4, 30, "Input",ExpressionUUID->"fdccea86-710c-448f-8aa8-6265f48986ed"],
Cell[105978, 3431, 749, 24, 56, "Output",ExpressionUUID->"ed9e97e0-448b-4699-a962-185aa9cfd55b"]
}, Open  ]],
Cell[106742, 3458, 371, 8, 30, "Input",ExpressionUUID->"a5befca0-7da7-4202-aac6-4f2e47772775"],
Cell[CellGroupData[{
Cell[107138, 3470, 418, 11, 30, "Input",ExpressionUUID->"16aeb155-6ef6-4502-ad11-ceb2880ab83b"],
Cell[107559, 3483, 322, 9, 54, "Output",ExpressionUUID->"5e40d9bc-9aec-4716-8b9a-5ce1317903c0"]
}, Open  ]],
Cell[CellGroupData[{
Cell[107918, 3497, 293, 6, 30, "Input",ExpressionUUID->"c97f43a6-9c0f-4c7b-a633-eea496aac009"],
Cell[108214, 3505, 456, 14, 71, "Output",ExpressionUUID->"1d88262a-b9a6-44b7-821a-7774c5a8d719"]
}, Open  ]],
Cell[CellGroupData[{
Cell[108707, 3524, 2335, 68, 94, "Input",ExpressionUUID->"720c5172-a198-48ca-afa7-81bf12ddd59c"],
Cell[111045, 3594, 204, 3, 34, "Output",ExpressionUUID->"9b15e2df-9f67-405e-86cf-7166f8f63e42"]
}, Open  ]],
Cell[111264, 3600, 367, 10, 32, "Input",ExpressionUUID->"3074f8a2-cbfd-4c46-a497-4bdee35d38fe"],
Cell[CellGroupData[{
Cell[111656, 3614, 2404, 79, 94, "Input",ExpressionUUID->"209c7467-1250-4b5e-99db-2aca94a6b24b"],
Cell[114063, 3695, 2404, 76, 124, "Output",ExpressionUUID->"2d6bb8f8-a486-4dcf-8f84-084b0982febb"]
}, Open  ]],
Cell[116482, 3774, 209, 3, 30, "Input",ExpressionUUID->"f39a09f7-8ee6-4539-964e-b0aefb8b58bb"],
Cell[CellGroupData[{
Cell[116716, 3781, 3150, 97, 119, "Input",ExpressionUUID->"40c810d4-b859-49db-b39f-64cd8e067258"],
Cell[119869, 3880, 4117, 128, 125, "Output",ExpressionUUID->"aff119ac-385c-4f12-a719-36984f4ace6a"]
}, Open  ]],
Cell[CellGroupData[{
Cell[124023, 4013, 212, 3, 30, "Input",ExpressionUUID->"57cfc8fb-9075-4b7f-8bd9-4369fd7fbac4"],
Cell[124238, 4018, 1102, 37, 49, "Output",ExpressionUUID->"df968256-af7e-409b-848f-b9cc35b5b824"]
}, Open  ]],
Cell[CellGroupData[{
Cell[125377, 4060, 243, 4, 30, "Input",ExpressionUUID->"fc00b7e5-f2e0-4cad-b0e0-a1c080de65f2"],
Cell[125623, 4066, 554, 17, 44, "Output",ExpressionUUID->"f7433286-4fd8-445e-97f0-deefd89641da"]
}, Open  ]],
Cell[CellGroupData[{
Cell[126214, 4088, 210, 3, 30, "Input",ExpressionUUID->"c96cf9a1-db35-445f-8c03-4f21278ad905"],
Cell[126427, 4093, 414, 12, 43, "Output",ExpressionUUID->"4906d4e5-834f-426d-827f-f11f371d3491"]
}, Open  ]],
Cell[126856, 4108, 152, 3, 30, "Input",ExpressionUUID->"863eb811-4d33-451f-abbf-9ed4ef8a96f4"],
Cell[127011, 4113, 293, 7, 32, "Input",ExpressionUUID->"9153557b-53c4-433d-8355-e0ea777f4e8a"],
Cell[CellGroupData[{
Cell[127329, 4124, 1222, 40, 52, "Input",ExpressionUUID->"3eb7ecca-8314-4def-80a5-04ea86a06760"],
Cell[128554, 4166, 1285, 41, 67, "Output",ExpressionUUID->"499ec4de-461f-4c98-bbd9-c5880ce2d840"]
}, Open  ]],
Cell[CellGroupData[{
Cell[129876, 4212, 210, 3, 30, "Input",ExpressionUUID->"24235662-2f2a-4b2d-b421-630a8f80eb61"],
Cell[130089, 4217, 497, 15, 43, "Output",ExpressionUUID->"f9499199-98db-4175-b913-aa628e99e0fb"]
}, Open  ]],
Cell[130601, 4235, 290, 6, 30, "Input",ExpressionUUID->"6e22fdad-41ca-4ebb-b78e-45ca7a6bb46e"],
Cell[CellGroupData[{
Cell[130916, 4245, 1079, 27, 30, "Input",ExpressionUUID->"624eaba1-ecd8-43b5-89c6-9397b541b4ae"],
Cell[131998, 4274, 6530, 175, 206, "Output",ExpressionUUID->"5d9c0a40-4111-4158-88ca-139ef7b3b93e"]
}, Open  ]],
Cell[CellGroupData[{
Cell[138565, 4454, 291, 5, 30, "Input",ExpressionUUID->"370c461f-7abb-45eb-978e-7ff901f6d34c"],
Cell[138859, 4461, 2954, 92, 167, "Output",ExpressionUUID->"39134828-f5e3-4de7-b721-206b2cced5f0"]
}, Open  ]],
Cell[CellGroupData[{
Cell[141850, 4558, 366, 9, 30, "Input",ExpressionUUID->"a474babe-7d4f-48b5-9616-f1d8f624a958"],
Cell[142219, 4569, 936, 28, 62, "Output",ExpressionUUID->"23dad21a-24df-4b12-a419-90c88ac030ae"]
}, Open  ]],
Cell[CellGroupData[{
Cell[143192, 4602, 209, 3, 30, "Input",ExpressionUUID->"8863660d-6c8d-4a80-9523-49861b641848"],
Cell[143404, 4607, 846, 27, 62, "Output",ExpressionUUID->"66c6fb23-c3df-4a4d-b366-94b555919c39"]
}, Open  ]],
Cell[CellGroupData[{
Cell[144287, 4639, 244, 4, 30, "Input",ExpressionUUID->"fce71a6c-a970-4d8a-a3c5-ee9713d8f1e6"],
Cell[144534, 4645, 229, 5, 34, "Output",ExpressionUUID->"b1c5274e-3e9f-4005-945e-e038d3d8aab0"]
}, Open  ]],
Cell[CellGroupData[{
Cell[144800, 4655, 275, 5, 30, "Input",ExpressionUUID->"c62c0eaf-4bb5-42d5-ae95-91101f2e04d5"],
Cell[145078, 4662, 781, 25, 62, "Output",ExpressionUUID->"ca4fb9b1-8285-4a64-b0fb-c495e53e1eb0"]
}, Open  ]],
Cell[CellGroupData[{
Cell[145896, 4692, 210, 3, 30, "Input",ExpressionUUID->"15d7be1c-1783-473c-ab07-cd695d7d5f6a"],
Cell[146109, 4697, 783, 25, 62, "Output",ExpressionUUID->"547a8aca-d104-4b69-8287-d523a601450e"]
}, Open  ]],
Cell[CellGroupData[{
Cell[146929, 4727, 274, 5, 30, "Input",ExpressionUUID->"82ded603-4e7c-4b38-9aa1-2485bd57ac59"],
Cell[147206, 4734, 759, 24, 62, "Output",ExpressionUUID->"a8e2ff25-cefa-482b-a5f1-da1fb2673fea"]
}, Open  ]],
Cell[CellGroupData[{
Cell[148002, 4763, 210, 3, 30, "Input",ExpressionUUID->"a480f42f-39b0-4b35-9ff1-9205ae676186"],
Cell[148215, 4768, 583, 18, 38, "Output",ExpressionUUID->"5324b109-ccc8-4242-bbad-1a815fb50dc8"]
}, Open  ]],
Cell[CellGroupData[{
Cell[148835, 4791, 271, 5, 30, "Input",ExpressionUUID->"bddc8cdb-1027-4fd3-b2eb-0f2312f5bb68"],
Cell[149109, 4798, 207, 4, 34, "Output",ExpressionUUID->"c464d6a0-641a-4ab5-b85a-8bf9b12e03ab"]
}, Open  ]],
Cell[CellGroupData[{
Cell[149353, 4807, 298, 6, 30, "Input",ExpressionUUID->"27c9c2c7-3d56-4d04-b7a7-2fc96d78c7e3"],
Cell[149654, 4815, 160, 2, 34, "Output",ExpressionUUID->"2fb4c794-8858-443f-b7a9-56c0a1f8d535"]
}, Open  ]],
Cell[CellGroupData[{
Cell[149851, 4822, 254, 5, 30, "Input",ExpressionUUID->"d2062cc5-527a-4fcf-91be-cf60bcfda989"],
Cell[150108, 4829, 2667, 88, 115, "Output",ExpressionUUID->"ea7b360b-4fcc-436c-be5e-5c097984a3fe"]
}, Open  ]],
Cell[CellGroupData[{
Cell[152812, 4922, 212, 3, 30, "Input",ExpressionUUID->"ef7ae34b-bd35-4e54-8dca-9d01dc31f8f7"],
Cell[153027, 4927, 1196, 39, 49, "Output",ExpressionUUID->"dc7e969f-1b13-48f5-9b3c-827e49eb6af2"]
}, Open  ]],
Cell[CellGroupData[{
Cell[154260, 4971, 238, 4, 30, "Input",ExpressionUUID->"63f4b314-38fa-465d-8ba3-fa1208e71123"],
Cell[154501, 4977, 5238, 173, 154, "Output",ExpressionUUID->"bc5e283c-e6e3-438d-9ecd-7dbfbb536747"]
}, Open  ]],
Cell[CellGroupData[{
Cell[159776, 5155, 212, 3, 30, "Input",ExpressionUUID->"8b083bf6-586a-4956-ab61-9191c0a9a587"],
Cell[159991, 5160, 1198, 39, 49, "Output",ExpressionUUID->"9194cd3d-a5a6-4234-b3a4-22345119b54a"]
}, Open  ]],
Cell[CellGroupData[{
Cell[161226, 5204, 254, 5, 30, "Input",ExpressionUUID->"73aa2eb3-4512-4c92-9a98-7c4917ef7380"],
Cell[161483, 5211, 689, 22, 63, "Output",ExpressionUUID->"f8ea5fbb-1cbc-4d01-8c3b-c0e0fa720bb0"]
}, Open  ]],
Cell[CellGroupData[{
Cell[162209, 5238, 210, 3, 30, "Input",ExpressionUUID->"bc60e938-ffc4-4650-95c2-de9137169453"],
Cell[162422, 5243, 631, 20, 44, "Output",ExpressionUUID->"7e3a7a01-b992-4c26-a66e-df1715cce43e"]
}, Open  ]],
Cell[CellGroupData[{
Cell[163090, 5268, 482, 10, 30, "Input",ExpressionUUID->"eebbbe06-8202-483b-b0f2-85926737d128"],
Cell[163575, 5280, 305, 7, 34, "Output",ExpressionUUID->"fb58f131-b0e9-4bb7-bac7-6bd18f3fc005"]
}, Open  ]],
Cell[CellGroupData[{
Cell[163917, 5292, 277, 5, 30, "Input",ExpressionUUID->"9f5e9182-fa26-44bd-a56c-27b8439cabf1"],
Cell[164197, 5299, 1019, 31, 63, "Output",ExpressionUUID->"e15291d4-a7fa-496c-bf63-2dd749ca2954"]
}, Open  ]],
Cell[CellGroupData[{
Cell[165253, 5335, 212, 3, 30, "Input",ExpressionUUID->"0e12da61-d49b-42ca-aea5-a3d006d231f3"],
Cell[165468, 5340, 394, 11, 37, "Output",ExpressionUUID->"f99505a3-1d6d-495b-a586-594973542974"]
}, Open  ]],
Cell[CellGroupData[{
Cell[165899, 5356, 255, 5, 30, "Input",ExpressionUUID->"9dc140dc-173d-4476-942f-aa94987faf14"],
Cell[166157, 5363, 690, 22, 63, "Output",ExpressionUUID->"b5be5606-9782-44f9-bb6a-9e3a5df54999"]
}, Open  ]],
Cell[CellGroupData[{
Cell[166884, 5390, 244, 4, 30, "Input",ExpressionUUID->"390ff774-84a1-4b0b-b42c-676cedfd62ad"],
Cell[167131, 5396, 582, 18, 62, "Output",ExpressionUUID->"d6aac006-7d61-4f7e-9892-9e6ce149312a"]
}, Open  ]],
Cell[CellGroupData[{
Cell[167750, 5419, 210, 3, 30, "Input",ExpressionUUID->"c6ab7122-b118-4224-aeec-ec86947dcaa0"],
Cell[167963, 5424, 239, 5, 34, "Output",ExpressionUUID->"1fbfde19-2639-4de0-bef8-7901896ffb83"]
}, Open  ]],
Cell[CellGroupData[{
Cell[168239, 5434, 275, 5, 30, "Input",ExpressionUUID->"e6928f14-ff02-49ce-9ab2-557aa51ac57d"],
Cell[168517, 5441, 635, 20, 63, "Output",ExpressionUUID->"85573fbd-676a-4383-8bfb-bd110a7c9ac5"]
}, Open  ]],
Cell[CellGroupData[{
Cell[169189, 5466, 212, 3, 30, "Input",ExpressionUUID->"b1c12649-1650-4cee-8a26-f2cd0bd72248"],
Cell[169404, 5471, 436, 13, 66, "Output",ExpressionUUID->"f1193e11-20ed-468a-82c7-3f2bd85f8f2e"]
}, Open  ]],
Cell[CellGroupData[{
Cell[169877, 5489, 277, 5, 30, "Input",ExpressionUUID->"cef8178b-43dc-409d-b3b7-83e7813c12d4"],
Cell[170157, 5496, 785, 25, 62, "Output",ExpressionUUID->"1a76f79e-3984-4427-8e09-4a90809bc359"]
}, Open  ]],
Cell[CellGroupData[{
Cell[170979, 5526, 210, 3, 30, "Input",ExpressionUUID->"93751e6a-25a8-4c1c-956a-5489051ab77e"],
Cell[171192, 5531, 783, 25, 62, "Output",ExpressionUUID->"878b27f6-3d7f-4263-b2b4-f355849657a5"]
}, Open  ]],
Cell[CellGroupData[{
Cell[172012, 5561, 266, 5, 30, "Input",ExpressionUUID->"b7bf1038-4a6d-4d32-a07a-1853b3cf3bff"],
Cell[172281, 5568, 163, 2, 34, "Output",ExpressionUUID->"cea5c990-cb7c-4269-88a9-e5f77c03d2c9"]
}, Open  ]],
Cell[CellGroupData[{
Cell[172481, 5575, 275, 5, 30, "Input",ExpressionUUID->"e30dfcce-1543-4a9a-b8e1-104c5296d006"],
Cell[172759, 5582, 1020, 32, 63, "Output",ExpressionUUID->"6347e8bc-519a-43ee-81aa-12ee62e94730"]
}, Open  ]],
Cell[CellGroupData[{
Cell[173816, 5619, 210, 3, 30, "Input",ExpressionUUID->"61c985b9-eeb6-4b17-9cf9-6b041ff387f3"],
Cell[174029, 5624, 1020, 32, 63, "Output",ExpressionUUID->"e3386211-0f87-451b-8a7d-0a35016af7c4"]
}, Open  ]],
Cell[CellGroupData[{
Cell[175086, 5661, 271, 5, 30, "Input",ExpressionUUID->"b410a9a0-b05c-45ae-96fa-5cc3c2a84ddf"],
Cell[175360, 5668, 163, 2, 34, "Output",ExpressionUUID->"bfc004c0-3501-4b90-a8c2-f3d41a0bddb8"]
}, Open  ]],
Cell[CellGroupData[{
Cell[175560, 5675, 251, 5, 30, "Input",ExpressionUUID->"14d0434f-f637-4f7c-accf-69cc5b250ef7"],
Cell[175814, 5682, 169, 2, 34, "Output",ExpressionUUID->"ac0844b0-7c4b-4d45-9c8c-d4694099f368"]
}, Open  ]],
Cell[CellGroupData[{
Cell[176020, 5689, 370, 8, 30, "Input",ExpressionUUID->"be9fe267-4b85-4224-ae17-252f7ac9ef3d"],
Cell[176393, 5699, 287, 5, 34, "Output",ExpressionUUID->"83f2bce0-b6e0-4fba-b7c6-d32eb75580d7"]
}, Open  ]],
Cell[CellGroupData[{
Cell[176717, 5709, 379, 8, 30, "Input",ExpressionUUID->"042f958d-7bba-475b-ad41-cd1c410db574"],
Cell[177099, 5719, 209, 4, 34, "Output",ExpressionUUID->"2ddedbb8-1d56-40ff-95d4-3cd17351e3dd"]
}, Open  ]],
Cell[CellGroupData[{
Cell[177345, 5728, 275, 5, 30, "Input",ExpressionUUID->"a246d2b5-9258-4367-97e8-51bdaaa01da4"],
Cell[177623, 5735, 759, 24, 62, "Output",ExpressionUUID->"ced5ddc7-5591-4a53-a56d-b1afdb53c37a"]
}, Open  ]],
Cell[CellGroupData[{
Cell[178419, 5764, 212, 3, 30, "Input",ExpressionUUID->"c9628259-7619-49a4-a079-6fdf0ccf18de"],
Cell[178634, 5769, 582, 18, 38, "Output",ExpressionUUID->"e7704b89-f1ca-4f60-849a-56ad9857413e"]
}, Open  ]],
Cell[CellGroupData[{
Cell[179253, 5792, 272, 5, 30, "Input",ExpressionUUID->"11d40462-9c0d-475b-b318-099a5ab54e9d"],
Cell[179528, 5799, 783, 25, 62, "Output",ExpressionUUID->"a798a381-81da-491c-97b2-fcfe3369c190"]
}, Open  ]],
Cell[CellGroupData[{
Cell[180348, 5829, 212, 3, 30, "Input",ExpressionUUID->"1f263930-930c-46f5-9d63-4a3c82aa885e"],
Cell[180563, 5834, 783, 25, 62, "Output",ExpressionUUID->"8f311790-c9a8-4446-aa50-86b44e85524b"]
}, Open  ]],
Cell[CellGroupData[{
Cell[181383, 5864, 265, 5, 30, "Input",ExpressionUUID->"69dbeebd-6753-408c-bfc2-38e6e0ee1eef"],
Cell[181651, 5871, 149, 2, 34, "Output",ExpressionUUID->"ed9014ed-bf83-4bfa-94e4-5f28a9023f23"]
}, Open  ]],
Cell[CellGroupData[{
Cell[181837, 5878, 275, 5, 30, "Input",ExpressionUUID->"ea6db3c6-2451-4e42-a0f1-7b2d8a305c82"],
Cell[182115, 5885, 732, 23, 62, "Output",ExpressionUUID->"d7266d03-abdd-4137-ba55-8ceffbf9f9f7"]
}, Open  ]],
Cell[CellGroupData[{
Cell[182884, 5913, 270, 5, 30, "Input",ExpressionUUID->"b791223b-f6a6-43df-ae36-d00d533f4684"],
Cell[183157, 5920, 224, 5, 34, "Output",ExpressionUUID->"4853d9ec-e11d-4745-aa10-1fe5a338e7c6"]
}, Open  ]],
Cell[CellGroupData[{
Cell[183418, 5930, 281, 6, 30, "Input",ExpressionUUID->"0f5935f2-80d1-46f2-960a-68380f52d09e"],
Cell[183702, 5938, 616, 20, 63, "Output",ExpressionUUID->"866c6d76-81a2-495f-81dd-2672b0e8febb"]
}, Open  ]],
Cell[CellGroupData[{
Cell[184355, 5963, 272, 6, 30, "Input",ExpressionUUID->"de121326-2b68-4b33-995c-ae6a87590c4b"],
Cell[184630, 5971, 189, 4, 34, "Output",ExpressionUUID->"46c7fc64-8639-4359-8c59-496e6b7cdbe0"]
}, Open  ]],
Cell[CellGroupData[{
Cell[184856, 5980, 1241, 34, 52, "Input",ExpressionUUID->"697970de-4399-4e5a-9298-22ad33f77418"],
Cell[186100, 6016, 417, 12, 37, "Output",ExpressionUUID->"d75bcf99-661e-422d-979e-6b03b4440d0f"]
}, Open  ]],
Cell[CellGroupData[{
Cell[186554, 6033, 1117, 32, 52, "Input",ExpressionUUID->"0435fa21-61e2-497c-b413-2f1ff42c440f"],
Cell[187674, 6067, 182, 3, 34, "Output",ExpressionUUID->"c62791c4-03c7-4b4d-a856-ca0d4560520e"]
}, Open  ]],
Cell[CellGroupData[{
Cell[187893, 6075, 334, 7, 30, "Input",ExpressionUUID->"2a377fcd-ca04-437f-aa55-8d8c28198e7d"],
Cell[188230, 6084, 808, 26, 62, "Output",ExpressionUUID->"918e06f7-901b-4dd3-b912-b88acf04b97f"]
}, Open  ]],
Cell[CellGroupData[{
Cell[189075, 6115, 216, 4, 30, "Input",ExpressionUUID->"bddc603f-ba3e-439c-92f0-54226427ba52"],
Cell[189294, 6121, 810, 26, 62, "Output",ExpressionUUID->"bd9e1ed0-346e-4595-ba89-bedb2162175b"]
}, Open  ]],
Cell[CellGroupData[{
Cell[190141, 6152, 346, 8, 30, "Input",ExpressionUUID->"cf6c7ff9-5593-41a8-a80d-5b7ec2955384"],
Cell[190490, 6162, 1076, 36, 62, "Output",ExpressionUUID->"07a04169-5eb3-4e17-9cde-760bbe40a0e8"]
}, Open  ]],
Cell[CellGroupData[{
Cell[191603, 6203, 216, 4, 30, "Input",ExpressionUUID->"e254bd5c-3973-4fc5-893b-759b422ab8e1"],
Cell[191822, 6209, 1037, 34, 57, "Output",ExpressionUUID->"ea25120c-eef5-4741-a201-8d4e5cee972d"]
}, Open  ]],
Cell[CellGroupData[{
Cell[192896, 6248, 294, 7, 30, "Input",ExpressionUUID->"28a3058c-3f73-4b83-9793-c0f2939d2081"],
Cell[193193, 6257, 1837, 57, 61, "Output",ExpressionUUID->"48982771-6251-4d1e-a029-090716cf380c"]
}, Open  ]],
Cell[CellGroupData[{
Cell[195067, 6319, 216, 4, 30, "Input",ExpressionUUID->"48342f30-7a9b-4aec-a680-99148983eb87"],
Cell[195286, 6325, 1709, 53, 61, "Output",ExpressionUUID->"a94c886d-87c4-437d-ba55-1b7c7c819348"]
}, Open  ]],
Cell[CellGroupData[{
Cell[197032, 6383, 274, 6, 30, "Input",ExpressionUUID->"a708ad45-996f-4b17-a09e-93482b2cbb73"],
Cell[197309, 6391, 787, 25, 62, "Output",ExpressionUUID->"7d831a0a-f787-4922-a835-5efb0651519a"]
}, Open  ]],
Cell[CellGroupData[{
Cell[198133, 6421, 216, 4, 30, "Input",ExpressionUUID->"073b686d-d825-4a1a-a418-dd5d32541cbf"],
Cell[198352, 6427, 587, 19, 38, "Output",ExpressionUUID->"a60614c9-2024-4b9d-bb36-9f3bbbc1047b"]
}, Open  ]],
Cell[CellGroupData[{
Cell[198976, 6451, 923, 27, 30, "Input",ExpressionUUID->"ba7464e0-0f4c-4be4-91bc-069bd26c2b72"],
Cell[199902, 6480, 649, 21, 38, "Output",ExpressionUUID->"18c1cc0e-c37a-44dd-a698-918431501db8"]
}, Open  ]],
Cell[CellGroupData[{
Cell[200588, 6506, 218, 4, 30, "Input",ExpressionUUID->"8a1a492f-ac6d-48e6-947e-6ec11a874e5e"],
Cell[200809, 6512, 648, 21, 38, "Output",ExpressionUUID->"840444e1-9bc0-496c-921e-78d7027fe627"]
}, Open  ]],
Cell[CellGroupData[{
Cell[201494, 6538, 968, 28, 52, "Input",ExpressionUUID->"e46241ed-1536-41f7-8bd2-730188e23aba"],
Cell[202465, 6568, 9678, 262, 300, "Output",ExpressionUUID->"330a52a4-4f5c-49be-a4c5-80b7590b89c8"]
}, Open  ]],
Cell[CellGroupData[{
Cell[212180, 6835, 216, 4, 30, "Input",ExpressionUUID->"b77887f9-c471-4142-b343-76a9c811747a"],
Cell[212399, 6841, 6516, 195, 185, "Output",ExpressionUUID->"4256dcd8-79a1-44cb-91e9-405e70a24115"]
}, Open  ]],
Cell[CellGroupData[{
Cell[218952, 7041, 404, 11, 30, "Input",ExpressionUUID->"96cae3aa-5ee8-4cb9-a8ba-31f8fe1e349e"],
Cell[219359, 7054, 1231, 41, 57, "Output",ExpressionUUID->"d3e53138-744d-4da0-9084-25813207ec1e"]
}, Open  ]],
Cell[CellGroupData[{
Cell[220627, 7100, 279, 6, 30, "Input",ExpressionUUID->"86a00f26-1c92-4359-9f1a-a2fddfc66532"],
Cell[220909, 7108, 390, 11, 37, "Output",ExpressionUUID->"31bef77e-0cfe-4a79-bbf1-f48504fd5968"]
}, Open  ]],
Cell[CellGroupData[{
Cell[221336, 7124, 325, 8, 30, "Input",ExpressionUUID->"b058de96-1043-47c9-a364-a7db40622d17"],
Cell[221664, 7134, 3685, 100, 141, "Output",ExpressionUUID->"44b003e8-92a8-44f3-90fc-ff789d0ef2bc"]
}, Open  ]],
Cell[CellGroupData[{
Cell[225386, 7239, 970, 28, 52, "Input",ExpressionUUID->"28685c05-f2c7-451a-963c-8b948aa52eee"],
Cell[226359, 7269, 13084, 342, 337, "Output",ExpressionUUID->"5f950a66-5d7a-4838-bf67-d99b3dbbb929"]
}, Open  ]],
Cell[CellGroupData[{
Cell[239480, 7616, 280, 6, 30, "Input",ExpressionUUID->"30c16df9-b5fc-4c9a-b322-4ea5028f257b"],
Cell[239763, 7624, 181, 3, 34, "Output",ExpressionUUID->"ec749145-9dc4-4e2a-a25b-2389cbf9834a"]
}, Open  ]],
Cell[CellGroupData[{
Cell[239981, 7632, 565, 15, 30, "Input",ExpressionUUID->"b95a10fc-6715-4cf5-933b-d98b852f8d5e"],
Cell[240549, 7649, 336, 8, 24, "Message",ExpressionUUID->"a496dcb7-e036-4917-8677-bd015d0ee7c2"],
Cell[240888, 7659, 337, 8, 24, "Message",ExpressionUUID->"31e636dd-873a-4a80-aec8-5fbc2876c659"],
Cell[241228, 7669, 3956, 114, 221, "Output",ExpressionUUID->"53b48277-5ede-4366-92a5-7ddbd13faf0f"]
}, Open  ]],
Cell[245199, 7786, 241, 5, 30, "Input",ExpressionUUID->"b4aaed45-b450-460f-b57e-92673537301b"],
Cell[CellGroupData[{
Cell[245465, 7795, 873, 25, 30, "Input",ExpressionUUID->"84308119-7477-4457-a429-3ddf26fd14d8"],
Cell[246341, 7822, 2806, 85, 123, "Output",ExpressionUUID->"f9dfdb35-9307-4b91-b548-9e6ecf5b1149"]
}, Open  ]],
Cell[CellGroupData[{
Cell[249184, 7912, 214, 4, 30, "Input",ExpressionUUID->"a24496ca-f6a4-4550-8506-d883bc884afc"],
Cell[249401, 7918, 2160, 67, 74, "Output",ExpressionUUID->"f848cd25-8777-4af6-8bd9-4d324f8becff"]
}, Open  ]],
Cell[CellGroupData[{
Cell[251598, 7990, 250, 5, 30, "Input",ExpressionUUID->"13eb3317-6e08-4e00-88d5-8960e671ff48"],
Cell[251851, 7997, 943, 31, 49, "Output",ExpressionUUID->"b90e4993-a692-44b4-9322-05c006ca4efa"]
}, Open  ]],
Cell[CellGroupData[{
Cell[252831, 8033, 372, 10, 30, "Input",ExpressionUUID->"b1f52e4d-00b4-4d3d-a681-ea61dcdcf5b9"],
Cell[253206, 8045, 651, 21, 44, "Output",ExpressionUUID->"9169152a-519e-4628-ac77-b5d946b1d9e5"]
}, Open  ]],
Cell[CellGroupData[{
Cell[253894, 8071, 784, 23, 30, "Input",ExpressionUUID->"fbcb74a4-dab4-4716-a6e0-c53563aed5eb"],
Cell[254681, 8096, 332, 10, 38, "Output",ExpressionUUID->"7388b862-f652-4f47-8605-7da359a01ab8"]
}, Open  ]],
Cell[CellGroupData[{
Cell[255050, 8111, 1020, 30, 52, "Input",ExpressionUUID->"75f71584-7320-4272-8d5a-044a84aa3887"],
Cell[256073, 8143, 396, 12, 37, "Output",ExpressionUUID->"e0c457e7-fe10-4211-b277-1aff27f46def"]
}, Open  ]],
Cell[CellGroupData[{
Cell[256506, 8160, 1018, 30, 52, "Input",ExpressionUUID->"e20b25cb-3961-40e0-9b13-ea72d6714551"],
Cell[257527, 8192, 3235, 102, 170, "Output",ExpressionUUID->"378d33af-854e-40d0-8874-df568c7c36b9"]
}, Open  ]],
Cell[CellGroupData[{
Cell[260799, 8299, 208, 4, 30, "Input",ExpressionUUID->"16563eb9-4d60-455a-9b0d-740e0b7ff5f3"],
Cell[261010, 8305, 2010, 66, 95, "Output",ExpressionUUID->"4ecd8954-ae66-418d-a306-90a5d77a040c"]
}, Open  ]],
Cell[CellGroupData[{
Cell[263057, 8376, 216, 4, 30, "Input",ExpressionUUID->"7402f492-a310-4277-bd07-447ecc81b6f3"],
Cell[263276, 8382, 2010, 66, 95, "Output",ExpressionUUID->"dedc6704-e70d-4e48-8b26-cc89efada380"]
}, Open  ]],
Cell[CellGroupData[{
Cell[265323, 8453, 322, 8, 30, "Input",ExpressionUUID->"b70d2432-b21e-4238-9dcc-6035e54c0824"],
Cell[265648, 8463, 1428, 43, 66, "Output",ExpressionUUID->"da519e4c-b823-46cb-a232-33e6d916ee65"]
}, Open  ]],
Cell[CellGroupData[{
Cell[267113, 8511, 213, 4, 30, "Input",ExpressionUUID->"7e0257fb-d722-412c-aefd-f8edb33fab96"],
Cell[267329, 8517, 1179, 36, 66, "Output",ExpressionUUID->"2ef4728d-e0cf-49a3-9dc9-61730eff6bc9"]
}, Open  ]],
Cell[CellGroupData[{
Cell[268545, 8558, 1268, 38, 52, "Input",ExpressionUUID->"02793c26-e651-4305-84ce-a6c264177ffa"],
Cell[269816, 8598, 160, 3, 34, "Output",ExpressionUUID->"1c3165ec-b50d-4adc-ac14-201e9ffb2d66"]
}, Open  ]],
Cell[CellGroupData[{
Cell[270013, 8606, 1068, 30, 52, "Input",ExpressionUUID->"5cc87adc-2180-42e8-a971-82353801d5f4"],
Cell[271084, 8638, 6489, 175, 206, "Output",ExpressionUUID->"234fe8f8-5dc0-4ae1-af5e-658b81bd9840"]
}, Open  ]],
Cell[CellGroupData[{
Cell[277610, 8818, 1093, 32, 52, "Input",ExpressionUUID->"db4e7a2a-931b-4d48-b6e1-89436dd560e9"],
Cell[278706, 8852, 5370, 166, 381, "Output",ExpressionUUID->"94bfc56a-4d19-4f88-b261-62936b87755a"]
}, Open  ]],
Cell[CellGroupData[{
Cell[284113, 9023, 216, 4, 30, "Input",ExpressionUUID->"f3ebc42e-3831-467e-b31f-d6f3de5e4370"],
Cell[284332, 9029, 162, 3, 34, "Output",ExpressionUUID->"c87b1a63-7c40-44ed-9cea-92e834a3dd03"]
}, Open  ]],
Cell[CellGroupData[{
Cell[284531, 9037, 323, 8, 30, "Input",ExpressionUUID->"1e0cd9a9-36c4-4fa8-a714-96f14ccffcb4"],
Cell[284857, 9047, 160, 3, 34, "Output",ExpressionUUID->"970e8ee2-95b2-467b-82a5-cad6b2df8a76"]
}, Open  ]],
Cell[CellGroupData[{
Cell[285054, 9055, 841, 24, 30, "Input",ExpressionUUID->"e2d7cb6f-0ca0-4c3b-be3c-474ef0ed0703"],
Cell[285898, 9081, 7108, 187, 223, "Output",ExpressionUUID->"afca4bc3-a158-410c-8ea2-2f2fc8bbb4eb"]
}, Open  ]],
Cell[CellGroupData[{
Cell[293043, 9273, 370, 10, 30, "Input",ExpressionUUID->"827cfb52-3a9a-4e94-a724-574ab7bf1326"],
Cell[293416, 9285, 160, 3, 34, "Output",ExpressionUUID->"dc98bf45-b20d-4518-9e07-2761701852ac"]
}, Open  ]],
Cell[CellGroupData[{
Cell[293613, 9293, 358, 9, 30, "Input",ExpressionUUID->"e556a5cd-8a19-4084-80f8-93ce2ce7a98f"],
Cell[293974, 9304, 10774, 311, 325, "Output",ExpressionUUID->"e09bace4-7142-43d8-bac1-510f481d33b3"]
}, Open  ]],
Cell[CellGroupData[{
Cell[304785, 9620, 207, 4, 30, "Input",ExpressionUUID->"a6c5831f-4bdc-42fc-9a94-7096adcddaa6"],
Cell[304995, 9626, 7648, 239, 289, "Output",ExpressionUUID->"0d22c9c4-ead5-4ddf-a298-78dec2e333d9"]
}, Open  ]],
Cell[CellGroupData[{
Cell[312680, 9870, 786, 23, 30, "Input",ExpressionUUID->"c84adf8d-9d05-4dbd-8e3e-28a5c7f5e2db"],
Cell[313469, 9895, 654, 20, 38, "Output",ExpressionUUID->"f490f36d-b90c-452b-b3fe-c8a42b4b3fac"]
}, Open  ]],
Cell[CellGroupData[{
Cell[314160, 9920, 216, 4, 30, "Input",ExpressionUUID->"4fcb95de-1628-4424-9ac1-746393c5ddb0"],
Cell[314379, 9926, 624, 21, 34, "Output",ExpressionUUID->"b0fedd08-570b-4257-863c-f886d097f24d"]
}, Open  ]],
Cell[CellGroupData[{
Cell[315040, 9952, 370, 10, 30, "Input",ExpressionUUID->"9db6a7f0-2bc4-4e62-b1b8-f874f547b165"],
Cell[315413, 9964, 160, 3, 34, "Output",ExpressionUUID->"b8b23c61-1f7f-445f-9cf2-860b4390a1d6"]
}, Open  ]],
Cell[CellGroupData[{
Cell[315610, 9972, 308, 8, 30, "Input",ExpressionUUID->"67132a99-39d2-47db-8982-30707e6bdf43"],
Cell[315921, 9982, 2274, 77, 77, "Output",ExpressionUUID->"a0624247-f838-46d9-950e-feea60a14675"]
}, Open  ]],
Cell[CellGroupData[{
Cell[318232, 10064, 247, 5, 30, "Input",ExpressionUUID->"3a7b7ebb-c6cc-420c-b78b-bedb6307ef64"],
Cell[318482, 10071, 1032, 34, 48, "Output",ExpressionUUID->"833bc333-2adf-4f64-bb44-2d9c4b53d7c3"]
}, Open  ]],
Cell[CellGroupData[{
Cell[319551, 10110, 484, 13, 30, "Input",ExpressionUUID->"ce852c62-6613-45ca-bb65-4d63f37de4d7"],
Cell[320038, 10125, 182, 3, 34, "Output",ExpressionUUID->"eece3429-2628-4b11-87cc-69f0f1537989"]
}, Open  ]],
Cell[CellGroupData[{
Cell[320257, 10133, 405, 11, 30, "Input",ExpressionUUID->"a6deb991-491f-4e69-b143-3326f4dfc12b"],
Cell[320665, 10146, 592, 21, 48, "Output",ExpressionUUID->"28cafa38-a17d-4af2-80a9-962a407fcafe"]
}, Open  ]],
Cell[CellGroupData[{
Cell[321294, 10172, 784, 23, 30, "Input",ExpressionUUID->"0092f0bc-50b4-45ba-af00-f8ebd3dbe137"],
Cell[322081, 10197, 652, 20, 38, "Output",ExpressionUUID->"5f7c1701-7437-4b48-b714-d9d98cebc53c"]
}, Open  ]],
Cell[CellGroupData[{
Cell[322770, 10222, 290, 7, 30, "Input",ExpressionUUID->"f92a69aa-47af-40eb-8055-bbb235cf8262"],
Cell[323063, 10231, 1033, 32, 38, "Output",ExpressionUUID->"18b364d4-2506-4939-b8c5-c2388b5c6d8b"]
}, Open  ]],
Cell[CellGroupData[{
Cell[324133, 10268, 208, 4, 30, "Input",ExpressionUUID->"33b69ed4-06da-45ab-a606-c5ef8cf94d3a"],
Cell[324344, 10274, 736, 25, 38, "Output",ExpressionUUID->"3b96167d-6764-4e2c-88c8-0760caa7b02a"]
}, Open  ]],
Cell[CellGroupData[{
Cell[325117, 10304, 308, 8, 30, "Input",ExpressionUUID->"d448a514-5f10-44f0-8021-c3b346cd23a0"],
Cell[325428, 10314, 2627, 86, 80, "Output",ExpressionUUID->"92ea4652-46f0-4949-88c7-8c2538d0c869"]
}, Open  ]],
Cell[CellGroupData[{
Cell[328092, 10405, 250, 5, 30, "Input",ExpressionUUID->"89e12e0a-a393-4893-8a48-3e8c4ec17aea"],
Cell[328345, 10412, 1339, 46, 50, "Output",ExpressionUUID->"b9b6aa10-63ed-4569-8af0-a8f456acafd9"]
}, Open  ]],
Cell[CellGroupData[{
Cell[329721, 10463, 849, 24, 30, "Input",ExpressionUUID->"00c93afc-aeea-42ee-9acc-e60907ce88c5"],
Cell[330573, 10489, 574, 19, 55, "Output",ExpressionUUID->"b592f94e-926e-4192-99c9-5e5df4ca3d4d"]
}, Open  ]],
Cell[CellGroupData[{
Cell[331184, 10513, 216, 4, 30, "Input",ExpressionUUID->"0d9db497-8cff-4e1a-a6fd-1e5c9f3f36c0"],
Cell[331403, 10519, 574, 19, 55, "Output",ExpressionUUID->"e234058e-38f0-434c-9975-e465050c203e"]
}, Open  ]],
Cell[CellGroupData[{
Cell[332014, 10543, 292, 7, 30, "Input",ExpressionUUID->"e75d44fe-f324-41ea-b44d-325a96641c93"],
Cell[332309, 10552, 519, 15, 34, "Output",ExpressionUUID->"9cafafa7-5478-4576-990b-aafc97c7dada"]
}, Open  ]],
Cell[CellGroupData[{
Cell[332865, 10572, 760, 23, 34, "Input",ExpressionUUID->"f5e559f7-2b07-4e99-a439-b37883955245"],
Cell[333628, 10597, 1529, 51, 68, "Output",ExpressionUUID->"20abdccb-b3b4-40ae-820e-e4ef41cc5ec1"]
}, Open  ]],
Cell[CellGroupData[{
Cell[335194, 10653, 218, 4, 30, "Input",ExpressionUUID->"d8365e24-7bfc-4c00-a862-959c1eef5c10"],
Cell[335415, 10659, 1120, 38, 44, "Output",ExpressionUUID->"9bf684bc-56ee-4f38-a3f0-080f984bc4a6"]
}, Open  ]],
Cell[CellGroupData[{
Cell[336572, 10702, 250, 5, 30, "Input",ExpressionUUID->"98483556-c5d8-453b-8a49-7fddff287cb7"],
Cell[336825, 10709, 394, 12, 41, "Output",ExpressionUUID->"042a00b9-e4fa-4dc7-bc7e-5db0e5e86bd8"]
}, Open  ]],
Cell[CellGroupData[{
Cell[337256, 10726, 639, 19, 30, "Input",ExpressionUUID->"4502b4de-59f5-4078-b88f-29584d84fe71"],
Cell[337898, 10747, 391, 13, 42, "Output",ExpressionUUID->"e9f0d80b-dadb-4293-9157-1188d0e1aa09"]
}, Open  ]],
Cell[CellGroupData[{
Cell[338326, 10765, 421, 12, 30, "Input",ExpressionUUID->"23689683-7847-4572-90f7-77fd8db4d294"],
Cell[338750, 10779, 329, 10, 54, "Output",ExpressionUUID->"1a068f70-675c-4a05-b5bb-ffccf5780264"]
}, Open  ]],
Cell[CellGroupData[{
Cell[339116, 10794, 253, 5, 30, "Input",ExpressionUUID->"1e3b2e42-608e-4ffc-a2ca-03cfd852861e"],
Cell[339372, 10801, 295, 9, 54, "Output",ExpressionUUID->"872a422f-9cb1-4f62-8ebc-c6c0172cde27"]
}, Open  ]],
Cell[CellGroupData[{
Cell[339704, 10815, 214, 4, 30, "Input",ExpressionUUID->"c4adba34-cddd-4ad4-99e3-2b252dceaf77"],
Cell[339921, 10821, 196, 5, 51, "Output",ExpressionUUID->"c9a6cba2-a0d1-4816-8596-6320d6ac5ddf"]
}, Open  ]],
Cell[CellGroupData[{
Cell[340154, 10831, 749, 22, 30, "Input",ExpressionUUID->"ccd96485-0c0d-42ab-a194-5f0785175770"],
Cell[340906, 10855, 544, 18, 59, "Output",ExpressionUUID->"faa20adb-e945-4e95-82af-d744d12fee1e"]
}, Open  ]],
Cell[CellGroupData[{
Cell[341487, 10878, 207, 4, 30, "Input",ExpressionUUID->"bcf0048a-2fda-4f15-b56d-204816ba30b8"],
Cell[341697, 10884, 592, 20, 59, "Output",ExpressionUUID->"1ab73c07-ddaf-4dbf-a84a-3669f5e096bc"]
}, Open  ]],
Cell[CellGroupData[{
Cell[342326, 10909, 248, 5, 30, "Input",ExpressionUUID->"fcda365c-dc7e-4810-8567-3de14178dc4d"],
Cell[342577, 10916, 542, 18, 55, "Output",ExpressionUUID->"e0ef3456-13b5-490f-898b-5ff4677eb4c1"]
}, Open  ]],
Cell[CellGroupData[{
Cell[343156, 10939, 291, 7, 30, "Input",ExpressionUUID->"9e21e795-6ecc-4d66-b128-147fdde25371"],
Cell[343450, 10948, 576, 17, 53, "Output",ExpressionUUID->"4c9cd1dc-8bcd-4134-91f8-d644239ef486"]
}, Open  ]],
Cell[CellGroupData[{
Cell[344063, 10970, 1265, 38, 57, "Input",ExpressionUUID->"a4ec6815-7e97-4ea2-8770-9f91f339daf5"],
Cell[345331, 11010, 572, 19, 55, "Output",ExpressionUUID->"77e2a544-a536-4c0d-b891-b57ba9cead8d"]
}, Open  ]],
Cell[CellGroupData[{
Cell[345940, 11034, 230, 5, 30, "Input",ExpressionUUID->"e3979540-857c-42d8-8676-3e495cb54c3c"],
Cell[346173, 11041, 1509, 53, 152, "Output",ExpressionUUID->"fd520fb6-37fb-4f27-8c8d-8f0e6950a5e1"]
}, Open  ]],
Cell[CellGroupData[{
Cell[347719, 11099, 214, 4, 30, "Input",ExpressionUUID->"5656bb51-75ce-403b-b95a-8b3df1b121be"],
Cell[347936, 11105, 542, 18, 55, "Output",ExpressionUUID->"8736f850-6a36-4649-92ff-943206b75eda"]
}, Open  ]],
Cell[CellGroupData[{
Cell[348515, 11128, 292, 7, 30, "Input",ExpressionUUID->"410c7c09-aa71-4b8d-a1b2-530fded6396c"],
Cell[348810, 11137, 576, 17, 53, "Output",ExpressionUUID->"453e17be-ad22-4d55-b675-84989b3aea35"]
}, Open  ]],
Cell[CellGroupData[{
Cell[349423, 11159, 816, 24, 34, "Input",ExpressionUUID->"b5c386f3-cb50-4d5f-81ef-e4fb18d1618a"],
Cell[350242, 11185, 1553, 51, 68, "Output",ExpressionUUID->"6c8e536e-b422-413c-8336-47d1c91539bc"]
}, Open  ]],
Cell[CellGroupData[{
Cell[351832, 11241, 214, 4, 30, "Input",ExpressionUUID->"7c527c1d-8904-41f5-8ef7-9297067e95cf"],
Cell[352049, 11247, 1120, 38, 44, "Output",ExpressionUUID->"61218a4f-aa0b-4232-9f87-967cf558bd2c"]
}, Open  ]],
Cell[CellGroupData[{
Cell[353206, 11290, 714, 21, 30, "Input",ExpressionUUID->"f4546377-cad4-45fd-9343-1b8525f17a75"],
Cell[353923, 11313, 544, 18, 59, "Output",ExpressionUUID->"07bda768-6ef8-4c4d-9031-1325992bb954"]
}, Open  ]],
Cell[CellGroupData[{
Cell[354504, 11336, 753, 22, 30, "Input",ExpressionUUID->"819b5fd4-ad58-44eb-9a4f-84d5be55ce7a"],
Cell[355260, 11360, 693, 23, 59, "Output",ExpressionUUID->"63922a4a-630f-489b-8197-43005607904a"]
}, Open  ]],
Cell[CellGroupData[{
Cell[355990, 11388, 750, 22, 30, "Input",ExpressionUUID->"b604368b-2666-44ab-89aa-a2dd088d770a"],
Cell[356743, 11412, 162, 3, 34, "Output",ExpressionUUID->"92a380ef-b4e7-4b52-8476-ec11812249fa"]
}, Open  ]],
Cell[CellGroupData[{
Cell[356942, 11420, 833, 25, 30, "Input",ExpressionUUID->"e8cc0749-b4a5-40a0-aedc-04832981663e"],
Cell[357778, 11447, 689, 21, 55, "Output",ExpressionUUID->"6a245992-d535-4588-91f0-6b2fd03f9244"]
}, Open  ]],
Cell[CellGroupData[{
Cell[358504, 11473, 226, 4, 30, "Input",ExpressionUUID->"f3b5a9a7-b8be-432e-bf53-56b215d80038"],
Cell[358733, 11479, 2001, 65, 106, "Output",ExpressionUUID->"4464ff38-a43c-44d0-93ac-51eaba494201"]
}, Open  ]],
Cell[CellGroupData[{
Cell[360771, 11549, 212, 3, 30, "Input",ExpressionUUID->"688c0a60-c76e-4b16-a402-903289f44330"],
Cell[360986, 11554, 1755, 57, 100, "Output",ExpressionUUID->"731eac68-605b-4bd9-9b4d-51026390c629"]
}, Open  ]],
Cell[CellGroupData[{
Cell[362778, 11616, 429, 11, 30, "Input",ExpressionUUID->"63d1b673-d6fa-4b9f-9875-fba550967b91"],
Cell[363210, 11629, 279, 7, 50, "Output",ExpressionUUID->"e14a8379-2864-4054-834c-7cea37efb389"]
}, Open  ]],
Cell[363504, 11639, 152, 3, 30, "Input",ExpressionUUID->"37564d03-f739-4ec3-b8da-5a3ecc8dbdf3"],
Cell[CellGroupData[{
Cell[363681, 11646, 423, 11, 30, "Input",ExpressionUUID->"77e9bbcb-f4aa-4e7a-a695-0dc576c422eb"],
Cell[364107, 11659, 175, 3, 47, "Output",ExpressionUUID->"81b64ecb-18cd-4860-b763-90a6a5b954e6"]
}, Open  ]],
Cell[CellGroupData[{
Cell[364319, 11667, 923, 23, 52, "Input",ExpressionUUID->"2c6ee22c-559a-4805-b164-b30a6c5135a7"],
Cell[365245, 11692, 226, 3, 34, "Output",ExpressionUUID->"8c389bf2-4869-42e3-81df-36948f77357c"]
}, Open  ]],
Cell[CellGroupData[{
Cell[365508, 11700, 731, 17, 30, "Input",ExpressionUUID->"79d97a71-d524-4e7f-ab18-840e1f72b88d"],
Cell[366242, 11719, 191, 3, 51, "Output",ExpressionUUID->"6beb9932-b489-4eba-ac8b-44795a16dcd5"]
}, Open  ]],
Cell[366448, 11725, 615, 16, 30, "Input",ExpressionUUID->"555e0e22-5723-4774-b302-d0b45ef62813"],
Cell[CellGroupData[{
Cell[367088, 11745, 543, 15, 30, "Input",ExpressionUUID->"926f1aa3-465b-4f1c-b6fa-4c3a7fb93302"],
Cell[367634, 11762, 362, 9, 51, "Output",ExpressionUUID->"206e1afa-2ef5-4d3c-b72d-a7357ff1e767"]
}, Open  ]],
Cell[CellGroupData[{
Cell[368033, 11776, 543, 15, 30, "Input",ExpressionUUID->"f8b3bbb2-d71f-4f91-ba64-afeea877727f"],
Cell[368579, 11793, 339, 9, 51, "Output",ExpressionUUID->"11bbbc6e-7b99-424c-a324-61809ed71736"]
}, Open  ]],
Cell[CellGroupData[{
Cell[368955, 11807, 589, 16, 30, "Input",ExpressionUUID->"9bd9f9e3-9a17-4387-aaab-518695e149f3"],
Cell[369547, 11825, 362, 10, 51, "Output",ExpressionUUID->"c7b29fa7-c28b-477f-a1f6-82b47d1bdb9f"]
}, Open  ]],
Cell[369924, 11838, 541, 15, 30, "Input",ExpressionUUID->"ece6da69-06cf-4948-8d3e-c27c40d07519"],
Cell[370468, 11855, 786, 23, 71, "Input",ExpressionUUID->"df7b40e0-f0e3-4219-8500-d4364b6afe77"],
Cell[CellGroupData[{
Cell[371279, 11882, 786, 23, 71, "Input",ExpressionUUID->"e520e3b1-e733-4392-9aff-39ac2d945253"],
Cell[372068, 11907, 416, 11, 51, "Output",ExpressionUUID->"e162ac97-d6da-4b34-940d-94a3fbb317c4"],
Cell[372487, 11920, 413, 11, 51, "Output",ExpressionUUID->"42dc8110-eba6-4c6f-a823-bd71a9e9b138"]
}, Open  ]],
Cell[372915, 11934, 688, 19, 30, "Input",ExpressionUUID->"bae67879-9940-4742-9617-ba06e5295880"],
Cell[CellGroupData[{
Cell[373628, 11957, 510, 15, 48, "Input",ExpressionUUID->"1b523354-ee25-41ff-a845-d1c1d87416f5"],
Cell[374141, 11974, 483, 15, 51, "Output",ExpressionUUID->"38e614f6-25fe-4db4-bc4d-f2c2716a0783"]
}, Open  ]],
Cell[CellGroupData[{
Cell[374661, 11994, 209, 3, 30, "Input",ExpressionUUID->"f03ac957-7b11-4933-82d8-04a9a5a2ff89"],
Cell[374873, 11999, 296, 8, 51, "Output",ExpressionUUID->"eb765494-ab79-4ff3-a0f8-109babc76b99"]
}, Open  ]],
Cell[375184, 12010, 771, 23, 30, "Input",ExpressionUUID->"c1310ec8-9f1d-4093-bf07-4b6b7c85f7fb"],
Cell[CellGroupData[{
Cell[375980, 12037, 496, 15, 48, "Input",ExpressionUUID->"dd0048a5-6bc6-4300-8ec6-cecfce8390bd"],
Cell[376479, 12054, 473, 15, 51, "Output",ExpressionUUID->"b7363952-2bda-4f8c-9a03-5a064eb3fc5e"]
}, Open  ]],
Cell[CellGroupData[{
Cell[376989, 12074, 210, 3, 30, "Input",ExpressionUUID->"ddd49fb3-696a-42ab-8ed4-e8d7744a6aff"],
Cell[377202, 12079, 292, 8, 51, "Output",ExpressionUUID->"78ac848e-ab96-4db3-ab04-f87d8f37b4b9"]
}, Open  ]],
Cell[CellGroupData[{
Cell[377531, 12092, 519, 15, 30, "Input",ExpressionUUID->"b6d8ab6f-a972-4676-8a58-4b2212d0b35f"],
Cell[378053, 12109, 363, 10, 51, "Output",ExpressionUUID->"38eefbc2-4f94-40ac-b611-ac4e55710e39"]
}, Open  ]],
Cell[CellGroupData[{
Cell[378453, 12124, 475, 14, 30, "Input",ExpressionUUID->"76e87f15-a746-4035-a070-17734d6c1c37"],
Cell[378931, 12140, 419, 12, 51, "Output",ExpressionUUID->"c2369917-e6ce-4aa8-b876-d0c80f7efb1c"]
}, Open  ]],
Cell[CellGroupData[{
Cell[379387, 12157, 1309, 35, 52, "Input",ExpressionUUID->"5bb16a0a-9006-4d5f-8288-ec5f21c0342a"],
Cell[380699, 12194, 926, 17, 61, "Message",ExpressionUUID->"2e461d33-cc83-4532-aee9-aeb345525b0c"],
Cell[381628, 12213, 1150, 33, 87, "Output",ExpressionUUID->"ccc98cd1-c23e-4f57-b9ba-e32fa832a6b7"]
}, Open  ]],
Cell[CellGroupData[{
Cell[382815, 12251, 592, 15, 30, "Input",ExpressionUUID->"2e585d26-9bbf-4058-98d9-3b677f953e69"],
Cell[383410, 12268, 196, 3, 34, "Output",ExpressionUUID->"37fb9309-a5b2-4c95-8227-030ad8171674"]
}, Open  ]],
Cell[CellGroupData[{
Cell[383643, 12276, 206, 3, 30, "Input",ExpressionUUID->"8b9ae90a-8fa8-474d-a4ca-811cd02a2c07"],
Cell[383852, 12281, 152, 2, 34, "Output",ExpressionUUID->"16b8b79f-4d0f-4554-89a4-ec4286af17d3"]
}, Open  ]],
Cell[384019, 12286, 199, 3, 30, "Input",ExpressionUUID->"9086ecce-05a6-4260-9fc6-e50bd9642347"],
Cell[CellGroupData[{
Cell[384243, 12293, 177, 2, 30, "Input",ExpressionUUID->"40eecb30-ef86-430f-8e5e-1c5d2302e0d1"],
Cell[384423, 12297, 153, 2, 34, "Output",ExpressionUUID->"64c714b4-de53-4318-a1e6-b4127eedfa60"]
}, Open  ]],
Cell[CellGroupData[{
Cell[384613, 12304, 417, 11, 30, "Input",ExpressionUUID->"ae895fe4-e7fc-44dd-ac0c-ffccd5cadde1"],
Cell[385033, 12317, 167, 2, 34, "Output",ExpressionUUID->"9c56df2c-f9d0-4ee6-8b9f-6532fa695185"]
}, Open  ]],
Cell[CellGroupData[{
Cell[385237, 12324, 849, 22, 30, "Input",ExpressionUUID->"e0d5bc15-1a46-487e-b66d-263f4fbcc022"],
Cell[386089, 12348, 242, 3, 34, "Output",ExpressionUUID->"9dd27162-b6d6-431f-bcbb-12cada6907a1"]
}, Open  ]],
Cell[CellGroupData[{
Cell[386368, 12356, 640, 17, 30, "Input",ExpressionUUID->"3d787c8f-442b-4f89-937e-6a03610e6dae"],
Cell[387011, 12375, 191, 2, 34, "Output",ExpressionUUID->"350169eb-bd15-43ad-a3fd-041b7714ba0e"]
}, Open  ]],
Cell[CellGroupData[{
Cell[387239, 12382, 570, 16, 30, "Input",ExpressionUUID->"2ee046d4-9eb4-484e-91f3-c6339f3547f0"],
Cell[387812, 12400, 1008, 32, 79, "Output",ExpressionUUID->"aa90bb82-0fbb-4aa6-8af4-024fe401623e"]
}, Open  ]],
Cell[CellGroupData[{
Cell[388857, 12437, 195, 3, 30, "Input",ExpressionUUID->"187d98ea-fea0-43c4-8851-0cdcb8f2c1cd"],
Cell[389055, 12442, 150, 2, 34, "Output",ExpressionUUID->"626bd98e-6c6c-43f1-a968-b59246ccb394"]
}, Open  ]],
Cell[CellGroupData[{
Cell[389242, 12449, 195, 3, 30, "Input",ExpressionUUID->"45726860-e057-453f-b5b1-4ada2f6e8b28"],
Cell[389440, 12454, 153, 2, 34, "Output",ExpressionUUID->"7681a9b0-5a7b-464a-8d5f-b1de98df2e84"]
}, Open  ]],
Cell[CellGroupData[{
Cell[389630, 12461, 418, 11, 30, "Input",ExpressionUUID->"61b4d569-9268-4093-b1fd-eb6858d4c4fe"],
Cell[390051, 12474, 153, 2, 34, "Output",ExpressionUUID->"5fde8338-ff2c-42c4-9f38-d62dc8779458"]
}, Open  ]],
Cell[CellGroupData[{
Cell[390241, 12481, 651, 18, 30, "Input",ExpressionUUID->"978b60c2-6400-4deb-9c33-cb9787c4ba40"],
Cell[390895, 12501, 166, 2, 34, "Output",ExpressionUUID->"e21eaddc-50b0-48ff-ba15-208300b9db5a"]
}, Open  ]],
Cell[CellGroupData[{
Cell[391098, 12508, 672, 19, 30, "Input",ExpressionUUID->"4a8d8383-b110-4ea0-8167-4d1da129aaac"],
Cell[391773, 12529, 190, 2, 34, "Output",ExpressionUUID->"0751e428-7c5d-463d-bb15-43f0b0788617"]
}, Open  ]],
Cell[CellGroupData[{
Cell[392000, 12536, 592, 17, 30, "Input",ExpressionUUID->"16c4fff0-b899-4059-b5a9-3fee0a873183"],
Cell[392595, 12555, 900, 27, 78, "Output",ExpressionUUID->"87a9426c-dc6c-40ec-85e5-e019d8ef0c6c"]
}, Open  ]],
Cell[393510, 12585, 235, 4, 30, "Input",ExpressionUUID->"022503cb-ab3c-4f29-9931-fd301dc71a4d"],
Cell[CellGroupData[{
Cell[393770, 12593, 675, 18, 47, "Input",ExpressionUUID->"f4b2c31a-d099-46f6-bf07-06ed8b0279d6"],
Cell[394448, 12613, 2285, 65, 75, "Output",ExpressionUUID->"4777db88-0b72-49e3-9a9b-78343c3e0b65"]
}, Open  ]],
Cell[CellGroupData[{
Cell[396770, 12683, 1360, 42, 66, "Input",ExpressionUUID->"29442691-8953-4596-a3e0-9236cb08ec0d"],
Cell[398133, 12727, 746, 23, 65, "Output",ExpressionUUID->"5cd8a87a-c8fb-4e8f-8a04-695bc8bea891"]
}, Open  ]],
Cell[CellGroupData[{
Cell[398916, 12755, 210, 3, 30, "Input",ExpressionUUID->"7a1058a0-414b-44e4-9272-8fb3409349aa"],
Cell[399129, 12760, 379, 11, 55, "Output",ExpressionUUID->"917339d9-1dd9-4c53-ae3e-3ad525e1fa81"]
}, Open  ]],
Cell[CellGroupData[{
Cell[399545, 12776, 668, 18, 47, "Input",ExpressionUUID->"b24f7105-f017-4d7f-91bb-aea312e7fec8"],
Cell[400216, 12796, 804, 23, 66, "Output",ExpressionUUID->"213a51e0-b1f8-48f4-97b4-ed1f5b30c6a5"]
}, Open  ]],
Cell[CellGroupData[{
Cell[401057, 12824, 214, 3, 30, "Input",ExpressionUUID->"0182448c-8e26-4885-a043-176858aa0d97"],
Cell[401274, 12829, 802, 23, 66, "Output",ExpressionUUID->"53231e71-2c72-47ac-b983-2bad5219b243"]
}, Open  ]],
Cell[402091, 12855, 276, 6, 30, "Input",ExpressionUUID->"3139a6ce-b55a-450d-b429-8ace3342a289"],
Cell[CellGroupData[{
Cell[402392, 12865, 453, 13, 30, "Input",ExpressionUUID->"6f3cac95-0fb5-4842-9dc8-e8e4d0cb7ea4"],
Cell[402848, 12880, 355, 9, 34, "Output",ExpressionUUID->"58d1f92a-3d90-4ca7-bab5-0a7388e25ca8"]
}, Open  ]],
Cell[CellGroupData[{
Cell[403240, 12894, 213, 3, 30, "Input",ExpressionUUID->"171e6b52-334e-4d68-ab13-5d85b78c6e32"],
Cell[403456, 12899, 196, 3, 34, "Output",ExpressionUUID->"e7182d71-e6a9-4393-8d6e-2d5d82665053"]
}, Open  ]],
Cell[403667, 12905, 306, 6, 30, "Input",ExpressionUUID->"009da15e-1419-4b8d-a9f3-e4cec3fd16f3"],
Cell[CellGroupData[{
Cell[403998, 12915, 817, 26, 30, "Input",ExpressionUUID->"3e891763-efa6-4e93-8694-e3ce24a7fec8"],
Cell[404818, 12943, 801, 26, 34, "Output",ExpressionUUID->"73ba8d8c-5600-4ebd-a5fa-6c32936c2b68"]
}, Open  ]],
Cell[CellGroupData[{
Cell[405656, 12974, 205, 3, 30, "Input",ExpressionUUID->"09fe2406-ae6f-46f9-a0d3-517ef7dbfc70"],
Cell[405864, 12979, 1493, 39, 56, "Output",ExpressionUUID->"ec03b1a9-f235-41a3-a3db-1885fa5f2402"]
}, Open  ]],
Cell[CellGroupData[{
Cell[407394, 13023, 288, 6, 30, "Input",ExpressionUUID->"7b6e9e95-9e00-4fb0-b26a-5f7d5632d515"],
Cell[407685, 13031, 2256, 62, 56, "Output",ExpressionUUID->"ff92756f-b834-40fc-bae7-24b41358e5fc"]
}, Open  ]],
Cell[CellGroupData[{
Cell[409978, 13098, 229, 4, 30, "Input",ExpressionUUID->"be23aefc-18b6-4c78-9350-8d4db9c996a3"],
Cell[410210, 13104, 149, 2, 34, "Output",ExpressionUUID->"abe16516-b473-44a0-bfe8-835795e98fa5"]
}, Open  ]],
Cell[CellGroupData[{
Cell[410396, 13111, 229, 4, 30, "Input",ExpressionUUID->"225970af-3965-4c38-8f50-6fa53d05c5ca"],
Cell[410628, 13117, 152, 2, 34, "Output",ExpressionUUID->"3385a80d-d302-452f-829b-d256b975c413"]
}, Open  ]],
Cell[CellGroupData[{
Cell[410817, 13124, 229, 4, 30, "Input",ExpressionUUID->"db31d9e2-0e10-4e5f-abbb-4ad87edb50a0"],
Cell[411049, 13130, 173, 2, 34, "Output",ExpressionUUID->"3c6f2dbf-96e1-4322-a14f-994c3e32f0ac"]
}, Open  ]],
Cell[CellGroupData[{
Cell[411259, 13137, 229, 4, 30, "Input",ExpressionUUID->"41fae29e-fe8f-4e61-afda-ab6699ad7ec9"],
Cell[411491, 13143, 149, 2, 34, "Output",ExpressionUUID->"97043063-0381-4ee9-be2a-3907cbe2789d"]
}, Open  ]],
Cell[CellGroupData[{
Cell[411677, 13150, 229, 4, 30, "Input",ExpressionUUID->"31d8e0cd-2d54-4158-8e37-25855e5ac0dd"],
Cell[411909, 13156, 150, 2, 34, "Output",ExpressionUUID->"9c45213f-a433-4e03-8677-32194ef3d3dd"]
}, Open  ]]
}
]
*)

